Copyright (C) 2001-2020 by Joe Taylor, K1JT.
Copyright (C) 2016-2020 by Igor Chernikov UA3DJY and Arvo Järve ES1JA.

JTDX is forked from  WSJT-X, a computer  program  dedicated to amateur
radio communication using very weak signals. 

The program runs equally well on Windows, Macintosh and Linux systems,
and installation packages are available for all three platforms.

JTDX  is  an  open-source project released under the  GPL license (See
COPYING). If  you have  programming or  documentation skills  or would
like to  contribute to  the project  in other  ways, please  make your
interests known  to the  development team.


Project Web site:

http://www.jtdx.tech

Project mailing  list:

https://jtdx.groups.io/g/main

This directory contains original artwork used to generate the graphics
used in various parts of the WSJT-X ecosystem. The CMake build scripts
do not  generate the  final image bitmaps  because of the  extra tools
required to  complete this  step. Instead there  is shell  script here
(make_graphics.sh) that does the generation. If you want to modify the
source graphics  or add new  ones then you  need an SVG editor  (I use
inkscape)  and  a   tool  to  do  various  conversion   steps  (I  use
ImageMagick), the shell script explicitly uses these tools.

The files here are:

installer_logo.svg - A 150x57 pixel  image (the size is important with
    a  whte background  that is  used  at the  top right  of the  NSIS
    Windows installer.

wsjt_globe_1024x1024.svg - A 1024x1024 pixel generic globe image which
    is used in various places, mainly for high resolution icons.

wsjtx_globe_1024x1024.svg -  A 1024x1024  pixel WSJT-X  specific image
    which is used in various places, mainly for high resolution icons.

wsjt_globe_128x128.svg - A  128x128 pixel image which is  used for low
    resolution icons.

make_graphics.sh  -  Run  this  script  (on  Linux)  to  generate  the
    intermediate  bitmap image  files used  in the  wsjtx  build. This
    script  generates all  but the  final  Mac iconset  file which  is
    generated by a build on Mac since it requires a Mac developer tool
    (iconutil). This script requires that inkscape and ImageMagick are
    installed.

                    Notes on JTDX Installation for Mac OS X
                    -----------------------------------------

                               Updated 11 October 2018
                               -------------------- 

If you have already installed a previous version of JTDX then I suggest 
you change the name in the Applications folder from JTDX to JTDX_previous 
before proceeding.  

BEGIN:

There are some system matters you must deal with first.  Open a Terminal window
by going to Applications->Utilities and clicking on Terminal.

Along with this ReadMe file there is a file:  com.jtdx.sysctl.plist  which must be copied to a
system area by typing this line in the Terminal window and then pressing the Return key.

      sudo  cp  /Volumes/JTDX/com.jtdx.sysctl.plist  /Library/LaunchDaemons

you will be asked for your normal password because authorisation is needed to copy this file.
(Your password will not be echoed but press the Return key when completed.)
Now re-boot your Mac. This is necessary to install the changes.  After the
reboot you should re-open the Terminal window as before and you can check that the
change has been made by typing:

      sysctl -a | grep sysv.shm

If shmmax is not shown as 14680064 then contact me since JTDX will fail to load with
an error message: "Unable to create shared memory segment".

You are now finished with system changes.  You should make certain that NO error messages
have been produced during these steps.   You can now close the Terminal window.  It will
not be necessary to repeat this procedure again, even when you download an updated
version of JTDX.  It might be necessary if you upgrade macOS.


NEXT:

Drag the JTDX app to your preferred location, such as Applications.

You need to configure your sound card.   Visit Applications > Utilities > Audio MIDI 
Setup and select your sound card and then set Format to be "48000Hz 2ch-16bit" for 
input and output.

Now double-click on the JTDX app and two windows will appear.
It is mandatory to Accept JTDX Audio Capture usage if first launch ask this.
Select Preferences under the JTDX Menu and fill in various station details on the General panel.   
I recommend checking the 4 boxes under the Display heading and the first 4 boxes under 
the Behaviour heading.

Next visit the Audio panel and select the Audio Codec you use to communicate between 
JTDX and your rig.   There are so many audio interfaces available that it is not 
possible to give detailed advice on selection.  If you have difficulties contact me.   
Note the location of the Save Directory.  Decoded wave forms are located here.

Look at the Reporting panel.  If you check the "Prompt me" box, a logging panel will appear 
at the end of the QSO.  Two log files are provided in Library/Application Support/JTDX.
These are a simple wsjtx.log file and wsjtx_log.adi which is formatted for use with 
logging databases.    The "File" menu bar items include a button "Open log directory" 
to open the log directory in Finder for you, ready for processing by any logging 
application you use.

Finally, visit the Radio panel.  JTDX is most effective when operated with CAT 
control.  You will need to install the relevant Mac driver for your rig.   This must 
be located in the device driver directory  /dev. You should install your driver 
and then re-launch JTDX. Return to the the Radio panel in Preferences and in 
the "Serial port" panel select your driver from the list that is presented.   If 
for some reason your driver is not shown, then insert the full name 
of your driver in the Serial Port panel.   Such as:  /dev/tty.PL2303-00002226 or 
whatever driver you have.  The /dev/ prefix is mandatory.  Set the relevant 
communication parameters as required by your transceiver and click "Test CAT" to
check.

JTDX needs the Mac clock to be accurate.  Visit System Preferences > Date & Time 
and make sure that date and time are set automatically.  The drop-down menu will 
normally offer you several time servers to choose from.

On the Help menu, have a look at the new Online User's Guide for operational hints 
and tips.

Please email me if you have problems.

--- Arvo ES1JA     (es1ja@es1ja@homeunix.com)

Addendum:  Information about com.jtdx.sysctl.plist and multiple instances of JTDX.

JTDX makes use of a block of memory which is shared between different parts of
the code.  The normal allocation of shared memory on a Mac is insufficient and this 
has to be increased.  The com.wsjtx.sysctl.plist file is used for this purpose.  You can 
use a Mac editor to examine the file.  (Do not use another editor - the file 
would probably be corrupted.)

It is possible to run multiple instances of WSJT-X simultaneously.  If you wish to run more
instances simultaneously, the shmall parameter in the com.jtdx.sysctl.plist file needs to be
modified as follows.

The shmall parameter determines the amount of shared memory which is allocated in 4096 byte pages
with 14MB (14680064) required for each instance.   The shmall parameter is calculated as: 
(n * 14680064)/4096  where 'n' is the number of instances required to run simultaneously.
Remember to reboot your Mac afterwards.

Note that the shmmax parameter remains unchanged.  This is the maximum amount of shared memory that
any one instance is allowed to request from the total shared memory allocation and should not
be changed.

If two instances of WSJT-X are running, it is likely that you might need additional
audio devices, from two rigs for example.  Visit Audio MIDI Setup and create an Aggregate Device
which will allow you to specify more than one interface.  I recommend you consult Apple's guide
on combining multiple audio interfaces which is at https://support.apple.com/en-us/HT202000.  

This folder  contains the sources  of WSJT-X documentation.   To build
these you will need the asciidoctor tool installed.

If you do not wish to build  the documentation, it is possible to skip
this  directory  in the  WSJT-X  build  by  setting the  CMake  option
WSJT_GENERATE_DOCS to OFF in your build tree.


On Linux
========

You will probably have these installed already if you are building the
WSJT-X  manpages,  if you  are  not  you  will  just need  to  install
asciidoc:

 sudo apt-get install asciidoctor

or

 sudo yum install asciidoctor

or whatever your distribution and package management requires.


On Mac OS X
===========

I recommend MacPorts:

 sudo port install rb-rubygems
 sudo gem install asciidoctor


On Windows
==========

The asciidoctor  tool is a  Ruby script so you  will need to  install a
version of Ruby. The gem tool is a good way to install asciidoctor:

   gem install asciidoctor

A UI for downloading sample files from a web server.

Works in concert with  samples/CMakeLists.txt which generates the JSON
contents description file  and has a build  target upload-samples that
uploads the samples and content file to the project files server.

# QDarkStylesheet

[![Build Status](https://travis-ci.org/ColinDuquesnoy/QDarkStyleSheet.png?branch=master)](https://travis-ci.org/ColinDuquesnoy/QDarkStyleSheet)
[![Latest PyPI version](https://img.shields.io/pypi/v/QDarkStyle.svg)](https://pypi.python.org/pypi/QDarkStyle)
[![License: MIT](https://img.shields.io/dub/l/vibe-d.svg)](https://opensource.org/licenses/MIT)
[![License: CC BY 4.0](https://img.shields.io/badge/License-CC%20BY%204.0-lightgrey.svg)](https://creativecommons.org/licenses/by/4.0/)
[![conduct](https://img.shields.io/badge/code%20of%20conduct-contributor%20covenant-green.svg?style=flat-square)](http://contributor-covenant.org/version/1/4/)


A dark stylesheet for Qt applications (Qt4, Qt5, PySide, PySide2, PyQt4, PyQt5, QtPy,
PyQtGraph).

## Installation

### Python

From PyPI: Get the latest stable version of ``qdarkstyle`` package
using *pip* (preferable):

```bash
pip install qdarkstyle
```

From code: Download/clone the project, go to ``qdarkstyle`` folder then:

- You can use the *setup* script and pip install.
    ```bash
    pip install .
    ```

- Or, you can use the *setup* script with Python:
    ```bash
    python setup.py install
    ```

### C++

- Download/clone the project and copy the following files to your application
  directory (keep the existing directory hierarchy):

  - **qdarkstyle/style.qss**
  - **qdarkstyle/style.qrc**
  - **qdarkstyle/rc/** (the whole directory)

- Add **qdarkstyle/style.qrc** to your **.pro file** as follows:

  ```cpp
  RESOURCES += qdarkstyle/style.qrc
  ```
- Load the stylesheet:

  ```cpp
  QFile f(":qdarkstyle/style.qss");
  if (!f.exists())
  {
      printf("Unable to set stylesheet, file not found\n");
  }
  else
  {
      f.open(QFile::ReadOnly | QFile::Text);
      QTextStream ts(&f);
      qApp->setStyleSheet(ts.readAll());
  }
  ```

_Note: The ":" in the file name is necessary to define that file as a resource library. For more information see the discussion [here](https://github.com/ColinDuquesnoy/QDarkStyleSheet/pull/87)._

## Usage

Here is an example using PySide

```Python
import sys
import qdarkstyle
from PySide import QtGui

# create the application and the main window
app = QtGui.QApplication(sys.argv)
window = QtGui.QMainWindow()

# setup stylesheet
app.setStyleSheet(qdarkstyle.load_stylesheet_pyside())

# run
window.show()
app.exec_()
```

To use another wrapper for Qt, you need to replace some lines.
See examples below.

To use PyQt4, change two lines

```Python
from PySide import QtGui
app.setStyleSheet(qdarkstyle.load_stylesheet_pyqt())
```

If PyQt5, more lines need to be changed because of its API,
see the complete example

```Python
import sys
import qdarkstyle
from PyQt5 import QtWidgets

# create the application and the main window
app = QtWidgets.QApplication(sys.argv)
window = QtWidgets.QMainWindow()

# setup stylesheet
app.setStyleSheet(qdarkstyle.load_stylesheet_pyqt5())

# run
window.show()
app.exec_()
```

If your project uses QtPy or you need to set it programmatically,
it is far more simple

```Python
import sys
import qdarkstyle
import os

# set the environment variable to use a specific wrapper
# it can be set to pyqt, pyqt5, pyside or pyside2 (not implemented yet)
# you do not need to use QtPy to set this variable
os.environ['QT_API'] = 'pyqt'

# import from QtPy instead of doing it directly
# note that QtPy always uses PyQt5 API
from qtpy import QtWidgets

# create the application and the main window
app = QtWidgets.QApplication(sys.argv)
window = QtWidgets.QMainWindow()

# setup stylesheet
app.setStyleSheet(qdarkstyle.load_stylesheet_from_environment())

# run
window.show()
app.exec_()
```

It is also simple if you use PyQtGraph

```Python
import sys
import qdarkstyle
import os

# set the environment variable to use a specific wrapper
# it can be set to PyQt, PyQt5, PySide or PySide2 (not implemented yet)
os.environ['PYQTGRAPH_QT_LIB'] = 'PyQt'

# import from pyqtgraph instead of doing it directly
# note that PyQtGraph always uses PyQt4 API
from pyqtgraph.Qt import QtGui

# create the application and the main window
app = QtGui.QApplication(sys.argv)
window = QtGui.QMainWindow()

# setup stylesheet
app.setStyleSheet(qdarkstyle.load_stylesheet_from_environment(is_pyqtgraph=True))

# run
window.show()
app.exec_()
```

If you are using Qt.py, which is different from qtpy, you should install
qtpy then set both to the same binding.

_There is an example included in the *example* folder.
You can run the script without installing qdarkstyle. You only need to have
PySide or PySide2 or PyQt4 or PyQt5 installed on your system._


## What is new?

In the version 2.6 and later, a reestructure stylesheet is provided. The palette has only 9 colors. Most widgets are revised and their styles were improved. We also provide a command line (script) to get info that could be used when opening issues. See the image below.

```
qdarkstyle --all
```

<img src="./screenshots/cmd.png"/>


## Snapshots

Here are a few snapshots comparing the use of QDarkStyle v2.6.1 and the default style.
Click in the image to zoom.

<table style="width:100%">
  <tr>
    <th colspan=2>Containers (no tabs) and Buttons</th>
  </tr>
  <tr>
    <td><img src="./screenshots/qdarkstyle_containers_buttons.png"/></td>
    <td><img src="./screenshots/no_dark_containers_buttons.png"/></td>
  </tr>
  <tr>
    <th colspan=2>Containers (tabs) and Displays</th>
  </tr>
  <tr>
    <td><img src="./screenshots/qdarkstyle_containers_tabs_displays.png"/></td>
    <td><img src="./screenshots/no_dark_containers_tabs_displays.png"/></td>
  </tr>
  <tr>
    <th colspan=2>Widgets and Inputs (fields)</th>
  </tr>
  <tr>
    <td><img src="./screenshots/qdarkstyle_widgets_inputs_fields.png"/></td>
    <td><img src="./screenshots/no_dark_widgets_inputs_fields.png"/></td>
  </tr>
  <tr>
    <th colspan=2>Views and Inputs (no fields)</th>
  </tr>
  <tr>
    <td><img src="./screenshots/qdarkstyle_views_inputs_no_fields.png"/></td>
    <td><img src="./screenshots/no_dark_views_inputs_no_fields.png"/></td>
  </tr>
</table>

## Changelog

Please, see [CHANGES](CHANGES.md) file.

## License

This project is licensed under the MIT license.
Images contained in this project are licensed under CC-BY license.

For more information see [LICENSE](LICENSE.md) file.

## Authors

For more information see [AUTHORS](AUTHORS.md) file.

## Contributing

Most widgets have been styled. If you find a widget that has not been
style, just open an issue on the issue tracker or, better, submit a pull
request.

If you want to contribute, see [CONTRIBUTING](CONTRIBUTING.md) file.

wsprd is a decoder for K1JT's Weak Signal Propagation Reporter (WSPR) mode.

The program is written in C and is a command-line program that reads from a
.c2 file or .wav file and writes output to the console. It is used by WSJT-X
for wspr-mode decoding. 

USAGE: 
       wsprd_jtdx [options...] infile

OPTIONS:
       -a <path> path to writeable data files, default="."
       -B disable block demodulation - use single-symbol noncoherent demod
       -c write .c2 file at the end of the first pass
       -C maximum number of decoder cycles per bit, default 10000
       -d deeper search. Slower, a few more decodes
       -e x (x is transceiver dial frequency error in Hz)
       -f x (x is transceiver dial frequency in MHz)
       -H do not use (or update) the hash table
       -J use the stack decoder instead of Fano decoder
       -m decode wspr-15 .wav file
       -o n (0<=n<=5), decoding depth for OSD, default is disabled
       -q quick mode - doesn't dig deep for weak signals
       -s single pass mode, no subtraction (same as original wsprd)
       -v verbose mode (shows dupes)
       -w wideband mode - decode signals within +/- 150 Hz of center
       -z x (x is fano metric table bias, default is 0.45)

infile can be either .wav or .c2

e.g. 
./wsprd_jtdx -wf 14.0956 140709_2258.wav

Note that for .c2 files, the frequency within the file overrides the command
line value.

FEATURES:
By default, wsprd reports signals that are within +/- 110 Hz of the
subband center frequency. The wideband option (-w) extends this to +/- 150 Hz.

wsprd maintains a hashtable and will decode all three types of wspr
messages. An option (-H) is available to turn off use of the hashtable.

Decoding is attempted using soft symbols derived using single-symbol 
noncoherent detection. If decoding fails, then soft symbols derived using
block demodulation over 2- and 3-symbol blocks are used in subsequent
decoding attempts. For slower computers, block demodulation can be 
disabled with the -B command line option. 

The symbols are decoded using Phil Karn's sequential decoder routine,
fano.c. The -J option replaces the Fano algorithm with the Jelinek 
"stack-bucket" algorithm. If the -o command line option is enabled, then
an ordered-statistics decoder (OSD) is invoked if the Fano (or Jelinek) algorithm
fails. The OSD is a complete decoder, meaning that it always returns a codeword. 
A returned codeword is considered valid only if the unpacked decode contains
a callsign that is already in the hashtable. 

NOTES:
This program attempts to maximize the number of successful decodes per transmit
interval by trying to decode virtually every peak in the averaged spectrum. 
The program also implements two-pass decoding, whereby signals that are successfully
decoded are subtracted one-by-one during the first decoding pass. Then, the 
decoder is run again. In many cases the subtraction process will uncover signals
that can then be successfully decoded on the second pass.

There will be occasional duplicate decodes when two closely spaced 
peaks come from the same signal. The program removes dupes based on callsign 
and frequency. Two decodes that have the same callsign and estimated frequencies
that are within 1 Hz will be treated as decodes of the same signal. This
dupechecking is turned off with the -v flag.

This is a collection of programs and modules, written in C, that
support research and education concerning Low Density Parity Check
(LDPC) codes.

See index.html in this directory for an index to the documentation.
Copyright information can be found there, and in the file COPYRIGHT.

This directory  contains the resources  necessary to build  the WSJT-X
samples database. The CMake build script creates a directory structure
ready for  upload to the project  samples web or ftp  file server. The
CMake  script  also  defines  a build  target  'upload-samples'  which
uploads  the sample  database to  the the  destination defined  by the
project  CMake variable  PROJECT_SAMPLES_UPLOAD_DEST  (defined in  the
project root  CMake script). A  suitably authorized user may  use this
target to update the server with the latest samples.

The  samples  database   includes  a  JSON  contents   file  for  each
major/minor version combination  of WSJT-X, this file  is generated by
CMake and should not be manually edited.

To  add  new  samples  simply  add  the  files  here  and  update  the
SAMPLE_FILES  list  variable  in   the  CMakeLists.txt  file  in  this
directory.  Sample  files  must  be checked  into  source  control.  A
meaningful  directory  structure  is  advisable,  the  same  directory
structure will  be replicated by  the WSJT-X sample  downloader dialog
allowing  WSJT-X  users  to  easily identify  wath  each  sample  file
contains.

! This source code file was last time modified by Igor UA3DJY on 20190315

subroutine extract_call(msg37,call2)

  character, intent(in) :: msg37*37
  character, intent(out) :: call2*12
  character part2*12,part3*12

  call2=''; part2=''; part3=''
  ispc1=index(msg37,' '); ispc2=index(msg37((ispc1+1):),' ')+ispc1; ispc3=index(msg37((ispc2+1):),' ')+ispc2
  part2=msg37(ispc1+1:ispc2-1); part3=msg37(ispc2+1:ispc3-1); npart2len=len_trim(part2)

  if(msg37(1:3).eq.'CQ ' .or. msg37(1:3).eq.'DE ' .or. msg37(1:4).eq.'QRZ ') then
    if(npart2len.gt.4) then; call2=part2
    elseif(npart2len.eq.4) then
      if(part2(2:2).ge.'0' .and. part2(2:2).lt.':' .or. part2(3:3).ge.'0' .and. part2(3:3).lt.':') then; call2=part2
      else; call2=part3
      endif
    elseif(npart2len.eq.3) then
      if(part2(1:1).ge.'A' .and. part2(1:1).lt.'[' .and. part2(2:2).ge.'0' .and. part2(2:2).lt.':') then; call2=part2
      else; call2=part3
      endif
    elseif(npart2len.eq.2) then; call2=part3
    endif
  elseif(ispc1.gt.3 .and. ispc1.lt.13) then; call2=part2
  endif

  return
end subroutine extract_call

! This source code file was last time modified by Igor UA3DJY on July 22nd, 2017
! All changes are shown in the patch file coming together with the full JTDX source code.

real function fchisq65(c5x,npts,fsample,a,ccfmax,dtmax)

  use timer_module, only: timer
  use jt65_mod4 !prc(i) logical(1) nagcc real dtcand

  parameter (NMAX=60*12000)          !Samples per 60 s
  complex c5x(npts)
  real a(2)
  complex w,wstep,z
  real ss(3000)
  complex csx(0:NMAX/8)
  data twopi/6.283185307/a1,a2/99.,99./
!  save

!  call timer('fchisq65',0)
  baud=11025.0/4096
  nsps=nint(fsample/baud)                  !Samples per symbol
  ndiv=16                                  !Output ss() steps per symbol
  nout=ndiv*npts/nsps
  dtstep=1.0/(ndiv*baud)                   !Time per output step

 if(a(1).ne.a1 .or. a(2).ne.a2) then
     a1=a(1)
     a2=a(2)

! Mix and integrate the complex signal
     csx(0)=0.
     wstep=(0.0,0.0); w=(1.0,0.0)
     x0=0.5*npts
     do i=1,npts
        if(mod(i,100).eq.1) then
           x=(float(i)-x0)/float(npts)
           dphi=(a(1) + x*a(2)) * (twopi/fsample)
           wstep=cmplx(cos(dphi),sin(dphi))
        endif
        w=w*wstep
        csx(i)=csx(i-1) + w*c5x(i)
     enddo
  endif
!print *,nout,nsps,npts 2411,64,9646
! Compute whole-symbol powers at 1/16-symbol steps.
  fac=1.e-4
  do i=1,nout
     j=nsps+(i-1)*nsps/16 !steps by 4 samples (1/16 of a symbol)
     k=j-nsps
     ss(i)=0.
     if(k.ge.0 .and. j.le.npts) then
        z=csx(j)-csx(k) ! difference over span of 64 pts
        ss(i)=fac*(abs(real(z)) + abs(aimag(z)))
     endif
  enddo

  ccfmax=0.
!  call timer('ccf2    ',0)
  call ccf2(ss,nout,ccf,xlagpk,lagpk)
!  call timer('ccf2    ',1)
  if(ccf.gt.ccfmax) then; ccfmax=ccf; dtmax=xlagpk*dtstep; endif !dtstep=0.02322
  fchisq65=-ccfmax

  s0=0.
  s1=0.
  do i=1,126
     j=16*(i-1)+1 + lagpk
     if(j.ge.1 .and. j.le.nout-8) then
        x=ss(j)**2
        if(.not.prc(i)) then
           s0=s0 + x
        else
           s1=s1 + x
        endif
     endif
  enddo
  ccf=s1-s0
  if(ccf.gt.0.0) ccfmax=ccf

  return
end function fchisq65

program bodide
! Compute probability of word error for a bounded distance decoder.
! Hardwired for non-coherent 64-FSK and the JT65 RS (63,12) code on GF(64).
!
! Let ps be symbol error probability. 
! The probability of getting an error pattern with e symbol errors is:
! ps^e * (1-ps)*(n-e)
! The number of error patterns with e errors is binomial(63,e)
! Overall probability of getting a word with e errors is:
! P(e)= binomial(63,e)* ps^e * (1-ps)*(n-e)
! Probability that word is correct is P(0 to 25 errors) = sum{e=0}^{25} P(e)
! Probability that word is wrong is 1-P(0 to 25 errors) 
! P_word_error=1-( sum_{e=0}^{t} P(e) )
!
  implicit real*16 (a-h,o-z)

  integer*8 binomial
  integer x,s,XX,NN,M
  character arg*8

  nargs=iargc()
  if(nargs.ne.1) then
     print*,'Probability of word error for noncoherent 64-FSK with bounded distance decoding'
     print*,'Usage:    bounded_distance   D'
     print*,'Example:  bounded_distance  25'
     go to 999
  endif
  call getarg(1,arg)
  read(arg,*) nt 
  M=64
  write(*,1012) 
1012 format('Es/No  P(word error)'/  &
             '----------------------')
  do isnr=0,40
    esno=10**(isnr/2.0/10.0)
    hsum=0.d0
    do k=1,M-1
      h=binomial(M-1,k)
      h=h*((-1)**(k+1))/(k+1)
      h=h*exp(-esno*k/(k+1))
      hsum=hsum + h
    enddo
    ps=hsum
    hsum=0.d0
    do i=0,nt
      h=binomial(63,i)
      h=h*ps**i
      h=h*(1-ps)**(63-i)
      hsum=hsum+h
    enddo
    pw=1-hsum
    write(*,'(f4.1,4x,e10.4,4x,e10.4)') isnr/2.0, ps, pw
  enddo
999 end program bodide 

module jt9_decode

  type :: jt9_decoder
     procedure(jt9_decode_callback), pointer :: callback
   contains
     procedure :: decode
  end type jt9_decoder

  abstract interface
     subroutine jt9_decode_callback (this, utc, snr, dt, freq, decoded, servis9)
       import jt9_decoder
       implicit none
       class(jt9_decoder), intent(inout) :: this
       integer, intent(in) :: utc
       integer, intent(in) :: snr
       real, intent(in) :: dt
       real, intent(in) :: freq
       character(len=26), intent(in) :: decoded
       character(len=1), intent(in) ::  servis9
     end subroutine jt9_decode_callback
  end interface

contains

  subroutine decode(this,callback,nutc,nfqso,newdatin,npts8,nfa,nfsplit,nfb,ntol,  &
       nzhsym,nagain,nagainfil,ndepth,nmode,hint,stophint,nlasttx,mycall12,hiscall12,hisgrid6,ntxmode)
    use timer_module, only: timer
!npts8 = 74736
    include 'constants.f90'
    class(jt9_decoder), intent(inout) :: this
    procedure(jt9_decode_callback) :: callback
    character(len=12), intent(in) :: mycall12, hiscall12
    character(len=6), intent(in) :: hisgrid6
    integer, intent(in) :: nlasttx
    integer i4Decoded6BitWords(12),i4GrayCodedSym(69),mrs(69),mrs2(69)
    real ccfred(NSMAX),red2(NSMAX),s3(0:7,69)
    logical, intent(in) :: newdatin,nagain
    logical(1), intent(in) :: nagainfil,hint,stophint
    logical newdat,ccfok(NSMAX),done(NSMAX)
    integer*1 i1SoftSymbols(207)
    character msg26*26,msg*22,servis9*1,mycall*6,hiscall*6,hisgrid*4,chint*1,hiscallrxf*6
    logical(1) freemsg,dupe,rxfreq,hintdec,dofano,tryhint
    type accepted_decode
       integer i
       character*22 decoded
    end type accepted_decode
    type(accepted_decode) dec(200)
    type rxfreq_decode
       real freq
       real xdt
       character*22 msg
    end type rxfreq_decode
    type(rxfreq_decode) rxfdec(1)
    save ccfred,red2,rxfdec

    this%callback => callback
    ndecoded=0; chint=' '; nsps=6912; ncycles=1
    df3=1500.0/2048.0
    if(nfqso.lt.nfa) then
      if(nfsplit.gt.nfa .and. nfsplit.lt.(nfb-18)) then; nfqso=nfsplit
      else; nfqso=nfa
      endif
    endif
    irxf=nint(nfqso/df3)+1
    dec%i=-1; dec%decoded=''
    newdat=newdatin
    mycall=mycall12(1:6); hiscall=hiscall12(1:6); hisgrid=hisgrid6(1:4); hiscallrxf=''
    tstep=0.5*nsps/12000.0                      !Half-symbol step (seconds)
    dupe=.false.; rxfreq=.false.; tryhint=.false.

    nf1=nfa
    if(nmode.eq.74) then ! 65+9
      if(nfsplit.gt.0 .and. nfsplit.lt.4983) then; nf1=nfsplit
      else; nf1=1
      endif
      if(nfb.lt.1 .or. nfb.gt.4982) nfb=4982
    endif
    if(nagain .or. nagainfil) then
       if(nfqso.ge.21) nf1=nfqso-20; if(nfqso.lt.21) nf1=nfqso
       if(nfqso.le.4962) then; nfb=nfqso+20
       else if(nfqso.gt.4962 .and. nfqso.lt.4983) then; nfb=nfqso
       else; nfb=4982
       endif
    endif
    ia=max(1,nint(nf1/df3))
    ib=min(NSMAX,nint(nfb/df3))
    lag1=-int(2.5/tstep + 0.9999)
    lag2=int(5.0/tstep + 0.9999)

  do ipass=1,2
!    call timer('sync9   ',0)
    call sync9(nzhsym,lag1,lag2,ia,ib,ccfred,red2)
!    call timer('sync9   ',1)
  
    done=.false.
    ipeak1=0; ipeak2=0; ipeak3=0; ipeak4=0; ipeak5=0
    if(.not.nagain .and. (.not.nagainfil)) then
       if(nfqso.ge.4) infa=nint((nfqso-3)/df3)
       if(nfqso.lt.4) infa=nint((nfqso)/df3)
       if(nfqso.le.4979) infb=nint((nfqso+3)/df3)
       if(nfqso.gt.4979) infb=nint((nfqso)/df3)
       if(infa.gt.0 .and. infb.gt.0 .and. infa.lt.NSMAX .and. infb.lt.NSMAX) then
          ccfredmax=0.
          do i=infa,infb
             if(ccfred(i).gt.ccfredmax) then
                ipeak1=i
                ccfredmax=ccfred(i)
             endif
          enddo
          ccfredmax=0.
          do i=infa,infb
             if(ccfred(i).gt.ccfredmax .and. i.ne.ipeak1) then
                ipeak2=i
                ccfredmax=ccfred(i)
             endif
          enddo
          ccfredmax=0.
          do i=infa,infb
             if(ccfred(i).gt.ccfredmax .and. i.ne.ipeak1 .and. i.ne.ipeak2) then
                ipeak3=i
                ccfredmax=ccfred(i)
             endif
          enddo
          ccfredmax=0.
          do i=infa,infb
             if(ccfred(i).gt.ccfredmax .and. i.ne.ipeak1 .and. i.ne.ipeak2 .and. i.ne.ipeak3) then
                ipeak4=i
                ccfredmax=ccfred(i)
             endif
          enddo
          ccfredmax=0.
          do i=infa,infb
             if(ccfred(i).gt.ccfredmax .and. i.ne.ipeak1 .and. i.ne.ipeak2 .and. i.ne.ipeak3 .and. i.ne.ipeak4) then
                ipeak5=i
                ccfredmax=ccfred(i)
             endif
          enddo
       endif
    endif
	
    if(nagain .or. nagainfil) then
    ipeak1=0; ipeak2=0; ipeak3=0; ipeak4=0; ipeak5=0
       if(nagain) then
         if(nfqso.ge.4) infa=nint((nfqso-3)/df3)
         if(nfqso.lt.4) infa=nint((nfqso)/df3)
         if(nfqso.le.4979) infb=nint((nfqso+3)/df3)
         if(nfqso.gt.4979) infb=nint((nfqso)/df3)
       endif
       if(nagainfil) then
          if(nfqso.ge.21) infa=nint((nfqso-20)/df3)
          if(nfqso.lt.21) infa=nint((nfqso)/df3)
          if(nfqso.le.4962) infb=nint((nfqso+20)/df3)
          if(nfqso.gt.4962) infb=nint((nfqso)/df3)
       endif
       if(infa.gt.0 .and. infb.gt.0 .and. infa.lt.NSMAX .and. infb.lt.NSMAX) then
          ccfredmax=0.
          do i=infa,infb
             if(ccfred(i).gt.ccfredmax) then
                ipeak1=i
                ccfredmax=ccfred(i)
             endif
          enddo
          ccfredmax=0.
          do i=infa,infb
             if(ccfred(i).gt.ccfredmax .and. i.ne.ipeak1) then
                ipeak2=i
                ccfredmax=ccfred(i)
             endif
          enddo
          ccfredmax=0.
          do i=infa,infb
             if(ccfred(i).gt.ccfredmax .and. i.ne.ipeak1 .and. i.ne.ipeak2) then
                ipeak3=i
                ccfredmax=ccfred(i)
             endif
          enddo
          ccfredmax=0.
          do i=infa,infb
             if(ccfred(i).gt.ccfredmax .and. i.ne.ipeak1 .and. i.ne.ipeak2 .and. i.ne.ipeak3) then
                ipeak4=i
                ccfredmax=ccfred(i)
             endif
          enddo
          ccfredmax=0.
          do i=infa,infb
             if(ccfred(i).gt.ccfredmax .and. i.ne.ipeak1 .and. i.ne.ipeak2 .and. i.ne.ipeak3 .and. i.ne.ipeak4) then
                ipeak5=i
                ccfredmax=ccfred(i)
             endif
          enddo
       endif
    endif

    nsps8=nsps/8
    df8=1500.0/nsps8
    dblim=db(864.0/nsps8) - 26.2

    ia1=1                         !quel compiler gripe
    ib1=1                         !quel compiler gripe
    if(hint .and. ntxmode.eq.9) then; ncycles=2; else; ncycles=1; endif
    do nqd=ncycles,0,-1
!if(nqd.eq.0) exit !diag only
       if(nqd.eq.1 .and. nagainfil) cycle
       limit=5000
       ccflim=3.0
       red2lim=1.6
       if(ndepth.eq.2) then
          limit=10000
          ccflim=2.7
       endif
       if(ndepth.ge.3) then
          limit=30000
          ccflim=2.5
       endif
       if(nqd.eq.1) then
          limit=200000
          ccflim=2.4
       endif
       if(nagain) then
          limit=5000000
          ccflim=2.3
       endif
       if(nagainfil) then
          limit=300000
          ccflim=2.3
       endif

       ccfok=.false.

       ntol1=ntol !supress compiler warning
       if(nqd.ge.1) then
          nfa1=nfqso-2
          nfb1=nfqso+2
          ia=max(1,nint(nfa1/df3))
          ib=min(NSMAX,nint(nfb1/df3))
          ccfok(ia:ib)=(ccfred(ia:ib).gt.(ccflim-2.0)) .and.               &
               (red2(ia:ib).gt.(red2lim-1.0))
          ia1=ia
          ib1=ib
       else
          nfa1=nf1
          nfb1=nfb
          ia=max(1,nint(nfa1/df3))
          ib=min(NSMAX,nint(nfb1/df3))
          do i=ia,ib
             ccfok(i)=ccfred(i).gt.ccflim .and. red2(i).gt.red2lim
          enddo
          ccfok(ia1:ib1)=.false.
       endif

       fgood=0.
       do i=ia,ib
          if((nagain.or.nagainfil.or.nqd.eq.1) .and. i.ne.ipeak1 .and. i.ne.ipeak2 .and. i.ne.ipeak3 &
              .and. i.ne.ipeak4 .and. i.ne.ipeak5) cycle
          if((nagain.or.nagainfil.or.nqd.eq.1) .and. i.eq.ipeak1 .and. ipeak1.eq.0) cycle
          if((nagain.or.nagainfil.or.nqd.eq.1) .and. i.eq.ipeak2 .and. ipeak2.eq.0) cycle
          if((nagain.or.nagainfil.or.nqd.eq.1) .and. i.eq.ipeak3 .and. ipeak3.eq.0) cycle
          if((nagain.or.nagainfil.or.nqd.eq.1) .and. i.eq.ipeak4 .and. ipeak4.eq.0) cycle
          if((nagain.or.nagainfil.or.nqd.eq.1) .and. i.eq.ipeak5 .and. ipeak5.eq.0) cycle

          if(nqd.ne.2 .and. done(i) .or. (.not.ccfok(i))) cycle
          f=(i-1)*df3

          if(nqd.ge.1 .or.                                                   &
               (ccfred(i).ge.ccflim .and. abs(f-fgood).gt.10.0*df8)) then

!             call timer('softsym ',0)
             fpk=df3*(i-1)
             if(nqd.eq.2) fpk=real(nfqso)
             tryhint=.false.
             if(nqd.eq.2 .and. ipass.eq.2) then
                if(abs(real(nfqso)-rxfdec(1)%freq).lt.2.0 .and. len_trim(hiscall).gt.2) then
                   i1=index(rxfdec(1)%msg,' ')
                   i2=index(rxfdec(1)%msg((i1+1):),' ')
                   if(i1.lt.8 .and. i2.lt.15) hiscallrxf=rxfdec(1)%msg((i1+1):(i1+i2-1))
                   if(hiscall.eq.hiscallrxf .and. len_trim(hiscallrxf).ne.0) then
                      fpk=rxfdec(1)%freq
                      xdtrxf=rxfdec(1)%xdt
                      if(xdtrxf.gt.-2.5 .and. xdtrxf.lt.5.0) tryhint=.true.
                   endif
                endif
             endif
             call softsym(npts8,nsps8,newdat,fpk,syncpk,snrdb,xdt,    &
                  freq,drift,a3,schk,i1SoftSymbols,mrs,mrs2,s3,tryhint,xdtrxf,nmode)
!             call timer('softsym ',1)

             sync=(syncpk+1)/4.0
             dofano=.true.
             if(nqd.eq.2) dofano=.false. 
             if(nqd.eq.1 .and. ((sync.lt.0.5) .or. (schk.lt.1.0))) dofano=.false.
             if(nqd.eq.0 .and. ((sync.lt.1.0) .or. (schk.lt.1.5))) cycle

             rxfreq=.false.
             if(abs(freq-real(nfqso)).lt.2.0 .and. xdt.gt.-0.5 .and. xdt.lt.1.5) rxfreq=.true.
             freemsg=.false.; servis9=' '

!if(rxfreq) print *,fpk,freq,xdt
             call decode9(i1SoftSymbols,limit,msg,freemsg,i4Decoded6BitWords,mrs,mrs2,hint, &
                  stophint,nlasttx,mycall,hiscall,hisgrid,rxfreq,s3,i4GrayCodedSym,hintdec, &
                  chint,dofano,snrdb,ntxmode,tryhint)
             if(nqd.ne.2) then
                if(abs(f-real(nfqso)).lt.3.0 .and. freemsg) servis9=','
                if(abs(f-real(nfqso)).ge.3.0 .and. freemsg) servis9='.'
             endif
             if(hintdec) servis9=chint

             if(sync.lt.0.0 .or. snrdb.lt.dblim-2.0) sync=0.0
             nsync=int(sync)
             if(nsync.gt.10) nsync=10
             nsnr=nint(snrdb)
             ndrift=nint(drift/df3)

             if(msg.ne.'                      ') then
                dupe=.false.
                if(ndecoded.ne.0) then
                   if(.not.hintdec) then
                      do k=1,200
                         if(dec(k)%i.eq.-1) exit
                         if(dec(k)%decoded.eq.msg .and. abs(dec(k)%i-i).lt.24) dupe=.true.
                      enddo
                   else
                     do k=1,200
                        if(dec(k)%i.eq.-1) exit
                        if(dec(k)%decoded(1:10).eq.msg(1:10) .and. abs(dec(k)%i-irxf).lt.104) dupe=.true. !45Hz
                     enddo
                   endif
                endif

                if(dupe) cycle
 
                if (associated(this%callback)) then
                   msg26=msg//'    '
                   call this%callback(nutc,nsnr,xdt,freq,msg26,servis9)
                end if
                if(.not.hintdec) then
                   iaa=max(1,i-1)
                   ibb=min(NSMAX,i+11)
                else
                   iaa=max(1,irxf-1)
                   ibb=min(NSMAX,irxf+1)
                endif
                fgood=f
                ndecoded=ndecoded+1
                ccfok(iaa:ibb)=.false.
                done(iaa:ibb)=.true.
                if(nqd.lt.2) then; dec(ndecoded)%i=i; else; dec(ndecoded)%i=irxf; endif
                dec(ndecoded)%decoded=msg
                if(.not.freemsg .and. abs(freq-real(nfqso)).lt.2.0 .and. msg(1:4).eq.mycall(1:4)) then
                   rxfdec(1)%msg=msg
                   rxfdec(1)%xdt=xdt
                   rxfdec(1)%freq=freq
                endif
                if(ipass.ne.2) call subtract9(i4Decoded6BitWords,freq,drift,xdt,i4GrayCodedSym,hintdec)
             endif
          endif
          if(nqd.eq.2) exit
       enddo
       if(nagain) exit
    enddo
    if(ipass.eq.1) newdat=.true.
  enddo
    return
  end subroutine decode
end module jt9_decode

program genmet

! Generate metric table for M-FSK modulation.

  character*12 arg
  real*4 r(0:255)
  integer hist(2,-128:128)
  data hist/514*0/,idum/-1/

  lim(x)=min(127,max(-128,nint(scale*x)))

  nargs=iargc()
  if(nargs.ne.5) then
     print*,'Usage: genmet ncoh nadd m0 snr iters'
     go to 999
  endif
  call getarg(1,arg)
  read(arg,*) ncoh
  call getarg(2,arg)
  read(arg,*) nadd
  call getarg(3,arg)
  read(arg,*) m0
  call getarg(4,arg)
  read(arg,*) snr
  call getarg(5,arg)
  read(arg,*) iters

  ntones=2**m0
  xm0=m0
  scale=5.0
  fac=sqrt(1.0/nadd)
  s=sqrt(10.0**(0.1*snr))
  hist=0
  nerr=0

  call sgran()

  do iter=1,iters
     do i=0,ntones-1
        r(i)=0.
        do n=1,nadd
           x1=0.707*gran()
           y1=0.707*gran()
           if(i.eq.0) x1=x1+s
           if(ncoh.eq.0) r(i)=r(i) + x1*x1 + y1*y1
           if(ncoh.ne.0) r(i)=r(i) + x1
        enddo
        r(i)=fac*r(i)
     enddo
     do m=0,m0-1
        n=2**m
        r1=0.
        r2=0.
        do i=0,ntones-1
           if(iand(i,n).ne.0) r1=max(r1,r(i))
           if(iand(i,n).eq.0) r2=max(r2,r(i))
        enddo
        don=r2-r1
        doff=r1-r2
        if(don.lt.0.0) nerr=nerr+1
        j1=lim(doff)
        hist(1,j1)=hist(1,j1)+1
        j2=lim(don)
        hist(2,j2)=hist(2,j2)+1
     enddo
  enddo

  do i=-128,127
     write(13,1010) i/scale,hist(1,i)/(xm0*iters),hist(2,i)/(xm0*iters)
1010 format(f8.3,2f12.9)
  enddo

  ber=nerr/(xm0*iters)
  write(*,1020) nadd,m0,snr,ber
1020 format('nadd:',i3,'   m0:',i2,'   snr: 'f5.1,'   BER:',f8.3)
      
  xln2=log(2.0)
  do i=-128,127
     p1=hist(2,i)/(xm0*iters)
     p0=hist(1,i)/(xm0*iters)
     if(p0+p1.eq.0.0 .and. i.lt.0) p0=1.e-6
     if(p0+p1.eq.0.0 .and. i.gt.0) p1=1.e-6
     xlhd0=log(max(0.001,2.0*p0/(p0+p1)))/xln2
     xlhd1=log(max(0.001,2.0*p1/(p0+p1)))/xln2
     write(14,1012) i/scale,xlhd0,xlhd1,p0/(p0+p1),p1/(p0+p1)
1012 format(f7.1,2f8.3,2f9.6)
  enddo
      
999 end program genmet

! This source code file was last time modified by Igor UA3DJY on 20191101
! All changes are shown in the patch file coming together with the full JTDX source code.

subroutine get_ft4_bitmetrics(cd,bitmetrics,badsync)

!   use ft4_mod1, only : llagcc
   include 'ft4_params.f90'
   parameter (NSS=NSPS/NDOWN,NDMAX=NMAX/NDOWN)
   complex cd(0:NN*NSS-1),cs(0:3,NN),csymb(NSS)
   integer icos4a(0:3),icos4b(0:3),icos4c(0:3),icos4d(0:3),graymap(0:3),ip(1)!,ka(1)
   logical one(0:255,0:7)    ! 256 4-symbol sequences, 8 bits
   logical first,badsync
   real bitmetrics(2*NN,3),s2(0:255),s4(0:3,NN)!,sp(0:3)

   data icos4a/0,1,3,2/,icos4b/1,0,2,3/,icos4c/2,3,1,0/,icos4d/3,2,0,1/,graymap/0,1,3,2/
   data first/.true./
   save first,one

   ibmax=1

   if(first) then
      one=.false.
      do i=0,255
         do j=0,7
            if(iand(i,2**j).ne.0) one(i,j)=.true.
         enddo
      enddo
      first=.false.
   endif

   do k=1,NN
      i1=(k-1)*NSS
      csymb=cd(i1:i1+NSS-1)
!      if(.not.llagcc) then; csymb(1)=csymb(1)*1.9; csymb(NSS)=csymb(NSS)*1.9; endif
      csymb(1)=csymb(1)*1.9; csymb(NSS)=csymb(NSS)*1.9
      call four2a(csymb,NSS,1,-1,1)
      cs(0:3,k)=csymb(1:4)
      s4(0:3,k)=abs(csymb(1:4))
   enddo

!   sp=0.
!   do k=0,3; sp(k)=sum(s4(k,1:4))+sum(s4(k,23:103)); enddo
!   ka=minloc(sp)-1; k=ka(1); if(k.lt.0) go to 2
!   do kb=0,3
!     if(kb.eq.k) cycle; spr=sp(kb)/sp(k)
!     if(spr.gt.1.4) then; s4(kb,:)=s4(kb,:)/spr; sprsqr=SQRT(spr); cs(kb,:)=cs(kb,:)/sprsqr; endif
!   enddo
!2  continue

! Sync quality check
   is1=0
   is2=0
   is3=0
   is4=0
   badsync=.false.
   do k=1,4
      ip=maxloc(s4(:,k))
      if(icos4a(k-1).eq.(ip(1)-1)) is1=is1+1
      ip=maxloc(s4(:,k+33))
      if(icos4b(k-1).eq.(ip(1)-1)) is2=is2+1
      ip=maxloc(s4(:,k+66))
      if(icos4c(k-1).eq.(ip(1)-1)) is3=is3+1
      ip=maxloc(s4(:,k+99))
      if(icos4d(k-1).eq.(ip(1)-1)) is4=is4+1
   enddo
   nsync=is1+is2+is3+is4   !Number of correct hard sync symbols, 0-16
   if(nsync .lt. 8) then
      badsync=.true.
      return
   endif

   do nseq=1,3             !Try coherent sequences of 1, 2, and 4 symbols
      if(nseq.eq.1) nsym=1
      if(nseq.eq.2) nsym=2
      if(nseq.eq.3) nsym=4
      nt=2**(2*nsym)
      do ks=1,NN-nsym+1,nsym  !87+16=103 symbols.
         amax=-1.0
         do i=0,nt-1
            i1=i/64
            i2=iand(i,63)/16
            i3=iand(i,15)/4
            i4=iand(i,3)
            if(nsym.eq.1) then
               s2(i)=abs(cs(graymap(i4),ks))
            elseif(nsym.eq.2) then
               s2(i)=abs(cs(graymap(i3),ks)+cs(graymap(i4),ks+1))
            elseif(nsym.eq.4) then
               s2(i)=abs(cs(graymap(i1),ks  ) + &
                  cs(graymap(i2),ks+1) + &
                  cs(graymap(i3),ks+2) + &
                  cs(graymap(i4),ks+3)   &
                  )
            else
               print*,"Error - nsym must be 1, 2, or 4."
            endif
         enddo
         ipt=1+(ks-1)*2
         if(nsym.eq.1) ibmax=1
         if(nsym.eq.2) ibmax=3
         if(nsym.eq.4) ibmax=7
         do ib=0,ibmax
            bm=maxval(s2(0:nt-1),one(0:nt-1,ibmax-ib)) - &
               maxval(s2(0:nt-1),.not.one(0:nt-1,ibmax-ib))
            if(ipt+ib.gt.2*NN) cycle
            bitmetrics(ipt+ib,nseq)=bm
         enddo
      enddo
   enddo

   bitmetrics(205:206,2)=bitmetrics(205:206,1)
   bitmetrics(201:204,3)=bitmetrics(201:204,2)
   bitmetrics(205:206,3)=bitmetrics(205:206,1)

   call normalizebmet(bitmetrics(:,1),2*NN)
   call normalizebmet(bitmetrics(:,2),2*NN)
   call normalizebmet(bitmetrics(:,3),2*NN)
   return

end subroutine get_ft4_bitmetrics

! This source code file was last time modified by Igor UA3DJY on January 24th, 2018
! All changes are shown in the patch file coming together with the full JTDX source code.

subroutine softsym(npts8,nsps8,newdat,fpk,syncpk,snrdb,xdt,        &
     freq,drift,a3,schk,i1SoftSymbols,mrs,mrs2,s3,tryhint,xdtrxf,nmode)

! Compute the soft symbols

  use timer_module, only: timer

  parameter (NZ2=1512,NZ3=1360)
  logical, intent(inout) :: newdat
  complex c2(0:NZ2-1)
  complex c3(0:NZ3-1)
  complex c5(0:NZ3-1)
  real a(3), s3(0:7,69)
  integer*1 i1SoftSymbolsScrambled(207),i1SoftSymbols(207)
  integer mrs(69),mrs2(69)
  logical(1) tryhint
  include 'jt9sync.f90'

  nspsd=16
  ndown=nsps8/nspsd

! Mix, low-pass filter, and downsample to 16 samples per symbol
!  call timer('downsam9',0)
  call downsam9(npts8,newdat,fpk,c2,nmode)
!  call timer('downsam9',1)

  call peakdt9(c2,nsps8,nspsd,c3,xdt,tryhint,xdtrxf)  !Find DT

  fsample=1500.0/ndown
  a=0.
!  call timer('afc9    ',0)
  call afc9(c3,nz3,fsample,a,syncpk)  !Find deltaF, fDot, extra DT
!  call timer('afc9    ',1)
  freq=fpk - a(1)
  drift=-2.0*a(2)
!  write(*,3301) fpk,freq,a
!3301 format(2f9.3,3f10.4)
  a3=a(3)
  a(3)=0.

!  call timer('twkfreq ',0)
  call twkfreq(c3,c5,nz3,fsample,a)   !Correct for delta f, f1, f2 ==> a(1:3)
!  call timer('twkfreq ',1)

! Compute soft symbols (in scrambled order)
!  call timer('symspec2',0)
  call symspec2(c5,nz3,nsps8,nspsd,fsample,freq,drift,snrdb,schk,      &
       i1SoftSymbolsScrambled,mrs,mrs2,s3)
!  call timer('symspec2',1)

! Remove interleaving
  call interleave9(i1SoftSymbolsScrambled,-1,i1SoftSymbols)

  return
end subroutine softsym

subroutine chkfalse8(msg37,i3,n3,nbadcrc,iaptype,lcall1hash)

  use ft8_mod1, only : mycall,hiscall,hisgrid4
  character msg37*37,decoded*22,callsign*12,calltmp*12,call_a*12,call_b*12,grid*12,callmask6*6
  character*6 mask6(3)
  integer, intent(in) :: i3,n3
  logical(1) falsedec,lchkcall,lgvalid,lwrongcall
  logical(1), intent(in) :: lcall1hash
  data mask6/'001000','101000','011000'/

  call_a=''; call_b=''
! iaptype=0 non-AP decoder
! iaptype=1 CQ message AP decoder

! i3 n3                                      Bits               Total  Message type
! ---------------------------------------------------------------------------------------
! 0   0 FREE TEXT MSG                        71                   71
! 0   1 K1ABC RR73; W9XYZ <KH1/KH7Z> -12     28 28 10 5           71   DXpedition Mode
! 0   2 PA3XYZ/P R 590003 IO91NP             28 1 1 3 12 25       70   EU VHF contest (2)
! 0   2 PA3XYZ 520093 IO91NP                 28 1 1 3 12 25       70   EU VHF contest (2)
! 0   3 WA9XYZ KA1ABC R 16A EMA              28 28 1 4 3 7        71   ARRL Field Day
! 0   3 WA9XYZ KA1ABC 7D EMA                 28 28 1 4 3 7        71   ARRL Field Day
! 0   3 WA9XYZ G8ABC 1D DX                   28 28 1 4 3 7        71   ARRL Field Day
! 0   4 WA9XYZ KA1ABC R 32A EMA              28 28 1 4 3 7        71   ARRL Field Day
! 0   5 123456789ABCDEF012                   71                   71   Telemetry (18 hex)
! 0   5 7123456789ABCDEF01                   71                   71   Telemetry (18 hex)
! 0   5 71234567                             71                   71   Telemetry (18 hex)
! 0   5 81234567                             71                   71   Telemetry (18 hex)
! 0   5 8123456789ABCDEF01                   71                   71   Telemetry (18 hex)
! 1     WA9XYZ/R KA1ABC/R R FN42             28 1 28 1 1 15       74   Standard msg, with std or non std callsign
! 1     WA9XYZ KA1ABC R-11                   28 1 28 1 1 15       74   Standard msg, with std or non std callsign
! 1     CQ 039 P30KJE/R DR46
! 2     PA1XYZ/P GM4ABC/P R FN42             28 1 28 1 1 15       74   EU VHF Contest
! 2     CQ 039 P30KJE/P DR46
! 3     TU; W9XYZ K1ABC R 579 MA             1 28 28 1 3 13       74   ARRL RTTY contest
! 3     TU; W9XYZ G8ABC R 559 0013           1 28 28 1 3 13       74   ARRL RTTY (DX)
! 4     <WA9XYZ> PJ4/KA1ABC RR73             13 58 1 2            74   Nonstandard call
! 4     <WA9XYZ> PJ4/KA1ABC                  13 58 1 2            74   Nonstandard call
! 4     PJ4/KA1ABC <WA9XYZ> RRR              13 58 1 2            74   Nonstandard call
! 4     CQ ZW5STAYHOME                       13 58 1 2            74   Nonstandard call

!print *,iaptype
!print *,i3,n3,msg37

! 'CQ 5NGX46MFKUE' 'CQ 53HDFKJEASD' 'CQ HDF53KJEASD'  i3=4 n3=1 
! -23  0.3 1482 ~ CQ EQ3YCI/KVNA  i3=4 n3=1 
! -23 -1.3 CQ P28Z58W/77M  i3=4 n3=1
  if(msg37(1:3).eq.'CQ ') then
    callsign=''; ispc1=index(msg37,' '); ispc2=index(msg37((ispc1+1):),' ')+ispc1
    if(i3.eq.4) then
      islash=index(msg37,'/')
      if(islash.le.0) then
        callsign=trim(msg37(ispc1+1:)); nlencall=len_trim(callsign); if(nlencall.lt.1) return; ispccall=index(callsign,' ')
! CQ 9D6T0GA4 Z space inside callsign of any length: protocol violation, or last char is digit
        if(ispccall.lt.nlencall .or. callsign(nlencall:nlencall).lt.':') then; nbadcrc=1; msg37=''; return; endif
      else
        if(islash.gt.ispc1 .and. islash.lt.ispc2) then
          if(islash-ispc1.le.ispc2-islash) then; callsign=msg37(islash+1:ispc2-1)
          else; callsign=msg37(ispc1+1:islash-1)
          endif
        endif
      endif
      include 'callsign_q.f90'
      if(islash.gt.0) then
        falsedec=.false.; call chkflscall('CQ          ',callsign,falsedec)
        if(falsedec) then; nbadcrc=1; msg37=''; return; endif
      else
        nlen=len_trim(callsign)
        if(nlen.ge.10) then
          falsedec=.false.
          call chklong8(callsign,falsedec)
          if(falsedec) then; nbadcrc=1; msg37=''; return; endif
        else if(nlen.eq.6 .and. index(callsign,'/').lt.1) then ! 'CQ VK6ZRW'  protocol violation, i3 for stdcall shall be equal to 1
          do i=1,6
            if(callsign(i:i).gt.'/' .and. callsign(i:i).lt.':') then; callmask6(i:i)='1'; else; callmask6(i:i)='0'; endif
          enddo
          falsedec=.false.
          do i=1,3
            if(callmask6.eq.mask6(i)) then; falsedec=.true.; exit; endif ! standard callsign, false decode
          enddo
          if(falsedec) then; nbadcrc=1; msg37=''; return; endif
        endif
      endif

! i=1 AP mask iaptype 1 false decodes
! -23  0.9 2630 ~ CQ P5RXL MK92 *
! -24  0.3  550 ~ CQ DZ0BIL/R AD94 *
!  -7  0.2  400 ~ CQ LI9NAI/R CF97 * in some noisy setups such decodes possible with a high SNR
    else if(iaptype.eq.1) then
      ispc3=index(msg37((ispc2+1):),' ')+ispc2
      if(msg37(ispc2-2:ispc2-1).eq.'/R' .or. msg37(ispc2-2:ispc2-1).eq.'/P') then; callsign=msg37(ispc1+1:ispc2-3)
      else; callsign=msg37(ispc1+1:ispc2-1)
      endif
      include 'callsign_q.f90'
      grid=''
      if(ispc3-ispc2.eq.5 .and. msg37(ispc2+1:ispc2+1).gt.'@' .and. msg37(ispc2+1:ispc2+1).lt.'S' .and. &
         msg37(ispc2+2:ispc2+2).gt.'@' .and. msg37(ispc2+2:ispc2+2).lt.'S' .and. &
         msg37(ispc2+3:ispc2+3).lt.':' .and. msg37(ispc2+4:ispc2+4).lt.':') grid=msg37(ispc2+1:ispc3-1)
      if(len_trim(grid).eq.4) then
        call chkgrid(callsign,grid,lchkcall,lgvalid,lwrongcall)
        if(lwrongcall .or. .not.lgvalid) then; nbadcrc=1; msg37=''; return; endif
      endif
    endif

    if(i3.eq.4) then
! CQ Y09Q7/SS60M  i3=4 n3=1
      callsign=''; callsign=trim(msg37(4:)); islash=index(callsign,'/'); islash2=index(callsign(islash+1:),'/')
      nlencall=len_trim(callsign)
      if(nlencall.eq.11 .and. islash.gt.0 .and. islash2.lt.1) then
        if(islash.lt.7) then
          if((callsign(islash+1:islash+1).lt.':' .and. callsign(islash+2:islash+2).lt.':') .or. &
             callsign(islash+1:islash+1).eq.'Q' .or. callsign(nlencall:nlencall).lt.':') then
            nbadcrc=1; msg37=''; return
          endif
        endif
        if(islash.gt.5) then
          if(callsign(islash-1:islash-1).lt.':' .or. (callsign(1:1).lt.':' .and. callsign(2:2).lt.':') .or. &
             callsign(1:1).eq.'Q') then
            nbadcrc=1; msg37=''; return
          endif
        endif
        if(islash.gt.4 .and. islash.lt.8) then
          call_a=''; call_b=''; call_a=callsign(1:islash-1); call_b=callsign(islash+1:)
          falsedec=.false.
          call chkflscall(call_a,call_b,falsedec)
          if(falsedec) then; nbadcrc=1; msg37=''; return; endif
        endif
      endif
    endif

! CQ 039 P30KJE/R DR46 i3=1 n3=5
! CQ 039 P30KJE/P DR46 i3=2 n3=5
    if(msg37(4:4).lt.':' .and. msg37(4:4).gt.'/' .and. msg37(7:7).eq.' ' .and. (i3.eq.1 .or. i3.eq.2)) then
      islash=index(msg37,'/')
      if(islash.gt.10 .and. islash.lt.15) then
        callsign=''; grid=''; callsign=msg37(8:islash-1); grid=msg37(islash+3:islash+6); nlengrid=len_trim(grid)
        if(nlengrid.eq.4 .and. grid(1:1).gt.'@' .and. grid(4:4).lt.':') then
          call chkgrid(callsign,grid,lchkcall,lgvalid,lwrongcall)
          if(lwrongcall .or. .not.lgvalid) then; nbadcrc=1; msg37=''; return; endif
        endif
        falsedec=.false.
        call chkflscall('MYCALL      ',callsign,falsedec)
        if(falsedec) then; nbadcrc=1; msg37=''; return; endif
      endif
    endif

! CQ CJ3OPE/R FP61 i3=1
! CQ KU3XIK NN41
    if(i3.eq.1 .and. iaptype.eq.0) then
      callsign=''; grid=''
      islash=index(msg37,'/R ')
      if(islash.gt.6) then
        callsign=msg37(4:islash-1); grid=msg37(islash+3:islash+6)
      else if(islash.lt.1) then
        ispc1=index(msg37,' '); ispc2=index(msg37((ispc1+1):),' ')+ispc1; ispc3=index(msg37((ispc2+1):),' ')+ispc2
        if(len_trim(msg37).eq.ispc3-1) then
          callsign=msg37(ispc1+1:ispc2-1); grid=msg37(ispc2+1:ispc3-1)
        else
          return ! 4-word message, will be processed in ft8b.f90
        endif
      endif
      nlengrid=len_trim(grid)
      if(nlengrid.eq.4 .and. grid(1:1).gt.'@' .and. grid(4:4).lt.':') then
        call chkgrid(callsign,grid,lchkcall,lgvalid,lwrongcall)
        if(lwrongcall .or. .not.lgvalid) then; nbadcrc=1; msg37=''; return; endif
      endif
      if(islash.gt.6) then
        falsedec=.false.
        call chkflscall('MYCALL      ',callsign,falsedec)
        if(falsedec) then; nbadcrc=1; msg37=''; return; endif
      endif
    endif

    return ! prevent further checking if message starts from 'CQ '
! TO DO via patterns: '175715 -18 -0.1 2519 ~ CQ P2PSR6UWBHS'
  endif

  if(iaptype.eq.2) then ! message starts with user's callsign, 2nd callsign is random
! ES1JA JA1QZQ/R R GD47
! UA3ALE A70DDN/R OF23
! ES6DO NH4CXV MA87
! EA1AHY PW1BSL R GR47 i3=1
! ES6DO ST0VQA R174 invalid message, can not be transmitted
    ispc1=index(msg37,' '); ispc2=index(msg37((ispc1+1):),' ')+ispc1
    callsign=''; grid=''
    callsign=msg37(ispc1+1:ispc2-1)
    islash=index(callsign,'/R')
    if(islash.gt.3) then
      calltmp='            '; calltmp=callsign(1:islash-1); callsign=calltmp
    endif
    include 'callsign_q.f90'
    ispc3=index(msg37((ispc2+1):),' ')+ispc2
    indxr=index(msg37,' R ')
    if(indxr.gt.7) then
      ispc4=index(msg37((ispc3+1):),' ')+ispc3
      if(ispc4-ispc3.eq.5) then
        if(msg37(ispc3+1:ispc3+1).gt.'@' .and. msg37(ispc3+1:ispc3+1).lt.'S' .and. &
           msg37(ispc3+2:ispc3+2).gt.'@' .and. msg37(ispc3+2:ispc3+2).lt.'S' .and. &
           msg37(ispc3+3:ispc3+3).lt.':' .and. msg37(ispc3+4:ispc3+4).lt.':') then
          grid=msg37(ispc3+1:ispc4-1)
        else ! invalid message
          nbadcrc=1; msg37=''; return
        endif
      endif
    else if(indxr.lt.1) then
      if(ispc3-ispc2.eq.5) then
        if(msg37(ispc2+1:ispc2+1).gt.'@' .and. msg37(ispc2+1:ispc2+1).lt.'S' .and. &
           msg37(ispc2+2:ispc2+2).gt.'@' .and. msg37(ispc2+2:ispc2+2).lt.'S' .and. &
           msg37(ispc2+3:ispc2+3).lt.':' .and. msg37(ispc2+4:ispc2+4).lt.':') then
          grid=msg37(ispc2+1:ispc3-1)
        else ! invalid message
          nbadcrc=1; msg37=''; return
        endif
      endif
    endif
    if(len_trim(grid).eq.4) then
      call chkgrid(callsign,grid,lchkcall,lgvalid,lwrongcall)
      if(lwrongcall .or. .not.lgvalid) then; nbadcrc=1; msg37=''; return; endif
    endif
!      call chkflscall('MYCALL      ',callsign,falsedec) ! too high risk to eliminate correct decode if callsign missed in ALLCALL7
!      if(falsedec) then; nbadcrc=1; msg37=''; return; endif
    return ! no need in other checks
  endif

  if(iaptype.eq.40) then ! AP mask '<mycall> ??? ???'
! JH4PUL/3 BG4NSA RQ43 * reported false decodes
! JH4PUL/3 M06FLK R AE10 * at least it is possible to transmit the message
    ispc1=index(msg37,' '); ispc2=index(msg37((ispc1+1):),' ')+ispc1
    callsign=''; grid=''
    callsign=msg37(ispc1+1:ispc2-1)
    include 'callsign_q.f90'
    ispc3=index(msg37((ispc2+1):),' ')+ispc2
    indxr=index(msg37,' R ')
    if(indxr.gt.7) then
      ispc4=index(msg37((ispc3+1):),' ')+ispc3
      if(ispc4-ispc3.eq.5 .and. msg37(ispc3+1:ispc3+1).gt.'@' .and. msg37(ispc3+1:ispc3+1).lt.'S' .and. &
         msg37(ispc3+2:ispc3+2).gt.'@' .and. msg37(ispc3+2:ispc3+2).lt.'S' .and. &
         msg37(ispc3+3:ispc3+3).lt.':' .and. msg37(ispc3+4:ispc3+4).lt.':') grid=msg37(ispc3+1:ispc4-1)
    else if(indxr.lt.1) then
      if(ispc3-ispc2.eq.5 .and. msg37(ispc2+1:ispc2+1).gt.'@' .and. msg37(ispc2+1:ispc2+1).lt.'S' .and. &
         msg37(ispc2+2:ispc2+2).gt.'@' .and. msg37(ispc2+2:ispc2+2).lt.'S' .and. &
         msg37(ispc2+3:ispc2+3).lt.':' .and. msg37(ispc2+4:ispc2+4).lt.':') grid=msg37(ispc2+1:ispc3-1)
    endif
    if(len_trim(grid).eq.4) then
      call chkgrid(callsign,grid,lchkcall,lgvalid,lwrongcall)
      if(lwrongcall .or. .not.lgvalid) then; nbadcrc=1; msg37=''; return; endif
    endif
    return ! no need in other checks for iaptype 40
  endif

! RV6ARZ CX7CO R NI25 ! mycall hiscall ??? AP mask false decode, both callsigns are correct, checking for valid grid
! ES6DO TK60CNES R MJ79 ! non standard DXCall, iaptype 11
! UA0ZZZ AA1AAA/1 R GC45 ! non standard DXCall, iaptype 11
! JH4PUL/3 HB9CEX R PN76 * ! non standard mycall, iaptype 41
! JH4PUL/3 JT1DN HB30 * ! non standard mycall, iaptype 41
  if(iaptype.eq.3 .or. iaptype.eq.11 .or. iaptype.eq.21 .or. iaptype.eq.41) then
    indxr=index(msg37,' R ')
    if(iaptype.eq.21 .and. indxr.gt.0) then; nbadcrc=1; msg37=''; return; endif ! not valid message in Hound mode
    islash1=index(msg37,'/'); ispc1=index(msg37,' '); ispc2=index(msg37((ispc1+1):),' ')+ispc1
    if(ispc1.gt.3 .and. ispc2.gt.7) then
      if(islash1.lt.ispc1 .or. (islash1.eq.ispc2-2 .and. msg37(ispc2-1:ispc2-1).lt.':' )) then ! AA1AAA/1 can be first or 2nd callsign
        if(msg37(1:ispc1-1).eq.mycall .and. msg37(ispc1+1:ispc2-1).eq.hiscall) then
          ispc3=index(msg37((ispc2+1):),' ')+ispc2; grid=''
          if(indxr.gt.7) then
            ispc4=index(msg37((ispc3+1):),' ')+ispc3
            if(ispc4-ispc3.eq.5 .and. msg37(ispc3+1:ispc3+1).gt.'@' .and. msg37(ispc3+1:ispc3+1).lt.'S' .and. &
               msg37(ispc3+2:ispc3+2).gt.'@' .and. msg37(ispc3+2:ispc3+2).lt.'S' .and. &
               msg37(ispc3+3:ispc3+3).lt.':' .and. msg37(ispc3+4:ispc3+4).lt.':') grid=msg37(ispc3+1:ispc4-1)
          else if(indxr.lt.1) then
            if(ispc3-ispc2.eq.5 .and. msg37(ispc2+1:ispc2+1).gt.'@' .and. msg37(ispc2+1:ispc2+1).lt.'S' .and. &
               msg37(ispc2+2:ispc2+2).gt.'@' .and. msg37(ispc2+2:ispc2+2).lt.'S' .and. &
               msg37(ispc2+3:ispc2+3).lt.':' .and. msg37(ispc2+4:ispc2+4).lt.':') grid=msg37(ispc2+1:ispc3-1)
          endif
          if(len_trim(grid).eq.4 .and. grid.ne.hisgrid4) then ! correctly decoded contest message
            if(iaptype.eq.21) then
              if(grid.eq.'RR73') then
                return ! AP mask 'mybcall hisbcall ???' can trigger RR73 message
              else
                nbadcrc=1; msg37=''; return ! not valid message in Hound mode
              endif
            endif
            call chkgrid(hiscall,grid,lchkcall,lgvalid,lwrongcall)
            if(.not.lgvalid) then; nbadcrc=1; msg37=''; return; endif
          endif
        endif
      endif
    endif
    return ! no need in other checks
  endif

  if((i3.ge.1 .and. i3.le.3) .and. (index(msg37,' R ').gt.0 .or. index(msg37,'/R ').gt.0 .or. index(msg37,'/P ').gt.0)) then
! i3=1: 'VF5RMP/P OW3ATG/P R MF' '378YYA/R 9H5PQU R OL53'
! i3=2: 'YT4MEY/P WL8QEW R IR03'
! i3=1: 'ER2XXD 8L7UWC R 529 26'			   
! i3=3 n3=1: '1M8JSH TI0CZQ R 539 42'
! i3=2 n3=5: 'DQ2VF/P J2OON KG37'
! 'N40RTH AD2WPI/R MG62'
!print *,msg37
    islash1=index(msg37,'/')
    call_a=''; call_b=''
    ispc1=index(msg37,' '); ispc2=index(msg37((ispc1+1):),' ')+ispc1
    if(islash1.lt.1 .and. ispc1.gt.3 .and. ispc2.gt.7) then
      call_a=msg37(1:ispc1-1); call_b=msg37(ispc1+1:ispc2-1)
      if(call_b.ne.hiscall) then
        include 'call_q.f90'
        falsedec=.false.
        call chkflscall(call_a,call_b,falsedec)
        if(falsedec) then; nbadcrc=1; msg37=''; return; endif
      endif
    endif

    if(islash1.gt.0 .and. ispc1.gt.3 .and. ispc2.gt.7) then
      islash2=index(msg37((islash1+1):),'/')+islash1
      if(islash1.gt.ispc1) then
        call_a=msg37(1:ispc1-1); call_b=msg37(ispc1+1:islash1-1)
      else
        call_a=msg37(1:islash1-1)
        if(islash2.gt.islash1) then
          call_b=msg37(ispc1+1:islash2-1)
        else
          call_b=msg37(ispc1+1:ispc2-1)
        endif
      endif
      include 'call_q.f90'
      if(call_a.ne.mycall .and. call_b.ne.hiscall) then
        falsedec=.false.
        call chkflscall(call_a,call_b,falsedec)
        if(falsedec) then; nbadcrc=1; msg37=''; return; endif
      endif
    endif
  endif

! i3=1 n3=4
! 000189 -23  0.4  300 ~ <...> QG6GFE CQ14
! 110015 -21 -0.0 2050 ~ <...> NF7OEX CP03
! check if grid is correct for call_2
  if(lcall1hash .and. i3.eq.1) then ! hash can be associated with a valid callsign in the table
    ispc1=index(msg37,' ')
    if(msg37(1:ispc1-1).ne.mycall) then
      ispc2=index(msg37((ispc1+1):),' ')+ispc1
      callsign=''; grid=''
      callsign=msg37(ispc1+1:ispc2-1)
      islash=index(callsign,'/')
      if(islash.lt.1) then
        include 'callsign_q.f90'
        if(callsign.ne.hiscall) then
          ispc3=index(msg37((ispc2+1):),' ')+ispc2
          if(ispc3-ispc2.eq.5 .and. msg37(ispc2+1:ispc2+1).gt.'@' .and. msg37(ispc2+1:ispc2+1).lt.'S' .and. &
             msg37(ispc2+2:ispc2+2).gt.'@' .and. msg37(ispc2+2:ispc2+2).lt.'S' .and. &
             msg37(ispc2+3:ispc2+3).lt.':' .and. msg37(ispc2+4:ispc2+4).lt.':') then
            grid=msg37(ispc2+1:ispc3-1)
            call chkgrid(callsign,grid,lchkcall,lgvalid,lwrongcall)
            if(lwrongcall .or. .not.lgvalid) then; nbadcrc=1; msg37=''; return; endif
          endif
        endif
      endif
    endif
  endif

! i3=1 n3=1 '4P6NPC 5M5UJG BK49'
! i3=3 n3=1 '8Z7TLB JQ0OTZ 589 02'
! i3=0 n3=3 'CE3NTP 4C2DWN 5E ONE'
  if(iaptype.ne.2) then
    if(((i3.eq.1 .or. i3.eq.3) .and. index(msg37,' R ').le.0 .and. index(msg37,'/').le.0) .or. (i3.eq.0 .and. n3.eq.3)) then
      if(msg37(1:2).eq.'<.') go to 2
      ispc1=index(msg37,' '); ispc2=index(msg37((ispc1+1):),' ')+ispc1
      if(ispc1.gt.3 .and. ispc2.gt.7) then
        call_a=msg37(1:ispc1-1); if(call_a.eq.mycall) go to 2 ! exception to incoming calls
        call_b=msg37(ispc1+1:ispc2-1)
        include 'call_q.f90'
        falsedec=.false.
        call chkflscall(call_a,call_b,falsedec)
        if(falsedec) then; nbadcrc=1; msg37=''; return; endif
      endif
    endif
  endif

2 continue

  if(i3.eq.4) then
    ibrace1=index(msg37,'<.')
    if(index(msg37,'<.').gt.4) then
      callsign=''; callsign=msg37(1:ibrace1-2); islash=index(callsign,'/'); nlencall=len_trim(callsign)
      if(nlencall.lt.1) go to 4
! i3=4 n3=2 '6397X6JN637 <...> RRR' 
! 'R 5QCDOIY9 <...> RR73'
      if(index(trim(callsign),' ').gt.0 .or. (islash.lt.1 .and. callsign(nlencall:nlencall).lt.':')) then
        nbadcrc=1; msg37=''; return
      endif
      include 'callsign_q.f90'
      falsedec=.false.
      call chklong8(callsign,falsedec)
      if(falsedec) then; nbadcrc=1; msg37=''; return; endif
    endif
    if(msg37(1:2).eq.'<.' .or. index(msg37,'.>').gt.4) then
!'<...> 104J71MFOT9 RR73'
! i3=4 n3=0 '<...> /7ZZZZ/ /8'
! i3=4 n3=2 '<...> 6HGLDZ 5IN2 RRR'
      callsign=''; nlenmsg=len_trim(msg37)
      if(msg37(1:2).eq.'<.') then
        if(msg37(nlenmsg-4:nlenmsg).eq.' RR73') then; callsign=msg37(7:nlenmsg-5)
        else if(msg37(nlenmsg-2:nlenmsg).eq.' 73') then; callsign=msg37(7:nlenmsg-3)
        else if(msg37(nlenmsg-3:nlenmsg).eq.' RRR') then; callsign=msg37(7:nlenmsg-4)
        else; callsign=msg37(7:nlenmsg)
        endif
      else
        ibracket=index(msg37,'<.'); callsign=msg37(1:ibracket-2)
      endif
      nlencall=len_trim(callsign)
      if(nlencall.gt.0) then
        ispace=index(callsign(1:nlencall),' '); islash=index(callsign,'/')
        if(ispace.gt.0 .or. (islash.lt.1 .and. callsign(nlencall:nlencall).lt.':') .or. islash.eq.nlencall) then
          nbadcrc=1; msg37=''; return
        endif
! KY2HTW/0O5M <...>  i3=4 n3=0
        if(islash.gt.4) then
          islash2=index(callsign(islash+1:),'/')
          if(nlencall.eq.11 .and. islash2.lt.1) then
            if(islash.lt.7) then
              if((callsign(islash+1:islash+1).lt.':' .and. callsign(islash+2:islash+2).lt.':') .or. &
                 callsign(islash+1:islash+1).eq.'Q' .or. callsign(nlencall:nlencall).lt.':') then
                nbadcrc=1; msg37=''; return
              endif
            endif
            if(islash.gt.5) then
              if(callsign(islash-1:islash-1).lt.':' .or. (callsign(1:1).lt.':' .and.callsign(2:2).lt.':') .or. &
                 callsign(1:1).eq.'Q') then
                nbadcrc=1; msg37=''; return
              endif
            endif
            if(islash.gt.4 .and. islash.lt.8) then
              call_a=''; call_b=''; call_a=callsign(1:islash-1); call_b=callsign(islash+1:)
              falsedec=.false.
              call chkflscall(call_a,call_b,falsedec)
              if(falsedec) then; nbadcrc=1; msg37=''; return; endif
            endif
          endif
        endif
        include 'callsign_q.f90'
        falsedec=.false.
        call chklong8(callsign,falsedec)
        if(falsedec) then; nbadcrc=1; msg37=''; return; endif
      endif
    endif
! '<...> T99LMF GC41' need to understand how to check such message
  endif

4 continue

  if(i3.eq.3 .and. msg37(1:3).eq.'TU;') then 
!i3=3 n3=3 'TU; QV4UPP 632TGU 529'
    ispc1=index(msg37,' '); ispc2=index(msg37((ispc1+1):),' ')+ispc1 
    ispc3=index(msg37((ispc2+1):),' ')+ispc2
    if(ispc2.gt.7 .and. ispc3.gt.11) then
      call_a=msg37(ispc1+1:ispc2-1); call_b=msg37(ispc2+1:ispc3-1)
      include 'call_q.f90'
      falsedec=.false.
      call chkflscall(call_a,call_b,falsedec)
      if(falsedec) then; nbadcrc=1; msg37=''; return; endif
    endif
  endif

  if(i3.eq.0 .and. n3.eq.0) then
! 'J/.ZM1R-D1Q89'
    if(index(msg37,'/.').gt.0) then; nbadcrc=1; msg37=''; return; endif
    decoded=msg37(1:22)
    falsedec=.false.
    call filtersfree(decoded,falsedec)
    if(falsedec) then; nbadcrc=1; msg37=''; return; endif
  endif

! CQ_RLXA 551626 ^J65XI 
  if(i3.eq.0 .and. (msg37(1:3).eq.'CQ_' .or. index(msg37,'^').gt.0)) then
    nbadcrc=1; msg37=''; return
  endif

  return
end subroutine chkfalse8

! This source code file was last time modified by Igor UA3DJY on March 9th, 2017
! All changes are shown in the patch file coming together with the full JTDX source code.

logical function baddata()

  use jt65_mod6

  ninterval=1200
  j=0
  smin=1.e30
  smax=-smin
  iz=49*12000/ninterval
  nadd=ninterval/60

 ! 3457-4800 range: cover broken data being observed under Windows XP
  if(abs(dd(4200)).lt.0.1) dd(4200)=1.0

  do i=1,iz
     sq=0.
     do n=1,ninterval,60
        j=j+60
        x=dd(j)
        sq=sq + x*x
     enddo
     rms=sqrt(sq/nadd)
     smin=min(smin,rms)
     smax=max(smax,rms)
  enddo

  sratio=smax/(smin+1.e-30)
  baddata=.false.
  if(sratio.gt.1.e30) baddata=.true.

  return
end function baddata

subroutine noisegen(d4,nmax)

  real*4 d4(4,nmax)

  call init_random_seed()       ! seed Fortran RANDOM_NUMBER generator
  call sgran()                  ! see C rand generator (used in gran)

  do i=1,nmax
     d4(1,i)=gran()
     d4(2,i)=gran()
     d4(3,i)=gran()
     d4(4,i)=gran()
  enddo

  return
end subroutine noisegen

! This source code file was last time modified by Igor UA3DJY on 20190309
! All changes are shown in the patch file coming together with the full JTDX source code.

module packjt77sd

! These variables are accessible from outside via "use packjt77":
!  integer n28a,n28b

  contains

subroutine pack77sd(msg0,i3,n3,c77)

  use packjt
  character*37 msg,msg0
  character*13 w(19)
  character*77 c77
  integer nw(19)

  msg=msg0

! Convert msg to upper case; collapse multiple blanks; parse into words.
  call split77(msg,nwords,nw,w)
  i3=-1
  n3=-1
  if(msg(1:3).eq.'CQ ' .or. msg(1:3).eq.'DE ' .or. msg(1:4).eq.'QRZ ') go to 100

! Check Type 1 (Standard 77-bit message) or Type 2, with optional "/P"
100 call pack77_1(nwords,w,i3,n3,c77)
  if(i3.ge.0) go to 900

! It defaults to free text
  i3=0
  n3=0
  msg(14:)='                        '
  call packtext77(msg(1:13),c77(1:71))
  write(c77(72:77),'(2b3.3)') n3,i3

900 return
end subroutine pack77sd

subroutine unpack77sd(c77,msg,unpk77_success)

  parameter (MAXGRID4=32400)
  integer*8 n58
  character*77 c77*77,msg*37,c*38,call_1*13,call_2*13,c11*11,grid4*4,crpt*3
  logical unpk28_success,unpk77_success

  data c/' 0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ/'/

  unpk77_success=.true.

! Check for bad data
  do i=1,77
     if(c77(i:i).ne.'0' .and. c77(i:i).ne.'1') then
        msg='failed unpack'
        unpk77_success=.false.
        return
     endif
  enddo

  read(c77(72:77),'(2b3)') n3,i3
  msg=repeat(' ',37)
  if(i3.eq.0 .and. n3.eq.0) then
! 0.0  Free text
     call unpacktext77(c77(1:71),msg(1:13))
     msg(14:)='                        '
     msg=adjustl(msg)

  else if(i3.eq.1 .or. i3.eq.2) then
! Type 1 (standard message) or Type 2 ("/P" form for EU VHF contest)
     read(c77,1000) n28a,ipa,n28b,ipb,ir,igrid4,i3
1000 format(2(b28,b1),b1,b15,b3)
     call unpack28(n28a,call_1,unpk28_success)
     if(.not.unpk28_success) unpk77_success=.false.
     call unpack28(n28b,call_2,unpk28_success)
     if(.not.unpk28_success) unpk77_success=.false.
     if(call_1(1:3).eq.'CQ_') call_1(3:3)=' '
     if(index(call_1,'<').le.0) then
        i=index(call_1,' ')
        if(i.ge.4 .and. ipa.eq.1 .and. i3.eq.1) call_1(i:i+1)='/R'
        if(i.ge.4 .and. ipa.eq.1 .and. i3.eq.2) call_1(i:i+1)='/P'
     endif
     if(index(call_2,'<').le.0) then
        i=index(call_2,' ')
        if(i.ge.4 .and. ipb.eq.1 .and. i3.eq.1) call_2(i:i+1)='/R'
        if(i.ge.4 .and. ipb.eq.1 .and. i3.eq.2) call_2(i:i+1)='/P'
     endif
     if(igrid4.le.MAXGRID4) then
        n=igrid4
        j1=n/(18*10*10)
        n=n-j1*18*10*10
        j2=n/(10*10)
        n=n-j2*10*10
        j3=n/10
        j4=n-j3*10
        grid4(1:1)=char(j1+ichar('A'))
        grid4(2:2)=char(j2+ichar('A'))
        grid4(3:3)=char(j3+ichar('0'))
        grid4(4:4)=char(j4+ichar('0'))
        if(ir.eq.0) msg=trim(call_1)//' '//trim(call_2)//' '//grid4
        if(ir.eq.1) msg=trim(call_1)//' '//trim(call_2)//' R '//grid4
        if(msg(1:3).eq.'CQ ' .and. ir.eq.1) unpk77_success=.false.
     else
        irpt=igrid4-MAXGRID4
        if(irpt.eq.1) msg=trim(call_1)//' '//trim(call_2)
        if(irpt.eq.2) msg=trim(call_1)//' '//trim(call_2)//' RRR'
        if(irpt.eq.3) msg=trim(call_1)//' '//trim(call_2)//' RR73'
        if(irpt.eq.4) msg=trim(call_1)//' '//trim(call_2)//' 73'
        if(irpt.ge.5) then
           write(crpt,'(i3.2)') irpt-35
           if(crpt(1:1).eq.' ') crpt(1:1)='+'
           if(ir.eq.0) msg=trim(call_1)//' '//trim(call_2)//' '//crpt
           if(ir.eq.1) msg=trim(call_1)//' '//trim(call_2)//' R'//crpt
        endif
        if(msg(1:3).eq.'CQ ' .and. irpt.ge.2) unpk77_success=.false. 
     endif

  else if(i3.eq.4) then
     read(c77,1050) n12,n58,iflip,nrpt,icq
1050 format(b12,b58,b1,b2,b1)
     if(icq.eq.1) then
       do i=11,1,-1
         j=mod(n58,38)+1
         c11(i:i)=c(j:j)
         n58=n58/38
       enddo
       call_2=adjustl(c11)//'  '
       msg='CQ '//trim(call_2)
       if(msg(1:4).eq.'CQ <') unpk77_success=.false.
     else
       unpk77_success=.false.
     endif
  endif

  return
end subroutine unpack77sd

subroutine pack28(c13,n28)

! Pack a special token, a 22-bit hash code, or a valid base call into a 28-bit
! integer.

  parameter (NTOKENS=2063592,MAX22=4194304)
  logical is_digit,is_letter
  character*13 c13
  character*6 callsign
  character*1 c
  character*4 c4
  character*37 a1
  character*36 a2
  character*10 a3
  character*27 a4
  data a1/' 0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ'/
  data a2/'0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ'/
  data a3/'0123456789'/
  data a4/' ABCDEFGHIJKLMNOPQRSTUVWXYZ'/
  
  is_digit(c)=c.ge.'0' .and. c.le.'9'
  is_letter(c)=c.ge.'A' .and. c.le.'Z'

  n28=-1
! Work-around for Swaziland prefix:
  if(c13(1:4).eq.'3DA0') callsign='3D0'//c13(5:7)
! Work-around for Guinea prefixes:
  if(c13(1:2).eq.'3X' .and. c13(3:3).ge.'A' .and.          &
       c13(3:3).le.'Z') callsign='Q'//c13(3:6)

! Check for special tokens first
  if(c13(1:3).eq.'DE ') then
     n28=0
     go to 900
  endif
  
  if(c13(1:4).eq.'QRZ ') then
     n28=1
     go to 900
  endif

  if(c13(1:3).eq.'CQ ') then
     n28=2
     go to 900
  endif

  if(c13(1:3).eq.'CQ_') then
     n=len(trim(c13))
     if(n.ge.4 .and. n.le.7) then
        nlet=0
        nnum=0
        do i=4,n
           c=c13(i:i)
           if(c.ge.'A' .and. c.le.'Z') nlet=nlet+1
           if(c.ge.'0' .and. c.le.'9') nnum=nnum+1
        enddo
        if(nnum.eq.3 .and. nlet.eq.0) then
           read(c13(4:3+nnum),*) nqsy
           n28=3+nqsy
           go to 900
        endif
        if(nlet.ge.1 .and. nlet.le.4 .and. nnum.eq.0) then
           c4=c13(4:n)
           c4=adjustr(c4)
           m=0
           do i=1,4
              j=0
              c=c4(i:i)
              if(c.ge.'A' .and. c.le.'Z') j=ichar(c)-ichar('A')+1
              m=27*m + j
           enddo
           n28=3+1000+m
           go to 900
        endif
     endif
  endif

! Check for standard callsign
  iarea=-1
  n=len(trim(c13))
  do i=n,2,-1
     if(is_digit(c13(i:i))) exit
  enddo
  iarea=i                                   !Call-area digit
  npdig=0                                   !Digits before call area
  nplet=0                                   !Letters before call area
  do i=1,iarea-1
     if(is_digit(c13(i:i))) npdig=npdig+1
     if(is_letter(c13(i:i))) nplet=nplet+1
  enddo
  nslet=0
  do i=iarea+1,n
     if(is_letter(c13(i:i))) nslet=nslet+1
  enddo
  
  n=len(trim(c13))
! This is a standard callsign
  if(iarea.eq.2) callsign=' '//c13(1:5)
  if(iarea.eq.3) callsign=c13(1:6)
  i1=index(a1,callsign(1:1))-1
  i2=index(a2,callsign(2:2))-1
  i3=index(a3,callsign(3:3))-1
  i4=index(a4,callsign(4:4))-1
  i5=index(a4,callsign(5:5))-1
  i6=index(a4,callsign(6:6))-1
  n28=36*10*27*27*27*i1 + 10*27*27*27*i2 + 27*27*27*i3 + 27*27*i4 + &
       27*i5 + i6
  n28=n28 + NTOKENS + MAX22

900 n28=iand(n28,ishft(1,28)-1)
  return
end subroutine pack28


subroutine unpack28(n28_0,c13,success)

  parameter (NTOKENS=2063592,MAX22=4194304)
  logical success
  character*13 c13
  character*37 c1
  character*36 c2
  character*10 c3
  character*27 c4
  data c1/' 0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ'/
  data c2/'0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ'/
  data c3/'0123456789'/
  data c4/' ABCDEFGHIJKLMNOPQRSTUVWXYZ'/

  success=.true.
  n28=n28_0
  if(n28.lt.NTOKENS) then
! Special tokens DE, QRZ, CQ, CQ_nnn, CQ_aaaa
     if(n28.eq.0) c13='DE           '
     if(n28.eq.1) c13='QRZ          '
     if(n28.eq.2) c13='CQ           '
     if(n28.le.2) go to 900
     if(n28.le.1002) then
        write(c13,1002) n28-3
1002    format('CQ_',i3.3)
        go to 900
     endif
     if(n28.le.532443) then
        n=n28-1003
        n0=n
        i1=n/(27*27*27)
        n=n-27*27*27*i1
        i2=n/(27*27)
        n=n-27*27*i2
        i3=n/27
        i4=n-27*i3
        c13=c4(i1+1:i1+1)//c4(i2+1:i2+1)//c4(i3+1:i3+1)//c4(i4+1:i4+1)
        c13=adjustl(c13)
        c13='CQ_'//c13(1:10)
        go to 900
     endif
  endif
  n28=n28-NTOKENS
  
! Standard callsign
  n=n28 - MAX22
  i1=n/(36*10*27*27*27)
  n=n-36*10*27*27*27*i1
  i2=n/(10*27*27*27)
  n=n-10*27*27*27*i2
  i3=n/(27*27*27)
  n=n-27*27*27*i3
  i4=n/(27*27)
  n=n-27*27*i4
  i5=n/27
  i6=n-27*i5
  c13=c1(i1+1:i1+1)//c2(i2+1:i2+1)//c3(i3+1:i3+1)//c4(i4+1:i4+1)//     &
       c4(i5+1:i5+1)//c4(i6+1:i6+1)
  c13=adjustl(c13)

900 i0=index(c13,' ')
  if(i0.ne.0 .and. i0.lt.len(trim(c13))) then
     c13='QU1RK'
     success=.false.
  endif
  return
end subroutine unpack28

subroutine split77(msg,nwords,nw,w)

! Convert msg to upper case; collapse multiple blanks; parse into words.

  character*37 msg
  character*13 w(19)
  character*1 c,c0
  character*6 bcall_1
  logical ok1
  integer nw(19)
    
  iz=len(trim(msg))
  j=0
  k=0
  n=0
  c0=' '
  w='             '
  do i=1,iz
     if(ichar(msg(i:i)).eq.0) msg(i:i)=' '
     c=msg(i:i)                                 !Single character
     if(c.eq.' ' .and. c0.eq.' ') cycle         !Skip leading/repeated blanks
     if(c.ne.' ' .and. c0.eq.' ') then
        k=k+1                                   !New word
        n=0
     endif
     j=j+1                                      !Index in msg
     n=n+1                                      !Index in word
     if(c.ge.'a' .and. c.le.'z') c=char(ichar(c)-32)  !Force upper case
     msg(j:j)=c
     if(n.le.13) w(k)(n:n)=c                    !Copy character c into word
     c0=c
  enddo
  iz=j                                          !Message length
  nwords=k                                      !Number of words in msg
  if(nwords.le.0) go to 900
  nw(k)=len(trim(w(k)))
  msg(iz+1:)='                                     '
  if(nwords.lt.3) go to 900
  call chkcall(w(3),bcall_1,ok1)
  if(ok1 .and. w(1)(1:3).eq.'CQ ') then
     w(1)='CQ_'//w(2)(1:10)             !Make "CQ " into "CQ_"
     w(2:12)=w(3:13)                    !Move all remeining words down by one
     nwords=nwords-1
  endif
  
900 return
end subroutine split77

subroutine pack77_1(nwords,w,i3,n3,c77)
! Check Type 1 (Standard 77-bit message) and Type 2 (ditto, with a "/P" call)

  parameter (MAXGRID4=32400)
  character*13 w(19),c13
  character*77 c77
  character*6 bcall_1,bcall_2
  character*4 grid4
  character c1*1,c2*2
  logical is_grid4
  logical ok1,ok2
  is_grid4(grid4)=len(trim(grid4)).eq.4 .and.                        &
       grid4(1:1).ge.'A' .and. grid4(1:1).le.'R' .and.               &
       grid4(2:2).ge.'A' .and. grid4(2:2).le.'R' .and.               &
       grid4(3:3).ge.'0' .and. grid4(3:3).le.'9' .and.               &
       grid4(4:4).ge.'0' .and. grid4(4:4).le.'9'

  if(nwords.lt.2 .or. nwords.gt.4) return
  call chkcall(w(1),bcall_1,ok1)
  call chkcall(w(2),bcall_2,ok2)
  if(w(1)(1:3).eq.'DE ' .or. w(1)(1:3).eq.'CQ_' .or.  w(1)(1:3).eq.'CQ ' .or. &
       w(1)(1:4).eq.'QRZ ') ok1=.true.
  if(w(1)(1:1).eq.'<' .and. index(w(1),'>').ge.5) ok1=.true.
  if(w(2)(1:1).eq.'<' .and. index(w(2),'>').ge.5) ok2=.true.
  if(.not.ok1 .or. .not.ok2) return
  if(w(1)(1:1).eq.'<' .and. index(w(2),'/').gt.0) return
  if(w(2)(1:1).eq.'<' .and. index(w(1),'/').gt.0) return
  if(nwords.eq.2 .and. (.not.ok2 .or. index(w(2),'/').ge.2)) return
  if(nwords.eq.2) go to 10

  c1=w(nwords)(1:1)
  c2=w(nwords)(1:2)
  if(.not.is_grid4(w(nwords)(1:4)) .and. c1.ne.'+' .and. c1.ne.'-'              &
       .and. c2.ne.'R+' .and. c2.ne.'R-' .and. trim(w(nwords)).ne.'RRR' .and.   &
       trim(w(nwords)).ne.'RR73' .and. trim(w(nwords)).ne.'73') return
  if(c1.eq.'+' .or. c1.eq.'-') then
     ir=0
     read(w(nwords),*,err=900) irpt
     irpt=irpt+35
  else if(c2.eq.'R+' .or. c2.eq.'R-') then
     ir=1
     read(w(nwords)(2:),*) irpt
     irpt=irpt+35
  else if(trim(w(nwords)).eq.'RRR') then
     ir=0
     irpt=2
  else if(trim(w(nwords)).eq.'RR73') then
     ir=0
     irpt=3
  else if(trim(w(nwords)).eq.'73') then
     ir=0
     irpt=4
  endif

! 1     WA9XYZ/R KA1ABC/R R FN42           28 1 28 1 1 15   74   Standard msg
! 2     PA3XYZ/P GM4ABC/P R JO22           28 1 28 1 1 15   74   EU VHF contest  

10 i1psuffix=index(w(1)//' ' ,'/P ')
  i2psuffix=index(w(2)//' ','/P ')
  if(nwords.eq.2 .or. nwords.eq.3 .or. (nwords.eq.4 .and.               &
       w(3)(1:2).eq.'R ')) then
     n3=0
     i3=1                          !Type 1: Standard message, possibly with "/R"
     if (i1psuffix.ge.4.or.i2psuffix.ge.4) i3=2 !Type 2, with "/P"
  endif
  c13=bcall_1
  if(c13(1:3).eq.'CQ_' .or. w(1)(1:1).eq.'<') c13=w(1)
  call pack28(c13,n28a)
  c13=bcall_2
  if(w(2)(1:1).eq.'<') c13=w(2)
  call pack28(c13,n28b)
  ipa=0
  ipb=0
  if(i1psuffix.ge.4.or.index(w(1)//' ','/R ').ge.4) ipa=1
  if(i2psuffix.ge.4.or.index(w(2)//' ','/R ').ge.4) ipb=1
  
  grid4=w(nwords)(1:4)
  if(is_grid4(grid4)) then
     ir=0
     if(w(3).eq.'R ') ir=1
     j1=(ichar(grid4(1:1))-ichar('A'))*18*10*10
     j2=(ichar(grid4(2:2))-ichar('A'))*10*10
     j3=(ichar(grid4(3:3))-ichar('0'))*10
     j4=(ichar(grid4(4:4))-ichar('0'))
     igrid4=j1+j2+j3+j4
  else
     igrid4=MAXGRID4 + irpt
  endif
  if(nwords.eq.2) then
     ir=0
     irpt=1
     igrid4=MAXGRID4+irpt
  endif
  write(c77,1000) n28a,ipa,n28b,ipb,ir,igrid4,i3
1000 format(2(b28.28,b1),b1,b15.15,b3.3)
  return

900 return
end subroutine pack77_1

subroutine packtext77(c13,c71)

  character*13 c13,w
  character*71 c71
  character*42 c
  character*1 qa(10),qb(10)
  data c/' 0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ+-./?'/

  call mp_short_init
  qa=char(0)
  w=adjustr(c13)
  do i=1,13
     j=index(c,w(i:i))-1
     if(j.lt.0) j=0
     call mp_short_mult(qb,qa(2:10),9,42)     !qb(1:9)=42*qa(2:9)
     call mp_short_add(qa,qb(2:10),9,j)      !qa(1:9)=qb(2:9)+j
  enddo

  write(c71,1010) qa(2:10)
1010 format(b7.7,8b8.8)

  return
end subroutine packtext77

subroutine unpacktext77(c71,c13)

  integer*1   ia(10)
  character*1 qa(10),qb(10)
  character*13 c13
  character*71 c71
  character*42 c
  equivalence (qa,ia),(qb,ib)
  data c/' 0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ+-./?'/

  qa(1)=char(0)
  read(c71,1010) qa(2:10)
1010 format(b7.7,8b8.8)

  do i=13,1,-1
     call mp_short_div(qb,qa(2:10),9,42,ir)
     c13(i:i)=c(ir+1:ir+1)
     qa(2:10)=qb(1:9)
  enddo

  return
end subroutine unpacktext77

subroutine mp_short_ops(w,u)
  character*1 w(*),u(*)
  integer i,ireg,j,n,ir,iv,ii1,ii2
  character*1 creg(4)
  save ii1,ii2
  equivalence (ireg,creg)

  entry mp_short_init
  ireg=256*ichar('2')+ichar('1')
  do j=1,4
     if (creg(j).eq.'1') ii1=j
     if (creg(j).eq.'2') ii2=j
  enddo
  return

  entry mp_short_add(w,u,n,iv)
  ireg=256*iv
  do j=n,1,-1
     ireg=ichar(u(j))+ichar(creg(ii2))
     w(j+1)=creg(ii1)
  enddo
  w(1)=creg(ii2)
  return

  entry mp_short_mult(w,u,n,iv)
  ireg=0
  do j=n,1,-1
     ireg=ichar(u(j))*iv+ichar(creg(ii2))
     w(j+1)=creg(ii1)
  enddo
  w(1)=creg(ii2)
  return

  entry mp_short_div(w,u,n,iv,ir)
  ir=0
  do j=1,n
     i=256*ir+ichar(u(j))
     w(j)=char(i/iv)
     ir=mod(i,iv)
  enddo
  return
  
  return
end subroutine mp_short_ops

end module packjt77sd

subroutine twkfreq1(ca,nbot,npts,ntop,fsample,a,cb)

  use ft8_mod1, only : twopi
  complex, intent(in) :: ca(nbot:ntop)
  complex, intent(out) :: cb(nbot:ntop)
  complex w,wstep
  real a(5)

! Mix the complex signal
  w=1.0; wstep=1.0
!!  x0=0.5*(npts+1)
!!  s=2.0/npts
  do i=0,npts
!!     x=s*(i-x0) ! valid for 'do i=1,npts'
!!     p2=1.5*x*x - 0.5
!!     p3=2.5*(x**3) - 1.5*x
!!     p4=4.375*(x**4) - 3.75*(x**2) + 0.375
!!     dphi=(a(1) + x*a(2) + p2*a(3) + p3*a(4) + p4*a(5)) * (twopi/fsample)
     dphi=a(1) * (twopi/fsample)
     wstep=cmplx(cos(dphi),sin(dphi))
     w=w*wstep
     cb(i)=w*ca(i)
  enddo

  return
end subroutine twkfreq1

! This source code file was last time modified by Igor UA3DJY on February 3rd, 2017
! All changes are shown in the patch file coming together with the full JTDX source code.

subroutine geodist(Eplat,Eplon,Stlat,Stlon,Az,Baz,Dist)
  implicit none
  real eplat, eplon, stlat, stlon, az, baz, dist

! JHT: In actual fact, I use the first two arguments for "My Location",
!     the second two for "His location"; West longitude is positive.

!      Taken directly from:
!      Thomas, P.D., 1970, Spheroidal geodesics, reference systems,
!      & local geometry, U.S. Naval Oceanographi!Office SP-138,
!      165 pp.
!      assumes North Latitude and East Longitude are positive

!      EpLat, EpLon = End point Lat/Long
!      Stlat, Stlon = Start point lat/long
!      Az, BAz = direct & reverse azimuith
!      Dist = Dist (km); Deg = central angle, discarded

  real BOA, F, P1R, P2R, L1R, L2R, DLR, T1R, T2R, TM,          &
       DTM, STM, CTM, SDTM,CDTM, KL, KK, SDLMR, L,                &
       CD, DL, SD, T, U, V, D, X, E, Y, A, FF64, TDLPM,           &
       HAPBR, HAMBR, A1M2, A2M1

  real AL,BL,D2R,Pi2

  data AL/6378206.4/              ! Clarke 1866 ellipsoid
  data BL/6356583.8/
!      real pi /3.14159265359/
  data D2R/0.01745329251994/      ! degrees to radians conversion factor
  data Pi2/6.28318530718/

  if(abs(Eplat-Stlat).lt.0.02 .and. abs(Eplon-Stlon).lt.0.02) then
     Az=0.
     Baz=180.0
     Dist=0
     go to 999
  endif

  if(abs(Eplat-Stlat).lt.0.02 .and. abs(Eplon-Stlon).lt.0.02) then
     Az=0.
     Baz=180.0
     Dist=0
     go to 999
  endif

  BOA = BL/AL
  F = 1.0 - BOA
! Convert st/end pts to radians
  P1R = Eplat * D2R
  P2R = Stlat * D2R
  L1R = Eplon * D2R
  L2R = StLon * D2R
  DLR = L2R - L1R                 ! DLR = Delta Long in Rads
  T1R = ATan(BOA * Tan(P1R))
  T2R = ATan(BOA * Tan(P2R))
  TM = (T1R + T2R) / 2.0
  DTM = (T2R - T1R) / 2.0
  STM = Sin(TM)
  CTM = Cos(TM)
  SDTM = Sin(DTM)
  CDTM = Cos(DTM)
  KL = STM * CDTM
  KK = SDTM * CTM
  SDLMR = Sin(DLR/2.0)
  L = SDTM * SDTM + SDLMR * SDLMR * (CDTM * CDTM - STM * STM)
  CD = 1.0 - 2.0 * L
  DL = ACos(CD)
  SD = Sin(DL)
  T = DL/SD
  U = 2.0 * KL * KL / (1.0 - L)
  V = 2.0 * KK * KK / L
  D = 4.0 * T * T
  X = U + V
  E = -2.0 * CD
  Y = U - V
  A = -D * E
  FF64 = F * F / 64.0
  Dist = AL*SD*(T -(F/4.0)*(T*X-Y)+FF64*(X*(A+(T-(A+E)                 &
       /2.0)*X)+Y*(-2.0*D+E*Y)+D*X*Y))/1000.0
  TDLPM = Tan((DLR+(-((E*(4.0-X)+2.0*Y)*((F/2.0)*T+FF64*               &
       (32.0*T+(A-20.0*T)*X-2.0*(D+2.0)*Y))/4.0)*Tan(DLR)))/2.0)
  HAPBR = ATan2(SDTM,(CTM*TDLPM))
  HAMBR = Atan2(CDTM,(STM*TDLPM))
  A1M2 = Pi2 + HAMBR - HAPBR
  A2M1 = Pi2 - HAMBR - HAPBR

1 If ((A1M2 .ge. 0.0) .AND. (A1M2 .lt. Pi2)) GOTO 5
  If (A1M2 .lt. Pi2) GOTO 4
  A1M2 = A1M2 - Pi2
  GOTO 1
4 A1M2 = A1M2 + Pi2
  GOTO 1

! All of this gens the proper az, baz (forward and back azimuth)

5 If ((A2M1 .ge. 0.0) .AND. (A2M1 .lt. Pi2)) GOTO 9
  If (A2M1 .lt. Pi2) GOTO 8
  A2M1 = A2M1 - Pi2
  GOTO 5
8 A2M1 = A2M1 + Pi2
  GOTO 5

9 Az = A1M2 / D2R
  BAZ = A2M1 / D2R

!Fix the mirrored coords here.
  
  az = 360.0 - az
  baz = 360.0 - baz

999 return
end subroutine geodist

module crc 
  use, intrinsic :: iso_c_binding, only: c_int, c_loc, c_int8_t, c_bool, c_short
  interface
    function crc14 (data, length) bind (C, name="crc14")
      use, intrinsic :: iso_c_binding, only: c_short, c_ptr, c_int
      implicit none
      integer (c_short) :: crc14
      type (c_ptr), value :: data
      integer (c_int), value :: length
    end function crc14
 
    function crc14_check (data, length) bind (C, name="crc14_check")
      use, intrinsic :: iso_c_binding, only: c_bool, c_ptr, c_int
      implicit none
      logical (c_bool) :: crc14_check
      type (c_ptr), value :: data
      integer (c_int), value :: length
    end function crc14_check
    function crc12 (data, length) bind (C, name="crc12")
      use, intrinsic :: iso_c_binding, only: c_short, c_ptr, c_int
      implicit none
      integer (c_short) :: crc12
      type (c_ptr), value :: data
      integer (c_int), value :: length
    end function crc12
 
    function crc12_check (data, length) bind (C, name="crc12_check")
      use, intrinsic :: iso_c_binding, only: c_bool, c_ptr, c_int
      implicit none
      logical (c_bool) :: crc12_check
      type (c_ptr), value :: data
      integer (c_int), value :: length
    end function crc12_check

    function crc10 (data, length) bind (C, name="crc10")
      use, intrinsic :: iso_c_binding, only: c_short, c_ptr, c_int
      implicit none
      integer (c_short) :: crc10
      type (c_ptr), value :: data
      integer (c_int), value :: length
    end function crc10

    function crc10_check (data, length) bind (C, name="crc10_check")
      use, intrinsic :: iso_c_binding, only: c_bool, c_ptr, c_int
      implicit none
      logical (c_bool) :: crc10_check
      type (c_ptr), value :: data
      integer (c_int), value :: length
    end function crc10_check

  end interface
end module crc

! This source code file was last time modified by Igor UA3DJY on June 29th, 2017.
! All changes are shown in the patch file coming together with the full JTDX source code.

subroutine sync10(nzhsym,ia,ib,irxf,th_wide,th_rxf,ncand0,newdat,carxf,ca)

!  use jt9_mod2
  use jt65_mod6
!  include 'constants.f90'
  include 'jt10sync.f90'
  integer, parameter :: NSMAX10=11520, NFFT=27648, NHSYM=184, MAXCANDRXF=5, MAXCAND=200
  real ss(NHSYM,NSMAX10)
  real, DIMENSION(:), ALLOCATABLE :: dd1,ccfred1
  real ccfred(NSMAX10),psum(ia:ib),x(NFFT),w(NFFT)!,syncrio(NSMAX10), syncpwr(16)
  complex c(0:NFFT/2)
  integer ncand0
  logical newdat
  logical(1) first
  equivalence (x,c)
  type candrxf
     real ccfred
     integer i
  end type candrxf
  type(candrxf) carxf(MAXCANDRXF)
  type candidate
     real ccfred
     integer i
  end type candidate
  type(candidate) ca(MAXCAND)
  data first/.true./
  save first,w,ccfred,ss

 ! ipk=0
  ccfred=0.; psum=0.; nmaxcand=200; carxf%ccfred=0.; carxf%i=-1; ca%ccfred=0.; ca%i=-1 !; lagpk=0
  syncrio=1.0  
!  tstep=0.5*nsps/12000.0                      !Half-symbol step (seconds)
  lag1=-9 !-int(2.5/tstep + 0.9999) ! -9
  lag2=18 !int(5.0/tstep + 0.9999)  ! 18
  pfloor=0.; psavg=0.; fac1=0.1; twopi=6.28318531!; icandcount=0
  nhstep=3456 ! 6912/2
  fac2=(1.0/NFFT)**2

  if(first) then ! Compute the FFT window
     do k=1,NFFT
        w(k)=sin(twopi*(k+2)/55296.) ! 27648 = 2*NFFT
     enddo
     first=.false.
  endif
  if(newdat) then
     allocate(dd1(660096), STAT = nAllocateStatus1)
     if(nAllocateStatus1.ne.0) STOP "Not enough memory"
     dd1(1:624000)=dd(1:624000)
     dd1(624001:660096)=0.

     do j=1,nhsym
        i0=(j-1)*nhstep
        x=fac1*w*dd1(i0+1:i0+NFFT)
        call four2a(c,NFFT,1,-1,0)                !r2c forward FFT
        do i=ia,ib
!          s=fac2*(real(c(i))**2 + aimag(c(i))**2)
          s=fac2*SQRT(real(c(i))**2 + aimag(c(i))**2)
          ss(j,i)=s
        enddo
     enddo
     deallocate (dd1, STAT = nDeAllocateStatus1)
     if (nDeAllocateStatus1.ne.0) print *, 'failed to release memory'

     do i=ia,ib
        psum(i)=sum(ss(1:NHSYM,i))
        pfloor=pfloor+psum(i)
     enddo
     pfloor=pfloor/(ib-ia)
     facps=0.025
     psavg=facps*pfloor/float(NHSYM)

     do j=1,nhsym
        do i=1,ib
           ss(j,i)=ss(j,i)+psavg
        enddo
     enddo
  endif
  
!do k=1,NHSYM
!sssum=0.
!do i=ia,ib
! sssum=sssum+ss(k,i)
!enddo
!enddo
!print *,sssum
     
  do i=ia,ib
     psum(i)=sum(ss(1:NHSYM,i)) ! have to calculate psum again with corrected ss()
  enddo

!  pave=0.
  do i=ia,ib                         !Loop over freq range
     smax=0.
     do lag=lag1,lag2                !DT = -2.5 to 5.0s, lag -9..18
        sum1=0.
        do j=1,16                    !Sum over 16 sync symbols
           k=ii2(j) + lag
           if(k.ge.1 .and. k.le.nzhsym) then
              if(lsync(j)) sum1=sum1 + ss(k,i)
              if(.not.lsync(j) .and. i.lt.(ib-16)) sum1=sum1 + ss(k,i+16)
           endif
        enddo
        if(sum1.gt.smax) then
           smax=sum1
!           lagpk=lag
!           ipk=i 
        endif
     enddo


!     syncpwr=0.
!     do j=1,16
!        k=ii2(j) + lagpk
!        if(k.ge.1 .and. k.le.nzhsym) then
!           if(lsync(j)) syncpwr(j)=ss(k,i)
!           if(.not.lsync(j) .and. i.lt.(ib-16)) syncpwr(j)=ss(k,i+16)
!        endif
!     enddo
!     syncav516=0.
!     syncav516=(2.*sum(syncpwr(5:16)))/12.
!     do j=1,4
!        if(syncpwr(j).gt.syncav516) syncpwr(j)=syncav516
!     enddo
!     sync1=0.; sync2=0.
!     do j=1,16
!        if(lsync(j)) sync1=sync1+syncpwr(j)
!        if(.not.lsync(j) .and. i.lt.(ib-16)) sync2=sync2+syncpwr(j)
!     enddo
!    syncrio(i)=sync2/sync1
!    if(syncrio.gt.0.25 .and. syncrio.lt.4.0) fac=1.



     psig=0.; pnoise=0.
     htnoise=float(2*(NHSYM-16)) ! number of noise halftones for 2-tone sync pattern
     if(i.lt.(ib-16)) then
        psig=smax/16.
        pnoise=abs(psum(i)+psum(i+16)-2.*smax)/htnoise
     endif
     if(i.ge.(ib-16)) then
        psig=smax/8.
        pnoise=2.*abs(psum(i)-2.*smax)/htnoise
     endif
	 
!     if(i.lt.(ib-9)) sm0=(smax/16.- (psum(i)+psum(i+9)-2.*smax)/336.)/(psum(i)+psum(i+9))
!     if(i.ge.(ib-9)) sm0=(smax/8.- (psum(i)-2.*smax)/168.)/psum(i)

!     ccfred(i)=8.*fac*sm0                        !Best at this freq, over all lags
!     ccfred(i)=1.2*psig/(pnoise+psavg)              !Best at this freq, over all lags

!     ccfred(i)=1.2*psig/pnoise
     ccfred(i)=1.5*psig/pnoise

!print *,psavg
!f=(i-1)*12000.0/27648.0
!if(i.lt.50 .or. i.gt.3916) print *,f,ccfred(i)
!print *,f,ccfred(i)
!print *,psig,pnoise
!print *,'-'
!print *,psig,(pnoise+psavg)
!print *,psavg
!     pave=pave+ccfred(i)
!if(ccfred(i).gt.th_wide) icandcount=icandcount+1
  enddo
  
!print *,icandcount
!  pave=pave/(ib-ia)
!print *,pave
!do i=ia,ib
!f=(i-1)*1500./2048.
!if(abs(f-1710.).lt.20.) then
!print *,f,ccfred(i)
!endif
!enddo
  allocate(ccfred1(NSMAX10), STAT = nAllocateStatus1)
  if(nAllocateStatus1.ne.0) STOP "Not enough memory"
  do i=ia+9,ib-8
    qual=ccfred(i)*2.0/(ccfred(i-8)+ccfred(i+8))
!if(syncrio(i).gt.1.0) ccfred1(i)=qual*ccfred(i)/sqrt(syncrio(i))
!if(syncrio(i).le.1.0) ccfred1(i)=qual*sqrt(syncrio(i))*ccfred(i)
    ccfred1(i)=qual*ccfred(i)
  enddo
  ccfred1(ia:ia+8)=ccfred(ia:ia+8)
  ccfred1(ib-8:ib)=ccfred(ib-8:ib)  

!  ccfred1=ccfred
  ncand1=0
  do m=1,maxcandrxf
     if(irxf.gt.3 .and. irxf.lt.(ib-3)) then
        nmaxloc=MAXLOC(ccfred1((irxf-3):(irxf+3)),dim=1)   !getting index of ccfred with maximum value for RX freq
        i=nmaxloc+irxf-4
        if(abs(ccfred1(i)).lt.th_rxf) cycle !lowest ccf threshold
        ncand1=ncand1+1
        carxf(ncand1)%ccfred=ccfred1(i)
        carxf(ncand1)%i=i
        ccfred1(i)=0.
     endif
  enddo

  ncand0=0
  do m=1,maxcand
     nmaxloc=MAXLOC(ccfred1,dim=1)   !getting index of ccfred with maximum value
     if(abs(ccfred1(nmaxloc)).lt.th_wide) cycle !lowest ccf threshold
     ncand0=ncand0+1
     ca(ncand0)%ccfred=ccfred1(nmaxloc)
     ca(ncand0)%i=nmaxloc
     ccfred1(nmaxloc)=0.
  enddo
  deallocate (ccfred1, STAT = nDeAllocateStatus1)
  if (nDeAllocateStatus1.ne.0) print *, 'failed to release memory'
!print *,ncand0

!do i=1,200
!print *,(ca(i)%i-1)*12000.0/27648.0, ca(i)%ccfred
!enddo

  return
end subroutine sync10

subroutine genft4(msg0,ichk,ntxhash,msgsent,msgbits,i4tone)

! Encode an FT4  message
! Input:
!   - msg0     requested message to be transmitted
!   - ichk     if ichk=1, return only msgsent
!   - msgsent  message as it will be decoded
!   - i4tone   array of audio tone values, {0,1,2,3} 

! Frame structure:
! s16 + 87symbols + 2 ramp up/down = 105 total channel symbols
! r1 + s4 + d29 + s4 + d29 + s4 + d29 + s4 + r1

! Message duration: TxT = 105*576/12000 = 5.04 s
  
! use iso_c_binding, only: c_loc,c_size_t

  use packjt77
  include 'ft4_params.f90'  
  character*37 msg0
  character*37 message                    !Message to be generated
  character*37 msgsent                    !Message as it will be received
  character*77 c77
  integer*4 i4tone(NN),itmp(ND)
  integer*1 codeword(2*ND)
  integer*1 msgbits(77),rvec(77) 
  integer icos4a(4),icos4b(4),icos4c(4),icos4d(4)
  logical unpk77_success
  data icos4a/0,1,3,2/
  data icos4b/1,0,2,3/
  data icos4c/2,3,1,0/
  data icos4d/3,2,0,1/
  data rvec/0,1,0,0,1,0,1,0,0,1,0,1,1,1,1,0,1,0,0,0,1,0,0,1,1,0,1,1,0, &
            1,0,0,1,0,1,1,0,0,0,0,1,0,0,0,1,0,1,0,0,1,1,1,1,0,0,1,0,1, &
            0,1,0,1,0,1,1,0,1,1,1,1,1,0,0,0,1,0,1/
  message=msg0

  do i=1, 37
     if(ichar(message(i:i)).eq.0) then
        message(i:37)=' '
        exit
     endif
  enddo
  do i=1,37                               !Strip leading blanks
     if(message(1:1).ne.' ') exit
     message=message(i+1:)
  enddo

  i3=-1
  n3=-1
  call pack77(message,i3,n3,c77,ntxhash)
  if(ntxhash.eq.1) then
    call unpack77(c77,0,msgsent,unpk77_success,26) !TX message, unpack to get msgsent, use TX hash tables and do not save RX hash values
  else
    call unpack77(c77,0,msgsent,unpk77_success,25) !service message, unpack to get msgsent. Do not save hash values
  endif

  if(ichk.eq.1) go to 999
  read(c77,'(77i1)',err=1) msgbits
  if(unpk77_success) go to 2
1 msgbits=0
  itone=0
  msgsent='*** bad message ***                  '
  go to 999

entry get_ft4_tones_from_77bits(msgbits,i4tone)

2 msgbits=mod(msgbits+rvec,2)
  call encode174_91(msgbits,codeword)

! Grayscale mapping:
! bits   tone
! 00     0
! 01     1
! 11     2
! 10     3

  do i=1,ND
    is=codeword(2*i)+2*codeword(2*i-1)
    if(is.le.1) itmp(i)=is
    if(is.eq.2) itmp(i)=3
    if(is.eq.3) itmp(i)=2
  enddo

  i4tone(1:4)=icos4a
  i4tone(5:33)=itmp(1:29)
  i4tone(34:37)=icos4b
  i4tone(38:66)=itmp(30:58)
  i4tone(67:70)=icos4c
  i4tone(71:99)=itmp(59:87)
  i4tone(100:103)=icos4d

999 return
end subroutine genft4

! This source code file was last time modified by Igor UA3DJY on June 10th, 2017
! All changes are shown in the patch file coming together with the full JTDX source code.

subroutine decode10(i1SoftSymbols,limit,msg,freemsg,i4Decoded6BitWords,mrs,mrs2,hint, &
           stophint,nlasttx,mycall,hiscall,hisgrid,rxfreq,s3,i4GrayCodedSym,hintdec, &
           chint,dofano,snrdb,tryhint)

  character msg*22,decoded*22,mycall*6,hiscall*6,hisgrid*4,chint*1
  real s3(0:7,69)
  integer i4Decoded6BitWords(12),mrs(69),mrs2(69),i4GrayCodedSym(69)
  integer*1 i1SoftSymbols(207)
  integer nlasttx,nft
  logical(1) freemsg,hint,stophint,rxfreq,hintdec,dofano,tryhint

! nlasttx last transmitted message matrix
! nlasttx   last TX message  expected RX message
!   0           Halt TX              -
!   1           GRID             -01, and may be again CQ DXCall based
!   2           -01                R-01, and may be again GRID DXCall based
!   3           R-01            RRR/RR73/73,  and may be again -01
!   4           RRR/RR73        RRR/RR73/73
!   5           73/freemsg      RRR/RR73/73
!   6           CQ              GRID fm CALL3
!   8           freemsg         RRR/RR73/73

  nft=0; hintdec=.false.; chint=' '; msg='                      '

  if(dofano) then
     call jt9fano(i1SoftSymbols,limit,msg,freemsg,i4Decoded6BitWords)
     if(msg.ne.'                      ') nft=1
  endif

  hintth=-24.0
  if(tryhint) hintth=28.0
!if(nft.eq.0) then ! diag only
  if(.not.stophint .and. hint .and. nft.eq.0 .and. snrdb.lt.hintth) then
     if(rxfreq) then
        if(nlasttx.eq.1) then
           call hintdxr10(mrs,mrs2,mycall,hiscall,decoded,hintdec,s3,i4GrayCodedSym)
           if(hintdec) go to 2
        endif
        if(nlasttx.eq.2) then
           call hintdxrr10(mrs,mrs2,mycall,hiscall,decoded,hintdec,s3,i4GrayCodedSym)
           if(hintdec) go to 2
           call hintdxgrid10(mrs,mrs2,mycall,hiscall,hisgrid,decoded,hintdec,s3,i4GrayCodedSym)
           if(hintdec) go to 2
        endif
        if(nlasttx.eq.3) then
           call hintdx7310(mrs,mrs2,mycall,hiscall,decoded,hintdec,s3,i4GrayCodedSym)
           if(hintdec) go to 2
           call hintdxr10(mrs,mrs2,mycall,hiscall,decoded,hintdec,s3,i4GrayCodedSym)
           if(hintdec) go to 2
        endif
        if(nlasttx.eq.4 .or. nlasttx.eq.5 .or. nlasttx.eq.8) then
           call hintdx7310(mrs,mrs2,mycall,hiscall,decoded,hintdec,s3,i4GrayCodedSym)
           if(hintdec) go to 2
        endif
        if(nlasttx.eq.6) then !CALL3 based decoder mycall+hiscall+grid message
           call hintrxgrid10(mrs,mrs2,mycall,decoded,hintdec,s3,i4GrayCodedSym)
           if(hintdec) go to 2
        endif
     endif
2    if(hintdec) then 
        nft=2; chint='*'; freemsg=.false.
        msg=decoded
     else
        msg='                      '
     endif
  endif

  return
end subroutine decode10

! This source code file was last time modified by Igor UA3DJY on August 1st, 2017
! All changes are shown in the patch file coming together with the full JTDX source code.

subroutine agcc(nmode,ntxmode)

  use jt65_mod6
! Compute JT65 symbol spectra at half-symbol steps
  integer, parameter :: NFFT=8192,NSZ=3413,NHSYM=276 !3413 = NFFT*5000/12000
 ! nhsym=276 (npts-NFFT)/hstep !number of half-symbols 276.2566 = (52*12000-8192)/(2048*12000/11025)
  real*4 x11(NFFT),w11(NFFT),b1(NHSYM),b2(NHSYM),b3(NHSYM),bband(3),bdeltamax(3)
  integer jmax(3)
  complex c11(0:NFFT/2)
  logical(1) first
  equivalence (x11,c11)
  data first/.true./
  save first,w11

  real, DIMENSION(:,:), ALLOCATABLE :: ss33
  allocate(ss33(276,3413), STAT = nAllocateStatus1)
  if(nAllocateStatus1.ne.0) STOP "Not enough memory"

  bdeltamax=0.1; jmax=1; bband=1.0; nhstep=2229 ! 2048*(12000./11025.) JT65 half-symbol = 2229.116 samples

  fac1=1.e-3
  twopi=6.28318531

  if(first) then ! Compute the FFT window
     do k=1,NFFT
     w11(k)=sin(twopi*(k+2)/16384) ! 16384 = 2*NFFT
      enddo
     first=.false.
  endif

  do j=1,nhsym
     i0=(j-1)*nhstep
     x11=fac1*w11*dd(i0+1:i0+NFFT)
     call four2a(c11,NFFT,1,-1,0)                !r2c forward FFT
     do i=1,NSZ
        s33=ABS(c11(i))
        ss33(j,i)=SQRT(s33)
     enddo
  enddo

  do k=1,3 ! nulling three strongest bins
     do j=1,65
        maxbindex=maxloc(ss33(j,341:410),dim=1)
        is1=340+maxbindex
        ss33(j,is1)=0.
        maxbindex=maxloc(ss33(j,853:922),dim=1)
        is1=852+maxbindex
        ss33(j,is1)=0.
        maxbindex=maxloc(ss33(j,1706:1775),dim=1)
        is1=1705+maxbindex
        ss33(j,is1)=0.
     enddo
  enddo
  
  do j=1,nhsym
     if(j.le.65 .or. j.ge.255) then
        b1(j)=sum(ss33(j,341:410))
        b2(j)=sum(ss33(j,853:922))
        b3(j)=sum(ss33(j,1706:1775))
     endif
  enddo

  deallocate (ss33, STAT = nDeAllocateStatus1)
  if (nDeAllocateStatus1.ne.0) print *, 'failed to release memory'

  if(sum(b1(255:256)).gt.0.0 .and. sum(b2(255:256)).gt.0.0 .and. sum(b3(255:256)).gt.0.0) then
     bend=max(sum(b1(275:276))/sum(b1(255:256)),sum(b2(275:276))/sum(b2(255:256)), &
          sum(b3(275:276))/sum(b3(255:256)))
  else
     bend=1.0
  endif

  do j=12,60
     bdelta1=b1(j-1)-b1(j)
     if(bdelta1.gt.bdeltamax(1)) then; bdeltamax(1)=bdelta1; jmax(1)=j; endif
     bdelta2=b2(j-1)-b2(j)
     if(bdelta2.gt.bdeltamax(2)) then; bdeltamax(2)=bdelta2; jmax(2)=j; endif
     bdelta3=b3(j-1)-b3(j)
     if(bdelta3.gt.bdeltamax(3)) then; bdeltamax(3)=bdelta3; jmax(3)=j; endif
  enddo

  if(jmax(1).gt.5) then
     b1p=b1(jmax(1)+3) + b1(jmax(1)+4) +  b1(jmax(1)+5); b1m=b1(jmax(1)-3) + b1(jmax(1)-4) +  b1(jmax(1)-5)
  else
     b1p=1.0; b1m=1.0
  endif
  if(jmax(2).gt.5) then
     b2p=b2(jmax(2)+3) + b2(jmax(2)+4) +  b2(jmax(2)+5); b2m=b2(jmax(2)-3) + b2(jmax(2)-4) +  b2(jmax(2)-5)
  else
     b2p=1.0; b2m=1.0
  endif
  if(jmax(3).gt.5) then
     b3p=b3(jmax(3)+3) + b3(jmax(3)+4) +  b3(jmax(3)+5); b3m=b3(jmax(3)-3) + b3(jmax(3)-4) +  b3(jmax(3)-5)
  else
     b3p=1.0; b3m=1.0
  endif

  if(b1p.ge.1.01) bband(1)=b1m/b1p
  if(b2p.ge.1.01) bband(2)=b2m/b2p
  if(b3p.ge.1.01) bband(3)=b3m/b3p

!do i=1,3
!print *,jmax(i),bband(i)
!enddo

  maxbandindex=maxloc(bband,dim=1)
  bstart=bband(maxbandindex)

  if(maxbandindex.eq.1) jslope=jmax(1); if(maxbandindex.eq.2) jslope=jmax(2); if(maxbandindex.eq.3) jslope=jmax(3)

!print *,jslope,bstart,bend
  facagc=2.0 
  nslope=2229*jslope
  nend=605708 ! = 26000+6000+12000+2229*252 where 6000 => 0.5sec DT
  if(nmode.eq.10 .or. nmode.eq.9) nend=605520 ! 6000+12000+6912*85
  if(nmode.eq.65+9 .and. ntxmode.eq.9) nend=624000
  if(bstart.gt.1.5) dd(1:nslope)=dd(1:nslope)/(bstart*facagc)
  if(bend.gt.1.5) dd(nend:)=dd(nend:)/(bend*facagc)
  return
end subroutine agcc

! last time modified by Igor UA3DJY on 20200215

subroutine chkfalse(decoded,mycall12,falsedec)
 
  character*22 decoded
  character*12 mycall12
  character*12 callsign1,callsign2,basecall
  logical(1) falsedec,lfound

  i2=index(decoded,' ')
  i3=index(decoded((i2+1):),' ')
  ieoc1=i2-1 ! end of 1st callsign
  iboc2=i2+1 ! beginning of 2nd callsign
  ieoc2=i2+i3-1 ! end of 2nd callsign
  falsedec=.true.; lfound=.false.

  if(decoded(1:3).eq.'CQ ' .or. decoded(1:3).eq.'DE ' .or. decoded(1:4).eq.'QRZ ') then
    if(i2.lt.3 .or. i3.lt.3) return ! check FT8 Hint CQ but directional messages
! CQ K1GT/QRP FN52  CQ EV1P/A  CQ EV1P/P  CQ EV1P/M  CQ EV1P/MM (standard messages)
    islash=index(decoded,'/')
    if(islash.ne.0) then
      if(decoded(islash+1:islash+4).eq.'QRP ' .or. decoded(islash+1:islash+2).eq.'A ' &
         .or. decoded(islash+1:islash+2).eq.'P ' &
         .or. decoded(islash+1:islash+2).eq.'M ' .or. decoded(islash+1:islash+3).eq.'MM ') then
        falsedec=.false.
        return
      endif
! CQ R8MB/1 (standard message)
      if(decoded(islash+1:islash+1).ge.'0' .and. decoded(islash+1:islash+1).le.'9' &
         .and. decoded(islash+2:islash+2).eq.' ') then
        falsedec=.false.
        return
      endif
! CQ YU/S56A (standard message)
      if(islash-iboc2.lt.4) then
        callsign2=decoded(islash+1:ieoc2)
!print *,"4","'"//callsign2//"'"
        call searchcalls(callsign2,"            ",lfound)
        if(lfound) then; falsedec=.false.; return; endif
      endif
    endif
! non compound callsigns
    callsign2=decoded(iboc2:ieoc2)
    if(callsign2(1:1).eq.'.') return ! CQ ...... JQ68
!print *,"5","'"//callsign2//"'"
    call searchcalls(callsign2,"            ",lfound)
    if(lfound) then; falsedec=.false.; return; endif
  else
! MM0VPY 73 (standard message)
    if(index(decoded,' 73 ').gt.4) then; falsedec=.false.; return; endif
! check 'call1 + call2 [+]' messages	
    if(i2.lt.4 .or. i3.lt.4) return
    islash=index(decoded,'/')
    if(islash.eq.0) then
      callsign1=decoded(1:ieoc1)
      callsign2=decoded(iboc2:ieoc2)
      if(callsign2(1:1).eq.'.' .or. callsign1(1:1).eq.'.') return !  PJ8WRZ ...... DA82  ...... VF8UWG KD91
! skip mycall for iaptype 2 FT8 messages
!print *,"1","'"//callsign2//"'"
      if(callsign1.ne.mycall12) then; call searchcalls(callsign1,callsign2,lfound)
      else; call searchcalls(callsign2,"            ",lfound)
      endif
      if(lfound) then; falsedec=.false.; return; endif
    else
! '5B/SQ2MGM G4CUS' 'SQ2MGM/1 G4CUS'
      if(islash.lt.ieoc1) then
        nfirsth=islash-1
        nsecondh=ieoc1-islash
        if(nfirsth.gt.nsecondh) then
          basecall=decoded(1:islash-1)
        else
          basecall=decoded(islash+1:ieoc1)
        endif
        callsign2=decoded(iboc2:ieoc2)
!print *,"2","'"//basecall//"'"
        call searchcalls(callsign2,basecall,lfound)
        if(lfound) then; falsedec=.false.; return; endif
      elseif (islash.gt.iboc2) then
! 'G4CUS 5B/SQ2MGM' 'G4CUS SQ2MGM/1'
        nfirsth=islash-i2-1
        nsecondh=ieoc2-islash
        if(nfirsth.gt.nsecondh) then
          basecall=decoded(i2+1:islash-1)
        else
          basecall=decoded(islash+1:ieoc2)
        endif
        callsign1=decoded(1:ieoc1)
! skip mycall for iaptype 2 FT8 messages
!print *,"3","'"//basecall//"'"
          if(callsign1.ne.mycall12) then; call searchcalls(callsign1,basecall,lfound)
          else; call searchcalls(basecall,"            ",lfound)
          endif
          if(lfound) then; falsedec=.false.; return; endif
      endif
    endif
  endif

  return
end subroutine chkfalse

subroutine entail(dgen,data0)

! Move 72-bit packed data from 6-bit to 8-bit symbols and add a zero tail.
  integer dgen(13)
  integer*1 data0(13)

  i4=0
  k=0
  m=0
  do i=1,12
     n=dgen(i)
     do j=1,6
        k=k+1
        i4=i4+i4+iand(1,ishft(n,j-6))
        i4=iand(i4,255)
        if(k.eq.8) then
           m=m+1
           if(i4.gt.127) i4=i4-256
           data0(m)=i4
           k=0
        endif
     enddo
  enddo
  do m=10,13
     data0(m)=0
  enddo

  return
end subroutine entail

! This source code file was last time modified by Igor UA3DJY on May 25th, 2017
! All changes are shown in the patch file coming together with the full JTDX source code.

program jt9sim

! Generate simulated data for testing of WSJT-X

  use wavhdr
  use packjt
  parameter (NTMAX=120)
  parameter (NMAX=NTMAX*12000)
  type(hdr) h
  integer*2 iwave(NMAX)                  !Generated waveform (no noise)
  real*4 dat(NMAX)
  real*8 f0,f,dt,twopi,phi,dphi,baud,fspan,fsample,freq
  character msg0*22,message*22,msgsent*22,arg*8,fname*11
!  character msg*22

  integer*4 i4tone(85)             !Channel symbols (values 0-8)
!  integer*4 i4DataSymNoGray(69)    !Data Symbols, values 0-7
!  integer*1 i1ScrambledBits(207)   !Unpacked bits, scrambled order
!  integer*1 i1Bits(207)            !Encoded information-carrying bits
!  integer*1 i1SoftSymbols(207)
  include 'jt9sync.f90'

  nargs=iargc()
  if(nargs.ne.6) then
     print*,'Usage:   jt9sim "message"     fspan nsigs minutes SNR nfiles'
     print*,'Example: jt9sim "CQ K1ABC FN42" 200  20      2    -28    1'
     print*,' '
     print*,'Enter message = "" to use entries in msgs.txt.'
     print*,'Enter SNR = 0 to generate a range of SNRs.'
     print*,'Enter SNR = 99 to generate a noiseless signal at frequency fspan'
     go to 999
  endif

  call getarg(1,msg0)  
  call fmtmsg(msg0,iz)
  message=msg0                       !Transmitted message
  call getarg(2,arg)
  read(arg,*) fspan                  !Total freq range (Hz)
  call getarg(3,arg)
  read(arg,*) nsigs                  !Number of signals in each file
  call getarg(4,arg)
  read(arg,*) minutes                !Length of file (1 2 5 10 30 minutes)
  call getarg(5,arg)
  read(arg,*) snrdb                  !S/N in dB (2500 hz reference BW)
  call getarg(6,arg)
  read(arg,*) nfiles                 !Number of files     

  rmsdb=25.
  rms=10.0**(0.05*rmsdb)
  fsample=12000.d0                   !Sample rate (Hz)
  dt=1.d0/fsample                    !Sample interval (s)
  twopi=8.d0*atan(1.d0)
  npts=12000*(60*minutes-6)
  nsps=0
  if(minutes.eq.1)  nsps=6912
  if(minutes.eq.2)  nsps=15360
  if(minutes.eq.5)  nsps=40960
  if(minutes.eq.10) nsps=82944
  if(minutes.eq.30) nsps=252000
  if(nsps.eq.0) stop 'Bad value for minutes.'

!  f0=1400.d0                         !Center frequency (Hz)
   f0=2750.d0                         !Center frequency (Hz) 
!  f0=3000.d0                         !Center frequency (Hz)

!  f0=1500.0
!  if(minutes.eq.5)  f0=1100.
!  if(minutes.eq.10) f0=1050.
!  if(minutes.eq.30) f0=1025.


  call init_random_seed()       ! seed Fortran RANDOM_NUMBER generator
  call sgran()                  ! see C rand generator (used in gran)

  h=default_header(12000,npts)  
  k=0                                !Silence compiler warning

  if(msg0(1:3).eq.'sin') read(msg0(4:),*) sinfreq
  
  if(message.eq."") open(12,file='msgs.txt',status='old')

  write(*,1000)
1000 format('File  N    freq      S/N  Message'/    &
            '---------------------------------------------------')

  do ifile=1,nfiles                            !Loop over all files
     nmin=(ifile-1)*minutes
     ihr=nmin/60
     imin=mod(nmin,60)
     write(fname,1002) ifile         !Output filename
1002 format('000000_',i4.4)
     open(10,file=fname//'.wav',access='stream',status='unknown')

     if(snrdb.lt.90) then
        do i=1,npts
           dat(i)=gran()
        enddo
     else
        dat(1:npts)=0.
     endif

     if(msg0.ne.'                      ') then
        call gen9(message,0,msgsent,i4tone,itype) !Encode message into tone #s
     endif

     rewind 12
     do isig=1,nsigs                            !Loop over multiple signals

        if(msg0.eq.'                      ') then
           read(12,1004) message                !Use pre-generated message texts
1004       format(a22)
           call gen9(message,0,msgsent,i4tone,itype)
        endif

        f=f0
        if(nsigs.gt.1) f=f0 - 0.5d0*fspan + fspan*(isig-1.d0)/(nsigs-1.d0)
        snrdbx=snrdb 
!        snrdbx=snrdb + (ifile-1)*4.0
        sig=10.0**(0.05*snrdbx)
        if(snrdb.gt.90.0) sig=1.0
        write(*,1020) ifile,isig,f,snrdbx,msgsent
1020    format(i3,i4,f10.3,f7.1,2x,a22)

        phi=0.
        baud=12000.d0/nsps
        k=12000                             !Start audio at t = 1.0 s
!        f1=0.0001 * (ifile-1)
        f1=0.
!        print*,ifile-1,f1
        dphi2=0.
        ddphi2=twopi*f1*dt/60.0
        do isym=1,85
           freq=f + i4tone(isym)*baud
           if(msg0(1:3).eq.'sin') freq=sinfreq
           dphi=twopi*freq*dt + dphi2
           do i=1,nsps
              phi=phi + dphi
              dphi2=dphi2 + ddphi2
              if(phi.lt.-twopi) phi=phi+twopi
              if(phi.gt.twopi) phi=phi-twopi
              xphi=phi
              k=k+1
              dat(k)=dat(k) + sig*sin(xphi)  !Use lookup table for i*2 sin(x) ?
           enddo
        enddo
     enddo

     fac=32767.0/nsigs
     if(snrdb.ge.90.0) iwave(1:npts)=nint(fac*dat(1:npts))
     if(snrdb.lt.90.0) iwave(1:npts)=nint(rms*dat(1:npts))

     write(10) h,iwave(1:npts)
     close(10)

! We're done!  Now decode the data symbols from i4tone, as a test.
!     if(msg0.ne.'                      ') then
!        j=0
!        do i=1,85
!           if(isync(i).eq.1) cycle
!           j=j+1
!           i4DataSymNoGray(j)=igray(i4tone(i)-1,-1)
!        enddo
!        call unpackbits(i4DataSymNoGray,69,3,i1ScrambledBits)
!        call interleave9(i1ScrambledBits,-1,i1Bits)
! 
!        do i=1,206
!           i4=-10
!           if(i1Bits(i).eq.1) i4=10
!           i1SoftSymbols(i)=i4
!        enddo
!        limit=1000
!        call jt9fano(i1SoftSymbols,limit,nlim,msg)
!        if(msg.ne.msg0) print*,'Decode error: ',msg0,' ',msg
!     endif
  enddo

999 end program jt9sim

subroutine chkmsg(message,cok,nspecial,flip)

  character message*22,cok*3

  nspecial=0
  flip=1.0
  cok="   "

  do i=22,1,-1
     if(message(i:i).ne.' ') go to 10
  enddo
  i=22

10 if(i.ge.11) then
     if((message(i-3:i).eq.' OOO') .or. (message(20:22).eq.' OO')) then
        cok='OOO'
        flip=-1.0
        if(message(20:22).eq.' OO') then
           message=message(1:19)
        else
           message=message(1:i-4)
        endif
     endif
  endif

  if(message(1:3).eq.'RO ')  nspecial=2
  if(message(1:4).eq.'RRR ') nspecial=3
  if(message(1:3).eq.'73 ')  nspecial=4

  return
end subroutine chkmsg

subroutine msgparser(msg37,msg37_2)

  character msg37*37,msg37_2*37,call1*12,call2*12,call3*12,report*6

! ES1JA RR73; TA1BM <...> -22 
! ES1JA RR73; TA1BM <SX60RAAG> -22

  call1='            '; call2='            '; call3='            '; report='      '
  ispc1=index(msg37,' '); ispc2=index(msg37((ispc1+1):),' ')+ispc1
  ispc3=index(msg37((ispc2+1):),' ')+ispc2; ispc4=index(msg37((ispc3+1):),' ')+ispc3
  ispc5=index(msg37((ispc4+1):),' ')+ispc4
  if(ispc5.gt.20) then
    call1=msg37(1:ispc1-1); call2=msg37(ispc2+1:ispc3-1)
    if(msg37(ispc3+1:ispc3+2).eq.'<.') then
      call3='<...>'
    else
      call3=msg37(ispc3+1:ispc4-1)
      if(call3(1:1).eq.'<') call3=call3(2:12)//' '
      ib=index(call3,'>'); if(ib.gt.3) call3(ib:ib)=' '
    endif
    if(len_trim(call3).lt.11) then; report=msg37(ispc4+1:ispc5-1); else; report=msg37(ispc4+1:37); endif
    msg37='                                     '
! build standard messages
    msg37=trim(call1)//' '//trim(call3)//' RR73'
    msg37_2=trim(call2)//' '//trim(call3)//' '//trim(report)
  endif

  return
end subroutine 

! This source code file was last time modified by Igor Chernikov UA3DJY on May 25th, 2016.
! All changes are shown in the patch file coming together with the full JTDX source code.

subroutine fqso_first(nfqso,nfhinted,ca,ncand)

! If a candidate was found within +/- nfhinted of nfqso, move it into ca(1).

  type candidate
     real freq
     real dt
     real sync
  end type candidate
  type(candidate) ca(300),cb

  dmin=1.e30
  i0=0
  do i=1,ncand
     d=abs(ca(i)%freq-nfqso)
     if(d.lt.dmin) then
        i0=i
        dmin=d
     endif
  enddo

  if(dmin.lt.float(nfhinted)) then
     cb=ca(i0)
     do i=i0,2,-1
        ca(i)=ca(i-1)
     enddo
     ca(1)=cb
  endif

  return
end subroutine fqso_first

! This source code file was last time modified by Igor UA3DJY on August 21st, 2017
! All changes are shown in the patch file coming together with the full JTDX source code.

subroutine decode65a(newfft,f0,ntrials,naggressive,hint_on,mycall,hiscall, &
   hisgrid,sync2,a,dt,nft,decoded,ncand_lt9,hintedrxfreq,nfqso,hint,npass1,  &
   sync1_lt1,ncandcount,nstophint,freemsg,nlasttx,ipass,nsdecatt,isfalse, &
   bypass_ftrsd,ncand,jt65bc,nharmonicsdepth,showharmonics)

! Apply AFC corrections to a candidate JT65 signal, then decode it.

  use timer_module, only: timer
  use jt65_mod11 !ca and dtchk data structures

  parameter (NMAX=60*12000)          !Samples per 60 s
  complex cx(NMAX/8)                 !Data at 1378.125 samples/s
  complex c5x(NMAX/64)               !Data at 172.154 Hz
  complex c5a(512)
  complex w,wstep!,cpwrfactor
  real s2(66,126),s2b(66,126),s2c(66,126),a(2)
  data twopi/6.283185307/
!  save

  character decoded*22,mycall*12,hiscall*12,hisgrid*6,hint*1,isfalse*1
  real dtlow,dthigh
  integer nft,nsym
  logical(1) freemsg,hintedrxfreq,hintedw,newfft,chkdecode,hint_on,bypass_hintcq,bypass_hintall, &
             bypass_ftrsd,criterion10,criterion15,criterion20,npass1,ncand_lt9, &
             sync1_lt1,offset1,nstophint,hinteddyn,hintedrxfdt,jt65bc(2),showharmonics
  
  chkdecode=.false.; bypass_hintcq=.false.; bypass_hintall=.false.; offset1=.false.; dtlow=-0.5

  dthigh=float(naggressive) ! DT range in advanced settings tab
  if(naggressive.le.3) dtlow=-0.5*naggressive
  if(naggressive.eq.4) dtlow=-2.5
  if(naggressive.eq.5) dtlow=-3.5 
  
! Mix sync tone to baseband, low-pass filter, 
! downsample to 1378.125 Hz
! apply 2nd low-pass antialiasing filter
! downsample to 172.265625 Hz
!  call timer('filbig  ',0)
  call filbig(f0,newfft,cx,n5,sq0,c5x,n6)
!  call timer('filbig  ',1)

! cx has sample rate 12000*77125/672000 = 1378.125 Hz
! c5x has sample rate  1378.125/8 = 172.265625 Hz
! Find best DF, drift, curvature, and DT.

  fsample=1378.125/8

!  call timer('afc65b  ',0)
! Best fit for DF, drift, banana-coefficient, and dt. fsample = 172.154 S/s
  call afc65b(c5x,n6,fsample,a,ccfbest,dtbest)

!  call timer('afc65b  ',1)
!if(lstart) ccfbest=ccfbest*0.11*bstartdec*(2.0+bstartdec/22.0)/agcfacdec
  do ibig=1,2 ! deviation of the start sample
    if(ibig.eq.1) then
       offset1=.true.
       dtbest=dtbest-0.000251 ! remove decimation filter and coh. integrator delay
    else
    if(ipass.ge.4 .and. ipass.le.6 .and. nsdecatt.gt.1) go to 2
  !apply 2nd pass of ibig cycle for QSO freq only if npass.gt.1 and for crowded band
       if((.not.hintedrxfreq .and. .not.npass1) .or. ncand_lt9) then
          nft=0
          decoded='                      '
          exit
       endif
2      bypass_hintall=.true.
       offset1=.false.
    endif

!  if(.not.hinted .and. npass.eq.3) dtbest=dtbest+0.000251+0.0004

  dt=dtbest !return new, improved estimate of dt
! if (dt.lt.-0.74) return !limiting DT bottom edge to -3.9sec, eliminating some good decodes too
  sync2=1.5e-4*ccfbest/sq0                    !Constant is empirical
! avoiding some false hinted decodes caused by AF path overload
  if(sync2.gt.0.3) bypass_hintall=.true. ! -05dB SNR threshold
! now limiting QSO frequency hinted decoding to dtlow...dthigh DT range, advanced tab settings
  hintedrxfdt=.true.
  if((dt-1.0-2.6/1.2).lt.dtlow .or. (dt-1.0-2.6/1.2).gt.dthigh) hintedrxfdt=.false.  !26k samples shift +1sec
  if((nint(f0+a(1)).gt.nfqso+3) .or. (nint(f0+a(1)).lt.nfqso-3)) hintedrxfreq=.false.
! now limiting wideband CQ/CQ DX hinted decoding to -0.5...1.0 DT range
  hintedw=.true.
  hinteddyn=.true.
  if((dt-1.0-2.6/1.2).lt.-0.5 .or. (dt-1.0-2.6/1.2).gt.1.0) hintedw=.false.
  if((dt-1.0-2.6/1.2).lt.-1.0 .or. (dt-1.0-2.6/1.2).gt.2.5) hinteddyn=.false. 

if(.not.npass1) then
  criterion10=.false.;criterion15=.false.;criterion20=.false.
  if(ccfbest.lt.10000.0 .and. dtbest.lt.1.0) criterion10=.true.
  if(ccfbest.lt.2000.0 .and. dtbest.lt.1.5) criterion15=.true.
  if(ccfbest.lt.500.0 .and. dtbest.lt.2.0) criterion20=.true.
  
    if(.not.hintedrxfreq .and. .not.hintedrxfdt) then ! if (out of QSO frequency and out of DT*ccfbest range)
      if(criterion10 .or. criterion15 .or. criterion20) then
! reducing number of candidates for decoding at npass 2...4, hence reducing decoding time
        nft=0
        decoded='                      '
        return
      endif
    endif
! now eliminating some false FTRSD decodes
  if(hintedrxfreq .and. hintedrxfdt) then ! if on QSO frequency and (sync less than 1.0 or out of DT*ccfbest range)
    if(sync1_lt1 .or. criterion10 .or. criterion15 .or. criterion20)  bypass_ftrsd=.true.
  endif
endif

if(npass1 .and. sync1_lt1)  bypass_ftrsd=.true.
!now checking if candidate's SYNC is harmonic of the some deocded signal
!this candidate, if decoded, will be checked through the CALL3.txt data 
  ncandcount=ncandcount+1
  nctemp=ncandcount
  if(ncandcount.gt.MAXINTCAND) then
     print *, 'input audio signal is distorted'
     return
  endif
  if(ncandcount.gt.2) then
    do i=1,nctemp-1
    if(dtchk(i)%cand_decoded) then
      if(abs(dtbest-dtchk(i)%cand_dtbest).lt.0.005) then 
        ncandcount=ncandcount-1 
        chkdecode=.true.
      endif
    endif
    enddo
  endif
!now removing some false hinted decodes caused by harmonics of the SYNC signal
  if(chkdecode .and. f0.gt.1500.0 .and. ccfbest.gt.10000.0) bypass_hintcq=.true.

 if((bypass_ftrsd .and. hint_on .and. bypass_hintall) .or. (bypass_ftrsd .and. .not.hint_on)) then
! there is nothing to decode
    nft=0
    decoded='                      '
    return
 endif
  
! Apply AFC corrections to the time-domain signal
! Now we are back to using the 1378.125 Hz sample rate, enough to 
! accommodate the full JT65C bandwidth.
! Apply AFC corrections to the cx data

  w=1.0
  wstep=1.0
  x0=0.5*n5
  do i=1,n5
     if(mod(i,100).eq.1) then
        x=(float(i)-x0)/float(n5)
        dphi=(a(1) + x*a(2)) * (twopi/1378.125)
        wstep=cmplx(cos(dphi),sin(dphi))
     endif
     w=w*wstep
     cx(i)=w*cx(i)
  enddo

! Compute spectrum for each symbol.
  nsym=126
  nfft=512
  fltj=dtbest*1378.125
  j=nint(fltj)
  if(ibig.eq.2) then ! try other side
     deltaj=fltj-dtbest*1378.125
     if(deltaj.gt.0.0) then
        j=j-1
     else
        j=j+1
     endif
  endif

  c5a=cmplx(0.0,0.0)
!  call timer('sh_ffts ',0)
  do k=1,nsym
     do i=1,nfft
        j=j+1
        if(j.ge.1 .and. j.le.NMAX/8) then
           c5a(i)=cx(j)
        else
           c5a(i)=0.
        endif
     enddo
     call four2a(c5a,nfft,1,1,1)
     ijtb=1; ijtc=1
     do i=1,66
        if(ncand.ge.17 .or. sync2.ge.0.01) s2(i,k)=SQRT(real(c5a(i))**2 + aimag(c5a(i))**2)
        if(ncand.lt.17 .and. sync2.lt.0.01) s2(i,k)=real(c5a(i))**2 + aimag(c5a(i))**2
        s2b(i,k)=SQRT(real(c5a(ijtb))**2 + aimag(c5a(ijtb))**2)
        s2c(i,k)=SQRT(real(c5a(ijtc))**2 + aimag(c5a(ijtc))**2)
        ijtb=ijtb+2; ijtc=ijtc+3
     enddo
 enddo

!  call timer('sh_ffts ',1)
!  call timer('dec65b  ',0)
  call decode65b(s2,s2b,s2c,ntrials,hint_on,mycall,hiscall,hisgrid,nft,decoded, &
                 hintedrxfreq,hint,npass1,hintedw,bypass_hintcq,bypass_hintall, &
                 bypass_ftrsd,offset1,nstophint,freemsg,hinteddyn,dt,hintedrxfdt,nlasttx, &
                 ipass,sync2,isfalse,jt65bc,nharmonicsdepth,showharmonics)
!  call timer('dec65b  ',1)

  if(decoded.ne.'                      ') then
!  print *,a(1),a(2)
!if(abs(a(1)).gt.1.0) print *,'a1',a(1)
!if(abs(a(2)).gt.1.0) print *,'a2',a(2)
    if(chkdecode) ncandcount=ncandcount+1
    dtchk(ncandcount)%cand_dtbest=dtbest
    dtchk(ncandcount)%cand_decoded=.true.
    exit !exit from ibig if message is decoded on the first cycle
  endif
  enddo
  return
end subroutine decode65a

! This source code file is created by Igor Chernikov UA3DJY on July 31st, 2016 and 
! last time mofified on July 31st, 2016.
! All changes are shown in the patch file coming together with the full JTDX source code.

module jt65_mod7
  real s3a(64,63)
  save
end module jt65_mod7

subroutine symspec(shared_data,k,ntrperiod,nsps,pxdb,s,df3,ihsym,npts8)

! Input:
!  k         pointer to the most recent new data
!  ntrperiod T/R sequence length, minutes
!  nsps      samples per symbol, at 12000 Hz
!  ndiskdat  0/1 to indicate if data from disk
!  nb        0/1 status of noise blanker (off/on)
!  nbslider  NB setting, 0-100

! Output:
!  pxdb      power (0-60 dB)
!  s()       current spectrum for waterfall display
!  ihsym     index number of this half-symbol (1-184) for 60 s modes

! jt9com
!  ss()      JT9 symbol spectra at half-symbol steps
!  savg()    average spectra for waterfall display

  use, intrinsic :: iso_c_binding, only: c_int, c_short, c_float, c_char
  !$ use omp_lib
  include 'jt9com.f90'

  type(dec_data) :: shared_data
  real*4 w3(MAXFFT3)
  real*4 s(NSMAX)
  real*4 ssum(NSMAX)
  real*4 xc(0:MAXFFT3-1)
  real*4 speak
  complex cx(0:MAXFFT3/2)

  data k0/99999999/,nfft3z/0/
  equivalence (xc,cx)
  save

  if(ntrperiod.eq.-999) stop                   !Silence compiler warning
!$omp single
  nfft3=16384                                  !df=12000.0/16384 = 0.732422
  jstep=nsps/2                                 !Step size = half-symbol in id2()
  if(k.gt.NMAX) go to 900
  if(k.lt.2048) then                !(2048 was nfft3)  (Any need for this ???)
     ihsym=0
     go to 900                                 !Wait for enough samples to start
  endif

  if(nfft3.ne.nfft3z) then
! Compute new window
     width=0.25*nsps
     do i=1,nfft3
        z=(i-nfft3/2)/width
        w3(i)=exp(-z*z)
     enddo
     nfft3z=nfft3
  endif

  if(k.lt.k0) then                             !Start a new data block
     ja=0
     ssum=0.
     ihsym=0
!     if(.not. shared_data%params%ndiskdat) shared_data%id2(k+1:)=0   !Needed to prevent "ghosts". Not sure why.
  endif
  gain=0.0063 !-22dB   =10**(0.1*(-22))

  speak=0.
  do i=k0+1,k
     kid2=shared_data%id2(i)
     if(abs(float(kid2)).gt.speak) speak=abs(float(kid2))
  enddo
  pxdb=0.
  if(speak.gt.0.0) pxdb=20.0*log10(speak)
  if(pxdb.gt.90.0) pxdb=90.0

  k0=k
  ja=ja+jstep                         !Index of first sample

  fac0=0.1
  do i=0,nfft3-1                      !Copy data into cx
     j=ja+i-(nfft3-1)
     xc(i)=0.
     if(j.ge.1 .and.j.le.NMAX) then
        nid2=shared_data%id2(j)
        xc(i)=fac0*nid2
     endif
  enddo
  ihsym=ihsym+1

  xc(0:nfft3-1)=w3(1:nfft3)*xc(0:nfft3-1)    !Apply window w3
  call four2a(cx,nfft3,1,-1,0)               !Real-to-complex FFT

  df3=12000.0/nfft3                   !JT9-1: 0.732 Hz = 0.42 * tone spacing
  iz=min(NSMAX,nint(5000.0/df3))
  fac1=1.0/nfft3
  fac2=1000.0*gain
  do i=1,iz
     j=i-1
     if(j.lt.0) j=j+nfft3
     sx=fac1*(abs(real(cx(j))) + abs(aimag(cx(j))))
     if(ihsym.le.184) shared_data%ss(ihsym,i)=sx
     ssum(i)=ssum(i) + sx
     s(i)=fac2*sx
  enddo

  shared_data%savg=ssum/ihsym

900 npts8=k/8
!$omp end single

  return
end subroutine symspec

subroutine ft8b(newdat1,nQSOProgress,nfqso,nftx,napwid,lsubtract,npos,freqsub,tmpcqdec,tmpmyc,          &
                nagainfil,iaptype,f1,xdt,nbadcrc,lft8sdec,msg37,msg37_2,xsnr,swl,stophint,              &
                nthr,lFreeText,ipass,lft8subpass,lspecial,lcqcand,ncqsignal,nmycsignal,npass,           &
                i3bit,lhidehash,lft8s,lmycallstd,lhiscallstd,levenint,loddint,lft8sd,i3,n3,nft8rxfsens, &
                ncount,msgsrcvd,lrepliedother,lhashmsg,lqsothread,lft8lowth,lhighsens,lsubtracted,      &
                tmpcqsig,tmpmycsig,tmpqsosig,lnohiscall,lnomycall,lnohisgrid)
!  use timer_module, only: timer
  use packjt77, only : unpack77
  use ft8_mod1, only : allmessages,ndecodes,apsym,mcq,m73,mrr73,mrrr,icos7,naptypes,nhaptypes,one,graymap,                     &
                       oddcopy,evencopy,lastrxmsg,lasthcall,nlasttx,calldteven,calldtodd,lqsomsgdcd,mycalllen1,                &
                       msgroot,msgrootlen,allfreq,idtone25,lapmyc,idtonemyc,mycall,hiscall,lhound,apsymsp,                     &
                       ndxnsaptypes,apsymdxns1,apsymdxnsrrr,lenabledxcsearch,lwidedxcsearch,apcqsym,apsymdxnsrr73,apsymdxns73, &
                       mybcall,hisbcall,lskiptx1,nft8cycles,nft8swlcycles,ctwkw,ctwkn,nincallthr,msgincall,xdtincall,          &
                       maskincallthr,ctwk256,numcqsig,numdeccq,evencq,oddcq,nummycsig,numdecmyc,evenmyc,oddmyc,idtone56,       &
                       idtonecqdxcns,evenqso,oddqso,nmycnsaptypes,apsymmyns1,apsymmyns2,apsymmynsrr73,apsymmyns73,apsymdxstd,  &
                       apsymdxnsr73,apsymdxns732,ltxing,apsymmynsrrr,idtonedxcns73,idtonefox73,idtonespec

  include 'ft8_params.f90'
  character c77*77,msg37*37,msg37_2*37,msgd*37,msgbase37*37,call_a*12,call_b*12,callsign*12,grid*12
  character*37 msgsrcvd(130)
  complex cd0(-800:4000),cd1(-800:4000),cd2(-800:4000),cd3(-800:4000),ctwk(32),csymb(32),cs(0:7,79),csymbr(32),csr(0:7,79), &
          csig(32),csig0(151680),z1,csymb256(256),cstmp2(0:7,79),csold(0:7,79),cscs(0:7,79)
  real a(5),s8(0:7,79),s82(0:7,79),s2(0:511),sp(0:7),s81(0:7),snrsync(21),syncw(7),sumkw(7),scoreratiow(7),freqsub(200), &
       s256(0:8),s2563(0:26),syncavpart(3)
  real bmeta(174),bmetb(174),bmetc(174),bmetd(174)
  real llra(174),llrb(174),llrc(174),llrd(174),llrz(174)
  integer*1 message77(77),apmask(174),cw(174),nsmax(8)
  integer itone(79),ip(1),ka(1),nqsoend(3)
  integer, intent(in) :: nQSOProgress,nfqso,nftx,napwid,nthr,ipass,nft8rxfsens
  logical newdat1,lsubtract,lFreeText,nagainfil,lspecial,unpk77_success
  logical(1), intent(in) :: swl,stophint,lft8subpass,lhidehash,lmycallstd,lhiscallstd,lqsothread,lft8lowth, &
                            lhighsens,lcqcand,levenint,loddint,lnohiscall,lnomycall,lnohisgrid
  logical(1) falsedec,lastsync,ldupemsg,lft8s,lft8sdec,lft8sd,lsdone,ldupeft8sd,lrepliedother,lhashmsg,                &
             lvirtual2,lvirtual3,lsd,lcq,ldeepsync,lcallsstd,lfound,lsubptxfreq,lreverse,lchkcall,lgvalid,             &
             lwrongcall,lsubtracted,lcqsignal,loutapwid,lfoundcq,lmycsignal,lfoundmyc,lqsosig,ldxcsig,lcqdxcsig,       &
             lcqdxcnssig,lqsocandave,lcall1hash,lqsosigtype3,lqso73,lqsorr73,lqsorrr,lfoxspecrpt,lfoxstdr73,lapcqonly, &
             lcall2hash,lskipnotap

  type tmpcqdec_struct
    real freq
    real xdt
  end type tmpcqdec_struct
  type(tmpcqdec_struct) tmpcqdec(numdeccq)

  type tmpcqsig_struct
    real freq
    real xdt
    complex cs(0:7,79)
  end type tmpcqsig_struct
  type(tmpcqsig_struct) tmpcqsig(numcqsig) ! 20 sigs 24 threads

  type tmpmyc_struct
    real freq
    real xdt
  end type tmpmyc_struct
  type(tmpmyc_struct) tmpmyc(numdecmyc)

  type tmpmycsig_struct
    real freq
    real xdt
    complex cs(0:7,79)
  end type tmpmycsig_struct
  type(tmpmycsig_struct) tmpmycsig(nummycsig) ! 5 sigs

  type tmpqsosig_struct
    real freq
    real xdt
    complex cs(0:7,79)
  end type tmpqsosig_struct
  type(tmpqsosig_struct) tmpqsosig(1)

  max_iterations=30; nharderrors=-1; nbadcrc=1; delfbest=0.; ibest=0; dfqso=500.; rrxdt=0.5
  fs2=200.; dt2=0.005 ! fs2=12000.0/NDOWN; dt2=1.0/fs2
  lcall1hash=.false.; lcall2hash=.false.; lskipnotap=.false.
  ldeepsync=.false.; if(lft8lowth .or. lft8subpass .or. swl) ldeepsync=.true.
  lcallsstd=.true.; if(.not.lmycallstd .or. .not.lhiscallstd) lcallsstd=.false.

  xdt0=xdt; f10=f1
! apply last freq f1 and last DT criteria here  
  nqso=1
  if(lqsothread .and. .not. lft8sdec .and. .not.lqsomsgdcd .and. .not.stophint .and. nlasttx.ge.1 &
    .and. nlasttx.le.4 .and. abs(f10-nfqso).lt.2.51) then
    if(lastrxmsg(1)%lstate .and. abs(lastrxmsg(1)%xdt-xdt).lt.0.18) then; nqso=2
      elseif(.not.lastrxmsg(1)%lstate) then; nqso=2
    endif
  endif

  lvirtual2=.false.; lvirtual3=.false.; maxlasttx=4
  if(lqsothread .and. .not. lft8sdec .and. .not.lqsomsgdcd) then
    if(len_trim(hiscall).gt.2) then
      if(xdt.gt.4.9 .or. xdt.lt.-4.9) then
        if(lastrxmsg(1)%lstate .and. trim(lastrxmsg(1)%lastmsg).eq.trim(msgroot)//' RRR') maxlasttx=5
      endif
      if(xdt.gt.4.9) then
        if(.not.stophint .and. nlasttx.ge.1 .and. nlasttx.le.maxlasttx .and. abs(f10-nfqso).lt.0.1) then
          if(lastrxmsg(1)%lstate) then; xdt0=lastrxmsg(1)%xdt; nqso=2; lvirtual2=.true.; endif
          if(.not.lastrxmsg(1)%lstate) then
            if(levenint) then
              do i=1,150
                if(trim(calldteven(i)%call2).eq.trim(hiscall)) then
                  xdt0=calldteven(i)%dt; nqso=3; lvirtual2=.true.; exit
                endif
              enddo
            else if(loddint) then 
              do i=1,150
                if(trim(calldtodd(i)%call2).eq.trim(hiscall)) then
                  xdt0=calldtodd(i)%dt; nqso=3; lvirtual2=.true.; exit
                endif
              enddo
            endif
          endif
        endif
      elseif (xdt.lt.-4.9) then
        if(.not.stophint .and. nlasttx.ge.1 .and. nlasttx.le.maxlasttx .and. abs(f10-nfqso).lt.0.1) then
          if(lastrxmsg(1)%lstate) then; xdt0=lastrxmsg(1)%xdt; nqso=3; lvirtual3=.true.; endif
          if(.not.lastrxmsg(1)%lstate) then
            if(levenint) then
              do i=1,150
                if(trim(calldteven(i)%call2).eq.trim(hiscall)) then
                  xdt0=calldteven(i)%dt; nqso=3; lvirtual3=.true.; exit
                endif
              enddo
            else if(loddint) then
              do i=1,150
                if(trim(calldtodd(i)%call2).eq.trim(hiscall)) then
                  xdt0=calldtodd(i)%dt; nqso=3; lvirtual3=.true.; exit
                endif
              enddo
            endif
          endif
        endif
      endif
    endif
  endif

  !call timer('ft8_down',0)
  call ft8_downsample(newdat1,f1,nqso,cd0,cd2,cd3,lhighsens,lsubtracted,npos,freqsub)   !Mix f1 to baseband and downsample
  !call timer('ft8_down',1)

  lsd=.false.; isd=1; lcq=.false.
  if(levenint) then
    do i=1,130
      if(.not.evencopy(i)%lstate) cycle
      if(abs(evencopy(i)%freq-f1).lt.3.0 .and. abs(evencopy(i)%dt-xdt).lt.0.19) then
        msgd=evencopy(i)%msg; lsd=.true.; isd=i
        if(msgd(1:3).eq.'CQ ' .or. msgd(1:3).eq.'DE ' .or. msgd(1:4).eq.'QRZ ') lcq=.true.
      endif
    enddo
  elseif(loddint) then
    do i=1,130
      if(.not.oddcopy(i)%lstate) cycle
      if(abs(oddcopy(i)%freq-f1).lt.3.0 .and. abs(oddcopy(i)%dt-xdt).lt.0.19) then
        msgd=oddcopy(i)%msg; lsd=.true.; isd=i
        if(msgd(1:3).eq.'CQ ' .or. msgd(1:3).eq.'DE ' .or. msgd(1:4).eq.'QRZ ') lcq=.true.
      endif
    enddo
  endif

  if(lsd .and. nqso.eq.1) nqso=4

!nlasttx  last TX message
!  0       Tx was halted
!  1      AA1AA BB1BB PL35
!  2      AA1AA BB1BB -15
!  3      AA1AA BB1BB R-15
!  4      AA1AA BB1BB RRR/RR73
!  5      AA1AA BB1BB 73
!  6      CQ BB1BB PL35

  if(nqso.eq.4) cd1=cd0
  do iqso=1,nqso
    lapcqonly=.false.
    if(iqso.gt.1 .and. iqso.lt.4 .and. nqso.eq.4) cycle
    if(xdt0.lt.-4.9 .or. xdt0.gt.4.9) cycle
    if(lvirtual2 .and. iqso.ne.2) cycle; if(lvirtual3 .and. iqso.lt.2) cycle
    if((lvirtual2 .or. lvirtual3) .and. nft8rxfsens.lt.3 .and. iqso.eq.3) cycle
    lastsync=.false.; lsdone=.false.
    if(.not.lvirtual2 .and. .not.lvirtual3 .and. iqso.eq.2) then; cd0=cd2
    elseif(lvirtual2 .and. iqso.eq.2) then; cd0=cd2
    elseif(lvirtual3 .and. iqso.eq.2) then; cd0=cd3
    endif
    if(iqso.eq.4) then; call tonesd(msgd,lcq); if(.not.ldeepsync) go to 32; cd0=cd1; endif
    if(iqso.eq.3) go to 16
    i0=nint((xdt0+0.5)*fs2)                   !Initial guess for start of signal
    smax=0.0; ctwk=cmplx(1.0,0.0)
    do idt=i0-8,i0+8                         !Search over +/- one quarter symbol
       call sync8d(cd0,idt,ctwk,0,sync,ipass,lastsync,iqso,lcq,lcallsstd,lcqcand)
       if(sync.gt.smax) then
          smax=sync
          ibest=idt
       endif
    enddo
    xdt2=ibest*dt2                           !Improved estimate for DT

! Now peak up in frequency
    i0=nint(xdt2*fs2)
    smax=0.0; kstep=1
    do ifr=-5,5
      if(iqso.eq.1 .or. iqso.eq.4) then; ctwk=ctwkw(kstep,:); delf=ifr*0.5 ! Search over +/- 2.5 Hz
      else; ctwk=ctwkn(kstep,:); delf=ifr*0.25 ! Search over +/- 1.25 Hz
      endif
      call sync8d(cd0,i0,ctwk,1,sync,ipass,lastsync,iqso,lcq,lcallsstd,lcqcand)
      if(sync.gt.smax) then; smax=sync; delfbest=delf; endif
      kstep=kstep+1
    enddo
    a=0.0
    a(1)=-delfbest
    call twkfreq1(cd0,-800,3199,4000,fs2,a,cd0)
    xdt=xdt2
    f1=f10+delfbest                           !Improved estimate of DF
    dfqso=abs(nfqso-f1)
!write (*,"(F5.2,1x,I1,1x,F6.1,1x,a3)") xdt,ipass,f1,'out'
    lastsync=.true.
    call sync8d(cd0,i0,ctwk,2,sync,ipass,lastsync,iqso,lcq,lcallsstd,lcqcand)

16  continue
    if(iqso.eq.3) ibest=ibest+1

    syncav=3.; syncavpart=3.
    snrsync=0.
    do k=1,79
      i1=ibest+(k-1)*32
      csymb=cd0(i1:i1+31)
      if((k.ge.1 .and. k.le.7) .or. (k.ge.37 .and. k.le.43) .or. (k.ge.73 .and. k.le.79)) then
        call four2a(csymb,32,1,-1,1)
        s81(0:7)=abs(csymb(1:8))
        if(k.ge.1 .and. k.le.7) then
          synclev=s81(icos7(k-1)); snoiselev=(sum(s81)-synclev)/7.0
          if(snoiselev.gt.1.E-16) snrsync(k)=synclev/snoiselev
        else if(k.ge.37 .and. k.le.43) then
          synclev=s81(icos7(k-37)); snoiselev=(sum(s81)-synclev)/7.0
          if(snoiselev.gt.1.E-16) snrsync(k-29)=synclev/snoiselev
        else if(k.ge.73 .and. k.le.79) then
          synclev=s81(icos7(k-73)); snoiselev=(sum(s81)-synclev)/7.0
          if(snoiselev.gt.1.E-16) snrsync(k-58)=synclev/snoiselev
        endif
      else
        cycle
      endif
    enddo
    syncav=sum(snrsync)/21.
    syncavpart(1)=sum(snrsync(1:7))/7.; syncavpart(2)=sum(snrsync(8:14))/7.; syncavpart(3)=sum(snrsync(15:21))/7.
    syncavemax=maxval(syncavpart,1)

!    plev=0.0
!    do k=1000,1009; abscd=abs(cd0(k)); if(abscd.gt.plev) plev=abscd; enddo
!    plev=plev/61.0
!    do k=0,3199; xx=plev*gran(); yy=plev*gran(); cd0(k)=cd0(k) + complex(xx,yy); enddo

    lreverse=.false.
    if(.not.swl) then
      if(nft8cycles.lt.2) then 
        if(ipass.eq.2) lreverse=.true.
      else
        if(ipass.eq.5 .or. ipass.eq.7) lreverse=.true.
      endif
    else ! swl
      if(nft8swlcycles.lt.2) then 
        if(ipass.eq.2) lreverse=.true.
      else
        if(ipass.eq.5 .or. ipass.eq.7) lreverse=.true.
      endif
    endif

    do k=1,79
      i1=ibest+(k-1)*32
      csymb=cd0(i1:i1+31)
      if(syncav.lt.2.5) then
        csymb(1)=csymb(1)*1.9; csymb(32)=csymb(32)*1.9
        scr=SQRT(abs(csymb(1)))/SQRT(abs(csymb(32)))
        if(scr.gt.1.0) then; csymb(32)=csymb(32)*scr; else; if(scr.gt.1.E-16) csymb(1)=csymb(1)/scr; endif
      endif
      do i=1,32; csymbr(i)=cmplx(real(csymb(33-i)),-aimag(csymb(33-i))); enddo
      if(lreverse) then
        call four2a(csymb,32,1,-1,1)
        cscs(0:7,k)=csymb(1:8)/1e3
        csymb=csymbr
      endif
      call four2a(csymb,32,1,-1,1)
      cs(0:7,k)=csymb(1:8)/1e3
      if(lreverse) then; csr=cs
      else; call four2a(csymbr,32,1,-1,1); csr(0:7,k)=csymbr(1:8)/1e3
      endif
      s8(0:7,k)=abs(csymb(1:8))
    enddo

    sp=0.
    do k=0,7; sp(k)=sum(s8(k,1:7))+sum(s8(k,18:79)); enddo
    ka=minloc(sp)-1; k=ka(1); if(k.lt.0) go to 128
    do kb=0,7
      if(kb.eq.k) cycle; spr=sp(kb)/sp(k)
      if(spr.gt.1.5) then
        s8(kb,:)=s8(kb,:)/spr; sprsqr=SQRT(spr)
        cs(kb,:)=cs(kb,:)/sprsqr; csr(kb,:)=csr(kb,:)/sprsqr; cscs(kb,:)=cscs(kb,:)/sprsqr
      endif
    enddo
128 continue

    if(iqso.gt.1 .and. iqso.lt.4) then; s82=SQRT(s8); go to 8; endif
    if(iqso.eq.4) go to 32

    nsyncscorew=0; scoreratiowa=0.; rrxdt=xdt-0.5
    if(rrxdt.ge.-0.5 .and. rrxdt.le.2.13) then
      do k=1,7; syncw(icos7(k-1)+1)=s8(icos7(k-1),k)+s8(icos7(k-1),k+36)+s8(icos7(k-1),k+72); enddo
      do k=1,7; sumkw(k)=(sum(s8(k-1,:))-syncw(k))/25.333; enddo ! (79-3)/3
    else if(rrxdt.lt.-0.5) then
      do k=1,7; syncw(icos7(k-1)+1)=s8(icos7(k-1),k+36)+s8(icos7(k-1),k+72); enddo
      do k=1,7; sumkw(k)=(sum(s8(k-1,26:79))-syncw(k))/26.; enddo ! (54-2)/2
    else if(rrxdt.gt.2.13) then
      do k=1,7; syncw(icos7(k-1)+1)=s8(icos7(k-1),k)+s8(icos7(k-1),k+36); enddo
      do k=1,7; sumkw(k)=(sum(s8(k-1,1:54))-syncw(k))/26.; enddo ! (54-2)/2
    endif
    do k=1,7; if(syncw(k).gt.sumkw(k)) nsyncscorew=nsyncscorew+1; scoreratiow(k)=syncw(k)/sumkw(k); enddo
    scoreratiowa=sum(scoreratiow)/7.

! sync quality check
    is1=0; is2=0; is3=0; nsyncscore=0; nsyncscore1=0; nsyncscore2=0; nsyncscore3=0
    scoreratio=0.; scoreratio1=0.; scoreratio2=0.; scoreratio3=0.; nsync2=0
    do k=1,7
      s81(:)=s8(:,k); ip=maxloc(s81)
      if(icos7(k-1).eq.(ip(1)-1)) then
        is1=is1+1
      else
        s81(ip(1)-1)=0.; ip=maxloc(s81)
        if(icos7(k-1).eq.(ip(1)-1)) nsync2=nsync2+1
      endif
      s81=s8(:,k+36); ip=maxloc(s81)
      if(icos7(k-1).eq.(ip(1)-1)) then
        is2=is2+1
      else
        s81(ip(1)-1)=0.; ip=maxloc(s81)
        if(icos7(k-1).eq.(ip(1)-1)) nsync2=nsync2+1
      endif
      s81=s8(:,k+72); ip=maxloc(s81)
      if(icos7(k-1).eq.(ip(1)-1)) then
        is3=is3+1
      else
        s81(ip(1)-1)=0.; ip=maxloc(s81)
        if(icos7(k-1).eq.(ip(1)-1)) nsync2=nsync2+1
      endif
      if(rrxdt.ge.-0.5) then
        synck=s8(icos7(k-1),k); sumk=(sum(s8(:,k))-synck)/7.0
        if(synck.gt.sumk) then; nsyncscore1=nsyncscore1+1; scoreratio1=scoreratio1+synck/sumk; endif
      endif
      synck=s8(icos7(k-1),k+36); sumk=(sum(s8(:,k+36))-synck)/7.0
      if(synck.gt.sumk) then; nsyncscore2=nsyncscore2+1; scoreratio2=scoreratio2+synck/sumk; endif
      if(rrxdt.le.2.13) then
        synck=s8(icos7(k-1),k+72); sumk=(sum(s8(:,k+72))-synck)/7.0
        if(synck.gt.sumk) then; nsyncscore3=nsyncscore3+1; scoreratio3=scoreratio3+synck/sumk; endif
      endif
    enddo
    nsyncscore=nsyncscore1+nsyncscore2+nsyncscore3; scoreratio=scoreratio1+scoreratio2+scoreratio3
! hard sync sum - max is 21
    nsync=is1+is2+is3
! bail out
    rscq=0.
    if(lcqcand) then
      do k11=8,16
        ip=maxloc(s8(:,k11))
        if(k11.lt.16) then; if(ip(1).eq.1) rscq=rscq+1.; else; if(ip(1).eq.2) rscq=rscq+1.; endif
      enddo
      ip=maxloc(s8(:,17)); if(ip(1).eq.1 .or. ip(1).eq.2) rscq=rscq+0.5
      ip=maxloc(s8(:,27)); if(ip(1).eq.1 .or. ip(1).eq.2) rscq=rscq+0.5
      ip=maxloc(s8(:,33)); if(ip(1).eq.3 .or. ip(1).eq.4) rscq=rscq+0.5
    endif
    if(lcqcand .and. nsync.eq.4) then
      if(nsync+nsync2.lt.12) then
        if(rscq.lt.6.6) then; nbadcrc=1; return; endif
      endif
    lapcqonly=.true.
    else if(lcqcand .and. nsync.eq.5) then
      if(nsync+nsync2.lt.12) then
        if(rscq.lt.6.1) then; nbadcrc=1; return; endif
      endif
    lapcqonly=.true.
    else if(lcqcand .and. nsync.eq.6) then
      if(nsync+nsync2.lt.11) then
        if(rscq.lt.5.6) then; nbadcrc=1; return; endif
      endif
    lapcqonly=.true.
    else
      if(nsync.lt.7) then; nbadcrc=1; return; endif
    endif

    lskipnotap=.false.
    if(.not.lapcqonly .and. nsync.lt.11) then
      nsmax=0
      do k=1,7
        s81=s8(:,k)
        include 'syncdist.f90'
        s81=s8(:,k+36)
        include 'syncdist.f90'
        s81=s8(:,k+72)
        include 'syncdist.f90'
      enddo
      if(sum(nsmax(7:8)).gt.sum(nsmax(2:3)) .or. sum(nsmax(5:6)).gt.sum(nsmax(2:3))) lskipnotap=.true.
    endif

!    if(lcqcand .and. nsync.lt.7 .and. nsync.gt.1) then
!      if(nsync+nsync2.lt.9) then
!        rscq=0.
!        do k11=8,16
!          ip=maxloc(s8(:,k11))
!          if(k11.lt.16) then; if(ip(1).eq.1) rscq=rscq+1.; else; if(ip(1).eq.2) rscq=rscq+1.; endif
!        enddo
!        ip=maxloc(s8(:,17)); if(ip(1).eq.1 .or. ip(1).eq.2) rscq=rscq+0.5
!        ip=maxloc(s8(:,27)); if(ip(1).eq.1 .or. ip(1).eq.2) rscq=rscq+0.5
!        ip=maxloc(s8(:,33)); if(ip(1).eq.3 .or. ip(1).eq.4) rscq=rscq+0.5
!        if(rscq.lt.4.9) then; nbadcrc=1; return; endif
!      endif
!    else
!      if(nsync.lt.7) then; nbadcrc=1; return; endif
!    endif
    if(nsyncscore.gt.0) then; scoreratio=scoreratio/nsyncscore; else; scoreratio=0.; endif 
    if(nsyncscore1.gt.0) then; scoreratio1=scoreratio1/nsyncscore1; else; scoreratio1=0.; endif 
    if(nsyncscore3.gt.0) then; scoreratio3=scoreratio3/nsyncscore3; else; scoreratio3=0.; endif
    if(dfqso.ge.2.0 .or. (dfqso.lt.2.0 .and. stophint)) then
      if(rrxdt.ge.-0.5 .and. rrxdt.le.2.13) then
        if(nsyncscore.lt.8 .or. (nsyncscore.lt.10 .and. scoreratio.lt.5.5) .or. (nsyncscore.lt.11 .and. &
           scoreratio.lt.3.63)) then
          nbadcrc=1; return ! 377 out of 20709
        else if(nsyncscore.eq.11 .and. scoreratio.lt.5.37) then
          if(nsyncscore1.lt.5 .and. nsyncscore3.lt.5 .and. scoreratio1.lt.4.2 .and. scoreratio3.lt.4.2) then
            nbadcrc=1; return ! 261
          endif
        else if(nsyncscore.eq.12 .and. scoreratio.lt.4.6) then
          if(nsyncscore1.lt.5 .and. nsyncscore3.lt.5 .and. scoreratio1.lt.4.0 .and. scoreratio3.lt.4.0) then
            nbadcrc=1; return ! 222
          endif
        else if(nsyncscore.eq.13 .and. scoreratio.lt.4.4) then
          if(nsyncscore1.lt.5 .and. nsyncscore2.lt.6 .and. nsyncscore3.lt.5 .and. scoreratio1.lt.4.4 .and. &
             scoreratio3.lt.4.4) then
            nbadcrc=1; return ! 98
          endif
        else if(nsyncscorew.lt.3) then
          if((nsyncscore1.gt.5 .and. scoreratio1.gt.13.8) .or. (nsyncscore2.gt.5 .and. scoreratio2.gt.13.8) .or. &
             (nsyncscore3.gt.5 .and. scoreratio3.gt.13.8)) go to 32
          nbadcrc=1; return ! 75
        else if(nsyncscorew.eq.3) then
          if(scoreratio1.gt.15. .or. scoreratio2.gt.15. .or. scoreratio3.gt.15.) go to 32
          nbadcrc=1; return ! 125
        else if(nsyncscorew.eq.4) then
          if(nsyncscore1.eq.7 .or. nsyncscore2.eq.7 .or. nsyncscore3.eq.7 .or. scoreratio1.gt.10. .or. &
             scoreratio2.gt.10. .or. scoreratio3.gt.10.) go to 32
          nbadcrc=1; return ! 94
        else if(nsyncscorew.eq.5) then
          if(nsyncscore.gt.17 .or. nsyncscore1.eq.7 .or. nsyncscore2.eq.7 .or. nsyncscore3.eq.7 .or. scoreratio1.gt.10. .or. &
             scoreratio2.gt.10. .or. scoreratio3.gt.10.) go to 32
            nbadcrc=1; return ! 131
        endif
      else if(rrxdt.lt.-0.5) then
        if(nsyncscore.lt.6 .or. (nsyncscore.gt.5 .and. nsyncscore.lt.8 .and. nsyncscorew.lt.6 .and. &
           scoreratio2.lt.5.5 .and. scoreratio3.lt.5.5)) then
          nbadcrc=1; return ! 46
        else if(nsyncscore.eq.8) then
          if(nsyncscore2.lt.6 .and. nsyncscore3.lt.6 .and. scoreratio2.lt.6.6 .and. scoreratio3.lt.6.6) then
            nbadcrc=1; return ! 20 
          endif
        else if(nsyncscore.eq.9 .and. scoreratio.lt.6.0) then
          if(nsyncscore2.lt.6 .and. nsyncscore3.lt.6 .and. scoreratio2.lt.6.6 .and. scoreratio3.lt.6.5) then
            nbadcrc=1; return ! 5 
          endif
        else if(nsyncscorew.lt.3) then
          if((nsyncscore2.gt.5 .and. scoreratio2.gt.13.8) .or. (nsyncscore3.gt.5 .and. scoreratio3.gt.13.8)) go to 32
          nbadcrc=1; return ! 22
        else if(nsyncscorew.eq.3) then
          if(scoreratio2.gt.15. .or. nsyncscore3.gt.15) go to 32
          nbadcrc=1; return ! 31
        else if(nsyncscorew.eq.4) then
          if(nsyncscore2.eq.7 .or. nsyncscore3.eq.7 .or. scoreratio2.gt.10. .or. nsyncscore3.gt.10) go to 32
          nbadcrc=1; return ! 34
        else if(nsyncscorew.eq.5) then
          if(nsyncscore.gt.11 .or. nsyncscore2.eq.7 .or. nsyncscore3.eq.7 .or. scoreratio2.gt.10. .or. &
             scoreratio3.gt.10.) go to 32
            nbadcrc=1; return ! 35
        endif
      else if(rrxdt.gt.2.13) then
        if(nsyncscore.lt.6 .or. (nsyncscore.gt.5 .and. nsyncscore.lt.8 .and. nsyncscorew.lt.6 .and. &
           scoreratio1.lt.5.5 .and. scoreratio2.lt.5.5)) then
          nbadcrc=1; return ! 4
        else if(nsyncscore.eq.8) then
          if(nsyncscore1.lt.6 .and. nsyncscore2.lt.6 .and. scoreratio1.lt.6.6 .and. scoreratio2.lt.6.6) then
            nbadcrc=1; return ! 8
          endif
        else if(nsyncscore.eq.9 .and. scoreratio.lt.6.0) then
          if(nsyncscore1.lt.6 .and. nsyncscore2.lt.6 .and. scoreratio2.lt.6.6 .and. scoreratio1.lt.6.5) then
            nbadcrc=1; return ! 2
          endif
        else if(nsyncscorew.lt.3) then
          if((nsyncscore1.gt.5 .and. scoreratio1.gt.13.8) .or. (nsyncscore2.gt.5 .and. scoreratio2.gt.13.8)) go to 32
          nbadcrc=1; return ! 12
        else if(nsyncscorew.eq.3) then
          if(scoreratio1.gt.15. .or. scoreratio2.gt.15.) go to 32
          nbadcrc=1; return ! 32
        else if(nsyncscorew.eq.4) then
          if(nsyncscore1.eq.7 .or. nsyncscore2.eq.7 .or. scoreratio1.gt.10. .or. nsyncscore2.gt.10) go to 32
          nbadcrc=1; return ! 103
        else if(nsyncscorew.eq.5) then
          if(nsyncscore.gt.11 .or. nsyncscore1.eq.7 .or. nsyncscore2.eq.7 .or. scoreratio1.gt.10. .or. &
             scoreratio2.gt.10.) go to 32
            nbadcrc=1; return ! 0
        endif
      endif
    endif

32  if(lsd) then
      if(iqso.eq.4 .and. .not.ldeepsync) go to 64
      call ft8sd1(s8,itone,msgd,msg37,lft8sd,lcq)
      if(lft8sd) then
        if(levenint) then; evencopy(isd)%lstate=.false.
        elseif(loddint) then; oddcopy(isd)%lstate=.false.
        endif
        i3=1; n3=1; iaptype=0; nbadcrc=0; lsd=.false.; go to 2
      endif
64    if(iqso.eq.4) then
        if(.not.lcq) then
          call ft8mf1(s8,itone,msgd,msg37,lft8sd)
          if(lft8sd) then
            if(levenint) then; evencopy(isd)%lstate=.false.
            elseif(loddint) then; oddcopy(isd)%lstate=.false.
            endif
            i3=1; n3=1; iaptype=0; nbadcrc=0; lsd=.false.; go to 2
          endif
        else
          call ft8mfcq(s8,itone,msgd,msg37,lft8sd)
          if(lft8sd) then
            if(levenint) then; evencopy(isd)%lstate=.false.
            elseif(loddint) then; oddcopy(isd)%lstate=.false.
            endif
            i3=1; n3=1; iaptype=0; nbadcrc=0; lsd=.false.; go to 2
          endif
        endif
      endif
    endif
    if(iqso.eq.4) then; nbadcrc=1; go to 2; endif

    synclev=0.0; snoiselev=1.0
    do k=1,7
      synclev=synclev+s8(icos7(k-1),k+36)
    enddo
    snoiselev=(sum(s8(0:7,37:43))- synclev)/7.0
    if(snoiselev.lt.0.1) snoiselev=1.0 ! safe division
    srr=synclev/snoiselev
!  SNR   srr range  average srr
! -18 1.8...4.0  2.9
! -19 1.7...3.6  2.65
! -20 1.6...3.3  2.43
! -21 1.6...3.0  2.22
! -22 1.55...2.8 2.19
! -23 1.4...2.6  2.03
! -24            1.94

8   if(iqso.gt.1 .and. iqso.lt.4) then
      if(.not.lqsomsgdcd .and. .not.(.not.lmycallstd .and. .not.lhiscallstd)) then
        if(.not.lft8sdec .and. dfqso.lt.2.0) then
          if(lvirtual2 .or. lvirtual3) srr=0.0
          call ft8s(s82,srr,itone,msg37,lft8s,nft8rxfsens,stophint)
          if(lft8s) then
            if(index(msg37,'<').gt.0) then; lhashmsg=.true.; call delbraces(msg37); endif
            nbadcrc=0; lft8sdec=.true.; lsdone=.true.; go to 2 ! i3=16 n3=16, any affect?
          endif
        endif
      endif
      lsdone=.true.; nbadcrc=1; cycle
    endif

    i1=ibest+224 ! 7*32
    csymb256=cd0(i1:i1+255)*ctwk256
    call four2a(csymb256,256,1,-1,1)
    s256(0:8)=abs(csymb256(1:9))
    rscq=0.; nmic=0
    do k11=8,16
      ip=maxloc(s8(:,k11))
      if(ip(1).eq.idtonemyc(k11-7)+1) nmic=nmic+1
      if(k11.lt.16) then
        if(ip(1).eq.1) rscq=rscq+1.
      else
        if(ip(1).eq.2) rscq=rscq+1.
      endif
    enddo
    ip=maxloc(s8(:,17)); if(ip(1).eq.1 .or. ip(1).eq.2) rscq=rscq+0.5
    ip=maxloc(s8(:,27)); if(ip(1).eq.1 .or. ip(1).eq.2) rscq=rscq+0.5
    ip=maxloc(s8(:,33)); if(ip(1).eq.3 .or. ip(1).eq.4) rscq=rscq+0.5

    lqsosig=.false.; lqsosigtype3=.false.; lqso73=.false.; lqsorr73=.false.; lqsorrr=.false. ! 73/rr73/rrr for std/nonstd callsigns
    if(.not.lqsomsgdcd .and. (dfqso.lt.napwid .or. abs(nftx-f1).lt.napwid) .and. lapmyc .and. len_trim(hiscall).gt.2) then
      nqsot=0
      do i=1,19
        ip=maxloc(s8(:,i+7))
        if(ip(1).eq.idtone56(1,i)+1) nqsot=nqsot+1
      enddo
      if(nqsot.gt.6) lqsosig=.true. ! decoding depth only
      do i=20,22
        ip=maxloc(s8(:,i+7))
        if(ip(1).eq.idtone56(1,i)+1) nqsot=nqsot+1
      enddo
      if(nqsot.gt.3) lqsosigtype3=.true.
      nqsoend=0 ! array 73,rr73,rrr
      if(dfqso.lt.napwid .and. (nQSOProgress.eq.3 .or. nQSOProgress.eq.4)) then ! QSO RX freq only
        do i=24,58
          if(i.lt.30) then; ip=maxloc(s8(:,i+7)); else; ip=maxloc(s8(:,i+14)); endif
          if(ip(1).eq.idtone56(56,i)+1) nqsoend(1)=nqsoend(1)+1
          if(ip(1).eq.idtone56(55,i)+1) nqsoend(2)=nqsoend(2)+1
          if(ip(1).eq.idtone56(54,i)+1) nqsoend(3)=nqsoend(3)+1
        enddo
        ip=maxloc(nqsoend)
        if(nqsoend(ip(1)).gt.6) then
          if(ip(1).eq.1) then; lqso73=.true.
          else if(ip(1).eq.2) then; lqsorr73=.true.
          else if(ip(1).eq.3) then; lqsorrr=.true.
          endif
        endif
      endif
    endif

    lcqsignal=.false.
    ip(1)=maxloc(s256,1)
    if(ip(1).eq.5 .or. rscq.gt.3.1) lcqsignal=.true.
    if(.not.lcqsignal .and. ip(1).eq.4 .or. ip(1).eq.6) then
      s2563(0:8)=s256(0:8); s2563(9:26)=abs(csymb256(9:26))
      ip(1)=maxloc(s2563,1)
      if(ip(1).eq.4 .or. ip(1).eq.6) lcqsignal=.true.
    endif
    lmycsignal=.false.; if(lapmyc .and. nmic.gt.2) lmycsignal=.true.

    ldxcsig=.false.; lcqdxcsig=.false.; lcqdxcnssig=.false.; ndxt=0
    if(lhiscallstd) then
      do k11=17,26
        ip=maxloc(s8(:,k11))
        if(ip(1).eq.idtone56(1,k11-7)+1) ndxt=ndxt+1
      enddo
      if(ndxt.gt.3) ldxcsig=.true.
      if(lcqsignal .and. ldxcsig) lcqdxcsig=.true.
    endif
! nonstd DXCall search in idle mode
    if(.not.lhiscallstd .and. len_trim(hiscall).gt.2) then ! nonstandard DXCall
      ncqdxcnst=0
      do i=1,4
        ip=maxloc(s8(:,i+7))
        if(ip(1).eq.idtonecqdxcns(i)+1) ncqdxcnst=ncqdxcnst+1
      enddo
      ndxt=0
      do i=5,23
        ip=maxloc(s8(:,i+7))
        if(ip(1).eq.idtonedxcns73(i)+1) ndxt=ndxt+1
        if(ip(1).eq.idtonecqdxcns(i)+1) ncqdxcnst=ncqdxcnst+1
      enddo
      ldxcsig=.false.
      if(dfqso.lt.napwid) then
        if(ndxt.gt.4) ldxcsig=.true. ! relaxed threshold for RXF napwid
        if(ncqdxcnst.gt.5) lcqdxcnssig=.true.
      else
        if(ndxt.gt.5) ldxcsig=.true.
        if(ncqdxcnst.gt.6) lcqdxcnssig=.true.
      endif
    endif

    lfoxstdr73=.false.; lfoxspecrpt=.false.
    nfoxspecrpt=0 ! checking fo special message with report to mybcall
    if(lhound) then
      nfoxstdbase=0 ! checking for report signal and base of RR73 signal
      nfoxspecr73=0 ! checking fo special message with RR73 to mybcall
      nfoxr73=0 ! checking for RR73 signal with standard message
      fdelta=abs(f1-nfqso); fdeltam=modulo(fdelta,60.)
      if(fdelta.lt.245.0 .and. fdeltam.lt.3.0 .and. (nQSOProgress.eq.1 .or. nQSOProgress.eq.3)) then ! calculate on possible Fox frequencies only
        do i=1,18
          ip=maxloc(s8(:,i+7))
          if(ip(1).eq.idtonefox73(i)+1) nfoxstdbase=nfoxstdbase+1
          if(i.gt.10 .and. ip(1).eq.idtonespec(i)+1) nfoxspecrpt=nfoxspecrpt+1
        enddo
        do i=20,22 ! hash10
          ip=maxloc(s8(:,i+7))
          if(ip(1).eq.idtonespec(i)+1) then; nfoxspecrpt=nfoxspecrpt+1; nfoxspecr73=nfoxspecr73+1; endif
        enddo
        ip=maxloc(s8(:,25+7)) ! i3,n3
        if(ip(1).eq.idtonespec(25)+1) then; nfoxspecrpt=nfoxspecrpt+1; nfoxspecr73=nfoxspecr73+1; endif
        if(nfoxstdbase.eq.0) then
          rspecstdrpt=(nfoxspecrpt*18.)/(1.2)
        else
          rspecstdrpt=(nfoxspecrpt*18.)/(12.*nfoxstdbase)
        endif
        if(rspecstdrpt.gt.1.) lfoxspecrpt=.true.
        if(nQSOProgress.eq.3) then
          do i=24,58
            if(i.lt.30) then; ip=maxloc(s8(:,i+7)); else; ip=maxloc(s8(:,i+14)); endif
            if(ip(1).eq.idtonefox73(i)+1) nfoxr73=nfoxr73+1
          enddo
          if(nfoxspecr73.eq.0) then
            rstdr73=(nfoxr73*4.)/(3.5)
          else
            rstdr73=(nfoxr73*4.)/(35.*nfoxspecr73)
          endif
          if(rstdr73.gt.1.) lfoxstdr73=.true.
        endif
      endif
    endif

    lsubptxfreq=.false.
    if(lapmyc .and. abs(f1-nftx).lt.2.0 .and. .not.lhound .and. .not.lft8sdec .and. .not.lqsomsgdcd .and. &
      ((.not.lskiptx1 .and. nlasttx.eq.1) .or. (lskiptx1 .and. nlasttx.eq.2))) lsubptxfreq=.true.

    nweak=1
    if(lft8subpass .or. swl .or. dfqso.lt.2.0 .or. lsubptxfreq) nweak=2
    nsubpasses=nweak
    if(lcqsignal) then
      nsubpasses=3
      if(levenint) then
        do ik=1,numcqsig
          if(evencq(ik,nthr)%freq.gt.5001.) exit
          if(abs(evencq(ik,nthr)%freq-f1).lt.2.0 .and. abs(evencq(ik,nthr)%xdt-xdt).lt.0.05) then
            nsubpasses=5; csold=evencq(ik,nthr)%cs
          endif
        enddo
      else if (loddint) then
        do ik=1,numcqsig
          if(oddcq(ik,nthr)%freq.gt.5001.) exit
          if(abs(oddcq(ik,nthr)%freq-f1).lt.2.0 .and. abs(oddcq(ik,nthr)%xdt-xdt).lt.0.05) then
            nsubpasses=5; csold=oddcq(ik,nthr)%cs
          endif
        enddo
      endif
    endif
    if(lmycsignal .and. lmycallstd) then
      nsubpasses=6
      if(levenint) then
        do ik=1,nummycsig
          if(evenmyc(ik,nthr)%freq.gt.5001.) exit
          if(abs(evenmyc(ik,nthr)%freq-f1).lt.2.0 .and. abs(evenmyc(ik,nthr)%xdt-xdt).lt.0.05) then
            nsubpasses=8; csold=evenmyc(ik,nthr)%cs
          endif
        enddo
      else if (loddint) then
        do ik=1,nummycsig
          if(oddmyc(ik,nthr)%freq.gt.5001.) exit
          if(abs(oddmyc(ik,nthr)%freq-f1).lt.2.0 .and. abs(oddmyc(ik,nthr)%xdt-xdt).lt.0.05) then
            nsubpasses=8; csold=oddmyc(ik,nthr)%cs
          endif
        enddo
      endif
    endif
    lqsocandave=.false.
    if(lapmyc .and. ndxt.gt.2 .and. nmic.gt.2 .and. .not.lqsomsgdcd .and. lmycallstd .and. lhiscallstd .and. &
       dfqso.lt.napwid/2.0) then
      lqsocandave=.true.
      nsubpasses=9
      if(levenint) then
          if(abs(evenqso(1,nthr)%freq-f1).lt.2.0 .and. abs(evenqso(1,nthr)%xdt-xdt).lt.0.05) then
            nsubpasses=11; csold=evenqso(1,nthr)%cs
          endif
      else if (loddint) then
          if(abs(oddqso(1,nthr)%freq-f1).lt.2.0 .and. abs(oddqso(1,nthr)%xdt-xdt).lt.0.05) then
            nsubpasses=11; csold=oddqso(1,nthr)%cs
          endif
      endif
    endif

    do isubp1=1,nsubpasses
      if(nweak.eq.1 .and. isubp1.eq.2) cycle
      if(isubp1.gt.2 .and. isubp1.lt.6 .and. lmycsignal) cycle ! skip if it is lmycsignal, can be both lcq and lmy
      syncavemax=3.
      if(isubp1.eq.2) cs=csr
      if(ipass.eq.npass-1 .and. (lcqsignal .or. lmycsignal) .and. &
        ((nweak.eq.1 .and. isubp1.eq.1) .or. (nweak.eq.2 .and. isubp1.eq.2))) cstmp2=cs
      if(ipass.eq.npass .and. lapmyc .and. ndxt.gt.2 .and. nmic.gt.2 .and. &
        ((nweak.eq.1 .and. isubp1.eq.1) .or. (nweak.eq.2 .and. isubp1.eq.2))) cstmp2=cs
      do nsym=1,3
        nt=2**(3*nsym)-1
        do ihalf=1,2
          do k=1,29,nsym
            if(ihalf.eq.1) then; ks=k+7
            else; ks=k+43
            endif
            ks1=ks+1; ks2=ks+2
            do i=0,nt
              i1=i/64
              i2=iand(i,63)/8
              i33=iand(i,7)
              if(isubp1.lt.3) then
                if(nsym.eq.1) then
                  s2(i)=abs(cs(graymap(i33),ks))
                elseif(nsym.eq.2) then
                  s2(i)=abs(cs(graymap(i2),ks)+cs(graymap(i33),ks1))
                else
                  s2(i)=abs(cs(graymap(i1),ks)+cs(graymap(i2),ks1)+cs(graymap(i33),ks2))
                endif
              else if(isubp1.eq.3 .or. isubp1.eq.6 .or. isubp1.eq.9) then
                if(nsym.eq.1) then
                  s2(i)=abs(cscs(graymap(i33),ks))**2+abs(csr(graymap(i33),ks))**2
                elseif(nsym.eq.2) then
                  s2(i)=abs(cscs(graymap(i2),ks)+cscs(graymap(i33),ks1))**2+abs(csr(graymap(i2),ks)+csr(graymap(i33),ks1))**2
                else
                  s2(i)=abs(cscs(graymap(i1),ks)+cscs(graymap(i2),ks1)+cscs(graymap(i33),ks2))**2 + &
                    abs(csr(graymap(i1),ks)+csr(graymap(i2),ks1)+csr(graymap(i33),ks2))**2
                endif
              else if(isubp1.eq.4 .or. isubp1.eq.7 .or. isubp1.eq.10) then
                if(nsym.eq.1) then
                  s2(i)=abs(cs(graymap(i33),ks))**2+abs(csold(graymap(i33),ks))**2
                elseif(nsym.eq.2) then
                  s2(i)=abs(cs(graymap(i2),ks)+cs(graymap(i33),ks1))**2+abs(csold(graymap(i2),ks)+csold(graymap(i33),ks1))**2
                else
                  s2(i)=abs(cs(graymap(i1),ks)+cs(graymap(i2),ks1)+cs(graymap(i33),ks2))**2 + &
                    abs(csold(graymap(i1),ks)+csold(graymap(i2),ks1)+csold(graymap(i33),ks2))**2
                endif
              else if(isubp1.eq.5 .or. isubp1.eq.8 .or. isubp1.eq.11) then
                if(nsym.eq.1) then
                  s2(i)=abs(cs(graymap(i33),ks))+abs(csold(graymap(i33),ks))
                elseif(nsym.eq.2) then
                  s2(i)=abs(cs(graymap(i2),ks)+cs(graymap(i33),ks1))+abs(csold(graymap(i2),ks)+csold(graymap(i33),ks1))
                else
                  s2(i)=abs(cs(graymap(i1),ks)+cs(graymap(i2),ks1)+cs(graymap(i33),ks2)) + &
                    abs(csold(graymap(i1),ks)+csold(graymap(i2),ks1)+csold(graymap(i33),ks2))
                endif
              endif
              if(isubp1.eq.1 .and. srr.lt.2.5) then !  srr.lt.2.5 -19dB SNR threshold
                if(srr.gt.2.3) then 
                  s2(i)=s2(i)**2
                else
                  ss1=s2(i)
                  if(ss1.lt.5.77) then; s2(i)=1+8.*ss1**2-0.12*ss1**4; else; s2(i)=(ss1+5.82)**2; endif
                endif
              endif
              if(isubp1.gt.1 .and. srr.lt.2.5) s2(i)=(0.5*s2(i))**3 ! -19dB SNR threshold
            enddo
            i32=1+(k-1)*3+(ihalf-1)*87
            if(nsym.eq.1) ibmax=2; if(nsym.eq.2) ibmax=5; if(nsym.eq.3) ibmax=8
            do ib=0,ibmax
              bm=maxval(s2(0:nt),one(0:nt,ibmax-ib)) - maxval(s2(0:nt),.not.one(0:nt,ibmax-ib))
              if(i32+ib .gt.174) cycle
              if(nsym.eq.1) then
                bmeta(i32+ib)=bm
                den=max(maxval(s2(0:nt),one(0:nt,ibmax-ib)),maxval(s2(0:nt),.not.one(0:nt,ibmax-ib)))
                if(den.gt.0.0) then; cm=bm/den; else; cm=0.0; endif
                bmetd(i32+ib)=cm
              elseif(nsym.eq.2) then
                bmetb(i32+ib)=bm
              elseif(nsym.eq.3) then
                bmetc(i32+ib)=bm
              endif
            enddo
          enddo ! k
        enddo ! ihalf
      enddo ! nsym

!tests
!call indexx(bmetc(1:174),174,indx)
!src=abs(bmetc(indx(1))/bmetc(indx(174)))
!print *,src
      call normalizebmet(bmeta,174);call normalizebmet(bmetb,174);call normalizebmet(bmetc,174);call normalizebmet(bmetd,174)
      scalefac=2.83; llra=scalefac*bmeta; llrb=scalefac*bmetb; llrc=scalefac*bmetc; llrd=scalefac*bmetd
      apmag=maxval(abs(llra))*1.01

! isubp2 #
!------------------------------
!   1        regular decoding, nsym=1 
!   2        regular decoding, nsym=2 
!   3        regular decoding, nsym=3 
!   4        regular decoding, llrd
!   5..18    ap passes

! iaptype Hound OFF, MyCall is standard, DXCall is standard or empty
!------------------------
!   0        cycle
!   1        CQ     ???    ???           (29+3=32 ap bits)
!   2        MyCall ???    ???           (29+3=32 ap bits)
!   3        MyCall DxCall ???           (58+3=61 ap bits)
!   4        MyCall DxCall RRR           (77 ap bits)
!   5        MyCall DxCall 73            (77 ap bits)
!   6        MyCall DxCall RR73          (77 ap bits)

! naptypes(nQSOProgress, extra decoding pass)
!  data naptypes(0,1:27)/0,0,0,0,0,0,0,0,0,0,0,0,2,2,2,1,1,1,31,31,31,36,36,36,35,35,35/ ! Tx6 CQ
!  data naptypes(1,1:27)/3,3,3,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,31,31,31,36,36,36,35,35,35/ ! Tx1 Grid
!  data naptypes(2,1:27)/3,3,3,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,31,31,31,36,36,36,35,35,35/ ! Tx2 Report
!  data naptypes(3,1:27)/3,3,3,6,6,6,5,5,5,4,4,4,0,0,0,0,0,0,31,31,31,36,36,36,35,35,35/ ! Tx3 RRreport
!  data naptypes(4,1:27)/3,3,3,6,6,6,5,5,5,4,4,4,2,2,2,0,0,0,31,31,31,36,36,36,35,35,35/ ! Tx4 RRR,RR73
!  data naptypes(5,1:27)/0,0,0,0,0,0,0,0,0,0,0,0,2,2,2,1,1,1,31,31,31,36,36,36,35,35,35/ ! Tx5 73

! iaptype standard DxCall tracking, also valid in Hound mode
!------------------------
!   31        CQ  DxCall Grid(???)     (77 ap bits)
!   35        ??? DxCall 73            (29+19 ap bits)
!   36        ??? DxCall RR73          (29+19 ap bits)

! iaptype Hound off, MyCall is nonstandard, DXCall is standard or empty
!------------------------
!   0         cycle
!   1         CQ     ???    ???        (29+3=32 ap bits)
!   40       <MyCall> ???  ???         (29+3=32 ap bits) incoming call
!   41       <MyCall> DxCall ???       (58 ap bits) REPORT/RREPORT
!   42        MyCall <DxCall> RRR      (77 ap bits)
!   43        MyCall <DxCall> 73       (77 ap bits)
!   44        MyCall <DxCall> RR73     (77 ap bits)
!   31        CQ  DxCall Grid(???)     (77 ap bits) standard DxCall tracking
!   35        ??? DxCall 73            (29+19 ap bits) standard DxCall tracking
!   36        ??? DxCall RR73          (29+19 ap bits) standard DxCall tracking

! nmycnsaptypes(nQSOProgress, extra decoding pass)
!  data nmycnsaptypes(0,1:27)/0,0,0,0,0,0,0,0,0,0,0,0,40,40,40,1,1,1,31,31,31,36,36,36,35,35,35/             ! Tx6 CQ
!  data nmycnsaptypes(1,1:27)/41,41,41,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,31,31,31,36,36,36,35,35,35/             ! Tx1 DXcall MyCall
!  data nmycnsaptypes(2,1:27)/41,41,41,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,31,31,31,36,36,36,35,35,35/             ! Tx2 Report
!  data nmycnsaptypes(3,1:27)/41,41,41,44,44,44,43,43,43,42,42,42,0,0,0,0,0,0,31,31,31,36,36,36,35,35,35/    ! Tx3 RRreport
!  data nmycnsaptypes(4,1:27)/41,41,41,44,44,44,43,43,43,42,42,42,40,40,40,0,0,0,31,31,31,36,36,36,35,35,35/ ! Tx4 RRR,RR73
!  data nmycnsaptypes(5,1:27)/0,0,0,0,0,0,0,0,0,0,0,0,40,40,40,1,1,1,31,31,31,36,36,36,35,35,35/             ! Tx5 73

! iaptype Hound off, MyCall is standard, DXCall is not empty and is nonstandard
!------------------------
!   0         cycle
!   1         CQ     ???    ???            (29+3=32 ap bits)
!   2         MyCall ???    ???            (29+3=32 ap bits)
!   11        MyCall <DxCall> ???          (58 ap bits) REPORT/RREPORT
!   12       <MyCall> DxCall RRR           (77 ap bits)
!   13       <MyCall> DxCall 73            (77 ap bits)
!   14       <MyCall> DxCall RR73          (77 ap bits)
!   31        CQ  DxCall                   (77 ap bits) ! full compound or just nonstandard callsign
!   35        ??? DxCall 73                (64 ap bits) ! full compound or just nonstandard callsign
!   36        ??? DxCall RR73              (64 ap bits) ! full compound or just nonstandard callsign

! ndxnsaptypes(nQSOProgress, extra decoding pass)
!  data ndxnsaptypes(0,1:27)/0,0,0,0,0,0,0,0,0,0,0,0,2,2,2,1,1,1,31,31,31,36,36,36,35,35,35/             ! Tx6 CQ
!  data ndxnsaptypes(1,1:27)/11,11,11,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,31,31,31,36,36,36,35,35,35/          ! Tx1 Grid
!  data ndxnsaptypes(2,1:27)/11,11,11,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,31,31,31,36,36,36,35,35,35/          ! Tx2 Report
!  data ndxnsaptypes(3,1:27)/11,11,11,14,14,14,13,13,13,12,12,12,0,0,0,0,0,0,31,31,31,36,36,36,35,35,35/ ! Tx3 RRreport
!  data ndxnsaptypes(4,1:27)/11,11,11,14,14,14,13,13,13,12,12,12,2,2,2,0,0,0,31,31,31,36,36,36,35,35,35/ ! Tx4 RRR,RR73
!  data ndxnsaptypes(5,1:27)/0,0,0,0,0,0,0,0,0,0,0,0,2,2,2,1,1,1,31,31,31,36,36,36,35,35,35/             ! Tx5 73

! iaptype Hound mode
!------------------------
!    0        cycle
!    1        CQ     ???    ???            (29+3=32 ap bits) standard callsign
!   21        MyBaseCall DxBaseCall ???    (58+3=61 ap bits) Report
!   22        ??? RR73; MyCall <???> ???   (28+6=34 ap bits)
!   23        MyBaseCall DxBaseCall RR73   (77 ap bits)
!   24        MyCall RR73; ??? <???> ???   (28+6=34 ap bits)
!   31        CQ  DxCall (DXGrid)          (77 ap bits) ! standard/full compound or just nonstandard callsign
!   36        ??? DxCall RR73              (29+19/64 ap bits) ! standard/ full compound or just nonstandard callsign
!  111        CQ     ???                   (3 last i3 bits) type 4 message with nonstandard callsign

! nhaptypes(nQSOProgress, extra decoding pass)
!  data nhaptypes(0,1:27)/0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,111,111,111/       ! Tx6 CQ, possible in idle mode if DXCall is empty
!  data nhaptypes(1,1:27)/21,21,21,22,22,22,0,0,0,0,0,0,0,0,0,31,31,31,0,0,0,36,36,36,0,0,0/ ! Tx1 Grid idle mode or transmitting
!  data nhaptypes(2,1:27)/0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0/             ! Tx2 none
!  data nhaptypes(3,1:27)/21,21,21,22,22,22,23,23,23,24,24,24,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0/ ! Tx3 RRreport QSO in progress or QSO is finished
!  data nhaptypes(4,1:27)/0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0/             ! Tx4 none
!  data nhaptypes(5,1:27)/0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0/             ! Tx5 none

      loutapwid=.false.; loutapwid=abs(f1-nfqso).gt.napwid .and. abs(f1-nftx).gt.napwid
      scqnr=2.; smycnr=2.

      do isubp2=1,31
        if(isubp2.lt.5) then
          if(lapcqonly .or. lskipnotap) cycle
          if(ltxing) then ! enabled Tx and transmitted message including CQ at last interval
            if(abs(f1-nfqso).lt.3.0) then ! +- 3Hz sync8 QSOfreq candidate list
              if(syncavemax.lt.1.8) cycle
            else
              if(syncavemax.lt.1.9) cycle
            endif
          else
            if(syncavemax.lt.1.8) cycle
          endif
        endif
        if(.not.swl .and. isubp2.eq.4) cycle
        if(isubp1.gt.2 .and. isubp2.lt.5) cycle ! skip regular decoding for extra subpasses
        if(lqsocandave) then
          if(isubp1.gt.2 .and. isubp1.lt.9) cycle ! skip other extra subpasses if QSO signal, highest priority
          if(lqsomsgdcd) cycle
        else if(lmycsignal .and. lmycallstd) then
          if(isubp1.gt.2 .and. isubp1.lt.6) cycle ! skip CQ signal extra subpasses if MyCall signal
        endif

        if(isubp2.lt.5) then
          apmask=0; iaptype=0
          if(isubp2.eq.1) then
            if(.not.swl .and. ipass.eq.1) then; llrz=llrd; else; llrz=llra; endif
            if(isubp1.gt.1 .and. ipass.gt.1) llrz=llrd
          else if(isubp2.eq.2) then; llrz=llrb; if(isubp1.gt.1) llrz=llra
          else if(isubp2.eq.3) then; llrz=llrc
          else if(isubp2.eq.4) then; llrz=llrd
          endif
        else
          if(.not.lhound) then
            if(lmycallstd .and. (lhiscallstd .or. lnohiscall)) then
              iaptype=naptypes(nQSOProgress,isubp2-4); if(iaptype.eq.0) cycle
              if(lqsomsgdcd .and. iaptype.gt.2 .and. iaptype.lt.31) cycle ! QSO message already decoded
              if(iaptype.eq.2) then
                if(.not.lapmyc .or. lapcqonly) cycle ! skip AP for 'mycall ???? ????' in 2..3 minutes after last TX
                if(nQSOProgress.ne.0 .and. nmic.lt.2) cycle ! reduce CPU load at QSO
              endif
              if(.not.stophint .and. iaptype.gt.30) cycle ! no DXCall searching at QSO, reduce Lag
              if(stophint .and. iaptype.gt.2 .and. iaptype.lt.31) cycle
              if(lft8sdec .and. iaptype.gt.2) cycle ! QSO message already decoded
              if(iaptype.gt.2 .and. lnohiscall) cycle ! no DXCall
              if(iaptype.gt.2 .and. iaptype.lt.31 .and. loutapwid) cycle
              if(iaptype.eq.3 .and. .not.lqsosigtype3) cycle ! not QSO signal
              if(iaptype.eq.4 .and. .not.lqsorrr) cycle ! not RRR signal
              if(iaptype.eq.5 .and. .not.lqso73) cycle ! not 73 signal
              if(iaptype.eq.6 .and. .not.lqsorr73) cycle ! not RR73 signal
              if(iaptype.gt.30 .and. .not.lenabledxcsearch) cycle ! in QSO or TXing CQ or last logged is DX Call: searching disabled
              if(iaptype.gt.30 .and. .not.lwidedxcsearch .and. loutapwid) cycle ! only RX freq DX Call searching
              if(iaptype.eq.31 .and. .not.lcqdxcsig) cycle ! not CQ signal from std DXCall
              if(iaptype.eq.31 .and. .not.lhiscallstd .and. lapcqonly) cycle ! skip weak CQ signals with std call
              if(iaptype.gt.31 .and. lapcqonly) cycle ! skip weak CQ signals
              if(iaptype.eq.35 .and. .not.lqso73) cycle ! DXCall searching, not 73 signal
              if(iaptype.eq.36 .and. .not.lqsorr73) cycle ! DXCall searching, not RR73 signal
              if(lqsocandave .and. isubp1.gt.8 .and. (iaptype.lt.3 .or. iaptype.gt.6)) cycle ! QSO signal
              if(.not.lqsocandave .and. lmycsignal .and. isubp1.gt.5 .and. isubp1.lt.9 .and. iaptype.ne.2) cycle ! skip other AP if lmycsignal extra subpasses)

              if(iaptype.eq.1) then
                if(.not.swl .and. isubp2.eq.20) then
                  scqlev=0.; do i4=1,9; scqlev=scqlev+s8(idtone25(2,i4),i4+7); enddo
                  snoiselev=(sum(s8(0:7,8:16))-scqlev)/7.0; scqnr=scqlev/snoiselev
                  if(scqnr.lt.1.0 .and. .not.lcqsignal) cycle
                endif
                if(isubp2.eq.21) then
                  if(.not.swl .and. (lft8lowth .or. lft8subpass)) then
                    if(scqnr.lt.1.2 .and. .not.lcqsignal) cycle
                  endif
                  if(.not.swl .and. .not. lft8subpass .and. .not.lft8lowth) then
                    if(scqnr.lt.1.3 .and. .not.lcqsignal) cycle
                  endif
                endif
              endif

              if(iaptype.eq.2) then
                if(.not.swl .and. isubp2.eq.17) then
                  smyclev=0.; do i4=1,9; smyclev=smyclev+s8(idtonemyc(i4),i4+7); enddo
                  snoiselev=(sum(s8(0:7,8:16))-smyclev)/7.0; smycnr=smyclev/snoiselev
                  if(smycnr.lt.1.0 .and. .not.lmycsignal) cycle
                endif
                if(isubp2.eq.18) then
                  if(.not.swl .and. (lft8lowth .or. lft8subpass)) then
                    if(smycnr.lt.1.2 .and. .not.lmycsignal) cycle
                  endif
                endif
              endif

              if(iaptype.eq.3) then
                if(isubp2.eq.5) then
                  smyclev=0.; do i4=1,9; smyclev=smyclev+s8(idtonemyc(i4),i4+7); enddo
                  snoiselev=(sum(s8(0:7,8:16))-smyclev)/7.0; smycnr=smyclev/snoiselev
                  if(smycnr.lt.1.0) cycle
                else if(isubp2.eq.6) then
                  if(smycnr.lt.1.2) cycle
                endif
              endif

              apmask=0
              if(iaptype.eq.1) then ! CQ
                if(isubp2.eq.20) then; llrz=llrc
                else if(isubp2.eq.21) then; llrz=llrb
                else if(isubp2.eq.22) then; llrz=llra
                endif
                apmask(1:29)=1; llrz(1:29)=apmag*mcq(1:29); apmask(75:77)=1; llrz(75:76)=apmag*(-1); llrz(77)=apmag*(+1)
              else if(iaptype.eq.2) then ! MyCall ??? ???
                if(isubp2.eq.17) then; llrz=llrc
                else if(isubp2.eq.18) then; llrz=llrb
                else if(isubp2.eq.19) then; llrz=llra
                endif
                apmask(1:29)=1; llrz(1:29)=apmag*apsym(1:29); apmask(75:77)=1; llrz(75:76)=apmag*(-1); llrz(77)=apmag*(+1)
              else if(iaptype.eq.3) then ! MyCall DxCall ???
                if(isubp2.eq.5) then; llrz=llrc
                else if(isubp2.eq.6) then; llrz=llrb
                else if(isubp2.eq.7) then; llrz=llra
                endif
                apmask(1:58)=1; llrz(1:58)=apmag*apsym; apmask(75:77)=1; llrz(75:76)=apmag*(-1); llrz(77)=apmag*(+1)
              else if(iaptype.gt.3 .and. iaptype.lt.7) then
                if(isubp2.eq.8 .or. isubp2.eq.11 .or. isubp2.eq.14) then; llrz=llrc
                else if(isubp2.eq.9 .or. isubp2.eq.12 .or. isubp2.eq.15) then; llrz=llrb
                else if(isubp2.eq.10 .or. isubp2.eq.13 .or. isubp2.eq.16) then; llrz=llrb
                endif
                apmask(1:77)=1; llrz(1:58)=apmag*apsym ! mycall hiscall 73|RR73
                if(iaptype.eq.5) then; llrz(59:77)=apmag*m73
                else if(iaptype.eq.6) then; llrz(59:77)=apmag*mrr73
                else if(iaptype.eq.4) then; llrz(59:77)=apmag*mrrr
                endif
              else if(iaptype.eq.31) then ! CQ DxCall Grid(???)
                if(isubp2.eq.23) then; llrz=llrc
                else if(isubp2.eq.24) then; llrz=llrb
                else if(isubp2.eq.25) then; llrz=llra
                endif
                if(lnohisgrid) then
                  apmask(1:58)=1; llrz(1:58)=apmag*apcqsym(1:58); apmask(75:77)=1; llrz(75:76)=apmag*(-1); llrz(77)=apmag*(+1)
                else
                  apmask(1:77)=1; llrz(1:77)=apmag*apcqsym
                endif
              else if(iaptype.eq.35) then ! ??? DxCall 73, type 1 std DXCall
                if(isubp2.eq.29) then; llrz=llrc
                else if(isubp2.eq.30) then; llrz=llrb
                else if(isubp2.eq.31) then; llrz=llra
                endif
                apmask(30:77)=1; llrz(30:58)=apmag*apsym(30:58); llrz(59:77)=apmag*m73
              else if(iaptype.eq.36) then ! ??? DxCall RR73 type 1 std DXCall
                if(isubp2.eq.26) then; llrz=llrc
                else if(isubp2.eq.27) then; llrz=llrb
                else if(isubp2.eq.28) then; llrz=llra
                endif
                apmask(30:77)=1; llrz(30:58)=apmag*apsym(30:58); llrz(59:77)=apmag*mrr73
              endif

            else if(lmycallstd .and. .not.lhiscallstd .and. len_trim(hiscall).gt.2) then
              iaptype=ndxnsaptypes(nQSOProgress,isubp2-4); if(iaptype.eq.0) cycle
              if(iaptype.eq.2 .and. lapcqonly) cycle ! skip weak CQ signals
              if(.not.stophint .and. iaptype.gt.30) cycle ! no DXCall searching at QSO, reduce Lag
              if((lqsomsgdcd .or. .not.lapmyc) .and. iaptype.gt.1 .and. iaptype.lt.15) cycle ! skip AP for mycall in 2..3 minutes after last TX
              if(iaptype.eq.12 .and. .not.lqsorrr) cycle ! not RRR signal
              if(iaptype.eq.13 .and. .not.lqso73) cycle ! not 73 signal
              if(iaptype.eq.14 .and. .not.lqsorr73) cycle ! not RR73 signal
              if(iaptype.gt.30 .and. .not.lenabledxcsearch) cycle ! in QSO or TXing CQ or last logged is DX Call: searching disabled
              if(iaptype.gt.30 .and. .not.lwidedxcsearch .and. loutapwid) cycle ! only RX freq DX Call searching
              if(iaptype.gt.30 .and. lapcqonly) cycle ! skip weak CQ signals
              if(iaptype.eq.31 .and. .not.lcqdxcnssig) cycle ! it is not CQ signal of non-standard DXCall
              if(iaptype.eq.35 .and. .not.lqso73) cycle ! DXCall searching, not 73 signal
              if(iaptype.eq.36 .and. .not.lqsorr73) cycle ! DXCall searching, not RR73 signal
              if(lqsocandave .and. isubp1.gt.8 .and. (iaptype.lt.11 .or. iaptype.gt.14)) cycle ! QSO signal
              if(iaptype.gt.2 .and. iaptype.lt.15 .and. loutapwid) cycle

              if(iaptype.eq.1) then
                if(.not.swl .and. isubp2.eq.20) then
                  scqlev=0.; do i4=1,9; scqlev=scqlev+s8(idtone25(2,i4),i4+7); enddo
                  snoiselev=(sum(s8(0:7,8:16))-scqlev)/7.0; scqnr=scqlev/snoiselev
                  if(scqnr.lt.1.0 .and. .not.lcqsignal) cycle
                endif
                if(isubp2.eq.21) then
                  if(.not.swl .and. (lft8lowth .or. lft8subpass)) then
                    if(scqnr.lt.1.2 .and. .not.lcqsignal) cycle
                  endif
                  if(.not.swl .and. .not. lft8subpass .and. .not.lft8lowth) then
                    if(scqnr.lt.1.3 .and. .not.lcqsignal) cycle
                  endif
                endif
              endif

              if(iaptype.eq.2) then
                if(.not.swl .and. isubp2.eq.17) then
                  smyclev=0.; do i4=1,9; smyclev=smyclev+s8(idtonemyc(i4),i4+7); enddo
                  snoiselev=(sum(s8(0:7,8:16))-smyclev)/7.0; smycnr=smyclev/snoiselev
                  if(smycnr.lt.1.0 .and. .not.lmycsignal) cycle
                endif
                if(isubp2.eq.18) then
                  if(.not.swl .and. (lft8lowth .or. lft8subpass)) then
                    if(smycnr.lt.1.2 .and. .not.lmycsignal) cycle
                  endif
                endif
              endif

              apmask=0
              if(iaptype.eq.1) then ! CQ ??? ???
                if(isubp2.eq.20) then; llrz=llrc
                else if(isubp2.eq.21) then; llrz=llrb
                else if(isubp2.eq.22) then; llrz=llra
                endif
                apmask(1:29)=1; llrz(1:29)=apmag*mcq(1:29); apmask(75:77)=1; llrz(75:76)=apmag*(-1); llrz(77)=apmag*(+1)
              else if(iaptype.eq.2) then ! MyCall ??? ???
                if(isubp2.eq.17) then; llrz=llrc
                else if(isubp2.eq.18) then; llrz=llrb
                else if(isubp2.eq.19) then; llrz=llra
                endif
                apmask(1:29)=1; llrz(1:29)=apmag*apsym(1:29); apmask(75:77)=1; llrz(75:76)=apmag*(-1); llrz(77)=apmag*(+1)
              else if(iaptype.eq.11) then ! MyCall <DxCall> ???  ! report rreport type 1 msg
                if(isubp2.eq.5) then; llrz=llrc
                else if(isubp2.eq.6) then; llrz=llrb
                else if(isubp2.eq.7) then; llrz=llra
                endif
                apmask(1:58)=1; llrz(1:58)=apmag*apsymdxns1; apmask(75:77)=1; llrz(75:76)=apmag*(-1); llrz(77)=apmag*(+1)
              else if(iaptype.eq.12) then  ! type 4 <MyCall> DxCall RRR
                if(isubp2.eq.14) then; llrz=llrc
                else if(isubp2.eq.15) then; llrz=llrb
                else if(isubp2.eq.16) then; llrz=llra
                endif
                apmask(1:77)=1; llrz(1:77)=apmag*apsymdxnsrrr
              else if(iaptype.eq.13) then  ! type 4 <MyCall> DxCall 73
                if(isubp2.eq.11) then; llrz=llrc
                else if(isubp2.eq.12) then; llrz=llrb
                else if(isubp2.eq.13) then; llrz=llra
                endif
                apmask(1:77)=1; llrz(1:77)=apmag*apsymdxns732
              else if(iaptype.eq.14) then  ! type 4 <MyCall> DxCall RR73
                if(isubp2.eq.8) then; llrz=llrc
                else if(isubp2.eq.9) then; llrz=llrb
                else if(isubp2.eq.10) then; llrz=llra
                endif
                apmask(1:77)=1; llrz(1:77)=apmag*apsymdxnsr73
              else if(iaptype.eq.31) then ! CQ  DxCall ! full compound or nonstandard
                if(isubp2.eq.23) then; llrz=llrc
                else if(isubp2.eq.24) then; llrz=llrb
                else if(isubp2.eq.25) then; llrz=llra
                endif
                apmask(1:77)=1; llrz(1:77)=apmag*apcqsym
              else if(iaptype.eq.35) then ! ??? DxCall 73 ! full compound or nonstandard
                if(isubp2.eq.29) then; llrz=llrc
                else if(isubp2.eq.30) then; llrz=llrb
                else if(isubp2.eq.31) then; llrz=llra
                endif
                apmask(14:77)=1; llrz(14:77)=apmag*apsymdxns73(14:77)
              else if(iaptype.eq.36) then ! ??? DxCall RR73 ! full compound or nonstandard
                if(isubp2.eq.26) then; llrz=llrc
                else if(isubp2.eq.27) then; llrz=llrb
                else if(isubp2.eq.28) then; llrz=llra
                endif
                apmask(14:77)=1; llrz(14:77)=apmag*apsymdxnsrr73(14:77)
              endif

            else if(.not.lmycallstd .and. .not.lhiscallstd .and. len_trim(hiscall).gt.2) then ! empty mycall or compound/nonstandard both calls
              iaptype=ndxnsaptypes(nQSOProgress,isubp2-4); if(iaptype.eq.0) cycle
              if(iaptype.gt.1 .and. iaptype.lt.31) cycle
              if(.not.stophint .and. iaptype.gt.1) cycle ! on air, QSO is not possible
              if(iaptype.gt.30 .and. lapcqonly) cycle ! skip weak CQ signals with std call
              if(iaptype.eq.31 .and. .not.lcqdxcnssig) cycle ! it is not CQ signal of non-standard DXCall
              if(iaptype.gt.34 .and. .not.ldxcsig) cycle ! not DXCall signal

              if(iaptype.eq.1) then
                if(.not.swl .and. isubp2.eq.20) then
                  scqlev=0.; do i4=1,9; scqlev=scqlev+s8(idtone25(2,i4),i4+7); enddo
                  snoiselev=(sum(s8(0:7,8:16))-scqlev)/7.0; scqnr=scqlev/snoiselev
                  if(scqnr.lt.1.0 .and. .not.lcqsignal) cycle
                endif
                if(isubp2.eq.21) then
                  if(.not.swl .and. (lft8lowth .or. lft8subpass)) then
                    if(scqnr.lt.1.2 .and. .not.lcqsignal) cycle
                  endif
                  if(.not.swl .and. .not. lft8subpass .and. .not.lft8lowth) then
                    if(scqnr.lt.1.3 .and. .not.lcqsignal) cycle
                  endif
                endif
              endif

              apmask=0
              if(iaptype.eq.1) then ! CQ ??? ???
                if(isubp2.eq.20) then; llrz=llrc
                else if(isubp2.eq.21) then; llrz=llrb
                else if(isubp2.eq.22) then; llrz=llra
                endif
                apmask(1:29)=1; llrz(1:29)=apmag*mcq(1:29); apmask(75:77)=1; llrz(75:76)=apmag*(-1)
                llrz(77)=apmag*(+1)
! nonstandard DXCall search masks below are for monitoring purpose in idle mode, QSO is not possible
! wideband searching being used by default
              else if(iaptype.eq.31) then ! CQ  DxCall ! full compound or nonstandard
                if(isubp2.eq.23) then; llrz=llrc
                else if(isubp2.eq.24) then; llrz=llrb
                else if(isubp2.eq.25) then; llrz=llra
                endif
                apmask(1:77)=1; llrz(1:77)=apmag*apcqsym
              else if(iaptype.eq.35) then ! ??? DxCall 73 ! full compound or nonstandard
                if(isubp2.eq.29) then; llrz=llrc
                else if(isubp2.eq.30) then; llrz=llrb
                else if(isubp2.eq.31) then; llrz=llra
                endif
                apmask(14:77)=1; llrz(14:77)=apmag*apsymdxns73(14:77)
              else if(iaptype.eq.36) then ! ??? DxCall RR73 ! full compound or nonstandard
                if(isubp2.eq.26) then; llrz=llrc
                else if(isubp2.eq.27) then; llrz=llrb
                else if(isubp2.eq.28) then; llrz=llra
                endif
                apmask(14:77)=1; llrz(14:77)=apmag*apsymdxnsrr73(14:77)
              endif

            else if(.not.lmycallstd .and. (lhiscallstd .or. lnohiscall)) then
              iaptype=nmycnsaptypes(nQSOProgress,isubp2-4); if(iaptype.eq.0) cycle
              if(isubp1.eq.2 .and. nweak.eq.1) cycle
              if(isubp1.gt.5) cycle ! so far CQ averaging only
              if(iaptype.eq.40 .and. lapcqonly) cycle ! skip weak CQ signals
              if(iaptype.gt.40 .and. iaptype.lt.45 .and. lqsomsgdcd) cycle ! already decoded
              if(iaptype.eq.42 .and. .not.lqsorrr) cycle ! not RRR signal
              if(iaptype.eq.43 .and. .not.lqso73) cycle ! not 73 signal
              if(iaptype.eq.44 .and. .not.lqsorr73) cycle ! not RR73 signal
              if(iaptype.gt.39 .and. .not.lapmyc) cycle
              if(lnomycall .and. iaptype.gt.39 .and. iaptype.lt.45) cycle ! skip QSO signals if mycall is empty
              if(lnohiscall .and. iaptype.ne.1 .and. iaptype.ne.40) cycle ! skip DXCall masks if empty
              if(iaptype.gt.30 .and. iaptype.lt.40 .and. .not.stophint) cycle ! in QSO, reduce number of CPU cycles
              if(iaptype.eq.31 .and. .not.lcqdxcsig) cycle ! not CQ signal from std DXCall
              if(iaptype.gt.34 .and. iaptype.lt.37 .and. (.not.ldxcsig .or. lapcqonly)) cycle ! not DXCall signal, skip weak CQ signals
              if(iaptype.gt.30 .and. iaptype.lt.40 .and. .not.lwidedxcsearch .and. loutapwid) cycle ! if wideband DX search disabled

              apmask=0
              if(lcqsignal .and. iaptype.eq.1) then ! CQ ??? ???
                if(isubp2.eq.20) then; llrz=llrc
                else if(isubp2.eq.21) then; llrz=llrb
                else if(isubp2.eq.22) then; llrz=llra
                endif
                apmask(1:29)=1; llrz(1:29)=apmag*mcq(1:29); apmask(75:77)=1; llrz(75:76)=apmag*(-1)
                llrz(77)=apmag*(+1)
              else if(iaptype.eq.31) then ! CQ DxCall Grid(???) //std DX call type1 with or without grid
                if(isubp2.eq.23) then; llrz=llrc
                else if(isubp2.eq.24) then; llrz=llrb
                else if(isubp2.eq.25) then; llrz=llra
                endif
                if(lnohisgrid) then
                  apmask(1:58)=1; llrz(1:58)=apmag*apcqsym(1:58); apmask(75:77)=1; llrz(75:76)=apmag*(-1); llrz(77)=apmag*(+1)
                else
                  apmask(1:77)=1; llrz(1:77)=apmag*apcqsym
                endif
              else if(iaptype.eq.35) then ! ??? DxCall 73 //std DX call
                if(isubp2.eq.29) then; llrz=llrc
                else if(isubp2.eq.30) then; llrz=llrb
                else if(isubp2.eq.31) then; llrz=llra
                endif
                apmask(30:77)=1; llrz(30:58)=apmag*apsymdxstd(30:58); llrz(59:77)=apmag*m73
              else if(iaptype.eq.36) then ! ??? DxCall RR73 //std DX call
                if(isubp2.eq.26) then; llrz=llrc
                else if(isubp2.eq.27) then; llrz=llrb
                else if(isubp2.eq.28) then; llrz=llra
                endif
                apmask(30:77)=1; llrz(30:58)=apmag*apsymdxstd(30:58); llrz(59:77)=apmag*mrr73
              else if(iaptype.eq.40) then ! <MyCall>,???,??? type 1
                if(isubp2.eq.17) then; llrz=llrc
                else if(isubp2.eq.18) then; llrz=llrb
                else if(isubp2.eq.19) then; llrz=llra
                endif
                apmask(1:29)=1; llrz(1:29)=apmag*apsymmyns1(1:29); apmask(75:77)=1; llrz(75:76)=apmag*(-1); llrz(77)=apmag*(+1)
              else if(iaptype.eq.41) then ! <MyCall>,DXCall,??? type 1
                if(isubp2.eq.5) then; llrz=llrc
                else if(isubp2.eq.6) then; llrz=llrb
                else if(isubp2.eq.7) then; llrz=llra
                endif
                apmask(1:58)=1; llrz(1:58)=apmag*apsymmyns2; apmask(75:77)=1; llrz(75:76)=apmag*(-1); llrz(77)=apmag*(+1)
              else if(iaptype.eq.42) then ! MyCall,<DXCall>,RRR type 4
                if(isubp2.eq.14) then; llrz=llrc
                else if(isubp2.eq.15) then; llrz=llrb
                else if(isubp2.eq.16) then; llrz=llra
                endif
                apmask(1:77)=1; llrz(1:77)=apmag*apsymmynsrrr
              else if(iaptype.eq.43) then ! MyCall,<DXCall>,73 type 4
                if(isubp2.eq.11) then; llrz=llrc
                else if(isubp2.eq.12) then; llrz=llrb
                else if(isubp2.eq.13) then; llrz=llra
                endif
                apmask(1:77)=1; llrz(1:77)=apmag*apsymmyns73
              else if(iaptype.eq.44) then ! MyCall,<DXCall>,RR73 type 4
                if(isubp2.eq.8) then; llrz=llrc
                else if(isubp2.eq.9) then; llrz=llrb
                else if(isubp2.eq.10) then; llrz=llra
                endif
                apmask(1:77)=1; llrz(1:77)=apmag*apsymmynsrr73
              endif
            else; cycle ! fallback
            endif

          else if(lhound) then
            iaptype=nhaptypes(nQSOProgress,isubp2-4); if(iaptype.eq.0) cycle
            if(lnomycall .and. iaptype.gt.1 .and. iaptype.lt.31) cycle ! skip AP if mycall is missed in config
            if(lhiscallstd .and. iaptype.eq.31 .and. .not.lcqsignal) cycle ! not CQ signal, skip CQ DXCall DXgrid mask
            if(lqsomsgdcd .and. iaptype.gt.0 .and. iaptype.lt.25) cycle ! QSO message already decoded
            if(.not.stophint .and. (iaptype.eq.31 .or. iaptype.eq.36)) cycle ! CQ and RR73 decoding not needed if TX is on
            if(nQSOProgress.eq.1) then
              if(lfoxspecrpt) then
                if(iaptype.eq.21) cycle ! it is not standard message report signal
                if((iaptype.eq.31 .or. iaptype.eq.36) .and. nfoxspecrpt.gt.3) cycle ! probably special message signal
              else
                if(iaptype.eq.22) cycle ! it is not special message report signal
                if((iaptype.eq.31 .or. iaptype.eq.36) .and. nmic.gt.3) cycle ! probably standard message signal with mybcall
              endif
            endif
            if(nQSOProgress.eq.3) then
              if(lfoxspecrpt) then
                if(iaptype.eq.21) cycle ! it is not standard message report signal
              else
                if(iaptype.eq.22) cycle ! it is not special message report signal
              endif
              if(lfoxstdr73) then
                if(iaptype.eq.24) cycle ! it is not special message RR73 signal
              else
                if(iaptype.eq.23) cycle ! it is not standard message RR73 signal
              endif
            endif
! can be staying in queue, need to process possible incoming report iaptype 21/22 even if TX is switched off
            if(.not.lapmyc .and. (iaptype.eq.23 .or. iaptype.eq.24)) cycle ! skip AP for mycall RR73 in 2..3 minutes after last TX
            fdelta=abs(f1-nfqso); fdeltam=modulo(fdelta,60.) ! dupe string to prevent compiler warning
            if(nQSOProgress.gt.0 .and. iaptype.lt.31 .and. (fdelta.gt.245.0 .or. fdeltam.gt.3.0)) cycle ! AP shall be applied to Fox frequencies only
            if((iaptype.eq.31 .or. iaptype.eq.36) .and. .not.lwidedxcsearch .and. (fdelta.gt.245.0 .or. fdeltam.gt.3.0)) cycle ! only Fox frequencies DX Call searching
            if(iaptype.eq.31 .and. .not.lhiscallstd .and. lapcqonly) cycle ! skip weak CQ signals with std call
            if(iaptype.eq.36 .and. lwidedxcsearch .and. lapcqonly) cycle ! skip weak CQ signals
            if(iaptype.eq.111 .and. lapcqonly) cycle ! skip weak CQ signals with std call

            apmask=0
            if(iaptype.eq.1) then ! CQ ??? ??? type 1 msg
              if(isubp2.eq.20) then; llrz=llrc
              else if(isubp2.eq.21) then; llrz=llrb
              else if(isubp2.eq.22) then; llrz=llra
              endif
              apmask(1:29)=1; llrz(1:29)=apmag*mcq(1:29); apmask(75:77)=1; llrz(75:76)=apmag*(-1)
              llrz(77)=apmag*(+1)
            else if(iaptype.eq.21) then ! MyBaseCall DxBaseCall ???  ! report
              if(isubp2.eq.5) then; llrz=llrc
              else if(isubp2.eq.6) then; llrz=llrb
              else if(isubp2.eq.7) then; llrz=llra
              endif
              apmask(1:58)=1; llrz(1:58)=apmag*apsym; apmask(75:77)=1; llrz(75:76)=apmag*(-1); llrz(77)=apmag*(+1)
            else if(iaptype.eq.22) then ! ??? RR73; MyCall <???> ??? ! report
              if(isubp2.eq.8) then; llrz=llrc
              else if(isubp2.eq.9) then; llrz=llrb
              else if(isubp2.eq.10) then; llrz=llra
              endif
              apmask(29:66)=1; llrz(29:66)=apmag*apsymsp(29:66); apmask(72:77)=1; llrz(72:73)=apmag*(-1)
              llrz(74)=apmag*(+1); llrz(75:77)=apmag*(-1)
            else if(iaptype.eq.23) then ! MyBaseCall DxBaseCall RR73
              if(isubp2.eq.11) then; llrz=llrc
              else if(isubp2.eq.12) then; llrz=llrb
              else if(isubp2.eq.13) then; llrz=llra
              endif
              apmask(1:77)=1; llrz(1:58)=apmag*apsym; llrz(59:77)=apmag*mrr73
            else if(iaptype.eq.24) then ! MyCall RR73; ??? <???> ???
              if(isubp2.eq.14) then; llrz=llrc
              else if(isubp2.eq.15) then; llrz=llrb
              else if(isubp2.eq.16) then; llrz=llra
              endif
              apmask(1:28)=1; apmask(57:66)=1; llrz(1:28)=apmag*apsymsp(1:28); llrz(57:66)=apmag*apsymsp(57:66)
              apmask(72:77)=1; llrz(72:73)=apmag*(-1); llrz(74)=apmag*(+1); llrz(75:77)=apmag*(-1)
            else if(iaptype.eq.31) then ! CQ  DxCall Grid(???)
              if(isubp2.eq.23) then; llrz=llrc
              else if(isubp2.eq.24) then; llrz=llrb
              else if(isubp2.eq.25) then; llrz=llra
              endif
              if(lhiscallstd) then
                if(lnohisgrid) then
                  apmask(1:58)=1; llrz(1:58)=apmag*apcqsym(1:58); apmask(75:77)=1; llrz(75:76)=apmag*(-1); llrz(77)=apmag*(+1)
                else
                  apmask(1:77)=1; llrz(1:77)=apmag*apcqsym
                endif
              else
                apmask(1:77)=1; llrz(1:77)=apmag*apcqsym
              endif
            else if(iaptype.eq.36) then
              if(isubp2.eq.26) then; llrz=llrc
              else if(isubp2.eq.27) then; llrz=llrb
              else if(isubp2.eq.28) then; llrz=llra
              endif
              if(lhiscallstd .or. (.not.lhiscallstd .and. len_trim(hiscall).gt.2 .and. index(hiscall,"/").gt.0)) then
                apmask(30:77)=1; llrz(30:58)=apmag*apsym(30:58); llrz(59:77)=apmag*mrr73 ! ??? DxBaseCall RR73
              else
                cycle ! (noncompound .and. nonstandard) Fox callsign being not supported by Fox WSJT-X
              endif
            else if(iaptype.eq.111) then ! CQ ??? type 4 msg (iflip,nrpt,icq,i3 001100)
              if(isubp2.eq.29) then; llrz=llrc
              else if(isubp2.eq.30) then; llrz=llrb
              else if(isubp2.eq.31) then; llrz=llra
              endif
              apmask(72:77)=1; llrz(72:73)=apmag*(-1); llrz(74:75)=apmag*(1); llrz(76:77)=apmag*(-1)
            endif
          else; cycle ! fallback
          endif
        endif

        cw=0
!        call timer('bpd174_91 ',0)
        call bpdecode174_91(llrz,apmask,max_iterations,message77,cw,nharderrors,  &
             niterations)
!        call timer('bpd174_91 ',1)
        dmin=0.0
        if(nharderrors.lt.0) then
          ndeep=3
          if(lqsosig .or. lmycsignal) then
            if((dfqso.lt.napwid .or. (abs(nftx-f1).lt.napwid .and. lapmyc)) .and. .not.nagainfil) ndeep=4
            if(lapmyc .and. lqsomsgdcd .or. iaptype.eq.0) ndeep=3 ! deep is not needed, reduce number of CPU cycles
            if(.not.stophint .and. len_trim(hiscall).gt.2) ndeep=3 ! unload CPU, let ft8s pick up QSO message
          endif
          if(ldxcsig .and. stophint .and. dfqso.lt.napwid) ndeep=4 ! DXCall search inside RX napwid
          if(lhound) ndeep=3 ! we have no enough CPU resources to decode all Fox slots with ndeep=4
!          if(nagainfil .or. swl) ndeep=5 ! 30 against 26 -23dB, more than 15sec to decode and many false decodes
!          if(swl) ndeep=4 ! 29 decodes -23dB, 7..12sec to decode
          if(nagainfil) ndeep=5
!print *,omp_get_nested(),OMP_get_num_threads()
!          call timer('osd174_91 ',0)
          call osd174_91(llrz,apmask,ndeep,message77,cw,nharderrors,dmin,nthr)
!          call timer('osd174_91 ',1)
        endif
        nbadcrc=1; msg37=''
        if(count(cw.eq.0).eq.174) cycle           !Reject the all-zero codeword
        if(nharderrors.lt.0 .or. nharderrors+dmin.ge.60.0 .or. (isubp2.gt.2 .and. nharderrors.gt.39)) then ! chk isubp2 value
          if(nweak.eq.2 .and. isubp1.eq.2) then
            if(ipass.eq.npass-1) then
              if(lcqsignal) then
                if(isubp2.eq.22) then ! last pass, std and nonstd mycall
                  lfoundcq=.false.
                  do ik=1,numdeccq
                    if(tmpcqdec(ik)%freq.gt.5001.0) exit
                    if(abs(tmpcqdec(ik)%freq-f1).lt.5.0 .and. abs(tmpcqdec(ik)%xdt-xdt).lt.0.05) then ! max signal delay
                      lfoundcq=.true.; exit
                    endif
                  enddo
                  if(.not.lfoundcq .and. ncqsignal.lt.numcqsig) then
                    ncqsignal=ncqsignal+1
                    tmpcqsig(ncqsignal)%freq=f1; tmpcqsig(ncqsignal)%xdt=xdt
                    tmpcqsig(ncqsignal)%cs=cstmp2
                  endif
                endif
              endif
              if(lmycsignal .and. isubp2.eq.19) then ! last pass
                lfoundmyc=.false.
                do ik=1,numdecmyc
                  if(tmpmyc(ik)%freq.gt.5001.0) exit
                  if(abs(tmpmyc(ik)%freq-f1).lt.5.0 .and. abs(tmpmyc(ik)%xdt-xdt).lt.0.05) then ! max signal delay
                    lfoundmyc=.true.; exit
                  endif
                enddo
                if(.not.lfoundmyc .and. nmycsignal.lt.nummycsig) then
                  nmycsignal=nmycsignal+1
                  tmpmycsig(nmycsignal)%freq=f1; tmpmycsig(nmycsignal)%xdt=xdt
                  tmpmycsig(nmycsignal)%cs=cstmp2
                endif
              endif
            endif
            if(ipass.eq.npass) then
              if(lqsocandave .and. (iaptype.eq.3 .or. iaptype.eq.6)) then
                tmpqsosig(1)%freq=f1; tmpqsosig(1)%xdt=xdt; tmpqsosig(1)%cs=cstmp2
              endif
            endif
          endif

          if(isubp1.gt.1) cycle

          if(lqsothread .and. (.not.lhound .and. iaptype.ge.3 .or. lhound .and. (iaptype.eq.21 .or. iaptype.eq.23)) &
             .and. .not.lsdone) then
            if(.not.lqsomsgdcd .and. .not.(.not.lmycallstd .and. .not.lhiscallstd)) then
              if(.not.lft8sdec .and. .not.stophint .and. dfqso.lt.2.0) then
                call ft8s(s8,srr,itone,msg37,lft8s,nft8rxfsens,stophint)
                if(lft8s) then
                  if(index(msg37,'<').gt.0) then; lhashmsg=.true.; call delbraces(msg37); endif
                  nbadcrc=0; lft8sdec=.true.
                endif
              endif
            endif
            lsdone=.true.
          endif
          if(nbadcrc.eq.0) then; i3=1; n3=1; exit; endif

          if(lsd .and. isubp2.eq.3 .and. nbadcrc.eq.1 .and. srr.lt.7.0) then ! low DR setups shall not try FT8SD for strong signals
            call ft8sd(s8,srr,itone,msgd,msg37,lft8sd,lcq)
            if(lft8sd) then
              if(levenint) then; evencopy(isd)%lstate=.false.
              elseif(loddint) then; oddcopy(isd)%lstate=.false.
              endif
              i3=1; n3=1; iaptype=0; nbadcrc=0; lsd=.false.; exit
            endif
          endif

          if(nweak.eq.1 .and. isubp1.eq.1) then
            if(ipass.eq.npass-1) then
              if(lcqsignal) then
                if(isubp2.eq.22) then ! last pass, std and nonstd mycall
                  lfoundcq=.false.
                  do ik=1,numdeccq
                    if(tmpcqdec(ik)%freq.gt.5001.0) exit
                    if(abs(tmpcqdec(ik)%freq-f1).lt.5.0 .and. abs(tmpcqdec(ik)%xdt-xdt).lt.0.05) then ! max signal delay
                      lfoundcq=.true.; exit
                    endif
                  enddo
                  if(.not.lfoundcq .and. ncqsignal.lt.numcqsig) then
                    ncqsignal=ncqsignal+1
                    tmpcqsig(ncqsignal)%freq=f1; tmpcqsig(ncqsignal)%xdt=xdt
                    tmpcqsig(ncqsignal)%cs=cstmp2
                  endif
                endif
              endif
              if(lmycsignal .and. isubp2.eq.19) then ! last pass
                lfoundmyc=.false.
                do ik=1,numdecmyc
                  if(tmpmyc(ik)%freq.gt.5001.0) exit
                  if(abs(tmpmyc(ik)%freq-f1).lt.5.0 .and. abs(tmpmyc(ik)%xdt-xdt).lt.0.05) then ! max signal delay
                    lfoundmyc=.true.; exit
                  endif
                enddo
                if(.not.lfoundmyc .and. nmycsignal.lt.nummycsig) then
                  nmycsignal=nmycsignal+1
                  tmpmycsig(nmycsignal)%freq=f1; tmpmycsig(nmycsignal)%xdt=xdt
                  tmpmycsig(nmycsignal)%cs=cstmp2
                endif
              endif
            endif
            if(ipass.eq.npass) then
              if(lqsocandave .and. (iaptype.eq.3 .or. iaptype.eq.6)) then
                tmpqsosig(1)%freq=f1; tmpqsosig(1)%xdt=xdt; tmpqsosig(1)%cs=cstmp2
              endif
            endif
          endif

          if(nbadcrc.eq.1) cycle
        endif

        write(c77,'(77i1)') message77
        read(c77(72:74),'(b3)') n3
        read(c77(75:77),'(b3)') i3
        if(i3.gt.4 .or. (i3.eq.0 .and. n3.gt.5)) cycle
!print *,i3,n3,iaptype
        call unpack77(c77,1,msg37,unpk77_success,nthr)
        if(.not.unpk77_success) then
          if(lqsothread .and. (.not.lhound .and. iaptype.ge.3 .or. lhound .and. &
             (iaptype.eq.21 .or. iaptype.eq.23)) .and. .not.lsdone) then
            if(.not.lqsomsgdcd .and. .not.(.not.lmycallstd .and. .not.lhiscallstd)) then
              if(.not.lft8sdec .and. .not.stophint .and. dfqso.lt.2.0) then
                call ft8s(s8,srr,itone,msg37,lft8s,nft8rxfsens,stophint)
                if(lft8s) then
                  if(index(msg37,'<').gt.0) then; lhashmsg=.true.; call delbraces(msg37); endif
                  nbadcrc=0; lft8sdec=.true.
                endif
              endif
            endif
            lsdone=.true.
            if(nbadcrc.eq.0) then; i3=1; n3=1; exit; endif
          endif
          cycle
        endif
        if(iaptype.eq.1 .and. msg37(1:10).eq.'CQ DE AA00') then; nbadcrc=1; cycle; endif
        lcall1hash=.false.; if(msg37(1:1).eq.'<') lcall1hash=.true.
        nbadcrc=0  ! If we get this far: valid codeword, valid (i3,n3), nonquirky message.
        call get_tones_from_77bits(message77,itone)

! 0.1  K1ABC RR73; W9XYZ <KH1/KH7Z> -11   28 28 10 5       71   DXpedition Mode
        i3bit=0; if(i3.eq.0 .and. n3.eq.1) i3bit=1
!        iFreeText=message77(57)
! 0.0  Free text
        if(i3.eq.0 .and. n3.eq.0) then; lFreeText=.true.; else; lFreeText=.false.; endif
! delete braces
        lcall2hash=.false.
        if(.not.lFreeText .and. i3bit.ne.1 .and. index(msg37,'<').gt.0) then
          if(index(msg37,'<').gt.4) lcall2hash=.true.
          if(index(msg37,'<').gt.0) then; lhashmsg=.true.; call delbraces(msg37); endif
        endif
!print *,msg37
        if(nbadcrc.eq.0) exit
      enddo ! ap passes
      if(nbadcrc.eq.0) exit
    enddo ! weak sigs
    if(nbadcrc.eq.0) exit
  enddo !nqso sync

2 if(nbadcrc.eq.0) then
! check for the false FT8S decode
    if(lft8s .and. lrepliedother) then; msg37=''; nbadcrc=1; return; endif
    msg37_2=''
    if(i3bit.eq.1 .and. .not.lft8s .and. .not.lft8sd) then
      call msgparser(msg37,msg37_2); lspecial=.true.
!protection against a false FT8S decode in Hound mode 
      if(lhound .and. dfqso.lt.2.0) lqsomsgdcd=.true.; !$OMP FLUSH (lqsomsgdcd)
    endif
    qual=1.0-(nharderrors+dmin)/60.0
    xsnr=0.001; xnoi=1.E-8
    xsnrtmp=0.001
    do i=1,79
      xsig=s8(itone(i),i)**2
      xnoi=(sum(s8(0:7,i)**2) - xsig)/7.0
      if(xnoi.lt.0.01) xnoi=0.01 ! safe division and better accuracy
      if(xnoi.lt.xsig) then; xsnr=xsig/xnoi; else; xsnr=1.01; endif
      xsnrtmp=xsnrtmp+xsnr
    enddo
!print *,xsig,xnoi
    xsnr=xsnrtmp/79.0-1.0
    xsnr=10.0*log10(xsnr)-26.5
    if(xsnr.gt.7.0) xsnr=xsnr+(xsnr-7.0)/2.0
    if(xsnr.gt.30.0) then; xsnr=xsnr-1.0; if(xsnr.gt.40.0) xsnr=xsnr-1.0; if(xsnr.gt.49.0) xsnr=49.0; endif 
    xsnrs=xsnr
    if(xsnr .lt. -17.0) then
      if(xsnr.lt.-22.5 .and. xsnr.gt.-23.5) xsnr=-22.5 ! safe division and better accuracy
      xsnr=xsnr-(1.0+1.4/(23.0+xsnr))**2+1.2
    endif
    if(iaptype.eq.0) then; if(xsnr.lt.-23.0) xsnr=-23.0; else; if(xsnr.lt.-24.0) xsnr=-24.0; endif
    if(lft8s .or. lft8sd) then
      if(xsnr.lt.-22.0) xsnr=xsnrs-1.0 ! correction offset
      if(xsnr.lt.-26.0) xsnr=-26.0;
! -26  0.1 1477 ~ AC1MX AC1MX R-17          ^
      if(len_trim(mycall).gt.3 .and. index(msg37,' '//trim(mycall)//' ').gt.1) then; msg37=''; return; endif 
      go to 4 ! bypass checking to false decode
    endif
!print *,qual,msg37
    rxdt=xdt-0.5
    if(iaptype.gt.34 .and. iaptype.lt.40) then ! DX Call searching false iaptype 35,36: 'CS7CYU/R FO5QB 73', 'T57KWP/R FO5QB RR73'
      ispc1=index(msg37,' ')
      if(ispc1.gt.5) then
        if(msg37((ispc1-2):(ispc1-1)).eq.'/R') then ! have to cascade it to prevent getting out of index range
          call_a=''; call_a=msg37(1:(ispc1-3))
          lfound=.false.
          call searchcalls(call_a,"            ",lfound)
          if(.not.lfound) then; nbadcrc=1; msg37=''; return; endif
        endif
      endif
    else if(qual.lt.0.39 .or. xsnr.lt.-20.5 .or. rxdt.lt.-0.5 .or. rxdt.gt.1.9 .or. (iaptype.gt.0 .and. iaptype.lt.4) .or. &
            iaptype.eq.11 .or. iaptype.eq.21 .or. iaptype.eq.40 .or. iaptype.eq.41) then
      if(iaptype.gt.3 .and. iaptype.lt.7) go to 4 ! skip, nothing to check
      if(iaptype.ne.2 .and. iaptype.ne.3 .and. iaptype.ne.11 .and. iaptype.ne.21 &
            .and. iaptype.ne.40 .and. iaptype.ne.41) then
        if((mybcall.ne."            " .and. index(msg37,mybcall).gt.0) .or. &
           (hisbcall.ne."            " .and. index(msg37,hisbcall).gt.0)) go to 256
      endif
      if(i3bit.eq.1) then; call chkspecial8(msg37,msg37_2,nbadcrc)
      else; call chkfalse8(msg37,i3,n3,nbadcrc,iaptype,lcall1hash)
      endif
      if(nbadcrc.eq.1) then; msg37=''; return; endif
    endif
    if(iaptype.eq.2 .or. iaptype.eq.3 .or. iaptype.eq.11 .or. iaptype.eq.21 .or. iaptype.eq.40 .or. iaptype.eq.41) go to 4 ! already checked

! decoded without AP masks:
! CQ PLIB U40OKH FE61
! CQ 000 RO8JSV GJ38
256 if(iaptype.eq.0 .and. i3.eq.1 .and. msg37(1:3).eq.'CQ ') then
      ispc1=index(msg37,' '); ispc2=index(msg37((ispc1+1):),' ')+ispc1
      if((ispc2-ispc1).eq.4 .or. (ispc2-ispc1).eq.5) then
        ispc3=index(msg37((ispc2+1):),' ')+ispc2; ispc4=index(msg37((ispc3+1):),' ')+ispc3
        if((ispc3-ispc2).gt.3 .and. (ispc4-ispc3).eq.5) then
          grid=''
          if(msg37(ispc3+1:ispc3+1).gt.'@' .and. msg37(ispc3+1:ispc3+1).lt.'S' .and. &
             msg37(ispc3+2:ispc3+2).gt.'@' .and. msg37(ispc3+2:ispc3+2).lt.'S' .and. &
             msg37(ispc3+3:ispc3+3).lt.':' .and. msg37(ispc3+4:ispc3+4).lt.':') grid=msg37(ispc3+1:ispc4-1)
          if(grid.ne.'') then
            callsign=''; callsign=msg37(ispc2+1:ispc3-1)
            call chkgrid(callsign,grid,lchkcall,lgvalid,lwrongcall)
            if(lwrongcall .or. .not.lgvalid) then; nbadcrc=1; msg37=''; return; endif
          endif
        endif
      endif
    endif

! i3=1,2 false decodes with ' R '
! 3B4NDC/R C40AUZ/R R IR83  i3=1
! MS8QQS UX3QBS/P R NG63  i3=2
! <...> P32WRF R LR56
! P32WRF <...> R LR56
    if((i3.eq.1 .or. i3.eq.2) .and. index(msg37,' R ').gt.0) then
      ispc1=index(msg37,' '); ispc2=index(msg37((ispc1+1):),' ')+ispc1; ispc3=index(msg37((ispc2+1):),' ')+ispc2
      if(ispc3-ispc2.eq.2) then
        if(msg37(ispc2:ispc3).eq.' R ') then
          call_b=''
          if((i3.eq.1 .and. msg37(ispc2-2:ispc2-1).eq.'/R') .or. (i3.eq.2 .and. msg37(ispc2-2:ispc2-1).eq.'/P')) then
            call_b=msg37(ispc1+1:ispc2-3)
          else
            call_b=msg37(ispc1+1:ispc2-1)
          endif
          if(lcall2hash) then ! valid call_b can be found in hash table, check call_a then
            call_a=''
            if((i3.eq.1 .and. msg37(ispc1-2:ispc1-1).eq.'/R') .or. (i3.eq.2 .and. msg37(ispc1-2:ispc1-1).eq.'/R')) then
              call_a=msg37(1:ispc1-3)
            else
              call_a=msg37(1:ispc1-1)
            endif
            falsedec=.false.; call chkflscall('CQ          ',call_a,falsedec)
            if(falsedec) then; nbadcrc=1; msg37=''; return; endif
          else if(len_trim(call_b).gt.2) then
            ispc4=index(msg37((ispc3+1):),' ')+ispc3; grid=''
            if(ispc4-ispc3.eq.5 .and. msg37(ispc3+1:ispc3+1).gt.'@' .and. msg37(ispc3+1:ispc3+1).lt.'S' .and. &
               msg37(ispc3+2:ispc3+2).gt.'@' .and. msg37(ispc3+2:ispc3+2).lt.'S' .and. &
               msg37(ispc3+3:ispc3+3).lt.':' .and. msg37(ispc3+4:ispc3+4).lt.':') grid=msg37(ispc3+1:ispc4-1)
            if(grid.ne.'') then
              call chkgrid(call_b,grid,lchkcall,lgvalid,lwrongcall)
              if(lwrongcall .or. .not.lgvalid) then; nbadcrc=1; msg37=''; return; endif
            endif
          endif
        endif
      endif
    endif

! 0.3   WA9XYZ KA1ABC R 16A EMA            28 28 1 4 3 7    71   ARRL Field Day
! 0.4   WA9XYZ KA1ABC R 32A EMA            28 28 1 4 3 7    71   ARRL Field Day
! -23  3.1  197 ~ Z67BGE H67HJI 22G EMA i3=0 n3=4
!  -3  2.2 FY4IML UV7BEA R 24F NNJ   i3=0 n3=4
    if(i3.eq.0 .and. n3.gt.2 .and. n3.lt.5) then
      ispc1=index(msg37,' '); ispc2=index(msg37((ispc1+1):),' ')+ispc1
      if(ispc1.gt.3 .and. ispc2.gt.7) then
        call_a=''; call_b=''
        if(msg37(1:ispc1-1).eq.'/R' .or. msg37(1:ispc1-1).eq.'/P') then; call_a=msg37(1:ispc1-3)
        else; call_a=msg37(1:ispc1-1)
        endif
        if(msg37(ispc1+1:ispc2-1).eq.'/R' .or. msg37(ispc1+1:ispc2-1).eq.'/P') then; call_b=msg37(ispc1+1:ispc2-3)
        else; call_b=msg37(ispc1+1:ispc2-1)
        endif
! operators outside USA and Canada shall transmit ' DX '
        if(call_b(1:1).ne.'A' .and. call_b(1:1).ne.'K' .and. call_b(1:1).ne.'N' .and. &
          call_b(1:1).ne.'W' .and. call_b(1:1).ne.'V' .and. call_b(1:1).ne.'C' .and. call_b(1:1).ne.'X') then
            if(index(msg37,' DX ').lt.1) then; nbadcrc=1; msg37=''; return; endif
        endif
! USA AA..AL
        if(call_b(1:1).eq.'A' .and. (call_b(2:2).lt.'A' .or. call_b(2:2).gt.'L')) then
            if(index(msg37,' DX ').lt.1) then; nbadcrc=1; msg37=''; return; endif
        endif
! Canada CF..CK,CY,CZ,VA..VG,VO,VX,VY,XJ..XO
        if(call_b(1:1).eq.'C' .and. (call_b(2:2).lt.'F' .or. call_b(2:2).gt.'K')) then
          if(call_b(2:2).ne.'Y' .and. call_b(2:2).ne.'Z') then
            if(index(msg37,' DX ').lt.1) then; nbadcrc=1; msg37=''; return; endif
          endif
        endif
        if(call_b(1:1).eq.'V' .and. (call_b(2:2).lt.'A' .or. call_b(2:2).gt.'G')) then
          if(call_b(2:2).ne.'O' .and. call_b(2:2).ne.'X' .and. call_b(2:2).ne.'Y') then
            if(index(msg37,' DX ').lt.1) then; nbadcrc=1; msg37=''; return; endif
          endif
        endif
        if(call_b(1:1).eq.'X' .and. (call_b(2:2).lt.'J' .or. call_b(2:2).gt.'O')) then
          if(index(msg37,' DX ').lt.1) then; nbadcrc=1; msg37=''; return; endif
        endif
        if(xsnr.lt.-19.0 .or. rxdt.lt.-0.5 .or. rxdt.gt.1.0) then
          falsedec=.false.; call chkflscall(call_a,call_b,falsedec)
          if(falsedec) then; nbadcrc=1; msg37=''; return; endif
        endif
      endif
    endif

! EU VHF contest exchange i3=5
! <PA3XYZ> <G4ABC/P> R 590003 IO91NP      h12 h22 r1 s3 S11 g25
! packing is not implemented in WSJT-X 2.5.4?
! old implementation with i3=0 n3=2
! JL6GSC/P R 571553 CJ76MV i3=5
! G59XTB R 521562 RA82SJ
!    if(i3.eq.0 .and. n3.eq.2 .and. (xsnr.lt.-19.0 .or. rxdt.lt.-0.5 .or. rxdt.gt.1.0)) then
!      ispc1=index(msg37,' ')
!      if(ispc1.gt.3) then
!        call_b=''
!        if(msg37(ispc1-2:ispc1-1).eq.'/P') then; call_b=msg37(1:ispc1-3)
!        else; call_b=msg37(1:ispc1-1)
!        endif
!        falsedec=.false.; call chkflscall('CQ          ',call_b,falsedec)
!        if(falsedec) then; nbadcrc=1; msg37=''; return; endif
!      endif
!    endif

! FT8OPG/R Z27HRN/R OH12 check all standard messages with contest callsigns
! /P has i3.eq.2 .and. n3.eq.0
    if(iaptype.eq.0 .and. i3.eq.1 .and. n3.eq.0 .and. index(msg37,'/R ').gt.3) then
      ispc1=index(msg37,' '); ispc2=index(msg37((ispc1+1):),' ')+ispc1
      if(ispc1.gt.3 .and. ispc2.gt.6) then
        call_a=''; call_b=''
        if(msg37(ispc1-2:ispc1-1).eq.'/R') then; call_a=msg37(1:ispc1-3); else; call_a=msg37(1:ispc1-1); endif
        if(msg37(ispc2-2:ispc2-1).eq.'/R') then; call_b=msg37(ispc1+1:ispc2-3); else; call_b=msg37(ispc1+1:ispc2-1); endif
        falsedec=.false.; call chkflscall(call_a,call_b,falsedec)
        if(falsedec) then; nbadcrc=1; msg37=''; return; endif
      endif
    endif

! -23 -0.5 2533 ~ <...> W LKNQZG2K4 RR73  invalid message, iaptype=0 this type of message is not allowed for transmission with RR73   
! -23 -1.2 1335 ~ <...> Z7VENB8R G9 RRR   non AP decode, iaptype=0 invalid message, this type of message is not allowed 
! for transmission with RRR   
    if(msg37(1:2).eq.'<.') then
      ispc1=index(msg37,' '); ispc2=index(msg37((ispc1+1):),' ')+ispc1; ispc3=index(msg37((ispc2+1):),' ')+ispc2
      ispc4=index(msg37((ispc3+1):),' ')+ispc3
      if((ispc4-ispc3.eq.4 .and. msg37(ispc3+1:ispc4-1).eq.'RRR') .or. &
         (ispc4-ispc3.eq.5 .and. msg37(ispc3+1:ispc4-1).eq.'RR73') .or. &
         (ispc4-ispc3.eq.3 .and. msg37(ispc3+1:ispc4-1).eq.'73')) then; nbadcrc=1; msg37=''; return; endif
! -19 0.0 2256 ~ <...> 9T4DQZ RP53  non AP decode, iaptype=0 i3=1 n3=1  SAME AS CQ MSG
! <...> 9T4DQZ -15(R-15) message has i3=1 n3=4
      if(i3.eq.1 .and. n3.eq.1 .and. (xsnr.lt.-18.0 .or. rxdt.lt.-0.5 .or. rxdt.gt.1.0)) then
        callsign='            '; callsign=msg37(ispc1+1:ispc2-1); grid=msg37(ispc2+1:ispc3-1)
        include 'callsign_q.f90'
        call chkgrid(callsign,grid,lchkcall,lgvalid,lwrongcall)
        if(lwrongcall) then; nbadcrc=1; msg37=''; return; endif
        if(lchkcall .or. .not.lgvalid) then
          falsedec=.false.
          call chkflscall('CQ          ',callsign,falsedec)
          if(falsedec) then; nbadcrc=1; msg37=''; return; endif
        endif
      endif
    endif

! -22  0.3 1000 ~ 9Y4DWY <...> BF70  iaptype=0 i3=1 n3=2  invalid message in FT8 protocol, can be transmitted manually
    if(i3.eq.1) then
      ispc1=index(msg37,' ')
      if(msg37(ispc1+1:ispc1+2).eq.'<.') then
        ispc2=index(msg37((ispc1+1):),' ')+ispc1
        ispc3=index(msg37((ispc2+1):),' ')+ispc2
        if(ispc3-ispc2.eq.5 .and. msg37(ispc2+1:ispc2+1).gt.'@' .and. msg37(ispc2+1:ispc2+1).lt.'S' .and. &
           msg37(ispc2+2:ispc2+2).gt.'@' .and. msg37(ispc2+2:ispc2+2).lt.'S' .and. &
           msg37(ispc2+3:ispc2+3).lt.':' .and. msg37(ispc2+4:ispc2+4).lt.':') then ! there is a valid grid in message
          call_b=''; call_b=msg37(1:ispc1-1)
          falsedec=.false.; call chkflscall('CQ          ',call_b,falsedec)
          if(falsedec) then; nbadcrc=1; msg37=''; return; endif
        endif
      endif
    endif

! i3=3 parse ARRL RTTY contest message
! i3 n3                                      Bits               Total  Message type
! 3     TU; W9XYZ K1ABC R 579 MA             1 28 28 1 3 13       74   ARRL RTTY contest
! 3     TU; W9XYZ G8ABC R 559 0013           1 28 28 1 3 13       74   ARRL RTTY (DX)
! TU; D47IAQ <...> 559 032' does protocol support the message?
    if(i3.eq.3 .and. msg37(1:3).eq.'TU;') then
      ispc1=index(msg37,' '); ispc2=index(msg37((ispc1+1):),' ')+ispc1 
      ispc3=index(msg37((ispc2+1):),' ')+ispc2
      call_a=''; call_b=''; call_a=msg37(ispc1+1:ispc2-1); call_b=msg37(ispc2+1:ispc3-1)
! check for false, too tough, need to rework if contest is supported
      falsedec=.false.
      call chkflscall(call_a,call_b,falsedec)
      if(falsedec) then; nbadcrc=1; msg37=''; return; endif
! parse
      lspecial=.true.
      msg37_2=msg37(5:37)//'    '
      msg37=''; msg37='DE '//trim(call_b)//' TU'
    endif

! DX Call searching false decodes, search for 1st callsign in ALLCALL7
! 6W6VIV EY8MM 73
! 6Y9KOZ EY8MM RR73
    if(iaptype.gt.34 .and. iaptype.lt.40 .and. (xsnr.lt.-21.0 .or. rxdt.lt.-0.5 .or. rxdt.gt.1.0)) then
      ispc1=index(msg37,' ')
      if(ispc1.gt.1) then
        call_b=''; call_b=msg37(1:ispc1-1)
        falsedec=.false.; call chkflscall('CQ          ',call_b,falsedec)
        if(falsedec) then; nbadcrc=1; msg37=''; return; endif
      endif
    endif

4   ldupemsg=.false.
    if(ndecodes.gt.0) then
      do i=1,ndecodes; if(allmessages(i).eq.msg37 .and. abs(allfreq(i)-f1).lt.45.0) ldupemsg=.true.; enddo
    endif

    if(.not.ldupemsg .and. dfqso.lt.2.0 .and. ((i3.eq.1 .and. .not.lft8s) .or. lft8s)) then
      if(msg37(1:msgrootlen+1).eq.trim(msgroot)//' ') then
        lasthcall=hiscall; lastrxmsg(1)%lastmsg=msg37; lastrxmsg(1)%xdt=xdt-0.5; lastrxmsg(1)%lstate=.true.
        lqsomsgdcd=.true.
!$OMP FLUSH (lqsomsgdcd)
      else if(.not.lft8s .and. mycalllen1.gt.2) then
        if(msg37(1:mycalllen1).ne.trim(mycall)//' ' .and. index(msg37,' '//trim(hiscall)//' ').gt.0) then
          lrepliedother=.true.
        endif
      endif
    endif
    if(len_trim(hiscall).gt.3 .and. .not.lqsomsgdcd) then
      if(msg37(1:msgrootlen+1).eq.trim(msgroot)//' ') then
      lqsomsgdcd=.true.
!$OMP FLUSH (lqsomsgdcd)
      endif
    endif
    if(.not.stophint .and. .not.ldupemsg .and. dfqso.lt.2.0 .and. nlasttx.gt.0 .and. &
       nlasttx.lt.6 .and. msg37(1:3).eq.'CQ ') then
      nlength=len_trim(hiscall)
      if(nlength.gt.2) then
        if(msg37(4:4+nlength).eq.trim(hiscall)//' ' .or. msg37(7:7+nlength).eq.trim(hiscall)//' ') lrepliedother=.true.
      endif
    endif

    if(mycalllen1.gt.2) then
      if(.not.ldupemsg .and. msg37(1:mycalllen1).eq.trim(mycall)//' ') then
        nincallthr(nthr)=nincallthr(nthr)+1
        nindex=maskincallthr(nthr)+nincallthr(nthr)
        if(nindex.lt.maskincallthr(nthr+1)) then
          msgincall(nindex)=msg37
          xdtincall(nindex)=xdt-0.5
        else
          nincallthr(nthr)=nincallthr(nthr)-1
        endif
      endif
    endif

    ldupeft8sd=.false.
    if(ncount.gt.0 .and. lft8sd) then
      ispc1=index(msg37,' '); ispc2=index(msg37((ispc1+1):),' ')+ispc1
      msgbase37=''; msgbase37=msg37(1:ispc2-1)
      do i=1,ncount
        if(trim(msgbase37).eq.trim(msgsrcvd(i))) then; ldupeft8sd=.true.; exit; endif
      enddo
    endif
    if(ldupeft8sd) then; msg37=''; nbadcrc=1; return; endif

    if(.not.ldupemsg .and. i3.eq.1 .and. .not.lft8sd .and. .not.lft8s .and. msg37(1:3).ne.'CQ ') then
      ispc1=index(msg37,' '); ispc2=index(msg37((ispc1+1):),' ')+ispc1
      ncount=ncount+1
      msgsrcvd(ncount)=msg37(1:ispc2-1)
    endif

! -23  0.0 1606 ~ <...> 3U1TBM/R CC65 i3=4 n3=0
! -18  0.3 1609 ~ CQ 6U6MBL/R IJ90 i3=1  in some noisy setups false decode with any SNR value is possible
    if((i3.eq.4 .and. n3.eq.0) .or. (i3.eq.1 .and. msg37(1:3).eq."CQ ")) then
      if(index(msg37,'/R ').gt.9) then
        ispc1=index(msg37,' '); ispc2=index(msg37((ispc1+1):),' ')+ispc1
        if(ispc2.gt.11) then
          ispc3=index(msg37((ispc2+1):),' ')+ispc2
          if(msg37((ispc2-2):(ispc2-1)).eq.'/R') then
            if((ispc3-ispc2).eq.5) then
              grid=msg37(ispc2+1:ispc3-1)
! grid can not be txed, invalid message:
              if(i3.eq.4 .and. len_trim(grid).eq.4) then; nbadcrc=1; msg37=''; return; endif
              call_b=''; call_b=msg37((ispc1+1):(ispc2-3))
              call chkgrid(call_b,grid,lchkcall,lgvalid,lwrongcall)
              if(lwrongcall .or. .not.lgvalid) then; nbadcrc=1; msg37=''; return; endif
            endif
          endif
        endif
      endif
    endif

!print *,'iaptype',iaptype
!print *,i3,msg37

! protocol violations
! 713STG 869TK NO05  i3=2 n3=5, false decode, as per protocol type2 shall be /P message
    if(i3.eq.2 .and. index(msg37,'/P ').lt.1) then; msg37=''; nbadcrc=1; return; endif
! -18  0.5  584 ~ UA3ALE <...> PR07         *  AP decode with grid
    if(iaptype.eq.2) then
      nhash=index(msg37,"<...>")
      if(nhash.gt.4 .and. nhash.lt.13 .and. msg37(nhash+6:nhash+6).gt.'@' .and. msg37(nhash+7:nhash+7).gt.'@') then
        msg37=''; nbadcrc=1; return
      endif
    endif

!    if(lsubtract .and. .not.ldupemsg) then
    if(lsubtract) then
      noff=10; sync0=0.; syncp=0.; syncm=0.; k=1
      call gen_ft8wave(itone,79,1920,2.0,12000.0,0.0,csig0,xjunk,1,151680)
      do i=0,78
        do j=1,32
          csig(j)=csig0(k)
          k=k+60
        enddo
        i21=i0+i*32; z1=0.; z1=sum(cd0(i21:i21+31)*conjg(csig)); sync0 = sync0 + real(z1)**2 + aimag(z1)**2
        i21=i0+i*32+noff; z1=0.; z1=sum(cd0(i21:i21+31)*conjg(csig)); syncp = syncp + real(z1)**2 + aimag(z1)**2
        i21=i21-noff*2; z1=0.; z1=sum(cd0(i21:i21+31)*conjg(csig)); syncm = syncm + real(z1)**2 + aimag(z1)**2
      enddo
      call peakup(syncm,sync0,syncp,dx)
      if(abs(dx).gt.1.0) then; scorr=0.; else; scorr=real(noff)*dx; endif
      xdt3=xdt+scorr*dt2
      call subtractft8(itone,f1,xdt3,swl)
      lsubtracted=.true. ! inside current thread
      if(npos.lt.200) then; npos=npos+1; freqsub(npos)=f1; endif
    endif

    if(lhidehash .and. index(msg37,'<...>').gt.6) then; nbadcrc=1; msg37=''; msg37_2=''; endif

!if(nbadcrc.eq.0 .and. iaptype.ge.2 .and. iaptype.le.3) then
!write (*,"(I1.1,1x,I1.1,1x,F5.3,38x,A1)") iaptype,iFreeText,qual,'d'
!flush(6)
!endif

  endif

  return
end subroutine ft8b

subroutine normalizebmet(bmet,n)
  real bmet(n)

!  bmetav=sum(bmet)/real(n)
  bmet2av=sum(bmet*bmet)/real(n)
!  var=bmet2av-bmetav*bmetav
!  if( var .gt. 0.0 ) then
!     bmetsig=sqrt(var)
!  else
     bmetsig=sqrt(bmet2av)
!  endif
  bmet=bmet/bmetsig
  return
end subroutine normalizebmet

subroutine timefft_opts(npatience,nthreads,linplace,lcomplex,nfft,    &
     problem,nflags)

  use FFTW3

  logical linplace,lcomplex
  character problem*9,arg*12

  nargs=iargc()
  if(nargs.lt.3) then
     print*,'Usage: timefft npatience maxthreads [[o|i][r|c]]nfft'
     print*,'       npatience  - 0 to 4'
     print*,'       maxthreads - suggest #CPUs or #CPUs-1'
     print*,'       o,i        - out-of-place or in-place (default=in-place)'
     print*,'       r,c        - real or complex (default=complex)'
     print*,' '
     print*,'Examples:'
     print*,'       timefft 1 1 32768     (1 thread, in-place, complex)'
     print*,'       timefft 2 3 or32768   (more patient, 3 threads,'
     print*,'                              out-of-place, real)'
     stop
  endif

  call getarg(1,arg)
  read(arg,*) npatience
  call getarg(2,arg)
  read(arg,*) nthreads
  call getarg(3,arg)
  linplace=arg(1:1).ne.'o' .and. arg(2:2).ne.'o'
  lcomplex=arg(1:1).ne.'r' .and. arg(2:2).ne.'r'
  k=3
  if(ichar(arg(2:2)).ge.48 .and. ichar(arg(2:2)).le.57) k=2
  if(ichar(arg(1:1)).ge.48 .and. ichar(arg(1:1)).le.57) k=1
  read(arg(k:),*) nfft

  write(problem,'(i9)') nfft
  problem='ic'//adjustl(problem)
  if(.not.linplace) problem(1:1)='o'
  if(.not.lcomplex) problem(2:2)='r'

  nflags=FFTW_ESTIMATE
  if(npatience.eq.1) nflags=FFTW_ESTIMATE_PATIENT
  if(npatience.eq.2) nflags=FFTW_MEASURE
  if(npatience.eq.3) nflags=FFTW_PATIENT
  if(npatience.eq.4) nflags=FFTW_EXHAUSTIVE

  return
end subroutine timefft_opts

C++++++++++++++++++++++++
C
      SUBROUTINE FSIZER1(NRECL,KSIZE,NRFILE,NAMFIL)
C
C++++++++++++++++++++++++
C
C   Version 1.0 uses the INQUIRE statement to find out the the record length 
C   of the direct access file before opening it.  This procedure is non-standard, 
C   but seems to work for VAX machines. 
C
C  THE SUBROUTINE ALSO SETS THE VALUES OF  NRECL, NRFILE, AND NAMFIL.

C  *****************************************************************
C  *****************************************************************
C
C  THE PARAMETERS NAMFIL, NRECL, AND NRFILE ARE TO BE SET BY THE USER
C
C  *****************************************************************

C  NAMFIL IS THE EXTERNAL NAME OF THE BINARY EPHEMERIS FILE

      CHARACTER*256  NAMFIL

c      NAMFIL='JPLEPH'

C  *****************************************************************

C  NRECL=1 IF "RECL" IN THE OPEN STATEMENT IS THE RECORD LENGTH IN S.P. WORDS
C  NRECL=4 IF "RECL" IN THE OPEN STATEMENT IS THE RECORD LENGTH IN BYTES
C  (for a VAX, it is probably 1)
C
      NRECL=4

C  *****************************************************************

C  NRFILE IS THE INTERNAL UNIT NUMBER USED FOR THE EPHEMERIS FILE

c      NRFILE=12

C  *****************************************************************

C   FIND THE RECORD SIZE USING THE INQUIRE STATEMENT  


c      IRECSZ=0

      INQUIRE(FILE=NAMFIL,RECL=IRECSZ)

C IF 'INQUIRE' DOES NOT WORK, USUALLY IRECSZ WILL BE LEFT AT 0 

      IF(IRECSZ .LE. 0) write(*,*)
     . ' INQUIRE STATEMENT PROBABLY DID NOT WORK'

      KSIZE=IRECSZ/NRECL
      if(nrfile.eq.-99) stop              !silence compiler warning

      RETURN

      END
C++++++++++++++++++++++++
C
      SUBROUTINE FSIZER2(NRECL,KSIZE,NRFILE,NAMFIL)
C
C++++++++++++++++++++++++
C  THIS SUBROUTINE OPENS THE FILE, 'NAMFIL', WITH A PHONY RECORD LENGTH, READS 
C  THE FIRST RECORD, AND USES THE INFO TO COMPUTE KSIZE, THE NUMBER OF SINGLE 
C  PRECISION WORDS IN A RECORD.  
C
C  THE SUBROUTINE ALSO SETS THE VALUES OF  NRECL, NRFILE, AND NAMFIL.

      IMPLICIT DOUBLE PRECISION(A-H,O-Z)

      SAVE

      INTEGER OLDMAX
      PARAMETER (OLDMAX = 400)
      INTEGER NMAX
      PARAMETER (NMAX = 1000)
      CHARACTER*6 TTL(14,3),CNAM(NMAX)
      CHARACTER*256 NAMFIL,jpleph_file_name
      DIMENSION SS(3)
      INTEGER IPT(3,13)
      common/jplcom/jpleph_file_name

C  *****************************************************************
C  *****************************************************************
C
C  THE PARAMETERS NRECL, NRFILE, AND NAMFIL ARE TO BE SET BY THE USER
C
C  *****************************************************************

C  NRECL=1 IF "RECL" IN THE OPEN STATEMENT IS THE RECORD LENGTH IN S.P. WORDS
C  NRECL=4 IF "RECL" IN THE OPEN STATEMENT IS THE RECORD LENGTH IN BYTES
C  (for UNIX, it is probably 4)
C
      NRECL=4

C  NRFILE IS THE INTERNAL UNIT NUMBER USED FOR THE EPHEMERIS FILE

      NRFILE=12

C  NAMFIL IS THE EXTERNAL NAME OF THE BINARY EPHEMERIS FILE

!      NAMFIL='JPLEPH' 
      NAMFIL=jpleph_file_name

C  *****************************************************************
C  *****************************************************************

C  **  OPEN THE DIRECT-ACCESS FILE AND GET THE POINTERS IN ORDER TO 
C  **  DETERMINE THE SIZE OF THE EPHEMERIS RECORD

      MRECL=NRECL*1000

        OPEN(NRFILE,
     *       FILE=NAMFIL,
     *       ACCESS='DIRECT',
     *       FORM='UNFORMATTED',
     *       RECL=MRECL,
     *       STATUS='OLD')

      READ(NRFILE,REC=1)TTL,(CNAM(K),K=1,OLDMAX),SS,NCON,AU,EMRAT,
     & ((IPT(I,J),I=1,3),J=1,12),NUMDE,(IPT(I,13),I=1,3)

      CLOSE(NRFILE)

C  FIND THE NUMBER OF EPHEMERIS COEFFICIENTS FROM THE POINTERS

      KMX = 0
      KHI = 0

      DO I = 1,13
         IF (IPT(1,I) .GT. KMX) THEN
            KMX = IPT(1,I)
            KHI = I
         ENDIF
      ENDDO

      ND = 3
      IF (KHI .EQ. 12) ND=2

      KSIZE = 2*(IPT(1,KHI)+ND*IPT(2,KHI)*IPT(3,KHI)-1)

      RETURN

      END
C++++++++++++++++++++++++
C
      SUBROUTINE FSIZER3(NRECL,KSIZE,NRFILE,NAMFIL)
C
C++++++++++++++++++++++++
C
C  THE SUBROUTINE SETS THE VALUES OF  NRECL, KSIZE, NRFILE, AND NAMFIL.

      SAVE
      CHARACTER*256 NAMFIL,jpleph_file_name
      common/jplcom/jpleph_file_name

C  *****************************************************************
C  *****************************************************************
C
C  THE PARAMETERS NRECL, NRFILE, AND NAMFIL ARE TO BE SET BY THE USER

C  *****************************************************************

C  NRECL=1 IF "RECL" IN THE OPEN STATEMENT IS THE RECORD LENGTH IN S.P. WORDS
C  NRECL=4 IF "RECL" IN THE OPEN STATEMENT IS THE RECORD LENGTH IN BYTES

       NRECL=4

C  *****************************************************************

C  NRFILE IS THE INTERNAL UNIT NUMBER USED FOR THE EPHEMERIS FILE (DEFAULT: 12)

      NRFILE=12

C  *****************************************************************

C  NAMFIL IS THE EXTERNAL NAME OF THE BINARY EPHEMERIS FILE

!      NAMFIL='JPLEPH'
      NAMFIL=jpleph_file_name

C  *****************************************************************

C  KSIZE must be set by the user according to the ephemeris to be read

C  For  de200, set KSIZE to 1652
C  For  de405, set KSIZE to 2036
C  For  de406, set KSIZE to 1456
C  For  de414, set KSIZE to 2036
C  For  de418, set KSIZE to 2036
C  For  de421, set KSIZE to 2036
C  For  de422, set KSIZE to 2036
C  For  de423, set KSIZE to 2036
C  For  de424, set KSIZE to 2036
C  For  de430, set KSIZE to 2036

      KSIZE = 2036

C  *******************************************************************

      RETURN

      END
C++++++++++++++++++++++++++
C
      SUBROUTINE PLEPH ( ET, NTARG, NCENT, RRD )
C
C++++++++++++++++++++++++++
C  NOTE : Over the years, different versions of PLEPH have had a fifth argument:
C  sometimes, an error return statement number; sometimes, a logical denoting
C  whether or not the requested date is covered by the ephemeris.  We apologize
C  for this inconsistency; in this present version, we use only the four necessary 
C  arguments and do the testing outside of the subroutine.
C
C     THIS SUBROUTINE READS THE JPL PLANETARY EPHEMERIS
C     AND GIVES THE POSITION AND VELOCITY OF THE POINT 'NTARG'
C     WITH RESPECT TO 'NCENT'.
C
C     CALLING SEQUENCE PARAMETERS:
C
C       ET = D.P. JULIAN EPHEMERIS DATE AT WHICH INTERPOLATION
C            IS WANTED.
C
C       ** NOTE THE ENTRY DPLEPH FOR A DOUBLY-DIMENSIONED TIME **
C          THE REASON FOR THIS OPTION IS DISCUSSED IN THE 
C          SUBROUTINE STATE
C
C     NTARG = INTEGER NUMBER OF 'TARGET' POINT.
C
C     NCENT = INTEGER NUMBER OF CENTER POINT.
C
C            THE NUMBERING CONVENTION FOR 'NTARG' AND 'NCENT' IS:
C
C                1 = MERCURY           8 = NEPTUNE
C                2 = VENUS             9 = PLUTO
C                3 = EARTH            10 = MOON
C                4 = MARS             11 = SUN
C                5 = JUPITER          12 = SOLAR-SYSTEM BARYCENTER
C                6 = SATURN           13 = EARTH-MOON BARYCENTER
C                7 = URANUS           14 = NUTATIONS (LONGITUDE AND OBLIQ)
C                            15 = LIBRATIONS, IF ON EPH FILE
C
C             (IF NUTATIONS ARE WANTED, SET NTARG = 14. FOR LIBRATIONS,
C              SET NTARG = 15. SET NCENT=0.)
C
C      RRD = OUTPUT 6-WORD D.P. ARRAY CONTAINING POSITION AND VELOCITY
C            OF POINT 'NTARG' RELATIVE TO 'NCENT'. THE UNITS ARE AU AND
C            AU/DAY. FOR LIBRATIONS THE UNITS ARE RADIANS AND RADIANS
C            PER DAY. IN THE CASE OF NUTATIONS THE FIRST FOUR WORDS OF
C            RRD WILL BE SET TO NUTATIONS AND RATES, HAVING UNITS OF
C            RADIANS AND RADIANS/DAY.
C
C            The option is available to have the units in km and km/sec.
C            For this, set km=.true. in the STCOMX common block.
C

      IMPLICIT DOUBLE PRECISION (A-H,O-Z)

      INTEGER NMAX
      PARAMETER (NMAX = 1000)

      DIMENSION RRD(6),ET2Z(2),ET2(2),PV(6,13)
      DIMENSION PVST(6,11),PNUT(4)
      DIMENSION SS(3),CVAL(NMAX),PVSUN(6),ZIPS(2)
      DATA ZIPS/2*0.d0/

      LOGICAL BSAVE,KM,BARY
      LOGICAL FIRST
      DATA FIRST/.TRUE./

      INTEGER LIST(12),IPT(39),DENUM
      COMMON/EPHHDR/CVAL,SS,AU,EMRAT,DENUM,NCON,IPT
      COMMON/STCOMX/KM,BARY,PVSUN

C     INITIALIZE ET2 FOR 'STATE' AND SET UP COMPONENT COUNT
C
      ET2(1)=ET
      ET2(2)=0.D0
      GO TO 11

C     ENTRY POINT 'DPLEPH' FOR DOUBLY-DIMENSIONED TIME ARGUMENT 
C          (SEE THE DISCUSSION IN THE SUBROUTINE STATE)

      ENTRY DPLEPH(ET2Z,NTARG,NCENT,RRD)

      ET2(1)=ET2Z(1)
      ET2(2)=ET2Z(2)

  11  IF(FIRST) CALL STATE(ZIPS,LIST,PVST,PNUT)
      FIRST=.FALSE.

      IF(NTARG .EQ. NCENT) RETURN

      DO I=1,12
        LIST(I)=0
      ENDDO

C     CHECK FOR NUTATION CALL

      IF(NTARG.NE.14) GO TO 97
        IF(IPT(35).GT.0) THEN
          LIST(11)=2
          CALL STATE(ET2,LIST,PVST,PNUT)
          DO I=1,4
            RRD(I)=PNUT(I)
          ENDDO
          RRD(5) = 0.d0
          RRD(6) = 0.d0
          RETURN
        ELSE
          DO I=1,4
            RRD(I)=0.d0
          ENDDO
          WRITE(6,297)
  297     FORMAT(' *****  NO NUTATIONS ON THE EPHEMERIS FILE  *****')
          STOP
        ENDIF

C     CHECK FOR LIBRATIONS

  97  CONTINUE
      DO I=1,6
        RRD(I)=0.d0
      ENDDO

      IF(NTARG.NE.15) GO TO 98
        IF(IPT(38).GT.0) THEN
          LIST(12)=2
          CALL STATE(ET2,LIST,PVST,PNUT)
          DO I=1,6
            RRD(I)=PVST(I,11)
          ENDDO
          RETURN
        ELSE
          WRITE(6,298)
  298     FORMAT(' *****  NO LIBRATIONS ON THE EPHEMERIS FILE  *****')
          STOP
        ENDIF

C       FORCE BARYCENTRIC OUTPUT BY 'STATE'

  98  BSAVE=BARY
      BARY=.TRUE.

C       SET UP PROPER ENTRIES IN 'LIST' ARRAY FOR STATE CALL

      DO I=1,2
        K=NTARG
        IF(I .EQ. 2) K=NCENT
        IF(K .LE. 10) LIST(K)=2
        IF(K .EQ. 10) LIST(3)=2
        IF(K .EQ. 3) LIST(10)=2
        IF(K .EQ. 13) LIST(3)=2
      ENDDO

C       MAKE CALL TO STATE

      CALL STATE(ET2,LIST,PVST,PNUT)

      DO I=1,10
        DO J = 1,6
          PV(J,I) = PVST(J,I)
        ENDDO
      ENDDO

      IF(NTARG .EQ. 11 .OR. NCENT .EQ. 11) THEN
      DO I=1,6
        PV(I,11)=PVSUN(I)
      ENDDO
      ENDIF

      IF(NTARG .EQ. 12 .OR. NCENT .EQ. 12) THEN
        DO I=1,6
          PV(I,12)=0.D0
        ENDDO
      ENDIF

      IF(NTARG .EQ. 13 .OR. NCENT .EQ. 13) THEN
        DO I=1,6
          PV(I,13) = PVST(I,3)
        ENDDO
      ENDIF

      IF(NTARG*NCENT .EQ. 30 .AND. NTARG+NCENT .EQ. 13) THEN
        DO I=1,6
          PV(I,3)=0.D0
        ENDDO
        GO TO 99
      ENDIF

      IF(LIST(3) .EQ. 2) THEN
        DO I=1,6
          PV(I,3)=PVST(I,3)-PVST(I,10)/(1.D0+EMRAT)
        ENDDO
      ENDIF

      IF(LIST(10) .EQ. 2) THEN
        DO I=1,6
          PV(I,10) = PV(I,3)+PVST(I,10)
        ENDDO
      ENDIF

  99  DO I=1,6
        RRD(I)=PV(I,NTARG)-PV(I,NCENT)
      ENDDO

      BARY=BSAVE

      RETURN
      END
C+++++++++++++++++++++++++++++++++
C
      SUBROUTINE INTERP(BUF,T,NCF,NCM,NA,IFL,PV)
C
C+++++++++++++++++++++++++++++++++
C
C     THIS SUBROUTINE DIFFERENTIATES AND INTERPOLATES A
C     SET OF CHEBYSHEV COEFFICIENTS TO GIVE POSITION AND VELOCITY
C
C     CALLING SEQUENCE PARAMETERS:
C
C       INPUT:
C
C         BUF   1ST LOCATION OF ARRAY OF D.P. CHEBYSHEV COEFFICIENTS OF POSITION
C
C           T   T(1) IS DP FRACTIONAL TIME IN INTERVAL COVERED BY
C               COEFFICIENTS AT WHICH INTERPOLATION IS WANTED
C               (0 .LE. T(1) .LE. 1).  T(2) IS DP LENGTH OF WHOLE
C               INTERVAL IN INPUT TIME UNITS.
C
C         NCF   # OF COEFFICIENTS PER COMPONENT
C
C         NCM   # OF COMPONENTS PER SET OF COEFFICIENTS
C
C          NA   # OF SETS OF COEFFICIENTS IN FULL ARRAY
C               (I.E., # OF SUB-INTERVALS IN FULL INTERVAL)
C
C          IFL  INTEGER FLAG: =1 FOR POSITIONS ONLY
C                             =2 FOR POS AND VEL
C
C
C       OUTPUT:
C
C         PV   INTERPOLATED QUANTITIES REQUESTED.  DIMENSION
C               EXPECTED IS PV(NCM,IFL), DP.
C
C
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)
C
      SAVE
C
      DOUBLE PRECISION BUF(NCF,NCM,*),T(2),PV(NCM,*),PC(18),VC(18)

C
      DATA NP/2/
      DATA NV/3/
      DATA TWOT/0.D0/
      DATA PC(1),PC(2)/1.D0,0.D0/
      DATA VC(2)/1.D0/
C
C       ENTRY POINT. GET CORRECT SUB-INTERVAL NUMBER FOR THIS SET
C       OF COEFFICIENTS AND THEN GET NORMALIZED CHEBYSHEV TIME
C       WITHIN THAT SUBINTERVAL.
C
      DNA=DBLE(NA)
      DT1=DINT(T(1))
      TEMP=DNA*T(1)
      L=IDINT(TEMP-DT1)+1

C         TC IS THE NORMALIZED CHEBYSHEV TIME (-1 .LE. TC .LE. 1)

      TC=2.D0*(DMOD(TEMP,1.D0)+DT1)-1.D0

C       CHECK TO SEE WHETHER CHEBYSHEV TIME HAS CHANGED,
C       AND COMPUTE NEW POLYNOMIAL VALUES IF IT HAS.
C       (THE ELEMENT PC(2) IS THE VALUE OF T1(TC) AND HENCE
C       CONTAINS THE VALUE OF TC ON THE PREVIOUS CALL.)

      IF(TC.NE.PC(2)) THEN
        NP=2
        NV=3
        PC(2)=TC
        TWOT=TC+TC
      ENDIF
C
C       BE SURE THAT AT LEAST 'NCF' POLYNOMIALS HAVE BEEN EVALUATED
C       AND ARE STORED IN THE ARRAY 'PC'.
C
      IF(NP.LT.NCF) THEN
        DO 1 I=NP+1,NCF
        PC(I)=TWOT*PC(I-1)-PC(I-2)
    1   CONTINUE
        NP=NCF
      ENDIF
C
C       INTERPOLATE TO GET POSITION FOR EACH COMPONENT
C
      DO 2 I=1,NCM
      PV(I,1)=0.D0
      DO 3 J=NCF,1,-1
      PV(I,1)=PV(I,1)+PC(J)*BUF(J,I,L)
    3 CONTINUE
    2 CONTINUE
      IF(IFL.LE.1) RETURN
C
C       IF VELOCITY INTERPOLATION IS WANTED, BE SURE ENOUGH
C       DERIVATIVE POLYNOMIALS HAVE BEEN GENERATED AND STORED.
C
      VFAC=(DNA+DNA)/T(2)
      VC(3)=TWOT+TWOT
      IF(NV.LT.NCF) THEN
        DO 4 I=NV+1,NCF
        VC(I)=TWOT*VC(I-1)+PC(I-1)+PC(I-1)-VC(I-2)
    4   CONTINUE
        NV=NCF
      ENDIF
C
C       INTERPOLATE TO GET VELOCITY FOR EACH COMPONENT
C
      DO 5 I=1,NCM
      PV(I,2)=0.D0
      DO 6 J=NCF,2,-1
      PV(I,2)=PV(I,2)+VC(J)*BUF(J,I,L)
    6 CONTINUE
      PV(I,2)=PV(I,2)*VFAC
    5 CONTINUE
C
      RETURN
C
      END

C+++++++++++++++++++++++++
C
      SUBROUTINE SPLIT(TT,FR)
C
C+++++++++++++++++++++++++
C
C     THIS SUBROUTINE BREAKS A D.P. NUMBER INTO A D.P. INTEGER
C     AND A D.P. FRACTIONAL PART.
C
C     CALLING SEQUENCE PARAMETERS:
C
C       TT = D.P. INPUT NUMBER
C
C       FR = D.P. 2-WORD OUTPUT ARRAY.
C            FR(1) CONTAINS INTEGER PART
C            FR(2) CONTAINS FRACTIONAL PART
C
C            FOR NEGATIVE INPUT NUMBERS, FR(1) CONTAINS THE NEXT
C            MORE NEGATIVE INTEGER; FR(2) CONTAINS A POSITIVE FRACTION.
C
C       CALLING SEQUENCE DECLARATIONS
C
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)

      DIMENSION FR(2)

C       MAIN ENTRY -- GET INTEGER AND FRACTIONAL PARTS

      FR(1)=DINT(TT)
      FR(2)=TT-FR(1)

      IF(TT.GE.0.D0 .OR. FR(2).EQ.0.D0) RETURN

C       MAKE ADJUSTMENTS FOR NEGATIVE INPUT NUMBER

      FR(1)=FR(1)-1.D0
      FR(2)=FR(2)+1.D0

      RETURN

      END


C++++++++++++++++++++++++++++++++
C
      SUBROUTINE STATE(ET2,LIST,PV,PNUT)
C
C++++++++++++++++++++++++++++++++
C
C THIS SUBROUTINE READS AND INTERPOLATES THE JPL PLANETARY EPHEMERIS FILE
C
C     CALLING SEQUENCE PARAMETERS:
C
C     INPUT:
C
C         ET2   DP 2-WORD JULIAN EPHEMERIS EPOCH AT WHICH INTERPOLATION
C               IS WANTED.  ANY COMBINATION OF ET2(1)+ET2(2) WHICH FALLS
C               WITHIN THE TIME SPAN ON THE FILE IS A PERMISSIBLE EPOCH.
C
C                A. FOR EASE IN PROGRAMMING, THE USER MAY PUT THE
C                   ENTIRE EPOCH IN ET2(1) AND SET ET2(2)=0.
C
C                B. FOR MAXIMUM INTERPOLATION ACCURACY, SET ET2(1) =
C                   THE MOST RECENT MIDNIGHT AT OR BEFORE INTERPOLATION
C                   EPOCH AND SET ET2(2) = FRACTIONAL PART OF A DAY
C                   ELAPSED BETWEEN ET2(1) AND EPOCH.
C
C                C. AS AN ALTERNATIVE, IT MAY PROVE CONVENIENT TO SET
C                   ET2(1) = SOME FIXED EPOCH, SUCH AS START OF INTEGRATION,
C                   AND ET2(2) = ELAPSED INTERVAL BETWEEN THEN AND EPOCH.
C
C        LIST   12-WORD INTEGER ARRAY SPECIFYING WHAT INTERPOLATION
C               IS WANTED FOR EACH OF THE BODIES ON THE FILE.
C
C                         LIST(I)=0, NO INTERPOLATION FOR BODY I
C                                =1, POSITION ONLY
C                                =2, POSITION AND VELOCITY
C
C               THE DESIGNATION OF THE ASTRONOMICAL BODIES BY I IS:
C
C                         I = 1: MERCURY
C                           = 2: VENUS
C                           = 3: EARTH-MOON BARYCENTER
C                           = 4: MARS
C                           = 5: JUPITER
C                           = 6: SATURN
C                           = 7: URANUS
C                           = 8: NEPTUNE
C                           = 9: PLUTO
C                           =10: GEOCENTRIC MOON
C                           =11: NUTATIONS IN LONGITUDE AND OBLIQUITY
C                           =12: LUNAR LIBRATIONS (IF ON FILE)
C
C     OUTPUT:
C
C          PV   DP 6 X 11 ARRAY THAT WILL CONTAIN REQUESTED INTERPOLATED
C               QUANTITIES (OTHER THAN NUTATION, STOERD IN PNUT).  
C               THE BODY SPECIFIED BY LIST(I) WILL HAVE ITS
C               STATE IN THE ARRAY STARTING AT PV(1,I).  
C               (ON ANY GIVEN CALL, ONLY THOSE WORDS IN 'PV' WHICH ARE 
C                AFFECTED BY THE  FIRST 10 'LIST' ENTRIES, AND BY LIST(12)
C                IF LIBRATIONS ARE ON THE FILE, ARE SET.  
C                THE REST OF THE 'PV' ARRAYIS UNTOUCHED.)  
C               THE ORDER OF COMPONENTS STARTING IN PV(1,I) IS: X,Y,Z,DX,DY,DZ.
C
C               ALL OUTPUT VECTORS ARE REFERENCED TO THE EARTH MEAN
C               EQUATOR AND EQUINOX OF J2000 IF THE DE NUMBER IS 200 OR
C               GREATER; OF B1950 IF THE DE NUMBER IS LESS THAN 200. 
C
C               THE MOON STATE IS ALWAYS GEOCENTRIC; THE OTHER NINE STATES 
C               ARE EITHER HELIOCENTRIC OR SOLAR-SYSTEM BARYCENTRIC, 
C               DEPENDING ON THE SETTING OF COMMON FLAGS (SEE BELOW).
C
C               LUNAR LIBRATIONS, IF ON FILE, ARE PUT INTO PV(K,11) IF
C               LIST(12) IS 1 OR 2.
C
C         NUT   DP 4-WORD ARRAY THAT WILL CONTAIN NUTATIONS AND RATES,
C               DEPENDING ON THE SETTING OF LIST(11).  THE ORDER OF
C               QUANTITIES IN NUT IS:
C
C                        D PSI  (NUTATION IN LONGITUDE)
C                        D EPSILON (NUTATION IN OBLIQUITY)
C                        D PSI DOT
C                        D EPSILON DOT
C
C           *   STATEMENT # FOR ERROR RETURN, IN CASE OF EPOCH OUT OF
C               RANGE OR I/O ERRORS.
C
C     COMMON AREA STCOMX:
C
C          KM   LOGICAL FLAG DEFINING PHYSICAL UNITS OF THE OUTPUT
C               STATES. KM = .TRUE., KM AND KM/SEC
C                          = .FALSE., AU AND AU/DAY
C               DEFAULT VALUE = .FALSE.  (KM DETERMINES TIME UNIT
C               FOR NUTATIONS AND LIBRATIONS.  ANGLE UNIT IS ALWAYS RADIANS.)
C
C        BARY   LOGICAL FLAG DEFINING OUTPUT CENTER.
C               ONLY THE 9 PLANETS ARE AFFECTED.
C                        BARY = .TRUE. =\ CENTER IS SOLAR-SYSTEM BARYCENTER
C                             = .FALSE. =\ CENTER IS SUN
C               DEFAULT VALUE = .FALSE.
C
C       PVSUN   DP 6-WORD ARRAY CONTAINING THE BARYCENTRIC POSITION AND
C               VELOCITY OF THE SUN.
C
C
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)

      SAVE

      INTEGER OLDMAX
      PARAMETER ( OLDMAX = 400)
      INTEGER NMAX
      PARAMETER ( NMAX = 1000)

      DIMENSION ET2(2),PV(6,11),PNUT(4),T(2),PJD(4),BUF(1500),
     . SS(3),CVAL(NMAX),PVSUN(6)

      INTEGER LIST(12),IPT(3,13)

      LOGICAL FIRST
      DATA FIRST/.TRUE./

      CHARACTER*6 TTL(14,3),CNAM(NMAX)
      CHARACTER*256 NAMFIL

      LOGICAL KM,BARY

      COMMON/EPHHDR/CVAL,SS,AU,EMRAT,NUMDE,NCON,IPT
      COMMON/CHRHDR/CNAM,TTL
      COMMON/STCOMX/KM,BARY,PVSUN

C
C       ENTRY POINT - 1ST TIME IN, GET POINTER DATA, ETC., FROM EPH FILE
C
      IF(FIRST) THEN
        FIRST=.FALSE.

C ************************************************************************
C ************************************************************************

C THE USER MUST SELECT ONE OF THE FOLLOWING BY DELETING THE 'C' IN COLUMN 1

C ************************************************************************

C        CALL FSIZER1(NRECL,KSIZE,NRFILE,NAMFIL)
C        CALL FSIZER2(NRECL,KSIZE,NRFILE,NAMFIL)
        CALL FSIZER3(NRECL,KSIZE,NRFILE,NAMFIL)

      IF(NRECL .EQ. 0) WRITE(*,*)'  ***** FSIZER IS NOT WORKING *****'

C ************************************************************************
C ************************************************************************

      IRECSZ=NRECL*KSIZE
      NCOEFFS=KSIZE/2

        OPEN(NRFILE,
     *       FILE=NAMFIL,
     *       ACCESS='DIRECT',
     *       FORM='UNFORMATTED',
     *       RECL=IRECSZ,
     *       STATUS='OLD')

      READ(NRFILE,REC=1)TTL,(CNAM(K),K=1,OLDMAX),SS,NCON,AU,EMRAT,
     & ((IPT(I,J),I=1,3),J=1,12),NUMDE,(IPT(I,13),I=1,3)
     & ,(CNAM(L),L=OLDMAX+1,NCON)

      IF(NCON .LE. OLDMAX)THEN
        READ(NRFILE,REC=2)(CVAL(I),I=1,OLDMAX)
      ELSE
        READ(NRFILE,REC=2)(CVAL(I),I=1,NCON)
      ENDIF

      NRL=0

      ENDIF

C       ********** MAIN ENTRY POINT **********

      IF(ET2(1) .EQ. 0.D0) RETURN

      S=ET2(1)-.5D0
      CALL SPLIT(S,PJD(1))
      CALL SPLIT(ET2(2),PJD(3))
      PJD(1)=PJD(1)+PJD(3)+.5D0
      PJD(2)=PJD(2)+PJD(4)
      CALL SPLIT(PJD(2),PJD(3))
      PJD(1)=PJD(1)+PJD(3)

C       ERROR RETURN FOR EPOCH OUT OF RANGE

      IF(PJD(1)+PJD(4).LT.SS(1) .OR. PJD(1)+PJD(4).GT.SS(2)) GO TO 98

C       CALCULATE RECORD # AND RELATIVE TIME IN INTERVAL

      NR=IDINT((PJD(1)-SS(1))/SS(3))+3
      IF(PJD(1).EQ.SS(2)) NR=NR-1

        tmp1 = DBLE(NR-3)*SS(3) + SS(1)
        tmp2 = PJD(1) - tmp1
        T(1) = (tmp2 + PJD(4))/SS(3)

C       READ CORRECT RECORD IF NOT IN CORE

      IF(NR.NE.NRL) THEN
        NRL=NR
        READ(NRFILE,REC=NR,ERR=99)(BUF(K),K=1,NCOEFFS)
      ENDIF

      IF(KM) THEN
      T(2)=SS(3)*86400.D0
      AUFAC=1.D0
      ELSE
      T(2)=SS(3)
      AUFAC=1.D0/AU
      ENDIF

C   INTERPOLATE SSBARY SUN

      CALL INTERP(BUF(IPT(1,11)),T,IPT(2,11),3,IPT(3,11),2,PVSUN)

      DO I=1,6
      PVSUN(I)=PVSUN(I)*AUFAC
      ENDDO

C   CHECK AND INTERPOLATE WHICHEVER BODIES ARE REQUESTED

      DO 4 I=1,10
      IF(LIST(I).EQ.0) GO TO 4

      CALL INTERP(BUF(IPT(1,I)),T,IPT(2,I),3,IPT(3,I),
     & LIST(I),PV(1,I))

      DO J=1,6
       IF(I.LE.9 .AND. .NOT.BARY) THEN
       PV(J,I)=PV(J,I)*AUFAC-PVSUN(J)
       ELSE
       PV(J,I)=PV(J,I)*AUFAC
       ENDIF
      ENDDO

   4  CONTINUE

C       DO NUTATIONS IF REQUESTED (AND IF ON FILE)

      IF(LIST(11).GT.0 .AND. IPT(2,12).GT.0)
     * CALL INTERP(BUF(IPT(1,12)),T,IPT(2,12),2,IPT(3,12),
     * LIST(11),PNUT)

C       GET LIBRATIONS IF REQUESTED (AND IF ON FILE)

      IF(LIST(12).GT.0 .AND. IPT(2,13).GT.0)
     * CALL INTERP(BUF(IPT(1,13)),T,IPT(2,13),3,IPT(3,13),
     * LIST(12),PV(1,11))

      RETURN

  98  WRITE(*,198)ET2(1)+ET2(2),SS(1),SS(2)
 198  FORMAT(' ***  Requested JED,',f12.2,
     * ' not within ephemeris limits,',2f12.2,'  ***')

      STOP

   99 WRITE(*,'(2F12.2,A80)')ET2,'ERROR RETURN IN STATE'

      STOP

      END
C+++++++++++++++++++++++++++++
C
      SUBROUTINE CONST(NAM,VAL,SSS,N)
C
C+++++++++++++++++++++++++++++
C
C     THIS ENTRY OBTAINS THE CONSTANTS FROM THE EPHEMERIS FILE
C
C     CALLING SEQEUNCE PARAMETERS (ALL OUTPUT):
C
C       NAM = CHARACTER*6 ARRAY OF CONSTANT NAMES
C
C       VAL = D.P. ARRAY OF VALUES OF CONSTANTS
C
C       SSS = D.P. JD START, JD STOP, STEP OF EPHEMERIS
C
C         N = INTEGER NUMBER OF ENTRIES IN 'NAM' AND 'VAL' ARRAYS
C
      IMPLICIT DOUBLE PRECISION (A-H,O-Z)

      SAVE

      INTEGER NMAX
      PARAMETER (NMAX = 1000)

      CHARACTER*6 NAM(*),TTL(14,3),CNAM(NMAX)

      DOUBLE PRECISION VAL(*),SSS(3),SS(3),CVAL(NMAX),ZIPS(2)
      DOUBLE PRECISION PVST(6,11),PNUT(4)
      DATA ZIPS/2*0.d0/

      INTEGER IPT(3,13),DENUM,LIST(12)
      logical first
      data first/.true./

      COMMON/EPHHDR/CVAL,SS,AU,EMRAT,DENUM,NCON,IPT
      COMMON/CHRHDR/CNAM,TTL

C  CALL STATE TO INITIALIZE THE EPHEMERIS AND READ IN THE CONSTANTS

      IF(FIRST) CALL STATE(ZIPS,LIST,PVST,PNUT)
      first=.false.

      N=NCON

      DO I=1,3
        SSS(I)=SS(I)
      ENDDO

      DO I=1,N
        NAM(I)=CNAM(I)
        VAL(I)=CVAL(I)
      ENDDO

      RETURN

      END

subroutine agccft8(nfa,nfb,lforcesync,forcedt)

  use ft8_mod1, only : dd8,twopi,lagccbail
  integer, parameter :: NFFT=1024,NSZ=426,NHSYM=178,NHSTEP=960 !3413 = NFFT*5000/12000
 ! nhsym=(npts-NFFT)/nhstep !number of half-symbols 178.96(6) = (180000-8192)/(1920/2)
  real*4 x11(NFFT),w11(NFFT),ss33(NSZ),s3(NHSYM)
  real, DIMENSION(:), ALLOCATABLE :: sa33
  integer, DIMENSION(:), ALLOCATABLE :: indx
  integer, intent(in) :: nfa,nfb
  complex c11(0:NFFT/2)
  logical(1) first
  logical(1), intent(in) :: lforcesync
  equivalence (x11,c11)
  data first/.true./
  save first,w11

  if(first) then ! FFT window
    do k=1,NFFT
      w11(k)=sin(twopi*(k+2)/2048) ! 16384 = 2*NFFT
    enddo
    first=.false.
  endif

  fac1=1.1e-3 ! 7548, 9.6e-4 7540, 9.7e-4 7546, 9.8e-4 7543, 1.0e-3 7539, 1.2e-3 7534..7538, 1.3e-3 7547, 2.4e-3 7543

  if(nfb.lt.5000) then; nfblim=nfb; else; nfblim=4999; endif ! ss33 top index protection
  nf1=NFFT*nfa/12000+1; nf2=NFFT*nfblim/12000
  nmed=(nf2-nf1)/2; nsb=nf2-nf1+1

  if(lforcesync) then
    jmin=0; specmin=1.E10
    do j=1,175
      i0=(j-1)*NFFT; x11=fac1*w11*dd8(i0+1:i0+NFFT)
      call four2a(c11,NFFT,1,-1,0)                !r2c forward FFT
      spec=0.
      do i=nf1,nf2
        s33=abs(c11(i)); spec=spec+s33
      enddo
      if(spec.gt.0.001 .and. spec.lt.specmin) then; specmin=spec; jmin=j; endif
    enddo
    forcedt=15.*jmin/175; if(forcedt.gt.7.5) forcedt=forcedt-15.
  else
    allocate(sa33(nsb), STAT = nAllocateStatus1)
    if(nAllocateStatus1.ne.0) STOP "Not enough memory"
    allocate(indx(nsb), STAT = nAllocateStatus1)
    if(nAllocateStatus1.ne.0) STOP "Not enough memory"

    do j=1,10
      i0=(j-1)*nhstep; x11=fac1*w11*dd8(i0+1:i0+NFFT)
      call four2a(c11,NFFT,1,-1,0)                !r2c forward FFT
      do i=nf1,nf2
        s33=ABS(c11(i)); ss33(i)=SQRT(s33)
      enddo
      sa33(1:nsb)=ss33(nf1:nf2)
      call indexx(sa33(1:nsb),nsb,indx)
      smed=sa33(indx(nmed)); if(smed.gt.1.e-6) then; s3(j)=smed; else; s3(j)=1.0; endif
    enddo

    do j=169,178
      i0=(j-1)*nhstep; x11=fac1*w11*dd8(i0+1:i0+NFFT)
      call four2a(c11,NFFT,1,-1,0)                !r2c forward FFT
      do i=nf1,nf2
        s33=ABS(c11(i)); ss33(i)=SQRT(s33)
      enddo
      sa33(1:nsb)=ss33(nf1:nf2)
      call indexx(sa33(1:nsb),nsb,indx)
      smed=sa33(indx(nmed)); if(smed.gt.1.e-6) then; s3(j)=smed; else; s3(j)=1.0; endif
    enddo

    deallocate (sa33, STAT = nDeAllocateStatus1)
    if (nDeAllocateStatus1.ne.0) print *, 'failed to release memory'
    deallocate (indx, STAT = nDeAllocateStatus1)
    if (nDeAllocateStatus1.ne.0) print *, 'failed to release memory'

    s3min1=minval(s3(1:10)); s3min2=minval(s3(169:178)); s3min=min(s3min1,s3min2)
    s3max1=maxval(s3(1:10)); s3max2=maxval(s3(169:178)); s3max=max(s3max1,s3max2)
    if(s3min.lt.0.1) then; s3min=1.0; s3max=1.0; endif
    s3ratio=s3max/s3min

    lagccbail=.false.
! 2.0dB delta
    if(s3ratio.lt.1.26) then; lagccbail=.true.; return; endif

    k=1
    do j=1,10
      dd8(k:k+959)=dd8(k:k+959)/s3(j); k=k+960
    enddo
    k=1+168*960
    do j=169,178
      dd8(k:k+959)=dd8(k:k+959)/s3(j); k=k+960
    enddo
    dd8(170881:171650)=dd8(170881:171650)/s3(178); dd8(171651:180000)=0.
  endif

  return
end subroutine agccft8

! This source code file was last time modified by Igor UA3DJY on 20181215
! All changes are shown in the patch file coming together with the full JTDX source code.

subroutine cqcall3()

  use jt65_mod10  ! used to share stored messages
  use packjt
  use prog_args
 
  integer dgen(12),sym_rev(0:62)
  character*6 call2(MAXCALLS)
  character*4 grid2(MAXCALLS)
  character line*180,callsign*12,grid*4,msg*22

     open(23,file=trim(data_dir)//'/CALL3.TXT',status='unknown')
     icall=0
     j=0
     do i=1,MAXCALLS
        read(23,1002,end=10) line
1002    format(a80)
        if(line(1:4).eq.'ZZZZ') exit
        if(line(1:2).eq.'//') cycle
        i1=index(line,',')
        if(i1.lt.4) cycle
        i2=index(line(i1+1:),',')
        if(i2.lt.5) cycle
        i2=i2+i1
        callsign=line(1:i1-1)
        grid=line(i1+1:i2-1)
        j=j+1
        call2(j)=callsign(1:6)               !### Fix for compound callsigns!
        grid2(j)=grid
     enddo
10   ncalls=j
     if(first .and. ncalls.lt.1) then
        print *, 'copy CALL3.TXT file to log directory'
        print *, 'http://www.jtdx.tech'
        first=.false.
!        stop 'CALL3.TXT is too short or missed?'
     endif
     close(23)

     if(ncalls.eq.0) then
        nused=0
        return
     endif
     j=0
     do i=1,ncalls
        j=j+1
        msg='CQ '//call2(i)//' '//grid2(i)
        call fmtmsg(msg,iz)
        call packmsg(msg,dgen,itype)            !Pack message into 72 bits
        call rs_encode(dgen,sym_rev)            !RS encode
        call interleave63(sym_rev,1)            !Interleave channel symbols
        call graycode(sym_rev,63,1,sym_rev)     !Apply Gray code
        sym2(0:62,j)=sym_rev(0:62)
        msg0(j)=msg
     enddo
     nused=j

return
end subroutine cqcall3

subroutine chkhist(mrsym,nmax,ipk)

  integer mrsym(63)
  integer hist(0:63)

  hist=0
  do j=1,63
     i=mrsym(j)
     hist(i)=hist(i)+1
  enddo

  nmax=0
  do i=0,63
     if(hist(i).gt.nmax) then
        nmax=hist(i)
        ipk=i+1
     endif
  enddo

  return
end subroutine chkhist

! This source code file was last time modified by Igor UA3DJY on 20190928
! All changes are shown in the patch file coming together with the full JTDX source code.

subroutine osd4_174_91(llr,apmask,ndeep,message77,cw,nhardmin,dmin)
!
! An ordered-statistics decoder for the (174,91) code.
! 
integer, parameter:: N=174, K=91, M=N-K
integer*1 apmask(N),apmaskr(N)
integer*1 gen(K,N)
integer*1 genmrb(K,N),g2(N,K)
integer*1 temp(K),m0(K),me(K),mi(K),misub(K),e2sub(N-K),e2(N-K),ui(N-K)
integer*1 r2pat(N-K)
integer indices(N),nxor(N)
integer*1 cw(N),ce(N),c0(N),hdec(N)
integer*1 decoded(K)
integer*1 message77(77)
integer indx(N)
real llr(N),rx(N),absrx(N)

include "ldpc_174_91_c_generator.f90"

logical first,reset
data first/.true./
save first,gen

npre1=0; npre2=0; d1=0.

if( first ) then ! fill the generator matrix
  gen=0
  do i=1,M
    do j=1,23
      read(g(i)(j:j),"(Z1)") istr
      ibmax=4
      if(j.eq.23) ibmax=3
      do jj=1, ibmax 
        irow=(j-1)*4+jj
        if( btest(istr,4-jj) ) gen(irow,K+i)=1 
      enddo
    enddo
  enddo
  do irow=1,K
    gen(irow,irow)=1
  enddo
first=.false.
endif

rx=llr
apmaskr=apmask

! Hard decisions on the received word.
hdec=0            
where(rx .ge. 0) hdec=1

! Use magnitude of received symbols as a measure of reliability.
absrx=abs(rx) 
call indexx(absrx,N,indx)  

! Re-order the columns of the generator matrix in order of decreasing reliability.
do i=1,N
  genmrb(1:K,i)=gen(1:K,indx(N+1-i))
  indices(i)=indx(N+1-i)
enddo

! Do gaussian elimination to create a generator matrix with the most reliable
! received bits in positions 1:K in order of decreasing reliability (more or less). 
do id=1,K ! diagonal element indices 
  do icol=id,K+20  ! The 20 is ad hoc - beware
    iflag=0
    if( genmrb(id,icol) .eq. 1 ) then
      iflag=1
      if( icol .ne. id ) then ! reorder column
        temp(1:K)=genmrb(1:K,id)
        genmrb(1:K,id)=genmrb(1:K,icol)
        genmrb(1:K,icol)=temp(1:K) 
        itmp=indices(id)
        indices(id)=indices(icol)
        indices(icol)=itmp
      endif
      do ii=1,K
        if( ii .ne. id .and. genmrb(ii,id) .eq. 1 ) then
          genmrb(ii,1:N)=ieor(genmrb(ii,1:N),genmrb(id,1:N))
        endif
      enddo
      exit
    endif
  enddo
enddo

g2=transpose(genmrb)

! The hard decisions for the K MRB bits define the order 0 message, m0. 
! Encode m0 using the modified generator matrix to find the "order 0" codeword. 
! Flip various combinations of bits in m0 and re-encode to generate a list of
! codewords. Return the member of the list that has the smallest Euclidean
! distance to the received word. 

hdec=hdec(indices)   ! hard decisions from received symbols
m0=hdec(1:K)         ! zero'th order message
absrx=absrx(indices) 
rx=rx(indices)       
apmaskr=apmaskr(indices)

call mrbencode4_91(m0,c0,g2,N,K)
nxor=ieor(c0,hdec)
nhardmin=sum(nxor)
dmin=sum(nxor*absrx)

cw=c0
ntotal=0
nrejected=0

if(ndeep.eq.0) goto 998  ! norder=0
if(ndeep.gt.5) ndeep=5
if( ndeep.eq. 1) then
   nord=1
   npre1=0
   npre2=0
   nt=40
   ntheta=12
elseif(ndeep.eq.2) then
   nord=1
   npre1=1
   npre2=0
   nt=40
   ntheta=12
elseif(ndeep.eq.3) then
   nord=1
   npre1=1
   npre2=1
   nt=40
   ntheta=12
   ntau=14
elseif(ndeep.eq.4) then
   nord=2
   npre1=1
   npre2=0
   nt=40
   ntheta=12
   ntau=19
elseif(ndeep.eq.5) then
   nord=2
   npre1=1
   npre2=1
   nt=40
   ntheta=12
   ntau=19
endif

do iorder=1,nord
   misub(1:K-iorder)=0
   misub(K-iorder+1:K)=1
   iflag=K-iorder+1
   do while(iflag .ge.0)
      if(iorder.eq.nord .and. npre1.eq.0) then
         iend=iflag
      else
         iend=1
      endif
      do n1=iflag,iend,-1
         mi=misub
         mi(n1)=1
         if(any(iand(apmaskr(1:K),mi).eq.1)) cycle
         ntotal=ntotal+1
         me=ieor(m0,mi)
         if(n1.eq.iflag) then
            call mrbencode4_91(me,ce,g2,N,K)
            e2sub=ieor(ce(K+1:N),hdec(K+1:N))
            e2=e2sub
            nd1Kpt=sum(e2sub(1:nt))+1
            d1=sum(ieor(me(1:K),hdec(1:K))*absrx(1:K))
         else
            e2=ieor(e2sub,g2(K+1:N,n1))
            nd1Kpt=sum(e2(1:nt))+2
         endif
         if(nd1Kpt .le. ntheta) then
            call mrbencode4_91(me,ce,g2,N,K)
            nxor=ieor(ce,hdec)
            if(n1.eq.iflag) then
               dd=d1+sum(e2sub*absrx(K+1:N))
            else
               dd=d1+ieor(ce(n1),hdec(n1))*absrx(n1)+sum(e2*absrx(K+1:N))
            endif
            if( dd .lt. dmin ) then
               dmin=dd
               cw=ce
               nhardmin=sum(nxor)
               nd1Kptbest=nd1Kpt
            endif
         else 
            nrejected=nrejected+1
         endif
      enddo
! Get the next test error pattern, iflag will go negative
! when the last pattern with weight iorder has been generated.
      call nextpat4_91(misub,k,iorder,iflag)
   enddo
enddo

if(npre2.eq.1) then
   reset=.true.
   ntotal=0
   do i1=K,1,-1
      do i2=i1-1,1,-1
         ntotal=ntotal+1
         mi(1:ntau)=ieor(g2(K+1:K+ntau,i1),g2(K+1:K+ntau,i2))
         call boxit4_91(reset,mi(1:ntau),ntau,ntotal,i1,i2)
      enddo
   enddo

   ncount2=0
   ntotal2=0
   reset=.true.
! Now run through again and do the second pre-processing rule
   misub(1:K-nord)=0
   misub(K-nord+1:K)=1
   iflag=K-nord+1
   do while(iflag .ge.0)
      me=ieor(m0,misub)
      call mrbencode4_91(me,ce,g2,N,K)
      e2sub=ieor(ce(K+1:N),hdec(K+1:N))
      do i2=0,ntau
         ntotal2=ntotal2+1
         ui=0 
         if(i2.gt.0) ui(i2)=1 
         r2pat=ieor(e2sub,ui)
778      continue 
            call fetchit4_91(reset,r2pat(1:ntau),ntau,in1,in2)
            if(in1.gt.0.and.in2.gt.0) then
               ncount2=ncount2+1
               mi=misub               
               mi(in1)=1
               mi(in2)=1
               if(sum(mi).lt.nord+npre1+npre2.or.any(iand(apmaskr(1:K),mi).eq.1)) cycle
               me=ieor(m0,mi)
               call mrbencode4_91(me,ce,g2,N,K)
               nxor=ieor(ce,hdec)
               dd=sum(nxor*absrx)
               if( dd .lt. dmin ) then
                  dmin=dd
                  cw=ce
                  nhardmin=sum(nxor)
               endif
               goto 778
             endif
      enddo
      call nextpat4_91(misub,K,nord,iflag)
   enddo
endif

998 continue
! Re-order the codeword to [message bits][parity bits] format. 
cw(indices)=cw
hdec(indices)=hdec
decoded=cw(1:K) 
call chkcrc14a(decoded,nbadcrc)
message77=decoded(1:77)
if(nbadcrc.eq.1) nhardmin=-nhardmin

return
end subroutine osd4_174_91

subroutine mrbencode4_91(me,codeword,g2,N,K)
integer*1 me(K),codeword(N),g2(N,K)
! fast encoding for low-weight test patterns
  codeword=0
  do i=1,K
    if( me(i) .eq. 1 ) then
      codeword=ieor(codeword,g2(1:N,i))
    endif
  enddo
return
end subroutine mrbencode4_91

subroutine nextpat4_91(mi,k,iorder,iflag)
  integer*1 mi(k),ms(k)
! generate the next test error pattern
  ind=-1
  do i=1,k-1
     if( mi(i).eq.0 .and. mi(i+1).eq.1) ind=i 
  enddo
  if( ind .lt. 0 ) then ! no more patterns of this order
    iflag=ind
    return
  endif
  ms=0
  ms(1:ind-1)=mi(1:ind-1)
  ms(ind)=1
  ms(ind+1)=0
  if( ind+1 .lt. k ) then
     nz=iorder-sum(ms)
     ms(k-nz+1:k)=1
  endif
  mi=ms
  do i=1,k  ! iflag will point to the lowest-index 1 in mi
    if(mi(i).eq.1) then
      iflag=i 
      exit
    endif
  enddo
  return
end subroutine nextpat4_91

subroutine boxit4_91(reset,e2,ntau,npindex,i1,i2)
  integer*1 e2(1:ntau)
  integer   indexes(5000,2),fp(0:525000),np(5000)
  logical reset
  common/boxes/indexes,fp,np

  if(reset) then
    patterns=-1
    fp=-1
    np=-1
    sc=-1
    indexes=-1
    reset=.false.
  endif
 
  indexes(npindex,1)=i1
  indexes(npindex,2)=i2
  ipat=0
  do i=1,ntau
    if(e2(i).eq.1) then
      ipat=ipat+ishft(1,ntau-i)
    endif
  enddo

  ip=fp(ipat)   ! see what's currently stored in fp(ipat)
  if(ip.eq.-1) then
    fp(ipat)=npindex
  else
     do while (np(ip).ne.-1)
      ip=np(ip) 
     enddo  
     np(ip)=npindex
  endif
  return
end subroutine boxit4_91

subroutine fetchit4_91(reset,e2,ntau,i1,i2)
  integer   indexes(5000,2),fp(0:525000),np(5000)
  integer   lastpat
  integer*1 e2(ntau)
  logical reset
  common/boxes/indexes,fp,np
  save lastpat,inext

  if(reset) then
    lastpat=-1
    reset=.false.
  endif

  ipat=0
  do i=1,ntau
    if(e2(i).eq.1) then
      ipat=ipat+ishft(1,ntau-i)
    endif
  enddo
  index=fp(ipat)

  if(lastpat.ne.ipat .and. index.gt.0) then ! return first set of indices
     i1=indexes(index,1)
     i2=indexes(index,2)
     inext=np(index)
  elseif(lastpat.eq.ipat .and. inext.gt.0) then
     i1=indexes(inext,1)
     i2=indexes(inext,2)
     inext=np(inext)
  else
     i1=-1
     i2=-1
     inext=-1
  endif
  lastpat=ipat
  return
end subroutine fetchit4_91
 

program code426

  parameter (MZ=26)                !Number of 4-FSK symbols
  parameter (JZMAX=64)             !Desired number of codewords
  integer ic(MZ,JZMAX),icsave(MZ)
  real c(MZ)
  character*12 arg

  nargs=iargc()
  if(nargs.ne.2) then
     print*,'Usage:   code426 <nmsgs> <iters>'
     print*,'Example: code426   64   10000000'
     go to 999
  endif
  call getarg(1,arg)
  read(arg,*) nmsgs
  call getarg(2,arg)
  read(arg,*) iters

  call init_random_seed()

  open(13,file='code426.out',status='unknown')

  write(*,1002) nmsgs,iters
  write(13,1002) nmsgs,iters
1002 format('Nmsgs:',i4,'   Iters:',i10/(66('-')))
  
  do i=1,MZ                     !Create 4 mutually orthogonal codewords
     ic(i,1)=mod(i-1,4)
     ic(i,2)=mod(i,4)
     ic(i,3)=mod(i+1,4)
     ic(i,4)=mod(i+2,4)
  enddo

  do j=1,4                      !Write them out
     write(*,1000) j,MZ,ic(1:MZ,j)
     write(13,1000) j,MZ,ic(1:MZ,j)
1000 format(2i5,3x,26i2)
  enddo
 
  do j=5,nmsgs                  !Find codewords up to j=nmsgs with maximum
     npk=0                      !distance from all the rest
     do i=1,iters
        call random_number(c)   !Generate a random codeword candidate
        ic(1:MZ,j)=int(4*c)     !Convert real to integer
!        nd=MZ
!        do k=1,j-1              !Test candidate against all others in list
!           n=count(ic(1:MZ,j).ne.ic(1:MZ,k))
!           nd=min(n,nd)
!        enddo
        call dist426(ic,j,mind)
        if(mind.gt.npk) then
           npk=mind
           icsave=ic(1:MZ,j)    !Best candidate so far, save it
!           if(npk.ge.19) exit   !It won't get any better...
        endif
     enddo
     write(*,1000) j,npk,ic(1:MZ,j)
     write(13,1000) j,npk,ic(1:MZ,j)
  enddo

999 end program code426

real function fchisq(c3,npts,fsample,a)

  parameter (NMAX=85*16)
  complex c3(npts)
  complex c4(NMAX)
  real a(3)
  complex z
  data a1,a2,a3/99.,99.,99./
  include 'jt9sync.f90'
  save

  if(a(1).ne.a1 .or. a(2).ne.a2 .or. a(3).ne.a3) then
     a1=a(1)
     a2=a(2)
     a3=a(3)
     call twkfreq(c3,c4,npts,fsample,a)
  endif

! Get sync power.
  nspsd=16
  sum1=0.
  sum0=0.
  k=-1
  do i=1,85
     z=0.
     do j=1,nspsd
        k=k+1
        z=z+c4(k+1)
     enddo
     pp=real(z)**2 + aimag(z)**2     
     if(isync(i).eq.1) then
        sum1=sum1+pp
     else
        sum0=sum0+pp
     endif
  enddo
  sync_4992=(sum1/16.0)/(sum0/69.0) - 1.0             !r4992
  sync_4993=sum1/10000.0                              !r4993+
!  write(80,3001) 1.e-5*sum1,1.e-5*sum0,sync_4992,sync_4993,sync
!3001 format(5f11.4)
  fchisq=-sync_4993

  return
end function fchisq

subroutine ft8_downsample(newdat1,f0,nqso,c0,c2,c3,lhighsens,lsubtracted,npos,freqsub)

! Downconvert to complex data sampled at 200 Hz ==> 32 samples/symbol
  use ft8_mod1, only : dd8,windowc1,facc1
  parameter (NFFT1=192000,NFFT2=3200)      !192000/60 = 3200
  
  logical newdat1
  complex, intent(out) :: c0(-800:4000),c2(-800:4000),c3(-800:4000)
  complex cx(0:96000),cxx(0:96000),c1(0:3199) ! 0:NFFT1/2
  real x(NFFT1)
  real, intent(in) :: f0
  integer, intent(in) :: nqso
  real freqsub(200)
  logical(1), intent(in) :: lhighsens
  logical(1) lsubtracted,ldofft
  equivalence (x,cx)
  save cxx

  ldofft=.false.
  if(lsubtracted) then
    do i=1,npos
      if(abs(f0-freqsub(i)).lt.50.) then; ldofft=.true.; lsubtracted=.false.; exit; endif
    enddo
  endif

  if(newdat1 .or. ldofft) then
! Data in dd have changed, recompute the long FFT
     x(1:180000)=dd8
     x(180001:NFFT1)=0.                       !Zero-pad the x array
     call four2a(cx,NFFT1,1,-1,0)             !r2c FFT to freq domain
     newdat1=.false.; ldofft=.false.; npos=0
     cxx=cx
  endif

  df=0.0625 ! 12000.0/NFFT1
!  tonewidth=6.25 Hz ! 12000.0/1920.
  i0=nint(f0/df)
  ft=f0+55.75; it=min(nint(ft/df),96000)
  fb=f0-5.75; ib=max(1,nint(fb/df))
  c1=cmplx(0.0,0.0)
  k=it-ib
  c1(0:k)=cxx(ib:it)
  c1(0:54)=c1(0:54)*windowc1(54:0:-1)
  c1(k-54:k)=c1(k-54:k)*windowc1
  c1=cshift(c1,i0-ib)
  if(lhighsens) then; c1(0)=c1(0)*1.93; c1(799)=c1(799)*1.7; c1(800)=c1(800)*1.7; c1(3199)=c1(3199)*1.93
  else; c1(45)=c1(45)*1.49; c1(54)=c1(54)*1.49; c1(3145)=c1(3145)*1.49; c1(3154)=c1(3154)*1.49
  endif ! 10346..10347
  call four2a(c1,NFFT2,1,1,1)            !c2c FFT back to time domain
  c0(-800:-1)=0.; c0(0:3199)=facc1*c1(0:3199); c0(3200:4000)=0.
  if(nqso.gt.1) then
    c2(-800:-1)=0.; c2(3200:4000)=0.
    do i=0,3198; c2(i)=c0(i)+c0(i+1); enddo
    c2(3199)=c0(3199); c2=c2/2
  endif
  if(nqso.eq.3) then
    c3(-800:-1)=0.; c3(3200:4000)=0.
    do i=1,3199; c3(i)=c0(i-1)+c0(i); enddo
    c3(0)=c0(0); c3=c3/2
  endif

  return
end subroutine ft8_downsample

ip=maxloc(s81)
if(icos7(k-1).eq.(ip(1)-1)) then
  nsmax(1)=nsmax(1)+1
else
  s81(ip(1)-1)=0.; ip=maxloc(s81)
  if(icos7(k-1).eq.(ip(1)-1)) then
    nsmax(2)=nsmax(2)+1
  else
    s81(ip(1)-1)=0.; ip=maxloc(s81)
    if(icos7(k-1).eq.(ip(1)-1)) then
      nsmax(3)=nsmax(3)+1
    else
      s81(ip(1)-1)=0.; ip=maxloc(s81)
      if(icos7(k-1).eq.(ip(1)-1)) then
        nsmax(4)=nsmax(4)+1
      else
        s81(ip(1)-1)=0.; ip=maxloc(s81)
        if(icos7(k-1).eq.(ip(1)-1)) then
          nsmax(5)=nsmax(5)+1
        else
          s81(ip(1)-1)=0.; ip=maxloc(s81)
          if(icos7(k-1).eq.(ip(1)-1)) then
            nsmax(6)=nsmax(6)+1
          else
            s81(ip(1)-1)=0.; ip=maxloc(s81)
            if(icos7(k-1).eq.(ip(1)-1)) then
              nsmax(7)=nsmax(7)+1
            else
              s81(ip(1)-1)=0.; ip=maxloc(s81)
              if(icos7(k-1).eq.(ip(1)-1)) nsmax(8)=nsmax(8)+1
            endif
          endif
        endif
      endif
    endif
  endif
endif

! This source code file was last time modified by Igor UA3DJY on January 12th, 2017
! All changes are shown in the patch file coming together with the full JTDX source code.

subroutine xcor(ss,ss22,ipk,ccf,lagpk,ccf22,lagpk22)

! Computes ccf of a single row of ss and the pseudo-random array pr.  Returns
! peak of the CCF and the lag at which peak occurs.  

  use jt65_mod4
  implicit none
  integer, parameter :: NSZ=3413,NHSYM=276,lag1=-21,lag2=75
  ! 3413 Max length of power spectra
  ! 276 number of half-symbol steps
  ! 2d spectrum, stepped by half-symbols
  real ccf(lag1:lag2),ccf22(lag1:lag2)
  real x,x22,ccfmax,ccfmax22,s0,s1,s20,s21
  integer j,lag,i,lagpk,lagpk22,ipk
  save
  real ss(:,:),ss22(:,:)
  ccfmax=0.; ccfmax22=0.; lagpk=75; lagpk22=75
! nsteps=nhsym=276.2566 =(52*12000-8192)/(2048*12000/11025) calculated in symspec65

  do lag=lag1,lag2
     s0=0.;s1=0.;s20=0.;s21=0.;x=0.;x22=0.
     do i=1,126 !number of symbols
        j=2*i-1+lag
        if(j.ge.1 .and. j.le.nhsym) then
          x=ss(j,ipk)
          x22=ss22(j,ipk)
          if(.not.prc(i)) then
             s0=s0 + x
             s20=s20 + x22
          else
             s1=s1 + x
             s21=s21 + x22
          endif
        endif
     enddo
     ccf(lag)=2*(s1-s0)                        !The 2 is for plotting scale
     ccf22(lag)=2*(s21-s20)
     if(ccf(lag).gt.ccfmax) then
        ccfmax=ccf(lag)
        lagpk=lag
     endif
     if(ccf22(lag).gt.ccfmax22) then
        ccfmax22=ccf22(lag)
        lagpk22=lag
     endif
  enddo

  return
end subroutine xcor

! This source code file was last time modified by Igor UA3DJY on 20181215
! All changes are shown in the patch file coming together with the full JTDX source code.

subroutine hintdxgrid(mrs,mrs2,mycall,hiscall,hisgrid,decoded,hint_dx)

  use packjt
  use jt65_mod2, only : s3,correct_hint
  
  parameter (MAXMSG=10)
  real u1
  integer mrs(63),mrs2(63),sym2(0:62,MAXMSG),dgen(12),sym_rev(0:62)
  logical(1) hint_dx,first
  character mycall*6,hiscall*6,hisgrid*4,msg*22,msg1*22,msg00*22,decoded*22,prevcall*6
  character*22 msg0(MAXMSG)
  data first/.true./
  save first,msg0,sym2,prevcall

  hint_dx=.false.
  do i=1,6
   if(hiscall(i:i).eq.'/') return
  enddo
  
  if(first) then
     do m=2,MAXMSG
        msg='UF0XYZ W9XYZ '//'EN3'//achar(47+m)
        call fmtmsg(msg,iz)
        call packmsg(msg,dgen,itype)            !Pack message into 72 bits
        call rs_encode(dgen,sym_rev)            !RS encode
        call interleave63(sym_rev,1)            !Interleave channel symbols
        call graycode(sym_rev,63,1,sym_rev)     !Apply Gray code
        sym2(0:62,m)=sym_rev(0:62)
        msg0(m)=msg
     enddo
     first=.false.
  endif

  if(hiscall.eq.prevcall) then
     go to 2
  else
     prevcall=hiscall
  endif

  msg=mycall//' '//hiscall//' '//hisgrid
  call fmtmsg(msg,iz)
  call packmsg(msg,dgen,itype)            !Pack message into 72 bits
  call rs_encode(dgen,sym_rev)            !RS encode
  call interleave63(sym_rev,1)            !Interleave channel symbols
  call graycode(sym_rev,63,1,sym_rev)     !Apply Gray code
  sym2(0:62,1)=sym_rev(0:62)
  msg0(1)=msg

2  ref0=0.
  do i=1,63
     do j=1,63
        ref0=ref0 + s3(mrs(j)+1,i)
     enddo
  enddo

  u1=-99.0
  u2=u1

! Find u1 and u2 (best and second-best) codeword from a list, using 
! a bank of matched filters on the symbol spectra s3(i,j).
  ipk=1
  msg00='                      '
  do k=1,MAXMSG
      psum=0.
      ref=ref0
      do j=1,63
         i=sym2(j-1,k)+1
         psum=psum + s3(i,j)
         if(i.eq.mrs(j)+1) ref=ref - s3(i,j) + s3(mrs2(j)+1,j)
      enddo
      p=psum*63.0/ref

      if(p.gt.u1) then
         if(msg0(k).ne.msg00) u2=u1
         u1=p
         ipk=k
         msg00=msg0(k)
      endif
      if(msg0(k).ne.msg00 .and. p.gt.u2) u2=p
  enddo

  decoded='                      '
  msg1=msg0(ipk)
  if(msg1(1:6).eq."UF0XYZ") go to 4
  
  bias=max(1.12*u2,0.35)
  qual=100.0*(u1-bias)
  if(qual.ge.8.0 .or. u1.ge.1.33) then
     decoded=msg1
!print *,qual,u1
!print *,decoded
     hint_dx=.true.
     correct_hint(1:63)=sym2(0:62,ipk)
  endif 
4  return
end subroutine hintdxgrid

! This source code file was last time modified by Igor UA3DJY on February 15th, 2017
! All changes are shown in the patch file coming together with the full JTDX source code.

module jt65_mod10 
! used to store last callsigns seen in JT modes in the memory
! used in some Hint decoders and for false FTRSD decodes checking

  parameter (MAXCALLS=35000)  ! max 34999 calls in CALL3.TXT
  parameter (MAXMSG=MAXCALLS) ! in chkftrsd MAXMSG is equal to CALL3 calls +1
  integer*1 sym2(0:62,MAXMSG)
  integer nused
  logical(1) first
  character*22 msg0(MAXMSG)
  data first/.true./

  save first,nused,msg0,sym2

end module jt65_mod10

subroutine delbraces(msg37)

  character msg37*37

  ispc1=index(msg37,' '); ispc2=index(msg37((ispc1+1):),' ')+ispc1; ispc3=index(msg37((ispc2+1):),' ')+ispc2
  ieoc1=ispc1-1; iboc2=ispc1+1; ieoc2=ispc2-1

  if(msg37(1:1).eq.'<' .and. msg37(2:2).ne.'.') then
    msg37(ieoc1:37)=msg37(ieoc1+1:37)//' '; msg37(1:37)=msg37(2:37)//' '
  else if(msg37(iboc2:iboc2).eq.'<' .and. msg37(iboc2+1:iboc2+1).ne.'.') then
    msg37(ieoc2:37)=msg37(ieoc2+1:37)//' '; msg37(iboc2:37)=msg37(iboc2+1:37)//' '
  else
    iboc3=ispc2+1; ieoc3=ispc3-1
    if(msg37(iboc3:iboc3).eq.'<' .and. msg37(iboc3+1:iboc3+1).ne.'.') then
      msg37(ieoc3:37)=msg37(ieoc3+1:37)//' '; msg37(iboc3:37)=msg37(iboc3+1:37)//' '
    endif
  endif

  return
end subroutine delbraces

! This source code file was last time modified by Igor UA3DJY on April 5th, 2017
! All changes are shown in the patch file coming together with the full JTDX source code.

subroutine afc10(c3a,npts,fsample,a,syncpk)

  parameter (NZ2=1512)
  complex c3a(0:NZ2-1)
  complex c3(0:NZ2-1)
  real a(3),deltaa(3)

  a(1)=0.                                   !f0
  a(2)=0.                                   !f1
  a(3)=0.                                   !f2
  deltaa(1)=1.736
  deltaa(2)=1.736
  deltaa(3)=1.0
  nterms=3

! Start the iteration
  chisqr=0.
  chisqr0=1.e6
  c3=c3a
  a3=a(3)
  do iter=1,4
     do j=1,nterms
        if(a(3).ne.a3) call shft10(c3a,a(3),a3,c3)
        chisq1=fchisq10(c3,npts,fsample,a)
        fn=0.
        delta=deltaa(j)
10      a(j)=a(j)+delta
        if(a(3).ne.a3) call shft10(c3a,a(3),a3,c3)
        chisq2=fchisq10(c3,npts,fsample,a)
        if(chisq2.eq.chisq1) go to 10
        if(chisq2.gt.chisq1) then
           delta=-delta                      !Reverse direction
           a(j)=a(j)+delta
           tmp=chisq1
           chisq1=chisq2
           chisq2=tmp
        endif
20      fn=fn+1.0
        a(j)=a(j)+delta
        if(a(3).ne.a3) call shft10(c3a,a(3),a3,c3)
        chisq3=fchisq10(c3,npts,fsample,a)
        if(chisq3.lt.chisq2) then
           chisq1=chisq2
           chisq2=chisq3
           go to 20
        endif

! Find minimum of parabola defined by last three points
        delta=delta*(1./(1.+(chisq1-chisq2)/(chisq3-chisq2))+0.5)
        a(j)=a(j)-delta
        if(j.lt.3) deltaa(j)=deltaa(j)*fn/3.
!        write(*,4000) iter,j,a,-chisq2
!4000    format(i1,i2,3f10.4,f11.3)
     enddo
     if(a(3).ne.a3) call shft10(c3a,a(3),a3,c3)
     chisqr=fchisq10(c3,npts,fsample,a)
!     write(*,4000) 0,0,a,-chisqr
     if(chisqr/chisqr0.gt.0.99) exit
     chisqr0=chisqr
  enddo

  syncpk=-chisqr
  c3a=c3
!  write(*,4001) a,syncpk
!4001 format(3x,3f10.4,f11.3)

  return
end subroutine afc10

subroutine shft10(c3a,a3a,a3,c3)
  complex c3a(0:1359)
  complex  c3(0:1359)

  a3=a3a
  n=nint(a3)
  c3=cshift(c3a,n)
  if(n.gt.0) c3(1360-n:)=0.0
  if(n.lt.0) c3(:n-1)=0.0

  return
end subroutine shft10

program timefft

! Tests and times one-dimensional FFTs computed by FFTW3

  use, intrinsic :: iso_c_binding
  use FFTW3

  complex(C_FLOAT_COMPLEX),pointer :: a(:),b(:),c(:)
  real(C_FLOAT),pointer :: ar(:),br(:)
  type(C_PTR) :: plan1,plan2              !Pointers to FFTW plans
  type(C_PTR) :: pa,pb,pc
  integer(C_INT) iret
  integer*8 count0,count1,clkfreq
  character problem*9
  logical linplace,lcomplex,lthreading

! Get command-line parameters
  call timefft_opts(npatience,maxthreads,linplace,lcomplex,nfft,problem,nflags)
  lthreading=maxthreads.ge.1
  maxthreads=max(1,maxthreads)

  call sgran()                  ! see C rand generator (used in gran)

! Allocate data arrays
  pa=fftwf_alloc_complex(int(nfft,C_SIZE_T))
  call c_f_pointer(pa,a,[nfft])
  call c_f_pointer(pa,ar,[nfft])

  pb=fftwf_alloc_complex(int(nfft,C_SIZE_T))
  call c_f_pointer(pb,b,[nfft])
  call c_f_pointer(pb,br,[nfft])

  pc=fftwf_alloc_complex(int(nfft,C_SIZE_T))
  call c_f_pointer(pc,c,[nfft])

! Initialize FFTW threading
  if(lthreading) iret=fftwf_init_threads()

! Import FFTW wisdom, if available
  iret=fftwf_import_wisdom_from_filename(C_CHAR_'wis.dat' // C_NULL_CHAR)

  do i=1,nfft                           !Generate random data
     x=gran()
     y=gran()
     b(i)=cmplx(x,y)
  enddo
  iters=100

  write(*,1000) 
1000 format(/'Problem  Threads Plan    Time    Gflops     RMS   iters'/    &
             '--------------------------------------------------------')

! Try nthreads = 1,maxthreads
  do nthreads=1,maxthreads
     a(1:nfft)=b(1:nfft)                             !Copy test data into a()
     call system_clock(count0,clkfreq)
! Make the plans
     if(lthreading) call fftwf_plan_with_nthreads(nthreads)
     if(lcomplex) then
        if(linplace) then
           plan1=fftwf_plan_dft_1d(nfft,a,a,-1,nflags)
           plan2=fftwf_plan_dft_1d(nfft,a,a,+1,nflags)
        else
           plan1=fftwf_plan_dft_1d(nfft,a,c,-1,nflags)
           plan2=fftwf_plan_dft_1d(nfft,c,a,+1,nflags)
        endif
     else
        if(linplace) then
           plan1=fftwf_plan_dft_r2c_1d(nfft,ar,a,nflags)
           plan2=fftwf_plan_dft_c2r_1d(nfft,a,ar,nflags)
        else
           plan1=fftwf_plan_dft_r2c_1d(nfft,ar,c,nflags)
           plan2=fftwf_plan_dft_c2r_1d(nfft,c,ar,nflags)
        endif
     endif
     call system_clock(count1,clkfreq)
     tplan=0.5*float(count1-count0)/float(clkfreq)    !Plan time for one transform

     total=0.
     do iter=1,iters                             !Do many iterations
        a=b                                      !Copy test data into a()
        call system_clock(count0,clkfreq)
! Compute the transforms
        if(lcomplex) then
           if(linplace) then
              call fftwf_execute_dft(plan1,a,a)
              call fftwf_execute_dft(plan2,a,a)
           else
              call fftwf_execute_dft(plan1,a,c)
              call fftwf_execute_dft(plan2,c,a)
           endif
        else
           if(linplace) then
              call fftwf_execute_dft_r2c(plan1,ar,a)
              call fftwf_execute_dft_c2r(plan2,a,ar)
           else
              call fftwf_execute_dft_r2c(plan1,ar,c)
              call fftwf_execute_dft_c2r(plan2,c,ar)
           endif
        endif
        call system_clock(count1,clkfreq)
        total=total + float(count1-count0)/float(clkfreq) 
        if(total>=1.0 .and. iter>=10) go to 40     !Cut iterations short ?
     enddo
     iter=iters

40   time=0.5*total/iter                         !Time for one FFT 
     gflops=5.0/(1.e9*time/(nfft*log(float(nfft))/log(2.0)))
     a(1:nfft)=a(1:nfft)/nfft              !Normalize the back-transformed data

! Compute RMS difference between original data and back-transformed data.
     sq=0.
     if(lcomplex) then
        do i=1,nfft
           sq=sq + real(a(i)-b(i))**2 + aimag(a(i)-b(i))**2
        enddo
     else
        do i=1,nfft
           sq=sq + (ar(i)-br(i))**2
        enddo
     endif
     rms=sqrt(sq/nfft)

! Display results
     write(*,1050) problem,nthreads,tplan,time,gflops,rms,iter
1050 format(a9,i4,f8.3,f10.6,f7.2,f11.7,i5)
  enddo

! Export accumulated FFTW wisdom
  iret=fftwf_export_wisdom_to_filename(C_CHAR_'wis.dat' // C_NULL_CHAR)

! Clean up
  call fftwf_destroy_plan(plan1)
  call fftwf_destroy_plan(plan2)
  call fftwf_free(pa)
  call fftwf_free(pb)
  call fftwf_free(pc)
  call fftwf_cleanup_threads()
  call fftwf_cleanup()

end program timefft

subroutine tone8myc()

  use ft8_mod1, only : idtonemyc,mycall
  character msg37*37,msgsent37*37
  integer itone(79)
  integer*1 msgbits(77)

  msg37=''; msg37=trim(mycall)//' AA1AAA FN25'
  i3=-1; n3=-1
  call genft8(msg37,i3,n3,0,msgsent37,msgbits,itone)
  idtonemyc(1:29)=itone(8:36); idtonemyc(30:58)=itone(44:72)
 
  return
end subroutine tone8myc

! This source code file was last time modified by Igor UA3DJY on June 5th, 2017
! All changes are shown in the patch file coming together with the full JTDX source code.

subroutine peakdt10(c2,nsps8,nspsd,c3,xdt,tryhint,xdtrxf)

  parameter (NZ2=1512,NZ3=1360)
  complex c2(0:NZ2-1)
  complex c3(0:NZ3-1)
  complex z
  real p(0:3300)
  logical(1) tryhint
  include 'jt10sync.f90'

  lag1=39; lag2=291; lag0=123
  p=0.
  i0=5*nspsd
  tsymbol=nsps8/1500.0
  dtlag=tsymbol/nspsd
  
  if(tryhint) then 
     lagpk=nint(xdtrxf/dtlag)+lag0
     xdt=xdtrxf
     goto 2 
  endif

  do i=0,NZ2-1
     z=1.e-3*sum(c2(max(i-(nspsd-1),0):i))
     p(i0+i)=real(z)**2 + aimag(z)**2      !Integrated power per 1/16 of the symbol
  enddo

  smax=0.
  lagpk=0
  do lag=lag1,lag2
     sum0=0.
     sum1=0.
     j=-nspsd
     do i=1,85
        j=j+nspsd
        if(isync(i).eq.1 .or. isync(i).eq.2) then
           sum1=sum1+p(j+lag)
        else
           sum0=sum0+p(j+lag)
        endif
     enddo
     ss=(sum1/16.0)/(sum0/69.0) - 1.0
     xdt=(lag-lag0)*dtlag
     if(ss.gt.smax) then
        smax=ss
        lagpk=lag
     endif
  enddo

  xdt=(lagpk-lag0)*dtlag

2 do i=0,NZ3-1
     j=i+lagpk-i0-nspsd+1
     if(j.ge.0 .and. j.lt.NZ2) then
        c3(i)=c2(j)
     else
        c3(i)=0.
     endif
  enddo
 
  return
end subroutine peakdt10

! This source code file was last time modified by Igor UA3DJY on January 18th, 2017.
! All changes are shown in the patch file coming together with the full JTDX source code.

  integer, parameter :: NTMAX=120
  integer, parameter :: NMAX=NTMAX*12000 !Total sample intervals (one minute)
  integer, parameter :: NDMAX=NTMAX*1500 !Sample intervals at 1500 Hz rate
  integer, parameter :: NSMAX=6827       !Max length of saved spectra
  integer, parameter :: MAXFFT3=16384

! This source code file is last time mofified by Igor UA3DJY on July 22nd, 2017
! All changes are shown in the patch file coming together with the full JTDX source code.

module jt65_mod2

  real s3(64,63),s3a(64,63)
  integer correct(63),correct_hint(63)
  
end module jt65_mod2

subroutine chkss2(ss2,freq,drift,schk)

  real ss2(0:8,85)
  real s(0:8,85)
  include 'jt9sync.f90'

  ave=sum(ss2)/(9*85)
  if(freq+drift.eq.-999999.0) ave=0.      !To silence compiler warning
  s=ss2/ave-1.0

  s1=0.
  do i=1,16
     j=ii(i)
     if(j.le.85) s1=s1 + s(0,j)
  enddo
  schk=s1/16.0

  return
end subroutine chkss2

subroutine twkfreq(c3,c4,npts,fsample,a)

  complex c3(npts)
  complex c4(npts)
  complex w,wstep
  real a(3)
  data twopi/6.283185307/

! Mix the complex signal
  w=1.0
  wstep=1.0
  x0=0.5*(npts+1)
  s=2.0/npts
  do i=1,npts
     x=s*(i-x0)
     p2=1.5*x*x - 0.5
!          p3=2.5*(x**3) - 1.5*x
!          p4=4.375*(x**4) - 3.75*(x**2) + 0.375
     dphi=(a(1) + x*a(2) + p2*a(3)) * (twopi/fsample)
     wstep=cmplx(cos(dphi),sin(dphi))
     w=w*wstep
     c4(i)=w*c3(i)
  enddo

  return
end subroutine twkfreq

subroutine jt9a()
  use, intrinsic :: iso_c_binding, only: c_f_pointer
  use prog_args
!  use timer_module, only: timer
!  use timer_impl, only: init_timer !, limtrace
  use jt65_mod6
  use ft8_mod1, only : dd8
  use ft4_mod1, only : dd4
  include 'jt9com.f90'

! These routines connect the shared memory region to the decoder.
  interface
     function address_jtdxjt9()
       use, intrinsic :: iso_c_binding, only: c_ptr
       type(c_ptr) :: address_jtdxjt9
     end function address_jtdxjt9
  end interface

  integer*1 attach_jtdxjt9
  integer size_jtdxjt9
! Multiple instances:
  character*80 mykey
  type(dec_data), pointer, volatile :: shared_data !also makes target volatile
  type(params_block) :: local_params
  logical fileExists

! Multiple instances:
  i0 = len(trim(shm_key))

!  call init_timer (trim(data_dir)//'/timer.out')
!  open(23,file=trim(data_dir)//'/CALL3.TXT',status='unknown')

!  limtrace=-1                            !Disable all calls to timer()

! Multiple instances: set the shared memory key before attaching
  mykey=trim(repeat(shm_key,1))
  i0 = len(mykey)
  i0=setkey_jtdxjt9(trim(mykey))

  i1=attach_jtdxjt9()

10 inquire(file=trim(temp_dir)//'/.lock',exist=fileExists)
  if(fileExists) then
!     call sleep_msec(100)
     call sleep_msec(10)
     go to 10
  endif


  inquire(file=trim(temp_dir)//'/.quit',exist=fileExists)
  if(fileExists) then
     i1=detach_jtdxjt9()
     go to 999
  endif
  if(i1.eq.999999) stop                  !Silence compiler warning

  nbytes=size_jtdxjt9()
  if(nbytes.le.0) then
     print*,'jt9a: Shared memory mem_jtdxjt9 does not exist.'
     print*,"Must start 'jtdxjt9 -s <thekey>' from within WSJT-X."
     go to 999
  endif
  call c_f_pointer(address_jtdxjt9(),shared_data)
  local_params=shared_data%params !save a copy because jtdx.exe carries on accessing
  call flush(6)

  nnmode=local_params%nmode

  if(local_params%nmode.eq.8) then; npts1=180000
  else if(local_params%nmode.eq.4) then; npts1=73728
  else; npts1=NPTS
  endif

  if(local_params%ndiskdat) then
    if(local_params%nmode.eq.8) then ! nblocks values shall match to ihsym/m_hsymStop in mainwindow
      if(local_params%nswl) then; nblocks=51
      else if(local_params%learlystart) then; nblocks=48
      else; nblocks=49
      endif
      local_params%nzhsym=nblocks; nlastsam=nblocks*3456
      dd(1:nlastsam)=shared_data%id2(1:nlastsam)
      dd(nlastsam+1:npts1)=0.
    else
     dd(1:npts1)=shared_data%id2(1:npts1)
    endif
  else
     if(local_params%nmode.eq.8) then
        rms=sum(abs(shared_data%dd2(1:10)))+sum(abs(shared_data%dd2(76001:76010)))+ &
            sum(abs(shared_data%dd2(151670:151680)))
     else if(local_params%nmode.eq.4) then
        rms=sum(abs(shared_data%dd2(1:10)))+sum(abs(shared_data%dd2(30001:30010)))+ &
            sum(abs(shared_data%dd2(60470:60480)))
     else
        rms=sum(abs(shared_data%dd2(1:10)))+sum(abs(shared_data%dd2(300000:300010)))+ &
            sum(abs(shared_data%dd2(623991:624000)))
     endif
     if(rms.gt.0.001) then
        dd(1:npts1)=shared_data%dd2(1:npts1)
!print *,'win7',rms
     else ! workaround for zero data values of dd2 array under WinXP
        dd(1:npts1)=shared_data%id2(1:npts1)
!print *, 'winxp',rms
     endif
  endif

  if(local_params%nmode.eq.8) then; dd8(1:npts1)=dd(1:npts1)
  else if(local_params%nmode.eq.4) then; dd4(1:npts1)=dd(1:npts1)
  endif

!  call timer('decoder ',0)
  call multimode_decoder(local_params)
!  call timer('decoder ',1)

100 inquire(file=trim(temp_dir)//'/.lock',exist=fileExists)
  if(fileExists) go to 10
  call sleep_msec(100)
  go to 100

999 continue
!    call timer('decoder ',101)

  return
end subroutine jt9a

subroutine zplot9(s,freq,drift)

  real s(0:8,85)
  character*1 line(85),mark(0:6)
  data mark/' ',' ','.','-','+','X','$'/
  include 'jt9sync.f90'

  write(32,1000) freq,drift
1000 format('Freq:',f7.1,'   Drift:',f5.1,'  ',60('-'))
  do j=8,0,-1
     do i=1,85
        n=(s(j,i))
        if(n.lt.0) n=0
        if(n.gt.6) n=6
        line(i)=mark(n)
     enddo
     write(32,1010) j,line
1010 format(i1,1x,85a1)
  enddo
  do i=1,85
     line(i)=' '
     if(isync(i).eq.1) line(i)='@'
  enddo
  write(32,1015)
1015 format(87('-'))
  write(32,1020) line
1020 format(2x,85a1)
  call flush(32)

  return
end subroutine zplot9

! This source code file was last time modified by Igor UA3DJY on July 22nd, 2017
! All changes are shown in the patch file coming together with the full JTDX source code.

subroutine demod64a(mrsym,mrprob,mr2sym,mr2prob)

! Demodulate the 64-bin spectra for each of 63 symbols in a frame.

! Parameters
!    mrsym    most reliable symbol value
!    mr2sym   second most likely symbol value
!    mrprob   probability that mrsym was the transmitted value
!    mr2prob  probability that mr2sym was the transmitted value

  use jt65_mod2, only : s3

  integer mrsym(63),mrprob(63),mr2sym(63),mr2prob(63)

  scale1=255.999

  i1=1                                      !Silence warning
  i2=1

! Compute probabilities for most reliable symbol values
  do j=1,63
     s1=0.0
     psum=0.   ! used for sfrsd metrics
     do i=1,64
        psum=psum+s3(i,j)
        if(s3(i,j).gt.s1) then
           s1=s3(i,j)
           i1=i                              !Most reliable
        endif
     enddo
     if(psum.eq.0.0) psum=1.e-6
     s2=0.0
     do i=1,64
        if(i.ne.i1 .and. s3(i,j).gt.s2) then
           s2=s3(i,j)
           i2=i                              !Second most reliable
        endif
     enddo
     p1=s1/psum                !Use these for sfrsd
     p2=s2/psum                !...
     mrsym(j)=i1-1
     mr2sym(j)=i2-1
     mrprob(j)=scale1*p1
     mr2prob(j)=scale1*p2
  enddo

  return
end subroutine demod64a

subroutine ft4_downsample(newdata,f0,c)

   use ft4_mod1, only : dd4 !,llagcc
   include 'ft4_params.f90'
   parameter (NFFT2=NMAX/NDOWN) ! 4096
   complex c(0:NMAX/NDOWN-1) ! 0:4095
   complex c1(0:NFFT2-1) ! 0:4095
   complex cx(0:NMAX/2)
   real x(NMAX), window(0:NFFT2-1)
   equivalence (x,cx)
   logical first, newdata
   data first/.true./
   save first,window,x

   df=12000.0/NMAX
   baud=12000.0/NSPS
   if(first) then
      bw_transition = 0.5*baud
      bw_flat = 4*baud
      iwt = bw_transition / df
      iwf = bw_flat / df
      pi=4.0*atan(1.0)
      window(0:iwt-1) = 0.5*(1+cos(pi*(/(i,i=iwt-1,0,-1)/)/iwt))
      window(iwt:iwt+iwf-1)=1.0
      window(iwt+iwf:2*iwt+iwf-1) = 0.5*(1+cos(pi*(/(i,i=0,iwt-1)/)/iwt))
      window(2*iwt+iwf:)=0.0
      iws = baud / df
      window=cshift(window,iws)
      first=.false.
   endif

   if(newdata) then
      x=dd4
      call four2a(cx,NMAX,1,-1,0)             !r2c FFT to freq domain
   endif
   i0=nint(f0/df)
   c1=0.
   if(i0.ge.0 .and. i0.le.NMAX/2) c1(0)=cx(i0)
   do i=1,NFFT2/2
      if(i0+i.ge.0 .and. i0+i.le.NMAX/2) c1(i)=cx(i0+i)
      if(i0-i.ge.0 .and. i0-i.le.NMAX/2) c1(NFFT2-i)=cx(i0-i)
   enddo
   c1=c1*window/NFFT2
!   if(.not.llagcc) then; c1(0)=c1(0)*1.9; c1(4095)=c1(4095)*1.9; endif
   c1(0)=c1(0)*1.9; c1(4095)=c1(4095)*1.9
   call four2a(c1,NFFT2,1,1,1)            !c2c FFT back to time domain
   c=c1(0:NMAX/NDOWN-1)

   return
end subroutine ft4_downsample

! This source code file was last time modified by Igor UA3DJY on 20190108

! call may not start from 'Q', zero and two digits
  if(call_a(1:1).eq.'Q' .or. call_b(1:1).eq.'Q') then
    nbadcrc=1; msg37='                                     '; return; endif
  if(call_a(1:1).eq.'0' .or. call_b(1:1).eq.'0') then
    nbadcrc=1; msg37='                                     '; return; endif
  if(call_a(1:1).ge.'0' .and. call_a(1:1).le.'9' .and. call_a(2:2).ge.'0' .and. call_a(2:2).le.'9') then
    nbadcrc=1; msg37='                                     '; return; endif
  if(call_b(1:1).ge.'0' .and. call_b(1:1).le.'9' .and. call_b(2:2).ge.'0' .and. call_b(2:2).le.'9') then
    nbadcrc=1; msg37='                                     '; return; endif

subroutine sort(n,arr)

  integer n,m,nstack
  real arr(n)
  parameter (m=7,nstack=50)
  integer i,ir,j,jstack,k,l,istack(nstack)
  real a,temp

  jstack=0
  l=1
  ir=n
  n0=n

1 if(ir-l.lt.m) then
     do j=l+1,ir
        a=arr(j)
        do i=j-1,1,-1
           if(arr(i).le.a) goto 2
           arr(i+1)=arr(i)
        enddo
        i=0
2       arr(i+1)=a
     enddo

     if(jstack.eq.0) return

     ir=istack(jstack)
     l=istack(jstack-1)
     jstack=jstack-2

  else
     k=(l+ir)/2
     temp=arr(k)
     arr(k)=arr(l+1)
     arr(l+1)=temp

     if(arr(l+1).gt.arr(ir)) then
        temp=arr(l+1)
        arr(l+1)=arr(ir)
        arr(ir)=temp
     endif

     if(arr(l).gt.arr(ir)) then
        temp=arr(l)
        arr(l)=arr(ir)
        arr(ir)=temp
     endif

     if(arr(l+1).gt.arr(l)) then
        temp=arr(l+1)
        arr(l+1)=arr(l)
        arr(l)=temp
     endif

     i=l+1
     j=ir
     a=arr(l)
3    i=i+1
     if(i.gt.n0) then
        do jj=1,n0
           write(99,3001) jj,arr(jj),i,n,ir
3001       format(i10,e12.3,3i10)
        enddo
        close(99)
        stop 'Bounds error in sort.f90'
     endif
     if(arr(i).lt.a) goto 3

4    j=j-1
     if(arr(j).gt.a) goto 4

     if(j.lt.i) goto 5
     temp=arr(i)
     arr(i)=arr(j)
     arr(j)=temp
     goto 3

5    arr(l)=arr(j)
     arr(j)=a
     jstack=jstack+2
     if(jstack.gt.nstack) stop 'nstack too small in sort'

     if(ir-i+1.ge.j-l) then
        istack(jstack)=ir
        istack(jstack-1)=i
        ir=j-1
     else
        istack(jstack)=j-1
        istack(jstack-1)=l
        l=i
     endif

  endif
  goto 1

end subroutine sort

! This source code file was last time modified by Igor UA3DJY on May 29th, 2018
! All changes are shown in the patch file coming together with the full JTDX source code.

subroutine filtersfree(decoded,falsedec)
  
  real datacorr
  character decoded*22,d1*1,d2*2,d3*3,d4*4,d5*5
  logical(1) falsedec

  ndot=0
  nsign=0
  nother=0

  if(decoded(11:12).eq.'73') go to 4
  if(decoded(12:13).eq.'73') go to 4
  if(decoded(1:1).eq.'/') go to 2

  do i=1,13
     d1=decoded(i:i); d2=decoded(i:(i+1)); d3=decoded(i:(i+2)); d4=decoded(i:(i+3)); d5=decoded(i:(i+4))
     if(d2.eq.'73' .or. d2.eq.'TU' .or. d2.eq.'GL') go to 4
!  HA8QJ -07   HA8QJ R-07  
     if(i.gt.4) then
        if((d2.eq.' -' .or. d2.eq.' +') .and. decoded(i+2:i+2).ge.'0' .and. decoded(i+2:i+2).lt.'3') go to 4
        if((d3.eq.' R-' .or. d3.eq.' R+') .and.  decoded(i+3:i+3).ge.'0' .and. decoded(i+3:i+3).lt.'3') go to 4
     endif
     if(d3.eq.'QSL' .or. d3.eq.'TNX' .or. d2.eq.'RR' .or.  &
        d3.eq.'QSO' .or. d3.eq.'CFM' .or. d4.eq.'LOTW' .or. &
        d3.eq.'BND' .or. d3.eq.'QSY' .or. d4.eq.'BAND') go to 4
     if(d3.eq.'MAS' .or. d3.eq.'HNY' .or. d3.eq.'HPY' .or. d3.eq.' DT' .or. &
        d3.eq.'XMS' .or. d5.eq.'EASTE' .or. d5.eq.'PIRAT' .or. d4.eq.'TEST') go to 4
     if(d5.eq.'/HYBR' .or. d5.eq.'/HTML' .or. d5.eq.'/PHOT' .or. d5.eq.'/IMAG' .or. d5.eq.'/JOIN' .or. d5.eq.'QRZ.C' & 
         .or. d4.eq.'/GIF' .or. d4.eq.'/JPG' .or. d4.eq.'/AVI' .or. d4.eq.'/MP4' .or. d4.eq.'/CMD') go to 4
     if(d1.eq.'.') ndot=ndot+1
     if(d1.eq.'-' .or. d1.eq.'+' .or. d1.eq.'?') nsign=nsign+1
     if(d1.eq.'/' .or. d1.eq.'?') nother=nother+1
  enddo

  if(ndot.ge.2 .or. nsign.ge.2 .or. nother.ge.2) go to 2
  if(decoded(1:2).eq.'-0')  go to 2
  if(decoded(1:1).ne.' ' .and. decoded(2:2).eq.' ') go to 2

  if(((decoded(13:13).ge.'A' .and. decoded(13:13).le.'Z') .or.  &
     (decoded(13:13).ge.'0' .and. decoded(13:13).le.'9')) .and. &
     decoded(12:12).eq.' ') go to 2

  if(decoded(1:1).eq.'.' .or. decoded(1:1).eq.'+' .or. decoded(1:1).eq.'?' &
     .or. decoded(1:1).eq.'/' .or. decoded(13:13).eq.'.' .or. decoded(13:13).eq.'+' &
     .or. decoded(13:13).eq.'-' .or. decoded(13:13).eq.'/') go to 2

  if(decoded(2:2).eq.'-' .or. decoded(2:2).eq.'+' .or. decoded(12:12).eq.'.' .or. &
     decoded(12:12).eq.'+' .or. decoded(12:12).eq.'-') go to 2

  if(decoded(12:12).ge.'0' .and. decoded(12:12).le.'9' .and. &
     decoded(13:13).ge.'0' .and. decoded(13:13).le.'9') then

     if(decoded(12:13).ne.'55' .and. decoded(12:13).ne.'73' .and. decoded(12:13).ne.'88') go to 2

  endif
 
  if(decoded(1:1).eq.'0' .and. decoded(2:2).ne.'.') go to 2

  do i=1,12
     if(i.lt.12 .and. decoded(i:i).eq."?" .and. decoded(i+1:i+1).ne." ") go to 2
     if(i.lt.12 .and. decoded(i:i).ne." " .and. decoded(i+1:i+1).eq."+" &
        .and. (decoded(i+2:i+2).le."0" .or. decoded(i+2:i+2).ge."9")) go to 2

     if(decoded(i:i).ge.'A' .and. decoded(i:i).le.'Z' .and. decoded(i+1:i+1).eq.'.' .and. &
        decoded(i+2:i+2).ge.'A' .and. decoded(i+2:i+2).le.'Z') go to 2

     if(decoded(i+1:i+2).eq.'/ ' .or. decoded(i+1:i+2).eq.' /') go to 2

     if(decoded(i:i).ge.'0' .and. decoded(i:i).le.'9' .and. decoded(i+1:i+1).eq.'/' .and. &
        decoded(i+2:i+2).ge.'0' .and. decoded(i+2:i+2).le.'9') go to 2

     if(decoded(i:i).eq.' ' .and. decoded(i+1:i+1).ge.'A' .and. decoded(i+1:i+1).le.'Z' .and.     &
        decoded(i+1:i+1).ne.'F' .and. decoded(i+1:i+1).ne.'G' .and. decoded(i+1:i+1).ne.'I' .and. &
        decoded(i+2:i+2).eq.'/') go to 2

     if(decoded(i:i).eq.' ' .and. decoded(i+1:i+1).ge.'A' .and. decoded(i+1:i+1).le.'Z' .and.     &
        (decoded(i+2:i+2).eq.'.' .or. decoded(i+2:i+2).eq.'+' .or. decoded(i+2:i+2).eq.'-')) go to 2

  enddo

  if(decoded(1:1).eq.'-' .and. decoded(2:2).le.'1' .and. decoded(2:2).ge.'9') go to 2
 
  if(decoded(1:1).ge.'1' .and. decoded(1:1).le.'9' .and.  &
     decoded(2:2).ge.'0' .and. decoded(2:2).le.'9' .and.  &
     decoded(3:3).ge.'0' .and. decoded(3:3).le.'9' .and.  &
     decoded(4:4).ne.'W') go to 2
 
  if(decoded(1:1).ge.'1' .and. decoded(1:1).le.'9' .and.  &
     decoded(2:2).ge.'0' .and. decoded(2:2).le.'9' .and.  &
     decoded(3:3).ne.'W') go to 2

  if(decoded(1:1).ge.'1' .and. decoded(1:1).le.'9' .and.  &
     decoded(2:3).ne.'EL') go to 2

  if(decoded(10:10).ne.'/' .and. decoded(11:11).ne.'/' .and. decoded(12:12).ge.'A' .and. &
     decoded(12:12).le.'Z' .and. decoded(13:13).ge.'0' .and. decoded(12:12).le.'9') go to 2

  call datacor(datapwr,datacorr)

! ban free message if datacorr is less than 1.55
  if(datacorr.lt.1.55) go to 2

  ncount=0
  nchar=0

  do i=1,13
     if(decoded(i:i).eq.' ') exit
     if(decoded(i:i).eq.'/' .or. decoded(i:i).eq.'-' .or. decoded(i:i).eq.'.') nchar=nchar+1
     ncount=ncount+1
  enddo

  if(ncount.eq.13 .and. nchar.ge.0) go to 2  

!print *,"passed"
!print *,decoded

  go to 4

2 falsedec=.true.
!print *,"stopped"
!print *,decoded
 return

4 return
end subroutine filtersfree

! This source code file was last time modified by Igor UA3DJY on July 22nd, 2017
! All changes are shown in the patch file coming together with the full JTDX source code.

subroutine datacor(datapwr,datacorr)

  use jt65_mod2, only : s3,correct

  real datapwr,datacorr

! calculate information tones power and datapower/syncpower ratio
  datapwr=0.0
  do i=1,63
     datapwr=datapwr+s3(correct(i)+1,i)
  enddo

! use short correlation function in time and frequency domains
  timeplus=0.; timeminus=0.; freqplus=0.; freqminus=0.
  do i=1,63
     k=i+1
     m=i-1
     if(i.eq.1) m=2
     if(i.eq.63) k=62
     timeplus=timeplus+s3(correct(i)+1,k)
     timeminus=timeminus+s3(correct(i)+1,m)
     if(correct(i).lt.63) then
        j=1
     else
        j=-1
     endif
     if(correct(i).gt.1) then
        n=-1
     else
        n=1
     endif
     freqplus=freqplus+s3(correct(i)+1+j,i)
     freqminus=freqminus+s3(correct(i)+1+n,i)
  enddo
  datacorr=datapwr*4.0/(timeplus+timeminus+freqplus+freqminus)

  return
end subroutine datacor

integer function savec2(c2name,ntrseconds,f0m1500)

! Array c0() has complex samples at 1500 Hz sample rate.
! WSPR-2:  downsample by 1/4 to produce c2, centered at 1500 Hz
! WSPR-15: downsample by 1/32 to produce c2, centered at 1612.5 Hz

  parameter (NDMAX=120*1500)         !Sample intervals at 1500 Hz rate
  parameter (MAXFFT=256*1024)

  character*(*) c2name
  character*14 outfile
  real*8 f0m1500
  complex c0
  complex c1(0:MAXFFT-1)
  complex c2(0:65535)
  common/c0com/c0(0:NDMAX-1)

  ntrminutes=ntrseconds/60
  npts=114*1500
  nfft1=262144
  if(ntrminutes.eq.15) then
     npts=890*1500
     nfft1=MAXFFT
  endif
  df1=1500.0/nfft1
  fac=1.0/nfft1
  c1(0:npts-1)=fac*c0(0:npts-1)
  c1(npts:nfft1-1)=0.

  call four2a(c1,nfft1,1,1,1)                 !Complex FFT to frequency domain

! Select the desired frequency range
  nfft2=65536
  nh2=nfft2/2
  if(ntrminutes.eq.2) then
     c2(0:nh2)=c1(0:nh2)
     c2(nh2+1:nfft2-1)=c1(nfft1-nh2+1:nfft1-1)
  else
     i0=nint(112.5/df1)
     c2(0:nh2)=c1(i0:i0+nh2)
     c2(nh2+1:nfft2-1)=c1(i0-nh2+1:i0-1)
  endif

  call four2a(c2,nfft2,1,-1,1)      !Shorter complex FFT, back to time domain

! Write complex time-domain data to disk.
  i1=index(c2name,'.c2')
  outfile=c2name(i1-11:i1+2)
  open(18,file=c2name,status='unknown',access='stream', iostat=ioerr)
  if (ioerr.eq.0) then
     write(18) outfile,ntrminutes,f0m1500,c2(0:45000-1)
     close(18)
  endif
  savec2 = ioerr
end function savec2

! This source code file was last time modified by Igor UA3DJY on June 19th, 2017
! All changes are shown in the patch file coming together with the full JTDX source code.

module jt65_mod
  integer param(0:5)
  integer mrs(63),mrs2(63)
  save
end module jt65_mod

! This source code file was last time modified by Igor UA3DJY on February 28th, 2017
! All changes are shown in the patch file coming together with the full JTDX source code.

subroutine setup65

! Defines arrays related to the JT65 pseudo-random synchronizing pattern.
! Executed at program start.

 use jt65_mod4
 integer nsym,nsig
 data mr2/0/                !Silence compiler warning

  nsym=126

! Determine locations of data and reference symbols
  k=0
  mr1=0
  do i=1,nsym
     if(.not.prc(i)) then
        k=k+1
        mdat(k)=i
     else
        mr2=i
        if(mr1.eq.0) mr1=i
     endif
  enddo
  nsig=k

! Determine the reference symbols for each data symbol.
  do k=1,nsig
     m=mdat(k)
     mref(k,1)=mr1
     do n=1,10                     !Get ref symbol before data
        if((m-n).gt.0) then
           if (prc(m-n)) go to 10
        endif
     enddo
     go to 12
10   mref(k,1)=m-n
12   mref(k,2)=mr2
     do n=1,10                     !Get ref symbol after data
        if((m+n).le.nsym) then
           if (prc(m+n)) go to 20
        endif
     enddo
     cycle
20   mref(k,2)=m+n
  enddo

  return
end subroutine setup65

subroutine interleave9(ia,ndir,ib)
  integer*1 ia(0:205),ib(0:205)
  integer j0(0:205)
  logical first
  data first/.true./
  save first,j0                     !Save not working, or j0 overwritten ???

  if(first) then
     k=-1
     do i=0,255
        m=i
        n=iand(m,1)
        n=2*n + iand(m/2,1)
        n=2*n + iand(m/4,1)
        n=2*n + iand(m/8,1)
        n=2*n + iand(m/16,1)
        n=2*n + iand(m/32,1)
        n=2*n + iand(m/64,1)
        n=2*n + iand(m/128,1)
        if(n.le.205) then
           k=k+1
           j0(k)=n
        endif
     enddo
!     first=.false.
  endif

  if(ndir.gt.0) then
     do i=0,205
        ib(j0(i))=ia(i)
     enddo
  else
     do i=0,205
        ib(i)=ia(j0(i))
     enddo
  endif

  return
end subroutine interleave9

! This source code file was last time modified by Igor UA3DJY on July 26th, 2017
! All changes are shown in the patch file coming together with the full JTDX source code.

subroutine sync65(ss,ss22,fmask,nfa,nfb,ncand,npass1, &
                  nfqso,hint_on,nfhinted,thresh0,ncandth25,ipass)

  use jt65_mod11
  use jt65_mod4

  implicit none
  integer, parameter :: NSZ=3413,NFFT=8192,NHSYM=276,lag1=-21,lag2=75  
!  real ss(:,:),ss22(:,:)
  real ccfblue(lag1:lag2),ccfblue22(lag1:lag2)           !CCF with pseudorandom sequence
  real ccfred(0:NSZ),ccfred22(0:NSZ)                 !Peak of ccfblue, as function of freq
  real fmask(15)
  real xlag,freq_i,tp,dx2,xmed,xmed22,df,dtx,ccfmax,ccfmax22,thresh0,dtxsync,fmaskdelta, &
       ffreq,fmasklow,fmaskhigh,deltaf,fnfqa,fnfqb,ccfpwrh,ccfpwr1h,ccfpwr2h
  integer k,l,m,nfqa,nfqb,nmaxloc,ntail_highhs,ntail_lowhs,ncandtmp, &
          nmaxcand,ia,ib,nfa,nfb,lagpk,lagpk22,ipass,ii, &
          nfqso,ncand,ncandth25,i,ifreq,nfhinted,itry,j,lagpeak
  logical(1) hint_on,qsofreq,ccfredth1,ccfredth08,ccfred22th08,ccfredth0,ccfred22th0, &
             npass1,lskip1

  type tmpcandidate
     real freq
     real dt
     real sync
     real tail_pwr
     real dtsync
  end type tmpcandidate
  type(tmpcandidate) catemp(MAXCAND)

  real, DIMENSION(:,:), ALLOCATABLE :: ss
  real, DIMENSION(:,:), ALLOCATABLE :: ss22

  interface
    subroutine xcor(ss,ss22,ifreq,ccfblue,lagpk,ccfblue22,lagpk22)
      real ss(:,:)
      real ss22(:,:)
      integer ifreq,lagpk,lagpk22
      real ccfblue(-21:75),ccfblue22(-21:75)
    end subroutine xcor
  end interface
  
  nfqa=nfqso-nfhinted
  nfqb=nfqso+nfhinted
  df=12000.0/NFFT                            !df = 12000.0/8192 = 1.465 Hz
  ia=max(2,nint(nfa/df)) ! 2 if lowest watefall frequesncy set to 0 Hz
  ib=min(NSZ-1,nint(nfb/df)) ! min(3412, nfb/1.465)  not more than 3412, if nfb 3740 ib=2552
  ncand=0; ncandtmp=0; ncandth25=0; ccfred=0.; ccfblue=0.; dtxsync=0.
  ccfmax=0.; ccfred22=0.; ccfblue22=0.; ccfmax22=0.; xlag=0.; catemp%tail_pwr=0.
  ca%freq=0.; ca%dt=0.; ca%sync=0.; catemp%freq=0.; catemp%dt=0.; catemp%sync=0.; catemp%dtsync=0.
  qsofreq=.false.; lagpeak=0

  fmaskdelta=2.0
  
  do i=ia,ib ! i=2,2552 for my waterfall settings or every 1.465 Hz

     if(ipass.eq.2 .or. ipass.eq.3) then
        lskip1=.true.
        do ii=1,15
           if(fmask(ii).lt.0.0) exit
           ffreq=float(i)*df
           fmasklow=fmask(ii)-fmaskdelta; fmaskhigh=fmask(ii)+fmaskdelta
           if(ffreq.gt.fmasklow .and. ffreq.lt.fmaskhigh) then
              lskip1=.false.; exit
           endif
        enddo
        if(lskip1) cycle
     endif

     ifreq=i
     call xcor(ss,ss22,ifreq,ccfblue,lagpk,ccfblue22,lagpk22)
     ! Remove best-fit slope from ccfblue and normalize so baseline rms=1.0
     call slope(ccfblue(lag1:lag2),lag2-lag1+1,lagpk-lag1+1.0)
     call slope(ccfblue22(lag1:lag2),lag2-lag1+1,lagpk22-lag1+1.0)
     ccfred(i)=ccfblue(lagpk)
     if(ccfred(i).gt.ccfmax) then
        ccfmax=ccfred(i)
     endif
     ccfred22(i)=ccfblue22(lagpk22)
     if(ccfred22(i).gt.ccfmax22) then
        ccfmax22=ccfred22(i)
     endif
  enddo
 
  call pctile(ccfred(ia:ib),ib-ia+1,35,xmed)
  ccfred(ia:ib)=ccfred(ia:ib)-xmed
  ccfred(ia-1)=ccfred(ia)
  ccfred(ib+1)=ccfred(ib)
  
  call pctile(ccfred22(ia:ib),ib-ia+1,35,xmed22)
  ccfred22(ia:ib)=ccfred22(ia:ib)-xmed22
  ccfred22(ia-1)=ccfred22(ia)
  ccfred22(ib+1)=ccfred22(ib)

  do i=ia,ib

     if(ipass.eq.2 .or. ipass.eq.3) then
        lskip1=.true.
        do ii=1,15
           if(fmask(ii).lt.0.0) exit
           ffreq=float(i)*df
           fmasklow=fmask(ii)-fmaskdelta; fmaskhigh=fmask(ii)+fmaskdelta
           if(ffreq.gt.fmasklow .and. ffreq.lt.fmaskhigh) then
              lskip1=.false.; exit
           endif
        enddo
        if(lskip1) cycle
     endif

     ifreq=i
     freq_i=float(i)*df
     itry=0
     qsofreq=.false.
 deltaf=abs(freq_i-float(nfqso))
 if(hint_on .and. deltaf.lt.1.0) then
    if(ccfred(i).gt.0.4 .or. ccfred22(i).gt.0.4) then
            if(ccfred(i).ge.ccfred22(i)) then
                itry=2
            else
                itry=4
            endif
        ncandtmp=ncandtmp+1
        qsofreq=.true.
        go to 32
    endif
 endif

  ccfredth1=.false.
  if(ccfred(i).gt.1.0 .or. ccfred22(i).gt.1.0) ccfredth1=.true.
  deltaf=abs(freq_i-float(nfqso))
  if(.not.hint_on .and. deltaf.lt.1.0 .and. ccfredth1) then
            if(ccfred(i).ge.ccfred22(i)) then
                itry=2
            else
                itry=4
            endif
        ncandtmp=ncandtmp+1
        qsofreq=.true.
        go to 32
 endif

 fnfqa=float(nfqa); fnfqb=float(nfqb)
 if(hint_on .and. freq_i.gt.fnfqa .and. freq_i.lt.fnfqb) then
    ccfredth08=.false.
    ccfred22th08=.false.
    if(ccfred(i).gt.0.8 .and. ccfred(i).gt.ccfred(i-1) .and.          &
        ccfred(i).gt.ccfred(i+1)) ccfredth08=.true.
    if(ccfred22(i).gt.0.8 .and. ccfred22(i).gt.ccfred22(i-1) .and.    &
        ccfred22(i).gt.ccfred22(i+1)) ccfred22th08=.true.
    if(ccfredth08 .or. ccfred22th08) then
            if(ccfred(i).ge.ccfred22(i)) then
                itry=2
            else
                itry=4
            endif
        ncandtmp=ncandtmp+1
        qsofreq=.true.
        go to 32
    endif
 endif

 ccfredth0=.false.
 ccfred22th0=.false.
 if(ccfred(i).ge.thresh0 .and. ccfred(i).gt.ccfred(i-1) .and.       &
             ccfred(i).gt.ccfred(i+1)) ccfredth0=.true.
 if(ccfred22(i).ge.thresh0 .and. ccfred22(i).gt.ccfred22(i-1) .and. &
 ccfred22(i).gt.ccfred22(i+1)) ccfred22th0=.true.
 if(ccfredth0 .or. ccfred22th0) then
   if(ccfred(i).ge.ccfred22(i)) then
     itry=2
   else
     itry=4
   endif
 ncandtmp=ncandtmp+1
 ! number of candidates above ccf threshold 2.5
 if(ccfred(i).gt.2.5 .or. ccfred22(i).gt.2.5) ncandth25=ncandth25+1
 endif

32   if(itry.ne.0) then
        call xcor(ss,ss22,ifreq,ccfblue,lagpk,ccfblue22,lagpk22)
        if(itry.eq.2) then
            call slope(ccfblue(lag1:lag2),lag2-lag1+1,lagpk-lag1+1.0)
            xlag=lagpk; lagpeak=lagpk
            if(lagpk.gt.lag1 .and. lagpk.lt.lag2) then
               call peakup(ccfblue(lagpk-1),ccfmax,ccfblue(lagpk+1),dx2)
               xlag=lagpk+dx2
            endif
        endif
        if(itry.eq.4) then    
            call slope(ccfblue22(lag1:lag2),lag2-lag1+1,lagpk22-lag1+1.0)
            xlag=lagpk22; lagpeak=lagpk22
            if(lagpk22.gt.lag1 .and. lagpk22.lt.lag2) then
               call peakup(ccfblue22(lagpk22-1),ccfmax22,ccfblue22(lagpk22+1),dx2)
               xlag=lagpk22+dx2
            endif
        endif

        dtx=xlag*2048.0/11025.0
        ccfblue(lag1)=0.; ccfblue(lag2)=0.; ccfblue22(lag1)=0.; ccfblue22(lag2)=0.
        tp=0.0
        if(dtx.gt.-2.4 .and. dtx.lt.8.4) then ! DT range limited to -5.3....5.3 sec
           ntail_lowhs=253+int((dtx-3.0)/0.186)
           ntail_highhs=269+int((dtx-3.0)/0.186)
           if(ntail_highhs.gt.322) ntail_highhs=322
           if(ntail_highhs.le.276) then
              tp=sum(ss(ntail_lowhs:ntail_highhs,i))
           else
              tp=sum(ss(ntail_lowhs:276,i))
             do k=277,ntail_highhs
               tp=tp+ss(276,i)
             enddo
           endif
           tp=tp*ccfred(i)

           !one more criterion to sort candidate list, -0.5...+1.0 DT range have highest priority 
           if(dtx.gt.2.4 .and. dtx.lt.4.1) dtxsync=ccfred(i)*5.31
           if(dtx.ge.4.1) dtxsync=ccfred(i)*(1.0+(8.41-dtx))
           if(dtx.le.2.4 .and. dtx.ge.0.0) dtxsync=ccfred(i)*(5.31-(2.4-dtx))
           if(dtx.lt.0.0) dtxsync=ccfred(i)*(2.91+dtx*0.795)

           ccfpwrh=0.; ccfpwr1h=0.; ccfpwr2h=0.
           do k=1,126 !number of symbols
              j=2*k-1+lagpeak
              if(j.ge.1 .and. j.le.nhsym) then
                 if(prc(k)) then
                    if(k.le.63) then
                       ccfpwr1h=ccfpwr1h + ss(j,i)
                    else
                       ccfpwr2h=ccfpwr2h + ss(j,i)
                    endif
                 endif
              endif
           enddo
           ccfpwrh=max(ccfpwr1h,ccfpwr2h)
           tp=tp+ccfpwrh

           catemp(ncandtmp)%freq=freq_i
           catemp(ncandtmp)%dt=dtx
           catemp(ncandtmp)%sync=ccfred(i)
           catemp(ncandtmp)%tail_pwr=tp
           catemp(ncandtmp)%dtsync=dtxsync
        else
           ncandtmp=ncandtmp-1
        endif
  endif
    if(ncandtmp.eq.MAXCAND) exit
  enddo
! now making candidate list
! put QSO frequency candidates at first positions of the list
   if(qsofreq) then
    fnfqa=float(nfqa); fnfqb=float(nfqb)
    do l=1,ncandtmp
     if(catemp(l)%freq.gt.fnfqb) exit
     if(catemp(l)%freq.gt.fnfqa .and. catemp(l)%freq.lt.fnfqb .and. catemp(l)%sync.gt.0.5) then
       ncand=ncand+1
       ca(ncand)%freq=catemp(l)%freq
       ca(ncand)%dt=catemp(l)%dt
       ca(ncand)%sync=catemp(l)%sync
       catemp(l)%tail_pwr=0.
       catemp(l)%sync=0.
       catemp(l)%dtsync=0.
     endif
    enddo
   endif

    nmaxcand=0
    nmaxloc=0

    if(npass1) nmaxcand=min(150,ncandtmp)
    if(.not.npass1) nmaxcand=min(35,ncandtmp)

! make candidate list for the first pass if band is crowded using (ccf * tail power) as criterion
if(npass1 .and. ncandth25.gt.8) then
    do m=1,nmaxcand
       nmaxloc=MAXLOC(catemp%tail_pwr,dim=1)   !getting index of tail_pwr with maximum value
       if(abs(catemp(nmaxloc)%tail_pwr).lt.0.001) cycle !if value of tail_pwr eq 0. then cycle loop
          ncand=ncand+1
          ca(ncand)%freq=catemp(nmaxloc)%freq
          ca(ncand)%dt=catemp(nmaxloc)%dt
          ca(ncand)%sync=catemp(nmaxloc)%sync
          catemp(nmaxloc)%tail_pwr=0.
          catemp(nmaxloc)%sync=0.
    enddo
    if(qsofreq) then !put qso frequency candidate also at end of the list to benefit from subtraction 
       ncand=ncand+1
       ca(ncand)%freq=ca(1)%freq
       ca(ncand)%dt=ca(1)%dt
       ca(ncand)%sync=ca(1)%sync
    endif
    go to 2
endif

! make candidate list for the first pass if band is not crowded using ccf value as criterion
if(npass1 .and. ncandth25.le.8) then
  do m=1,nmaxcand
    nmaxloc=MAXLOC(catemp%sync,dim=1)   !getting index of sync with maximum value
    if(abs(catemp(nmaxloc)%sync).lt.0.001) cycle !if value of sync eq 0. then cycle loop
       ncand=ncand+1
       ca(ncand)%freq=catemp(nmaxloc)%freq
       ca(ncand)%dt=catemp(nmaxloc)%dt
       ca(ncand)%sync=catemp(nmaxloc)%sync
       catemp(nmaxloc)%sync=0.
  enddo
    go to 2
endif

! make candidate list for passes 2...4 using (ccf * dt) criterion
if(.not.npass1) then
  do m=1,nmaxcand
    nmaxloc=MAXLOC(catemp%dtsync,dim=1)   !getting index of sync with maximum value
    if(abs(catemp(nmaxloc)%sync).lt.0.001) cycle !if value of sync eq 0. then cycle loop
    if(abs(catemp(nmaxloc)%dtsync).lt.0.001) cycle !if value of dtsync eq 0. then cycle loop
       ncand=ncand+1
       ca(ncand)%freq=catemp(nmaxloc)%freq
       ca(ncand)%dt=catemp(nmaxloc)%dt
       ca(ncand)%sync=catemp(nmaxloc)%sync
       catemp(nmaxloc)%sync=0.
       catemp(nmaxloc)%dtsync=0.
  enddo
! put first QSO freq candidate also at end of the list to benefit from subtraction 
    if(qsofreq .and. ncandth25.gt.8) then 
       ncand=ncand+1
       ca(ncand)%freq=ca(1)%freq
       ca(ncand)%dt=ca(1)%dt
       ca(ncand)%sync=ca(1)%sync
    endif
endif
2 continue
 return
end subroutine sync65

! This source code file was last time modified by Igor UA3DJY on 20181215
! All changes are shown in the patch file coming together with the full JTDX source code.

program JT65code

! Provides examples of message packing, bit and symbol ordering,
! Reed Solomon encoding, and other necessary details of the JT65
! protocol.

  use packjt
  character*22 msg,msg0,msg1,decoded,cok*3,bad*1,msgtype*10
  integer dgen(12),sent(63),tmp(63),recd(12),era(51)
  include 'testmsg.f90'

  nargs=iargc()
  if(nargs.ne.1) then
     print*,'Usage: jt65code "message"'
     print*,'       jt65code -t'
     go to 999
  endif

  call getarg(1,msg)                     !Get message from command line
  nmsg=1
  if(msg(1:2).eq."-t") then
     testmsg(NTEST+1)="KA1ABC WB9XYZ EN34 OOO"
     testmsg(NTEST+2)="KA1ABC WB9XYZ OOO"
     testmsg(NTEST+3)="RO"
     testmsg(NTEST+4)="RRR"
     testmsg(NTEST+5)="73"
     nmsg=NTEST+5
  endif

  write(*,1010)
1010 format("     Message                 Decoded                Err? Type"/   &
            74("-"))

  do imsg=1,nmsg
     if(nmsg.gt.1) msg=testmsg(imsg)

     call fmtmsg(msg,iz)                    !To upper, collapse mult blanks
     msg0=msg                               !Input message
     call chkmsg(msg,cok,nspecial,flip)     !See if it includes "OOO" report
     msg1=msg                               !Message without "OOO"

     if(nspecial.gt.0) then                  !or is a shorthand message
        if(nspecial.eq.2) decoded="RO"
        if(nspecial.eq.3) decoded="RRR"
        if(nspecial.eq.4) decoded="73"
        itype=-1
        msgtype="Shorthand"
        go to 10
     endif

     call packmsg(msg1,dgen,itype)           !Pack message into 12 six-bit bytes
     msgtype=""
     if(itype.eq.1) msgtype="Std Msg"
     if(itype.eq.2) msgtype="Type 1 pfx"
     if(itype.eq.3) msgtype="Type 1 sfx"
     if(itype.eq.4) msgtype="Type 2 pfx"
     if(itype.eq.5) msgtype="Type 2 sfx"
     if(itype.eq.6) msgtype="Free text"

     call rs_encode(dgen,sent)               !RS encode
     call interleave63(sent,1)               !Interleave channel symbols
     call graycode(sent,63,1,sent)           !Apply Gray code

     call graycode(sent,63,-1,tmp)           !Remove Gray code
     call interleave63(tmp,-1)               !Remove interleaving
     call rs_decode(tmp,era,0,recd,nerr)     !Decode the message
     call unpackmsg(recd,decoded)            !Unpack the user message
     if(cok.eq."OOO") decoded(20:22)=cok
     call fmtmsg(decoded,iz)

10     bad=" "
     if(decoded.ne.msg0) bad="*"
     write(*,1020) imsg,msg0,decoded,bad,itype,msgtype
1020 format(i2,'.',2x,a22,2x,a22,3x,a1,i3,": ",a13)
  enddo

  if(nmsg.eq.1 .and. nspecial.eq.0) then
     write(*,1030) dgen
1030 format(/'Packed message, 6-bit symbols ',12i3) !Display packed symbols

     write(*,1040) sent
1040 format(/'Information-carrying channel symbols'/(i5,20i3))
  endif

999 end program JT65code

program stats

  character*8 arg
  character*40 infile
  character decoded*22

  nargs=iargc()
  if(nargs.lt.1) then
     print*,'Usage: stats file1 ...'
     go to 999
  endif

  ttol=0.1
  nftol=1
  write(*,1000)
1000 format(' SNR  Files  Sync    BM    FT  Hint Total  False BadSync'/  &
          56('-'))

  do ifile=1,nargs
     call getarg(ifile,infile)
     open(10,file=infile,status='old')
     i1=index(infile,".")+1
     i2=40
     if(index(infile,"_").gt.1) i2=index(infile,"_") - 1
     snrgen=0.
     read(infile(i1:i2),*,err=1) snrgen
1     snrgen=-snrgen
     nsynced=0
     nbm=0
     nftok=0
     nhint=0
     ngood=0
     nbad=0
     nbadsync=0

     do iline=1,999999
        read(10,1010,end=100) nutc,sync,nsnr,dt,nfreq,ncandidates,nhard,  &
             ntotal,rtt,ntry,nft,nqual,decoded
1010    format(i4.4,f5.1,i4,f5.1,i5,i6,i3,i4,f6.3,i8,i2,i3,1x,a22)

        ndfreq=abs(nfreq-1500)
        if(sync.ge.1.0 .and. abs(dt).le.ttol .and. ndfreq.le.nftol) then
           nsynced=nsynced+1
        else
           nbadsync=nbadsync+1
        endif

        if(decoded.eq.'                      ') cycle
        if(nft.eq.2 .or. (ntotal.le.81 .and. rtt.le.0.87)) then       !nag=0
           if(decoded(1:11).eq.'K1ABC W9XYZ') then
              ngood=ngood+1
              if(nft.eq.1 .and. ncandidates.eq.0) nbm=nbm+1
              if(nft.eq.1) nftok=nftok+1
              if(nft.ge.2) nhint=nhint+1
           else
              nbad=nbad+1
           endif
        endif
     enddo

100  write(*,1100) snrgen,nutc,nsynced,nbm,nftok,nhint,ngood,nbad,   &
          nbadsync
1100 format(f5.1,8i6)
  enddo

999 end program stats

subroutine gen_ft8wave(itone,nsym,nsps,bt,fsample,f0,cwave,wave,icmplx,nwave)
!
! generate ft8 waveform using Gaussian-filtered frequency pulses.
!
  parameter(MAX_SECONDS=20,NTAB=65536)
  real wave(nwave)
  complex cwave(nwave),ctab(0:NTAB-1)
  real pulse(23040)
  real dphi(0:(nsym+2)*nsps-1)
  integer itone(nsym)
  data ibt0/0/
  save pulse,twopi,dt,hmod,ibt0,ctab

  ibt=nint(10*bt)
  if(ibt0.ne.ibt) then
     twopi=8.0*atan(1.0)
     dt=1.0/fsample
     hmod=1.0
! Compute the frequency-smoothing pulse
     do i=1,3*nsps
        tt=(i-1.5*nsps)/real(nsps)
        pulse(i)=gfsk_pulse(bt,tt)
     enddo
     ibt0=nint(10*bt)
     do i=0,NTAB-1
        phi=i*twopi/NTAB
        ctab(i)=cmplx(cos(phi),sin(phi))
     enddo
  endif

! Compute the smoothed frequency waveform.
! Length = (nsym+2)*nsps samples, first and last symbols extended 
  dphi_peak=twopi*hmod/real(nsps)
  dphi=0.0 
  do j=1,nsym         
     ib=(j-1)*nsps
     ie=ib+3*nsps-1
     dphi(ib:ie) = dphi(ib:ie) + dphi_peak*pulse(1:3*nsps)*itone(j)
  enddo
! Add dummy symbols at beginning and end with tone values equal to 1st and last symbol, respectively
  dphi(0:2*nsps-1)=dphi(0:2*nsps-1)+dphi_peak*itone(1)*pulse(nsps+1:3*nsps)
  dphi(nsym*nsps:(nsym+2)*nsps-1)=dphi(nsym*nsps:(nsym+2)*nsps-1)+dphi_peak*itone(nsym)*pulse(1:2*nsps)

! Calculate and insert the audio waveform
  phi=0.0
  dphi = dphi + twopi*f0*dt                      !Shift frequency up by f0
  if(icmplx .eq. 0) wave=0.
  if(icmplx .ne. 0) cwave=0. !Avoid writing to memory we may not have access to

  k=0
  do j=nsps,nsps+nwave-1                         !Don't include dummy symbols
     k=k+1
     if(icmplx.eq.0) then
        wave(k)=sin(phi)
     else
        i=phi*float(NTAB)/twopi
        cwave(k)=ctab(i)
     endif
     phi=mod(phi+dphi(j),twopi)
  enddo

! Apply envelope shaping to the first and last symbols
  nramp=nint(nsps/8.0)
  if(icmplx.eq.0) then
     wave(1:nramp)=wave(1:nramp) *                                          &
          (1.0-cos(twopi*(/(i,i=0,nramp-1)/)/(2.0*nramp)))/2.0
     k1=nsym*nsps-nramp+1
     wave(k1:k1+nramp-1)=wave(k1:k1+nramp-1) *                              &
          (1.0+cos(twopi*(/(i,i=0,nramp-1)/)/(2.0*nramp)))/2.0
  else
     cwave(1:nramp)=cwave(1:nramp) *                                        &
          (1.0-cos(twopi*(/(i,i=0,nramp-1)/)/(2.0*nramp)))/2.0
     k1=nsym*nsps-nramp+1
     cwave(k1:k1+nramp-1)=cwave(k1:k1+nramp-1) *                            &
          (1.0+cos(twopi*(/(i,i=0,nramp-1)/)/(2.0*nramp)))/2.0
  endif

  return
end subroutine gen_ft8wave

subroutine getlags(nsps8,lag0,lag1,lag2)
  if(nsps8.eq.864) then
     lag1=39
     lag2=291
     lag0=123
  else if(nsps8.eq.1920) then
     lag1=70
     lag2=184
     lag0=108
  else if(nsps8.eq.5120) then
     lag1=84
     lag2=129
     lag0=99
  else if(nsps8.eq.10368) then
     lag1=91
     lag2=112
     lag0=98
  else if(nsps8.eq.31500) then
     lag1=93
     lag2=102
     lag0=96
  else 
     stop 'Error in getlags'
  endif

  return
end subroutine getlags

! This source code file was last time modified by Igor UA3DJY on April 13th, 2017
! All changes are shown in the patch file coming together with the full JTDX source code.

module jt9_mod2

  integer, parameter :: MAXCANDRXF=5, MAXCAND=200

  type candrxf
     real ccfred
     integer i
  end type candrxf
  type(candrxf) carxf(MAXCANDRXF)

  type candidate
     real ccfred
     integer i
  end type candidate
  type(candidate) ca(MAXCAND)
  
end module jt9_mod2

subroutine extract(s3b,s3c,ntrials,hint_on,mycall_12,hiscall_12,hisgrid,  &
           msg_decoded,decoded,freemsg,nft,hintedrxfreq,hint,npass1, &
           hintedw,bypass_hintcq,bypass_hintall,bypass_ftrsd,nstophint, &
           hinteddyn,dt,hintedrxfdt,syncpwr,nlasttx,ipass,sync2,isfalse,jt65bc, &
           nharmonicsdepth,showharmonics)

! Input:
!   s3       64-point spectra for each of 63 data symbols

! Output:
!   msg_decoded  true if message is decoded
!   nhist    maximum number of identical symbol values
!   decoded  decoded message (if ncount >=0)
!   freemsg    true if decoded message is free text
!   nft      0=no decode; 1=FT decode; 2=hinted decode

! nlasttx last transmitted message matrix
! nlasttx   last TX message  expected RX message
!   0           Halt TX              -
!   1           GRID             -01, CQ
!   2           -01                R-01, and might be again GRID
!   3           R-01            RRR/RR73/73,  and might be again -01
!   4           RRR/RR73        RRR/RR73/73
!   5           73/freemsg      RRR/RR73/73
!   6           CQ              GRID fm CALL3
!   8           freemsg         RRR/RR73/73

! nlastrx last received message matrix, used for wideband hintdyn decoder, dynhint(300) structure
! nlastrx   last RX message   / dinterval1 expected inversed msg / dinterval2 expected RX message
!   0           initialization/               none              / none
!   1           GRID          /               -01               / R-01, and might be again GRID
!   2           -01           /               R-01              / RRR/RR73/73, and might be again -01
!   3           R-01          /               RRR/RR73/73       / RRR/RR73/73,  and might be again R-01
!   4           RRR/RR73/73   /               RRR/RR73/73       / none

  use, intrinsic :: iso_c_binding
  use packjt
  use jt65_mod2 ! s3(64,63),s3a(64,63),correct(63), correct_hint(63)
  use jt65_mod8 !  dynhint(300),dynhintcq(150),rxfreq(20),rxfchg(1),ninterval,freq,maxsync2,maxsync2freq
  use timer_module, only: timer

  character decoded*22,mycall*6,hiscall*6,hisgrid4*4,hint*1,mycall_12*12,hiscall_12*12,hisgrid*6, &
            call1*6,call2*6,call1_old*6,call2_old*6,direction*2,callsign*6,grid*4,directionrxf*2,grid2*4,&
            isfalse*1,mycall12*12
  integer dat4(12),mrsym(63),mr2sym(63),mrprob(63),mr2prob(63),tmp(63),param(0:5),mrs(63),mrs2(63), &
          mrsymb(63),mr2symb(63),mrprobb(63),mr2probb(63)
  integer nft,nfail,nbirdie,npct,ncand,nlastrx
  logical(1) hintedrxfreq,hintedw,freemsg,hint_on,msg_decoded,hint_call3,hint_wide,hint_dx,&
             bypass_hintcq,bypass_hintall,bypass_ftrsd,npass1,ftrsd_cfmd, &
             falsedec,nstophint,hint_dyn,hinteddyn,hinteddyncq,hintedrxfdt,inverse,lhiscall, &
             jtbcand,jtccand,jt65bc(2),showharmonics
  real s3b(64,63),s3c(64,63),s3temp(64,63),syncpwr

  call1_old=' '; call2_old=' '
  mycall=mycall_12(1:6)
  mycall12='' !not used in chkfalse() for JT65
  hiscall=hiscall_12(1:6)
  hisgrid4=hisgrid(1:4)
  npct=50
  nft=0
  nfail=0
  decoded='                      '
  hinteddyncq=.true.; inverse=.false.; jtbcand=.false.; jtccand=.false.; jt65bc=.false.
  nvect=ntrials
  sdratio=1.0; sdratiob=0.0; sdratioc=0.0

 ! nstophint=.false. ! dedicated for tests only, comment this line for SW release
 ! bypass_ftrsd=.true. ! dedicated for tests only, comment this line for SW release
 ! bypass_hintcq=.true. ! dedicated for tests only, comment this line for SW release
 ! hinteddyn=.false. ! dedicated for tests only, comment this line for SW release
 ! hinteddyncq=.false. ! dedicated for tests only, comment this line for SW release

  call pctile(s3,4032,npct,base)

  s3=s3/base
  nbirdie=6
  hint=' '
  isfalse=' '
  msg_decoded=.true.; hint_wide=.false.; hint_call3=.false.; hint_dx=.false.; ncand=16
  hint_dyn=.false.
  ftrsd_cfmd=.false.
! Get most reliable and second-most-reliable symbol values, and their
! probabilities

1 call demod64a(mrsym,mrprob,mr2sym,mr2prob)

  call chkhist(mrsym,nhist,ipk)       !Test for birdies and QRM
  if(nhist.ge.nbirdie) then
     nfail=nfail+1
     s3(ipk,1:63)=1.0
     if(nfail.gt.30) then
        decoded='                      '; msg_decoded=.false.; mrs=mrsym; mrs2=mr2sym; go to 8
     endif
     go to 1
  endif
  s3a=s3
  mrs=mrsym
  mrs2=mr2sym
!go to 128 ! diag only
  if(ipass.lt.4 .or. ipass.gt.6) then
     if(bypass_ftrsd .or. sync2.lt.0.0021) then ! 0.0021 => -30.0 dB SNR
        nft=0; decoded='                      '; msg_decoded=.false.; go to 8
     endif
  endif

  pdata1=0.
  do j=1,63
     pdata1=pdata1+s3(mrsym(j)+1,j)
  enddo
  sdratio=syncpwr/(pdata1*base)
! applying SYNC/DATA thresholds
  if(sdratio.lt.0.15) then; nft=0; decoded='                      '; msg_decoded=.false.; go to 2; endif

  if(nharmonicsdepth.ge.1 .and. sdratio.gt.1.81) then ! jt65bc decoding applying SYNC/DATA thresholds

     s3=s3b
     nfail=0
64   call demod64a(mrsym,mrprob,mr2sym,mr2prob)
     call chkhist(mrsym,nhist,ipk)       !Test for birdies and QRM
     if(nhist.ge.nbirdie) then
        nfail=nfail+1
        s3(ipk,1:63)=1.0 !=base
        if(nfail.gt.30) then; nft=0; decoded='                      '; msg_decoded=.false.; go to 4096; endif
        go to 64
     endif
     pdata1=0.
     do j=1,63
        pdata1=pdata1+s3(mrsym(j)+1,j)
     enddo
     sdratiob=syncpwr/pdata1
     if(sdratiob.gt.0.15 .and. sdratiob.lt.1.81) then
        jtbcand=.true.
        mrsymb=mrsym; mrprobb=mrprob; mr2symb=mr2sym; mr2probb=mr2prob
        s3temp=s3
     endif

4096 s3=s3c
     nfail=0
256  call demod64a(mrsym,mrprob,mr2sym,mr2prob)
     call chkhist(mrsym,nhist,ipk)       !Test for birdies and QRM
     if(nhist.ge.nbirdie) then
        nfail=nfail+1
        s3(ipk,1:63)=1.0 !=base
        if(nfail.gt.30) then; nft=0; decoded='                      '; msg_decoded=.false.; go to 32; endif
        go to 256
     endif
     pdata1=0.
     do j=1,63
        pdata1=pdata1+s3(mrsym(j)+1,j)
     enddo
     sdratioc=syncpwr/pdata1
     if(sdratioc.gt.0.15 .and. sdratioc.lt.1.81) jtccand=.true.
     if((jtbcand .and. .not.jtccand) .or. (.not.jtbcand .and. jtccand)) go to 8192
     if(.not.jtbcand .and. .not.jtccand) then
        nft=0; decoded='                      '; msg_decoded=.false.; go to 32
     endif
     if(jtbcand .and. jtccand) then
        dsdratiob=abs(sdratiob-1.0); dsdratioc=abs(sdratioc-1.0)
        if(dsdratiob .lt. dsdratioc) then; jtccand=.false.; else; jtbcand=.false.; endif
     endif
8192 if(jtbcand) then
        s3a=s3temp
        mrsym=mrsymb; mrprob=mrprobb; mr2sym=mr2symb; mr2prob=mr2probb
     endif
     if(jtccand) s3a=s3
!print *, 'bc cand'
     if(nharmonicsdepth.lt.4) then; nvect=10; else; nvect=100; endif
  endif

  call graycode65(mrsym,63,-1)        !Remove gray code 
  call interleave63(mrsym,-1)         !Remove interleaving
  call interleave63(mrprob,-1)

  call graycode65(mr2sym,63,-1)      !Remove gray code and interleaving
  call interleave63(mr2sym,-1)       !from second-most-reliable symbols
  call interleave63(mr2prob,-1)

  ! syncpwr -24dB SNR threshold for srand activation, srand for RX freq passes
!  if((npass1.and.ncand_lt9) .or. syncpwr.lt.200.0 .or. (ipass.ge.4 .and. ipass.le.6)) ncand=0
!  call timer('ftrsd   ',0)
  param=0; correct=0
  call ftrsd2(mrsym,mrprob,mr2sym,mr2prob,nvect,ipass,correct,param)
!  call timer('ftrsd   ',1)
  ncandidates=param(0)
  nhard=param(1)
  nsoft=param(2)
  nerased=param(3)
  rtt=0.001*param(4)
  ntotal=param(5)
  if(ntotal.le.81 .and. rtt.le.0.87) nft=1
  if(nhard.gt.49 .or. ntotal.gt.83 .or. rtt.gt.0.90) then
     nft=0; msg_decoded=.false.; decoded='                      '
     if(jtbcand .or. jtccand) then; go to 32; else; go to 8; endif
  endif

  msg_decoded=.false.
  decoded='                      '
  freemsg=.false.
  if(nft.eq.1 .and. nhard.ge.0) then
! Turn the corrected symbol array into channel symbols for subtraction;
! pass it back to jt65a via module "jt65_mod2".
     do i=1,12
        dat4(i)=correct(13-i)
     enddo
     do i=1,63
       tmp(i)=correct(64-i)
     enddo
     correct(1:63)=tmp(1:63)
     call interleave63(correct,1)
     call graycode65(correct,63,1)
     call unpackmsg(dat4,decoded)     !Unpack the user message
     if(decoded.ne.'                      ') then
        msg_decoded=.true.
        if(iand(dat4(10),8).ne.0) freemsg=.true.
        if(sync2.gt.2.0) then
           if(sync2.gt.maxsync2) then
              maxsync2=sync2
              maxsync2freq=freq
           endif
        endif
     else
        nft=0
     endif
  endif

! check some FTRSD decodes with matched filter
  if(nft.eq.1 .and. (nhard.gt.30 .or. nsoft.gt.0)) then
! protection from getting standard message like 'HK0M/MB8STK EQ7OMT'
     if(.not.freemsg) then 
        i1=index(decoded,' ')
        i2=index(decoded(i1+1:),' ')
        i2=i2+i1
        if(i1.gt.7 .or. (i1.gt.4 .and. i2.gt.14)) then
           nft=0; msg_decoded=.false.; decoded='                      '
           if(jtbcand .or. jtccand) then; go to 32; else; go to 8; endif
        endif
     endif

     if(.not.freemsg .and. (decoded(1:3).eq."CQ " .or. decoded(1:4).eq."QRZ " .or. decoded(1:3).eq."DE ")) then 
        falsedec=.false.
        call filterscq(decoded,falsedec)
        if(falsedec) then
           nft=0; msg_decoded=.false.; decoded='                      '
           if(jtbcand .or. jtccand) then; go to 32; else; go to 8; endif
        endif
     endif

     if(.not.freemsg .and. decoded(1:3).eq."DE ") then 
        falsedec=.false.
        call filtersde(decoded,falsedec)
        if(falsedec) then
           nft=0; msg_decoded=.false.; decoded='                      '
           if(jtbcand .or. jtccand) then; go to 32; else; go to 8; endif
        endif
     endif

     if(.not.freemsg .and. decoded(1:3).ne."CQ " .and. decoded(1:3).ne."DE " .and. decoded(1:3).ne."QRZ") then
        falsedec=.false.
        call filtersstd(decoded,mycall,falsedec,syncpwr)
        if(falsedec) then
           nft=0; msg_decoded=.false.; decoded='                      '
           if(jtbcand .or. jtccand) then; go to 32; else; go to 8; endif
        endif
     endif

     if(freemsg .and. decoded(1:3).ne."CQ " .and. decoded(1:3).ne."DE " .and. decoded(1:3).ne."QRZ") then
        falsedec=.false.
        call filtersfree(decoded,falsedec)
        if(falsedec) then
           nft=0; msg_decoded=.false.; decoded='                      '
           if(jtbcand .or. jtccand) then; go to 32; else; go to 8; endif
        endif
     endif

     if(decoded(1:3).eq."CQ ".or. decoded(1:3).eq."DE " .or. decoded(1:3).eq."QRZ" .or. freemsg) then
        if(showharmonics) then
           if(msg_decoded .and. jtbcand) print *,'2nd-h',nint(freq),'# ',decoded
           if(msg_decoded .and. jtccand) print *,'3rd-h',nint(freq),'# ',decoded
        endif
        go to 32
     endif
 
     ftrsd_cfmd=.false.
     falsedec=.false.
     if(.not.jtbcand .or. .not.jtccand) call chkftrsd(mrs,mrs2,decoded,ftrsd_cfmd)
     call chkfalse(decoded,mycall12,falsedec)
     if(ftrsd_cfmd) then
        if(falsedec .and. nhard.gt.44) isfalse='?'
     else
        if(falsedec) then        
           nft=0; msg_decoded=.false.; decoded='                      '
           if(jtbcand .or. jtccand) go to 32
        endif
     endif
     if(showharmonics .and. .not.falsedec .and. msg_decoded .and. (jtbcand .or. jtccand)) then
        if(msg_decoded .and. jtbcand) print *,'2nd-h',nint(freq),'# ',decoded
        if(msg_decoded .and. jtccand) print *,'3rd-h',nint(freq),'# ',decoded
        go to 32
     endif
	 
     if(ftrsd_cfmd) go to 32
  endif

     if(showharmonics .and. msg_decoded .and. (jtbcand .or. jtccand)) then
        if(msg_decoded .and. jtbcand) print *,'2nd-h',nint(freq),'# ',decoded
        if(msg_decoded .and. jtccand) print *,'3rd-h',nint(freq),'# ',decoded
        go to 32
     endif

8  if(bypass_hintall .and. nft.eq.0) then
      msg_decoded=.false.; decoded='                      '; go to 2
   endif

   if(nft.eq.0 .and. hinteddyncq .and. hint_on) then
      do i=1,150
         if(dynhintcq(i)%ninterval.lt.0) cycle
         if(ninterval.gt.0 .and. (ninterval-dynhintcq(i)%ninterval).eq.2 .and. & 
            (ninterval-dynhintcq(i)%ninterval).gt.0 .and. abs(freq-dynhintcq(i)%freq).lt.3.0) then

               direction=dynhintcq(i)%direction
               callsign=dynhintcq(i)%callsign
               grid=dynhintcq(i)%grid
               if(abs(dt-dynhintcq(i)%dt).gt.0.2) cycle     ! applying DT window +-0.2 sec

            call hintdyncq(mrs,mrs2,direction,callsign,grid,decoded,hint_dyn)
            if(hint_dyn) then
               nft=2; hint='*'; msg_decoded=.true.; freemsg=.false.; go to 2
            else
               cycle ! multiple call on single frequency support
            endif
         endif
      enddo
      msg_decoded=.false.; decoded='                      '
   endif 

   if(bypass_hintcq .or. sync2.lt.0.0021 .or. maxsync2.gt.100.0) go to 4 ! 0.0021 => -30.0 dB SNR
   if(maxsync2.gt.2.0 .and. abs(freq-maxsync2freq).lt.2.0) go to 4 ! ban false Hint CQ under strong signals
   if(maxsync2.gt.3.0 .and. hintedrxfreq .and. sync2.lt.0.003)  go to 4 ! ban some false Hint CQ on RX freq -28dB SNR
!128 continue !diag only
   if(nft.eq.0 .and. hintedw .and. hint_on) then

      msg_decoded=.false.
      decoded='                      '

      call hintwidecq(mrs,mrs2,decoded,hint_wide,npass1)
      if(hint_wide) then
         nft=2; hint='*'; msg_decoded=.true.; freemsg=.false.; go to 2
      endif

      call hintwidedx(mrs,mrs2,decoded,hint_wide,npass1)
      if(hint_wide) then
         nft=2; hint='*'; msg_decoded=.true.; freemsg=.false.; go to 2
      endif
   endif
!go to 2 ! diag only 
4  if(nft.eq.0 .and. hint_on) then
      do i=1,300
         if(dynhint(i)%ninterval.lt.0) cycle
         if(ninterval.gt.0 .and. (ninterval-dynhint(i)%ninterval).le.2 .and. & 
            (ninterval-dynhint(i)%ninterval).gt.0 .and. abs(freq-dynhint(i)%freq).lt.3.0) then
            if((ninterval-dynhint(i)%ninterval).eq.1) then
               if(.not.hinteddyn) cycle ! drop one cycle if candidate is out of hinteddyn DT window
               inverse=.true.
               call1=dynhint(i)%call2
               call2=dynhint(i)%call1
            endif
            if((ninterval-dynhint(i)%ninterval).eq.2) then
               inverse=.false.
               call1=dynhint(i)%call1
               call2=dynhint(i)%call2
               if(abs(dt-dynhint(i)%dt).gt.0.2) cycle     ! applying DT window +-0.2 sec
            endif
            if(call1.eq.call1_old .and. call2.eq.call1_old) cycle
            call1_old=call1; call2_old=call2
            nlastrx=dynhint(i)%nlastrx
            grid2=dynhint(i)%grid2
            call hintdyn(mrs,mrs2,call1,call2,grid2,decoded,hint_dyn,inverse,nlastrx)
            if(hint_dyn) then
               nft=2; hint='*'; msg_decoded=.true.; freemsg=.false.; go to 2
            else
               cycle ! multiple call on single frequency support
            endif
         endif
      enddo
      msg_decoded=.false.
      decoded='                      '
   endif

!  hintedrxfdt is the only variable controlled via DT Range of the Advanced tab settings
   if(hintedrxfreq .and. hintedrxfdt .and. nft.eq.0 .and. hint_on) then

      decoded='                      '
      msg_decoded=.false.
      hint_call3=.false.

      if(.not.nstophint .and. nlasttx.ge.4 .and. nlasttx.le.8) then
      call hintrxgrid(mrs,mrs2,mycall,decoded,hint_call3)
         if(hint_call3) then
            nft=2; hint='*'; msg_decoded=.true.; freemsg=.false.; go to 2
         endif
      endif

      if(maxsync2.gt.3.0 .and. sync2.lt.0.003)  go to 16 ! ban some false Hint CQ on RX freq -28dB SNR
      if(maxsync2.gt.10.0)  go to 16 ! ban false Hint CQ if there are strong signals on the band
      call hintrxcq(mrs,mrs2,decoded,hint_call3)
      if(hint_call3) then
         nft=2; hint='*'; msg_decoded=.true.; freemsg=.false.; go to 2
      endif
16    continue
! This memory consuming decoder may be implemented just in case if someone will call
! on RX frequency with signal report rather than grid. Deactivated it as most such calls 
! coming on the non RX frequency
! 
!      if(.not.nstophint) then
!         call hintrxrmin(s3,mrs,mrs2,mycall,decoded,hint_call3)
!         if(hint_call3) then
!            nft=2
!            hint='*'
!            msg_decoded=.true.
!            freemsg=.false.
!            go to 2
!         endif
!      endif

   endif

   if(hintedrxfreq .and. nft.eq.0 .and. hint_on) then

      if(hiscall(1:2).ne.'') then
         if(.not.nstophint) then
            hint_dx=.false.

            lhiscall=.false.
            do i=1,20
               if(rxfreq(i)%call2.eq.hiscall) then
                  lhiscall=.true.
                  exit
               endif
            enddo

               if(nlasttx.lt.2 .or. nlasttx.gt.3) then
                  directionrxf='00'
                  do i=1,20
                     if((ninterval-rxfreq(i)%ninterval).ne.2) cycle
                     if(abs(dt-rxfreq(i)%dt).gt.0.2) cycle ! applying DT window +-0.2 sec for high sensitivity mode
                     if(rxfreq(i)%call2.eq.hiscall .and. rxfreq(i)%direction.ne.'00') then
                        directionrxf=rxfreq(i)%direction
                        exit
                     endif
                  enddo

!128 if(hintedrxfreq) then ; directionrxf='00' !diag only
                  call hintdxcq(mrs,mrs2,hiscall,hisgrid4,decoded,directionrxf,hint_dx)
                  if(hint_dx) then
                     nft=2; hint='*'; msg_decoded=.true.; freemsg=.false.; go to 2
                  endif
!endif; go to 2 ! diag only
               endif


            if(lhiscall) then
               do i=1,20
                  if(rxfreq(i)%ninterval.lt.0) cycle
                  if(ninterval.gt.0 .and. (ninterval-rxfreq(i)%ninterval).le.6 &
                     .and. (ninterval-rxfreq(i)%ninterval).gt.0 .and. &
                     abs(freq-rxfreq(i)%freq).lt.3.0) then

                     if((ninterval-rxfreq(i)%ninterval).eq.1 .or. &
                        (ninterval-rxfreq(i)%ninterval).eq.3 .or. &
                        (ninterval-rxfreq(i)%ninterval).eq.5) cycle
			 
                     if((ninterval-rxfreq(i)%ninterval).eq.2 .or. &
                        (ninterval-rxfreq(i)%ninterval).eq.4 .or. &
                        (ninterval-rxfreq(i)%ninterval).eq.6) then
                        if(rxfreq(i)%call2.eq.hiscall) then

                           if(abs(dt-rxfreq(i)%dt).gt.0.2) cycle     ! applying DT window +-0.2 sec
                           if(nlasttx.eq.2) then ! decoder for mycall+hiscall+grid message retransmission
!128 if(hintedrxfreq) then !diag only
                              call hintdxgrid(mrs,mrs2,mycall,hiscall,hisgrid,decoded,hint_dx)
                              if(hint_dx) then; nft=2; hint='*'; msg_decoded=.true.; freemsg=.false.; go to 2
                              endif
!endif; go to 2 ! diag only
                           endif
                        endif
                     endif
                  endif
               enddo
            endif

            if(nlasttx.gt.0 .and. nlasttx.le.8 .and. nlasttx.ne.6) then
               do i=1,20
                  if(rxfreq(i)%ninterval.lt.0) cycle
                  if(ninterval.gt.0 .and. (ninterval-rxfreq(i)%ninterval).le.6 &
                     .and. (ninterval-rxfreq(i)%ninterval).gt.0 .and. &
                     abs(freq-rxfreq(i)%freq).lt.3.0) then

                     if((ninterval-rxfreq(i)%ninterval).eq.1 .or. &
                        (ninterval-rxfreq(i)%ninterval).eq.3 .or. &
                        (ninterval-rxfreq(i)%ninterval).eq.5) cycle
			 
                    if((ninterval-rxfreq(i)%ninterval).eq.2 .or. &
                       (ninterval-rxfreq(i)%ninterval).eq.4 .or. &
                       (ninterval-rxfreq(i)%ninterval).eq.6) then
                       if(rxfreq(i)%call2.eq.hiscall) then

                          if(abs(dt-rxfreq(i)%dt).gt.0.2) cycle     ! applying DT window +-0.2 sec
                          if(nlasttx.eq.1 .or. nlasttx.eq.3) then
                             call hintdxr(mrs,mrs2,mycall,hiscall,decoded,hint_dx)
                             if(hint_dx) then
                                nft=2; hint='*'; msg_decoded=.true.; freemsg=.false.; go to 2
                             endif
                          endif
                          if(nlasttx.eq.2) then
! 128 if(hintedrxfreq) then ! diag only
                             call hintdxrr(mrs,mrs2,mycall,hiscall,decoded,hint_dx)
                             if(hint_dx) then
                                nft=2; hint='*'; msg_decoded=.true.; freemsg=.false.; go to 2
                             endif
! endif; go to 2 ! diag only
                          endif
                          if(nlasttx.ge.4 .and. nlasttx.le.8 .and. nlasttx.ne.6) then
                             call hintdx73(mrs,mrs2,mycall,hiscall,decoded,hint_dx)
                             if(hint_dx) then
                                nft=2; hint='*'; msg_decoded=.true.; freemsg=.false.; go to 2
                             endif
                          endif
                       endif
                    endif
                 endif
              enddo
            endif

         endif

         if(nstophint .and. rxfchg(1)%rxfchanged) then
            hint_dx=.false.

            directionrxf='00'
            do i=1,20
               if((ninterval-rxfreq(i)%ninterval).ne.2) cycle
               if(abs(dt-rxfreq(i)%dt).gt.0.2) cycle ! applying DT window +-0.2 sec for high sensitivity mode
               if(rxfreq(i)%call2.eq.hiscall .and. rxfreq(i)%direction.ne.'00') then
                  directionrxf=rxfreq(i)%direction
                  exit
               endif
            enddo

            call hintdxcq(mrs,mrs2,hiscall,hisgrid4,decoded,directionrxf,hint_dx)
            if(hint_dx) then
               nft=2; hint='*'; msg_decoded=.true.; freemsg=.false.; go to 2
            endif

         endif
      endif    
   endif

2 if(hint_wide .or. hint_dyn .or. hint_call3 .or. hint_dx) correct(1:63)=correct_hint(1:63)

!  if(nft.eq.1 .and. msg_decoded .and. (sdratio.lt.0.15 .or. sdratio.gt.1.81))  print *,sdratio
  if(nharmonicsdepth.eq.2) sdthreshold=1.0
  if(nharmonicsdepth.ge.3) sdthreshold=0.0
  if(.not.msg_decoded .and. nharmonicsdepth.ge.2 .and. sdratio.gt.sdthreshold) then !try more jt65bc candidates

     s3=s3b
     nfail=0
512  call demod64a(mrsym,mrprob,mr2sym,mr2prob)
     call chkhist(mrsym,nhist,ipk)       !Test for birdies and QRM
     if(nhist.ge.nbirdie) then
        nfail=nfail+1
        s3(ipk,1:63)=1.0 !=base
        if(nfail.gt.30) then
           nft=0; decoded='                      '; msg_decoded=.false.; go to 2048
        endif
        go to 512
     endif
     pdata1=0.
     do j=1,63
        pdata1=pdata1+s3(mrsym(j)+1,j)
     enddo
     sdratiob=syncpwr/pdata1
     if(sdratiob.gt.0.6 .and. sdratiob.lt.1.81) then
        jtbcand=.true.
        mrsymb=mrsym; mrprobb=mrprob; mr2symb=mr2sym; mr2probb=mr2prob
        s3temp=s3
     endif

2048 s3=s3c
     nfail=0
1024 call demod64a(mrsym,mrprob,mr2sym,mr2prob)
     call chkhist(mrsym,nhist,ipk)       !Test for birdies and QRM
     if(nhist.ge.nbirdie) then
        nfail=nfail+1
        s3(ipk,1:63)=1.0 !=base
        if(nfail.gt.30) then
           nft=0; decoded='                      '; msg_decoded=.false.; go to 32
        endif
        go to 1024
     endif
     pdata1=0.
     do j=1,63
        pdata1=pdata1+s3(mrsym(j)+1,j)
     enddo
     sdratioc=syncpwr/pdata1
     if(sdratioc.gt.0.6 .and. sdratioc.lt.1.81) jtccand=.true.
     if((jtbcand .and. .not.jtccand) .or. (.not.jtbcand .and. jtccand)) go to 8194
     if(.not.jtbcand .and. .not.jtccand) then
        nft=0; decoded='                      '; msg_decoded=.false.; go to 32
     endif
     if(jtbcand .and. jtccand) then
        dsdratiob=abs(sdratiob-1.0); dsdratioc=abs(sdratioc-1.0)
        if(dsdratiob .lt. dsdratioc) then
           jtccand=.false.
        else
           jtbcand=.false.
        endif
     endif
8194 if(jtbcand) then
        s3a=s3temp
        mrsym=mrsymb; mrprob=mrprobb; mr2sym=mr2symb; mr2prob=mr2probb
     endif
     if(jtccand) s3a=s3

     call graycode65(mrsym,63,-1)        !Remove gray code 
     call interleave63(mrsym,-1)         !Remove interleaving
     call interleave63(mrprob,-1)

     call graycode65(mr2sym,63,-1)      !Remove gray code and interleaving
     call interleave63(mr2sym,-1)       !from second-most-reliable symbols
     call interleave63(mr2prob,-1)

!  call timer('ftrsd   ',0)
     param=0; correct=0
     if(nharmonicsdepth.lt.4) then; nvect=10; else; nvect=100; endif
     call ftrsd2(mrsym,mrprob,mr2sym,mr2prob,nvect,ipass,correct,param)
!  call timer('ftrsd   ',1)
     ncandidates=param(0)
     nhard=param(1)
     nsoft=param(2)
     nerased=param(3)
     rtt=0.001*param(4)
     ntotal=param(5)
     if(ntotal.le.81 .and. rtt.le.0.87) nft=1
     if(nhard.gt.49 .or. ntotal.gt.83 .or. rtt.gt.0.90) then
        nft=0; msg_decoded=.false.; decoded='                      '; go to 32
     endif

     msg_decoded=.false.
     decoded='                      '
     freemsg=.false.
     if(nft.eq.1 .and. nhard.ge.0) then
! Turn the corrected symbol array into channel symbols for subtraction;
! pass it back to jt65a via module "jt65_mod2".
        do i=1,12
           dat4(i)=correct(13-i)
        enddo
        do i=1,63
          tmp(i)=correct(64-i)
        enddo
        correct(1:63)=tmp(1:63)
        call interleave63(correct,1)
        call graycode65(correct,63,1)
        call unpackmsg(dat4,decoded)     !Unpack the user message
        if(decoded.ne.'                      ') then
           msg_decoded=.true.
           if(iand(dat4(10),8).ne.0) freemsg=.true.
           if(sync2.gt.2.0) then
              if(sync2.gt.maxsync2) then
                 maxsync2=sync2
                 maxsync2freq=freq
              endif
           endif
        else
           nft=0; go to 32
        endif
     endif

! check some FTRSD decodes with matched filter
     if(nft.eq.1 .and. (nhard.gt.30 .or. nsoft.gt.0)) then
! protection from getting standard message like 'HK0M/MB8STK EQ7OMT'
        if(.not.freemsg) then 
           i1=index(decoded,' ')
           i2=index(decoded(i1+1:),' ')
           i2=i2+i1
           if(i1.gt.7 .or. (i1.gt.4 .and. i2.gt.14)) then
              nft=0; msg_decoded=.false.; decoded='                      '; go to 32
           endif
        endif

        if(.not.freemsg .and. (decoded(1:3).eq."CQ " .or. decoded(1:4).eq."QRZ " .or. decoded(1:3).eq."DE ")) then
           falsedec=.false.
           call filterscq(decoded,falsedec)
           if(falsedec) then; nft=0; msg_decoded=.false.; decoded='                      '; go to 32; endif
        endif

        if(.not.freemsg .and. decoded(1:3).eq."DE ") then 
           falsedec=.false.
           call filtersde(decoded,falsedec)
           if(falsedec) then; nft=0; msg_decoded=.false.; decoded='                      '; go to 32; endif
        endif

        if(.not.freemsg .and. decoded(1:3).ne."CQ " &
           .and. decoded(1:3).ne."DE " .and. decoded(1:3).ne."QRZ") then
           falsedec=.false.
           call filtersstd(decoded,mycall,falsedec,syncpwr)
           if(falsedec) then; nft=0; msg_decoded=.false.; decoded='                      '; go to 32; endif
        endif

        if(freemsg .and. decoded(1:3).ne."CQ " .and. decoded(1:3).ne."DE " .and. decoded(1:3).ne."QRZ") then
           falsedec=.false.
           call filtersfree(decoded,falsedec)
           if(falsedec) then; nft=0; msg_decoded=.false.; decoded='                      '; go to 32; endif
        endif

        if(decoded(1:3).eq."CQ ".or. decoded(1:3).eq."DE " .or. decoded(1:3).eq."QRZ" .or. freemsg) then
           if(showharmonics) then
              if(msg_decoded .and. jtbcand) print *,'2nd-h',nint(freq),'# ',decoded
              if(msg_decoded .and. jtccand) print *,'3rd-h',nint(freq),'# ',decoded
           endif
           go to 32
        endif
 
        falsedec=.false.
        call chkfalse(decoded,mycall12,falsedec)
        if(falsedec) then; nft=0; msg_decoded=.false.; decoded='                      '; go to 32; endif
        if(showharmonics .and. msg_decoded) then
           if(msg_decoded .and. jtbcand) print *,'2nd-h',nint(freq),'# ',decoded
           if(msg_decoded .and. jtccand) print *,'3rd-h',nint(freq),'# ',decoded
           go to 32
        endif
     endif
     if(showharmonics .and. msg_decoded) then
        if(msg_decoded .and. jtbcand) print *,'2nd-h',nint(freq),'# ',decoded
        if(msg_decoded .and. jtccand) print *,'3rd-h',nint(freq),'# ',decoded
        go to 32
     endif
  endif

32 if(msg_decoded) then; if(jtbcand) jt65bc(1)=.true.; if(jtccand) jt65bc(2)=.true.; endif
  
  return
end subroutine extract

subroutine getpp(workdat,pp)

  use, intrinsic :: iso_c_binding
  use jt65_mod2, only : s3a
  integer workdat(63),b(63)
  real pp

  b(1:63)=workdat(63:1:-1)
  call interleave63(b,1)
  call graycode(b,63,1,b)
  
  psum=0.
  do j=1,63
     i=b(j)+1
     x=s3a(i,j)
     s3a(i,j)=0.
     psum=psum + x
     s3a(i,j)=x
  enddo
  pp=psum/63.0

  return
end subroutine getpp

subroutine chkcrc14a(decoded,nbadcrc)

  use crc
  integer*1 decoded(91)
  integer*1, target:: i1Dec8BitBytes(12)
  character*91 cbits

! Write decoded bits into cbits: 77-bit message plus 14-bit CRC
  write(cbits,1000) decoded
1000 format(91i1)
  read(cbits,1001) i1Dec8BitBytes
1001 format(12b8)
  read(cbits,1002) ncrc14                         !Received CRC14
1002 format(77x,b14)

  i1Dec8BitBytes(10)=iand(i1Dec8BitBytes(10),transfer(128+64+32+16+8,0_1))
  i1Dec8BitBytes(11:12)=0
  icrc14=crc14(c_loc(i1Dec8BitBytes),12)          !CRC14 computed from 77 msg bits

  nbadcrc=1
  if(ncrc14.eq.icrc14) nbadcrc=0
  
  return
end subroutine chkcrc14a

! This source code file was last time modified by Igor UA3DJY on 20190929
! All changes are shown in the patch file coming together with the full JTDX source code.

subroutine subtractft4(itone,f0,dt)

! Subtract an ft4 signal
!
! Measured signal  : dd(t)    = a(t)cos(2*pi*f0*t+theta(t))
! Reference signal : cref(t)  = exp( j*(2*pi*f0*t+phi(t)) )
! Complex amp      : cfilt(t) = LPF[ dd(t)*CONJG(cref(t)) ]
! Subtract         : dd(t)    = dd(t) - 2*REAL{cref*cfilt}

!  use timer_module, only: timer
  use ft4_mod1, only : dd4

!  parameter (NMAX=21*3456,NSPS=576,NFFT=NMAX,NFILT=1400)
  parameter (NMAX=73728,NSPS=576,NFFT=NMAX,NFILT=1400)
  parameter (NFRAME=(103+2)*NSPS)
  real*4  window(-NFILT/2:NFILT/2), xjunk
  complex cref,camp,cfilt,cw
  integer itone(103)
  logical first
  data first/.true./
  common/heap8/cref(NFRAME),camp(NMAX),cfilt(NMAX),cw(NMAX),xjunk(NFRAME)
  save first

  nstart=dt*12000+1-NSPS
  nsym=103
  fs=12000.0
  icmplx=1
  bt=1.0 
  nss=NSPS
  call gen_ft4wave(itone,nsym,nss,fs,f0,cref,xjunk,icmplx,NFRAME)
  camp=0.
  do i=1,nframe
    id=nstart-1+i 
    if(id.ge.1.and.id.le.NMAX) camp(i)=dd4(id)*conjg(cref(i))
  enddo

  if(first) then
! Create and normalize the filter
     pi=4.0*atan(1.0)
     fac=1.0/float(nfft)
     sum=0.0
     do j=-NFILT/2,NFILT/2
        window(j)=cos(pi*j/NFILT)**2
        sum=sum+window(j)
     enddo
     cw=0.
     cw(1:NFILT+1)=window/sum
     cw=cshift(cw,NFILT/2+1)
     call four2a(cw,nfft,1,-1,1)
     cw=cw*fac
     first=.false.
  endif

  cfilt=0.0
  cfilt(1:nframe)=camp(1:nframe)
  call four2a(cfilt,nfft,1,-1,1)
  cfilt(1:nfft)=cfilt(1:nfft)*cw(1:nfft)
  call four2a(cfilt,nfft,1,1,1)

! Subtract the reconstructed signal
  do i=1,nframe
     j=nstart+i-1
     if(j.ge.1 .and. j.le.NMAX) dd4(j)=dd4(j)-2*REAL(cfilt(i)*cref(i))
  enddo

  return
end subroutine subtractft4

program genmet

  character*12 arg
  integer hist(-128:128)
  lim(x)=min(127,max(-128,nint(scale*x)))

  nargs=iargc()
  if(nargs.ne.4) then
     print*,'Usage:   genmet  bw  scale snr   iters'
     print*,'Example: genmet 1.46  20   -24  1000000'
     go to 999
  endif
  call getarg(1,arg)
  read(arg,*) bw
  call getarg(2,arg)
  read(arg,*) scale
  call getarg(3,arg)
  read(arg,*) snr
  call getarg(4,arg)
  read(arg,*) iters

  hist=0
  s=sqrt(2500.0/bw) * 10.0**(0.05*snr)
  fac=1.0/sqrt(2.0)
  do iter=1,iters
     x1=fac*gran()
     y1=fac*gran()
     x0=fac*gran()
     y0=fac*gran()
     r=(x1+s)**2 + y1*y1 - x0*x0 - y0*y0
     hist(lim(r))=hist(lim(r))+1
  enddo

  xln2=log(2.0)
  do i=-128,127
     p1=hist(i)/dfloat(iters)
     j=-i
     if(j.gt.127) j=127
     p0=hist(j)/dfloat(iters)
     xlhd0=log(max(0.001,2.0*p0/(p0+p1)))/xln2
     xlhd1=log(max(0.001,2.0*p1/(p0+p1)))/xln2
     write(13,1010) i/scale,hist(i)/dfloat(iters)
1010 format(f8.3,f12.9)
     write(14,1012) i+128,xlhd0,xlhd1
1012 format(i4,2f8.3)
  enddo

999 end program genmet

module hashing
  interface
     integer(c_int32_t) function nhash (key, length, initval) bind(C, name="nhash")
       use iso_c_binding, only: c_ptr, c_size_t, c_int32_t
       type(c_ptr), intent(in), value :: key
       integer(c_size_t), intent(in), value :: length
       integer(c_int32_t), intent(in), value :: initval
     end function nhash
  end interface
end module hashing

subroutine flat2(s,nz,ref)

  parameter (NSMAX=6827)
  real s(NSMAX)
  real ref(NSMAX)

  nsmo=10
  ia=nsmo+1
  ib=nz-nsmo-1
  do i=ia,ib
     call pctile(s(i-nsmo),2*nsmo+1,5,ref(i))
  enddo

  ref(:ia-1)=ref(ia)
  ref(ib+1:)=ref(ib)

  return
end subroutine flat2

subroutine fano232(symbol,nbits,mettab,ndelta,maxcycles,dat,     &
     ncycles,metric,ierr)

! Sequential decoder for K=32, r=1/2 convolutional code using 
! the Fano algorithm.  Translated from C routine for same purpose
! written by Phil Karn, KA9Q.

  parameter (MAXBITS=103)
  parameter (MAXBYTES=13) ! MAXBYTES=(MAXBITS+7)/8
  integer*1 symbol(0:2*MAXBITS-1)  !Soft symbols (as unsigned i*1)
  integer*1 dat(MAXBYTES)          !Decoded user data, 8 bits per byte
  integer mettab(-128:127,0:1)     !Metric table

! These were the "node" structure in Karn's C code:
  integer nstate(0:MAXBITS)        !Encoder state of next node
  integer gamma(0:MAXBITS)         !Cumulative metric to this node
  integer metrics(0:3,0:MAXBITS)   !Metrics indexed by all possible Tx syms
  integer tm(0:1,0:MAXBITS)        !Sorted metrics for current hypotheses
  integer ii(0:MAXBITS)            !Current branch being tested

  logical noback
  include 'conv232.f90'            !Polynomials defined here

  ntail=nbits-31

! Compute all possible branch metrics for each symbol pair.
! This is the only place we actually look at the raw input symbols
  i4a=0
  i4b=0
  do np=0,nbits-1
     j=2*np
     i4a=symbol(j)
     i4b=symbol(j+1)
     metrics(0,np) = mettab(i4a,0) + mettab(i4b,0)
     metrics(1,np) = mettab(i4a,0) + mettab(i4b,1)
     metrics(2,np) = mettab(i4a,1) + mettab(i4b,0)
     metrics(3,np) = mettab(i4a,1) + mettab(i4b,1)
  enddo

  np=0
  nstate(np)=0

  n=iand(nstate(np),npoly1)                  !Compute and sort branch metrics 
  n=ieor(n,ishft(n,-16))                     !from the root node
  lsym=partab(iand(ieor(n,ishft(n,-8)),255))
  n=iand(nstate(np),npoly2)
  n=ieor(n,ishft(n,-16))
  lsym=lsym+lsym+partab(iand(ieor(n,ishft(n,-8)),255))
  m0=metrics(lsym,np)
  m1=metrics(ieor(3,lsym),np)
  if(m0.gt.m1) then
     tm(0,np)=m0                             !0-branch has better metric
     tm(1,np)=m1
  else
     tm(0,np)=m1                             !1-branch is better
     tm(1,np)=m0
     nstate(np)=nstate(np) + 1               !Set low bit
  endif

  ii(np)=0                                   !Start with best branch
  gamma(np)=0
  nt=0

  do i=1,nbits*maxcycles                     !Start the Fano decoder
     ngamma=gamma(np) + tm(ii(np),np)        !Look forward
     if(ngamma.ge.nt) then
! Node is acceptable.  If first time visiting this node, tighten threshold:
        if(gamma(np).lt.(nt+ndelta)) nt=nt + ndelta * ((ngamma-nt)/ndelta)
        gamma(np+1)=ngamma                   !Move forward
        nstate(np+1)=ishft(nstate(np),1)
        np=np+1
        if(np.eq.nbits) go to 100          !We're done!

        n=iand(nstate(np),npoly1)
        n=ieor(n,ishft(n,-16))
        lsym=partab(iand(ieor(n,ishft(n,-8)),255))
        n=iand(nstate(np),npoly2)
        n=ieor(n,ishft(n,-16))
        lsym=lsym+lsym+partab(iand(ieor(n,ishft(n,-8)),255))
            
        if(np.ge.ntail) then
           tm(0,np)=metrics(lsym,np)      !We're in the tail, now all zeros
        else
           m0=metrics(lsym,np)
           m1=metrics(ieor(3,lsym),np)
           if(m0.gt.m1) then
              tm(0,np)=m0                 !0-branch has better metric
              tm(1,np)=m1
           else
              tm(0,np)=m1                 !1-branch is better
              tm(1,np)=m0
              nstate(np)=nstate(np) + 1   !Set low bit
           endif
        endif
        ii(np)=0                          !Start with best branch
     else
        do while(.true.)
           noback=.false.                 !Threshold violated, can't go forward
           if(np.eq.0) noback=.true.
           if(np.gt.0) then
              if(gamma(np-1).lt.nt) noback=.true.
           endif

           if(noback) then               !Can't back up, either
              nt=nt-ndelta               !Relax threshold and look forward again
              if(ii(np).ne.0) then
                 ii(np)=0
                 nstate(np)=ieor(nstate(np),1)
              endif
              exit
           endif

           np=np-1                       !Back up
           if(np.lt.ntail .and. ii(np).ne.1) then
              ii(np)=ii(np)+1            !Search the next best branch
              nstate(np)=ieor(nstate(np),1)
              exit
           endif
        enddo
     endif
  enddo
  i=nbits*maxcycles
  
100 metric=gamma(np)                       !Final path metric
  nbytes=(nbits+7)/8                       !Copy decoded data to user's buffer
  np=7
  do j=1,nbytes-1
     i4a=nstate(np)
     dat(j)=i4a
     np=np+8
  enddo
  dat(nbytes)=0
  ncycles=i+1
  ierr=0
  if(i.ge.maxcycles*nbits) ierr=-1

  return
end subroutine fano232

module timer_impl
  !$ use omp_lib
  use :: iso_c_binding, only: c_ptr
  use timer_module, only: timer_callback
  implicit none

  public :: init_timer, fini_timer
  integer, public :: limtrace=0

  private

  integer, parameter :: MAXCALL=100
  integer :: lu=6
  real :: dut
  integer :: i,nmax=0,ncall(MAXCALL),nlevel(MAXCALL),nparent(MAXCALL)
  character(len=8) :: name(MAXCALL),space='        '
  logical :: on(MAXCALL)
  real :: total,sum,sumf,ut(MAXCALL),ut0(MAXCALL)
  !$ integer :: j,l,m,ntid(MAXCALL)

  !
  ! C interoperable callback setup
  !
  public :: C_init_timer
  abstract interface
     subroutine C_timer_callback (context, dname, k)
       use, intrinsic :: iso_c_binding, only: c_ptr
       implicit none
       type(c_ptr), intent(in) :: context
       character(len=8), intent(in) :: dname
       integer, intent(in) :: k
     end subroutine C_timer_callback
  end interface
  type(c_ptr), private :: the_context
  procedure(C_timer_callback), pointer, private :: the_C_callback

contains
  subroutine timer_callback_wrapper (dname, k)
    implicit none
    character(len=8), intent(in) :: dname
    integer, intent(in) :: k
    call the_C_callback (the_context, dname, k)
  end subroutine timer_callback_wrapper

  subroutine C_init_timer (context, callback) bind(C)
    use, intrinsic :: iso_c_binding, only: c_ptr, c_funptr, c_f_procpointer
    use iso_c_utilities, only: c_to_f_string
    use timer_module, only: timer
    implicit none
    type(c_ptr), intent(in) :: context
    type(c_funptr), intent(in) :: callback
    the_context=context
    call c_f_procpointer (callback, the_C_callback)
    timer => timer_callback_wrapper
  end subroutine C_init_timer

  !
  ! default Fortran implementation which is thread safe using OpenMP
  !
  subroutine default_timer (dname, k)

    ! Times procedure number n between a call with k=0 (tstart) and with
    ! k=1 (tstop). Accumulates sums of these times in array ut (user time).
    ! Also traces all calls (for debugging purposes) if limtrace.gt.0
    !
    ! If this is used with OpenMP than the /timer_private/ common
    ! block must be copyed into each thread of a thread team by using
    ! the copyin() clause on the !$omp parallel directive that creates
    ! the team.

    implicit none

    character(len=8), intent(in) :: dname
    integer, intent(in) :: k

    real :: ut1,eps=0.000001
    integer :: n,ndiv,ntrace=0
    !$ integer :: tid
    character(len=8) :: tname
    include 'timer_common.inc'

    !$omp critical(timer)
    if(limtrace.lt.0) go to 999
    if(k.gt.1) go to 40                        !Check for "all done" (k>1)
    onlevel(0)=0

    !$ tid=omp_get_thread_num()
    do n=1,nmax                                !Check for existing name/parent[/thread]
       if(name(n).eq.dname &
                                !$ .and.ntid(n).eq.tid &
            ) then
          if (on(n)) then
             if (nparent(n).eq.onlevel(level-1)) goto 20
          else
             if (nparent(n).eq.onlevel(level)) goto 20
          end if
       end if
    enddo

    nmax=nmax+1                                !This is a new one
    n=nmax
    !$ ntid(n)=tid
    ncall(n)=0
    on(n)=.false.
    ut(n)=eps
    name(n)=dname

20  if(k.eq.0) then                                !Get start times (k=0)
       if(on(n)) then
          print*,'Error in timer: ',dname,' already on.'
       end if
       level=level+1 !Increment the level
       on(n)=.true.
       !     call system_clock(icount,irate)
       !     ut0(n)=float(icount)/irate
       !     call cpu_time(ut0(n))
       ut0(n)=secnds(0.0)

       ncall(n)=ncall(n)+1
       if(ncall(n).gt.1.and.nlevel(n).ne.level) then
          !recursion is happening
          !
          !TODO: somehow need to account for this deeper call at the
          !shallowest instance in the call chain and this needs to be
          !done without incrementing anything here other than counters
          !and timers
          !
          nlevel(n)=-1
       else
          nlevel(n)=level
       endif
       nparent(n)=onlevel(level-1)
       onlevel(level)=n

    else if(k.eq.1) then        !Get stop times and accumulate sums. (k=1)
       if(on(n)) then
          on(n)=.false.
          !        call system_clock(icount,irate)
          !        ut1=float(icount)/irate
          !        call cpu_time(ut1)
          ut1=secnds(0.0)

          ut(n)=ut(n)+ut1-ut0(n)
       endif
       level=level-1
    endif

    ntrace=ntrace+1
    if(ntrace.lt.limtrace) write(lu,1020) ntrace,tname,k,level,nparent(n)
1020 format(i8,': ',a8,3i5)
    go to 998

    ! Write out the timer statistics

40  write(lu,1040)
1040 format(/' Name                 Time  Frac     dTime',       &
         ' dFrac    Calls'/58('-'))

    !$ !walk backwards through the database rolling up thread data by call chain
    !$ do i=nmax,1,-1
    !$    do j=1,i-1
    !$       l=j
    !$       m=i
    !$       do while (name(l).eq.name(m))
    !$          l=nparent(l)
    !$          m=nparent(m)
    !$          if (l.eq.0.or.m.eq.0) exit
    !$       end do
    !$       if (l.eq.0.and.m.eq.0) then
    !$          !same call chain so roll up data
    !$          ncall(j)=ncall(j)+ncall(i)
    !$          ut(j)=ut(j)+ut(i)
    !$          do n=1,nmax
    !$            if (nparent(n).eq.i) nparent(n)=j
    !$          end do
    !$          name(i)=space
    !$          exit
    !$       end if
    !$    end do
    !$ end do

    if(k.gt.100) then
       ndiv=k-100
       do i=1,nmax
          ncall(i)=ncall(i)/ndiv
          ut(i)=ut(i)/ndiv
       enddo
    endif

    total=ut(1)
    sum=0.
    sumf=0.
    call print_root(1)
    write(lu,1070) sum,sumf
1070 format(58('-')/32x,f10.3,f6.2)
    nmax=0
    eps=0.000001
    ntrace=0
    level=0
    onlevel(0)=0

998 flush(lu)

999 continue

    !$omp end critical(timer)
    return
  end subroutine default_timer

  recursive subroutine print_root(i)
    implicit none
    integer, intent(in) :: i
    character(len=16) :: sname
    real :: dutf, utf
    integer :: j, kk

    if (i.le.nmax) then
       if (name(i).ne.space) then
          dut=ut(i)
          do j=i,nmax
             if (name(j).ne.space.and.nparent(j).eq.i) dut=dut-ut(j)
          enddo
          if(dut.lt.0.0) dut=0.0
          utf=ut(i)/total
          dutf=dut/total
          sum=sum+dut
          sumf=sumf+dutf
          kk=nlevel(i)
          sname=space(1:kk)//name(i)//space(1:8-kk)
          write(lu,2000) sname,ut(i),utf,dut,dutf,ncall(i)
2000      format(a16,2(f10.3,f6.2),i9)
          do j=i,nmax
             if(nparent(j).eq.i) call print_root(j)
          enddo
       end if
    end if
    return
  end subroutine print_root

  subroutine init_timer (filename)
    use, intrinsic :: iso_c_binding, only: c_char
    use timer_module, only: timer
    implicit none
    character(len=*), optional, intent(in) :: filename
    include 'timer_common.inc'
    data level/0/, onlevel/11 * 0/
    if (present (filename)) then
       open (newunit=lu, file=filename, status='unknown')
    else
       open (newunit=lu, file='timer.out', status='unknown')
    end if
    timer => default_timer
  end subroutine init_timer

  subroutine fini_timer ()
    use timer_module, only: timer, null_timer
    implicit none
    timer => null_timer
    close (lu)
  end subroutine fini_timer

end module timer_impl

! This source code file was last time modified by Igor UA3DJY on November 27th, 2017
! All changes are shown in the patch file coming together with the full JTDX source code.

subroutine extract2(s3,nadd,ntrials,param,msg)

  real s3(64,63)
  real tmp(4032)
  integer np1(0:7,0:7),np2(0:7,0:7),np0(0:7,0:7)
  integer ns(0:7,0:7)
  integer perr(0:7,0:7),pmr2(0:7,0:7)
  character msg*22
  integer dat4(12)
  integer mrsym(0:62),mr2sym(0:62),mrprob(0:62),mr2prob(0:62)
  integer correct(0:62)
  integer param(0:7)
  integer indx(0:62)
  logical first
  real*8 tt
  common/extcom/ntdecode
  data ndone/0/,ngood/0/,nbad/0/,first/.true./
  save

  if(first) then
     np1=0
     np2=0
     np0=0
     ns=0
     first=.false.
  endif

  nfail=0
1 call demod64a(s3,nadd,mrsym,mrprob,mr2sym,mr2prob,ntest,nlow)

!  if(ntest.lt.50 .or. nlow.gt.20) then
!     ncount=-999                         !Flag bad data
!     go to 900
!  endif

  call chkhist(mrsym,nhist,ipk)
  if(nhist.ge.20) then
     nfail=nfail+1
     call pctile(s3,tmp,4032,50,base)     ! ### or, use ave from demod64a ?
     do j=1,63
        s3(ipk,j)=base
     enddo
     go to 1
  endif

  call graycode(mrsym,63,-1)
  call interleave63(mrsym,-1)
  call interleave63(mrprob,-1)

  call graycode(mr2sym,63,-1)
  call interleave63(mr2sym,-1)
  call interleave63(mr2prob,-1)

  nverbose=0
  call ftrsd2(mrsym,mrprob,mr2sym,mr2prob,ntrials,nverbose,correct,   &
       param,indx,tt,ntry)
  ncandidates=param(0)
  nhard=param(1)
  nsoft=param(2)
  nera=param(3)
  ngmd=param(4)
  ndone=ndone+1

  do i=1,12
     dat4(i)=correct(12-i)
  enddo


  msg='                      '
! if(nhard.ge.0) then
  if(nhard.ge.0 .and. nhard.le.42 .and. nsoft.le.32 .and.              &
       (nhard+nsoft).le.73) then
     call unpackmsg(dat4,msg) !Unpack the user message
     if(msg.eq.'VK7MO K1JT FN20       ') then
        ngood=ngood+1
        do k=0,62
           j=indx(k)
           i=(62-j)
           p1=mrprob(i)/255.0 + 1.e-10
           p2=mr2prob(i)/255.0
           ii=k/8
           jj=7.9999*p2/p1
           ns(ii,jj)=ns(ii,jj)+1
           if(correct(j).eq.mrsym(i)) then
              np1(ii,jj)=np1(ii,jj)+1
           else
              np0(ii,jj)=np0(ii,jj)+1
           endif
           if(correct(j).eq.mr2sym(i)) np2(ii,jj)=np2(ii,jj)+1
        enddo
     else
        nbad=nbad+1
     endif
  endif
  fgood=float(ngood)/ndone
  fbad=float(nbad)/ndone

  nboth=nhard+nsoft
  if(nhard.lt.0) then
     nsoft=99
     nera=99
     nboth=99
  endif
  write(*,1010) ndone,fgood,fbad,ncandidates,nhard,nsoft,nera,nboth,   &
       ntry,tt,msg
  write(32,1010) ndone,fgood,fbad,ncandidates,nhard,nsoft,nera,nboth,  &
       ntry,tt,msg
1010 format(i4,2f7.3,i7,4i3,i8,f8.1,1x,a22)
  flush(32)

  if(msg.eq.'VK7MO K1JT FN20       ') then
     write(33,1012) ndone,ngood,nbad,ntry,log10(float(1+ntry))
1012 format(4i8,f8.3)
     flush(33)
  endif

  rewind 40
  write(40,1080)
1080 format('Totals:')
  write(40,1090) ns
1090 format(8i7)
  write(40,1091)
1091 format(/'error:')
  write(40,1090) np0
  write(40,1092)
1092 format(/'sym = mrsym:')
  write(40,1090) np1
  write(40,1093)
1093 format(/'sym = mr2sym:')
  write(40,1090) np2

  write(40,1095)
1095 format(/'Probability of error:')
  perr=nint(100.0*float(np0)/(ns+0.001))
  write(40,1096) perr
1096 format(8i7)

  write(40,1097)
1097 format(/'P(mr2 correct | mr not correct) :')
  pmr2=nint(100.0*float(np2)/(np0+0.001))
  write(40,1096) pmr2
  flush(40)

  return
end subroutine extract2

! This source code file was last time modified by Igor UA3DJY on February 10th, 2017
! All changes are shown in the patch file coming together with the full JTDX source code.

module jt65_mod8

  type dynhint_struct
    integer ninterval
    character*6 call1
    character*6 call2
    character*4 grid2
    integer nlastrx
    real freq
    real dt
  end type dynhint_struct
  type(dynhint_struct) dynhint(300)

  type dynhintcq_struct
    integer ninterval
    character*2 direction
    character*6 callsign
    character*4 grid
    real freq
    real dt
  end type dynhintcq_struct
  type(dynhintcq_struct) dynhintcq(150)
  
  type rxfreq_struct
    integer ninterval
    character*2 direction ! used to recognize CQ and directional CQ messages, 01 - CQ, 00 - other messages
    character*6 call2
    real freq
    real dt
  end type rxfreq_struct
  type(rxfreq_struct) rxfreq(20)
  
  type rxfreqchg_struct
    integer ninterval
    integer nfqso
    logical rxfchanged
  end type rxfreqchg_struct
  type(rxfreqchg_struct) rxfchg(1)
  
  integer ninterval
  real freq,maxsync2,maxsync2freq
  
  save

end module jt65_mod8

! This source code file was last time modified by Igor UA3DJY on February 6th, 2017
! All changes are shown in the patch file coming together with the full JTDX source code.

subroutine splitmsgdupe(decodedhist,callncq)

  character decodedhist*22,callncq*6

  if(decodedhist(1:3).eq.'CQ ' .or. &
     decodedhist(1:3).eq.'QRZ' .or. decodedhist(1:3).eq.'DE ') return

  i1=index(decodedhist,' ')
  if(i1.lt.4) return
  i2=index(decodedhist(i1+1:),' ')
  if(i2.lt.4) return
  i2=i2+i1
  if(len_trim(decodedhist(i1+1:i2-1)).gt.6) return
  callncq=decodedhist(i1+1:i2-1)


return
end subroutine splitmsgdupe

module timer_c_wrapper
  use :: iso_c_binding, only: c_ptr
  use timer_module, only: timer, null_timer
  implicit none

  !
  ! C interoperable callback setup
  !
  abstract interface
     subroutine c_timer_callback (context, dname, k)
       use, intrinsic :: iso_c_binding, only: c_ptr, c_char
       implicit none
       type(c_ptr), value, intent(in) :: context
       character(c_char), intent(in) :: dname(*)
       integer, intent(in), value :: k
     end subroutine c_timer_callback
  end interface

  public :: init, fini

  private

  !
  ! the following are singleton items which assumes that any timer
  ! implementation should only assume one global instance, probably a
  ! struct or class object whose address is stored the context below
  !
  type(c_ptr), private :: the_context
  procedure(C_timer_callback), pointer, private :: the_callback

contains
  subroutine timer_callback_wrapper (dname, k)
    use, intrinsic :: iso_c_binding, only: c_null_char
    implicit none
    character(len=8), intent(in) :: dname
    integer, intent(in) :: k
    call the_callback (the_context, trim (dname) // c_null_char, k)
  end subroutine timer_callback_wrapper

  subroutine init (context, callback)
    use, intrinsic :: iso_c_binding, only: c_ptr, c_funptr, c_f_procpointer
    use iso_c_utilities, only: c_to_f_string
    use timer_module, only: timer
    implicit none
    type(c_ptr), value, intent(in) :: context
    type(c_funptr), value, intent(in) :: callback
    the_context=context
    call c_f_procpointer (callback, the_callback)
    timer => timer_callback_wrapper
  end subroutine init

  subroutine fini ()
    implicit none
    timer => null_timer
  end subroutine fini

end module timer_c_wrapper

subroutine azdist(MyGrid,HisGrid,utch,nAz,nEl,nDmiles,nDkm,nHotAz,nHotABetter)

  character(len=*) :: MyGrid,HisGrid
  character*8 mygrid0,hisgrid0
  real*8 utch,utch0
  logical HotABetter,IamEast
  real eltab(22),daztab(22)
  data eltab/18.,15.,13.,11.,9.,8.,7.,6.,5.3,4.7,4.,3.3,2.7,    &
       2.,1.5,1.,0.8,0.6,0.4,0.2,0.0,0.0/
  data daztab/21.,18.,16.,15.,14.,13.,12.,11.,10.7,10.3,10.,    &
       10.,10.,10.,10.,10.,10.,9.,9.,9.,8.,8./
  data mygrid0/"        "/,hisgrid0/"        "/,utch0/-999.d0/
  save

  if(MyGrid.eq.HisGrid) then
     naz=0
     nel=0
     ndmiles=0
     ndkm=0
     nhotaz=0
     nhotabetter=1
     go to 999
  endif

  if(mygrid.eq.mygrid0 .and. hisgrid.eq.hisgrid0 .and.              &
       abs(utch-utch0).lt.0.1666667d0) go to 900
  utch0=utch
  mygrid0=mygrid
  hisgrid0=hisgrid
  utchours=utch

  if(MyGrid(5:5).eq.' ') MyGrid(5:5)='l'
  if(MyGrid(6:6).eq.' ') MyGrid(6:6)='l'
  if(HisGrid(5:5).eq.' ') HisGrid(5:5)='l'
  if(HisGrid(6:6).eq.' ') HisGrid(6:6)='l'
  if(MyGrid(7:7).eq.' ') MyGrid(7:7)='5'
  if(MyGrid(8:8).eq.' ') MyGrid(8:8)='5'
  if(HisGrid(7:7).eq.' ') HisGrid(7:7)='5'
  if(HisGrid(8:8).eq.' ') HisGrid(8:8)='5'

  if(MyGrid.eq.HisGrid) then
     Az=0.
     Dmiles=0.
     Dkm=0.0
     El=0.
     HotA=0.
     HotB=0.
     HotABetter=.true.
     go to 900
  endif
  call grid2deg(MyGrid,dlong1,dlat1)
  call grid2deg(HisGrid,dlong2,dlat2)
  eps=1.e-6
  Az=0.
  Dmiles=0.
  Dkm=0.0
  El=0.
  HotA=0.
  HotB=0.
  HotABetter=.true.
  if(abs(dlat1-dlat2).lt.eps .and. abs(dlong1-dlong2).lt.eps) go to 900

  difflong=mod(dlong1-dlong2+720.0,360.0)
  if(abs(dlat1+dlat2).lt.eps .and. abs(difflong-180.0).lt.eps) then
! Antipodes
     Dkm=20400
     go to 900
  endif

  call geodist(dlat1,dlong1,dlat2,dlong2,Az,Baz,Dkm)

  ndkm=Dkm/100
  j=ndkm-4
  if(j.lt.1) j=1
  if(j.gt.21)j=21
  if(Dkm.lt.500.0) then
     El=18.0
  else
     u=(Dkm-100.0*ndkm)/100.0
     El=(1.0-u)*eltab(j) + u*eltab(j+1)
  endif

  daz=daztab(j) + u * (daztab(j+1)-daztab(j))
  Dmiles=Dkm/1.609344

  tmid=mod(UTChours-0.5*(dlong1+dlong2)/15.0+48.0,24.0)
  IamEast=.false.
  if(dlong1.lt.dlong2) IamEast=.true.
  if(dlong1.eq.dlong2 .and. dlat1.gt.dlat2) IamEast=.false.
  azEast=baz
  if(IamEast) azEast=az
  if((azEast.ge.45.0 .and. azEast.lt.135.0) .or.                    &
       (azEast.ge.225.0 .and. azEast.lt.315.0)) then
! The path will be taken as "east-west".
     HotABetter=.true.
     if(abs(tmid-6.0).lt.6.0) HotABetter=.false.
     if((dlat1+dlat2)/2.0 .lt. 0.0) HotABetter=.not.HotABetter
  else
! The path will be taken as "north-south".
     HotABetter=.false.
     if(abs(tmid-12.0).lt.6.0) HotABetter=.true.
  endif
  if(IamEast) then
     HotA = Az - daz
     HotB = Az + daz
  else
     HotA = Az + daz
     HotB = Az - daz
  endif
  if(HotA.lt.0.0)   HotA=HotA+360.0
  if(HotA.gt.360.0) HotA=HotA-360.0
  if(HotB.lt.0.0)   HotB=HotB+360.0
  if(HotB.gt.360.0) HotB=HotB-360.0

900 continue
  naz=nint(Az)
  nel=nint(el)
  nDmiles=nint(Dmiles)
  nDkm=nint(Dkm)
  nHotAz=nint(HotB)
  nHotABetter=0
  if(HotABetter) then
     nHotAz=nint(HotA)
     nHotABetter=1
  endif

999 return
end subroutine azdist

subroutine imopen(plotfile)
  character*(*) plotfile
  common/imcom/ lu,npage

  lu=80
  open(lu,file=plotfile,status='unknown')
  write(lu,1000) 
1000 format('%!PS-Adobe-2.0'/                                            &
          '/rightshow { dup stringwidth pop neg 0 rmoveto show } def'/   &
          '/centershow { dup stringwidth pop neg 2 div ',                &
          '0 rmoveto show } def'/                                        &
          '/lt { lineto } def'/'%%Page: 1 1')
  npage=1

  return
end subroutine imopen

subroutine impalette(palette)
  character*(*) palette
  integer r(0:8),g(0:8),b(0:8)
  integer rr,gg,bb
  common/imcom/ lu,npage
  common/imcom2/rr(0:255),gg(0:255),bb(0:255)

  if(palette.eq.'afmhot') then
     do i=0,255
        j=255-i
        rr(i)=min(255,2*j)
        gg(i)=max(0,min(255,2*j-128))
        bb(i)=max(0,min(255,2*j-256))
     enddo
  else if(palette.eq.'hot') then
     do i=0,255
        j=255-i
        rr(i)=min(255,3*j)
        gg(i)=max(0,min(255,3*j-256))
        bb(i)=max(0,min(255,3*j-512))
     enddo
  else
     open(11,file="Palettes/"//palette,status="old")
     do j=0,8
        read(11,*) r(j),g(j),b(j)
     enddo
     close(11)
     do i=0,255
        j0=i/32
        j1=j0+1
        k=i-32*j0
        rr(i)=r(j0) + int((k*(r(j1)-r(j0)))/31 + 0.5)
        gg(i)=g(j0) + int((k*(g(j1)-g(j0)))/31 + 0.5)
        bb(i)=b(j0) + int((k*(b(j1)-b(j0)))/31 + 0.5)
     enddo

  endif

  return
end subroutine impalette

subroutine imclose
  common/imcom/ lu,npage
  write(lu,1000)
1000 format('showpage'/'%%Trailer')
  close(lu)
  return
end subroutine imclose

subroutine imnewpage
  common/imcom/ lu,npage
  npage=npage+1
  write(lu,1000) npage,npage
1000 format('showpage'/'%%Page:',2i4)
  return
end subroutine imnewpage

subroutine imxline(x,y,dx)
! Draw a line from (x,y) to (x+dx,y)  integer r,g,b
  common/imcom/ lu,npage
  write(lu,1000) 72.0*x,72.0*y,72.0*dx
1000 format('newpath',2f7.1,' moveto',f7.1,' 0 rlineto stroke')
  return
end subroutine imxline

subroutine imyline(x,y,dy)
! Draw a line from (x,y) to (x,y+dy)
  common/imcom/ lu,npage
  write(lu,1000) 72.0*x,72.0*y,72.0*dy
1000 format('newpath',2f7.1,' moveto 0',f7.1,' rlineto stroke')
  return
end subroutine imyline

subroutine imwidth(width)
  common/imcom/ lu,npage
  write(lu,1000) width
1000 format(f7.1,' setlinewidth')
  return
end subroutine imwidth

subroutine imfont(fontname,npoints)
  character*(*) fontname
  common/imcom/ lu,npage
  write(lu,1000) fontname,npoints
1000 format('/',a,' findfont',i4,' scalefont setfont')
  return
end subroutine imfont

subroutine imstring(string,x,y,just,ndeg)
  character*(*) string
  common/imcom/ lu,npage
  write(lu,1000) 72.0*x,72.0*y,ndeg,string
1000 format(2f7.1,' moveto',i4,' rotate'/'(',a,')')
  if(just.eq.1) write(lu,*) 'rightshow'
  if(just.eq.2) write(lu,*) 'centershow'
  if(just.eq.3) write(lu,*) 'show'
  write(lu,1010) -ndeg
1010 format(i4,' rotate'/)
  return
end subroutine imstring

subroutine imr4mat(z,IP,JP,imax,jmax,zz1,zz2,x,y,dx,dy,nbox)
  real z(IP,JP)
  integer idat(2048)
  common/imcom/ lu,npage

  z1=zz1
  z2=zz2
  if(z1.eq.0.0 .and. z2.eq.0.0) then
     z1=z(1,1)
     z2=z1
     do i=1,imax
        do j=1,jmax
           z1=min(z(i,j),z1)
           z2=max(z(i,j),z2)
        enddo
     enddo
  endif
  scale=255.99/(z2-z1)

  write(lu,1002) 72.0*x,72.0*y,72.0*dx,72.0*dy
1002 format(2f7.1,' translate',2f7.1,' scale')
  write(lu,*) imax,jmax,8,' [',imax,0,0,jmax,0,0,']'
  write(lu,*) '{<'

  do j=1,jmax
     do i=1,imax
        idat(i)=scale*(z(i,j)-z1)
        idat(i)=max(idat(i),0)
        idat(i)=min(idat(i),255)
        idat(i)=255-idat(i)
     enddo
     write(lu,1004) (idat(i),i=1,imax)
1004 format(30z2.2)
  enddo
  write(lu,*) '>} image'
  write(lu,1006) 1.0/(72.0*dx),1.0/(72.0*dy),-72.0*x,-72.0*y
1006 format(2f9.6,' scale',2f7.1,' translate')

  if(nbox.ne.0) then
     write(lu,1010) 72.0*x,72.0*y,72.0*dx,72.0*dy,-72*dx
1010 format('newpath',2f7.1,' moveto',f7.1,' 0 rlineto 0',             &
          f7.1,' rlineto',f7.1,' 0 rlineto closepath stroke')
  endif

  return
end subroutine imr4mat

subroutine imr4mat_color(z,IP,JP,imax,jmax,zz1,zz2,x,y,dx,dy,nbox)
  real z(IP,JP)
  integer idat(2048,3)
  integer rr,gg,bb
  common/imcom/ lu,npage
  common/imcom2/rr(0:255),gg(0:255),bb(0:255)

  z1=zz1
  z2=zz2
  if(z1.eq.0.0 .and. z2.eq.0.0) then
     z1=z(1,1)
     z2=z1
     do i=1,imax
        do j=1,jmax
           z1=min(z(i,j),z1)
           z2=max(z(i,j),z2)
        enddo
     enddo
  endif
  scale=255.99/(z2-z1)

  write(lu,1002) 72.0*x,72.0*y,72.0*dx,72.0*dy
1002 format(2f7.1,' translate',2f7.1,' scale')
  write(lu,1003) imax,jmax,8,imax,0,0,jmax,0,0
1003 format(3i5,' [',6i4,']')
  write(lu,1004) imax
1004 format('{currentfile 3',i4,' mul string readhexstring pop} bind'/   &
          'false 3 colorimage')

  do j=1,jmax
     do i=1,imax
        n=scale*(z(i,j)-z1)
        n=max(n,0)
        n=min(n,255)
        idat(i,1)=rr(n)
        idat(i,2)=gg(n)
        idat(i,3)=bb(n)
     enddo
     write(lu,1005) (idat(i,1),idat(i,2),idat(i,3),i=1,imax)
1005 format(30z2.2)
  enddo

  write(lu,1006) 1.0/(72.0*dx),1.0/(72.0*dy),-72.0*x,-72.0*y
1006 format(2f9.6,' scale',2f7.1,' translate')

  if(nbox.ne.0) then
     write(lu,1010) 72.0*x,72.0*y,72.0*dx,72.0*dy,-72*dx
1010 format('newpath',2f7.1,' moveto',f7.1,' 0 rlineto 0',             &
          f7.1,' rlineto',f7.1,' 0 rlineto closepath stroke')
  endif

  return
end subroutine imr4mat_color

subroutine imr4pro(p,imax,yy1,yy2,x,y,dx,dy,nbox)
  real p(imax)
  common/imcom/ lu,npage

  y1=yy1
  y2=yy2
  if(y1.eq.0.0 .and. y2.eq.0.0) then
     y1=p(1)
     y2=y1
     do i=1,imax
        y1=min(p(i),y1)
        y2=max(p(i),y2)
     enddo
  endif

  xscale=72.0*dx/imax
  xoff=72.0*x
  yscale=72.0*dy
  if(y1.ne.y2) yscale=yscale/(y2-y1)
  yoff=72.0*y

  write(lu,*) '1.416 setmiterlimit'
  write(lu,1002) xoff+0.5*xscale,yoff+yscale*(p(1)-y1)
1002 format('newpath',2f7.1,' moveto')

  do i=2,imax
     write(lu,1004) xoff+(i-0.5)*xscale,yoff+yscale*(p(i)-y1)
1004 format(2f6.1,' lt')
  enddo
  write(lu,*) 'stroke'

  if(nbox.ne.0) then
     write(lu,1010) xoff,yoff,72.0*dx,72.0*dy,-72*dx
1010 format('newpath',2f7.1,' moveto',f7.1,' 0 rlineto 0',               &
          f7.1,' rlineto',f7.1,' 0 rlineto closepath stroke')
  endif

  return
end subroutine imr4pro

subroutine imline(x1,y1,x2,y2)
  common/imcom/ lu,npage
  write(lu,1000) 72*x1,72*y1,72*x2,72*y2
1000 format('newpath',2f7.1,' moveto',2f7.1,' lineto stroke')
  return
end subroutine imline

subroutine imcircle(x,y,radius,shade)
  common/imcom/ lu,npage
  write(lu,1000) shade
1000 format(f7.1,' setgray')
  write(lu,1002) 72*x,72*y,72*radius
1002 format('newpath',3f7.1,' 0 360 arc fill')
  write(lu,1000) 0.0
  write(lu,1004) 72*x,72*y,72*radius
1004 format('newpath',3f7.1,' 0 360 arc stroke')
  return
end subroutine imcircle

subroutine imtriangle(x,y,rr,shade)
  common/imcom/ lu,npage
  write(lu,1000) shade
1000 format(f7.1,' setgray')
  write(lu,1002) 72*x,72*(y+rr)
1002 format('newpath',2f7.1,' moveto ')
  write(lu,1004) 72*(x-rr),72*(y-rr)
1004 format(2f7.1,' lineto ')
  write(lu,1004) 72*(x+rr),72*(y-rr)
  write(lu,*) 'closepath fill 0 setgray'
  write(lu,1002) 72*x,72*(y+rr)
  write(lu,1004) 72*(x-rr),72*(y-rr)
  write(lu,1004) 72*(x+rr),72*(y-rr)
  write(lu,*) 'closepath stroke'
  
  return
end subroutine imtriangle

subroutine imr4prov(p,jmax,xx1,xx2,x,y,dx,dy,nbox)
  real p(jmax)
  common/imcom/ lu,npage

  x1=xx1
  x2=xx2
  if(x1.eq.0.0 .and. x2.eq.0.0) then
     x1=p(1)
     x2=x1
     do j=1,jmax
        x1=min(p(j),x1)
        x2=max(p(j),x2)
     enddo
  endif

  xscale=72.0*dx
  xoff=72.0*x
  if(x1.ne.x2) xscale=xscale/(x2-x1)

  yscale=72.0*dy/jmax
  yoff=72.0*y
  
  write(lu,*) '1.416 setmiterlimit'
  write(lu,1002) xoff+xscale*(x2-p(1)),yoff+0.5*yscale
1002 format('newpath',2f7.1,' moveto')
  
  do j=2,jmax
     write(lu,1004) xoff+xscale*(x2-p(j)),yoff+(j-0.5)*yscale
1004 format(2f6.1,' lt')
  enddo
  write(lu,*) 'stroke'

  if(nbox.ne.0) then
     write(lu,1010) xoff,yoff,72.0*dx,72.0*dy,-72*dx
1010 format('newpath',2f7.1,' moveto',f7.1,' 0 rlineto 0',            &
          f7.1,' rlineto',f7.1,' 0 rlineto closepath stroke')
  endif

  return
end subroutine imr4prov

program mfsk
! Compute probability of symbol error for non-coherent MFSK
  implicit real*16 (a-h,o-z)
  integer*8 binomial
  integer x,s,XX,NN,M
  real*16 hypergeo, snr, term, sum
  character arg*8

  nargs=iargc()
  if(nargs.ne.1) then
     print*,'Probability of symbol error for noncoherent MFSK'
     print*,'Usage:    mfsk   M'
     print*,'Example:  mfsk  64'
     go to 999
  endif
  call getarg(1,arg)
  read(arg,*) M

  write(*,1012) 
1012 format('Es/No  P(symbol error)'/  &
             '----------------------')
  do isnr=0,40
    esno=10**(isnr/2.0/10.0)
    hsum=0.d0
    do k=1,M-1
      h=binomial(M-1,k)
      h=h*((-1)**(k+1))/(k+1)
      h=h*exp(-esno*k/(k+1))
      hsum=hsum + h
    enddo
    write(*,'(f4.1,4x,e10.4)') isnr/2.0, hsum
  enddo
999 end program mfsk

program chkfft

! Tests and times one-dimensional FFTs computed by FFTW3
  use FFTW3
  parameter (NMAX=8*1024*1024)           !Maximum FFT length
  complex a(NMAX),b(NMAX),c(NMAX)
  real ar(NMAX),br(NMAX),cr(NMAX)
  real mflops
  integer*8 plan1,plan2                  !Pointers to stored plans
  character infile*12,arg*8
  logical list
  common/patience/npatience
  equivalence (a,ar),(b,br),(c,cr)
!  include 'fftw3.f90'                    !FFTW definitions

  nargs=iargc()
  if(nargs.ne.6) then
     print*,'Usage: chkfft <nfft | infile> nr nw nc np inplace'
     print*,'       nfft:    length of FFT'
     print*,'       nfft=0:  do lengths 2^n, n=2^4 to 2^23'
     print*,'       infile:  name of file with nfft values, one per line'
     print*,'       nr:      0/1 to not read (or read) wisdom'
     print*,'       nw:      0/1 to not write (or write) wisdom'
     print*,'       nc:      0/1 for real or complex data'
     print*,'       np:      0-4 patience for finding best algorithm'
     print*,'       inplace: 1 for inplace, 0 otherwise'
     go to 999
  endif

  list=.false.
  nfft=-1
  call getarg(1,infile)
  open(10,file=infile,status='old',err=1)
  list=.true.                          !A valid file name was provided
  go to 2
1 read(infile,*) nfft                  !Take first argument to be nfft
2  call getarg(2,arg)
  read(arg,*) nr
  call getarg(3,arg)
  read(arg,*) nw
  call getarg(4,arg)
  read(arg,*) ncomplex
  call getarg(5,arg)
  read(arg,*) npatience
  call getarg(6,arg)
  read(arg,*) inplace

  if(list) write(*,1000) infile,nr,nw,ncomplex,npatience
1000 format(/'infile: ',a12,'   nr:',i2,'   nw',i2,'   nc:',i2,'   np:',i2/)
  if(.not.list) write(*,1002) nfft,nr,nw,ncomplex,npatience
1002 format(/'nfft: ',i10,'   nr:',i2,'   nw',i2,'   nc:',i2,'   np:',i2/)

  nflags=FFTW_ESTIMATE
  if(npatience.eq.1) nflags=FFTW_ESTIMATE_PATIENT
  if(npatience.eq.2) nflags=FFTW_MEASURE
  if(npatience.eq.3) nflags=FFTW_PATIENT
  if(npatience.eq.4) nflags=FFTW_EXHAUSTIVE

  open(12,file='chkfft.out',status='unknown')
  open(13,file='fftwf_wisdom.dat',status='unknown')

  if(nr.ne.0) then
     call import_wisdom_from_file(isuccess,13)
     if(isuccess.eq.0) then
        write(*,1010) 
1010    format('Failed to import FFTW wisdom.')
        go to 999
     endif
  endif

  idum=-1                               !Set random seed
  ndim=1				!One-dimensional transforms
  do i=1,NMAX                           !Set random data
     x=gran()
     y=gran()
     b(i)=cmplx(x,y)                    !Generate random data
  enddo

  iters=1000000
  if(list .or. (nfft.gt.0)) then
     n1=1
     n2=1
     if(nfft.eq.-1) n2=999999
     write(*,1020) 
1020 format('    NFFT     Time        rms      MHz   MFlops  iters',    &
          '  tplan'/61('-'))
  else
     n1=4
     n2=23
     write(*,1030) 
1030 format(' n   N=2^n     Time        rms      MHz   MFlops  iters',  &
          '  tplan'/63('-'))
  endif

  do ii=n1,n2                           !Test one or more FFT lengths
     if(list) then
        read(10,*,end=900) nfft         !Read nfft from file
     else if(n2.gt.n1) then
        nfft=2**ii                      !Do powers of 2
     endif

     iformf=1
     iformb=1
     if(ncomplex.eq.0) then
        iformf=0                        !Real-to-complex transform
        iformb=-1                       !Complex-to-real (inverse) transform
     endif

     if(nfft.gt.NMAX) go to 900
     a(1:nfft)=b(1:nfft)                !Copy test data into a()
     t0=second()
     if(inplace.ne.0) then
        if(ncomplex.ne.0) then
           call sfftw_plan_dft_1d(plan1,nfft,a,a,FFTW_FORWARD,nflags)
           call sfftw_plan_dft_1d(plan2,nfft,a,a,FFTW_BACKWARD,nflags)
        else
           call sfftw_plan_dft_r2c_1d(plan1,nfft,a,a,nflags)
           call sfftw_plan_dft_c2r_1d(plan2,nfft,a,a,nflags)
        endif
     else
        if(ncomplex.ne.0) then
           call sfftw_plan_dft_1d(plan1,nfft,a,c,FFTW_FORWARD,nflags)
           call sfftw_plan_dft_1d(plan2,nfft,c,a,FFTW_BACKWARD,nflags)
        else
           call sfftw_plan_dft_r2c_1d(plan1,nfft,a,c,nflags)
           call sfftw_plan_dft_c2r_1d(plan2,nfft,c,a,nflags)
        endif
     endif

     t2=second()
     tplan=t2-t0                        !Total planning time for this length
     
     total=0.
     do iter=1,iters                    !Now do many iterations
        a(1:nfft)=b(1:nfft)             !Copy test data into a()
        t0=second()
        call sfftw_execute(plan1)
        call sfftw_execute(plan2)
        t1=second()
        total=total+t1-t0
        if(total.ge.1.0) go to 40       !Cut iterations short if t>1 s
     enddo
     iter=iters

40   time=0.5*total/iter                !Time for one FFT of current length
     tplan=0.5*tplan-time               !Planning time for one FFT
     if(tplan.lt.0) tplan=0.
     a(1:nfft)=a(1:nfft)/nfft

! Compute RMS difference between original array and back-transformed array.
     sq=0.
     if(ncomplex.eq.1) then
        do i=1,nfft
           sq=sq + real(a(i)-b(i))**2 + imag(a(i)-b(i))**2
        enddo
     else
        do i=1,nfft
           sq=sq + (ar(i)-br(i))**2
        enddo
     endif
     rms=sqrt(sq/nfft)

     freq=1.e-6*nfft/time
     mflops=5.0/(1.e6*time/(nfft*log(float(nfft))/log(2.0)))
     if(n2.eq.1 .or. n2.eq.999999) then
        write(*,1050) nfft,time,rms,freq,mflops,iter,tplan
        write(12,1050) nfft,time,rms,freq,mflops,iter,tplan
1050    format(i8,f11.7,f12.8,f7.2,f8.1,i8,f6.1)
     else
        write(*,1060) ii,nfft,time,rms,freq,mflops,iter,tplan
        write(12,1060) ii,nfft,time,rms,freq,mflops,iter,tplan
1060    format(i2,i8,f11.7,f12.8,f7.2,f8.1,i8,f6.1)
     endif
  enddo

900  continue 
  if(nw.eq.1) then
     rewind 13
     call export_wisdom_to_file(13)
!     write(*,1070) 
!1070 format(/'Exported FFTW wisdom')
  endif

  call sfftw_destroy_plan(plan1)
  call sfftw_destroy_plan(plan2)

999 end program chkfft

subroutine sun(y,m,DD,UT,lon,lat,RA,Dec,LST,Az,El,mjd,day)

  implicit none

  integer y                         !Year
  integer m                         !Month
  integer DD                        !Day
  integer mjd                       !Modified Julian Date
  real UT                           !UT!in hours
  real RA,Dec                       !RA and Dec of sun

! NB: Double caps here are single caps in the writeup.

! Orbital elements of the Sun (also N=0, i=0, a=1):
  real w                            !Argument of perihelion
  real e                            !Eccentricity
  real MM                           !Mean anomaly
  real Ls                           !Mean longitude

! Other standard variables:
  real v                            !True anomaly
  real EE                           !Eccentric anomaly
  real ecl                          !Obliquity of the ecliptic
  real d                            !Ephemeris time argument in days
  real r                            !Distance to sun, AU
  real xv,yv                        !x and y coords in ecliptic
  real lonsun                       !Ecliptic long and lat of sun
!Ecliptic coords of sun (geocentric)
  real xs,ys
!Equatorial coords of sun (geocentric)
  real xe,ye,ze
  real lon,lat
  real GMST0,LST,HA
  real xx,yy,zz
  real xhor,yhor,zhor
  real Az,El

  real day
  real rad
  data rad/57.2957795/

! Time in days, with Jan 0, 2000 equal to 0.0:
  d=367*y - 7*(y+(m+9)/12)/4 + 275*m/9 + DD - 730530 + UT/24.0
  mjd=d + 51543
  ecl = 23.4393 - 3.563e-7 * d

! Compute updated orbital elements for Sun:
  w = 282.9404 + 4.70935e-5 * d
  e = 0.016709 - 1.151e-9 * d
  MM = mod(356.0470d0 + 0.9856002585d0 * d + 360000.d0,360.d0)
  Ls = mod(w+MM+720.0,360.0)

  EE = MM + e*rad*sin(MM/rad) * (1.0 + e*cos(M/rad))
  EE = EE - (EE - e*rad*sin(EE/rad)-MM) / (1.0 - e*cos(EE/rad))

  xv = cos(EE/rad) - e
  yv = sqrt(1.0-e*e) * sin(EE/rad)
  v = rad*atan2(yv,xv)
  r = sqrt(xv*xv + yv*yv)
  lonsun = mod(v + w + 720.0,360.0)
! Ecliptic coordinates of sun (rectangular):
  xs = r * cos(lonsun/rad)
  ys = r * sin(lonsun/rad)

! Equatorial coordinates of sun (rectangular):
  xe = xs
  ye = ys * cos(ecl/rad)
  ze = ys * sin(ecl/rad)

! RA and Dec in degrees:
  RA = rad*atan2(ye,xe)
  Dec = rad*atan2(ze,sqrt(xe*xe + ye*ye))

  GMST0 = (Ls + 180.0)/15.0
  LST = mod(GMST0+UT+lon/15.0+48.0,24.0)    !LST in hours
  HA = 15.0*LST - RA                        !HA in degrees
  xx = cos(HA/rad)*cos(Dec/rad)
  yy = sin(HA/rad)*cos(Dec/rad)
  zz =             sin(Dec/rad)
  xhor = xx*sin(lat/rad) - zz*cos(lat/rad)
  yhor = yy
  zhor = xx*cos(lat/rad) + zz*sin(lat/rad)
  Az = mod(rad*atan2(yhor,xhor) + 180.0 + 360.0,360.0)
  El = rad*asin(zhor)
  day=d-1.5
  
  return
end subroutine sun

module jt65_mod9 
! stores callsign DB in memory for false decodes checking
  
  parameter (MAXC=200000)
! supporting 7-char Australian callsigns
  character*7 call0c(11500),calld(11100),callef(9000),callgh(7500),calli(7600),callj(9000),callk(24000),calllm(6500), &
              calln(9400),callo(6700),callpq(5800),callr(6500),callst(7500),calluv(10400),callw(13700),callxz(5800)
  character callsign*12
  character*180 line
  integer ncall0c,ncalld,ncallef,ncallgh,ncalli,ncallj,ncallk,ncalllm,ncalln,ncallo,ncallpq,ncallr,ncallst,ncalluv, &
          ncallw,ncallxz
  logical ldbvalid
  data ldbvalid/.true./
  data ncall0c,ncalld,ncallef,ncallgh,ncalli,ncallj,ncallk,ncalllm,ncalln,ncallo,ncallpq,ncallr,ncallst,ncalluv,ncallw, &
       ncallxz/0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0/

end module jt65_mod9

subroutine grid2deg(grid0,dlong,dlat)

! Converts Maidenhead grid locator to degrees of West longitude
! and North latitude.

  character*8 grid0,grid
  character*1 g1,g2,g3,g4,g5,g6,g7,g8

  grid=grid0
  i=ichar(grid(5:5))
  if(grid(5:5).eq.' ' .or. i.le.64 .or. i.ge.128) grid(5:6)='ll'
  i2=ichar(grid(7:7))
  if(grid(7:7).eq.' ' .or. i2.le.47 .or. i2.ge.58) grid(7:8)='55'

  if(grid(1:1).ge.'a' .and. grid(1:1).le.'z') grid(1:1)=          &
        char(ichar(grid(1:1))+ichar('A')-ichar('a'))
  if(grid(2:2).ge.'a' .and. grid(2:2).le.'z') grid(2:2)=          &
        char(ichar(grid(2:2))+ichar('A')-ichar('a'))
  if(grid(5:5).ge.'A' .and. grid(5:5).le.'Z') grid(5:5)=          &
        char(ichar(grid(5:5))-ichar('A')+ichar('a'))
  if(grid(6:6).ge.'A' .and. grid(6:6).le.'Z') grid(6:6)=          &
        char(ichar(grid(6:6))-ichar('A')+ichar('a'))

  g1=grid(1:1)
  g2=grid(2:2)
  g3=grid(3:3)
  g4=grid(4:4)
  g5=grid(5:5)
  g6=grid(6:6)
  g7=grid(7:7)
  g8=grid(8:8)

  nlong = 180 - 20*(ichar(g1)-ichar('A'))
  n20d = 2*(ichar(g3)-ichar('0'))
  xminlong2 = (ichar(g7)-ichar('0')) / 10.0
  xminlong = 5*(ichar(g5)-ichar('a')+xminlong2)
  dlong = nlong - n20d - xminlong/60.0
  nlat = -90+10*(ichar(g2)-ichar('A')) + ichar(g4)-ichar('0')
  xminlat2 = (ichar(g8)-ichar('0')) / 10.0
  xminlat = 2.5*(ichar(g6)-ichar('a')+xminlat2)
  dlat = nlat + xminlat/60.0
!  print *, grid, nlong, n20d, xminlong2, xminlong, dlong, nlat, xminlat2, xminlat, dlat
  return
end subroutine grid2deg

program fixwav

  use wavhdr
  parameter (NBANDS=23,NMODES=11)
  parameter(NMAX=120*12000)
  type(hdr) h
  integer*2 id2(NMAX),id(4)
  character*8 mode,mode0
  character*6 band
  character*12 arg
  character*80 infile
  character*1 c
  logical ok

  nargs=iargc()
  if(nargs.ne.1 .and. nargs.ne.5) then
     print*,'Usage: fixwav [fMHz mode submode TRperiod] infile'
     go to 999
  endif
  call getarg(1,infile)
  if(nargs.eq.1) go to 10
  read(infile,*) fMHz
  call getarg(2,mode0)
  call getarg(3,arg)
  nsubmode0=-1
  do i=1,8
     if(arg(1:1).eq.char(ichar('A')-1+i)) nsubmode0=i
  enddo
  if(nsubmode0.lt.0) read(arg,*) nsubmode0
  call getarg(4,arg)
  read(arg,*) ntrperiod0
  call getarg(5,infile)

10 open(10,file=infile,status='old',access='stream')
  read(10) h
  npts=h%ndata/2
  nfsample=h%nsamrate
  read(10) id2(1:npts)
  write(*,1002) h%nchan2,h%nbitsam2,h%nsamrate,npts
1002 format('Channels:',i2,'   Bits/sample:',i3,'   Sample rate:',i6,   &
          '   Npts:',i8)

  call get_wsjtx_wav_params(id2,band,mode,nsubmode,ntrperiod,ok)
  if(nfsample.ne.11025 .and. nfsample.ne.12000) ok=.false.
  if(ok) write(*,1010) band,ntrperiod,mode,char(ichar('A')-1+id2(3))
1010 format('Band: ',a6,'  T/R period:',i4,'   Mode: ',a8,1x,a1)

  if(.not.ok) write(*,'(a)') 'File has no valid WSJT-X params.'
  if(ok .and. nargs.eq.1) go to 999

  write(*,'(a)',advance='no') 'Do you want to add or change them? (Y/N): '
  read*,c
  if(c.ne.'y' .and. c.ne.'Y') go to 999

  print*,fMHz,mode0,nsubmode0,ntrperiod0
  call set_wsjtx_wav_params(fMHz,mode0,nsubmode0,ntrperiod0,id2)
  band=""
  mode=""
  nsubmode=0
  ntrperiod=0
  call get_wsjtx_wav_params(id2,band,mode,nsubmode,ntrperiod,ok)
  write(*,1010) band,ntrperiod,mode,char(ichar('A')-1+id2(3))
  rewind 10
  write(10) h,id2(1:npts)

999 end program fixwav

program prob

  implicit real*8 (a-h,o-z)
  integer*8 binomial
  integer x,s,XX,NN
  real*8 hypergeo
  character arg*8

  nargs=iargc()
  if(nargs.ne.4) then
     print*,'Usage:    prob  x  N  X  s'
     print*,'Example:  prob 35 63 40 40'
     go to 999
  endif
  call getarg(1,arg)
  read(arg,*) x
  call getarg(2,arg)
  read(arg,*) NN
  call getarg(3,arg)
  read(arg,*) XX
  call getarg(4,arg)
  read(arg,*) s

!  print*,binomial(5, 3)             ! 10
!  print*,binomial(40, 19)           ! 131282408400

  write(*,1010) x,NN,XX,s
1010 format(//' x=',i2,'   N=',i2,'   X=',i2,'   s=',i2)
  write(*,1012) 
1012 format(/' x    P(x|N,X,s)  P(>=x|N,X,s) '/  &
             '-------------------------------')

  hsum=0.d0
  do ix=x,XX
     h=hypergeo(ix,NN,XX,s)
     hsum=hsum + h
     write(*,1020) ix,h,hsum
1020 format(i3,2d13.4)
  enddo

999 end program prob

! This source code file was last time modified by Igor UA3DJY on April 7th, 2017
! All changes are shown in the patch file coming together with the full JTDX source code.

real function fchisq10(c3,npts,fsample,a)

  parameter (NMAX=85*16)
  complex c3(npts)
  complex c4(NMAX)
  complex c5(NMAX)
  real a(3)
  real aa(3)
  complex z
  data a1,a2,a3/99.,99.,99./
  include 'jt10sync.f90'
  save

  if(a(1).ne.a1 .or. a(2).ne.a2 .or. a(3).ne.a3) then
     a1=a(1)
     a2=a(2)
     a3=a(3)
     call twkfreq(c3,c4,npts,fsample,a)
     aa(1)=-1500.0*4.0/864 !-1500.0*4.0/nsps8
     aa(2)=0.
     aa(3)=0.
     call twkfreq(c4,c5,npts,fsample,aa)
  endif

! Get sync power.
  nspsd=16
  sum1=0.
  k=-1
  do i=1,85
     if(isync(i).eq.1 .or. isync(i).eq.2) then
        z=0.
        if(isync(i).eq.1) then
           do j=1,nspsd
              k=k+1
              z=z+c4(k+1)
           enddo
        endif
        if(isync(i).eq.2) then
           do j=1,nspsd
              k=k+1
              z=z+c5(k+1)
           enddo
        endif
        pp=real(z)**2 + aimag(z)**2     
        sum1=sum1+pp
     endif
  enddo
!  sync_4992=(sum1/16.0)/(sum0/69.0) - 1.0             !r4992
!  sync_4993=sum1/10000.0
  syncpwr=sum1/2500.0

! Get sync power.
!  nspsd=16
!  sum1=0.
!  sum0=0.
!  k=-1
!  do i=1,85
!     z=0.
!     do j=1,nspsd
!        k=k+1
!        z=z+c4(k+1)
!     enddo
!     pp=real(z)**2 + aimag(z)**2     
!     if(isync(i).eq.1 .or. isync(i).eq.2) then
!        sum1=sum1+pp
!     else
!        sum0=sum0+pp
!     endif
!  enddo
!!  sync_4992=(sum1/16.0)/(sum0/69.0) - 1.0             !r4992
!  sync_4993=sum1/10000.0                              !r4993+
!!  write(80,3001) 1.e-5*sum1,1.e-5*sum0,sync_4992,sync_4993,sync
!!3001 format(5f11.4)
!  fchisq10=-sync_4993
  fchisq10=-syncpwr

  return
end function fchisq10

subroutine shell(n,a)
  integer n
  real a(n)
  integer i,j,inc
  real v

  inc=1
1 inc=3*inc+1
  if(inc.le.n) go to 1
2  inc=inc/3

  do i=inc+1,n
     v=a(i)
     j=i
3    if(a(j-inc).gt.v) then
        a(j)=a(j-inc)
        j=j-inc
        if(j.le.inc) go to 4
        go to 3
     endif
4    a(j)=v
  enddo

  if(inc.gt.1) go to 2

  return
end subroutine shell

subroutine sfrsd(mrsym,mrprob,mr2sym,mr2prob,ntrials,correct,indexes,   &
     param,ntry)

  integer mrsym(0:62),mrprob(0:62),mr2sym(0:62),mr2prob(0:62)
  integer correct(0:62),indexes(0:62),probs(0:62),thresh0(0:62)
  integer rxdat(0:62),rxdat2(0:62),rxprob(0:62),rxprob2(0:62)
  integer workdat(0:62),era_pos(0:50)
  integer perr(0:7,0:7)
  integer param(0:7)
  real ratio0(0:62)

  call init_rs_int()
  do i=0,62
     rxdat(i)=mrsym(62-i)
     rxdat2(i)=mr2sym(62-i)
     rxprob(i)=mrprob(62-i)
     rxprob2(i)=mr2prob(62-i)
  enddo

  do i=0,62
     indexes(i)=i
     probs(i)=rxprob(i)
  enddo

  do ip=1,62
     do k=0,63-ip
        if(probs(k).lt.probs(k+1)) then
           ntmp=probs(k)
           probs(k)=probs(k+1)
           probs(k+1)=ntmp
           ntmp=indexes(k)
           indexes(k)=indexes(k+1)
           indexes(k+1)=ntmp
        endif
     enddo
  enddo

  era_pos=0
  numera=0
  workdat=rxdat
  call decode_rs_int()
  if(nerr.ge.0) then
     correct=workdat
     param=0
     return
  endif

  call random_seed()

  ncandidates=0
  nsum=0
  do i=0,62
     nsum=nsum+rxprob(i)
     j=indexes(62-i)
     ratio0(i)=float(rxprob2(j))/(float(rxprob(j))+0.01)
     ii=int(7.999*ratio0(i))
     jj=(62-i)/8
     thresh0(i)=nint(1.3*perr(jj,ii))
  enddo
  if(nsum.eq.0) return

  do k=0,ntrials
     era_pos=0
     workdat=rxdat
     numera=0
     do i=0,62
        j=indexes(62-i)
        thresh=thresh0(i)
        ir=rand()
        if(...) then
           era_pos(numera)=j
           numera=numera+1
        endif
     enddo

     call decode_rs_int()
     if(nerr.ge.0) then
        ncandidates=ncandidates+1
        nhard=0
        nsoft=0
        nsofter=0
        do i=0,62
           if(workdat(i).ne.rxdat(i)) then
              nhard=nhard+1
              nsofter=nsofter+rxprob(i)
              if(workdat(i).ne.rxdat2(i)) nsoft=nsoft+rxprob(i)
           else
              nsofter=nsofter-rxprob(i)
           endif
        enddo
        nsoft=63*nsoft/nsum
        nsofter=63*nsofter/nsum
        ntotal=nsoft+nhard
        if(ntotal.lt.ntotal_min) then
           nsoft_min=nsoft
           nhard_min=nhard
           nsofter_min=nsofter
           ntotal_min=ntotal
           correct=workdat
           nera_best=numera
           ntry=k
        endif
        if(ntotal_min.lt.72 .and. nhard_min.lt.42) exit
     endif
     if(k.eq.ntrials-1) ntry=k+1
  enddo

  if(ntotal_min.ge.76 .or. nhard.ge.44) nhard_min=-1

  param(0)=ncandidates
  param(1)=nhard_min
  param(2)=nsoft_min
  param(3)=nera_best
  param(4)=nsofter_min
  if(param(0).eq.0) param(2)=-1

  return
end subroutine sfrsd


                 

program jt9code

! Generate simulated data for testing of WSJT-X

  character msg*22,decoded*22,bad*1,msgtype*13
  integer*4 i4tone(85)                     !Channel symbols (values 0-8)
  include 'testmsg.f90'
  include 'jt9sync.f90'

  nargs=iargc()
  if(nargs.ne.1) then
     print*,'Usage: jt9code "message"'
     print*,'       jt9code -t'
     go to 999
  endif

  call getarg(1,msg)
  nmsg=1
  if(msg(1:2).eq."-t") nmsg=NTEST

  write(*,1010)
1010 format("     Message                 Decoded                Err? Type"/   &
            74("-"))
  do imsg=1,nmsg
     if(nmsg.gt.1) msg=testmsg(imsg)
     call fmtmsg(msg,iz)                !To upper case, collapse multiple blanks
     ichk=0
     call gen9(msg,ichk,decoded,i4tone,itype)   !Encode message into tone #s

     msgtype=""
     if(itype.eq.1) msgtype="Std Msg"
     if(itype.eq.2) msgtype="Type 1 prefix"
     if(itype.eq.3) msgtype="Type 1 suffix"
     if(itype.eq.4) msgtype="Type 2 prefix"
     if(itype.eq.5) msgtype="Type 2 suffix"
     if(itype.eq.6) msgtype="Free text"

     bad=" "
     if(decoded.ne.msg) bad="*"
     write(*,1020) imsg,msg,decoded,bad,itype,msgtype
1020 format(i2,'.',2x,a22,2x,a22,3x,a1,i3,": ",a13)
  enddo

  if(nmsg.eq.1) write(*,1030) i4tone
1030 format(/'Channel symbols'/(30i2))

999 end program jt9code

! This source code file was last time modified by Igor Chernikov UA3DJY on June 11th, 2016.
! All changes are shown in the patch file coming together with the full JTDX source code.

subroutine s3avg(nsave,mode65,nutc,nhz,xdt,npol,ntol,s3,nsum,nkv,decoded)

! Save the current synchronized spectra, s3(64,63), for possible
! decoding of average.

  real s3(64,63)                        !Synchronized spectra for 63 symbols
  real s3a(64,63,64)                    !Saved spectra
  real s3b(64,63)                       !Average spectra
  integer iutc(64),ihz(64),ipol(64)
  real dt(64)
  character*22 decoded
  logical first
  logical(1) freemsg
  data first/.true./
  save

  if(first) then
     iutc=-1
     ihz=0
     ipol=0
     first=.false.
     ihzdiff=min(100,ntol)
     dtdiff=0.2
  endif

  do i=1,64
     if(nutc.eq.iutc(i) .and. abs(nhz-ihz(i)).lt.ihzdiff) then
        nsave=mod(nsave-1+64,64)+1
        go to 10
     endif
  enddo
  
  iutc(nsave)=nutc                          !Save UTC
  ihz(nsave)=nhz                            !Save freq in Hz
  ipol(nsave)=npol                          !Save pol
  dt(nsave)=xdt                             !Save DT
  s3a(1:64,1:63,nsave)=s3                   !Save the spectra

10 s3b=0.
  do i=1,64                                 !Accumulate avg spectra
     if(iutc(i).lt.0) cycle
     if(mod(iutc(i),2).ne.mod(nutc,2)) cycle !Use only same sequence
     if(abs(nhz-ihz(i)).gt.ihzdiff) cycle   !Freq must match
     if(abs(xdt-dt(i)).gt.dtdiff) cycle     !DT must match
     s3b=s3b + s3a(1:64,1:63,i)
     nsum=nsum+1
  enddo
 
  decoded='                      '
  if(nsum.ge.2) then                        !Try decoding the sverage
     nadd=mode65*nsum
     call extract(s3b,nadd,ncount,nhist,decoded,freemsg)     !Extract the message
     nkv=nsum
     if(ncount.lt.0) then 
        nkv=0
        decoded='                      '
     endif
  endif

  return
end subroutine s3avg

! This source code file was last time modified by Igor UA3DJY on 20181215
! All changes are shown in the patch file coming together with the full JTDX source code.

subroutine chkftrsd(mrs,mrs2,decoded,ftrsd_cfmd)

  use jt65_mod2, only : s3
  use jt65_mod10
  use packjt

  real u1
  integer mrs(63),mrs2(63),dgen(12),sym_rev(0:62)
  character msg*22,msg00*22,decoded*22
  logical(1) ftrsd_cfmd

  if(first) then
     call cqcall3()
     first=.false.
  endif

  if(nused.lt.5000) return
  nactual=nused+1
  msg=decoded
  call fmtmsg(msg,iz)
  call packmsg(msg,dgen,itype)            !Pack message into 72 bits
  call rs_encode(dgen,sym_rev)            !RS encode
  call interleave63(sym_rev,1)            !Interleave channel symbols
  call graycode(sym_rev,63,1,sym_rev)     !Apply Gray code
  sym2(0:62,nactual)=sym_rev(0:62)
  msg0(nactual)=decoded
  
  ref0=0.
  do j=1,63
     ref0=ref0 + s3(mrs(j)+1,j)
  enddo

  u1=-99.0
  u2=u1

! Find u1 and u2 (best and second-best) codeword from a list, using 
! a bank of matched filters on the symbol spectra s3(i,j).
  ipk=1
  msg00='                      '
  do k=1,nactual
        psum=0.
        ref=ref0
        do j=1,63
           i=sym2(j-1,k)+1
           psum=psum + s3(i,j)
           if(i.eq.mrs(j)+1) ref=ref - s3(i,j) + s3(mrs2(j)+1,j)
        enddo
        p=psum/ref

        if(p.gt.u1) then
           if(msg0(k).ne.msg00) u2=u1
           u1=p
           ipk=k
           msg00=msg0(k)
        endif
        if(msg0(k).ne.msg00 .and. p.gt.u2) u2=p
  enddo
  if(decoded.eq.msg0(ipk)) ftrsd_cfmd=.true.

return
end subroutine chkftrsd

program test_wspr

! This program provides examples of the source encoding, convolutional
! error-control coding, bit and symbol ordering, and synchronizing
! information contained in WSPR messages.

  character*22 msg,msg2
  character*23 msg3
  character*1 err2,err3
  integer*1 data0(11)
  logical lfile

! Get command-line argument(s)
  nargs=iargc()
  if(nargs.ne.1) then
     print*,'Usage: test_wspr "message"'
     go to 999
  endif
  call getarg(1,msg)                             !Get message from command line
  call unpk(data0,1,msg3)                !Read the C hashtable
  lfile=msg(1:2).eq."-t"
  if(lfile) open(10,file="messages.txt",status="old")

  do imsg=1,999
     if(lfile) read(10,1001,end=900) msg
1001 format(a22)

     data0=0
     call wqencode(msg,ntype0,data0)             !Source encoding
!     write(*,1002) data0(1:7)
!1002 format('Source-encoded message (50 bits, hex):',7z3.2)
!     data0(8:11)=0

     call wqdecode(data0,msg2,ntype1)         

!  write(*,1020) ntype1
!1020 format('Message type: ',i7)
!  write(*,1030) msg2
!1030 format('Decoded message:  ',a22)

     call unpk(data0,0,msg3)
     do i=1,23
        if(ichar(msg3(i:i)).eq.0) then
           msg3(i:)="                      "
           exit
        endif
     enddo

     err2=' '
     err3=' '
     if(msg2.ne.msg) err2='*'
     if(msg3.ne.msg) err3='*'

     write(*,1040) msg,err2,msg2,err3,msg3
1040 format(a22,1x,a1,1x,a22,1x,a1,1x,a22)
     if(.not.lfile) exit
  enddo
900 call unpk(data0,2,msg3)


999 end program test_wspr

! This source code file was last time modified by Igor UA3DJY on 20190309
! All changes are shown in the patch file coming together with the full JTDX source code.

subroutine genft8sd(msg,i3,n3,msgsent,msgbits,itone)

! Encode an FT8 message, producing array itone().
  
  use packjt77sd
  use ft8_mod1, only : icos7,graymap
  character msg*37,msgsent*37,c77*77
  integer*1 msgbits(77),codeword(174)
  integer itone(79)
  logical unpk77_success

  i3=-1
  n3=-1
  call pack77sd(msg,i3,n3,c77)
  call unpack77sd(c77,msgsent,unpk77_success)
  read(c77,'(77i1)',err=1) msgbits
  if(unpk77_success) go to 2
1 msgbits=0
  itone=0
  msgsent='*** bad message ***                  '
  go to 900

2  call encode174_91(msgbits,codeword)      !Encode the test message

! Message structure: S7 D29 S7 D29 S7
  itone(1:7)=icos7; itone(37:43)=icos7; itone(73:79)=icos7
  k=7
  do j=1,58
     i=3*j -2
     k=k+1
     if(j.eq.30) k=k+7
     indx=codeword(i)*4 + codeword(i+1)*2 + codeword(i+2)
     itone(k)=graymap(indx)
  enddo

900 return
end subroutine genft8sd

! last time modified by Igor UA3DJY on 20200104

module jt65_decode

  integer, parameter :: NSZ=3413, NFFT=1000, NHSYM=276
  type :: jt65_decoder
     procedure(jt65_decode_callback), pointer :: callback => null()
   contains
     procedure :: decode
  end type jt65_decoder

  !
  ! Callback function to be called with each decode
  !
  abstract interface
     subroutine jt65_decode_callback (this, utc, snr, dt, nfreq, decoded, servis)
       import jt65_decoder
       implicit none
       class(jt65_decoder), intent(inout) :: this
       integer, intent(in) :: utc
       integer, intent(in) :: snr
       real, intent(in) :: dt
       integer, intent(in) :: nfreq
       character(len=26), intent(in) :: decoded
       character(len=1), intent(in) :: servis
     end subroutine jt65_decode_callback
  end interface

contains

  subroutine decode(this,callback,nutc,nf1,nf2,nfqso,nagainfil,ntrials,naggressive, &
                    nhint,mycall,hiscall,hisgrid,nprepass,swl,filter,stophint,nlasttx,nsdecatt, &
                    fmaskact,ntxmode,ntopfreq65,nharmonicsdepth,showharmonics)

    !  Process dd() data to find and decode JT65 signals.
    use jt65_mod6 ! dd(NPTS) NPTS=624000
    use jt65_mod8 !  dynhint(300), dynhintcq(150), rxfreq(20), rxfchg(1), ninterval, freq, maxsync2, maxsync2freq
    use jt65_mod11 !ca and dtchk data structures
    use timer_module, only: timer

    include 'constants.f90'

    class(jt65_decoder), intent(inout) :: this
    procedure(jt65_decode_callback) :: callback
    integer, intent(in) :: nutc,nf1,nf2,nfqso,ntrials,naggressive,nprepass,nlasttx,nsdecatt,ntxmode,ntopfreq65, &
                           nharmonicsdepth
    logical, intent(in) :: nagainfil
    logical(1), intent(in) :: filter, swl, stophint, fmaskact, nhint, showharmonics
    character(len=12), intent(in) :: mycall, hiscall
    character(len=6), intent(in) :: hisgrid

    real a(2)
    character*22 decoded

    type accepted_decode
       real freq
       character*22 decoded
       character*1 hint
       logical(1) freemsg
    end type accepted_decode
    type(accepted_decode) dec(200)

    logical(1) hintedrxfreq,hint_on,dupe,npass1,ncand_lt9,sync1_lt1,newfft,first,nstophint
    integer ntrials0,ntrials1,ncand,nvec,ncandth25,nfdistort,nfhinted,nft,ipass, &
            ncandcut,imax1,imax2,m,icand,nfa,nfb,nint_prev,nint_newday
    integer h0(0:11),d0(0:11)
    real r0(0:11)
    real thresh3,syncmax1,syncmax2,syncmax3,dtx,sync1
    real snrd(31)

!            0  1  2  3  4  5  6  7  8  9 10 11
    data h0/41,42,43,43,44,45,46,47,48,48,49,49/
    data d0/71,72,73,74,76,77,78,80,81,82,83,83/

!             0    1    2    3    4    5    6    7    8    9   10   11
    data r0/0.70,0.72,0.74,0.76,0.78,0.80,0.82,0.84,0.86,0.88,0.90,0.90/
!              -1   -2   -3   -4   -5   -6   -7   -8    -9   -10   -11   -12   -13  -14  -15  -16  -17
    data snrd/-1.0,-1.2,-1.5,-1.5,-1.5,-1.6,-1.7,-1.75,-1.8,-1.85,-1.95,-2.15,-2.2,-2.3,-2.3,-2.3,-2.35, &
!    -18   -19   -20  -21  -22  -23  -24  -25  -26  -27  -28  -29  -30  -31
    -2.35,-2.35,-2.4,-2.4,-2.4,-2.4,-2.5,-2.5,-2.5,-2.6,-2.6,-2.7,-2.7,-2.7/
    data first/.true./
    data nint_prev/-1/
    data nint_newday/0/
    save

    character msg26*26,callcq*6,callncq*6,hint*1,isfalse*1,servis*1
    logical(1) freemsg,bypass_ftrsd,jt65bc(2)
    real fmask(15)

  real, DIMENSION(:,:), ALLOCATABLE :: ss
  real, DIMENSION(:,:), ALLOCATABLE :: ss22

  interface
    subroutine symspec65(ss,ss22,nfdistort)
      real ss(:,:)
      real ss22(:,:)
      integer nfdistort
    end subroutine symspec65
    subroutine sync65(ss,ss22,fmask,nfa,nfb,ncand,npass1,nfqso,hint_on, &
                      nfhinted,thresh0,ncandth25,ipass)
      real ss(:,:)
      real ss22(:,:)
      real fmask(15)
      integer nfa,nfb,ncand,nfqso,nfhinted,ncandth25,ipass
      logical(1) hint_on,npass1
      real thresh0
    end subroutine sync65
  end interface

    this%callback => callback
    nfhinted=3 ! +- frequency offset for hinted decoding
    ncandcount=0 ! common count for all four decoding passes, used in decoded65a
! initialize data structures for each time interval before decoding
    ca%freq=0.; ca%dt=0.; ca%sync=0.
    dec%freq=0.; dec%decoded='                      '; dec%hint='*'
    dtchk%cand_dtbest=-10.0; dtchk%cand_decoded=.false.
    fmask=-1.0
    ndecoded=0; ncandth25=0; ndecpass1=0; ncandipass1=64
    hint_on=.false.; bypass_ftrsd=.false.

    nstophint=stophint; if(ntxmode.eq.9) nstophint=.true.
    if(nhint) hint_on=.true.
! calculate unique time interval number from the current time or wav file interval time
    ninterval=(nutc/100)*60 + mod(nutc,100)
    nminutes=1440 ! number of minutes a day
    do i=1,7 ! smooth one week time change for experience based Hint decoders
       nminmin=1435+(i-1)*nminutes
       nminmax=nminmin+4
       if(nint_prev.ge.nminmin .and. nint_prev.le.nminmax .and. &
          ninterval.ge.0 .and. ninterval.le.5) then
          nint_newday=nint_newday+nminutes
          exit
       endif
    enddo
    ninterval=ninterval+nint_newday ! smooth day time change for experience based Hint decoders

   if(first) then !
      dynhint%ninterval=-1
      dynhintcq%ninterval=-1
      rxfreq%ninterval=-1
      rxfchg%ninterval=-1
      rxfchg%nfqso=nfqso
      rxfchg%rxfchanged=.false.
      first=.false.
   endif

   if(ninterval.ne.rxfchg(1)%ninterval) then
      if(nfqso.le.ntopfreq65 .and. nfqso.ne.rxfchg(1)%nfqso) then
         rxfchg(1)%rxfchanged=.true.
         go to 2
      endif
   endif
   if(rxfchg(1)%ninterval.ge.0) then
      if(abs(ninterval-rxfchg(1)%ninterval).gt.6 .and. rxfchg(1)%rxfchanged) &
         rxfchg(1)%rxfchanged=.false.
   endif
2  if(nfqso.ne.rxfchg(1)%nfqso) then
      rxfchg(1)%ninterval=ninterval
      rxfchg(1)%nfqso=nfqso
   endif
   
   do i=1,20
      if(rxfreq(i)%ninterval.eq.-1) cycle
      deltaf=abs(float(nfqso)-rxfreq(i)%freq)
      if(deltaf.gt.4.0) rxfreq(i)%ninterval=-1
   enddo

   maxsync2=0.; maxsync2freq=0.

    do ipass=1,nprepass+5                          ! up to 4-pass decoding loop
       newfft=.true.
          if(ipass.eq.1) then  !first-pass parameters, fmask being filled in
              thresh0=2.3
              nfdistort=2
          elseif(ipass.eq.2) then !fmask decoding pass
              thresh0=1.5
              nfdistort=1
              if(ncandth25.gt.17) hint_on=.false. ! turn off Hint
          elseif(ipass.eq.3) then !fmask decoding pass
              thresh0=1.5
              nfdistort=3
              if(nhint) hint_on=.true. ! recover Hint after 1st fmask decoding pass
              if(ncandth25.gt.17) hint_on=.false. ! turn off Hint
          elseif(ipass.eq.4) then !single decode pass subpass3
              if(nfqso.lt.4) cycle
              thresh0=1.2
              nfdistort=1
              hint_on=.false. ! turn off Hint for single decode passes
          elseif(ipass.eq.5) then !single decode pass subpass4
              if(nfqso.lt.4) cycle
              thresh0=1.2
              nfdistort=3
          elseif(ipass.eq.6) then !single decode pass subpass5
              if(nfqso.lt.4) cycle
              thresh0=1.2
              nfdistort=2
          elseif(ipass.eq.7) then !second-pass parameters 2+5
              thresh0=1.5
              nfdistort=1
              if(nhint) hint_on=.true. ! recover Hint after the single decode
          elseif(ipass.eq.8) then !third-pass parameters 3+5
              thresh0=1.5
              nfdistort=3
          elseif(ipass.eq.9) then !fourth-pass parameters 4+5
              thresh0=1.3
              nfdistort=2
          endif

       if(ipass.eq.2 .or. ipass.eq.3) then
          if(.not.fmaskact .and. ncandth25.gt.17) cycle
       endif

       npass1=.false.
       if(ipass.eq.1) npass1=.true.

       allocate(ss(NHSYM,NSZ), STAT = nAllocateStatus1)
       if (nAllocateStatus1 .ne. 0) STOP "Not enough memory"
       allocate(ss22(NHSYM,NSZ), STAT = nAllocateStatus1)
       if (nAllocateStatus1 .ne. 0) STOP "Not enough memory"

!       call timer('symsp65 ',0)
       call symspec65(ss,ss22,nfdistort)    !Get normalized symbol spectra
!       call timer('symsp65 ',1)

       if(.not.filter .and. .not.nagainfil) then
          nfa=nf1
          nfb=min(ntopfreq65,nf2)     ! bottom freq defined by waterfall, upper one limited to 3000Hz
       endif
       if(filter .or. nagainfil) then  ! +- 200Hz bandwidth for FILTER
          nfa=max(0,nfqso-200)
          nfb=min(ntopfreq65,nfqso+200) 
       endif

       if(ipass.ge.4 .and. ipass.le.6) then
          nfa=nfqso-3; nfb=nfqso+3
       endif
	   
!       call timer('sync65  ',0)
       call sync65(ss,ss22,fmask,nfa,nfb,ncand,npass1,nfqso,hint_on, &
                      nfhinted,thresh0,ncandth25,ipass)
!       call timer('sync65  ',1)

       if(ipass.eq.1 .and. ncand.lt.15) ncandipass1=ncand
       if(ncand.lt.15) nfilt=1600
       if(ncand.ge.15) nfilt=1580


  deallocate (ss, STAT = nDeAllocateStatus1)
  if (nDeAllocateStatus1.ne.0) print *, 'failed to release memory'
  deallocate (ss22, STAT = nDeAllocateStatus1)
  if (nDeAllocateStatus1.ne.0) print *, 'failed to release memory'

ntrials0=1; ntrials1=1
if(ntrials.gt.1) then
   if(.not.swl) then
     ntrials1=ntrials-1
   else 
     ntrials1=min(ntrials-1+3,7) ! defining number of decoding attempts for SWL mode
   endif
endif

if(ntrials.eq.1) then
   if(.not.swl) then
     ntrials0=ntrials
   else
     ntrials0=ntrials+3          ! defining number of decoding attempts for SWL mode
   endif
endif

if(npass1) then
    thresh3=3.0
    if(npass1 .and. ncand.gt.0 .and. ncandth25.lt.9) then
       syncmax1=0.      ! candidate with the highiest sync value
       syncmax2=0.      ! candidate with the 2nd most sync value
       syncmax3=0.      ! candidate with the 3rd most sync value
       do m=1,ncand
         if(ca(m)%sync.gt.syncmax1) then 
            syncmax1=ca(m)%sync
            imax1=m
         endif
       enddo
       do m=1,ncand
         if(ca(m)%sync.gt.syncmax2 .and. m.ne.imax1) then
            syncmax2=ca(m)%sync
            imax2=m
         endif
       enddo
       do m=1,ncand
         if(ca(m)%sync.gt.syncmax3 .and. m.ne.imax1 .and. m.ne.imax2) syncmax3=ca(m)%sync
       enddo
       if(syncmax1.lt.3.5 .and. ncandth25.lt.5) thresh3=2.3
       if(ncand.gt.1 .and. syncmax2.lt.3.5 .and. ncandth25.lt.6) thresh3=2.3
       if(ncand.gt.2 .and. syncmax3.lt.3.5 .and. ncandth25.lt.7) thresh3=2.3
    endif


    if(ncandth25.lt.9) then
       ncandcut=ncand
       do m=1,ncand
         if(ca(m)%sync.lt.thresh3) then
            fup=float(nfqso+nfhinted); fdown=float(nfqso-nfhinted)
            if(ca(m)%freq.ge.fup .or. ca(m)%freq.le.fdown) &
               ncandcut=ncandcut-1   ! number non QSOfreq candidates above thresh3
         endif
       enddo
    endif

    kp1=0 ! counter for fmask candidates

    do j=1,2

      if(ncand.eq.0) exit
  
      if(ntrials.gt.1) then
         if(ncandth25.eq.9) nvec=(10375*(2**(ntrials1-1)))/(4*ncandth25) 
         if(ncandth25.ge.10) nvec=(10375*(2**(ntrials1-1)))/(10*ncandth25) 
         if((ncandth25.gt.0 .and. ncandth25.lt.9) .or. (ncandth25.gt.0 .and. ncandcut.eq.0)) &
            nvec=(10375*(2**(ntrials1-1)))/ncandth25
      endif
      if(ntrials.eq.1) then
         if(ncandth25.eq.9) nvec=(5180*(2**(ntrials0-1)))/(4*ncandth25) 
         if(ncandth25.ge.10) nvec=(5180*(2**(ntrials0-1)))/(10*ncandth25) 
         if((ncandth25.gt.0 .and. ncandth25.lt.9) .or. (ncandth25.gt.0 .and. ncandcut.eq.0)) &
            nvec=(5180*(2**(ntrials0-1)))/ncandth25
      endif

      if(ncandth25.gt.0 .and. ncandcut.gt.0 .and. ncandth25.lt.9) then 
         if(.not.swl) then
            if(ntrials.eq.1) nvec=38000/ncandcut
            if(ntrials.eq.2) nvec=52000/ncandcut
            if(ntrials.eq.3) nvec=66000/ncandcut
            if(ntrials.eq.4) nvec=90000/ncandcut 
            if(ntrials.eq.5) nvec=140000/ncandcut
            if(ntrials.eq.6) nvec=264000/ncandcut
            if(ntrials.eq.7) nvec=390000/ncandcut
            if(ntrials.eq.8) nvec=480000/ncandcut
         else
            ntrialswl=min(ntrials+2,8)
            if(ntrialswl.eq.3) nvec=66000/ncandcut
            if(ntrialswl.eq.4) nvec=90000/ncandcut 
            if(ntrialswl.eq.5) nvec=140000/ncandcut
            if(ntrialswl.eq.6) nvec=264000/ncandcut
            if(ntrialswl.eq.7) nvec=390000/ncandcut
            if(ntrialswl.eq.8) nvec=480000/ncandcut
         endif
      endif

      do icand=1,ncand
        if(ca(icand)%freq.lt.0.0) cycle
        if(.not.swl) then
           if(j.eq.1 .and. ca(icand)%sync.lt.thresh3 .and. ncandth25.lt.9) then
              fup=float(nfqso+nfhinted); fdown=float(nfqso-nfhinted)
              if(ca(icand)%freq.ge.fup .or. ca(icand)%freq.le.fdown) cycle
           endif
        endif
        hintedrxfreq=.false.; ncand_lt9=.false.; sync1_lt1=.false.
        freq=ca(icand)%freq
        dtx=ca(icand)%dt
        sync1=ca(icand)%sync
        fup=float(nfqso+nfhinted); fdown=float(nfqso-nfhinted)
        if(freq.gt.fdown .and. freq.lt.fup) hintedrxfreq=.true.
        if(ncandth25.lt.9) ncand_lt9=.true. ! if number of candidates less then 9
        if(sync1.lt.1.0) sync1_lt1=.true.
        servis=' '; jt65bc=.false.
!        call timer('decod65a',0);
        call decode65a(newfft,freq,nvec,naggressive,hint_on,mycall,hiscall, &
             hisgrid,sync2,a,dtx,nft,decoded,ncand_lt9,hintedrxfreq,nfqso,hint,npass1, &
             sync1_lt1,ncandcount,nstophint,freemsg,nlasttx,ipass,nsdecatt,isfalse, &
             bypass_ftrsd,ncand,jt65bc,nharmonicsdepth,showharmonics)
!        call timer('decod65a',1)
        if(ncandcount.gt.MAXINTCAND) go to 4 ! input audio signal is distorted
        newfft=.false.; bypass_ftrsd=.false.
        if(j.eq.2 .and. decoded.eq.'                      ' .and. ca(icand)%sync.gt.thresh3) then
           if(ncandth25.lt.7 .and. kp1.gt.4) go to 8
           if(ncandth25.lt.15 .and. kp1.gt.9) go to 8
           if(ncandth25.ge.15 .and. kp1.gt.14) go to 8
           kp1=kp1+1
           fmask(kp1)=ca(icand)%freq
8       endif
        if(decoded.ne.'                      ') then
           newfft=.true.
           freqa1=freq+a(1)
           a2=a(2)
           nfreq=nint(freqa1)
           ndrift=nint(a(2))
           s2db=10.0*log10(sync2)
           if(s2db.lt.-0.51 .and. s2db.gt.-31.49) then
              nsnr=nint(s2db+snrd(nint(abs(s2db))))
           else
              nsnr=nint(s2db)
           endif
           if(nsnr.lt.-30) nsnr=-30
           if(nsnr.gt.-1) nsnr=-1

           ca(icand)%freq=-1.0

           dupe=.false. ! de-dedupe
           callcq='AAAAAA'
           callncq='BBBBBB'
           if(ndecoded.gt.0) then
              if(decoded(1:3).eq.'CQ ' .and. hint.eq.'*') then
                 call splitdupecq(decoded,callcq)
              endif
              do i=1, ndecoded
                if(decoded.eq.dec(i)%decoded) then
                   dupe=.true.
                   exit
                endif
! hide Hint CQ decode if there was FTRSD decode with the same call
              if(decoded(1:3).eq.'CQ ' .and. hint.eq.'*') then
                 if(.not.dec(i)%freemsg) then
                    call splitmsgdupe(dec(i)%decoded,callncq)
                    if(callncq.eq.callcq) then
                       dupe=.true.
                       exit
                    endif
                 endif
              endif
! hide Hint decode if there was FTRSD decode with the same calls done before on QSOfreq
                if(hint.eq.'*' .and. decoded(1:10).eq.dec(i)%decoded(1:10) .and. &
                   abs(freqa1-dec(i)%freq).le.10.0) then
                   dupe=.true.
                   exit
                endif
              enddo
           endif

!          call timer('subtr65 ',0)
           if(isfalse.ne.'?') then 
              if(hint.ne.'*' .or. (hint.eq.'*' .and. .not.dupe)) then
                 call subtract65(freqa1,dtx,a2,nfilt,jt65bc)
              endif
           endif
!          call timer('subtr65 ',1)

           if(decoded(2:5).eq.'....' .or. decoded(9:12).eq.'....') dupe=.true.
           if(filter .and. (nfreq.lt.nfqso-50 .or. nfreq.gt.nfqso+50)) dupe=.true.
           if(nagainfil .and. (nfreq.lt.nfqso-25 .or. nfreq.gt.nfqso+25)) dupe=.true.
           if(.not.dupe .and. .not.jt65bc(1) .and. .not.jt65bc(2)) then
! split and record data in the dynhint structure if it is not decoding again
              if(.not.freemsg .and. ninterval.ne.nint_prev .and. isfalse.ne.'?') &
                 call splitmsg(decoded,mycall,dtx,hintedrxfreq)
              if(decoded(1:3).eq."CQ ") call splitmsgcq(decoded,dtx)
              ndecpass1=ndecpass1+1
              ndecoded=ndecoded+1
              dec(ndecoded)%freq=freq+a(1)
              dec(ndecoded)%decoded=decoded
              dec(ndecoded)%hint=hint
              dec(ndecoded)%freemsg=freemsg
              if (associated(this%callback)) then
                  if(hint.eq.'*') servis=hint
                  if(isfalse.eq.'?') servis=isfalse
                  if(.not.hintedrxfreq .and. freemsg) servis='.'
                  if(hintedrxfreq .and. freemsg) servis=','
                  msg26=decoded//'    '
                  call this%callback(nutc,nsnr,dtx-1.0,nfreq,msg26,servis)
              endif
           endif
        endif
      enddo                                 !candidate loop
    enddo
endif

if(ipass.eq.2) then

   if(ncand.eq.0 .or. kp1.eq.0) cycle
   fmask=-1.0
   nveceq1=5180
   nvecgt1=10375
   if(ncandipass1.lt.15) then
      nveceq1=nveceq1*3
      if(ntrials.eq.2) nvecgt1=nvecgt1*1.7
   endif

   if(ntrials.gt.1) then
      if(ncand.gt.0) nvec=(nvecgt1*(2**(ntrials1-1)))/kp1 
   endif
   if(ntrials.eq.1) then   
      if(ncand.gt.0) nvec=(nveceq1*(2**(ntrials0-1)))/kp1 
   endif

   kp1=0 ! counter for fmask candidates

   do icand=1,ncand
      hintedrxfreq=.false.; ncand_lt9=.false.; sync1_lt1=.false.
      freq=ca(icand)%freq
      dtx=ca(icand)%dt
      sync1=ca(icand)%sync
      fup=float(nfqso+nfhinted); fdown=float(nfqso-nfhinted)
      if(freq.gt.fdown .and. freq.lt.fup) hintedrxfreq=.true.
      if(ncand.lt.9) ncand_lt9=.true. ! if number of candidates less then 9
      if(sync1.lt.1.0) sync1_lt1=.true.
      servis=' '; jt65bc=.false.
!        call timer('decod65a',0);
        call decode65a(newfft,freq,nvec,naggressive,hint_on,mycall,hiscall, &
             hisgrid,sync2,a,dtx,nft,decoded,ncand_lt9,hintedrxfreq,nfqso,hint,npass1, &
             sync1_lt1,ncandcount,nstophint,freemsg,nlasttx,ipass,nsdecatt,isfalse, &
             bypass_ftrsd,ncand,jt65bc,nharmonicsdepth,showharmonics)
!        call timer('decod65a',1)
        if(ncandcount.gt.MAXINTCAND) go to 4 ! input audio signal is distorted
        newfft=.false.; bypass_ftrsd=.false.
        if(decoded.eq.'                      ' .and. ca(icand)%sync.gt.thresh3) then
           if(ncandth25.lt.7 .and. kp1.gt.3) go to 16
           if(ncandth25.lt.15 .and. kp1.gt.7) go to 16
           if(ncandth25.ge.15 .and. kp1.gt.12) go to 16
           kp1=kp1+1
           fmask(kp1)=ca(icand)%freq
16       endif
        if(decoded.ne.'                      ') then
           newfft=.true.
           freqa1=freq+a(1)
           a2=a(2)
           nfreq=nint(freqa1)
           ndrift=nint(a(2))
           s2db=10.0*log10(sync2)
           if(s2db.lt.-0.51 .and. s2db.gt.-31.49) then
              nsnr=nint(s2db+snrd(nint(abs(s2db))))
           else
              nsnr=nint(s2db)
           endif
           if(nsnr.lt.-30) nsnr=-30
           if(nsnr.gt.-1) nsnr=-1

           ca(icand)%freq=-1.0

           dupe=.false. ! de-dedupe
           callcq='AAAAAA'
           callncq='BBBBBB'
           if(ndecoded.gt.0) then
              if(decoded(1:3).eq.'CQ ' .and. hint.eq.'*') then
                 call splitdupecq(decoded,callcq)
              endif
              do i=1, ndecoded
                if(decoded.eq.dec(i)%decoded) then
                   dupe=.true.
                   exit
                endif
! hide Hint CQ decode if there was FTRSD decode with the same call
              if(decoded(1:3).eq.'CQ ' .and. hint.eq.'*') then
                 if(.not.dec(i)%freemsg) then
                    call splitmsgdupe(dec(i)%decoded,callncq)
                    if(callncq.eq.callcq) then
                       dupe=.true.
                       exit
                    endif
                 endif
              endif
! hide Hint decode if there was FTRSD decode with the same calls done before on QSOfreq
                if(hint.eq.'*' .and. decoded(1:10).eq.dec(i)%decoded(1:10) .and. &
                   abs(freqa1-dec(i)%freq).le.10.0) then
                   dupe=.true.
                   exit
                endif
              enddo
           endif

!          call timer('subtr65 ',0)
           if(isfalse.ne.'?') then 
              if(hint.ne.'*' .or. (hint.eq.'*' .and. .not.dupe)) then
                 call subtract65(freqa1,dtx,a2,nfilt,jt65bc)
              endif
           endif
!          call timer('subtr65 ',1)

           if(decoded(2:5).eq.'....' .or. decoded(9:12).eq.'....') dupe=.true.
           if(filter .and. (nfreq.lt.nfqso-50 .or. nfreq.gt.nfqso+50)) dupe=.true.
           if(nagainfil .and. (nfreq.lt.nfqso-25 .or. nfreq.gt.nfqso+25)) dupe=.true.
           if(.not.dupe .and. .not.jt65bc(1) .and. .not.jt65bc(2)) then
! split and record data in the dynhint structure if it is not decoding again
              if(.not.freemsg .and. ninterval.ne.nint_prev .and. isfalse.ne.'?') &
                 call splitmsg(decoded,mycall,dtx,hintedrxfreq)
              if(decoded(1:3).eq."CQ ") call splitmsgcq(decoded,dtx)
              ndecoded=ndecoded+1
              dec(ndecoded)%freq=freq+a(1)
              dec(ndecoded)%decoded=decoded
              dec(ndecoded)%hint=hint
              dec(ndecoded)%freemsg=freemsg
              if (associated(this%callback)) then
                  if(hint.eq.'*') servis=hint
                  if(isfalse.eq.'?') servis=isfalse
                  if(.not.hintedrxfreq .and. freemsg) servis='.'
                  if(hintedrxfreq .and. freemsg) servis=','
                  msg26=decoded//'    '
                  call this%callback(nutc,nsnr,dtx-1.0,nfreq,msg26,servis)
              endif
           endif
        endif
      enddo                                 !candidate loop
endif



if(ipass.eq.3) then

   if(ncand.eq.0 .or. kp1.eq.0) cycle

   nveceq1=5180
   nvecgt1=10375
   if(ncandipass1.lt.15) then
      nveceq1=nveceq1*3
      if(ntrials.eq.2) nvecgt1=nvecgt1*1.7
   endif

   if(ntrials.gt.1) then
      if(ncand.gt.0) nvec=(nvecgt1*(2**(ntrials1-1)))/kp1 
   endif
   if(ntrials.eq.1) then   
      if(ncand.gt.0) nvec=(nveceq1*(2**(ntrials0-1)))/kp1 
   endif

   do icand=1,ncand
      hintedrxfreq=.false.; ncand_lt9=.false.; sync1_lt1=.false.
      freq=ca(icand)%freq
      dtx=ca(icand)%dt
      sync1=ca(icand)%sync
      fup=float(nfqso+nfhinted); fdown=float(nfqso-nfhinted)
      if(freq.gt.fdown .and. freq.lt.fup) hintedrxfreq=.true.
      if(ncand.lt.9) ncand_lt9=.true. ! if number of candidates less then 9
      if(sync1.lt.1.0) sync1_lt1=.true.
      servis=' '; jt65bc=.false.
!        call timer('decod65a',0);
        call decode65a(newfft,freq,nvec,naggressive,hint_on,mycall,hiscall, &
             hisgrid,sync2,a,dtx,nft,decoded,ncand_lt9,hintedrxfreq,nfqso,hint,npass1, &
             sync1_lt1,ncandcount,nstophint,freemsg,nlasttx,ipass,nsdecatt,isfalse, &
             bypass_ftrsd,ncand,jt65bc,nharmonicsdepth,showharmonics)
!        call timer('decod65a',1)
        if(ncandcount.gt.MAXINTCAND) go to 4 ! input audio signal is distorted
        newfft=.false.; bypass_ftrsd=.false.
        if(decoded.ne.'                      ') then
           newfft=.true.
           freqa1=freq+a(1)
           a2=a(2)
           nfreq=nint(freqa1)
           ndrift=nint(a(2))
           s2db=10.0*log10(sync2)
           if(s2db.lt.-0.51 .and. s2db.gt.-31.49) then
              nsnr=nint(s2db+snrd(nint(abs(s2db))))
           else
              nsnr=nint(s2db)
           endif
           if(nsnr.lt.-30) nsnr=-30
           if(nsnr.gt.-1) nsnr=-1

           ca(icand)%freq=-1.0

           dupe=.false. ! de-dedupe
           callcq='AAAAAA'
           callncq='BBBBBB'
           if(ndecoded.gt.0) then
              if(decoded(1:3).eq.'CQ ' .and. hint.eq.'*') then
                 call splitdupecq(decoded,callcq)
              endif
              do i=1, ndecoded
                if(decoded.eq.dec(i)%decoded) then
                   dupe=.true.
                   exit
                endif
! hide Hint CQ decode if there was FTRSD decode with the same call
              if(decoded(1:3).eq.'CQ ' .and. hint.eq.'*') then
                 if(.not.dec(i)%freemsg) then
                    call splitmsgdupe(dec(i)%decoded,callncq)
                    if(callncq.eq.callcq) then
                       dupe=.true.
                       exit
                    endif
                 endif
              endif
! hide Hint decode if there was FTRSD decode with the same calls done before on QSOfreq
                if(hint.eq.'*' .and. decoded(1:10).eq.dec(i)%decoded(1:10) .and. &
                   abs(freqa1-dec(i)%freq).le.10.0) then
                   dupe=.true.
                   exit
                endif
              enddo
           endif

!          call timer('subtr65 ',0)
           if(isfalse.ne.'?') then 
              if(hint.ne.'*' .or. (hint.eq.'*' .and. .not.dupe)) then
                 call subtract65(freqa1,dtx,a2,nfilt,jt65bc)
              endif
           endif
!          call timer('subtr65 ',1)

           if(decoded(2:5).eq.'....' .or. decoded(9:12).eq.'....') dupe=.true.
           if(filter .and. (nfreq.lt.nfqso-50 .or. nfreq.gt.nfqso+50)) dupe=.true.
           if(nagainfil .and. (nfreq.lt.nfqso-25 .or. nfreq.gt.nfqso+25)) dupe=.true.
           if(.not.dupe .and. .not.jt65bc(1) .and. .not.jt65bc(2)) then
! split and record data in the dynhint structure if it is not decoding again
              if(.not.freemsg .and. ninterval.ne.nint_prev .and. isfalse.ne.'?') &
                 call splitmsg(decoded,mycall,dtx,hintedrxfreq)
              if(decoded(1:3).eq."CQ ") call splitmsgcq(decoded,dtx)
              ndecoded=ndecoded+1
              dec(ndecoded)%freq=freq+a(1)
              dec(ndecoded)%decoded=decoded
              dec(ndecoded)%hint=hint
              dec(ndecoded)%freemsg=freemsg
              if (associated(this%callback)) then
                  if(hint.eq.'*') servis=hint
                  if(isfalse.eq.'?') servis=isfalse
                  if(.not.hintedrxfreq .and. freemsg) servis='.'
                  if(hintedrxfreq .and. freemsg) servis=','
                  msg26=decoded//'    '
                  call this%callback(nutc,nsnr,dtx-1.0,nfreq,msg26,servis)
              endif
           endif
        endif
      enddo                                 !candidate loop
endif



! single decode 3 subpasses
if(ipass.ge.4 .and. ipass.le.6) then

   if(.not.swl) then
      if(ntrials.eq.1) nvec=3800
      if(ntrials.eq.2) nvec=5200
      if(ntrials.eq.3) nvec=6600
      if(ntrials.eq.4) nvec=9000
      if(ntrials.eq.5) nvec=14000
      if(ntrials.eq.6) nvec=26400
      if(ntrials.eq.7) nvec=39000
      if(ntrials.eq.8) nvec=48000
   else
      ntrialswl=min(ntrials+2,8)
      if(ntrialswl.eq.3) nvec=6600
      if(ntrialswl.eq.4) nvec=9000
      if(ntrialswl.eq.5) nvec=14000
      if(ntrialswl.eq.6) nvec=26400
      if(ntrialswl.eq.7) nvec=39000
      if(ntrialswl.eq.8) nvec=48000
   endif

   nvec=nvec*(nsdecatt**2)

   do icand=1,ncand
      if(icand.gt.2) cycle
!      if(ca(icand)%freq.lt.0.0) cycle
      hintedrxfreq=.true.; ncand_lt9=.true.; sync1_lt1=.false.
      freq=ca(icand)%freq
      dtx=ca(icand)%dt
      sync1=ca(icand)%sync
      if(sync1.lt.1.0) sync1_lt1=.true.
      servis=' '; jt65bc=.false.
!      call timer('decod65a',0);
      call decode65a(newfft,freq,nvec,naggressive,hint_on,mycall,hiscall, &
             hisgrid,sync2,a,dtx,nft,decoded,ncand_lt9,hintedrxfreq,nfqso,hint,npass1, &
             sync1_lt1,ncandcount,nstophint,freemsg,nlasttx,ipass,nsdecatt,isfalse, &
             bypass_ftrsd,ncand,jt65bc,nharmonicsdepth,showharmonics)
!      call timer('decod65a',1)
      if(ncandcount.gt.MAXINTCAND) go to 4 ! input audio signal is distorted
      newfft=.false.; bypass_ftrsd=.false.
      if(decoded.ne.'                      ') then
         newfft=.true.
         freqa1=freq+a(1)
         a2=a(2)
         nfreq=nint(freqa1)
         ndrift=nint(a(2))
         s2db=10.0*log10(sync2)
         if(s2db.lt.-0.51 .and. s2db.gt.-31.49) then
            nsnr=nint(s2db+snrd(nint(abs(s2db))))
         else
            nsnr=nint(s2db)
         endif
         if(nsnr.lt.-30) nsnr=-30
         if(nsnr.gt.-1) nsnr=-1

!         ca(icand)%freq=-1.0

         dupe=.false. ! de-dedupe
           callcq='AAAAAA'
           callncq='BBBBBB'
           if(ndecoded.gt.0) then
              if(decoded(1:3).eq.'CQ ' .and. hint.eq.'*') then
                 call splitdupecq(decoded,callcq)
              endif
              do i=1, ndecoded
                 if(decoded.eq.dec(i)%decoded) then
                    dupe=.true.
                    exit
                 endif
! hide Hint CQ decode if there was FTRSD decode with the same call
              if(decoded(1:3).eq.'CQ ' .and. hint.eq.'*') then
                 if(.not.dec(i)%freemsg) then
                    call splitmsgdupe(dec(i)%decoded,callncq)
                    if(callncq.eq.callcq) then
                       dupe=.true.
                       exit
                    endif
                 endif
              endif
! hide Hint decode if there was FTRSD decode with the same calls done before on QSOfreq
                 if(hint.eq.'*' .and. decoded(1:10).eq.dec(i)%decoded(1:10) .and. &
                    abs(freqa1-dec(i)%freq).le.10.0) then
                    dupe=.true.
                    exit
                 endif
              enddo
           endif

!        call timer('subtr65 ',0)
         if(isfalse.ne.'?') then 
            if(hint.ne.'*' .or. (hint.eq.'*' .and. .not.dupe)) then
               call subtract65(freqa1,dtx,a2,nfilt,jt65bc)
            endif
         endif
!        call timer('subtr65 ',1)

         if(decoded(2:5).eq.'....' .or. decoded(9:12).eq.'....') dupe=.true.
         if(.not.dupe .and. .not.jt65bc(1) .and. .not.jt65bc(2)) then
! split and record data in the dynhint structure if it is not decoding again
            if(.not.freemsg .and. ninterval.ne.nint_prev .and. isfalse.ne.'?') &
               call splitmsg(decoded,mycall,dtx,hintedrxfreq)
            if(decoded(1:3).eq."CQ ") call splitmsgcq(decoded,dtx)
            ndecoded=ndecoded+1
            dec(ndecoded)%freq=freq+a(1)
            dec(ndecoded)%decoded=decoded
            dec(ndecoded)%hint=hint
            dec(ndecoded)%freemsg=freemsg
            if (associated(this%callback)) then
                if(hint.eq.'*') servis=hint
                if(isfalse.eq.'?') servis=isfalse
                if(.not.hintedrxfreq .and. freemsg) servis='.'
                if(hintedrxfreq .and. freemsg) servis=','
                msg26=decoded//'    '
                call this%callback(nutc,nsnr,dtx-1.0,nfreq,msg26,servis)
            endif
         endif
      endif
   enddo                                 !candidate loop
endif

! decoding passes 2,3,4
if(ipass.ge.7) then

   if(ncand.eq.0) cycle

   if(ipass.eq.7) ndecodedk=ndecoded
   ncandk=0
   if(ndecodedk.le.6) then
      do kk=1,10
         if(ca(kk)%sync.gt.2.5) ncandk=ncandk+1
      enddo
   endif

   if(ntrials.gt.1) then
      if(ndecpass1.ge.5) nvec=(10375*(2**(ntrials1-1)))/ncand
      if(ndecpass1.lt.5) nvec=(10375*(2**(ntrials1-1)))/10
      if(ncandk.gt.0) nvec=(10375*(2**(ntrials1-1)))/ncandk
   endif
   if(ntrials.eq.1) then   
      if(ndecpass1.ge.5) nvec=(5180*(2**(ntrials0-1)))/ncand
      if(ndecpass1.lt.5) nvec=(5180*(2**(ntrials0-1)))/10
      if(ncandk.gt.0) nvec=(5180*(2**(ntrials0-1)))/ncandk
   endif

   bypass_ftrsd=.false.
  
   do icand=1,ncand

      if(.not.hint_on) then
         if(ndecpass1.lt.5 .and. icand.gt.10) exit
         if(ncandk.gt.0 .and. icand.gt.ncandk) exit
      endif
      if(hint_on) then
         if(ndecpass1.lt.5 .and. icand.gt.10) bypass_ftrsd=.true.
         if(ncandk.gt.0 .and. icand.gt.ncandk) bypass_ftrsd=.true.
      endif

      hintedrxfreq=.false.; ncand_lt9=.false.; sync1_lt1=.false.
      freq=ca(icand)%freq
      dtx=ca(icand)%dt
      sync1=ca(icand)%sync
      fup=float(nfqso+nfhinted); fdown=float(nfqso-nfhinted)
      if(freq.gt.fdown .and. freq.lt.fup) hintedrxfreq=.true.
      if(ncand.lt.9) ncand_lt9=.true. ! if number of candidates less then 9
      if(sync1.lt.1.0) sync1_lt1=.true.
      servis=' '; jt65bc=.false.
!      call timer('decod65a',0)
      call decode65a(newfft,freq,nvec,naggressive,hint_on,mycall,hiscall, &
           hisgrid,sync2,a,dtx,nft,decoded,ncand_lt9,hintedrxfreq,nfqso,hint,npass1, &
           sync1_lt1,ncandcount,nstophint,freemsg,nlasttx,ipass,nsdecatt,isfalse, &
           bypass_ftrsd,ncand,jt65bc,nharmonicsdepth,showharmonics)
!      call timer('decod65a',1)
      if(ncandcount.gt.MAXINTCAND) go to 4 ! input audio signal is distorted
      newfft=.false.; bypass_ftrsd=.false.
      if(decoded.ne.'                      ') then
         newfft=.true.
         freqa1=freq+a(1)
         a2=a(2)
         nfreq=nint(freqa1)
         ndrift=nint(a(2))
         s2db=10.0*log10(sync2)
         if(s2db.lt.-0.51 .and. s2db.gt.-31.49) then
            nsnr=nint(s2db+snrd(nint(abs(s2db))))
         else
            nsnr=nint(s2db)
         endif
         if(nsnr.lt.-30) nsnr=-30
         if(nsnr.gt.-1) nsnr=-1

         dupe=.false. ! de-dedupe
         callcq='AAAAAA'
         callncq='BBBBBB'
         if(ndecoded.gt.0) then
            if(decoded(1:3).eq.'CQ ' .and. hint.eq.'*') then
               call splitdupecq(decoded,callcq)
            endif
            do i=1, ndecoded
               if(decoded.eq.dec(i)%decoded) then
                  dupe=.true.
                  exit
               endif
! hide Hint CQ decode if there was FTRSD decode with the same call
              if(decoded(1:3).eq.'CQ ' .and. hint.eq.'*') then
                 if(.not.dec(i)%freemsg) then
                    call splitmsgdupe(dec(i)%decoded,callncq)
                    if(callncq.eq.callcq) then
                       dupe=.true.
                       exit
                    endif
                 endif
              endif
! hide Hint decode if there was FTRSD decode with the same calls done before on QSOfreq
               if(hint.eq.'*' .and. decoded(1:10).eq.dec(i)%decoded(1:10) .and. &
                  abs(freqa1-dec(i)%freq).le.10.0) then
                  dupe=.true.
                  exit
               endif
            enddo
         endif

!        call timer('subtr65 ',0)
         if(isfalse.ne.'?') then 
            if(hint.ne.'*' .or. (hint.eq.'*' .and. .not.dupe)) then
               call subtract65(freqa1,dtx,a2,nfilt,jt65bc)
            endif
         endif
!          call timer('subtr65 ',1)

         if(decoded(2:5).eq.'....' .or. decoded(9:12).eq.'....') dupe=.true.
! hide decoded messages in 400Hz bandwidth if Filter turned ON, show only 100Hz BW
         if(filter .and. (nfreq.lt.nfqso-50 .or. nfreq.gt.nfqso+50)) dupe=.true.
! hide dupe decodes if frequency difference is greater than 25Hz 
         if(nagainfil .and. (nfreq.lt.nfqso-25 .or. nfreq.gt.nfqso+25)) dupe=.true.
         if(.not.dupe .and. .not.jt65bc(1) .and. .not.jt65bc(2)) then
! split and record data in the dynhint structure if it is not decoding again
              if(.not.freemsg .and. ninterval.ne.nint_prev .and. isfalse.ne.'?') &
                 call splitmsg(decoded,mycall,dtx,hintedrxfreq)
              if(decoded(1:3).eq."CQ ") call splitmsgcq(decoded,dtx)
            ndecoded=ndecoded+1
            dec(ndecoded)%freq=freq+a(1)
            dec(ndecoded)%decoded=decoded
            dec(ndecoded)%hint=hint
            dec(ndecoded)%freemsg=freemsg
            if(associated(this%callback)) then
               if(hint.eq.'*') servis=hint
               if(isfalse.eq.'?') servis=isfalse
               if(.not.hintedrxfreq .and. freemsg) servis='.'
               if(hintedrxfreq .and. freemsg) servis=','
               msg26=decoded//'    '
               call this%callback(nutc,nsnr,dtx-1.0,nfreq,msg26,servis)
            endif
         endif
      endif
   enddo                                 !candidate loop
endif
enddo                                   !four-pass loop

4 continue
! clear old data from dynhint data structure if it is not first run and
! if it is not the same wav file or the decoding again same interval
if(nint_prev.ge.0 .and. ninterval.ne.nint_prev) then
   do i=1,300
      if(dynhint(i)%ninterval.eq.-1) cycle
      if(ninterval-dynhint(i)%ninterval.lt.0) dynhint(i)%ninterval=-1
      if(ninterval-dynhint(i)%ninterval.gt.2) dynhint(i)%ninterval=-1
   enddo
   do i=1,150
      if(dynhintcq(i)%ninterval.eq.-1) cycle
      if(ninterval-dynhintcq(i)%ninterval.lt.0) dynhintcq(i)%ninterval=-1
      if(ninterval-dynhintcq(i)%ninterval.gt.2) dynhintcq(i)%ninterval=-1
   enddo   
   do i=1,20
      if(rxfreq(i)%ninterval.eq.-1) cycle
      if(ninterval-rxfreq(i)%ninterval.lt.0) rxfreq(i)%ninterval=-1
      if(ninterval-rxfreq(i)%ninterval.gt.6) rxfreq(i)%ninterval=-1
   enddo
endif

nint_prev=ninterval ! set as previous interval/wav time number

return
end subroutine decode

end module jt65_decode

! This source code file was last time modified by Igor UA3DJY on January 16th, 2017
! All changes are shown in the patch file coming together with the full JTDX source code.

subroutine splitmsg(decoded,mycall,dtx,hintedrxfreq)
  
  use jt65_mod8 !  dynhint(300), dynhintcq(150), rxfreq(20), rxfchg(1), ninterval, freq
  
  character call1*6,call2*6,grid2*4
  save

  character mycall*12,decoded*22,direction*2
  logical(1) hintedrxfreq

  direction='00' ! non-CQ message
  nlastrx=0 ! unknown type of the standard message, initialization
  grid2='HQ01' ! unknown grid square, initialization and protection for hintdyn decoder

! nlastrx last received message matrix, used for wideband hintdyn decoder, dynhint(300) structure
! nlastrx   last RX message   / dinterval1 expected inversed msg / dinterval2 expected RX message
!   0           initialization/               none              / none
!   1           GRID          /               -01               / R-01, and might be again GRID
!   2           -01           /               R-01              / RRR/RR73/73, and might be again -01
!   3           R-01          /               RRR/RR73/73       / RRR/RR73/73,  and might be again R-01
!   4           RRR/RR73/73   /               RRR/RR73/73       / none

  if(decoded(1:3).eq.'CQ ' .or. &
     decoded(1:3).eq.'QRZ' .or. decoded(1:3).eq.'DE ') go to 2

  i1=index(decoded,' ')
  if(i1.lt.4) return
  i2=index(decoded(i1+1:),' ')
  if(i2.lt.4) return
  i2=i2+i1
  call1=decoded(1:i1-1)
  lmycall=len_trim(mycall)
  lcall1=len_trim(call1)
  if(lcall1.eq.lmycall) then
     if(call1(1:lcall1).eq.mycall(1:lmycall)) then
        call2=decoded(i1+1:i2-1)
        go to 4
     endif
  endif

  call2=decoded(i1+1:i2-1)
  nlastrx=1 ! shall be GRID if conditions below are not met
  do i=1,9
     if(i2+i.gt.16) exit ! protection for getting out of the decoded*22 length
     if(decoded(i2+i-1:i2+i).eq.' -') nlastrx=2
     if(decoded(i2+i-1:i2+i+1).eq.' R-') nlastrx=3
     if(decoded(i2+i-1:i2+i+1).eq.' RR') nlastrx=4
     if(decoded(i2+i-1:i2+i+1).eq.' 73') nlastrx=4
  enddo

  if(nlastrx.eq.1) then ! there is grid square in the message
     i3=index(decoded(i2+1:),' ')
     if(i3.eq.5) then
        grid2=decoded(i2+1:i2+1+i3-1)
     endif
  endif
!print *,call1,' ',call2,nlastrx
!print *,nlastrx
!print *,grid2

  do i=1,300
    if(dynhint(i)%ninterval.lt.0) then
       dynhint(i)%ninterval=ninterval
       dynhint(i)%call1=call1
       dynhint(i)%call2=call2
       dynhint(i)%grid2=grid2
       dynhint(i)%nlastrx=nlastrx
       dynhint(i)%freq=freq
       dynhint(i)%dt=dtx
       exit
    endif
  enddo

2 if(decoded(1:3).eq.'CQ ' .and. decoded(6:6).ne.' ') then ! CQ message
     i2=index(decoded(4:),' ')
     i2=i2+3
     call2=decoded(4:i2-1)
     direction='01'
  endif

  if(decoded(1:3).eq.'CQ ' .and. decoded(6:6).eq.' ') then ! directional CQ message
     i2=index(decoded(7:),' ')
     i2=i2+6
     call2=decoded(7:i2-1)
     direction=decoded(4:5)
  endif
  
4 if(hintedrxfreq) then
    do i=1,20
    if(rxfreq(i)%ninterval.lt.0) then
       rxfreq(i)%ninterval=ninterval
       rxfreq(i)%direction=direction
       rxfreq(i)%call2=call2
       rxfreq(i)%freq=freq
       rxfreq(i)%dt=dtx
       exit
    endif
    enddo
  endif

!do i=1,30
!print *, dynhint(i)%ninterval
!print *, dynhint(i)%call1
!enddo
!do i=1,20
!if(rxfreq(i)%ninterval.ge.1) then
!print *, rxfreq(i)%direction
!print *, rxfreq(i)%call2
!endif
!enddo

return
end subroutine splitmsg

! last time modified by Igor UA3DJY on 20200215

subroutine filterscq2(decoded,falsedec,iFreeText)
  
  character*22 decoded
  character*12 basecall
  logical(1) falsedec,lfound

  islash=index(decoded,'/')
  i2=index(decoded,' ')
  i3=index(decoded((i2+1):),' ')

  if(islash.ne.0) then
     ieoc=i2+i3-1 ! end of callsign

     if(iFreeText.eq.0) then ! slash in standard message
! CQ K1GT/QRP FN52  CQ EV1P/A  CQ EV1P/P  CQ EV1P/M  CQ EV1P/MM
        if(decoded(islash+1:islash+4).eq.'QRP ' .or. decoded(islash+1:islash+2).eq.'A ' &
           .or. decoded(islash+1:islash+2).eq.'P ' .or. decoded(islash+1:islash+2).eq.'M ' &
           .or. decoded(islash+1:islash+3).eq.'MM ') return
! CQ R8MB/1
        if(decoded(islash+1:islash+1).ge.'0' .and. decoded(islash+1:islash+1).le.'9' &
           .and. decoded(islash+2:islash+2).eq.' ') return
     endif
! CQ 4ID5/G7RPY   QRZ UMQH/VR0KZP AJ8  CQ LU2FQ/J GF07  CQ J/LU2FQ GF07  CQ 3DA0/K1AA
     if(islash.gt.(i2+1) .and. islash.lt.ieoc) then
        nleft=islash-i2-1
        nright=ieoc-islash
        if(nleft.gt.nright) then
           basecall=decoded(i2+1:islash-1)
        else ! check right side
           basecall=decoded(islash+1:ieoc)
        endif
        falsedec=.true.; lfound=.false.
        call searchcalls(basecall,"            ",lfound); if(lfound) falsedec=.false.; if(.not.falsedec) return
! check left side if both sides have equal length
        if(nleft.eq.nright) then
           basecall=decoded(i2+1:islash-1)
           if(basecall(nleft:nleft).gt.'9' .and. basecall(nleft:nleft).le.'Z') then
             call searchcalls(basecall,"            ",lfound); if(lfound) falsedec=.false.; if(.not.falsedec) return
           endif
        endif
     endif
  endif
 ! freemsg CQ UL7DIG+2C-  CQ YR100R KN2  CQ TC1919ATA
  if(iFreeText.eq.1) then
    if(i3.gt.7 .and. i3.le.10) then
       do i=4,13
          if(decoded(i:i).eq.'+' .or. decoded(i:i).eq.'-' .or. decoded(i:i).eq.'.' .or. decoded(i:i).eq.'?') falsedec=.true.
       enddo
    endif
    if(.not.falsedec .and. i3.gt.10) then
 !more than 9-char long special callsigns will be lost
       falsedec=.true.
       return
    endif
  endif

  return
end subroutine filterscq2

! This source code file was last time modified by Igor UA3DJY on April 6th, 2018
! All changes are shown in the patch file coming together with the full JTDX source code.

subroutine process_dd(lagcc,nmode,ntxmode,nzhsym)

  use jt65_mod6, only : dd
  use jt9_mod1
  logical(1), intent(in) :: lagcc

  if(.not.lagcc) dd9(0:NPTS9-1)=dd(1:NPTS9) ! NPTS9=618624 for decoding on 52nd second, NPTS9=597888
  if(lagcc .and. (nmode.eq.10 .or. nmode.eq.9)) then
     call agcc(nmode,ntxmode)
  endif

  if(nmode.ne.10 .and. nmode.ne.9) then
!    dd(1+nshift:npts)=dd(1:npts-nshift) ! NPTS=624000
     dd(26001:624000)=dd(1:598000)
!    dd(1:nshift)=0.0
     dd(1:26000)=0.0

     if(lagcc) then
        call agcc(nmode,ntxmode)
        if(nmode.eq.65+9) then
!          id2(0:580464-1)=nint(dd(1+nshift:580464+nshift))
           dd9(0:597999)=dd(26001:624000)
           if(nzhsym.eq.173) dd9(597888:597999)=0.
           dd9(598000:NPTS9-1)=0.
        endif
     endif
  endif

  return
end subroutine process_dd

! last time modified by Igor UA3DJY on 20200302

subroutine searchcalls(callsign1,callsign2,lfound)
  
  use jt65_mod9, only : ncall0c,ncalld,ncallef,ncallgh,ncalli,ncallj,ncallk,ncalllm,ncalln,ncallo,ncallpq,ncallr, &
                        ncallst,ncalluv,ncallw,ncallxz,call0c,calld,callef,callgh,calli,callj,callk,calllm,calln,callo,  &
                        callpq,callr,callst,calluv,callw,callxz,ldbvalid ! callsign DB in memory
  character*12 callsign0,callsign1,callsign2
  logical(1) lfound

  if(.not.ldbvalid) then; lfound=.true.; return; endif ! bail out
 
  nlencall1=len_trim(callsign1);  nlencall2=len_trim(callsign2)
  if(nlencall1.gt.7 .and. callsign2.eq."            ") then; lfound=.true.; return; endif
  if(nlencall2.gt.7) callsign2="            " ! we can not put in ALLCALL all special callsign0s in advance
  ncycles=2; if(callsign2.eq."            ") ncycles=1
  do j=1,ncycles
    if(j.eq.1) then; callsign0=callsign1; else; callsign0=callsign2; endif
    if(callsign0.eq."TU;") cycle
    if(callsign0(1:1).lt."N") then
      if(callsign0(1:1).lt."I") then
        if(callsign0(1:1).lt."E") then
          if(callsign0(1:1).lt."D") then
            do i=1,ncall0c; if(call0c(i).eq.callsign0) then; lfound=.true.; return; endif; enddo
          else
            do i=1,ncalld; if(calld(i).eq.callsign0) then; lfound=.true.; return; endif; enddo
          endif
        else
          if(callsign0(1:1).lt."G") then
            do i=1,ncallef; if(callef(i).eq.callsign0) then; lfound=.true.; return; endif; enddo
          else
            do i=1,ncallgh; if(callgh(i).eq.callsign0) then; lfound=.true.; return; endif; enddo
         endif
        endif
      else
        if(callsign0(1:1).lt."K") then
          if(callsign0(1:1).lt."J") then
            do i=1,ncalli; if(calli(i).eq.callsign0) then; lfound=.true.; return; endif; enddo
          else
            do i=1,ncallj; if(callj(i).eq.callsign0) then; lfound=.true.; return; endif; enddo
          endif
        else
          if(callsign0(1:1).lt."L") then
            do i=1,ncallk; if(callk(i).eq.callsign0) then; lfound=.true.; return; endif; enddo
          else
            do i=1,ncalllm; if(calllm(i).eq.callsign0) then; lfound=.true.; return; endif; enddo
          endif
        endif
      endif
    else
      if(callsign0(1:1).lt."S") then
        if(callsign0(1:1).lt."P") then
          if(callsign0(1:1).lt."O") then
            do i=1,ncalln; if(calln(i).eq.callsign0) then; lfound=.true.; return; endif; enddo
          else
            do i=1,ncallo; if(callo(i).eq.callsign0) then; lfound=.true.; return; endif; enddo
          endif
        else
          if(callsign0(1:1).lt."R") then
            do i=1,ncallpq; if(callpq(i).eq.callsign0) then; lfound=.true.; return; endif; enddo
          else
            do i=1,ncallr; if(callr(i).eq.callsign0) then; lfound=.true.; return; endif; enddo
         endif
        endif
      else
        if(callsign0(1:1).lt."W") then
          if(callsign0(1:1).lt."U") then
            do i=1,ncallst; if(callst(i).eq.callsign0) then; lfound=.true.; return; endif; enddo
          else
            do i=1,ncalluv; if(calluv(i).eq.callsign0) then; lfound=.true.; return; endif; enddo
          endif
        else
          if(callsign0(1:1).lt."X") then
            do i=1,ncallw; if(callw(i).eq.callsign0) then; lfound=.true.; return; endif; enddo
          else
            do i=1,ncallxz; if(callxz(i).eq.callsign0) then; lfound=.true.; return; endif; enddo
          endif
        endif
      endif
    endif
  enddo
! print *,"blocked ",callsign1,callsign2
  return
end subroutine searchcalls

! This source code file was last time modified by Igor UA3DJY on February 21st, 2017
! All changes are shown in the patch file coming together with the full JTDX source code.

module jt65_mod11
 ! MAXINTCAND max sum number of candidates for all decoding passes
  integer, parameter :: MAXCAND=300,MAXINTCAND=500

  type candidate
     real freq
     real dt
     real sync
  end type candidate
  type(candidate) ca(MAXCAND)
  
  type dt_check
    real cand_dtbest
    logical cand_decoded
  end type dt_check
  type(dt_check) dtchk(MAXINTCAND)
  
end module jt65_mod11

subroutine chkflscall(call_a,call_b,falsedec)

  character*12 call_a,call_b
  logical(1) falsedec,lfound

  if(call_a(1:2).eq.'<.') return
  falsedec=.true.; lfound=.false.
!print *,"11","'"//call_a//"'","'"//call_b//"'"
  if(call_a.eq.'MYCALL      ' .or. call_a.eq.'CQ          ') then
    call searchcalls(call_b,"            ",lfound); if(lfound) falsedec=.false.
  else if(call_b(1:1).eq.'<') then
    call searchcalls(call_a,"            ",lfound); if(lfound) falsedec=.false.
  else
    call searchcalls(call_a,call_b,lfound); if(lfound) falsedec=.false.
  endif

  return
end subroutine chkflscall

subroutine wqencode(msg,ntype,data0)

!  Parse and encode a WSPR message.

  use packjt
  parameter (MASK15=32767)
  character*22 msg
  character*12 call1,call2
  character grid4*4,grid6*6
  logical lbad1,lbad2
  integer*1 data0(11)
  integer nu(0:9)
  data nu/0,-1,1,0,-1,2,1,0,-1,1/

! Standard WSPR message (types 0 3 7 10 13 17 ... 60)
  i1=index(msg,' ')
  i2=index(msg,'/')
  i3=index(msg,'<')
  call1=msg(:i1-1)
  if(i1.lt.3 .or. i1.gt.7 .or. i2.gt.0 .or. i3.gt.0) go to 10
  grid4=msg(i1+1:i1+4)
  call packcall(call1,n1,lbad1)
  call packgrid(grid4,ng,lbad2)
  if(lbad1 .or. lbad2) go to 10
  ndbm=0
  read(msg(i1+5:),*) ndbm
  if(ndbm.lt.0) ndbm=0
  if(ndbm.gt.60) ndbm=60
  ndbm=ndbm+nu(mod(ndbm,10))
  n2=128*ng + (ndbm+64)
  call pack50(n1,n2,data0)
  ntype=ndbm
  go to 900

10 if(i2.ge.2 .and. i3.lt.1) then
     call packpfx(call1,n1,ng,nadd)
     ndbm=0
     read(msg(i1+1:),*) ndbm
     if(ndbm.lt.0) ndbm=0
     if(ndbm.gt.60) ndbm=60
     ndbm=ndbm+nu(mod(ndbm,10))
     ntype=ndbm + 1 + nadd
     n2=128*ng + ntype + 64
     call pack50(n1,n2,data0)
  else if(i3.eq.1) then
     i4=index(msg,'>')
     call1=msg(2:i4-1)
     call hash(call1,i4-2,ih)
     grid6=msg(i1+1:i1+6)
     call2=grid6(2:6)//grid6(1:1)//'      '
     call packcall(call2,n1,lbad1)
     ndbm=0
     read(msg(i1+8:),*) ndbm
     if(ndbm.lt.0) ndbm=0
     if(ndbm.gt.60) ndbm=60
     ndbm=ndbm+nu(mod(ndbm,10))
     ntype=-(ndbm+1)
     n2=128*ih + ntype + 64
     call pack50(n1,n2,data0)
  endif
  go to 900

900 continue
  return
end subroutine wqencode

subroutine baseline(s,nfa,nfb,sbase)

! Fit baseline to spectrum (for FT8)
! Input:  s(npts)         Linear scale in power
! Output: sbase(npts)    Baseline

  implicit real*8 (a-h,o-z)
  real*4 s(1920)
  real*4 sbase(1920)
  real*4 base
  real*8 x(1000),y(1000),a(5)
  data nseg/10/,npct/10/

  df=12000.0/3840.0                    !3.125 Hz
  ia=max(1,nint(nfa/df))
  ib=nint(nfb/df)
  do i=ia,ib
     s(i)=10.0*log10(s(i))            !Convert to dB scale
  enddo

  nterms=5
  nlen=(ib-ia+1)/nseg                 !Length of test segment
  i0=(ib-ia+1)/2                      !Midpoint
  k=0
  do n=1,nseg                         !Loop over all segments
     ja=ia + (n-1)*nlen
     jb=ja+nlen-1
     call pctile(s(ja),nlen,npct,base) !Find lowest npct of points
     do i=ja,jb
        if(s(i).le.base) then
           if (k.lt.1000) k=k+1       !Save all "lower envelope" points
           x(k)=i-i0
           y(k)=s(i)
        endif
     enddo
  enddo
  kz=k
  a=0.
  call polyfit(x,y,y,kz,nterms,0,a,chisqr)  !Fit a low-order polynomial
  do i=ia,ib
     t=i-i0
     sbase(i)=a(1)+t*(a(2)+t*(a(3)+t*(a(4)+t*(a(5))))) + 0.65
!     write(51,3051) i*df,s(i),sbase(i)
!3051 format(3f12.3)
  enddo

  return
end subroutine baseline

! This source code file was last time modified by Igor UA3DJY on July 5th, 2017
! All changes are shown in the patch file coming together with the full JTDX source code.

subroutine subtract9s(i4Decoded6BitWords,freq,drift,xdt,i4GrayCodedSym,hintdec)

! Subtract a jt9 signal
!
! Measured signal  : dd(t)    = a(t)cos(2*pi*f0*t+theta(t))
! Reference signal : cref(t)  = exp( j*(2*pi*f0*t+phi(t)) )
! Complex amp      : cfilt(t) = LPF[ dd(t)*CONJG(cref(t)) ]
! Subtract         : dd(t)    = dd(t) - 2*REAL{cref*cfilt}

!  use timer_module, only: timer
  use packjt
  use jt65_mod6 ! real*4 dd(624000) npts9=597888
  parameter (NFILT=1600)
  complex cw(720000)
  complex, DIMENSION(:), ALLOCATABLE :: cref,camp,cfilt
  integer*4 i4Decoded6BitWords(13)        !72-bit message as 6-bit words
  integer*1 i1Msg8BitBytes(13)            !72 bits and zero tail as 8-bit bytes
  integer*1 i1EncodedBits(207)            !Encoded information-carrying bits
  integer*1 i1ScrambledBits(207)          !Encoded bits after interleaving
  integer*4 i4DataSymbols(69)             !Data symbols (values 0-7)
  integer*4 i4GrayCodedSymbols(69)        !Gray-coded symbols (values 0-7)
  integer*4 i4GrayCodedSym(69)            !Gray-coded symbols (values 0-7)
  integer*4 i4tone(85)                    !Tone #s, data and sync (values 0-8)
  integer k,nsym,ns,nref,id,ind
  real*4 window(-NFILT/2:NFILT/2)
  real freq,drift,xdt,dt,dphi,phi,twopi,omega,a2,x0,x1
  logical(1) first,hintdec
  data first/.true./
  include 'jt9sync.f90'
  save first,cw

  allocate(cref(720000), STAT = nAllocateStatus1)
  if(nAllocateStatus1.ne.0) STOP "Not enough memory"
  allocate(camp(720000), STAT = nAllocateStatus1)
  if(nAllocateStatus1.ne.0) STOP "Not enough memory"
  allocate(cfilt(720000), STAT = nAllocateStatus1)
  if(nAllocateStatus1.ne.0) STOP "Not enough memory"

  twopi=6.28318531; pi512=1608.49548; phi=0.0 ! pi512=pi*512
  nsym=85; nsym2=206; ns=6912; ind=1; isym=1; id=1; nref=587520 ! nref=nsym*ns

  dt=xdt+1.0 ! one second TX offset
  nstart=nint(dt*12000.0)+1

  if(hintdec) then
     i4GrayCodedSymbols=i4GrayCodedSym
     goto 2
  endif

  call entail(i4Decoded6BitWords,i1Msg8BitBytes)  !Add tail, make 8-bit bytes
  call encode232(i1Msg8BitBytes,nsym2,i1EncodedBits)   !Encode K=32, r=1/2
  i1EncodedBits(207)=0
  call interleave9(i1EncodedBits,1,i1ScrambledBits)    !Interleave bits
  i1ScrambledBits(207)=0
  call packbits(i1ScrambledBits,69,3,i4DataSymbols)    !Pk 3-bits into words
  call graycode(i4DataSymbols,69,1,i4GrayCodedSymbols) !Apply Gray code

!do i=200,207
!print *,i1EncodedBits(i),i1ScrambledBits(i)
!print *,i4DataSymbols(69)
!enddo

2 continue
! Insert sync symbols at ntone=0 and add 2 to the data-tone numbers.
  j=0
  do i=1,85
     if(isync(i).eq.1) then
        i4tone(i)=0
     else
        j=j+1
        i4tone(i)=i4GrayCodedSymbols(j)+1
     endif
  enddo

!  call timer('subtr_1 ',0)
  x0=653184.0/2 ! 653184 samples are used for freq drift calculation, centering it
  x1=dt*12000.0+1.0
  a2=drift/(-2.0)
  do k=1,nsym
    omega=(pi512*(freq+a2*(k*ns+x1-x0)/653184.0+1.73611111*i4tone(isym)))/256 ! =2*pi*(f0+...
    isym=isym+1
    dphi=omega/12000.0
    do i=1,ns
        cref(ind)=cexp(cmplx(0.0,phi))
        phi=mod(phi+dphi,twopi)
        id=nstart-1+ind
        if(id.gt.(624000-1)) exit
        if(id.ge.1) camp(ind)=dd(id)*conjg(cref(ind))
        ind=ind+1
    enddo
  enddo
!  call timer('subtr_1 ',1)

!  call timer('subtr_2 ',0)
! Smoothing filter: do the convolution by means of FFTs. Ignore end-around 
! cyclic effects for now.

  nfft=588000
  if(first) then
! Create and normalize the filter
     sum1=0.0
     do j=-nfilt/2,nfilt/2
        window(j)=cos(twopi*j/(2*nfilt))
        sum1=sum1+window(j)
     enddo
     cw=0.
     do l=-nfilt/2,nfilt/2
        j1=l+1
        if(j1.lt.1) j1=j1+nfft
        cw(j1)=window(l)/sum1
     enddo
     call four2a(cw,nfft,1,-1,1)
     first=.false.
  endif

  cfilt(1:nref)=camp(1:nref)
  cfilt(nref+1:nfft)=0.
  call four2a(cfilt,nfft,1,-1,1)
  fac=1.0/float(nfft)
  cfilt(1:nfft)=fac*cfilt(1:nfft)*cw(1:nfft)
  call four2a(cfilt,nfft,1,1,1)
!  call timer('subtr_2 ',1)

! Subtract the reconstructed signal
!  call timer('subtr_3 ',0)
  do m=1,nref
     j2=nstart+m-1
     if(j2.ge.1 .and. j2.le.(624000-1)) dd(j2)=dd(j2)-2*REAL(cfilt(m)*cref(m))
  enddo
!  call timer('subtr_3 ',1)

  deallocate (cfilt, STAT = nDeAllocateStatus1)
  if (nDeAllocateStatus1.ne.0) print *, 'failed to release memory'
  deallocate (camp, STAT = nDeAllocateStatus1)
  if (nDeAllocateStatus1.ne.0) print *, 'failed to release memory'
  deallocate (cref, STAT = nDeAllocateStatus1)
  if (nDeAllocateStatus1.ne.0) print *, 'failed to release memory'

  return
end subroutine subtract9s

! This source code file was last time modified by Igor UA3DJY on August 19th, 2017
! All changes are shown in the patch file coming together with the full JTDX source code.

subroutine subtract65(freqa1,dt,a2,nfilt,jt65bc)

! Subtract a jt65 signal
!
! Measured signal  : dd(t)    = a(t)cos(2*pi*f0*t+theta(t))
! Reference signal : cref(t)  = exp( j*(2*pi*f0*t+phi(t)) )
! Complex amp      : cfilt(t) = LPF[ dd(t)*CONJG(cref(t)) ]
! Subtract         : dd(t)    = dd(t) - 2*REAL{cref*cfilt}

  use packjt
!  use timer_module, only: timer
  use jt65_mod2, only : correct
  use jt65_mod4 ! prc(126)
  use jt65_mod6 ! dd(NPTS)

  complex, DIMENSION(:), ALLOCATABLE :: cref,camp,cfilt
  complex cw(720000)
  integer k,nsym,ns,nref,id,ind
  real*4 window(-nfilt/2:nfilt/2)
  real*4 freqa1,dt,dphi,phi,twopi,omega,a2,a22,x0,x1,x10,fk,fc
  logical(1) first,jt65bc(2)
  data first/.true./
  save first,cw

  allocate(cref(720000), STAT = nAllocateStatus1)
  if(nAllocateStatus1.ne.0) STOP "Not enough memory"
  allocate(camp(720000), STAT = nAllocateStatus1)
  if(nAllocateStatus1.ne.0) STOP "Not enough memory"
  allocate(cfilt(720000), STAT = nAllocateStatus1)
  if(nAllocateStatus1.ne.0) STOP "Not enough memory"
  twopi=6.28318531
  pi512=1608.49548 !pi*512
! Symbol duration is 4096/11025 s.
! Sample rate is 12000/s, so 12000*(4096/11025)=4458.23 samples/symbol.
  nstart=nint(dt*12000.0)+1
  nsym=126
  ns=4458
  nref=561737 ! nsym*ns+29
  phi=0.0
  ind=1
  isym=1
  id=1

!  call timer('subtr_1 ',0)
  x0=672000.0/2 ! 672000 samples are used for freq drift calculation, centering it
  x1=dt*12000.0+1.0
  x10=x1-x0
  do k=1,nsym
    fk=float(k)
    a22=a2*(fk*4458.23129+x10)/672000.0
    if(prc(k)) then
        omega=pi512*(freqa1+a22)/256 ! =2*pi*f0
    else
        fc=float((correct(isym)+2))
        omega=pi512*(freqa1+a22+2.6916504*fc)/256 ! =2*pi*(f0+...
        if(jt65bc(1)) then
           fcb=float((2*correct(isym)+4))
           omega=pi512*(freqa1+a22+2.6916504*fcb)/256
        endif
        if(jt65bc(2)) then
           fcc=float((3*correct(isym)+6))
           omega=pi512*(freqa1+a22+2.6916504*fcc)/256
        endif
        isym=isym+1
    endif
    dphi=omega/12000.0
    do i=1,ns
        cref(ind)=cexp(cmplx(0.0,phi))
        phi=mod(phi+dphi,twopi)
        id=nstart-1+ind
        if(id.gt.npts) exit
        if(id.ge.1) camp(ind)=dd(id)*conjg(cref(ind))
        ind=ind+1
    enddo
    if(mod(k,5).eq.0) then !mod
    id=id+1
    if(id.gt.npts) exit
    if(id.ge.1) camp(ind)=dd(id)*conjg(cref(ind))
    ind=ind+1
    endif
  enddo
!  call timer('subtr_1 ',1)

!  call timer('subtr_2 ',0)
! Smoothing filter: do the convolution by means of FFTs. Ignore end-around 
! cyclic effects for now.

  nfft=564480
  if(first) then
! Create and normalize the filter
     sum1=0.0
     do j=-nfilt/2,nfilt/2
        window(j)=cos(twopi*j/(2*nfilt))
!        window(j)=abs(cos(twopi*j/(2*nfilt)))
        sum1=sum1+window(j)
     enddo
     cw=0.
     do l=-nfilt/2,nfilt/2
        j1=l+1
        if(j1.lt.1) j1=j1+nfft
        cw(j1)=window(l)/sum1
     enddo
     call four2a(cw,nfft,1,-1,1)
     first=.false.
  endif

  cfilt(1:nref)=camp(1:nref)
  cfilt(nref+1:nfft)=0.
  call four2a(cfilt,nfft,1,-1,1)
  fac=1.0/float(nfft)
  cfilt(1:nfft)=fac*cfilt(1:nfft)*cw(1:nfft)
  call four2a(cfilt,nfft,1,1,1)
!  call timer('subtr_2 ',1)

! Subtract the reconstructed signal
!  call timer('subtr_3 ',0)
  do m=1,nref
     j2=nstart+m-1
     if(j2.ge.1 .and. j2.le.npts) dd(j2)=dd(j2)-2*REAL(cfilt(m)*cref(m))
  enddo
!  call timer('subtr_3 ',1)

  deallocate (cfilt, STAT = nDeAllocateStatus1)
  if (nDeAllocateStatus1.ne.0) print *, 'failed to release memory'
  deallocate (camp, STAT = nDeAllocateStatus1)
  if (nDeAllocateStatus1.ne.0) print *, 'failed to release memory'
  deallocate (cref, STAT = nDeAllocateStatus1)
  if (nDeAllocateStatus1.ne.0) print *, 'failed to release memory'

  return
end subroutine subtract65 

! This source code file was last time modified by Igor UA3DJY on 20181215
! All changes are shown in the patch file coming together with the full JTDX source code.

subroutine hintrxgrid10(mrs,mrs2,mycall,decoded,hintdec,s3,i4GrayCodedSym)

  use packjt
  use prog_args
  parameter (MAXCALLS=35000)
  parameter (MAXMSG=MAXCALLS)
  real u1
  real s3(0:7,69)
  integer*1 sym2(0:68,MAXMSG)
  integer mrs(69),mrs2(69),sym_rev(0:68)
  integer*4 i4Msg6BitWords(13)            !72-bit message as 6-bit words
  integer*1 i1Msg8BitBytes(13)            !72 bits and zero tail as 8-bit bytes
  integer*1 i1EncodedBits(207)            !Encoded information-carrying bits
  integer*1 i1ScrambledBits(207)          !Encoded bits after interleaving
  integer*4 i4DataSymbols(69)             !Data symbols (values 0-7)
  integer*4 i4GrayCodedSym(69)            !Gray-coded symbols (values 0-7)
  logical(1) hintdec,first
  character*6 call2(MAXCALLS)
  character*4 grid2(MAXCALLS)
  character line*180,mycall*6,callsign*12,grid*4,msg*22,msg00*22,decoded*22
  character*22 msg0(MAXMSG)
  data first/.true./

  save first,nused,msg0,sym2

  if(first) then
     open(23,file=trim(data_dir)//'/CALL3.TXT',status='unknown')
     j=0
     do i=1,MAXCALLS
        read(23,1002,end=10) line
1002    format(a80)
        if(line(1:4).eq.'ZZZZ') exit
        if(line(1:2).eq.'//') cycle
        i1=index(line,',')
        if(i1.lt.4) cycle
        i2=index(line(i1+1:),',')
        if(i2.lt.5) cycle
        i2=i2+i1
        callsign=line(1:i1-1)
        grid=line(i1+1:i2-1)
        j=j+1
        call2(j)=callsign(1:6)               !### Fix for compound callsigns!
        grid2(j)=grid
     enddo
10   ncalls=j
     if(ncalls.lt.1) then
        print *, 'copy CALL3.TXT file to log directory'
        print *, 'http://www.jtdx.tech' 
!        stop 'CALL3.TXT is too short or missed?'
     endif
     close(23)

     if(ncalls.eq.0) then
        first=.false.
        return
     endif

     j=0; nsym2=206
     do i=1,ncalls
        j=j+1
        msg=mycall//' '//call2(i)//' '//grid2(i)
        call fmtmsg(msg,iz)
        call packmsg(msg,i4Msg6BitWords,itype)  !Pack into 12 6-bit bytes
        call entail(i4Msg6BitWords,i1Msg8BitBytes)  !Add tail, make 8-bit bytes
        call encode232(i1Msg8BitBytes,nsym2,i1EncodedBits)   !Encode K=32, r=1/2
        i1EncodedBits(207)=0
        call interleave9(i1EncodedBits,1,i1ScrambledBits)    !Interleave bits
        i1ScrambledBits(207)=0
        call packbits(i1ScrambledBits,69,3,i4DataSymbols)    !Pk 3-bits into words
        call graycode(i4DataSymbols,69,1,sym_rev) !Apply Gray code
        sym2(0:68,j)=sym_rev(0:68)
        msg0(j)=msg
     enddo
     nused=j
     first=.false.
  endif

  hintdec=.false.

  ref0=0.
  do j=1,69
     ref0=ref0 + s3(mrs(j),j)
  enddo

  u1=-99.0
  u2=u1

! Find u1 and u2 (best and second-best) codeword from a list, using 
! a bank of matched filters on the symbol spectra s3(i,j).
  ipk=1
  msg00='                      '
  do k=1,nused
     psum=0.
     ref=ref0
     do j=1,69
        i=sym2(j-1,k)
        psum=psum + s3(i,j)
        if(i.eq.mrs(j)) ref=ref - s3(i,j) + s3(mrs2(j),j)
     enddo
     p=psum/ref

     if(p.gt.u1) then
        if(msg0(k).ne.msg00) u2=u1
        u1=p
        ipk=k
        msg00=msg0(k)
     endif
     if(msg0(k).ne.msg00 .and. p.gt.u2) u2=p
  enddo

  decoded='                      '
  bias=max(1.12*u2,0.35)
  qual=100.0*(u1-bias)
  thresh=(qual+8.0)*u1

!  if((qual.ge.0.0 .or. u1.ge.0.6) .and. thresh.gt.1.65) then
  if((qual.ge.0.67 .or. u1.ge.0.75) .and. thresh.gt.7.6) then
!print *,qual,u1
!print *,thresh
     decoded=msg0(ipk)
     hintdec=.true.
     i4GrayCodedSym(1:69)=sym2(0:68,ipk)
  endif
return
end subroutine hintrxgrid10

! last time modified by Igor UA3DJY on 20191119

subroutine ft8s(s8,srr,itone,msg37,lft8s,nft8rxfsens,stophint)

  use ft8_mod1, only : itone56,idtone56,msg,nlasttx,lastrxmsg,mycall,hiscall
  real, intent(in) :: s8(0:7,79),srr
  real s8_1(0:7,79),s8d(0:7,58),xsync(21),xmsync(21),xdata(58),xmdata(58),xnoise(79),xmnoise(79)
  character, intent(out) :: msg37*37
  character*37 lastrcvdmsg,msgsent37
  integer, intent(out) :: itone(79)
  integer, intent(in) :: nft8rxfsens
  integer itonedem(58),idtone(58),mrs(58),mrs2(58),mrs3(58),mrs4(58),ip1(1)
  logical(1), intent(in) :: stophint
  logical(1), intent(out) :: lft8s
  logical(1) lmatched(58),lmycall,lhiscall,lrrr,lr73,lcallingrprt,lastrrprt,lastreport,lgrid

! taken from ft8_mod1
!    integer itone56(56,79),idtone56(56,58)
!    character*37 msg(56)

!nlasttx  last TX message
!  0       Tx was halted
!  1      AA1AA BB1BB PL35
!  2      AA1AA BB1BB -15
!  3      AA1AA BB1BB R-15
!  4      AA1AA BB1BB RRR/RR73
!  5      AA1AA BB1BB 73
!  6      CQ BB1BB PL35

  lft8s=.false.
  if(stophint) return; if(len_trim(hiscall).lt.3) return; if(nlasttx.eq.6 .or. nlasttx.eq.0) return ! CQ or TX halted
  lgrid=.false.; nft8rxfslow=nft8rxfsens; lmycall=.false.; lastrcvdmsg=''
  lmatched=.false.; s8_1=s8; lhiscall=.false.; lrrr=.false.; lr73=.false.; lcallingrprt=.false.; lastrrprt=.false.
  lastreport=.false.; itonedem=11; ntresh1=26; ntresh2=38; if(srr.gt.7.0) then; ntresh1=29; ntresh2=41; endif

  if(lastrxmsg(1)%lstate) then; lastrcvdmsg=lastrxmsg(1)%lastmsg; else; lastrcvdmsg=''; endif

  if(lastrcvdmsg.ne.'                                     ') then
    if(index(lastrcvdmsg,trim(hiscall)).gt.0) lhiscall=.true.
    if(index(lastrcvdmsg,trim(mycall)).eq.1) lmycall=.true.
    if(lmycall .and. lhiscall) then
      if(index(lastrcvdmsg,' RRR').gt.0) lrrr=.true.
      if(index(lastrcvdmsg,' RR73').gt.0 .or. index(lastrcvdmsg,' 73').gt.0) lr73=.true.
    endif
  else
    if(nlasttx.eq.2) lcallingrprt=.true. ! calling with REPORT scenario
  endif
  if(lmycall .and. lhiscall) then
    if(index(lastrcvdmsg,' +').gt.0 .or. index(lastrcvdmsg,' -').gt.0) lastreport=.true.
    if(index(lastrcvdmsg,' R+').gt.0 .or. index(lastrcvdmsg,' R-').gt.0) lastrrprt=.true.
  endif
  if(lastrxmsg(1)%lstate .and. lmycall .and. lhiscall .and. .not.lastreport .and. .not. lastrrprt .and. .not.lrrr .and. &
    .not.lr73) lgrid=.true.
  if(lastrxmsg(1)%lstate .and. .not.lmycall .and. lhiscall .and. nlasttx.eq.2) lcallingrprt=.true. ! calling with REPORT

  if(lgrid .and. index(msg(53),trim(mycall)//' '//trim(hiscall)//' AA00').eq.1) then ! standard callsigns
    i3=-1; n3=-1
    msg(53)=lastrxmsg(1)%lastmsg
    call genft8sd(msg(53),i3,n3,msgsent37,msgbits,itone)
    idtone56(53,1:29)=itone(8:36)
    idtone56(53,30:58)=itone(44:72)
    itone56(53,1:79)=itone(1:79)
  endif

  do i=1,58
    if(i.le.29) then; ip1=maxloc(s8_1(:,i+7))-1; itonedem(i)=ip1(1); s8_1(ip1(1),i+7)=0.0
    else; ip1=maxloc(s8_1(:,i+14))-1; itonedem(i)=ip1(1); s8_1(ip1(1),i+14)=0.0; endif
  enddo

  nmycall1=0; nbase1=0
  do k=1,19
    if(idtone56(1,k).eq.itonedem(k)) then; if(k.lt.10) nmycall1=nmycall1+1; nbase1=nbase1+1; endif
  enddo

! /'-01 ','-02 ','-03 ','-04 ','-05 ','-06 ','-07 ','-08 ','-09 ','-10 ',
!  '-11 ','-12 ','-13 ','-14 ','-15 ','-16 ','-17 ','-18 ','-19 ','-20 ',
!  '-21 ','-22 ','-23 ','-24 ','-25 ','-26 ','R-01','R-02','R-03','R-04',
!  'R-05','R-06','R-07','R-08','R-09','R-10','R-11','R-12','R-13','R-14',
!  'R-15','R-16','R-17','R-18','R-19','R-20','R-21','R-22','R-23','R-24',
!  'R-25','R-26','AA00','RRR ','RR73','73  '/

  ilow=1; ihigh=56
  if(nlasttx.eq.1) then; ilow=1; ihigh=26 ! GRID R+REPORT RRR RR73 73 are not valid msgs
  elseif(lgrid) then; ilow=27; ihigh=53 ! REPORT RRR RR73 73 are not valid msgs
  elseif(lcallingrprt) then; ilow=27; ihigh=52 ! GRID REPORT RRR RR73 73 are not valid msgs
  elseif(lastrrprt) then; ilow=27; ihigh=56 ! REPORT is not a valid msg, GRID shall be excluded later 
  elseif(lr73 .or. lrrr) then; ilow=54; ihigh=56 ! GRID, REPORT or R+REPORT is not a valid msg, 
! MF GRID shall be excluded later
  endif

  nmatchditer1=0; ncrcpatyiter1=0; imax=0
  do i=ilow,ihigh
    if(lastreport .and. i.gt.26 .and. i.lt.54) cycle ! RREPORT is not a valid msg, direction change is not allowed
    nmatch1=0; ncrcpaty1=0
    do k=1,58
      if(idtone56(i,k).eq.itonedem(k)) then; nmatch1=nmatch1+1; if(k.gt.25) ncrcpaty1=ncrcpaty1+1; endif
    enddo
    if(nmatch1.gt.nmatchditer1) then
      imax=i; nmatchditer1=nmatch1; ncrcpatyiter1=ncrcpaty1
    endif
  enddo
!write (*,"(i2,1x,i2,1x,i2,1x,i2)") nmatchlast1,nmatchditer1,ncrcpatylast1,ncrcpatyiter1
  if(imax.eq.0) return
  if(srr.gt.3.0 .and. (nmycall1.lt.5 .or. nbase1.lt.10)) return ! prevent false decodes from the strong signals
  if((nlasttx.eq.1 .or. lcallingrprt) .and. nmycall1.eq.0) return ! answer to other operator
  if(lr73 .and. (imax.eq.53 .or. imax.eq.54)) return ! RRR,GRID is not a valid msg

  nmatch1=nmatchditer1; ncrcpaty1=ncrcpatyiter1
  idtone(1:58)=idtone56(imax,1:58)
  do k=1,58
    if(idtone(k).eq.itonedem(k)) lmatched(k)=.true. 
  enddo

  if(ncrcpaty1.lt.8) return
  
  thresh=0.0; i1=0; i2=0; i33=0; i4=0
  do i=1,58; if(i.le.29) then; s8d(0:7,i)=s8(0:7,i+7); else; s8d(0:7,i)=s8(0:7,i+14); endif; enddo
  do j=1,58
    s1=-1.0E6; s2=-1.0E6; s3=-1.0E6; s4=-1.0E6
    do i=0,7; if(s8d(i,j).gt.s1) then; s1=s8d(i,j); i1=i; endif; enddo
    do i=0,7; if(i.ne.i1 .and. s8d(i,j).gt.s2) then; s2=s8d(i,j); i2=i; endif; enddo
    do i=0,7; if(i.ne.i1 .and. i.ne.i2 .and. s8d(i,j).gt.s3) then; s3=s8d(i,j); i33=i; endif; enddo
    do i=0,7; if(i.ne.i1 .and. i.ne.i2 .and. i.ne.i33 .and. s8d(i,j).gt.s4) then; s4=s8d(i,j); i4=i; endif; enddo
    mrs(j)=i1; mrs2(j)=i2; mrs3(j)=i33; mrs4(j)=i4
  enddo
  ref0=0.; ref0paty=0.; ref0mycl=0.; ref0oth=0.
  do i=1,58
    ref0=ref0 + s8d(mrs(i),i)
    if(i.gt.26) then; ref0paty=ref0paty + s8d(mrs(i),i)
    else if(i.lt.10) then; ref0mycl=ref0mycl + s8d(mrs(i),i)
    endif
  enddo
  ref0oth=ref0mycl+ref0paty
  ipk=0; u1=0.; u2=0.; u1paty=0.; u2paty=0.; u1oth=0.; u2oth=0.
  do k=ilow,ihigh
    if(lastreport .and. k.gt.26 .and. k.lt.54) cycle ! GRID, RREPORT is not a valid msg, direction change is not allowed
    psum=0.0; ref=ref0; psumpaty=0.; refpaty=ref0paty; psumoth=0.; refoth=ref0oth
    do j=1,58; i=idtone56(k,j); psum=psum + s8d(i,j)
      if(j.gt.26) then; psumpaty=psumpaty + s8d(i,j); psumoth=psumoth + s8d(i,j)
      else if(j.lt.10) then; psumoth=psumoth + s8d(i,j)
      endif
      if(i.eq.mrs(j)) then
        stmp=s8d(mrs2(j),j)-s8d(i,j); ref=ref + stmp
        if(j.gt.26) then; refpaty=refpaty + stmp; refoth=refoth + stmp
        else if(j.lt.10) then; refoth=refoth + stmp
        endif
      endif
      if(i.eq.mrs2(j)) then
        stmp=s8d(mrs3(j),j) - s8d(mrs2(j),j); ref=ref + stmp
        if(j.gt.26) then; refpaty=refpaty + stmp; refoth=refoth + stmp
        else if(j.lt.10) then; refoth=refoth + stmp
        endif
      endif
      if(i.eq.mrs3(j)) then
        stmp=s8d(mrs4(j),j) - s8d(mrs3(j),j); ref=ref + stmp
        if(j.gt.26) then; refpaty=refpaty + stmp; refoth=refoth + stmp
        else if(j.lt.10) then; refoth=refoth + stmp
        endif
      endif
!!      if(i.eq.mrs2(j)) then; ref=ref - s8d(mrs(j),j) + s8d(mrs3(j),j); endif
!!      if(i.eq.mrs3(j)) then; ref=ref - s8d(mrs(j),j) + s8d(mrs4(j),j); endif
    enddo
    p=psum/ref; ppaty=psumpaty/refpaty; poth=psumoth/refoth
    if(p.gt.u1) then; u2=u1; u1=p; u2paty=u1paty; u1paty=ppaty; u2oth=u1oth; u1oth=poth; ipk=k
    else if(p.gt.u2) then; u2=p; u2paty=ppaty; u2oth=poth
    endif
  enddo
  if(lastrrprt .and. ipk.eq.53) return ! GRID is not valid
  if(lr73 .and. ipk.lt.55) return

  if(lcallingrprt .or. nlasttx.eq.1) nft8rxfslow=1

  if(ipk.ne.0) then
    qual=100.0*(u1-u2); qualp=100.0*(u1paty-u2paty); qualo=100.0*(u1oth-u2oth)
    thresh=(qual+10.0)*(u1-0.6); if(thresh.lt.1.5) return
    threshp=(qualp+10.0)*(u1paty-0.6); thresho=(qualo+10.0)*(u1oth-0.6)
    if((lcallingrprt .or. nlasttx.eq.1) .and. thresho.lt.3.43) return
    if(thresho.lt.2.63 .or. threshp.lt.2.45) return
    if(((nft8rxfslow.eq.1 .and. thresh.gt.4.0) .or. (nft8rxfslow.eq.2 .and. thresh.gt.3.55) &
      .or. (nft8rxfslow.eq.3 .and. thresh.gt.3.0)) .and. qual.gt.2.6 .and. u1.gt.0.77) then
!if(ipk.ne.7) print *,'match1',thresh
      lft8s=.true.; msg37=msg(ipk); itone(1:79)=itone56(ipk,1:79); go to 2
    endif
  endif

  if(imax.eq.ipk .and. (nft8rxfslow.gt.1 .or. (nft8rxfslow.eq.1 .and. thresh.gt.2.7)) .and. srr.lt.7.0 &
    .and. (ncrcpaty1.gt.14 .or. (nmatch1.gt.22 .and. ncrcpaty1.gt.13))) then
!if(imax.ne.7) print *,'11',thresh
    lft8s=.true.; msg37=msg(imax); itone(1:79)=itone56(imax,1:79); go to 2
  endif

  if(imax.eq.ipk .and. nmatch1.gt.ntresh1 .and. ncrcpaty1.gt.10) then
!if(imax.ne.7) print *,'12',thresh
    lft8s=.true.; msg37=msg(imax); itone(1:79)=itone56(imax,1:79); go to 2
  endif

  if(nmatchditer1.ge.16) then

    do i=1,58
      if(lmatched(i)) cycle
      if(i.le.29) then; ip1=maxloc(s8_1(:,i+7))-1; itonedem(i)=ip1(1); s8_1(ip1(1),i+7)=0.0
      else; ip1=maxloc(s8_1(:,i+14))-1; itonedem(i)=ip1(1); s8_1(ip1(1),i+14)=0.0; endif
    enddo
    nmatch2=nmatch1; ncrcpaty2=ncrcpaty1
    do k=1,58
      if(lmatched(k)) cycle
      if(idtone(k).eq.itonedem(k)) then; nmatch2=nmatch2+1; lmatched(k)=.true.; if(k.gt.25) ncrcpaty2=ncrcpaty2+1; endif
    enddo
    if(nmatch2.gt.ntresh2 .and. ncrcpaty2.gt.19) then
!if(imax.ne.7) print *,'2',thresh
       lft8s=.true.; msg37=msg(imax); itone(1:79)=itone56(imax,1:79); go to 2
    endif

    if(srr.gt.7.0) return ! do not process strong signals anymore

    do i=1,58
      if(lmatched(i)) cycle
      if(i.le.29) then; ip1=maxloc(s8_1(:,i+7))-1; itonedem(i)=ip1(1); s8_1(ip1(1),i+7)=0.0
      else; ip1=maxloc(s8_1(:,i+14))-1; itonedem(i)=ip1(1); s8_1(ip1(1),i+14)=0.0; endif
    enddo
    nmatch3=nmatch2; ncrcpaty3=ncrcpaty2
    do k=1,58
      if(lmatched(k)) cycle
      if(idtone(k).eq.itonedem(k)) then; nmatch3=nmatch3+1; lmatched(k)=.true.; if(k.gt.25) ncrcpaty3=ncrcpaty3+1; endif
    enddo
    if(nmatch3.gt.44 .and. ncrcpaty3.gt.21) then
!if(imax.ne.7) print *,'3',thresh
      lft8s=.true.; msg37=msg(imax); itone(1:79)=itone56(imax,1:79); go to 2
    endif

    do i=1,58
      if(lmatched(i)) cycle
      if(i.le.29) then; ip1=maxloc(s8_1(:,i+7))-1; itonedem(i)=ip1(1); s8_1(ip1(1),i+7)=0.0
      else; ip1=maxloc(s8_1(:,i+14))-1; itonedem(i)=ip1(1); s8_1(ip1(1),i+14)=0.0; endif
    enddo
    nmatch4=nmatch3; ncrcpaty4=ncrcpaty3
    do k=1,58
      if(lmatched(k)) cycle
      if(idtone(k).eq.itonedem(k)) then; nmatch4=nmatch4+1; lmatched(k)=.true.; if(k.gt.25) ncrcpaty4=ncrcpaty4+1; endif
    enddo
    if((nft8rxfslow.eq.3 .or. (nft8rxfslow.eq.2 .and. thresh.gt.2.2)) .and. nmatch4.gt.47 .and. ncrcpaty4.gt.23) then
!if(imax.ne.7) print *,'4',thresh
      lft8s=.true.; msg37=msg(imax); itone(1:79)=itone56(imax,1:79); go to 2
    endif

    do i=1,58
      if(lmatched(i)) cycle
      if(i.le.29) then; ip1=maxloc(s8_1(:,i+7))-1; itonedem(i)=ip1(1); s8_1(ip1(1),i+7)=0.0
      else; ip1=maxloc(s8_1(:,i+14))-1; itonedem(i)=ip1(1); s8_1(ip1(1),i+14)=0.0; endif
    enddo
    nmatch5=nmatch4; ncrcpaty5=ncrcpaty4
    do k=1,58
      if(lmatched(k)) cycle
      if(idtone(k).eq.itonedem(k)) then; nmatch5=nmatch5+1; lmatched(k)=.true.; if(k.gt.25) ncrcpaty5=ncrcpaty5+1; endif
    enddo
    if((nft8rxfslow.eq.3 .or. (nft8rxfslow.eq.1 .and. thresh.gt.3.4) .or. (nft8rxfslow.eq.2 .and. thresh.gt.3.25)) &
      .and. nmatch5.gt.50 .and. (nmatch1.gt.21 .or. nmatch2.gt.31 .or. nmatch3.gt.38 .or. nmatch4.gt.46) &
      .and. ncrcpaty5.gt.25) then
!if(imax.ne.7) print *,'5',thresh
      lft8s=.true.; msg37=msg(imax); itone(1:79)=itone56(imax,1:79); go to 2
    endif

    do i=1,58
      if(lmatched(i)) cycle
      if(i.le.29) then; ip1=maxloc(s8_1(:,i+7))-1; itonedem(i)=ip1(1); s8_1(ip1(1),i+7)=0.0
      else; ip1=maxloc(s8_1(:,i+14))-1; itonedem(i)=ip1(1); s8_1(ip1(1),i+14)=0.0; endif
    enddo
    nmatch6=nmatch5; ncrcpaty6=ncrcpaty5
    do k=1,58
      if(lmatched(k)) cycle
      if(idtone(k).eq.itonedem(k)) then; nmatch6=nmatch6+1; lmatched(k)=.true.; if(k.gt.25) ncrcpaty6=ncrcpaty6+1; endif
    enddo
    if(((nft8rxfslow.eq.2 .and. thresh.gt.2.6) .or. (nft8rxfslow.eq.3 .and. thresh.gt.2.22)) &
      .and. imax.eq.ipk .and. ncrcpaty6.gt.26) then
!if(imax.ne.7) print *,'61',thresh
!print *,'61',thresh
!write (*,"(i2,1x,i2,1x,f5.2)") 6,ncrcpaty6,thresh
      lft8s=.true.; msg37=msg(imax); itone(1:79)=itone56(imax,1:79); go to 2
    endif

    if(nft8rxfslow.eq.1) then
      if(nmatch6.gt.54 .and. (nmatch1.gt.22 .or. nmatch2.gt.27 .or. nmatch3.gt.35 .or. &
        (nmatch2-nmatch1).gt.9 .or. (nmatch3-nmatch2).gt.10) .and. ncrcpaty6.gt.29 .and. thresh.gt.3.15) then
!if(imax.ne.7) print *,'62',thresh
!print *,'62',thresh
        lft8s=.true.; msg37=msg(imax); itone(1:79)=itone56(imax,1:79); go to 2
      endif
    endif

    if(ncrcpaty6.gt.29) then
      if((nft8rxfslow.eq.3 .or. (nft8rxfslow.eq.3 .and. thresh.gt.1.94)) .and. imax.eq.ipk .and. ncrcpaty2-ncrcpaty1.gt.3 &
        .and. ncrcpaty3-ncrcpaty2.gt.3 .and. ncrcpaty4-ncrcpaty3.gt.3 .and. ncrcpaty6-ncrcpaty5.lt.6) then
!if(imax.ne.7) print *,'63',thresh
!print *,'63',thresh
!if(imax.ne.7) write (*,"(i2,1x,f5.2,1x,f5.2,1x,f5.2)") 62,u1,qual,thresh
        lft8s=.true.; msg37=msg(imax); itone(1:79)=itone56(imax,1:79); go to 2
      endif
    endif
  endif

2 if(lft8s) then
    snr=0.0; snrbase=0.0; snrpaty=0.0; snrdata=0.0; snrsync=0.0; snrmycall=0.0; snrother=0.0
    do i=1,79
      xsig=s8(itone(i),i); xnoi=(sum(s8(0:7,i)) - xsig)/7.0; snr1=xsig/(xnoi+1E-6); snr=snr+snr1
      if(i.gt.7 .and. i.lt.34) then; snrbase=snrbase + snr1; if(i.lt.17) snrmycall=snrmycall + snr1; endif
      if((i.gt.43 .and. i.lt.73) .or. (i.gt.33 .and. i.lt.37)) then; snrpaty=snrpaty+snr1; endif
    enddo
    snrdata=snrbase+snrpaty; snrsync=snr-snrdata; snrother=snrmycall+snrpaty
    snrsync=snrsync/21.0; snrother=snrother/48.0; snrpaty=snrpaty/32.0
    if(lcallingrprt .or. nlasttx.eq.1) then
      soratio=snrsync/snrother
      if(soratio.gt.1.29) then;lft8s=.false.; msg37=''; return; endif
    endif
    spratio=snrsync/snrpaty
    if(spratio.lt.0.6 .or. spratio.gt.1.25) then;lft8s=.false.; msg37=''; return; endif

    do i=1,7; xsync(i)=s8(itone(i),i); enddo; do i=8,14; k=i+29; xsync(i)=s8(itone(k),k); enddo
    do i=15,21; k=i+58; xsync(i)=s8(itone(k),k); enddo
    do i=1,29; k=i+7; xdata(i)=s8(itone(k),k); enddo; do i=30,58; k=i+14; xdata(i)=s8(itone(k),k); enddo
    do i=1,79; k=modulo(itone(i)+4,8); xnoise(i)=s8(k,i); enddo

    do i=1,19
      if((xsync(i).gt.xsync(i+1) .and. xsync(i).lt.xsync(i+2)) &
        .or. (xsync(i).lt.xsync(i+1) .and. xsync(i).gt.xsync(i+2))) then; xmsync(i)=xsync(i)
      else if((xsync(i+1).gt.xsync(i) .and. xsync(i+1).lt.xsync(i+2)) &
        .or. (xsync(i+1).lt.xsync(i) .and. xsync(i+1).gt.xsync(i+2))) then; xmsync(i)=xsync(i+1)
      else if((xsync(i+2).gt.xsync(i) .and. xsync(i+2).lt.xsync(i+1)) &
        .or. (xsync(i+2).lt.xsync(i) .and. xsync(i+2).gt.xsync(i+1))) then; xmsync(i)=xsync(i+2)
      else; xmsync(i)=xsync(i)
      endif
    enddo
    xmsync(20)=xmsync(18); xmsync(21)=xmsync(19)

    do i=1,56
      if((xdata(i).gt.xdata(i+1) .and. xdata(i).lt.xdata(i+2)) &
        .or. (xdata(i).lt.xdata(i+1) .and. xdata(i).gt.xdata(i+2))) then; xmdata(i)=xdata(i)
      else if((xdata(i+1).gt.xdata(i) .and. xdata(i+1).lt.xdata(i+2)) &
        .or. (xdata(i+1).lt.xdata(i) .and. xdata(i+1).gt.xdata(i+2))) then; xmdata(i)=xdata(i+1)
      else if((xdata(i+2).gt.xdata(i) .and. xdata(i+2).lt.xdata(i+1)) &
        .or. (xdata(i+2).lt.xdata(i) .and. xdata(i+2).gt.xdata(i+1))) then; xmdata(i)=xdata(i+2)
      else; xmdata(i)=xdata(i)
      endif
    enddo
    xmdata(57)=xmdata(55); xmdata(58)=xmdata(56)

    do i=1,77
      if((xnoise(i).gt.xnoise(i+1) .and. xnoise(i).lt.xnoise(i+2)) &
        .or. (xnoise(i).lt.xnoise(i+1) .and. xnoise(i).gt.xnoise(i+2))) then; xmnoise(i)=xnoise(i)
      else if((xnoise(i+1).gt.xnoise(i) .and. xnoise(i+1).lt.xnoise(i+2)) &
        .or. (xnoise(i+1).lt.xnoise(i) .and. xnoise(i+1).gt.xnoise(i+2))) then; xmnoise(i)=xnoise(i+1)
      else if((xnoise(i+2).gt.xnoise(i) .and. xnoise(i+2).lt.xnoise(i+1)) &
        .or. (xnoise(i+2).lt.xnoise(i) .and. xnoise(i+2).gt.xnoise(i+1))) then; xmnoise(i)=xnoise(i+2)
      else; xmnoise(i)=xnoise(i)
      endif
    enddo
    xmnoise(78)=xmnoise(76); xmnoise(79)=xmnoise(77)

    ssync=sum(xmsync)/21.0; spaty=sum(xmdata(27:58))/32.0; spnoise=(sum(xmnoise(34:36)) + sum(xmnoise(44:72)))/32.0
    spother=(sum(xmdata(1:9)) + sum(xmdata(27:58)))/41.0
    spratiom=ssync/(spaty+1E-6); spnratiom=spaty/(spnoise+1E-6); sporatiom=ssync/(spother+1E-6)
    if(spnratiom.gt.2.3) then
      if(lcallingrprt .or. nlasttx.eq.1) then; if(sporatiom.gt.1.35) then; lft8s=.false.; msg37=''; return; endif
      else; if(spratiom.gt.1.35) then; lft8s=.false.; msg37=''; return; endif
      endif
    endif
  endif

  return
end subroutine ft8s

! This source code file was last time modified by Igor UA3DJY on January 18th, 2017
! All changes are shown in the patch file coming together with the full JTDX source code.

subroutine symspec65(ss,ss22,nfdistort)

! Compute JT65 symbol spectra at half-symbol steps
  use jt65_mod5 !ref(3413)
  use jt65_mod6 !dd(NPTS) NPTS

  integer, parameter :: NFFT=8192,NSZ=3413,NHSYM=276 !3413 = NFFT*5000/12000
 ! nhsym=276 (npts-NFFT)/hstep !number of half-symbols 276.2566 = (52*12000-8192)/(2048*12000/11025)
  real*8 hstep
  real*4 ss(:,:),ss22(:,:),x(NFFT),x22(NFFT),w(NFFT),ref22(NSZ),stmp1(NSZ),ss1(NHSYM),stmp2(NSZ),ss2(NHSYM)
  complex c(0:NFFT/2),c22(0:NFFT/2)
  integer nfdistort
  logical(1) first
  equivalence (x,c),(x22,c22)
  data first/.true./
  save first,w
  ss=0.; ss22=0.
  hstep=2048.d0*12000.d0/11025.d0              !half-symbol = 2229.116 samples

  fac1=1.e-3
  twopi=6.28318531

  if(first) then ! Compute the FFT window
     do k=1,NFFT
     w(k)=sin(twopi*(k+2)/16384) ! 16384 = 2*NFFT
      enddo
     first=.false.
  endif

  do j=1,nhsym
     i0=(j-1)*hstep
     x=fac1*w*dd(i0+1:i0+NFFT)
     if(i0.lt.1115) then
        x22=0.
     else
        x22=fac1*w*dd(i0+1-1115:i0+NFFT-1115) !dd data shifted 1115 samples or quarter of the sybmol
     endif
     call four2a(c,NFFT,1,-1,0)                !r2c forward FFT
     call four2a(c22,NFFT,1,-1,0)

     if (nfdistort.eq.1) then
        do i=1,NSZ
          s=real(c(i))**2 + aimag(c(i))**2
          ss(j,i)=s
          s22=real(c22(i))**2 + aimag(c22(i))**2
          ss22(j,i)=s22
        enddo
     elseif(nfdistort.eq.2) then
        do i=1,NSZ
          s=SQRT(real(c(i))**2 + aimag(c(i))**2)
          ss(j,i)=s
          s22=SQRT(real(c22(i))**2 + aimag(c22(i))**2)
          ss22(j,i)=s22
        enddo
     elseif(nfdistort.eq.3) then
        do i=1,NSZ
          s=abs(real(c(i))) + abs(aimag(c(i)))
          ss(j,i)=s
          s22=abs(real(c22(i))) + abs(aimag(c22(i)))
          ss22(j,i)=s22
        enddo
     endif
  enddo

 !Flatten the 2d spectrum, saving

  npct=28  !Somewhat arbitrary
  nsmo=33 
  ia=nsmo/2 + 1
  ib=NSZ - nsmo/2 - 1
  
  do i=1,NSZ
     ss1(1:NHSYM)=ss(1:NHSYM,i)
     call pctile(ss1,nhsym,npct,stmp1(i))
  enddo
  do i=ia,ib
     call pctile(stmp1(i-nsmo/2),nsmo,npct,ref(i))
  enddo
  ref(:ia-1)=ref(ia)
  ref(ib+1:)=ref(ib)
  ref=4.0*ref

  do i=1,NSZ
     ss2=ss22(1:NHSYM,i)
     call pctile(ss2,nhsym,npct,stmp2(i))
  enddo
  do i=ia,ib
     call pctile(stmp2(i-nsmo/2),nsmo,npct,ref22(i))
  enddo
  ref22(:ia-1)=ref22(ia)
  ref22(ib+1:)=ref22(ib)
  ref22=4.0*ref22
  
  do j=1,nhsym
     ss(j,1:NSZ)=ss(j,1:NSZ)/ref
     ss22(j,1:NSZ)=ss22(j,1:NSZ)/ref22
  enddo

  return
end subroutine symspec65

! This source code file was last time modified by Igor Chernikov UA3DJY on July 12th, 2016.
! All changes are shown in the patch file coming together with the full JTDX source code.

subroutine slope(y,npts,xpk)

! Remove best-fit slope from data in y(i).  When fitting the straight line,
! ignore the peak around xpk +/- 2.
  implicit none
  integer i
  integer npts
  real y(npts)
  real xpk,sumw,sumx,sumy,sumx2,sumxy,sumy2,x,a,b,delta,sq,rms
  
  sumw=0.; sumx=0.; sumy=0.; sumx2=0.; sumxy=0.; sumy2=0.
  
  do i=1,npts
     if(abs(i-xpk).gt.2.0) then
        sumw=sumw + 1.0
        x=i
        sumx=sumx + x
        sumy=sumy + y(i)
        sumx2=sumx2 + x*x
        sumxy=sumxy + x*y(i)
        sumy2=sumy2 + y(i)**2
     endif
  enddo

  delta=sumw*sumx2 - sumx**2
  a=(sumx2*sumy - sumx*sumxy) / delta
  b=(sumw*sumxy - sumx*sumy) / delta

  sq=0.
  do i=1,npts
     y(i)=y(i)-(a + b*i)
     if(abs(i-xpk).gt.2.0) sq=sq + y(i)**2
  enddo
  rms=sqrt(sq/(sumw-2.0))
  y=y/rms

  return
end subroutine slope

subroutine sync8(nfa,nfb,syncmin,nfqso,candidate,ncand,jzb,jzt,swl,ipass,lqsothread,ncandthin,filter,ndtcenter)

  use ft8_mod1, only : dd8,windowx,facx,icos7,lagcc,lagccbail,nfawide,nfbwide
  include 'ft8_params.f90'
  complex cx(0:NH1)
  real s(NH1,NHSYM),x(NFFT1),sync2d(NH1,jzb:jzt),red(NH1),candidate0(5,450),candidate(4,460),tall(30),freq,rcandthin,dtcenter
  integer jpeak(NH1),indx(NH1),ii(1)
  integer, intent(in) :: nfa,nfb,nfqso,jzb,jzt,ipass,ncandthin,ndtcenter
  logical(1) syncq(NH1,jzb:jzt),redcq(NH1),lcq,lcq2,lpass1,lpass2
  logical(1), intent(in) :: swl,lqsothread,filter
  equivalence (x,cx)

! Compute symbol spectra, stepping by NSTEP steps.  
  tstep=0.04 ! NSTEP/12000.0                         
  df=3.125 ! 12000.0/NFFT1 , Hz
  syncq=.false.; redcq=.false.; candidate(4,:)=0.
  rcandthin=ncandthin/100.; if(filter) rcandthin=min(rcandthin*3.0,1.0)
  dtcenter=ndtcenter/100.

  if(ipass.eq.1 .or. ipass.eq.4 .or. ipass.eq.7) then
    do j=1,NHSYM
      ia=(j-1)*NSTEP + 1
      ib=ia+NSPS-1
      x(1:759)=0.
      if(j.ne.1) then; x(760:960)=dd8(ia-201:ia-1)*windowx(200:0:-1); else; x(760:960)=0.; endif
      x(961:2880)=facx*dd8(ia:ib); x(961)=x(961)*1.9; x(2880)=x(2880)*1.9
      if(j.ne.NHSYM) then; x(2881:3081)=dd8(ib+1:ib+201)*windowx; else; x(2881:3081)=0.; endif
      x(3082:)=0.
      call four2a(cx,NFFT1,1,-1,0)              !r2c FFT
      do i=1,NH1
        s(i,j)=SQRT(real(cx(i))**2 + aimag(cx(i))**2)
      enddo
    enddo
  endif
  if(ipass.eq.2 .or. ipass.eq.5 .or. ipass.eq.8) then
    do j=1,NHSYM
      ia=(j-1)*NSTEP + 1
      ib=ia+NSPS-1
      x(1:759)=0.
      if(j.ne.1) then; x(760:960)=dd8(ia-201:ia-1)*windowx(200:0:-1); else; x(760:960)=0.; endif
      x(961:2880)=facx*dd8(ia:ib); x(961)=x(961)*1.9; x(2880)=x(2880)*1.9
      if(j.ne.NHSYM) then; x(2881:3081)=dd8(ib+1:ib+201)*windowx; else; x(2881:3081)=0.; endif
      x(3082:)=0.
      call four2a(cx,NFFT1,1,-1,0)              !r2c FFT
      do i=1,NH1
        s(i,j)=real(cx(i))**2 + aimag(cx(i))**2
      enddo
    enddo
  endif
  if(ipass.eq.3 .or. ipass.eq.6 .or. ipass.eq.9) then
    do j=1,NHSYM
      ia=(j-1)*NSTEP + 1
      ib=ia+NSPS-1
      x(1:759)=0.
      if(j.ne.1) then; x(760:960)=dd8(ia-201:ia-1)*windowx(200:0:-1); else; x(760:960)=0.; endif
      x(961:2880)=facx*dd8(ia:ib); x(961)=x(961)*1.9; x(2880)=x(2880)*1.9
      if(j.ne.NHSYM) then; x(2881:3081)=dd8(ib+1:ib+201)*windowx; else; x(2881:3081)=0.; endif
      x(3082:)=0.
      call four2a(cx,NFFT1,1,-1,0)              !r2c FFT
      do i=1,NH1
        s(i,j)=abs(real(cx(i))) + abs(aimag(cx(i)))
      enddo
    enddo
  endif

  ia=max(1,nint(nfa/df)); ib=max(1,nint(nfb/df)); iaw=max(1,nint(nfawide/df)); ibw=max(1,nint(nfbwide/df))
  nssy=4 ! NSPS/NSTEP   ! # steps per symbol
  nssy36=144 ! nssy*36
  nssy72=288 ! nssy*72
  nfos=2 ! NFFT1/NSPS   ! # frequency bin oversampling factor
  jstrt=12.5 ! 0.5/tstep

  if(lagcc .and. .not.lagccbail) then
    nfos6=12 ! nfos*6
    do j=jzb,jzt
      do i=iaw,ibw
        ta=0.; tb=0.; tc=0.
        do n=0,6
          k=j+jstrt+nssy*n
          if(k.gt.0) then
            ta=s(i+nfos*icos7(n),k)
            if(ta.gt.1e-9) then; tall(n+1)=ta*6.0/(sum(s(i:i+nfos6:nfos,k))-ta); else; tall(n+1)=0.; endif
          endif
          k36=k+nssy36
          if(k36.gt.0 .and. k36.le.NHSYM) then
            tb=s(i+nfos*icos7(n),k36)
            if(tb.gt.1e-9) then; tall(n+17)=tb*6.0/(sum(s(i:i+nfos6:nfos,k36))-tb); else; tall(n+17)=0.; endif
          endif
          k72=k+nssy72
          if(k72.le.NHSYM) then
            tc=s(i+nfos*icos7(n),k72)
            if(tc.gt.1e-9) then; tall(n+24)=tc*6.0/(sum(s(i:i+nfos6:nfos,k72))-tc); else; tall(n+24)=0.; endif
          endif
        enddo
        lcq=.false.
        if(ipass.gt.1) then
          do n=7,15
            k=j+jstrt+nssy*n
            if(k.gt.0) then
              if(n.lt.15) then
                tall(n+1)=s(i,k)*6.0/(sum(s(i:i+nfos6:nfos,k))-s(i,k))
              else
                tall(n+1)=s(i+2,k)*6.0/(sum(s(i:i+nfos6:nfos,k))-s(i+2,k))
              endif
            endif
          enddo
          sya=sum(tall(1:7)); sycq=sum(tall(8:16)); sybc=sum(tall(17:30))
          sy1=(sya+sycq+sybc)/30.; sy2=(sya+sybc)/21.; sync_abc=max(sy1,sy2)
          sy1=(sycq+sybc)/23.; sy2=(sybc)/14.; sync_bc=max(sy1,sy2); if(sy1.gt.sy2) lcq=.true.
        else
          sybc=sum(tall(17:30)); sync_abc=sum(tall(1:7))+sybc; sync_bc=sybc/14.; sync_abc=sync_abc/21.
        endif
        sync2d(i,j)=max(sync_abc,sync_bc); if(lcq) syncq(i,j)=.true.
      enddo
    enddo
  else
!    nfos6=15 ! 16i spec bw -1
    nfos6=16
    do j=jzb,jzt
      do i=iaw,ibw
        ta=0.; tb=0.; tc=0.; tcq=0.; t0a=0.; t0b=0.; t0c=0.; t0cq=0.
        do n=0,6
          k=j+jstrt+nssy*n
          if(k.gt.0) then; ta=ta + s(i+nfos*icos7(n),k); t0a=t0a + sum(s(i:i+nfos6,k)) - s(i+nfos*icos7(n)+1,k); endif
          k36=k+nssy36
          if(k36.gt.0 .and. k36.le.NHSYM) then
            tb=tb + s(i+nfos*icos7(n),k36); t0b=t0b + sum(s(i:i+nfos6,k36)) - s(i+nfos*icos7(n)+1,k36)
          endif
          k72=k+nssy72
          if(k72.le.NHSYM) then
            tc=tc + s(i+nfos*icos7(n),k72)
            t0c=t0c + sum(s(i:i+nfos6,k72)) - s(i+nfos*icos7(n)+1,k72)
          endif
        enddo
        do n=7,15
          k=j+jstrt+nssy*n
          if(k.ge.1) then
            if(n.lt.15) then; tcq=tcq + s(i,k); t0cq=t0cq + sum(s(i:i+nfos6,k)) - s(i,k+1)
            else; tcq=tcq + s(i+2,k); t0cq=t0cq + sum(s(i:i+nfos6,k)) - s(i,k+3)
            endif
          endif
        enddo
        t1=ta+tb+tc; t01=t0a+t0b+t0c; t2=t1+tcq; t02=t01+t0cq
        t01=(t01-t1*2)/42.0; if(t01.lt.1e-8) t01=1.0; t02=(t02-t2*2)/60.0; if(t02.lt.1e-8) t02=1.0 ! safe division
        sync01=t1/(7.0*t01); sync02=(t1/7.0 + tcq/9.0)/t02; syncf=max(sync01,sync02)
        lcq=.false.; if(sync02.gt.sync01) lcq=.true.
        t1=tb+tc; t01=t0b+t0c; t2=t1+tcq; t02=t01+t0cq
        t01=(t01-t1*2)/28.0; if(t01.lt.1e-8) t01=1.0; t02=(t02-t2*2)/46.0; if(t02.lt.1e-8) t02=1.0 ! safe division
        sync01=t1/(7.0*t01); sync02=(t1/7.0 + tcq/9.0)/t02; syncs=max(sync01,sync02)
        lcq2=.false.; if(sync02.gt.sync01) lcq2=.true.
        sync2d(i,j)=max(syncf,syncs)
        if(syncf.gt.syncs) then; if(lcq) syncq(i,j)=.true.; else; if(lcq2) syncq(i,j)=.true.; endif
      enddo
    enddo
  endif

  red=0.
  do i=iaw,ibw
    ii=maxloc(sync2d(i,jzb:jzt)) - 1 + jzb
    j0=ii(1)
    jpeak(i)=j0
    red(i)=sync2d(i,j0); if(syncq(i,j0)) redcq(i)=.true.
!     write(52,3052) i*df,red(i),db(red(i))
!3052 format(3f12.3)
  enddo

  iz=ibw-iaw+1
  call indexx(red(iaw:ibw),iz,indx)
  ibase=indx(max(1,nint(0.40*iz))) - 1 + iaw ! max is workaround to prevent indx getting out of bounds
  base=red(ibase)
  if(base.lt.1e-8) base=1.0 ! safe division
  red=red/base

  candidate0=0.; k=0; iz=ib-ia+1; lpass1=.false.; lpass2=.false.
  if(rcandthin.lt.0.99) then
    if(ipass.eq.1 .or. ipass.eq.4 .or. ipass.eq.7) then; lpass1=.true.
    else if(ipass.eq.2 .or. ipass.eq.5 .or. ipass.eq.8) then; lpass2=.true.
    endif
  endif
  call indexx(red(ia:ib),iz,indx)
  do i=1,iz
    n=ia + indx(iz+1-i) - 1
    freq=n*df
    if(abs(freq-nfqso).gt.3.0) then
      if (red(n).lt.syncmin) cycle
    else
      if (red(n).lt.1.1) cycle
    endif
    if(swl) then
      if(jpeak(n).lt.-74 .or. jpeak(n).gt.101) cycle
    else
      if(jpeak(n).lt.-49 .or. jpeak(n).gt.76) cycle
    endif
    if(k.lt.450) then; k=k+1; else; exit; endif
! being sorted by sync
    candidate0(1,k)=freq
    candidate0(2,k)=(jpeak(n)-1)*tstep
    candidate0(3,k)=red(n)
    if(rcandthin.lt.0.99) then ! candidate thinning option
      if(lpass2) then
        candidate0(5,k)=candidate0(3,k)/(abs(candidate0(2,k)-dtcenter)+1.0)**2
      else
        candidate0(5,k)=candidate0(3,k)/(abs(candidate0(2,k)-dtcenter)+1.0)
      endif
    endif
    if(redcq(n)) candidate0(4,k)=2.
  enddo
  ncand=k

  fdif0=4.0; if(swl) fdif0=3.0
  xdtdelta=0.0
! save sync only to the best of near-dupe freqs 
  do i=1,ncand
    if(i.ge.2) then
      do j=1,i-1
        fdiff=abs(candidate0(1,i)-candidate0(1,j))
        xdtdelta=abs(candidate0(2,i)-candidate0(2,j))
        if(fdiff.lt.fdif0 .and. abs(candidate0(1,i)-nfqso).gt.3.0) then
          if(xdtdelta.lt.0.1) then
            if(candidate0(3,i).ge.candidate0(3,j)) candidate0(3,j)=0.
            if(candidate0(3,i).lt.candidate0(3,j)) candidate0(3,i)=0.
          endif
        endif
      enddo
!        write(*,3001) i,candidate0(1,i-1),candidate0(1,i),candidate0(3,i-1),  &
!             candidate0(3,i)
!3001    format(i2,4f8.1)
    endif
  enddo

! Sort by sync
!  call indexx(candidate0(3,1:ncand),ncand,indx)
  if(rcandthin.gt.0.99) then; call indexx(candidate0(3,1:ncand),ncand,indx)
! sort by sync value with DT weight
  else; call indexx(candidate0(5,1:ncand),ncand,indx)
  endif
! Sort by frequency 
!  call indexx(candidate0(1,1:ncand),ncand,indx)

  k=1; ncandfqso=0
!Put nfqso at top of list and apply lowest sync threshold for nfqso
  fprev=5004.
  do i=ncand,1,-1
    j=indx(i)
    if(abs(candidate0(1,j)-nfqso).le.3.0 .and. candidate0(3,j).ge.1.1 .and. abs(candidate0(1,j)-fprev).gt.3.0) then
      candidate(1,k)=candidate0(1,j); candidate(2,k)=candidate0(2,j)
      candidate(3,k)=candidate0(3,j); candidate(4,k)=candidate0(4,j)
      fprev=candidate0(1,j)
      k=k+1; ncandfqso=ncandfqso+1
    endif
  enddo

!put virtual candidates for FT8S decoder
  if(lqsothread) then
    candidate(1,k)=float(nfqso)
    candidate(2,k)=5.0 ! xdt
    candidate(3,k)=0.0 ! sync
    k=k+1; ncandfqso=ncandfqso+1
    candidate(1,k)=float(nfqso)
    candidate(2,k)=-5.0
    candidate(3,k)=0.0
    k=k+1; ncandfqso=ncandfqso+1
  endif

  do i=ncand,1,-1
    j=indx(i)
    if(abs(candidate0(1,j)-nfqso).gt.3.0) then; syncmin1=syncmin; else; syncmin1=1.1; endif
    if(candidate0(3,j) .ge. syncmin1) then
      candidate(1,k)=candidate0(1,j); candidate(2,k)=candidate0(2,j)
      candidate(3,k)=candidate0(3,j); candidate(4,k)=candidate0(4,j)
      k=k+1
      if(k.gt.460) exit 
    endif
  enddo
  ncand=k-1
  if(ncand-ncandfqso.gt.1 .and. rcandthin.lt.0.99) then
! applying decoding pass weight factor, derived from number of candidates in each pass
    if(lpass1) then; rcandthin=min(rcandthin*1.27,1.0)
    else if(lpass2) then
      if(rcandthin.gt.0.79) then; rcandthin=rcandthin**2
      else; rcandthin=rcandthin*0.79
      endif
    else; rcandthin=min(rcandthin*5.0,1.0) ! ipass 3,6,9
    endif
    ncand=ncandfqso+nint((ncand-ncandfqso)*rcandthin)
  endif

  return
end subroutine sync8

! This source code file was last time modified by Igor UA3DJY on February 6th, 2017
! All changes are shown in the patch file coming together with the full JTDX source code.

subroutine splitdupecq(decoded,callcq)
  
  
  character decoded*22,callcq*6

  i1=index(decoded,' ')
  i2=index(decoded(i1+1:),' ')

  if(i2.eq.3) then ! directional CQ message
     i2=i2+i1
     i3=index(decoded(i2+1:),' ')
     i3=i3+i2
if(len_trim(decoded(i2+1:i3-1)).gt.6) go to 2
     callcq=decoded(i2+1:i3-1)
     go to 2
  endif

  if(i2.gt.3) then ! non-directional CQ message
     i2=i2+i1
     callcq=decoded(i1+1:i2-1)
  endif

2 return
end subroutine splitdupecq

! This source code file was last time modified by Igor UA3DJY on 20190708
! All changes are shown in the patch file coming together with the full JTDX source code.

subroutine gen_ft8wavesub(itone,f0,cwave)

  use ft8_mod1, only : twopi,dt

  parameter(NSYM=79,NSPS=1920,NFRAME=151680)
  complex cwave(nframe)
  real pulse(23040)
  real dphi(0:155519) ! (0:(nsym+2)*nsps-1)
  integer itone(79)
  data ibt0/0/
  save pulse,hmod,ibt0
  
  bt=4.0 ! Temporary compromise?
  ibt=nint(10*bt)
  if(ibt0.ne.ibt) then
     hmod=1.0
! Compute the frequency-smoothing pulse
     do i=1,5760 ! 3*nsps
        tt=(i-2880)/real(nsps) ! (i-1.5*nsps)
        pulse(i)=gfsk_pulse(bt,tt)
     enddo
     ibt0=nint(10*bt)
  endif

! Compute the smoothed frequency waveform.
! Length = (nsym+2)*nsps samples, first and last symbols extended 
  dphi_peak=twopi*hmod/real(nsps)
  dphi=0.0 
  do j=1,nsym       
     ib=(j-1)*nsps
     ie=ib+5759 ! +3*nsps-1
     dphi(ib:ie) = dphi(ib:ie) + dphi_peak*pulse(1:5760)*itone(j) ! pulse(1:3*nsps)
  enddo
! Add dummy symbols at beginning and end with tone values equal to 1st and last symbol, respectively
!  dphi(0:2*nsps-1)=dphi(0:2*nsps-1)+dphi_peak*itone(1)*pulse(nsps+1:3*nsps)
  dphi(0:3839)=dphi(0:3839)+dphi_peak*itone(1)*pulse(1921:5760)

!  dphi(nsym*nsps:(nsym+2)*nsps-1)=dphi(nsym*nsps:(nsym+2)*nsps-1)+dphi_peak*itone(nsym)*pulse(1:2*nsps)
  dphi(nframe:155519)=dphi(nframe:155519)+dphi_peak*itone(nsym)*pulse(1:3840)

! Calculate and insert the audio waveform
  phi=0.0
  dphi = dphi + twopi*f0*dt                          !Shift frequency up by f0
  cwave=0. ! avoid writing to memory we may not have access to
  k=0
  do j=nsps,153599 ! nsps+ nframe(151680) -1   Don't include dummy symbols
    k=k+1
    cwave(k)=cmplx(cos(phi),sin(phi))
    phi=mod(phi+dphi(j),twopi)
  enddo

! Apply envelope shaping to the first and last symbols
  nramp=240 ! =nint(nsps/8.0)
  cwave(1:nramp)=cwave(1:nramp) * (1.0-cos(twopi*(/(i,i=0,nramp-1)/)/(2.0*nramp)))/2.0
!  k1=nsym*nsps-nramp+1 == 151441
!  cwave(k1:k1+nramp-1)=cwave(k1:k1+nramp-1) * (1.0+cos(twopi*(/(i,i=0,nramp-1)/)/(2.0*nramp)))/2.0
  cwave(151441:nframe)=cwave(151441:nframe) * (1.0+cos(twopi*(/(i,i=0,nramp-1)/)/(2.0*nramp)))/2.0

  return
end subroutine gen_ft8wavesub

! This file was last time modified by Igor UA3DJY on 20181215
! All changes are shown in the patch file coming together with the full JTDX source code.

subroutine hintdyn(mrs,mrs2,call1,call2,grid2,decoded,hint_dyn,inverse,nlastrx)

  use packjt
  use jt65_mod2, only : s3,correct_hint
  parameter (MAXRPT=33,IMAXRPT=30,IMAXRPT73=3)
  parameter (MAXMSG=MAXRPT)
  real u1
  integer nlastrx
  integer sym2(0:62,MAXMSG),mrs(63),mrs2(63),dgen(12),sym_rev(0:62)
  logical(1) hint_dyn,inverse
  character grid2*4,call1*6,call2*6,msg*22,msg1*22,msg00*22,decoded*22
  character*3 irpt(IMAXRPT)
  character*4 irrpt(IMAXRPT),i73(IMAXRPT73),rpt(MAXRPT),rrpt(MAXRPT),rrptgrid((MAXRPT-1))
  character*22 msg0(MAXMSG)



  data irpt/'-01','-02','-03','-04','-05',         &
           '-06','-07','-08','-09','-10',          &
           '-11','-12','-13','-14','-15',          &
           '-16','-17','-18','-19','-20',          &
           '-21','-22','-23','-24','-25',          &
           '-26','-27','-28','-29','-30'/

  data irrpt/'R-01','R-02','R-03','R-04','R-05',   &
            'R-06','R-07','R-08','R-09','R-10',    &
            'R-11','R-12','R-13','R-14','R-15',    &
            'R-16','R-17','R-18','R-19','R-20',    &
            'R-21','R-22','R-23','R-24','R-25',    &
            'R-26','R-27','R-28','R-29','R-30'/

  data i73/'RRR','73','RR73'/

  data rpt/'-01','-02','-03','-04','-05',          &
           '-06','-07','-08','-09','-10',          &
           '-11','-12','-13','-14','-15',          &
           '-16','-17','-18','-19','-20',          &
           '-21','-22','-23','-24','-25',          &
           '-26','-27','-28','-29','-30',          &
           'RRR','73','RR73'/

  data rrpt/'R-01','R-02','R-03','R-04','R-05',    &
            'R-06','R-07','R-08','R-09','R-10',    &
            'R-11','R-12','R-13','R-14','R-15',    &
            'R-16','R-17','R-18','R-19','R-20',    &
            'R-21','R-22','R-23','R-24','R-25',    &
            'R-26','R-27','R-28','R-29','R-30',    &
            'RRR','73','RR73'/

  data rrptgrid/'R-01','R-02','R-03','R-04','R-05',&
            'R-06','R-07','R-08','R-09','R-10',    &
            'R-11','R-12','R-13','R-14','R-15',    &
            'R-16','R-17','R-18','R-19','R-20',    &
            'R-21','R-22','R-23','R-24','R-25',    &
            'R-26','R-27','R-28','R-29','R-30',    &
            'HQ02','HQ03'/

   save irpt,irrpt,i73,rpt,rrpt,rrptgrid

! nlastrx last received message matrix, used for wideband hintdyn decoder, dynhint(300) structure
! nlastrx   last RX message   / dinterval1 expected inversed msg / dinterval2 expected RX message
!   0           initialization/               none              / none
!   1           GRID          /               -01               / R-01, and might be again GRID
!   2           -01           /               R-01              / RRR/RR73/73, and might be again -01
!   3           R-01          /               RRR/RR73/73       / RRR/RR73/73,  and might be again R-01
!   4           RRR/RR73/73   /               RRR/RR73/73       / none


  hint_dyn=.false.
 
  if(nlastrx.lt.1 .or. nlastrx.gt.4) return

  do i=1,6
     if(call1(i:i).eq.'/') return
     if(call2(i:i).eq.'/') return
  enddo

  if(inverse) then
     if(nlastrx.eq.1) then ! expected -01 message
        do m=1,IMAXRPT
          msg=trim(call1)//' '//trim(call2)//' '//irpt(m)
          call fmtmsg(msg,iz)
          call packmsg(msg,dgen,itype)            !Pack message into 72 bits
          call rs_encode(dgen,sym_rev)            !RS encode
          call interleave63(sym_rev,1)            !Interleave channel symbols
          call graycode(sym_rev,63,1,sym_rev)     !Apply Gray code
          sym2(0:62,m)=sym_rev(0:62)
          msg0(m)=msg
        enddo
     endif

     if(nlastrx.eq.2) then! expected R-01 message
        do m=1,IMAXRPT
          msg=trim(call1)//' '//trim(call2)//' '//irrpt(m)
          call fmtmsg(msg,iz)
          call packmsg(msg,dgen,itype)            !Pack message into 72 bits
          call rs_encode(dgen,sym_rev)            !RS encode
          call interleave63(sym_rev,1)            !Interleave channel symbols
          call graycode(sym_rev,63,1,sym_rev)     !Apply Gray code
          sym2(0:62,m)=sym_rev(0:62)
          msg0(m)=msg
        enddo
     endif
  
     if(nlastrx.ge.3) then! expected RRR/RR73/73 message
        do m=1,IMAXRPT73
          msg=trim(call1)//' '//trim(call2)//' '//i73(m)
          call fmtmsg(msg,iz)
          call packmsg(msg,dgen,itype)            !Pack message into 72 bits
          call rs_encode(dgen,sym_rev)            !RS encode
          call interleave63(sym_rev,1)            !Interleave channel symbols
          call graycode(sym_rev,63,1,sym_rev)     !Apply Gray code
          sym2(0:62,m)=sym_rev(0:62)
          msg0(m)=msg
        enddo

       do m=4,IMAXRPT73+7
          msg='UF0XYZ W9XYZ '//'EN3'//achar(47+m)
          call fmtmsg(msg,iz)
          call packmsg(msg,dgen,itype)            !Pack message into 72 bits
          call rs_encode(dgen,sym_rev)            !RS encode
          call interleave63(sym_rev,1)            !Interleave channel symbols
          call graycode(sym_rev,63,1,sym_rev)     !Apply Gray code
          sym2(0:62,m)=sym_rev(0:62)
          msg0(m)=msg
       enddo
     endif
  endif


  if(.not.inverse) then
     if(nlastrx.lt.1 .or. nlastrx.gt.3) return

     if(nlastrx.eq.1) then ! expected R-01, and might be again GRID message
        do m=1,MAXMSG
          if(m.eq.1) msg=trim(call1)//' '//trim(call2)//' '//grid2
          if(m.ge.2) msg=trim(call1)//' '//trim(call2)//' '//rrptgrid(m-1)
          call fmtmsg(msg,iz)
          call packmsg(msg,dgen,itype)            !Pack message into 72 bits
          call rs_encode(dgen,sym_rev)            !RS encode
          call interleave63(sym_rev,1)            !Interleave channel symbols
          call graycode(sym_rev,63,1,sym_rev)     !Apply Gray code
          sym2(0:62,m)=sym_rev(0:62)
          msg0(m)=msg
        enddo
     endif

     if(nlastrx.eq.2) then! expected RRR/RR73/73, and might be again -01 message
        do m=1,MAXMSG
          msg=trim(call1)//' '//trim(call2)//' '//rpt(m)
          call fmtmsg(msg,iz)
          call packmsg(msg,dgen,itype)            !Pack message into 72 bits
          call rs_encode(dgen,sym_rev)            !RS encode
          call interleave63(sym_rev,1)            !Interleave channel symbols
          call graycode(sym_rev,63,1,sym_rev)     !Apply Gray code
          sym2(0:62,m)=sym_rev(0:62)
          msg0(m)=msg
        enddo
     endif
  
     if(nlastrx.eq.3) then! expected RRR/RR73/73,  and might be again R-01 message
        do m=1,MAXMSG
          msg=trim(call1)//' '//trim(call2)//' '//rrpt(m)
          call fmtmsg(msg,iz)
          call packmsg(msg,dgen,itype)            !Pack message into 72 bits
          call rs_encode(dgen,sym_rev)            !RS encode
          call interleave63(sym_rev,1)            !Interleave channel symbols
          call graycode(sym_rev,63,1,sym_rev)     !Apply Gray code
          sym2(0:62,m)=sym_rev(0:62)
          msg0(m)=msg
        enddo
     endif
  endif

  ref0=0.
  do i=1,63
     do j=1,63
        ref0=ref0 + s3(mrs(j)+1,i)
     enddo
  enddo

  u1=-99.0
  u2=u1

! Find u1 and u2 (best and second-best) codeword from a list, using 
! a bank of matched filters on the symbol spectra s3(i,j).
  ipk=1
  msg00='                      '

  if(inverse) then
     if(nlastrx.le.2) maxmsgs=IMAXRPT
     if(nlastrx.ge.3) maxmsgs=IMAXRPT73+7
  endif
  if(.not.inverse) then
     maxmsgs=MAXMSG
  endif

  do k=1,maxmsgs
     psum=0.
     ref=ref0
     do j=1,63
        i=sym2(j-1,k)+1
        psum=psum + s3(i,j)
        if(i.eq.mrs(j)+1) ref=ref - s3(i,j) + s3(mrs2(j)+1,j)
     enddo
     p=psum*63.0/ref

     if(p.gt.u1) then
        if(msg0(k).ne.msg00) u2=u1
        u1=p
        ipk=k
        msg00=msg0(k)
     endif
     if(msg0(k).ne.msg00 .and. p.gt.u2) u2=p
  enddo

  decoded='                      '

  msg1=msg0(ipk)
!print*, inverse, msg1
  if(.not.inverse) then
     do i=9,15
        if(msg1(i:i+2).eq.'HQ0') go to 4
     enddo
  endif

  if(inverse .and. nlastrx.gt.2 .and. msg1(1:6).eq."UF0XYZ") go to 4

  bias=max(1.12*u2,0.35)
  qual=100.0*(u1-bias)
  thresh=(qual+20.0)*(u1-1.0)
  qmin=-2.0
  if(inverse) qmin=0.0
  
  
!if(.not.inverse .and. nlastrx.eq.3) then
!write(6,1010) qual,u1,thresh
!1010 format(f7.2,1x,f6.2,1x,f6.2)
!print *,msg0(ipk)
!endif

  if(inverse .and. nlastrx.gt.2) then
     if(qual.ge.8.0 .or. u1.ge.1.33) then
        decoded=msg0(ipk)
        hint_dyn=.true.
!write(6,1010) qual,u1,thresh
!1010 format(f6.2,1x,f5.3,1x,f5.2)
        correct_hint(1:63)=sym2(0:62,ipk)
     endif
  else
     if((qual.ge.qmin .or. u1.ge.1.4) .and. thresh.gt.6.5) then
        decoded=msg0(ipk)
        hint_dyn=.true.
!write(6,1010) qual,u1,thresh
!1010 format(f6.2,1x,f5.3,1x,f5.2)
        correct_hint(1:63)=sym2(0:62,ipk)
     endif
  endif

4 return
end subroutine hintdyn

subroutine ft8apset(lmycallstd,lhiscallstd,numthreads)

  use packjt77
  use ft8_mod1, only : apsym,mycall,hiscall,apsymsp,lhound,apsymdxns1,apsymdxnsrrr,mybcall,hisbcall,apcqsym,hisgrid4,     &
                       apsymdxnsrr73,apsymdxns73,apsymmyns1,apsymmyns2,apsymmynsrr73,apsymmyns73,apsymdxstd,apsymdxnsr73, &
                       apsymdxns732,apsymmynsrrr
  character*77 c77
  character*37 msg,msgchk
  character*12 hiscallt,mycallprev,hiscallprev
  logical lnohiscall,unpk77_success,first
  logical(1) lhoundprev
  logical(1), intent(in) :: lmycallstd,lhiscallstd
  data mycallprev/'QQ2QQ'/
  data hiscallprev/'QQ1QQ'/
  data lhoundprev/.false./
  data first/.true./
  save hiscallprev,mycallprev,lhoundprev,first

  if(hiscall.ne.hiscallprev .or. mycall.ne.mycallprev .or. (lhound.neqv.lhoundprev) .or. first) then ! first for lhound triggered

    first=.false.; mycallprev=mycall; lhoundprev=lhound

! shall hash both callsigns for making AP masks with nonstandard callsign message
    if(.not.lhound) call fillhash(numthreads,.true.)

    lnohiscall=.false.
    hiscallt=hiscall
    if(len_trim(hiscallt).lt.3) then
      hiscallt=mycall  ! use mycall for dummy hiscall - mycall won't be hashed
      lnohiscall=.true.
    endif

    if(hiscall.ne.hiscallprev) then
      hiscallprev=hiscall
! Encode a dummy standard message: i3=1, 28 1 28 1 1 15
      if(len_trim(hiscall).gt.2) then
        if(lhiscallstd .and. len_trim(hisgrid4).eq.4) then; msg='CQ '//trim(hiscall)//' '//trim(hisgrid4)
        else; msg='CQ '//trim(hiscall)
        endif

        call pack77(msg,i3,n3,c77,0)
        call unpack77(c77,1,msgchk,unpk77_success,25)
!read(c77(75:77),'(b3)') k3; print *,'i3 =',k3; print *,msgchk
        if(lhiscallstd .and. i3.ne.1 .or. .not.lhiscallstd .and. i3.ne.4 .or. (msg.ne.msgchk) .or. .not.unpk77_success) go to 1
        read(c77,'(77i1)',err=1) apcqsym(1:77)
        apcqsym=2*apcqsym-1
      endif

      if(lhiscallstd .and. .not.lmycallstd) then
        msg=trim(hiscall)//' '//trim(hiscall)//' RRR'
        i3=0; n3=0
        call pack77(msg,i3,n3,c77,0)
        call unpack77(c77,1,msgchk,unpk77_success,25)
!read(c77(75:77),'(b3)') k3; print *,'i3 =',k3; print *,msgchk
        if(i3.ne.1 .or. (msg.ne.msgchk) .or. .not.unpk77_success) go to 2
        read(c77,'(58i1)',err=2) apsymdxstd(1:58)
        apsymdxstd=2*apsymdxstd-1
      endif

      if(.not.lhound .and. .not.lhiscallstd .and. len_trim(hiscall).gt.2) then
! nonstandard DXCall searching
        msg='<W9XYZ> '//trim(hiscall)//' RR73'
        call pack77(msg,i3,n3,c77,0)
        call unpack77(c77,1,msgchk,unpk77_success,25)
!read(c77(75:77),'(b3)') k3; print *,'i3 =',k3; print *,msgchk
        if(i3.ne.4 .or. .not.unpk77_success) go to 3
        read(c77,'(77i1)',err=3) apsymdxnsrr73(1:77)
        apsymdxnsrr73=2*apsymdxnsrr73-1

        msg='<W9XYZ> '//trim(hiscall)//' 73'
        call pack77(msg,i3,n3,c77,0)
        call unpack77(c77,1,msgchk,unpk77_success,25)
!read(c77(75:77),'(b3)') k3; print *,'i3 =',k3; print *,msgchk
        if(i3.ne.4 .or. .not.unpk77_success) go to 4
        read(c77,'(77i1)',err=4) apsymdxns73(1:77)
        apsymdxns73=2*apsymdxns73-1
      endif
    endif

    if(.not.lhound .and. .not.lmycallstd .and. len_trim(mycall).gt.2) then
      if(lhiscallstd) then
        msg='<'//trim(mycall)//'> '//trim(hiscall)//' -15'
        call pack77(msg,i3,n3,c77,0)
        call unpack77(c77,1,msgchk,unpk77_success,25)
        if(i3.ne.1 .or. msg.ne.msgchk .or. .not.unpk77_success) go to 5
        read(c77,'(58i1)',err=5) apsymmyns2(1:58)
        apsymmyns2=2*apsymmyns2-1

        nlenmyc=len_trim(mycall)
        msg=trim(mycall)//' <'//trim(hiscall)//'> RR73'
        call pack77(msg,i3,n3,c77,0)
        call unpack77(c77,1,msgchk,unpk77_success,25)
        if(i3.ne.4 .or. msg.ne.msgchk .or. .not.unpk77_success) go to 6
        read(c77,'(77i1)',err=6) apsymmynsrr73(1:77)
        apsymmynsrr73=2*apsymmynsrr73-1
        msg=trim(mycall)//' <'//trim(hiscall)//'> 73'
        call pack77(msg,i3,n3,c77,0)
        call unpack77(c77,1,msgchk,unpk77_success,25)
        if(i3.ne.4 .or. msg.ne.msgchk .or. .not.unpk77_success) go to 7
        read(c77,'(77i1)',err=7) apsymmyns73(1:77)
        apsymmyns73=2*apsymmyns73-1
        msg=trim(mycall)//' <'//trim(hiscall)//'> RRR'
        call pack77(msg,i3,n3,c77,0)
        call unpack77(c77,1,msgchk,unpk77_success,25)
        if(i3.ne.4 .or. msg.ne.msgchk .or. .not.unpk77_success) go to 15
        read(c77,'(77i1)',err=15) apsymmynsrrr(1:77)
        apsymmynsrrr=2*apsymmynsrrr-1

      else if(lnohiscall) then

        msg='<'//trim(mycall)//'> ZZ1ZZZ -15'
        call pack77(msg,i3,n3,c77,0)
        call unpack77(c77,1,msgchk,unpk77_success,25)
        if(i3.ne.1 .or. msgchk.ne.msg .or. .not.unpk77_success) go to 8
        read(c77,'(29i1)',err=8) apsymmyns1(1:29)
        apsymmyns1=2*apsymmyns1-1
      endif
    endif

    if(len_trim(mycall).lt.3) return

    if(.not.lhound .and. lmycallstd .and. (lhiscallstd .or. lnohiscall)) then
      msg=trim(mycall)//' '//trim(hiscallt)//' RRR'
      i3=0; n3=0
      call pack77(msg,i3,n3,c77,0)
      call unpack77(c77,1,msgchk,unpk77_success,25)
!read(c77(75:77),'(b3)') k3; print *,'i3 =',k3; print *,msgchk
      if(i3.ne.1 .or. (msg.ne.msgchk) .or. .not.unpk77_success) go to 9
      read(c77,'(58i1)',err=9) apsym(1:58)
      apsym=2*apsym-1; if(lnohiscall) apsym(30)=99
    endif

    if(lhound) then
! standard messages from Fox, always base callsigns
      if(len_trim(hisbcall).gt.2 .and. len_trim(mybcall).gt.2) then
        msg=trim(mybcall)//' '//trim(hisbcall)//' -15'
        call pack77(msg,i3,n3,c77,0)
        call unpack77(c77,1,msgchk,unpk77_success,25)
!read(c77(75:77),'(b3)') k3; print *,'i3 =',k3; print *,msgchk
        if(i3.ne.1 .or. (msg.ne.msgchk) .or. .not.unpk77_success) go to 9
        read(c77,'(58i1)',err=9) apsym(1:58)
        apsym=2*apsym-1
      else
        apsym(30)=99
      endif

! special messages
      msg=trim(mycall)//' RR73; '//trim(mycall)//' <'//trim(hiscallt)//'> -16'
      i3=0; n3=1
      call pack77(msg,i3,n3,c77,0)
      call unpack77(c77,1,msgchk,unpk77_success,25)
!read(c77(75:77),'(b3)') k3; print *,'i3 =',k3; print *,msgchk
      i1=0; i1=index(msgchk,'<'); if(i1.lt.15) return
      if(i3.ne.0 .or. msg(1:i1).ne.msgchk(1:i1) .or. .not.unpk77_success) go to 10
      read(c77,'(66i1)',err=10) apsymsp(1:66)
      apsymsp=2*apsymsp-1!; if(lnohiscall) apsymsp(30)=99
    endif

    if(.not.lhound .and. lmycallstd .and. .not.lhiscallstd .and. len_trim(hiscall).gt.2) then
      msg=trim(mycall)//' <'//trim(hiscall)//'> -16' ! report, rreport
      call pack77(msg,i3,n3,c77,0)
      call unpack77(c77,1,msgchk,unpk77_success,25)
!read(c77(75:77),'(b3)') k3; print *,'i3 =',k3; print *,msgchk
      if(i3.ne.1 .or. msg.ne.msgchk .or. .not.unpk77_success) go to 11
      read(c77,'(58i1)',err=11) apsymdxns1(1:58)
      apsymdxns1=2*apsymdxns1-1

      msg='<'//trim(mycall)//'> '//trim(hiscall)//' RRR'
      call pack77(msg,i3,n3,c77,0)
      call unpack77(c77,1,msgchk,unpk77_success,25)
!read(c77(75:77),'(b3)') k3; print *,'i3 =',k3; print *,msgchk
      if(i3.ne.4 .or. msg.ne.msgchk .or. .not.unpk77_success) go to 12
      read(c77,'(77i1)',err=12) apsymdxnsrrr(1:77)
      apsymdxnsrrr=2*apsymdxnsrrr-1

      msg='<'//trim(mycall)//'> '//trim(hiscall)//' RR73'
      call pack77(msg,i3,n3,c77,0)
      call unpack77(c77,1,msgchk,unpk77_success,25)
!read(c77(75:77),'(b3)') k3; print *,'i3 =',k3; print *,msgchk
      if(i3.ne.4 .or. msg.ne.msgchk .or. .not.unpk77_success) go to 13
      read(c77,'(77i1)',err=13) apsymdxnsr73(1:77)
      apsymdxnsr73=2*apsymdxnsr73-1

      msg='<'//trim(mycall)//'> '//trim(hiscall)//' 73'
      call pack77(msg,i3,n3,c77,0)
      call unpack77(c77,1,msgchk,unpk77_success,25)
!read(c77(75:77),'(b3)') k3; print *,'i3 =',k3; print *,msgchk
      if(i3.ne.4 .or. msg.ne.msgchk .or. .not.unpk77_success) go to 14
      read(c77,'(77i1)',err=14) apsymdxns732(1:77)
      apsymdxns732=2*apsymdxns732-1
    endif

  endif

  go to 32

1 apcqsym=0; apcqsym(1)=99; apcqsym(30)=99; go to 32
2 apsymdxstd=0; apsymdxstd(1)=99; apsymdxstd(30)=99; go to 32
3 apsymdxnsrr73=0; apsymdxnsrr73(1)=99; apsymdxnsrr73(30)=99; go to 32
4 apsymdxns73=0; apsymdxns73(1)=99; apsymdxns73(30)=99; go to 32
5 apsymmyns2=0; apsymmyns2(1)=99; apsymmyns2(30)=99; go to 32
6 apsymmynsrr73=0; apsymmynsrr73(1)=99; apsymmynsrr73(30)=99; go to 32
7 apsymmyns73=0; apsymmyns73(1)=99; apsymmyns73(30)=99; go to 32
8 apsymmyns1=0; apsymmyns1(1)=99; go to 32
9 apsym=0; apsym(1)=99; apsym(30)=99; go to 32
10 apsymsp=0; apsymsp(1)=99; apsymsp(30)=99; go to 32
11 apsymdxns1=0; apsymdxns1(1)=99; apsymdxns1(30)=99; go to 32
12 apsymdxnsrrr=0; apsymdxnsrrr(1)=99; apsymdxnsrrr(30)=99; go to 32
13 apsymdxnsr73=0; apsymdxnsr73(1)=99; apsymdxnsr73(30)=99; go to 32
14 apsymdxns732=0; apsymdxns732(1)=99; apsymdxns732(30)=99; go to 32
15 apsymmynsrrr=0; apsymmynsrrr(1)=99; apsymmynsrrr(30)=99; go to 32

32 continue

  return
end subroutine ft8apset

subroutine chklong8(callsign,falsedec)

  parameter (NMASK10=9,NMASK11=7)
  character callsign*12,callmask*12
  logical(1) falsedec
  character*12 mask10(NMASK10),mask11(NMASK11)
  data mask10/'0011000000  ','0011100000  ','0011110000  ','1011000000  ','1011100000  ','1011110000  ', &
              '0010000000  ','1010000000  ','0110000000  '/
  data mask11/'00111000000 ','00111100000 ','10111000000 ','10111100000 ','00100000000 ','01100000000 ','10100000000 '/

! <...> I78PY2MTFLF RR73    
! <...> CM5XFIVGPIP RR73  
! WG0XC120LS9 <...> RR73    
! <...> A7MNPJDX/QO RRR   TODO list
! CQ P2PSR6UWBHS

!valid masks for 11-char callsign:
! DL2019ABCDE TC630ABCDEF 9A200ABCDEF 9A2019ABCDE ZW5STAYHOME Z39STAYHOME 5B4STAYHOME
! 00111100000 00111000000 10111000000 10111100000 00100000000 01100000000 10100000000
  callmask=''
! need to exclude 8J/8N/8K Japanese callsigns from checking
  if(index(callsign,'/').lt.1 .and. callsign(1:2).ne.'8J' .and. callsign(1:2).ne.'8N') then
    if(len_trim(callsign).eq.10) then
      do i=1,10
        if(callsign(i:i).gt.'/' .and. callsign(i:i).lt.':') then; callmask(i:i)='1'; else; callmask(i:i)='0'; endif
      enddo
!print *,callsign,callmask
      falsedec=.true.
      do i=1,NMASK10
        if(callmask.eq.mask10(i)) then; falsedec=.false.; return; endif 
      enddo
    endif
    if(len_trim(callsign).eq.11) then
      do i=1,11
        if(callsign(i:i).gt.'/' .and. callsign(i:i).lt.':') then; callmask(i:i)='1'; else; callmask(i:i)='0'; endif
      enddo
!print *,callsign,callmask
      falsedec=.true.
      do i=1,NMASK11
        if(callmask.eq.mask11(i)) then; falsedec=.false.; return; endif 
      enddo
    endif
  endif

  return
end subroutine chklong8

! This source code file was last time modified by Igor Chernikov UA3DJY on May 25th, 2016.
! All changes are shown in the file 15_6.patch coming together with the full JTDX source code.

subroutine ccf65(ss,nhsym,ssmax,sync1,dt1,flipk,syncshort,snr2,dt2)

  parameter (NFFT=512,NH=NFFT/2)
  real ss(322)                     !Input: half-symbol normalized powers
  real s(NFFT)                     !CCF = ss*pr
  complex cs(0:NH)                 !Complex FT of s
  real s2(NFFT)                    !CCF = ss*pr2
  complex cs2(0:NH)                !Complex FT of s2
  real pr(NFFT)                    !JT65 pseudo-random sync pattern
  complex cpr(0:NH)                !Complex FT of pr
  real pr2(NFFT)                   !JT65 shorthand pattern
  complex cpr2(0:NH)               !Complex FT of pr2
  real tmp1(322)
  real ccf(-11:54)
  logical first
  integer npr(126)
  data first/.true./
  equivalence (s,cs),(pr,cpr),(s2,cs2),(pr2,cpr2)
  save

! The JT65 pseudo-random sync pattern:
  data npr/                                        &
      1,0,0,1,1,0,0,0,1,1,1,1,1,1,0,1,0,1,0,0,     &
      0,1,0,1,1,0,0,1,0,0,0,1,1,1,0,0,1,1,1,1,     &
      0,1,1,0,1,1,1,1,0,0,0,1,1,0,1,0,1,0,1,1,     &
      0,0,1,1,0,1,0,1,0,1,0,0,1,0,0,0,0,0,0,1,     &
      1,0,0,0,0,0,0,0,1,1,0,1,0,0,1,0,1,1,0,1,     &
      0,1,0,1,0,0,1,1,0,0,1,0,0,1,0,0,0,0,1,1,     &
      1,1,1,1,1,1/


  if(first) then
! Initialize pr, pr2; compute cpr, cpr2.
     fac=1.0/NFFT
     do i=1,NFFT
        pr(i)=0.
        pr2(i)=0.
        k=2*mod((i-1)/8,2)-1
        if(i.le.NH) pr2(i)=fac*k
     enddo
     do i=1,126
        j=2*i
        pr(j)=fac*(2*npr(i)-1)
! Not sure why, but it works significantly better without the following line:
     !pr(j-1)=pr(j)
     enddo
     call four2a(cpr,NFFT,1,-1,0)
     call four2a(cpr2,NFFT,1,-1,0)
     first=.false.
  endif

! Look for JT65 sync pattern and shorthand square-wave pattern.
  ccfbest=0.
  ccfbest2=0.
  do i=1,nhsym-1
     s(i)=min(ssmax,ss(i)+ss(i+1))
!     s(i)=ss(i)+ss(i+1)
  enddo

  call pctile(s,nhsym-1,50,base)
  s(1:nhsym-1)=s(1:nhsym-1)-base
  s(nhsym:NFFT)=0.
  call four2a(cs,NFFT,1,-1,0)               !Real-to-complex FFT
  do i=0,NH
!     cs2(i)=cs(i)*conjg(cpr2(i))            !Mult by complex FFT of pr2
     cs(i)=cs(i)*conjg(cpr(i))              !Mult by complex FFT of pr
  enddo
  call four2a(cs,NFFT,1,1,-1)               !Complex-to-real inv-FFT
!  call four2a(cs2,NFFT,1,1,-1)              !Complex-to-real inv-FFT

  do lag=-11,54                             !Check for best JT65 sync
     j=lag
     if(j.lt.1) j=j+NFFT
     ccf(lag)=s(j)
!     if(abs(ccf(lag)).gt.ccfbest) then
     if(ccf(lag).gt.ccfbest) then           !No inverted sync for use at HF
!        ccfbest=abs(ccf(lag))
        ccfbest=ccf(lag)
        lagpk=lag
        flipk=1.0
!        if(ccf(lag).lt.0.0) flipk=-1.0
     endif
  enddo

!  do lag=-11,54                             !Check for best shorthand
!     ccf2=s2(lag+28)
!     if(ccf2.gt.ccfbest2) then
!        ccfbest2=ccf2
!        lagpk2=lag
!     endif
!  enddo

! Find rms level on baseline of "ccfblue", for normalization.
  sum=0.
  do lag=-11,54
     if(abs(lag-lagpk).gt.1) sum=sum + ccf(lag)
  enddo
  base=sum/50.0
  sq=0.
  do lag=-11,54
     if(abs(lag-lagpk).gt.1) sq=sq + (ccf(lag)-base)**2
  enddo
  rms=sqrt(sq/49.0)
  sync1=ccfbest/rms - 4.0
  dt1=lagpk*(2048.0/11025.0) - 2.5

! Find base level for normalizing snr2.
  do i=1,nhsym
     tmp1(i)=ss(i)
  enddo
  call pctile(tmp1,nhsym,40,base)
  snr2=0.398107*ccfbest2/base                !### empirical
  syncshort=0.5*ccfbest2/rms - 4.0           !### better normalizer than rms?
!  dt2=(2.5 + lagpk2*(2048.0/11025.0))
  dt2=0.

  return
end subroutine ccf65

! This source code file was last time modified by Igor UA3DJY on December 28th, 2016.
! All changes are shown in the patch file coming together with the full JTDX source code.

subroutine ccf2(ss,nz,ccfbest,xlagpk,lagpk)

  use jt65_mod4 ! prc(i)
!  parameter (LAGMIN=-86,LAGMAX=324)
  parameter (LAGMIN=-76,LAGMAX=382)

  real ss(nz)
  real ccf(LAGMIN:LAGMAX)

  ccfbest=0.;lagpk=0

  do lag=LAGMIN,LAGMAX
     s0=0.
     s1=0.
     do i=1,126
        j=16*(i-1)+1 + lag
        if(j.ge.1 .and. j.le.nz-8) then
           x=ss(j)
           if(.not.prc(i)) then
              s0=s0 + x
           else
              s1=s1 + x
           endif
        endif
     enddo
     ccf(lag)=s1-s0
     if(ccf(lag).gt.ccfbest) then
        ccfbest=ccf(lag)
        lagpk=lag
        xlagpk=lagpk
     endif
  enddo
  if(lagpk.gt.LAGMIN .and. lagpk.lt.LAGMAX) then
     call peakup(ccf(lagpk-1),ccf(lagpk),ccf(lagpk+1),dx)
!     if(1.0-abs(ccf(lagpk-1)/ccf(lagpk+1)).gt.0.08 .and. ccf(lagpk-1).lt.ccf(lagpk+1)) dx=0.08
!     if(1.0-abs(ccf(lagpk-1)/ccf(lagpk+1)).gt.0.08 .and. ccf(lagpk-1).gt.ccf(lagpk+1)) dx=-0.08
     xlagpk=lagpk+dx
  endif

  return
end subroutine ccf2

!
! readwav - open and read the header of a WAV format file
!
! On successful exit the file is left positioned at the start of the
! data.
!
! Example of usage:
!
!  use readwav
!  integer*2 sample
!  type(wav_header) wav
!  call wav%read ('file.wav')
!  write (*,*) 'Sample rate is: ', wav%audio_format%sample_rate
!  do i=0,wav%data_size
!    read (unit=wav%lun) sample
!    ! process sample
!  end do
!
module readwav
  implicit none

  type format_chunk
     integer*2 audio_format
     integer*2 num_channels
     integer sample_rate
     integer byte_rate
     integer*2 block_align
     integer*2 bits_per_sample
  end type format_chunk
  
  type, public :: wav_header
     integer :: lun
     type(format_chunk) :: audio_format
     integer :: data_size
   contains
     procedure :: read
  end type wav_header

  private
contains
  subroutine read (this, filename)
    implicit none

    type riff_descriptor
       character(len=4) :: id
       integer :: size
    end type riff_descriptor

    class(wav_header), intent(inout) :: this
    character(len=*), intent(in) :: filename

    integer :: filepos
    type(riff_descriptor) :: desc
    character(len=4) :: riff_type

    open (newunit=this%lun, file=filename, access='stream', form='unformatted', status='old')
    read (unit=this%lun) desc,riff_type
    inquire (unit=this%lun, pos=filepos)
    do
       read (unit=this%lun, pos=filepos) desc
       inquire (unit=this%lun, pos=filepos)
       if (desc%id .eq. 'fmt ') then
          read (unit=this%lun) this%audio_format
       else if (desc%id .eq. 'data') then
          this%data_size = desc%size
          exit
       end if
       filepos = filepos + (desc%size + 1) / 2 * 2 ! pad to even alignment
    end do
  end subroutine read
end module readwav

subroutine sync4d(cd0,i0,ctwk,itwk,sync)

! Compute sync power for a complex, downsampled FT4 signal.

  include 'ft4_params.f90'
  parameter(NP=NMAX/NDOWN,NSS=NSPS/NDOWN)
  complex cd0(0:NP-1)
  complex csynca(2*NSS),csyncb(2*NSS),csyncc(2*NSS),csyncd(2*NSS)
  complex csync2(2*NSS)
  complex ctwk(2*NSS)
  complex z1,z2,z3,z4
  logical first
  integer icos4a(0:3),icos4b(0:3),icos4c(0:3),icos4d(0:3)
  data icos4a/0,1,3,2/
  data icos4b/1,0,2,3/
  data icos4c/2,3,1,0/
  data icos4d/3,2,0,1/
  data first/.true./
  save first,twopi,csynca,csyncb,csyncc,csyncd,fac

  p(z1)=(real(z1*fac)**2 + aimag(z1*fac)**2)**0.5          !Statement function for power

  if( first ) then
    twopi=8.0*atan(1.0)
    k=1
    phia=0.0
    phib=0.0
    phic=0.0
    phid=0.0
    do i=0,3
      dphia=2*twopi*icos4a(i)/real(NSS) 
      dphib=2*twopi*icos4b(i)/real(NSS) 
      dphic=2*twopi*icos4c(i)/real(NSS) 
      dphid=2*twopi*icos4d(i)/real(NSS) 
      do j=1,NSS/2
        csynca(k)=cmplx(cos(phia),sin(phia)) 
        csyncb(k)=cmplx(cos(phib),sin(phib)) 
        csyncc(k)=cmplx(cos(phic),sin(phic)) 
        csyncd(k)=cmplx(cos(phid),sin(phid)) 
        phia=mod(phia+dphia,twopi)
        phib=mod(phib+dphib,twopi)
        phic=mod(phic+dphic,twopi)
        phid=mod(phid+dphid,twopi)
        k=k+1
      enddo
    enddo
    first=.false.
    fac=1.0/(2.0*NSS)
  endif

  i1=i0                            !four Costas arrays
  i2=i0+33*NSS
  i3=i0+66*NSS
  i4=i0+99*NSS

  z1=0.
  z2=0.
  z3=0.
  z4=0.

  if(itwk.eq.1) csync2=ctwk*csynca      !Tweak the frequency
  z1=0.
  if(i1.ge.0 .and. i1+4*NSS-1.le.NP-1) then
    z1=sum(cd0(i1:i1+4*NSS-1:2)*conjg(csync2))
  elseif( i1.lt.0 ) then
    npts=(i1+4*NSS-1)/2
    if(npts.le.16) then
      z1=0.
    else
      z1=sum(cd0(0:i1+4*NSS-1:2)*conjg(csync2(2*NSS-npts:)))
    endif
  endif

  if(itwk.eq.1) csync2=ctwk*csyncb      !Tweak the frequency
  if(i2.ge.0 .and. i2+4*NSS-1.le.NP-1) z2=sum(cd0(i2:i2+4*NSS-1:2)*conjg(csync2))

  if(itwk.eq.1) csync2=ctwk*csyncc      !Tweak the frequency
  if(i3.ge.0 .and. i3+4*NSS-1.le.NP-1) z3=sum(cd0(i3:i3+4*NSS-1:2)*conjg(csync2))

  if(itwk.eq.1) csync2=ctwk*csyncd      !Tweak the frequency
  z4=0.
  if(i4.ge.0 .and. i4+4*NSS-1.le.NP-1) then
    z4=sum(cd0(i4:i4+4*NSS-1:2)*conjg(csync2))
  elseif( i4+4*NSS-1.gt.NP-1 ) then
    npts=(NP-1-i4+1)/2
    if(npts.le.16) then
      z4=0.
    else
      z4=sum(cd0(i4:i4+2*npts-1:2)*conjg(csync2(1:npts)))
    endif
  endif

  sync = p(z1) + p(z2) + p(z3) + p(z4)

  return
end subroutine sync4d

! This source code file was last time modified by Igor UA3DJY on January 23rd, 2018
! All changes are shown in the patch file coming together with the full JTDX source code.

module jt65_mod6

  integer, parameter :: NPTS=624000
  real*4 dd(NPTS)
  integer nnmode
  save

end module jt65_mod6

! This source code file was last time modified by Igor UA3DJY on November 27th, 2017
! All changes are shown in the patch file coming together with the full JTDX source code.

module wavhdr
  type hdr
     character*4 ariff
     integer*4 lenfile
     character*4 awave
     character*4 afmt
     integer*4 lenfmt
     integer*2 nfmt2
     integer*2 nchan2
     integer*4 nsamrate
     integer*4 nbytesec
     integer*2 nbytesam2
     integer*2 nbitsam2
     character*4 adata
     integer*4 ndata
  end type hdr

  contains

    function default_header(nsamrate,npts)
      type(hdr) default_header,h
      h%ariff='RIFF'
      h%awave='WAVE'
      h%afmt='fmt '
      h%lenfmt=16
      h%nfmt2=1
      h%nchan2=1
      h%nsamrate=nsamrate
      h%nbitsam2=16
      h%nbytesam2=h%nbitsam2 * h%nchan2 / 8
      h%adata='data'
      h%nbytesec=h%nsamrate * h%nbitsam2 * h%nchan2 / 8
      h%ndata=2*npts
      h%lenfile=h%ndata + 44 - 8
      default_header=h
    end function default_header

    subroutine set_wsjtx_wav_params(fMHz,mode,nsubmode,ntrperiod,id2)

      parameter (NBANDS=23,NMODES=6)
      character*8 mode,modes(NMODES)
      integer*2 id2(4)
      integer iperiod(7)
      real fband(NBANDS)
      data fband/0.137,0.474,1.8,3.5,5.1,7.0,10.14,14.0,18.1,21.0,24.9,  &
           28.0,50.0,144.0,222.0,432.0,902.0,1296.0,2304.0,3400.0,       &
           5760.0,10368.0,24048.0/
      data modes/'JT65','T10','FT8','JT9','JT9+JT65','WSPR'/
      data iperiod/5,10,15,30,60,120,900/

      dmin=1.e30
      iband=0
      do i=1,NBANDS
         if(abs(fMHz-fband(i)).lt.dmin) then
            dmin=abs(fMHz-fband(i))
            iband=i
         endif
      enddo

      imode=0
      do i=1,NMODES
         if(mode.eq.modes(i)) imode=i
      enddo

      ip=0
      do i=1,7
         if(ntrperiod.eq.iperiod(i)) ip=i
      enddo

      id2(1)=iband
      id2(2)=imode
      id2(3)=nsubmode
      id2(4)=ip
      
      return
    end subroutine set_wsjtx_wav_params

    subroutine get_wsjtx_wav_params(id2,band,mode,nsubmode,ntrperiod,ok)

      parameter (NBANDS=23,NMODES=6)
      character*8 mode,modes(NMODES)
      character*6 band,bands(NBANDS)
      integer*2 id2(4)
      integer iperiod(7)
      logical ok
      data modes/'JT65','T10','FT8','JT9','JT9+JT65','WSPR'/
      data iperiod/5,10,15,30,60,120,900/
      data bands/'2190m','630m','160m','80m','60m','40m','30m','20m',  &
           '17m','15m','12m','10m','6m','2m','1.25m','70cm','33cm',    &
           '23cm','13cm','9cm','6cm','3cm','1.25cm'/

      ok=.true.
      if(id2(1).lt.1 .or. id2(1).gt.NBANDS) ok=.false.
      if(id2(2).lt.1 .or. id2(2).gt.NMODES) ok=.false.
      if(id2(3).lt.1 .or. id2(3).gt.8) ok=.false.
      if(id2(4).lt.1 .or. id2(4).gt.7) ok=.false.

      if(ok) then
         band=bands(id2(1))
         mode=modes(id2(2))
         nsubmode=id2(3)
         ntrperiod=iperiod(id2(4))
      endif

      return
    end subroutine get_wsjtx_wav_params

end module wavhdr

! This source code file was last time modified by Igor UA3DJY on March 12th, 2017
! All changes are shown in the patch file coming together with the full JTDX source code.

module jt9_mod1

  integer, parameter :: NPTS9=618624 ! NPTS9=597888
  real*4 dd9(0:NPTS9-1) !   integer*2 id2(0:8*npts8-1)
  save

end module jt9_mod1

! Generated automatically.  DO NOT EDIT!

  integer, parameter :: C_FFTW_R2R_KIND = C_INT32_T

  integer(C_INT), parameter :: FFTW_R2HC = 0
  integer(C_INT), parameter :: FFTW_HC2R = 1
  integer(C_INT), parameter :: FFTW_DHT = 2
  integer(C_INT), parameter :: FFTW_REDFT00 = 3
  integer(C_INT), parameter :: FFTW_REDFT01 = 4
  integer(C_INT), parameter :: FFTW_REDFT10 = 5
  integer(C_INT), parameter :: FFTW_REDFT11 = 6
  integer(C_INT), parameter :: FFTW_RODFT00 = 7
  integer(C_INT), parameter :: FFTW_RODFT01 = 8
  integer(C_INT), parameter :: FFTW_RODFT10 = 9
  integer(C_INT), parameter :: FFTW_RODFT11 = 10
  integer(C_INT), parameter :: FFTW_FORWARD = -1
  integer(C_INT), parameter :: FFTW_BACKWARD = +1
  integer(C_INT), parameter :: FFTW_MEASURE = 0
  integer(C_INT), parameter :: FFTW_DESTROY_INPUT = 1
  integer(C_INT), parameter :: FFTW_UNALIGNED = 2
  integer(C_INT), parameter :: FFTW_CONSERVE_MEMORY = 4
  integer(C_INT), parameter :: FFTW_EXHAUSTIVE = 8
  integer(C_INT), parameter :: FFTW_PRESERVE_INPUT = 16
  integer(C_INT), parameter :: FFTW_PATIENT = 32
  integer(C_INT), parameter :: FFTW_ESTIMATE = 64
  integer(C_INT), parameter :: FFTW_WISDOM_ONLY = 2097152
  integer(C_INT), parameter :: FFTW_ESTIMATE_PATIENT = 128
  integer(C_INT), parameter :: FFTW_BELIEVE_PCOST = 256
  integer(C_INT), parameter :: FFTW_NO_DFT_R2HC = 512
  integer(C_INT), parameter :: FFTW_NO_NONTHREADED = 1024
  integer(C_INT), parameter :: FFTW_NO_BUFFERING = 2048
  integer(C_INT), parameter :: FFTW_NO_INDIRECT_OP = 4096
  integer(C_INT), parameter :: FFTW_ALLOW_LARGE_GENERIC = 8192
  integer(C_INT), parameter :: FFTW_NO_RANK_SPLITS = 16384
  integer(C_INT), parameter :: FFTW_NO_VRANK_SPLITS = 32768
  integer(C_INT), parameter :: FFTW_NO_VRECURSE = 65536
  integer(C_INT), parameter :: FFTW_NO_SIMD = 131072
  integer(C_INT), parameter :: FFTW_NO_SLOW = 262144
  integer(C_INT), parameter :: FFTW_NO_FIXED_RADIX_LARGE_N = 524288
  integer(C_INT), parameter :: FFTW_ALLOW_PRUNING = 1048576

  type, bind(C) :: fftw_iodim
     integer(C_INT) n, is, os
  end type fftw_iodim
  type, bind(C) :: fftw_iodim64
     integer(C_INTPTR_T) n, is, os
  end type fftw_iodim64

  interface
    type(C_PTR) function fftw_plan_dft(rank,n,in,out,sign,flags) bind(C, name='fftw_plan_dft')
      import
      integer(C_INT), value :: rank
      integer(C_INT), dimension(*), intent(in) :: n
      complex(C_DOUBLE_COMPLEX), dimension(*), intent(out) :: in
      complex(C_DOUBLE_COMPLEX), dimension(*), intent(out) :: out
      integer(C_INT), value :: sign
      integer(C_INT), value :: flags
    end function fftw_plan_dft
    
    type(C_PTR) function fftw_plan_dft_1d(n,in,out,sign,flags) bind(C, name='fftw_plan_dft_1d')
      import
      integer(C_INT), value :: n
      complex(C_DOUBLE_COMPLEX), dimension(*), intent(out) :: in
      complex(C_DOUBLE_COMPLEX), dimension(*), intent(out) :: out
      integer(C_INT), value :: sign
      integer(C_INT), value :: flags
    end function fftw_plan_dft_1d
    
    type(C_PTR) function fftw_plan_dft_2d(n0,n1,in,out,sign,flags) bind(C, name='fftw_plan_dft_2d')
      import
      integer(C_INT), value :: n0
      integer(C_INT), value :: n1
      complex(C_DOUBLE_COMPLEX), dimension(*), intent(out) :: in
      complex(C_DOUBLE_COMPLEX), dimension(*), intent(out) :: out
      integer(C_INT), value :: sign
      integer(C_INT), value :: flags
    end function fftw_plan_dft_2d
    
    type(C_PTR) function fftw_plan_dft_3d(n0,n1,n2,in,out,sign,flags) bind(C, name='fftw_plan_dft_3d')
      import
      integer(C_INT), value :: n0
      integer(C_INT), value :: n1
      integer(C_INT), value :: n2
      complex(C_DOUBLE_COMPLEX), dimension(*), intent(out) :: in
      complex(C_DOUBLE_COMPLEX), dimension(*), intent(out) :: out
      integer(C_INT), value :: sign
      integer(C_INT), value :: flags
    end function fftw_plan_dft_3d
    
    type(C_PTR) function fftw_plan_many_dft(rank,n,howmany,in,inembed,istride,idist,out,onembed,ostride,odist,sign,flags) &
                         bind(C, name='fftw_plan_many_dft')
      import
      integer(C_INT), value :: rank
      integer(C_INT), dimension(*), intent(in) :: n
      integer(C_INT), value :: howmany
      complex(C_DOUBLE_COMPLEX), dimension(*), intent(out) :: in
      integer(C_INT), dimension(*), intent(in) :: inembed
      integer(C_INT), value :: istride
      integer(C_INT), value :: idist
      complex(C_DOUBLE_COMPLEX), dimension(*), intent(out) :: out
      integer(C_INT), dimension(*), intent(in) :: onembed
      integer(C_INT), value :: ostride
      integer(C_INT), value :: odist
      integer(C_INT), value :: sign
      integer(C_INT), value :: flags
    end function fftw_plan_many_dft
    
    type(C_PTR) function fftw_plan_guru_dft(rank,dims,howmany_rank,howmany_dims,in,out,sign,flags) &
                         bind(C, name='fftw_plan_guru_dft')
      import
      integer(C_INT), value :: rank
      type(fftw_iodim), dimension(*), intent(in) :: dims
      integer(C_INT), value :: howmany_rank
      type(fftw_iodim), dimension(*), intent(in) :: howmany_dims
      complex(C_DOUBLE_COMPLEX), dimension(*), intent(out) :: in
      complex(C_DOUBLE_COMPLEX), dimension(*), intent(out) :: out
      integer(C_INT), value :: sign
      integer(C_INT), value :: flags
    end function fftw_plan_guru_dft
    
    type(C_PTR) function fftw_plan_guru_split_dft(rank,dims,howmany_rank,howmany_dims,ri,ii,ro,io,flags) &
                         bind(C, name='fftw_plan_guru_split_dft')
      import
      integer(C_INT), value :: rank
      type(fftw_iodim), dimension(*), intent(in) :: dims
      integer(C_INT), value :: howmany_rank
      type(fftw_iodim), dimension(*), intent(in) :: howmany_dims
      real(C_DOUBLE), dimension(*), intent(out) :: ri
      real(C_DOUBLE), dimension(*), intent(out) :: ii
      real(C_DOUBLE), dimension(*), intent(out) :: ro
      real(C_DOUBLE), dimension(*), intent(out) :: io
      integer(C_INT), value :: flags
    end function fftw_plan_guru_split_dft
    
    type(C_PTR) function fftw_plan_guru64_dft(rank,dims,howmany_rank,howmany_dims,in,out,sign,flags) &
                         bind(C, name='fftw_plan_guru64_dft')
      import
      integer(C_INT), value :: rank
      type(fftw_iodim64), dimension(*), intent(in) :: dims
      integer(C_INT), value :: howmany_rank
      type(fftw_iodim64), dimension(*), intent(in) :: howmany_dims
      complex(C_DOUBLE_COMPLEX), dimension(*), intent(out) :: in
      complex(C_DOUBLE_COMPLEX), dimension(*), intent(out) :: out
      integer(C_INT), value :: sign
      integer(C_INT), value :: flags
    end function fftw_plan_guru64_dft
    
    type(C_PTR) function fftw_plan_guru64_split_dft(rank,dims,howmany_rank,howmany_dims,ri,ii,ro,io,flags) &
                         bind(C, name='fftw_plan_guru64_split_dft')
      import
      integer(C_INT), value :: rank
      type(fftw_iodim64), dimension(*), intent(in) :: dims
      integer(C_INT), value :: howmany_rank
      type(fftw_iodim64), dimension(*), intent(in) :: howmany_dims
      real(C_DOUBLE), dimension(*), intent(out) :: ri
      real(C_DOUBLE), dimension(*), intent(out) :: ii
      real(C_DOUBLE), dimension(*), intent(out) :: ro
      real(C_DOUBLE), dimension(*), intent(out) :: io
      integer(C_INT), value :: flags
    end function fftw_plan_guru64_split_dft
    
    subroutine fftw_execute_dft(p,in,out) bind(C, name='fftw_execute_dft')
      import
      type(C_PTR), value :: p
      complex(C_DOUBLE_COMPLEX), dimension(*), intent(inout) :: in
      complex(C_DOUBLE_COMPLEX), dimension(*), intent(out) :: out
    end subroutine fftw_execute_dft
    
    subroutine fftw_execute_split_dft(p,ri,ii,ro,io) bind(C, name='fftw_execute_split_dft')
      import
      type(C_PTR), value :: p
      real(C_DOUBLE), dimension(*), intent(inout) :: ri
      real(C_DOUBLE), dimension(*), intent(inout) :: ii
      real(C_DOUBLE), dimension(*), intent(out) :: ro
      real(C_DOUBLE), dimension(*), intent(out) :: io
    end subroutine fftw_execute_split_dft
    
    type(C_PTR) function fftw_plan_many_dft_r2c(rank,n,howmany,in,inembed,istride,idist,out,onembed,ostride,odist,flags) &
                         bind(C, name='fftw_plan_many_dft_r2c')
      import
      integer(C_INT), value :: rank
      integer(C_INT), dimension(*), intent(in) :: n
      integer(C_INT), value :: howmany
      real(C_DOUBLE), dimension(*), intent(out) :: in
      integer(C_INT), dimension(*), intent(in) :: inembed
      integer(C_INT), value :: istride
      integer(C_INT), value :: idist
      complex(C_DOUBLE_COMPLEX), dimension(*), intent(out) :: out
      integer(C_INT), dimension(*), intent(in) :: onembed
      integer(C_INT), value :: ostride
      integer(C_INT), value :: odist
      integer(C_INT), value :: flags
    end function fftw_plan_many_dft_r2c
    
    type(C_PTR) function fftw_plan_dft_r2c(rank,n,in,out,flags) bind(C, name='fftw_plan_dft_r2c')
      import
      integer(C_INT), value :: rank
      integer(C_INT), dimension(*), intent(in) :: n
      real(C_DOUBLE), dimension(*), intent(out) :: in
      complex(C_DOUBLE_COMPLEX), dimension(*), intent(out) :: out
      integer(C_INT), value :: flags
    end function fftw_plan_dft_r2c
    
    type(C_PTR) function fftw_plan_dft_r2c_1d(n,in,out,flags) bind(C, name='fftw_plan_dft_r2c_1d')
      import
      integer(C_INT), value :: n
      real(C_DOUBLE), dimension(*), intent(out) :: in
      complex(C_DOUBLE_COMPLEX), dimension(*), intent(out) :: out
      integer(C_INT), value :: flags
    end function fftw_plan_dft_r2c_1d
    
    type(C_PTR) function fftw_plan_dft_r2c_2d(n0,n1,in,out,flags) bind(C, name='fftw_plan_dft_r2c_2d')
      import
      integer(C_INT), value :: n0
      integer(C_INT), value :: n1
      real(C_DOUBLE), dimension(*), intent(out) :: in
      complex(C_DOUBLE_COMPLEX), dimension(*), intent(out) :: out
      integer(C_INT), value :: flags
    end function fftw_plan_dft_r2c_2d
    
    type(C_PTR) function fftw_plan_dft_r2c_3d(n0,n1,n2,in,out,flags) bind(C, name='fftw_plan_dft_r2c_3d')
      import
      integer(C_INT), value :: n0
      integer(C_INT), value :: n1
      integer(C_INT), value :: n2
      real(C_DOUBLE), dimension(*), intent(out) :: in
      complex(C_DOUBLE_COMPLEX), dimension(*), intent(out) :: out
      integer(C_INT), value :: flags
    end function fftw_plan_dft_r2c_3d
    
    type(C_PTR) function fftw_plan_many_dft_c2r(rank,n,howmany,in,inembed,istride,idist,out,onembed,ostride,odist,flags) &
                         bind(C, name='fftw_plan_many_dft_c2r')
      import
      integer(C_INT), value :: rank
      integer(C_INT), dimension(*), intent(in) :: n
      integer(C_INT), value :: howmany
      complex(C_DOUBLE_COMPLEX), dimension(*), intent(out) :: in
      integer(C_INT), dimension(*), intent(in) :: inembed
      integer(C_INT), value :: istride
      integer(C_INT), value :: idist
      real(C_DOUBLE), dimension(*), intent(out) :: out
      integer(C_INT), dimension(*), intent(in) :: onembed
      integer(C_INT), value :: ostride
      integer(C_INT), value :: odist
      integer(C_INT), value :: flags
    end function fftw_plan_many_dft_c2r
    
    type(C_PTR) function fftw_plan_dft_c2r(rank,n,in,out,flags) bind(C, name='fftw_plan_dft_c2r')
      import
      integer(C_INT), value :: rank
      integer(C_INT), dimension(*), intent(in) :: n
      complex(C_DOUBLE_COMPLEX), dimension(*), intent(out) :: in
      real(C_DOUBLE), dimension(*), intent(out) :: out
      integer(C_INT), value :: flags
    end function fftw_plan_dft_c2r
    
    type(C_PTR) function fftw_plan_dft_c2r_1d(n,in,out,flags) bind(C, name='fftw_plan_dft_c2r_1d')
      import
      integer(C_INT), value :: n
      complex(C_DOUBLE_COMPLEX), dimension(*), intent(out) :: in
      real(C_DOUBLE), dimension(*), intent(out) :: out
      integer(C_INT), value :: flags
    end function fftw_plan_dft_c2r_1d
    
    type(C_PTR) function fftw_plan_dft_c2r_2d(n0,n1,in,out,flags) bind(C, name='fftw_plan_dft_c2r_2d')
      import
      integer(C_INT), value :: n0
      integer(C_INT), value :: n1
      complex(C_DOUBLE_COMPLEX), dimension(*), intent(out) :: in
      real(C_DOUBLE), dimension(*), intent(out) :: out
      integer(C_INT), value :: flags
    end function fftw_plan_dft_c2r_2d
    
    type(C_PTR) function fftw_plan_dft_c2r_3d(n0,n1,n2,in,out,flags) bind(C, name='fftw_plan_dft_c2r_3d')
      import
      integer(C_INT), value :: n0
      integer(C_INT), value :: n1
      integer(C_INT), value :: n2
      complex(C_DOUBLE_COMPLEX), dimension(*), intent(out) :: in
      real(C_DOUBLE), dimension(*), intent(out) :: out
      integer(C_INT), value :: flags
    end function fftw_plan_dft_c2r_3d
    
    type(C_PTR) function fftw_plan_guru_dft_r2c(rank,dims,howmany_rank,howmany_dims,in,out,flags) &
                         bind(C, name='fftw_plan_guru_dft_r2c')
      import
      integer(C_INT), value :: rank
      type(fftw_iodim), dimension(*), intent(in) :: dims
      integer(C_INT), value :: howmany_rank
      type(fftw_iodim), dimension(*), intent(in) :: howmany_dims
      real(C_DOUBLE), dimension(*), intent(out) :: in
      complex(C_DOUBLE_COMPLEX), dimension(*), intent(out) :: out
      integer(C_INT), value :: flags
    end function fftw_plan_guru_dft_r2c
    
    type(C_PTR) function fftw_plan_guru_dft_c2r(rank,dims,howmany_rank,howmany_dims,in,out,flags) &
                         bind(C, name='fftw_plan_guru_dft_c2r')
      import
      integer(C_INT), value :: rank
      type(fftw_iodim), dimension(*), intent(in) :: dims
      integer(C_INT), value :: howmany_rank
      type(fftw_iodim), dimension(*), intent(in) :: howmany_dims
      complex(C_DOUBLE_COMPLEX), dimension(*), intent(out) :: in
      real(C_DOUBLE), dimension(*), intent(out) :: out
      integer(C_INT), value :: flags
    end function fftw_plan_guru_dft_c2r
    
    type(C_PTR) function fftw_plan_guru_split_dft_r2c(rank,dims,howmany_rank,howmany_dims,in,ro,io,flags) &
                         bind(C, name='fftw_plan_guru_split_dft_r2c')
      import
      integer(C_INT), value :: rank
      type(fftw_iodim), dimension(*), intent(in) :: dims
      integer(C_INT), value :: howmany_rank
      type(fftw_iodim), dimension(*), intent(in) :: howmany_dims
      real(C_DOUBLE), dimension(*), intent(out) :: in
      real(C_DOUBLE), dimension(*), intent(out) :: ro
      real(C_DOUBLE), dimension(*), intent(out) :: io
      integer(C_INT), value :: flags
    end function fftw_plan_guru_split_dft_r2c
    
    type(C_PTR) function fftw_plan_guru_split_dft_c2r(rank,dims,howmany_rank,howmany_dims,ri,ii,out,flags) &
                         bind(C, name='fftw_plan_guru_split_dft_c2r')
      import
      integer(C_INT), value :: rank
      type(fftw_iodim), dimension(*), intent(in) :: dims
      integer(C_INT), value :: howmany_rank
      type(fftw_iodim), dimension(*), intent(in) :: howmany_dims
      real(C_DOUBLE), dimension(*), intent(out) :: ri
      real(C_DOUBLE), dimension(*), intent(out) :: ii
      real(C_DOUBLE), dimension(*), intent(out) :: out
      integer(C_INT), value :: flags
    end function fftw_plan_guru_split_dft_c2r
    
    type(C_PTR) function fftw_plan_guru64_dft_r2c(rank,dims,howmany_rank,howmany_dims,in,out,flags) &
                         bind(C, name='fftw_plan_guru64_dft_r2c')
      import
      integer(C_INT), value :: rank
      type(fftw_iodim64), dimension(*), intent(in) :: dims
      integer(C_INT), value :: howmany_rank
      type(fftw_iodim64), dimension(*), intent(in) :: howmany_dims
      real(C_DOUBLE), dimension(*), intent(out) :: in
      complex(C_DOUBLE_COMPLEX), dimension(*), intent(out) :: out
      integer(C_INT), value :: flags
    end function fftw_plan_guru64_dft_r2c
    
    type(C_PTR) function fftw_plan_guru64_dft_c2r(rank,dims,howmany_rank,howmany_dims,in,out,flags) &
                         bind(C, name='fftw_plan_guru64_dft_c2r')
      import
      integer(C_INT), value :: rank
      type(fftw_iodim64), dimension(*), intent(in) :: dims
      integer(C_INT), value :: howmany_rank
      type(fftw_iodim64), dimension(*), intent(in) :: howmany_dims
      complex(C_DOUBLE_COMPLEX), dimension(*), intent(out) :: in
      real(C_DOUBLE), dimension(*), intent(out) :: out
      integer(C_INT), value :: flags
    end function fftw_plan_guru64_dft_c2r
    
    type(C_PTR) function fftw_plan_guru64_split_dft_r2c(rank,dims,howmany_rank,howmany_dims,in,ro,io,flags) &
                         bind(C, name='fftw_plan_guru64_split_dft_r2c')
      import
      integer(C_INT), value :: rank
      type(fftw_iodim64), dimension(*), intent(in) :: dims
      integer(C_INT), value :: howmany_rank
      type(fftw_iodim64), dimension(*), intent(in) :: howmany_dims
      real(C_DOUBLE), dimension(*), intent(out) :: in
      real(C_DOUBLE), dimension(*), intent(out) :: ro
      real(C_DOUBLE), dimension(*), intent(out) :: io
      integer(C_INT), value :: flags
    end function fftw_plan_guru64_split_dft_r2c
    
    type(C_PTR) function fftw_plan_guru64_split_dft_c2r(rank,dims,howmany_rank,howmany_dims,ri,ii,out,flags) &
                         bind(C, name='fftw_plan_guru64_split_dft_c2r')
      import
      integer(C_INT), value :: rank
      type(fftw_iodim64), dimension(*), intent(in) :: dims
      integer(C_INT), value :: howmany_rank
      type(fftw_iodim64), dimension(*), intent(in) :: howmany_dims
      real(C_DOUBLE), dimension(*), intent(out) :: ri
      real(C_DOUBLE), dimension(*), intent(out) :: ii
      real(C_DOUBLE), dimension(*), intent(out) :: out
      integer(C_INT), value :: flags
    end function fftw_plan_guru64_split_dft_c2r
    
    subroutine fftw_execute_dft_r2c(p,in,out) bind(C, name='fftw_execute_dft_r2c')
      import
      type(C_PTR), value :: p
      real(C_DOUBLE), dimension(*), intent(inout) :: in
      complex(C_DOUBLE_COMPLEX), dimension(*), intent(out) :: out
    end subroutine fftw_execute_dft_r2c
    
    subroutine fftw_execute_dft_c2r(p,in,out) bind(C, name='fftw_execute_dft_c2r')
      import
      type(C_PTR), value :: p
      complex(C_DOUBLE_COMPLEX), dimension(*), intent(inout) :: in
      real(C_DOUBLE), dimension(*), intent(out) :: out
    end subroutine fftw_execute_dft_c2r
    
    subroutine fftw_execute_split_dft_r2c(p,in,ro,io) bind(C, name='fftw_execute_split_dft_r2c')
      import
      type(C_PTR), value :: p
      real(C_DOUBLE), dimension(*), intent(inout) :: in
      real(C_DOUBLE), dimension(*), intent(out) :: ro
      real(C_DOUBLE), dimension(*), intent(out) :: io
    end subroutine fftw_execute_split_dft_r2c
    
    subroutine fftw_execute_split_dft_c2r(p,ri,ii,out) bind(C, name='fftw_execute_split_dft_c2r')
      import
      type(C_PTR), value :: p
      real(C_DOUBLE), dimension(*), intent(inout) :: ri
      real(C_DOUBLE), dimension(*), intent(inout) :: ii
      real(C_DOUBLE), dimension(*), intent(out) :: out
    end subroutine fftw_execute_split_dft_c2r
    
    type(C_PTR) function fftw_plan_many_r2r(rank,n,howmany,in,inembed,istride,idist,out,onembed,ostride,odist,kind,flags) &
                         bind(C, name='fftw_plan_many_r2r')
      import
      integer(C_INT), value :: rank
      integer(C_INT), dimension(*), intent(in) :: n
      integer(C_INT), value :: howmany
      real(C_DOUBLE), dimension(*), intent(out) :: in
      integer(C_INT), dimension(*), intent(in) :: inembed
      integer(C_INT), value :: istride
      integer(C_INT), value :: idist
      real(C_DOUBLE), dimension(*), intent(out) :: out
      integer(C_INT), dimension(*), intent(in) :: onembed
      integer(C_INT), value :: ostride
      integer(C_INT), value :: odist
      integer(C_FFTW_R2R_KIND), dimension(*), intent(in) :: kind
      integer(C_INT), value :: flags
    end function fftw_plan_many_r2r
    
    type(C_PTR) function fftw_plan_r2r(rank,n,in,out,kind,flags) bind(C, name='fftw_plan_r2r')
      import
      integer(C_INT), value :: rank
      integer(C_INT), dimension(*), intent(in) :: n
      real(C_DOUBLE), dimension(*), intent(out) :: in
      real(C_DOUBLE), dimension(*), intent(out) :: out
      integer(C_FFTW_R2R_KIND), dimension(*), intent(in) :: kind
      integer(C_INT), value :: flags
    end function fftw_plan_r2r
    
    type(C_PTR) function fftw_plan_r2r_1d(n,in,out,kind,flags) bind(C, name='fftw_plan_r2r_1d')
      import
      integer(C_INT), value :: n
      real(C_DOUBLE), dimension(*), intent(out) :: in
      real(C_DOUBLE), dimension(*), intent(out) :: out
      integer(C_FFTW_R2R_KIND), value :: kind
      integer(C_INT), value :: flags
    end function fftw_plan_r2r_1d
    
    type(C_PTR) function fftw_plan_r2r_2d(n0,n1,in,out,kind0,kind1,flags) bind(C, name='fftw_plan_r2r_2d')
      import
      integer(C_INT), value :: n0
      integer(C_INT), value :: n1
      real(C_DOUBLE), dimension(*), intent(out) :: in
      real(C_DOUBLE), dimension(*), intent(out) :: out
      integer(C_FFTW_R2R_KIND), value :: kind0
      integer(C_FFTW_R2R_KIND), value :: kind1
      integer(C_INT), value :: flags
    end function fftw_plan_r2r_2d
    
    type(C_PTR) function fftw_plan_r2r_3d(n0,n1,n2,in,out,kind0,kind1,kind2,flags) bind(C, name='fftw_plan_r2r_3d')
      import
      integer(C_INT), value :: n0
      integer(C_INT), value :: n1
      integer(C_INT), value :: n2
      real(C_DOUBLE), dimension(*), intent(out) :: in
      real(C_DOUBLE), dimension(*), intent(out) :: out
      integer(C_FFTW_R2R_KIND), value :: kind0
      integer(C_FFTW_R2R_KIND), value :: kind1
      integer(C_FFTW_R2R_KIND), value :: kind2
      integer(C_INT), value :: flags
    end function fftw_plan_r2r_3d
    
    type(C_PTR) function fftw_plan_guru_r2r(rank,dims,howmany_rank,howmany_dims,in,out,kind,flags) &
                         bind(C, name='fftw_plan_guru_r2r')
      import
      integer(C_INT), value :: rank
      type(fftw_iodim), dimension(*), intent(in) :: dims
      integer(C_INT), value :: howmany_rank
      type(fftw_iodim), dimension(*), intent(in) :: howmany_dims
      real(C_DOUBLE), dimension(*), intent(out) :: in
      real(C_DOUBLE), dimension(*), intent(out) :: out
      integer(C_FFTW_R2R_KIND), dimension(*), intent(in) :: kind
      integer(C_INT), value :: flags
    end function fftw_plan_guru_r2r
    
    type(C_PTR) function fftw_plan_guru64_r2r(rank,dims,howmany_rank,howmany_dims,in,out,kind,flags) &
                         bind(C, name='fftw_plan_guru64_r2r')
      import
      integer(C_INT), value :: rank
      type(fftw_iodim64), dimension(*), intent(in) :: dims
      integer(C_INT), value :: howmany_rank
      type(fftw_iodim64), dimension(*), intent(in) :: howmany_dims
      real(C_DOUBLE), dimension(*), intent(out) :: in
      real(C_DOUBLE), dimension(*), intent(out) :: out
      integer(C_FFTW_R2R_KIND), dimension(*), intent(in) :: kind
      integer(C_INT), value :: flags
    end function fftw_plan_guru64_r2r
    
    subroutine fftw_execute_r2r(p,in,out) bind(C, name='fftw_execute_r2r')
      import
      type(C_PTR), value :: p
      real(C_DOUBLE), dimension(*), intent(inout) :: in
      real(C_DOUBLE), dimension(*), intent(out) :: out
    end subroutine fftw_execute_r2r
    
    subroutine fftw_destroy_plan(p) bind(C, name='fftw_destroy_plan')
      import
      type(C_PTR), value :: p
    end subroutine fftw_destroy_plan
    
    subroutine fftw_forget_wisdom() bind(C, name='fftw_forget_wisdom')
      import
    end subroutine fftw_forget_wisdom
    
    subroutine fftw_cleanup() bind(C, name='fftw_cleanup')
      import
    end subroutine fftw_cleanup
    
    subroutine fftw_set_timelimit(t) bind(C, name='fftw_set_timelimit')
      import
      real(C_DOUBLE), value :: t
    end subroutine fftw_set_timelimit
    
    subroutine fftw_plan_with_nthreads(nthreads) bind(C, name='fftw_plan_with_nthreads')
      import
      integer(C_INT), value :: nthreads
    end subroutine fftw_plan_with_nthreads
    
    integer(C_INT) function fftw_init_threads() bind(C, name='fftw_init_threads')
      import
    end function fftw_init_threads
    
    subroutine fftw_cleanup_threads() bind(C, name='fftw_cleanup_threads')
      import
    end subroutine fftw_cleanup_threads
    
    integer(C_INT) function fftw_export_wisdom_to_filename(filename) bind(C, name='fftw_export_wisdom_to_filename')
      import
      character(C_CHAR), dimension(*), intent(in) :: filename
    end function fftw_export_wisdom_to_filename
    
    subroutine fftw_export_wisdom_to_file(output_file) bind(C, name='fftw_export_wisdom_to_file')
      import
      type(C_PTR), value :: output_file
    end subroutine fftw_export_wisdom_to_file
    
    type(C_PTR) function fftw_export_wisdom_to_string() bind(C, name='fftw_export_wisdom_to_string')
      import
    end function fftw_export_wisdom_to_string
    
    subroutine fftw_export_wisdom(write_char,data) bind(C, name='fftw_export_wisdom')
      import
      type(C_FUNPTR), value :: write_char
      type(C_PTR), value :: data
    end subroutine fftw_export_wisdom
    
    integer(C_INT) function fftw_import_system_wisdom() bind(C, name='fftw_import_system_wisdom')
      import
    end function fftw_import_system_wisdom
    
    integer(C_INT) function fftw_import_wisdom_from_filename(filename) bind(C, name='fftw_import_wisdom_from_filename')
      import
      character(C_CHAR), dimension(*), intent(in) :: filename
    end function fftw_import_wisdom_from_filename
    
    integer(C_INT) function fftw_import_wisdom_from_file(input_file) bind(C, name='fftw_import_wisdom_from_file')
      import
      type(C_PTR), value :: input_file
    end function fftw_import_wisdom_from_file
    
    integer(C_INT) function fftw_import_wisdom_from_string(input_string) bind(C, name='fftw_import_wisdom_from_string')
      import
      character(C_CHAR), dimension(*), intent(in) :: input_string
    end function fftw_import_wisdom_from_string
    
    integer(C_INT) function fftw_import_wisdom(read_char,data) bind(C, name='fftw_import_wisdom')
      import
      type(C_FUNPTR), value :: read_char
      type(C_PTR), value :: data
    end function fftw_import_wisdom
    
    subroutine fftw_fprint_plan(p,output_file) bind(C, name='fftw_fprint_plan')
      import
      type(C_PTR), value :: p
      type(C_PTR), value :: output_file
    end subroutine fftw_fprint_plan
    
    subroutine fftw_print_plan(p) bind(C, name='fftw_print_plan')
      import
      type(C_PTR), value :: p
    end subroutine fftw_print_plan
    
    type(C_PTR) function fftw_sprint_plan(p) bind(C, name='fftw_sprint_plan')
      import
      type(C_PTR), value :: p
    end function fftw_sprint_plan
    
    type(C_PTR) function fftw_malloc(n) bind(C, name='fftw_malloc')
      import
      integer(C_SIZE_T), value :: n
    end function fftw_malloc
    
    type(C_PTR) function fftw_alloc_real(n) bind(C, name='fftw_alloc_real')
      import
      integer(C_SIZE_T), value :: n
    end function fftw_alloc_real
    
    type(C_PTR) function fftw_alloc_complex(n) bind(C, name='fftw_alloc_complex')
      import
      integer(C_SIZE_T), value :: n
    end function fftw_alloc_complex
    
    subroutine fftw_free(p) bind(C, name='fftw_free')
      import
      type(C_PTR), value :: p
    end subroutine fftw_free
    
    subroutine fftw_flops(p,add,mul,fmas) bind(C, name='fftw_flops')
      import
      type(C_PTR), value :: p
      real(C_DOUBLE), intent(out) :: add
      real(C_DOUBLE), intent(out) :: mul
      real(C_DOUBLE), intent(out) :: fmas
    end subroutine fftw_flops
    
    real(C_DOUBLE) function fftw_estimate_cost(p) bind(C, name='fftw_estimate_cost')
      import
      type(C_PTR), value :: p
    end function fftw_estimate_cost
    
    real(C_DOUBLE) function fftw_cost(p) bind(C, name='fftw_cost')
      import
      type(C_PTR), value :: p
    end function fftw_cost
    
    integer(C_INT) function fftw_alignment_of(p) bind(C, name='fftw_alignment_of')
      import
      real(C_DOUBLE), dimension(*), intent(out) :: p
    end function fftw_alignment_of
    
  end interface

  type, bind(C) :: fftwf_iodim
     integer(C_INT) n, is, os
  end type fftwf_iodim
  type, bind(C) :: fftwf_iodim64
     integer(C_INTPTR_T) n, is, os
  end type fftwf_iodim64

  interface
    type(C_PTR) function fftwf_plan_dft(rank,n,in,out,sign,flags) bind(C, name='fftwf_plan_dft')
      import
      integer(C_INT), value :: rank
      integer(C_INT), dimension(*), intent(in) :: n
      complex(C_FLOAT_COMPLEX), dimension(*), intent(out) :: in
      complex(C_FLOAT_COMPLEX), dimension(*), intent(out) :: out
      integer(C_INT), value :: sign
      integer(C_INT), value :: flags
    end function fftwf_plan_dft
    
    type(C_PTR) function fftwf_plan_dft_1d(n,in,out,sign,flags) bind(C, name='fftwf_plan_dft_1d')
      import
      integer(C_INT), value :: n
      complex(C_FLOAT_COMPLEX), dimension(*), intent(out) :: in
      complex(C_FLOAT_COMPLEX), dimension(*), intent(out) :: out
      integer(C_INT), value :: sign
      integer(C_INT), value :: flags
    end function fftwf_plan_dft_1d
    
    type(C_PTR) function fftwf_plan_dft_2d(n0,n1,in,out,sign,flags) bind(C, name='fftwf_plan_dft_2d')
      import
      integer(C_INT), value :: n0
      integer(C_INT), value :: n1
      complex(C_FLOAT_COMPLEX), dimension(*), intent(out) :: in
      complex(C_FLOAT_COMPLEX), dimension(*), intent(out) :: out
      integer(C_INT), value :: sign
      integer(C_INT), value :: flags
    end function fftwf_plan_dft_2d
    
    type(C_PTR) function fftwf_plan_dft_3d(n0,n1,n2,in,out,sign,flags) bind(C, name='fftwf_plan_dft_3d')
      import
      integer(C_INT), value :: n0
      integer(C_INT), value :: n1
      integer(C_INT), value :: n2
      complex(C_FLOAT_COMPLEX), dimension(*), intent(out) :: in
      complex(C_FLOAT_COMPLEX), dimension(*), intent(out) :: out
      integer(C_INT), value :: sign
      integer(C_INT), value :: flags
    end function fftwf_plan_dft_3d
    
    type(C_PTR) function fftwf_plan_many_dft(rank,n,howmany,in,inembed,istride,idist,out,onembed,ostride,odist,sign,flags) &
                         bind(C, name='fftwf_plan_many_dft')
      import
      integer(C_INT), value :: rank
      integer(C_INT), dimension(*), intent(in) :: n
      integer(C_INT), value :: howmany
      complex(C_FLOAT_COMPLEX), dimension(*), intent(out) :: in
      integer(C_INT), dimension(*), intent(in) :: inembed
      integer(C_INT), value :: istride
      integer(C_INT), value :: idist
      complex(C_FLOAT_COMPLEX), dimension(*), intent(out) :: out
      integer(C_INT), dimension(*), intent(in) :: onembed
      integer(C_INT), value :: ostride
      integer(C_INT), value :: odist
      integer(C_INT), value :: sign
      integer(C_INT), value :: flags
    end function fftwf_plan_many_dft
    
    type(C_PTR) function fftwf_plan_guru_dft(rank,dims,howmany_rank,howmany_dims,in,out,sign,flags) &
                         bind(C, name='fftwf_plan_guru_dft')
      import
      integer(C_INT), value :: rank
      type(fftwf_iodim), dimension(*), intent(in) :: dims
      integer(C_INT), value :: howmany_rank
      type(fftwf_iodim), dimension(*), intent(in) :: howmany_dims
      complex(C_FLOAT_COMPLEX), dimension(*), intent(out) :: in
      complex(C_FLOAT_COMPLEX), dimension(*), intent(out) :: out
      integer(C_INT), value :: sign
      integer(C_INT), value :: flags
    end function fftwf_plan_guru_dft
    
    type(C_PTR) function fftwf_plan_guru_split_dft(rank,dims,howmany_rank,howmany_dims,ri,ii,ro,io,flags) &
                         bind(C, name='fftwf_plan_guru_split_dft')
      import
      integer(C_INT), value :: rank
      type(fftwf_iodim), dimension(*), intent(in) :: dims
      integer(C_INT), value :: howmany_rank
      type(fftwf_iodim), dimension(*), intent(in) :: howmany_dims
      real(C_FLOAT), dimension(*), intent(out) :: ri
      real(C_FLOAT), dimension(*), intent(out) :: ii
      real(C_FLOAT), dimension(*), intent(out) :: ro
      real(C_FLOAT), dimension(*), intent(out) :: io
      integer(C_INT), value :: flags
    end function fftwf_plan_guru_split_dft
    
    type(C_PTR) function fftwf_plan_guru64_dft(rank,dims,howmany_rank,howmany_dims,in,out,sign,flags) &
                         bind(C, name='fftwf_plan_guru64_dft')
      import
      integer(C_INT), value :: rank
      type(fftwf_iodim64), dimension(*), intent(in) :: dims
      integer(C_INT), value :: howmany_rank
      type(fftwf_iodim64), dimension(*), intent(in) :: howmany_dims
      complex(C_FLOAT_COMPLEX), dimension(*), intent(out) :: in
      complex(C_FLOAT_COMPLEX), dimension(*), intent(out) :: out
      integer(C_INT), value :: sign
      integer(C_INT), value :: flags
    end function fftwf_plan_guru64_dft
    
    type(C_PTR) function fftwf_plan_guru64_split_dft(rank,dims,howmany_rank,howmany_dims,ri,ii,ro,io,flags) &
                         bind(C, name='fftwf_plan_guru64_split_dft')
      import
      integer(C_INT), value :: rank
      type(fftwf_iodim64), dimension(*), intent(in) :: dims
      integer(C_INT), value :: howmany_rank
      type(fftwf_iodim64), dimension(*), intent(in) :: howmany_dims
      real(C_FLOAT), dimension(*), intent(out) :: ri
      real(C_FLOAT), dimension(*), intent(out) :: ii
      real(C_FLOAT), dimension(*), intent(out) :: ro
      real(C_FLOAT), dimension(*), intent(out) :: io
      integer(C_INT), value :: flags
    end function fftwf_plan_guru64_split_dft
    
    subroutine fftwf_execute_dft(p,in,out) bind(C, name='fftwf_execute_dft')
      import
      type(C_PTR), value :: p
      complex(C_FLOAT_COMPLEX), dimension(*), intent(inout) :: in
      complex(C_FLOAT_COMPLEX), dimension(*), intent(out) :: out
    end subroutine fftwf_execute_dft
    
    subroutine fftwf_execute_split_dft(p,ri,ii,ro,io) bind(C, name='fftwf_execute_split_dft')
      import
      type(C_PTR), value :: p
      real(C_FLOAT), dimension(*), intent(inout) :: ri
      real(C_FLOAT), dimension(*), intent(inout) :: ii
      real(C_FLOAT), dimension(*), intent(out) :: ro
      real(C_FLOAT), dimension(*), intent(out) :: io
    end subroutine fftwf_execute_split_dft
    
    type(C_PTR) function fftwf_plan_many_dft_r2c(rank,n,howmany,in,inembed,istride,idist,out,onembed,ostride,odist,flags) &
                         bind(C, name='fftwf_plan_many_dft_r2c')
      import
      integer(C_INT), value :: rank
      integer(C_INT), dimension(*), intent(in) :: n
      integer(C_INT), value :: howmany
      real(C_FLOAT), dimension(*), intent(out) :: in
      integer(C_INT), dimension(*), intent(in) :: inembed
      integer(C_INT), value :: istride
      integer(C_INT), value :: idist
      complex(C_FLOAT_COMPLEX), dimension(*), intent(out) :: out
      integer(C_INT), dimension(*), intent(in) :: onembed
      integer(C_INT), value :: ostride
      integer(C_INT), value :: odist
      integer(C_INT), value :: flags
    end function fftwf_plan_many_dft_r2c
    
    type(C_PTR) function fftwf_plan_dft_r2c(rank,n,in,out,flags) bind(C, name='fftwf_plan_dft_r2c')
      import
      integer(C_INT), value :: rank
      integer(C_INT), dimension(*), intent(in) :: n
      real(C_FLOAT), dimension(*), intent(out) :: in
      complex(C_FLOAT_COMPLEX), dimension(*), intent(out) :: out
      integer(C_INT), value :: flags
    end function fftwf_plan_dft_r2c
    
    type(C_PTR) function fftwf_plan_dft_r2c_1d(n,in,out,flags) bind(C, name='fftwf_plan_dft_r2c_1d')
      import
      integer(C_INT), value :: n
      real(C_FLOAT), dimension(*), intent(out) :: in
      complex(C_FLOAT_COMPLEX), dimension(*), intent(out) :: out
      integer(C_INT), value :: flags
    end function fftwf_plan_dft_r2c_1d
    
    type(C_PTR) function fftwf_plan_dft_r2c_2d(n0,n1,in,out,flags) bind(C, name='fftwf_plan_dft_r2c_2d')
      import
      integer(C_INT), value :: n0
      integer(C_INT), value :: n1
      real(C_FLOAT), dimension(*), intent(out) :: in
      complex(C_FLOAT_COMPLEX), dimension(*), intent(out) :: out
      integer(C_INT), value :: flags
    end function fftwf_plan_dft_r2c_2d
    
    type(C_PTR) function fftwf_plan_dft_r2c_3d(n0,n1,n2,in,out,flags) bind(C, name='fftwf_plan_dft_r2c_3d')
      import
      integer(C_INT), value :: n0
      integer(C_INT), value :: n1
      integer(C_INT), value :: n2
      real(C_FLOAT), dimension(*), intent(out) :: in
      complex(C_FLOAT_COMPLEX), dimension(*), intent(out) :: out
      integer(C_INT), value :: flags
    end function fftwf_plan_dft_r2c_3d
    
    type(C_PTR) function fftwf_plan_many_dft_c2r(rank,n,howmany,in,inembed,istride,idist,out,onembed,ostride,odist,flags) &
                         bind(C, name='fftwf_plan_many_dft_c2r')
      import
      integer(C_INT), value :: rank
      integer(C_INT), dimension(*), intent(in) :: n
      integer(C_INT), value :: howmany
      complex(C_FLOAT_COMPLEX), dimension(*), intent(out) :: in
      integer(C_INT), dimension(*), intent(in) :: inembed
      integer(C_INT), value :: istride
      integer(C_INT), value :: idist
      real(C_FLOAT), dimension(*), intent(out) :: out
      integer(C_INT), dimension(*), intent(in) :: onembed
      integer(C_INT), value :: ostride
      integer(C_INT), value :: odist
      integer(C_INT), value :: flags
    end function fftwf_plan_many_dft_c2r
    
    type(C_PTR) function fftwf_plan_dft_c2r(rank,n,in,out,flags) bind(C, name='fftwf_plan_dft_c2r')
      import
      integer(C_INT), value :: rank
      integer(C_INT), dimension(*), intent(in) :: n
      complex(C_FLOAT_COMPLEX), dimension(*), intent(out) :: in
      real(C_FLOAT), dimension(*), intent(out) :: out
      integer(C_INT), value :: flags
    end function fftwf_plan_dft_c2r
    
    type(C_PTR) function fftwf_plan_dft_c2r_1d(n,in,out,flags) bind(C, name='fftwf_plan_dft_c2r_1d')
      import
      integer(C_INT), value :: n
      complex(C_FLOAT_COMPLEX), dimension(*), intent(out) :: in
      real(C_FLOAT), dimension(*), intent(out) :: out
      integer(C_INT), value :: flags
    end function fftwf_plan_dft_c2r_1d
    
    type(C_PTR) function fftwf_plan_dft_c2r_2d(n0,n1,in,out,flags) bind(C, name='fftwf_plan_dft_c2r_2d')
      import
      integer(C_INT), value :: n0
      integer(C_INT), value :: n1
      complex(C_FLOAT_COMPLEX), dimension(*), intent(out) :: in
      real(C_FLOAT), dimension(*), intent(out) :: out
      integer(C_INT), value :: flags
    end function fftwf_plan_dft_c2r_2d
    
    type(C_PTR) function fftwf_plan_dft_c2r_3d(n0,n1,n2,in,out,flags) bind(C, name='fftwf_plan_dft_c2r_3d')
      import
      integer(C_INT), value :: n0
      integer(C_INT), value :: n1
      integer(C_INT), value :: n2
      complex(C_FLOAT_COMPLEX), dimension(*), intent(out) :: in
      real(C_FLOAT), dimension(*), intent(out) :: out
      integer(C_INT), value :: flags
    end function fftwf_plan_dft_c2r_3d
    
    type(C_PTR) function fftwf_plan_guru_dft_r2c(rank,dims,howmany_rank,howmany_dims,in,out,flags) &
                         bind(C, name='fftwf_plan_guru_dft_r2c')
      import
      integer(C_INT), value :: rank
      type(fftwf_iodim), dimension(*), intent(in) :: dims
      integer(C_INT), value :: howmany_rank
      type(fftwf_iodim), dimension(*), intent(in) :: howmany_dims
      real(C_FLOAT), dimension(*), intent(out) :: in
      complex(C_FLOAT_COMPLEX), dimension(*), intent(out) :: out
      integer(C_INT), value :: flags
    end function fftwf_plan_guru_dft_r2c
    
    type(C_PTR) function fftwf_plan_guru_dft_c2r(rank,dims,howmany_rank,howmany_dims,in,out,flags) &
                         bind(C, name='fftwf_plan_guru_dft_c2r')
      import
      integer(C_INT), value :: rank
      type(fftwf_iodim), dimension(*), intent(in) :: dims
      integer(C_INT), value :: howmany_rank
      type(fftwf_iodim), dimension(*), intent(in) :: howmany_dims
      complex(C_FLOAT_COMPLEX), dimension(*), intent(out) :: in
      real(C_FLOAT), dimension(*), intent(out) :: out
      integer(C_INT), value :: flags
    end function fftwf_plan_guru_dft_c2r
    
    type(C_PTR) function fftwf_plan_guru_split_dft_r2c(rank,dims,howmany_rank,howmany_dims,in,ro,io,flags) &
                         bind(C, name='fftwf_plan_guru_split_dft_r2c')
      import
      integer(C_INT), value :: rank
      type(fftwf_iodim), dimension(*), intent(in) :: dims
      integer(C_INT), value :: howmany_rank
      type(fftwf_iodim), dimension(*), intent(in) :: howmany_dims
      real(C_FLOAT), dimension(*), intent(out) :: in
      real(C_FLOAT), dimension(*), intent(out) :: ro
      real(C_FLOAT), dimension(*), intent(out) :: io
      integer(C_INT), value :: flags
    end function fftwf_plan_guru_split_dft_r2c
    
    type(C_PTR) function fftwf_plan_guru_split_dft_c2r(rank,dims,howmany_rank,howmany_dims,ri,ii,out,flags) &
                         bind(C, name='fftwf_plan_guru_split_dft_c2r')
      import
      integer(C_INT), value :: rank
      type(fftwf_iodim), dimension(*), intent(in) :: dims
      integer(C_INT), value :: howmany_rank
      type(fftwf_iodim), dimension(*), intent(in) :: howmany_dims
      real(C_FLOAT), dimension(*), intent(out) :: ri
      real(C_FLOAT), dimension(*), intent(out) :: ii
      real(C_FLOAT), dimension(*), intent(out) :: out
      integer(C_INT), value :: flags
    end function fftwf_plan_guru_split_dft_c2r
    
    type(C_PTR) function fftwf_plan_guru64_dft_r2c(rank,dims,howmany_rank,howmany_dims,in,out,flags) &
                         bind(C, name='fftwf_plan_guru64_dft_r2c')
      import
      integer(C_INT), value :: rank
      type(fftwf_iodim64), dimension(*), intent(in) :: dims
      integer(C_INT), value :: howmany_rank
      type(fftwf_iodim64), dimension(*), intent(in) :: howmany_dims
      real(C_FLOAT), dimension(*), intent(out) :: in
      complex(C_FLOAT_COMPLEX), dimension(*), intent(out) :: out
      integer(C_INT), value :: flags
    end function fftwf_plan_guru64_dft_r2c
    
    type(C_PTR) function fftwf_plan_guru64_dft_c2r(rank,dims,howmany_rank,howmany_dims,in,out,flags) &
                         bind(C, name='fftwf_plan_guru64_dft_c2r')
      import
      integer(C_INT), value :: rank
      type(fftwf_iodim64), dimension(*), intent(in) :: dims
      integer(C_INT), value :: howmany_rank
      type(fftwf_iodim64), dimension(*), intent(in) :: howmany_dims
      complex(C_FLOAT_COMPLEX), dimension(*), intent(out) :: in
      real(C_FLOAT), dimension(*), intent(out) :: out
      integer(C_INT), value :: flags
    end function fftwf_plan_guru64_dft_c2r
    
    type(C_PTR) function fftwf_plan_guru64_split_dft_r2c(rank,dims,howmany_rank,howmany_dims,in,ro,io,flags) &
                         bind(C, name='fftwf_plan_guru64_split_dft_r2c')
      import
      integer(C_INT), value :: rank
      type(fftwf_iodim64), dimension(*), intent(in) :: dims
      integer(C_INT), value :: howmany_rank
      type(fftwf_iodim64), dimension(*), intent(in) :: howmany_dims
      real(C_FLOAT), dimension(*), intent(out) :: in
      real(C_FLOAT), dimension(*), intent(out) :: ro
      real(C_FLOAT), dimension(*), intent(out) :: io
      integer(C_INT), value :: flags
    end function fftwf_plan_guru64_split_dft_r2c
    
    type(C_PTR) function fftwf_plan_guru64_split_dft_c2r(rank,dims,howmany_rank,howmany_dims,ri,ii,out,flags) &
                         bind(C, name='fftwf_plan_guru64_split_dft_c2r')
      import
      integer(C_INT), value :: rank
      type(fftwf_iodim64), dimension(*), intent(in) :: dims
      integer(C_INT), value :: howmany_rank
      type(fftwf_iodim64), dimension(*), intent(in) :: howmany_dims
      real(C_FLOAT), dimension(*), intent(out) :: ri
      real(C_FLOAT), dimension(*), intent(out) :: ii
      real(C_FLOAT), dimension(*), intent(out) :: out
      integer(C_INT), value :: flags
    end function fftwf_plan_guru64_split_dft_c2r
    
    subroutine fftwf_execute_dft_r2c(p,in,out) bind(C, name='fftwf_execute_dft_r2c')
      import
      type(C_PTR), value :: p
      real(C_FLOAT), dimension(*), intent(inout) :: in
      complex(C_FLOAT_COMPLEX), dimension(*), intent(out) :: out
    end subroutine fftwf_execute_dft_r2c
    
    subroutine fftwf_execute_dft_c2r(p,in,out) bind(C, name='fftwf_execute_dft_c2r')
      import
      type(C_PTR), value :: p
      complex(C_FLOAT_COMPLEX), dimension(*), intent(inout) :: in
      real(C_FLOAT), dimension(*), intent(out) :: out
    end subroutine fftwf_execute_dft_c2r
    
    subroutine fftwf_execute_split_dft_r2c(p,in,ro,io) bind(C, name='fftwf_execute_split_dft_r2c')
      import
      type(C_PTR), value :: p
      real(C_FLOAT), dimension(*), intent(inout) :: in
      real(C_FLOAT), dimension(*), intent(out) :: ro
      real(C_FLOAT), dimension(*), intent(out) :: io
    end subroutine fftwf_execute_split_dft_r2c
    
    subroutine fftwf_execute_split_dft_c2r(p,ri,ii,out) bind(C, name='fftwf_execute_split_dft_c2r')
      import
      type(C_PTR), value :: p
      real(C_FLOAT), dimension(*), intent(inout) :: ri
      real(C_FLOAT), dimension(*), intent(inout) :: ii
      real(C_FLOAT), dimension(*), intent(out) :: out
    end subroutine fftwf_execute_split_dft_c2r
    
    type(C_PTR) function fftwf_plan_many_r2r(rank,n,howmany,in,inembed,istride,idist,out,onembed,ostride,odist,kind,flags) &
                         bind(C, name='fftwf_plan_many_r2r')
      import
      integer(C_INT), value :: rank
      integer(C_INT), dimension(*), intent(in) :: n
      integer(C_INT), value :: howmany
      real(C_FLOAT), dimension(*), intent(out) :: in
      integer(C_INT), dimension(*), intent(in) :: inembed
      integer(C_INT), value :: istride
      integer(C_INT), value :: idist
      real(C_FLOAT), dimension(*), intent(out) :: out
      integer(C_INT), dimension(*), intent(in) :: onembed
      integer(C_INT), value :: ostride
      integer(C_INT), value :: odist
      integer(C_FFTW_R2R_KIND), dimension(*), intent(in) :: kind
      integer(C_INT), value :: flags
    end function fftwf_plan_many_r2r
    
    type(C_PTR) function fftwf_plan_r2r(rank,n,in,out,kind,flags) bind(C, name='fftwf_plan_r2r')
      import
      integer(C_INT), value :: rank
      integer(C_INT), dimension(*), intent(in) :: n
      real(C_FLOAT), dimension(*), intent(out) :: in
      real(C_FLOAT), dimension(*), intent(out) :: out
      integer(C_FFTW_R2R_KIND), dimension(*), intent(in) :: kind
      integer(C_INT), value :: flags
    end function fftwf_plan_r2r
    
    type(C_PTR) function fftwf_plan_r2r_1d(n,in,out,kind,flags) bind(C, name='fftwf_plan_r2r_1d')
      import
      integer(C_INT), value :: n
      real(C_FLOAT), dimension(*), intent(out) :: in
      real(C_FLOAT), dimension(*), intent(out) :: out
      integer(C_FFTW_R2R_KIND), value :: kind
      integer(C_INT), value :: flags
    end function fftwf_plan_r2r_1d
    
    type(C_PTR) function fftwf_plan_r2r_2d(n0,n1,in,out,kind0,kind1,flags) bind(C, name='fftwf_plan_r2r_2d')
      import
      integer(C_INT), value :: n0
      integer(C_INT), value :: n1
      real(C_FLOAT), dimension(*), intent(out) :: in
      real(C_FLOAT), dimension(*), intent(out) :: out
      integer(C_FFTW_R2R_KIND), value :: kind0
      integer(C_FFTW_R2R_KIND), value :: kind1
      integer(C_INT), value :: flags
    end function fftwf_plan_r2r_2d
    
    type(C_PTR) function fftwf_plan_r2r_3d(n0,n1,n2,in,out,kind0,kind1,kind2,flags) bind(C, name='fftwf_plan_r2r_3d')
      import
      integer(C_INT), value :: n0
      integer(C_INT), value :: n1
      integer(C_INT), value :: n2
      real(C_FLOAT), dimension(*), intent(out) :: in
      real(C_FLOAT), dimension(*), intent(out) :: out
      integer(C_FFTW_R2R_KIND), value :: kind0
      integer(C_FFTW_R2R_KIND), value :: kind1
      integer(C_FFTW_R2R_KIND), value :: kind2
      integer(C_INT), value :: flags
    end function fftwf_plan_r2r_3d
    
    type(C_PTR) function fftwf_plan_guru_r2r(rank,dims,howmany_rank,howmany_dims,in,out,kind,flags) &
                         bind(C, name='fftwf_plan_guru_r2r')
      import
      integer(C_INT), value :: rank
      type(fftwf_iodim), dimension(*), intent(in) :: dims
      integer(C_INT), value :: howmany_rank
      type(fftwf_iodim), dimension(*), intent(in) :: howmany_dims
      real(C_FLOAT), dimension(*), intent(out) :: in
      real(C_FLOAT), dimension(*), intent(out) :: out
      integer(C_FFTW_R2R_KIND), dimension(*), intent(in) :: kind
      integer(C_INT), value :: flags
    end function fftwf_plan_guru_r2r
    
    type(C_PTR) function fftwf_plan_guru64_r2r(rank,dims,howmany_rank,howmany_dims,in,out,kind,flags) &
                         bind(C, name='fftwf_plan_guru64_r2r')
      import
      integer(C_INT), value :: rank
      type(fftwf_iodim64), dimension(*), intent(in) :: dims
      integer(C_INT), value :: howmany_rank
      type(fftwf_iodim64), dimension(*), intent(in) :: howmany_dims
      real(C_FLOAT), dimension(*), intent(out) :: in
      real(C_FLOAT), dimension(*), intent(out) :: out
      integer(C_FFTW_R2R_KIND), dimension(*), intent(in) :: kind
      integer(C_INT), value :: flags
    end function fftwf_plan_guru64_r2r
    
    subroutine fftwf_execute_r2r(p,in,out) bind(C, name='fftwf_execute_r2r')
      import
      type(C_PTR), value :: p
      real(C_FLOAT), dimension(*), intent(inout) :: in
      real(C_FLOAT), dimension(*), intent(out) :: out
    end subroutine fftwf_execute_r2r
    
    subroutine fftwf_destroy_plan(p) bind(C, name='fftwf_destroy_plan')
      import
      type(C_PTR), value :: p
    end subroutine fftwf_destroy_plan
    
    subroutine fftwf_forget_wisdom() bind(C, name='fftwf_forget_wisdom')
      import
    end subroutine fftwf_forget_wisdom
    
    subroutine fftwf_cleanup() bind(C, name='fftwf_cleanup')
      import
    end subroutine fftwf_cleanup
    
    subroutine fftwf_set_timelimit(t) bind(C, name='fftwf_set_timelimit')
      import
      real(C_DOUBLE), value :: t
    end subroutine fftwf_set_timelimit
    
    subroutine fftwf_plan_with_nthreads(nthreads) bind(C, name='fftwf_plan_with_nthreads')
      import
      integer(C_INT), value :: nthreads
    end subroutine fftwf_plan_with_nthreads
    
    integer(C_INT) function fftwf_init_threads() bind(C, name='fftwf_init_threads')
      import
    end function fftwf_init_threads
    
    subroutine fftwf_cleanup_threads() bind(C, name='fftwf_cleanup_threads')
      import
    end subroutine fftwf_cleanup_threads
    
    integer(C_INT) function fftwf_export_wisdom_to_filename(filename) bind(C, name='fftwf_export_wisdom_to_filename')
      import
      character(C_CHAR), dimension(*), intent(in) :: filename
    end function fftwf_export_wisdom_to_filename
    
    subroutine fftwf_export_wisdom_to_file(output_file) bind(C, name='fftwf_export_wisdom_to_file')
      import
      type(C_PTR), value :: output_file
    end subroutine fftwf_export_wisdom_to_file
    
    type(C_PTR) function fftwf_export_wisdom_to_string() bind(C, name='fftwf_export_wisdom_to_string')
      import
    end function fftwf_export_wisdom_to_string
    
    subroutine fftwf_export_wisdom(write_char,data) bind(C, name='fftwf_export_wisdom')
      import
      type(C_FUNPTR), value :: write_char
      type(C_PTR), value :: data
    end subroutine fftwf_export_wisdom
    
    integer(C_INT) function fftwf_import_system_wisdom() bind(C, name='fftwf_import_system_wisdom')
      import
    end function fftwf_import_system_wisdom
    
    integer(C_INT) function fftwf_import_wisdom_from_filename(filename) bind(C, name='fftwf_import_wisdom_from_filename')
      import
      character(C_CHAR), dimension(*), intent(in) :: filename
    end function fftwf_import_wisdom_from_filename
    
    integer(C_INT) function fftwf_import_wisdom_from_file(input_file) bind(C, name='fftwf_import_wisdom_from_file')
      import
      type(C_PTR), value :: input_file
    end function fftwf_import_wisdom_from_file
    
    integer(C_INT) function fftwf_import_wisdom_from_string(input_string) bind(C, name='fftwf_import_wisdom_from_string')
      import
      character(C_CHAR), dimension(*), intent(in) :: input_string
    end function fftwf_import_wisdom_from_string
    
    integer(C_INT) function fftwf_import_wisdom(read_char,data) bind(C, name='fftwf_import_wisdom')
      import
      type(C_FUNPTR), value :: read_char
      type(C_PTR), value :: data
    end function fftwf_import_wisdom
    
    subroutine fftwf_fprint_plan(p,output_file) bind(C, name='fftwf_fprint_plan')
      import
      type(C_PTR), value :: p
      type(C_PTR), value :: output_file
    end subroutine fftwf_fprint_plan
    
    subroutine fftwf_print_plan(p) bind(C, name='fftwf_print_plan')
      import
      type(C_PTR), value :: p
    end subroutine fftwf_print_plan
    
    type(C_PTR) function fftwf_sprint_plan(p) bind(C, name='fftwf_sprint_plan')
      import
      type(C_PTR), value :: p
    end function fftwf_sprint_plan
    
    type(C_PTR) function fftwf_malloc(n) bind(C, name='fftwf_malloc')
      import
      integer(C_SIZE_T), value :: n
    end function fftwf_malloc
    
    type(C_PTR) function fftwf_alloc_real(n) bind(C, name='fftwf_alloc_real')
      import
      integer(C_SIZE_T), value :: n
    end function fftwf_alloc_real
    
    type(C_PTR) function fftwf_alloc_complex(n) bind(C, name='fftwf_alloc_complex')
      import
      integer(C_SIZE_T), value :: n
    end function fftwf_alloc_complex
    
    subroutine fftwf_free(p) bind(C, name='fftwf_free')
      import
      type(C_PTR), value :: p
    end subroutine fftwf_free
    
    subroutine fftwf_flops(p,add,mul,fmas) bind(C, name='fftwf_flops')
      import
      type(C_PTR), value :: p
      real(C_DOUBLE), intent(out) :: add
      real(C_DOUBLE), intent(out) :: mul
      real(C_DOUBLE), intent(out) :: fmas
    end subroutine fftwf_flops
    
    real(C_DOUBLE) function fftwf_estimate_cost(p) bind(C, name='fftwf_estimate_cost')
      import
      type(C_PTR), value :: p
    end function fftwf_estimate_cost
    
    real(C_DOUBLE) function fftwf_cost(p) bind(C, name='fftwf_cost')
      import
      type(C_PTR), value :: p
    end function fftwf_cost
    
    integer(C_INT) function fftwf_alignment_of(p) bind(C, name='fftwf_alignment_of')
      import
      real(C_FLOAT), dimension(*), intent(out) :: p
    end function fftwf_alignment_of
    
  end interface

! LDPC (174,91) code
parameter (KK=91)                     !Information bits (77 + CRC14)
parameter (ND=58)                     !Data symbols
parameter (NS=21)                     !Sync symbols (3 @ Costas 7x7)
parameter (NN=79)                     !Total channel symbols NS+ND (79)
parameter (NSPS=1920)                 !Samples per symbol at 12000 S/s
parameter (NZ=151680)                 !Samples in full 15 s waveform NSPS*NN (151,680)
parameter (NMAX=180000)               !Samples in iwave 15s*12000 (180,000)
parameter (NFFT1=3840, NH1=1920)      !Length of FFTs for symbol spectra NFFT1=2*NSPS, NH1=NFFT1/2
parameter (NSTEP=480)                 !Rough time-sync step size NSTEP=NSPS/4
parameter (NHSYM=372)                 !Number of symbol spectra (1/4-sym steps) NHSYM=NMAX/NSTEP-3
parameter (NDOWN=60)                  !Downsample factor

function stdmsg(msg0)

  ! Returns .true. if msg0 a standard "JT-style" message
  
  ! i3.n3
  !  0.0   Free text
  !  0.1   DXpeditiion mode
  !  0.2   EU VHF Contest
  !  0.3   ARRL Field Day <=16 transmitters
  !  0.4   ARRL Field Day >16 transmitters
  !  0.5   telemetry
  !  0.6
  !  0.7
  !  1     Standard 77-bit structured message (optional /R)
  !  2     EU VHF Contest (optional /P)
  !  3     ARRL RTTY Contest
  !  4     Nonstandard calls

  use iso_c_binding, only: c_bool
  use packjt
  use packjt77

  character*37 msg0,msg1
  character*77 c77
  logical(c_bool) :: stdmsg

  msg1=msg0
  i3=-1
  n3=-1
  call pack77(msg1,i3,n3,c77,0)
  stdmsg=(i3.gt.0 .or. n3.gt.0)

!###
!  rewind 82
!  do i=1,nzhash
!     write(82,3082) i,nzhash,callsign(i),ihash10(i),ihash12(i),ihash22(i)
!3082 format(2i5,2x,a13,3i10)
!  enddo
!  flush(82)
!###
  
  return
end function stdmsg

! This source code file was last time modified by Arvo ES1JA on January 6th, 2017.
! All changes are shown in the patch file coming together with the full JTDX source code.
MODULE prog_args
  CHARACTER(len=80) :: shm_key
  CHARACTER(len=500) :: exe_dir = '.', data_dir = '.', temp_dir = '.', share_dir = '.'
END MODULE prog_args

subroutine wav12(d2,d1,npts,nbitsam2)

! Convert i*2 or i*1 data at 11025 Hz (from WSJT *.wav files)
! to i*2 data at 12000 Hz.

! Input:  i*2 d2(npts) or i*1 d1(npts)
!         i*2 nbitsam2 = 8 or 16 (bits per sample)

! Output: npts = (12000*npts)/11025
!         i*2 d2(npts)

  parameter (NZ11=60*11025,NZ12=60*12000)
  parameter (NFFT1=64*11025,NFFT2=64*12000)
  integer*1 d1(NZ11)
  integer*1 d1a(NZ11)
  integer*1 i1
  integer*2 i2
  integer*2 d2(NZ12)
  real x(NFFT2)
  complex cx(0:NFFT2/2)
  integer*2 nbitsam2
  equivalence (x,cx),(i1,i2)

  jz=min(NZ11,npts)
  if(nbitsam2.eq.8) then
     jz=min(NZ11,2*npts)
     d1a(1:jz)=d1(1:jz)            !d1 and d2 may be same array in calling prog 
     do i=1,jz                     !Move data from d1a into d2
        i2=0
        i1=d1a(i)
        d2(i)=10*(i2-128)
     enddo
  endif

  x(1:jz)=d2(1:jz)
  x(jz+1:)=0.0
  call four2a(cx,nfft1,1,-1,0)                    !Forwarxd FFT, r2c
  cx(nfft1/2:)=0.0
  call four2a(cx,nfft2,1,1,-1)                   !Inverse FFT, c2r

  npts=jz*12000.0/11025.0
  fac=1.e-6
!  if(nbitsam2.eq.16) fac=3.e-6
  x=fac*x
  d2(1:npts)=nint(x(1:npts))
  if(npts.lt.NZ12) d2(npts+1:NZ12)=0

  return
end subroutine wav12

! This source code file was last time modified by Igor UA3DJY on January 18th, 2018
! All changes are shown in the patch file coming together with the full JTDX source code.

subroutine downsam10(npts8,newdat,fpk,c5,c3)

!Downsample from dd() into c2() so as to yield nspsd samples per symbol, 
!mixing from fpk down to zero frequency.  The downsample factors is 6.75 & 4 & 4 & 4, total is 432.

  use, intrinsic :: iso_c_binding
  use FFTW3
  use timer_module, only: timer
  use jt65_mod6

  include 'constants.f90'
  integer(C_SIZE_T) NMAX1
  parameter (NMAX1=653184)
  parameter (NFFT1=653184,NFFT3=24192,NFFT5=1512)
  type(C_PTR) :: plan !Pointers plan for big FFT
  logical, intent(inout) :: newdat
  real*4, pointer :: x1(:)
  complex c1(0:NFFT1/2),c3(0:NFFT3-1),c5(0:NFFT5-1)
  real s(5000)
  logical first
  data first/.true./
  common/patience/npatience,nthreads
  save plan,first,c1,s,x1

  df1=12000.0/NFFT1
  npts10=8*npts8
  if(npts10.gt.NFFT1) npts10=NFFT1  !### Fix! ###

  if(first) then
     nflags=FFTW_ESTIMATE
     if(npatience.eq.1) nflags=FFTW_ESTIMATE_PATIENT
     if(npatience.eq.2) nflags=FFTW_MEASURE
     if(npatience.eq.3) nflags=FFTW_PATIENT
     if(npatience.eq.4) nflags=FFTW_EXHAUSTIVE
! Plan the FFTs just once

     !$omp critical(fftw) ! serialize non thread-safe FFTW3 calls
     plan=fftwf_alloc_real(NMAX1)
     call c_f_pointer(plan,x1,[NMAX1])
     x1(0:NMAX1-1) => x1        !remap bounds
     call fftwf_plan_with_nthreads(nthreads)
     plan=fftwf_plan_dft_r2c_1d(NFFT1,x1,c1,nflags)
     !$omp end critical(fftw)
     first=.false.
  endif

  if(newdat) then
     x1(0:npts10-1)=dd(1:npts10)
     x1(npts10:NFFT1-1)=0.                      !Zero the rest of x1
!     call timer('FFTbig9 ',0)
     call fftwf_execute_dft_r2c(plan,x1,c1)
!     call timer('FFTbig9 ',1)

     nadd=int(1.0/df1)
     s=0.
     do i=1,5000
        j=int((i-1)/df1)
        do n=1,nadd
           j=j+1
           s(i)=s(i)+real(c1(j))**2 + aimag(c1(j))**2
        enddo
     enddo
     newdat=.false.
  endif

  nf=nint(fpk)
  i0=nint(fpk/df1)

!  nw=100
  nw=400
  ia=max(1,nf-nw)
  ib=min(5000,nf+nw)
  call pctile(s(ia),ib-ia+1,40,avenoise)

  fac=sqrt(1./avenoise) 
  nh=NFFT3/2
  do i=0,NFFT3-1
     j=i0+i
     if(i.gt.nh) j=j-NFFT3
     if(j.lt.0) j=0 ! protection of getting to negative index values
     c3(i)=fac*c1(j)
  enddo
  nh=NFFT5/2
  do i=0,NFFT5-1
     j=i0+i
     if(i.gt.nh) j=j-NFFT5
     if(j.lt.0) j=0 ! protection of getting to negative index values
     c5(i)=fac*c1(j)
  enddo
  
  call four2a(c3,NFFT3,1,1,1)              !FFT back to time domain
  call four2a(c5,NFFT5,1,1,1)              !FFT back to time domain

  return
end subroutine downsam10

subroutine subtractft8(itone,f0,dt,swl)

! Subtract an ft8 signal
!
! Measured signal  : dd(t)    = a(t)cos(2*pi*f0*t+theta(t))
! Reference signal : cref(t)  = exp( j*(2*pi*f0*t+phi(t)) )
! Complex amp      : cfilt(t) = LPF[ dd(t)*CONJG(cref(t)) ]
! Subtract         : dd(t)    = dd(t) - 2*REAL{cref*cfilt}

  use ft8_mod1, only : dd8,cw,NFILT1,NFILT2,endcorr,endcorrswl
! NMAX=15*12000,NFFT=15*12000,NFRAME=1920*79
  parameter (NFFT=180000,NMAX=180000,NFRAME=151680)
  complex cref(nframe),cfilt(nmax)
  integer itone(79)
  logical(1), intent(in) :: swl
  save cfilt
  !$omp threadprivate(cfilt)

  nstart=dt*12000+1
  call gen_ft8wave(itone,79,1920,2.0,12000.0,f0,cref,xjunk,1,NFRAME)
  do i=1,nframe
    id=nstart-1+i 
    if(id.ge.1.and.id.le.NMAX) then
      cfilt(i)=dd8(id)*conjg(cref(i))
    else
      cfilt(i)=0.0
    endif
  enddo
  cfilt(nframe+1:)=0.0
  call four2a(cfilt,nfft,1,-1,1)
  cfilt(1:nfft)=cfilt(1:nfft)*cw(1:nfft)
  call four2a(cfilt,nfft,1,1,1)
  if(.not.swl) then
    cfilt(1:NFILT1/2+1)=cfilt(1:NFILT1/2+1)*endcorr
    cfilt(nframe:nframe-NFILT1/2:-1)=cfilt(nframe:nframe-NFILT1/2:-1)*endcorr
  else
    cfilt(1:NFILT2/2+1)=cfilt(1:NFILT2/2+1)*endcorrswl
    cfilt(nframe:nframe-NFILT2/2:-1)=cfilt(nframe:nframe-NFILT2/2:-1)*endcorrswl
  endif
  do i=1,nframe
     j=nstart+i-1
     if(j.ge.1 .and. j.le.NMAX) dd8(j)=dd8(j)-2*REAL(cfilt(i)*cref(i))
  enddo
!!!$omp flush(dd8) ! makes no difference in number of decoded messages

  return
end subroutine subtractft8

program rsdtest

  real s3(64,63)
  character msg*22,arg*12
  integer param(0:7)

  nargs=iargc()
  if(nargs.ne.2) then
     print*,'Usage: rsdtest ntrials nfiles'
     go to 999
  endif
  call getarg(1,arg)
  read(arg,*) ntrials
  call getarg(2,arg)
  read(arg,*) nfiles

  open(10,file='s3_1000.bin',access='stream', status='old')
  open(22,file='kvasd.dat',access='direct',recl=1024,status='unknown')

  nadd=1
  ifile0=0
  if(nfiles.lt.0) then
     ifile0=-nfiles
     nfiles=99999
  endif

  do ifile=1,nfiles
     read(10,end=999) s3
     if(ifile.lt.ifile0) cycle
     call extract2(s3,nadd,ntrials,param,msg)
     if(ifile.eq.ifile0) exit
  enddo

999 end program rsdtest

! last time modified by Arvo ES1JA on 20191117

subroutine chkcrc12a(decoded,nbadcrc)

  use crc
  integer*1 decoded(87)
  integer*1, target:: i1Dec8BitBytes(11)
  character*87 cbits

! Write decoded bits into cbits: 75-bit message plus 12-bit CRC
  write(cbits,1000) decoded
1000 format(87i1)
  read(cbits,1001) i1Dec8BitBytes
1001 format(11b8)
  read(cbits,1002) ncrc12                         !Received CRC12
1002 format(75x,b12)

  i1Dec8BitBytes(10)=iand(i1Dec8BitBytes(10),transfer(128+64+32,0_1))
  i1Dec8BitBytes(11)=0
  icrc12=crc12(c_loc(i1Dec8BitBytes),11)          !CRC12 computed from 75 msg bits

  nbadcrc=1
  if(ncrc12.eq.icrc12) nbadcrc=0
  
  return
end subroutine chkcrc12a

subroutine filbig(f0,newfft,c4a,n4,sq0,c6a,n2)

! Filter and downsample the real data in array dd(npts), sampled at 12000 Hz.
! Output is complex, sampled at 1378.125 Hz.

  use, intrinsic :: iso_c_binding
  use FFTW3
  use timer_module, only: timer
  use jt65_mod5 !ref(3413)
  use jt65_mod6 !NPTS=624000 dd(NPTS)

  parameter (NFFT1=672000,NFFT2=77175,NFFT3=9646,NSZ=3413)
  parameter (NZ2=1000)
  
  real*4 rca(NFFT1)
  complex ca(NFFT1/2+1)                      !FFT of input
  complex c4a(NFFT2),c6a(NFFT3)              !Output data
  real*4 s(NZ2)
  integer i,j
  real halfpulse(15),halfpulse2(15)  !Impulse response of filter (one sided)
  complex cfilt(NFFT2),cfilt2(NFFT2)    !Filter (complex; imag = 0)
  real rfilt(NFFT2),rfilt2(NFFT2)     !Filter (real)
  type(C_PTR) :: plan1,plan2,plan3,plan4,plan5    !Pointers to FFTW plans
  logical first
  logical(1) newfft
  equivalence (rfilt,cfilt),(rfilt2,cfilt2),(rca,ca)
  data first/.true./

! Kaiser-Bessel FIR LPF  http://www.arc.id.au/FilterDesign.html
! fsample    (Hz)  12000      Input sample rate
! Ntaps            29          Number of filter taps
! fc         (Hz)  4353       Cutoff frequency
! dF/2       (Hz)  328        Half transition band
! Stop Atten (dB)  30        Stopband attenuation
! fout       (Hz)  1378.125   Output sample rate
  data halfpulse/0.725500000, 0.240786311, -0.154852552, 0.053941884, 0.022651887, -0.053126870, &
  0.041168005, -0.009120071, -0.017722128, 0.025226891, -0.015037961, -0.001056840, 0.011283798, &
 -0.011212205, 0.004348607/

! Kaiser-Bessel FIR LPF  http://www.arc.id.au/FilterDesign.html
! fsample    (Hz)  1378.125   Input sample rate
! Ntaps            29          Number of filter taps
! fc         (Hz)  86         Cutoff frequency
! dF/2       (Hz)  38        Half transition band
! Stop Atten (dB)  30        Stopband attenuation
! fout       (Hz)  172.265625   Output sample rate
   data halfpulse2/0.124952381, 0.121297716, 0.110774440, 0.094635363, 0.074749989, 0.053318415, &
  0.032545585, 0.014332629, 0.000036722, -0.009663997, -0.014785038, -0.015937306, -0.014143718, &
 -0.010611825, -0.006507996/
  common/patience/npatience,nthreads
  save first,plan1,plan2,plan3,plan4,plan5,rfilt,cfilt,rfilt2,cfilt2,ca

  if(f0.lt.0.) go to 900                    !Clean up at end of program

  nthreadsmin=nthreads !single JT65 mode
  if(nnmode.eq.74) then
    nthreadsmin=max(nthreads-1,1)
    if(nthreads.ge.8 .and. nthreads.lt.12) nthreadsmin=nthreads-2
    if(nthreads.ge.12) nthreadsmin=nthreads-3
  endif
  
  if(first) then
     nflags=FFTW_ESTIMATE
     if(npatience.eq.1) nflags=FFTW_ESTIMATE_PATIENT
     if(npatience.eq.2) nflags=FFTW_MEASURE
     if(npatience.eq.3) nflags=FFTW_PATIENT
     if(npatience.eq.4) nflags=FFTW_EXHAUSTIVE

! Plan the FFTs just once
     !$omp critical(fftw) ! serialize non thread-safe FFTW3 calls
     call fftwf_plan_with_nthreads(nthreadsmin)
     plan1=fftwf_plan_dft_r2c_1d(nfft1,rca,ca,nflags)
     plan2=fftwf_plan_dft_1d(nfft2,c4a,c4a,-1,nflags)
     plan3=fftwf_plan_dft_1d(nfft2,cfilt,cfilt,+1,nflags)
     call fftwf_plan_with_nthreads(1)
     plan4=fftwf_plan_dft_1d(nfft3,cfilt2,cfilt2,+1,nflags)
     plan5=fftwf_plan_dft_1d(nfft3,c6a,c6a,-1,nflags)
     !$omp end critical(fftw)

! Convert impulse response to filter function
     cfilt=0.
     cfilt2=0.
     fac=0.00625/nfft1
     fac2=0.03

     cfilt(1)=fac*halfpulse(1)
     cfilt2(1)=fac2*halfpulse2(1)
     do i=2,15
        cfilt(i)=fac*halfpulse(i)
        cfilt(nfft2+2-i)=fac*halfpulse(i)
     enddo
     do i=2,15
        cfilt2(i)=fac2*halfpulse2(i)
        cfilt2(nfft3+2-i)=fac2*halfpulse2(i)
     enddo

     call fftwf_execute_dft(plan3,cfilt,cfilt)
     call fftwf_execute_dft(plan4,cfilt2,cfilt2)

     base=real(cfilt(38588)) ! nfft2/2+1
     base2=real(cfilt2(nfft3/2+1))
     do i=1,nfft2
        rfilt(i)=real(cfilt(i))-base
     enddo
     do i=1,nfft3
        rfilt2(i)=real(cfilt2(i))-base2
     enddo
     first=.false.
  endif

! When new data comes along, we need to compute a new "big FFT"
! If we just have a new f0, continue with the existing data in ca.

  if(newfft) then
!     call timer('FFTbig  ',0)
     rca(1:npts)=dd(1:npts)
     rca(npts+1:)=0.

     call fftwf_execute_dft_r2c(plan1,rca,ca)
!     call timer('FFTbig  ',1)

     ib=0
     do j=1,NSZ
        ia=ib+1
        ib=nint(float(j)*(672000./8192)) ! NFFT1/NFFT
        if(ref(j).le.0.0) ref(j)=0.0001
        fac=sqrt(1.0/ref(j))
        ca(ia:ib)=fac*conjg(ca(ia:ib))
     enddo
  endif

! NB: f0 is the frequency at which we want our filter centered.
!     i0 is the bin number in ca closest to f0.
!  call timer('loops   ',0)
  i0=nint(f0*56.) + 1 ! f0/df where delta f = 12000/672000 = 1/56
  nh=38587 ! nfft2/2

  do i=1,nh                                !Copy data into c4a and apply
     j=i0+i-1                              !the filter function
     if(j.ge.1 .and. j.le.nfft1/2+1) then
        c4a(i)=rfilt(i)*ca(j)
     else
        c4a(i)=0.
     endif
  enddo
  do i=nh+1,nfft2
     j=i0+i-1-nfft2
     if(j.ge.1) then
        c4a(i)=rfilt(i)*ca(j)
     else
        c4a(i)=rfilt(i)*conjg(ca(2-j))
     endif
  enddo
  
  nh=nfft3/2
  do i=1,nh
     c6a(i)=rfilt2(i)*c4a(i)
  enddo
  do i=nh+1,nfft3
     c6a(i)=rfilt2(i)*c4a(nfft2-nfft3+i)
  enddo

  nadd=nfft2/(3.0*NZ2) ! 180Hz BW

  i=0
  do j=1,NZ2
     s(j)=0.
     do n=1,nadd
        i=i+1
        s(j)=s(j) + real(c4a(i))**2 + aimag(c4a(i))**2
     enddo
  enddo
  call pctile(s,NZ2,10,sq0)
  sq0=sq0*1.732 ! SQRT(3.0)
!  call timer('loops   ',1)

! Do the short reverse transform, to go back to time domain.
!  call timer('FFTsmall',0)
  call fftwf_execute_dft(plan2,c4a,c4a)
  call fftwf_execute_dft(plan5,c6a,c6a)
!  call timer('FFTsmall',1)
  n4=min(npts/8,nfft2)
  n2=nfft3

  return

900 continue

  !$omp critical(fftw) ! serialize non thread-safe FFTW3 calls
  call fftwf_destroy_plan(plan1)
  call fftwf_destroy_plan(plan2)
  call fftwf_destroy_plan(plan3)
  call fftwf_destroy_plan(plan4)
  call fftwf_destroy_plan(plan5)
  !$omp end critical(fftw)
  
  return
end subroutine filbig

subroutine sync8d(cd0,i0,ctwk,itwk,sync,ipass,lastsync,iqso,lcq,lcallsstd,lcqcand)

! Compute sync power for a complex, downsampled FT8 signal.
  use ft8_mod1, only : csync,csynce,csyncsd,csyncsdcq,csynccq

  complex, intent(in) :: cd0(-800:4000),ctwk(32)
  complex csync1(0:18,32),csync2(32),z1,z2,z3,z4,zt1(0:6),zt2(0:6),zt3(0:6),zt4(0:7),zt5(0:18), &
          z11(224),z22(224),z33(224)
  real sync1(0:20)!,sync2(0:20)
  integer, intent(in) :: i0,ipass,iqso
  logical(1), intent(in) :: lcq,lcallsstd,lcqcand
  logical(1) lastsync

  sync=0.; sync1=0.; zt1=0.; zt2=0.; zt3=0.; z11=0.; z22=0.; z33=0.!; sync2=0.
  k=1
  do i=0,6 ! Sum over 7 Costas frequencies and three Costas arrays
    i1=i0+i*32; i2=i1+1152; i3=i1+2304 ! +36*32, +72*32
    csync2=csync(i,1:32)
    if(itwk.eq.1) csync2=ctwk*csync2      !Tweak the frequency
    z11(k:k+31)=cd0(i1:i1+31)*conjg(csync2);  z22(k:k+31)=cd0(i2:i2+31)*conjg(csync2)
    z33(k:k+31)=cd0(i3:i3+31)*conjg(csync2)
    zt1(i)=sum(z11(k:k+31)); zt2(i)=sum(z22(k:k+31)); zt3(i)=sum(z33(k:k+31))
    k=k+32
  enddo
  if(ipass.eq.1 .or. ipass.eq.5 .or. ipass.eq.9) then
    if(.not.lastsync) then
      do i=0,6
        sync1(i) = SQRT(real(zt1(i))**2 + aimag(zt1(i))**2)
        sync1(i+7) = SQRT(real(zt2(i))**2 + aimag(zt2(i))**2)
        sync1(i+14) = SQRT(real(zt3(i))**2 + aimag(zt3(i))**2)
      enddo
      sync=sum(sync1)
    else
      do i=0,6
        sync = sync + real(zt1(i))**2 + aimag(zt1(i))**2 + real(zt2(i))**2 + aimag(zt2(i))**2 + real(zt3(i))**2 + &
          aimag(zt3(i))**2
      enddo
    endif
  else if(ipass.eq.2 .or. ipass.eq.6 .or. ipass.eq.7) then
    if(.not.lastsync) then
      do i=0,6
        sync1(i) = real(zt1(i))**2 + aimag(zt1(i))**2
        sync1(i+7) = real(zt2(i))**2 + aimag(zt2(i))**2
        sync1(i+14) = real(zt3(i))**2 + aimag(zt3(i))**2
      enddo
      sync=sum(sync1)
    else
      do i=0,6
        sync = sync + real(zt1(i))**2 + aimag(zt1(i))**2 + real(zt2(i))**2 + aimag(zt2(i))**2 + real(zt3(i))**2 + &
          aimag(zt3(i))**2
      enddo
    endif
  else ! if(ipass.eq.3 .or. ipass.eq.4 .or. ipass.eq.8)  then
    do i=0,6
      if(i.lt.6) then
        z1=(zt1(i)+zt1(i+1))/2; z2=(zt2(i)+zt2(i+1))/2; z3=(zt3(i)+zt3(i+1))/2 ! use i=5 z values for i=6
      endif
      if(.not.lastsync) then
        sync = sync + abs(real(z1)) + abs(aimag(z1)) + abs(real(z2)) + abs(aimag(z2)) + abs(real(z3)) + abs(aimag(z3))
      else
        sync = sync + real(z1)**2 + aimag(z1)**2 + real(z2)**2 + aimag(z2)**2 + real(z3)**2 + aimag(z3)**2
      endif
    enddo
  endif

  if(itwk.eq.1 .and. lcqcand .and. iqso.eq.1) then
    zt4=0.
    do i=0,7
      csync2=csynccq(i,1:32); csync2=ctwk*csync2      !Tweak the frequency
      i4=i0+(i+7)*32; zt4(i)=sum(cd0(i4:i4+31)*conjg(csync2))
    enddo
    do i=0,7
      if(ipass.eq.3 .or. ipass.eq.4 .or. ipass.eq.8)  then
        if(i.lt.7) z4=(zt4(i)+zt4(i+1))/2 ! use i=6 z4 value for i=7
      else
       z4=zt4(i)
      endif
      if(ipass.eq.1 .or. ipass.eq.5 .or. ipass.eq.9) then; sync = sync + SQRT(real(z4)**2 + aimag(z4)**2)
      else if(ipass.eq.2 .or. ipass.eq.6 .or. ipass.eq.7) then; sync = sync + real(z4)**2 + aimag(z4)**2
      else if(ipass.eq.3 .or. ipass.eq.4 .or. ipass.eq.8) then; sync = sync + abs(real(z4)) + abs(aimag(z4))
      endif
    enddo
  endif

  if(.not.lastsync) then
    if(iqso.gt.1 .and. iqso.lt.4 .and. lcallsstd) csync1=csynce; if(iqso.eq.4 .and. .not.lcq) csync1=csyncsd

    if((iqso.eq.4 .and. .not.lcq) .or. ((iqso.eq.2 .or. iqso.eq.3) .and. lcallsstd)) then
      zt5=0.
      do i=0,18
        csync2=csync1(i,1:32)
        if(itwk.eq.1) csync2=ctwk*csync2      !Tweak the frequency
        i4=i0+(i+7)*32; zt5(i)=sum(cd0(i4:i4+31)*conjg(csync2))
      enddo
      do i=0,18
        if(ipass.eq.2 .or. ipass.eq.6 .or. ipass.eq.7)  then
          if(i.lt.18) z4=(zt5(i)+zt5(i+1))/2 ! use i=17 z4 value for i=18
        else
         z4=zt5(i)
        endif
        if(ipass.eq.1 .or. ipass.eq.5 .or. ipass.eq.9) then; sync = sync + SQRT(real(z4)**2 + aimag(z4)**2)
        else if(ipass.eq.2 .or. ipass.eq.6 .or. ipass.eq.7) then; sync = sync + real(z4)**2 + aimag(z4)**2
        else if(ipass.eq.3 .or. ipass.eq.4 .or. ipass.eq.8) then; sync = sync + abs(real(z4)) + abs(aimag(z4))
        endif
      enddo
    endif

    if(iqso.eq.4 .and. lcq) then
      do i=0,57
        csync2=csyncsdcq(i,1:32)
        if(itwk.eq.1) csync2=ctwk*csync2      !Tweak the frequency
        z4=0.; if(i.lt.29) then; k=i+7; else; k=i+14; endif
        i4=i0+k*32; z4=sum(cd0(i4:i4+31)*conjg(csync2))
        if(ipass.eq.1 .or. ipass.eq.5 .or. ipass.eq.9) then; sync = sync + SQRT(real(z4)**2 + aimag(z4)**2)
          else if(ipass.eq.2 .or. ipass.eq.6 .or. ipass.eq.7) then; sync = sync + real(z4)**2 + aimag(z4)**2
          else if(ipass.eq.3 .or. ipass.eq.4 .or. ipass.eq.8) then; sync = sync + abs(real(z4)) + abs(aimag(z4))
        endif
      enddo
    endif
  endif

  return
end subroutine sync8d

subroutine polyfit(x,y,sigmay,npts,nterms,mode,a,chisqr)
  implicit real*8 (a-h,o-z)
  real*8 x(npts), y(npts), sigmay(npts), a(nterms)
  real*8 sumx(19), sumy(10), array(10,10)

! Accumulate weighted sums
  nmax = 2*nterms-1
  sumx=0.
  sumy=0.
  chisq=0.
  do i=1,npts
     xi=x(i)
     yi=y(i)
     if(mode.lt.0) then
        weight=1./abs(yi)
     else if(mode.eq.0) then
        weight=1
     else
        weight=1./sigmay(i)**2
     end if
     xterm=weight
     do n=1,nmax
        sumx(n)=sumx(n)+xterm
        xterm=xterm*xi
     enddo
     yterm=weight*yi
     do n=1,nterms
        sumy(n)=sumy(n)+yterm
        yterm=yterm*xi
     enddo
     chisq=chisq+weight*yi**2
  enddo

! Construct matrices and calculate coefficients
  do j=1,nterms
     do k=1,nterms
        n=j+k-1
        array(j,k)=sumx(n)
     enddo
  enddo

  delta=determ(array,nterms)
  if(delta.eq.0) then
     chisqr=0.
     a=0.
  else
     do l=1,nterms
        do j=1,nterms
           do k=1,nterms
              n=j+k-1
              array(j,k)=sumx(n)
           enddo
           array(j,l)=sumy(j)
        enddo
        a(l)=determ(array,nterms)/delta
     enddo

! Calculate chi square

     do j=1,nterms
        chisq=chisq-2*a(j)*sumy(j)
        do k=1,nterms
           n=j+k-1
           chisq=chisq+a(j)*a(k)*sumx(n)
        enddo
     enddo
     free=npts-nterms
     chisqr=chisq/free
  end if
  
  return
end subroutine polyfit

subroutine extractmessage174(decoded,msgreceived,ncrcflag)
  use iso_c_binding, only: c_loc,c_size_t
  use crc
  use packjt

  character*22 msgreceived
  character*87 cbits
  integer*1 decoded(87)
  integer*1, target::  i1Dec8BitBytes(11)
  integer*4 i4Dec6BitWords(12)

! Write decoded bits into cbits: 75-bit message plus 12-bit CRC
  write(cbits,1000) decoded
1000 format(87i1)
  read(cbits,1001) i1Dec8BitBytes
1001 format(11b8)
  read(cbits,1002) ncrc12                         !Received CRC12
1002 format(75x,b12)

  i1Dec8BitBytes(10)=iand(i1Dec8BitBytes(10),transfer(128+64+32,0_1))
  i1Dec8BitBytes(11)=0
  icrc12=crc12(c_loc(i1Dec8BitBytes),11)          !CRC12 computed from 75 msg bits

  if(ncrc12.eq.icrc12 .or. sum(decoded(57:87)).eq.0) then
! CRC12 checks out --- unpack 72-bit message
    do ibyte=1,12
      itmp=0
      do ibit=1,6
        itmp=ishft(itmp,1)+iand(transfer(1,0_1),decoded((ibyte-1)*6+ibit))
      enddo
      i4Dec6BitWords(ibyte)=itmp
    enddo
    call unpackmsg(i4Dec6BitWords,msgreceived)
    ncrcflag=1
  else
    msgreceived=' '
    ncrcflag=-1
  endif 
  return
  end subroutine extractmessage174

! This source code file was last time modified by Igor UA3DJY on 20181215
! All changes are shown in the patch file coming together with the full JTDX source code.

subroutine hintdxrr(mrs,mrs2,mycall,hiscall,decoded,hint_dx)

  use packjt
  use jt65_mod2, only : s3,correct_hint

  parameter (MAXRPT=30)
  parameter (MAXMSG=MAXRPT)
  real u1
  integer mrs(63),mrs2(63),sym2(0:62,MAXMSG),dgen(12),sym_rev(0:62)
  logical(1) hint_dx
  character mycall*6,hiscall*6,msg*22,msg00*22,decoded*22,prevcall*6
  character*4 rpt(MAXRPT)
  character*22 msg0(MAXMSG)

  data rpt/'R-01','R-02','R-03','R-04','R-05',     &
           'R-06','R-07','R-08','R-09','R-10',     &
           'R-11','R-12','R-13','R-14','R-15',     &
           'R-16','R-17','R-18','R-19','R-20',     &
           'R-21','R-22','R-23','R-24','R-25',     &
           'R-26','R-27','R-28','R-29','R-30'/

  save msg0,sym2,prevcall

  hint_dx=.false.
  do i=1,6
   if(hiscall(i:i).eq.'/') return
  enddo

  if(hiscall.eq.prevcall) then
     go to 2
  else
     prevcall=hiscall
  endif
  
        do m=1,MAXMSG
           msg=mycall//' '//hiscall//' '//rpt(m)
           call fmtmsg(msg,iz)
           call packmsg(msg,dgen,itype)            !Pack message into 72 bits
           call rs_encode(dgen,sym_rev)            !RS encode
           call interleave63(sym_rev,1)            !Interleave channel symbols
           call graycode(sym_rev,63,1,sym_rev)     !Apply Gray code
           sym2(0:62,m)=sym_rev(0:62)
           msg0(m)=msg
        enddo

2  ref0=0.
  do i=1,63
     do j=1,63
        ref0=ref0 + s3(mrs(j)+1,i)
     enddo
  enddo

  u1=-99.0
  u2=u1

! Find u1 and u2 (best and second-best) codeword from a list, using 
! a bank of matched filters on the symbol spectra s3(i,j).
  ipk=1
  msg00='                      '
  do k=1,MAXMSG
        psum=0.
        ref=ref0
        do j=1,63
           i=sym2(j-1,k)+1
           psum=psum + s3(i,j)
           if(i.eq.mrs(j)+1) ref=ref - s3(i,j) + s3(mrs2(j)+1,j)
        enddo
        p=psum*63.0/ref

        if(p.gt.u1) then
           if(msg0(k).ne.msg00) u2=u1
           u1=p
           ipk=k
           msg00=msg0(k)
        endif
        if(msg0(k).ne.msg00 .and. p.gt.u2) u2=p
  enddo

  decoded='                      '
  bias=max(1.12*u2,0.35)
  qual=100.0*(u1-bias)
  thresh=(qual+20.0)*(u1-1.0)
! maximizing sensitivity .and. blocking some false decodes
  if((qual.ge.-2.0 .or. u1.ge.1.4) .and. thresh.gt.6.5) then


    decoded=msg0(ipk)
!print *,qual,u1,thresh
!print *,qual,thresh
!print *,decoded
    hint_dx=.true.
    correct_hint(1:63)=sym2(0:62,ipk)
  endif 
  return
end subroutine hintdxrr

! This source code file was last time modified by Igor UA3DJY on September 30th, 2018
! All changes are shown in the patch file coming together with the full JTDX source code.

program jt9

! Decoder for JT9. Can run as the back end of JTDX only, with data placed in a shared memory region.

  use options
  use prog_args
  use, intrinsic :: iso_c_binding
  use FFTW3
!  use timer_module, only: timer
!  use timer_impl, only: init_timer, fini_timer
!  use readwav

  include 'jt9com.f90'

  integer(C_INT) iret
!  type(wav_header) wav
  character c
  character(len=500) optarg
  character wisfile*80
  integer :: arglen,stat,offset,remain,mode=0,flow=200,fsplit=2700,          &
       fhigh=4000,nrxfreq=1500,ntrperiod=1,ndepth=1
  logical :: read_files = .true., tx9 = .false., display_help = .false.
  type (option) :: long_options(22) = [ &
    option ('help', .false., 'h', 'Display this help message', ''),          &
    option ('shmem',.true.,'s','Use shared memory for sample data','KEY'),   &
    option ('tr-period', .true., 'p', 'Tx/Rx period, default MINUTES=1',     &
        'MINUTES'),                                                          &
    option ('executable-path', .true., 'e',                                  &
        'Location of subordinate executables (KVASD) default PATH="."',      &
        'PATH'),                                                             &
    option ('data-path', .true., 'a',                                        &
        'Location of writeable data files, default PATH="."', 'PATH'),       &
    option ('temp-path', .true., 't',                                        &
        'Temporary files path, default PATH="."', 'PATH'),                   &
    option ('share-path', .true., 'r',                                       &
        'Share files path, default PATH="."', 'PATH'),                       &
    option ('lowest', .true., 'L',                                           &
        'Lowest frequency decoded (JT65), default HERTZ=200', 'HERTZ'),      &
    option ('highest', .true., 'H',                                          &
        'Highest frequency decoded, default HERTZ=4007', 'HERTZ'),           &
    option ('split', .true., 'S',                                            &
        'Lowest JT9 frequency decoded, default HERTZ=2700', 'HERTZ'),        &
    option ('rx-frequency', .true., 'f',                                     &
        'Receive frequency offset, default HERTZ=1500', 'HERTZ'),            &
    option ('patience', .true., 'w',                                         &
        'FFTW3 planing patience (0-4), default PATIENCE=1', 'PATIENCE'),     &
    option ('fft-threads', .true., 'm',                                      &
        'Number of threads to process large FFTs, default THREADS=1',        &
        'THREADS'),                                                          &
    option ('jt65', .false., '6', 'JT65 mode', ''),                          &
    option ('jt9', .false., '9', 'JT9 mode', ''),                            &
    option ('sub-mode', .true., 'b', 'Sub mode, default SUBMODE=A', 'A'),    &
    option ('depth', .true., 'd',                                            &
        'JT9 decoding depth (1-3), default DEPTH=1', 'DEPTH'),               &
    option ('tx-jt9', .false., 'T', 'Tx mode is JT9', ''),                   &
    option ('my-call', .true., 'c', 'my callsign', 'CALL'),                  &
    option ('my-grid', .true., 'G', 'my grid locator', 'GRID'),              &
    option ('his-call', .true., 'x', 'his callsign', 'CALL'),                &
    option ('his-grid', .true., 'g', 'his grid locator', 'GRID') ]

  character(len=12) :: mycall, hiscall
  character(len=6) :: mygrid, hisgrid
  common/patience/npatience,nthreads
  data npatience/1/,nthreads/1/

  nsubmode = 0

  do
     call getopt('hs:e:a:b:r:m:p:d:f:w:t:964TL:S:H:c:G:x:g:',long_options,c,   &
          optarg,arglen,stat,offset,remain,.true.)
     if (stat .ne. 0) then
        exit
     end if
     select case (c)
        case ('h')
           display_help = .true.
        case ('s')
           read_files = .false.
           shm_key = optarg(:arglen)
        case ('e')
           exe_dir = optarg(:arglen)
        case ('a')
           data_dir = optarg(:arglen)
        case ('r')
           share_dir = optarg(:arglen)
        case ('b')
           nsubmode = ichar (optarg(:1)) - ichar ('A')
        case ('t')
           temp_dir = optarg(:arglen)
        case ('m')
           read (optarg(:arglen), *) nthreads
        case ('p')
           read (optarg(:arglen), *) ntrperiod
        case ('d')
           read (optarg(:arglen), *) ndepth
        case ('f')
           read (optarg(:arglen), *) nrxfreq
        case ('L')
           read (optarg(:arglen), *) flow
        case ('S')
           read (optarg(:arglen), *) fsplit
        case ('H')
           read (optarg(:arglen), *) fhigh
        case ('4')
           mode = 4
        case ('6')
           if (mode.lt.65) mode = mode + 65
        case ('9')
           if (mode.lt.9.or.mode.eq.65) mode = mode + 9
        case ('T')
           tx9 = .true.
        case ('w')
           read (optarg(:arglen), *) npatience
        case ('c')
           read (optarg(:arglen), *) mycall
        case ('G')
           read (optarg(:arglen), *) mygrid
        case ('x')
           read (optarg(:arglen), *) hiscall
        case ('g')
           read (optarg(:arglen), *) hisgrid
     end select
  end do

  if (display_help .or. stat .lt. 0                      &
       .or. (.not. read_files .and. remain .gt. 0)       &
       .or. (read_files .and. remain .lt. 1)) then
!
!     print *, 'Usage: jt9 [OPTIONS] file1 [file2 ...]'
!     print *, '       Reads data from *.wav files.'
!     print *, ''
!     print *, '       jt9 -s <key> [-w patience] [-m threads] [-e path] [-a path] [-t path]'
!     print *, '       Gets data from shared memory region with key==<key>'
!     print *, ''
!     print *, 'OPTIONS:'
!     print *, ''
!     do i = 1, size (long_options)
!       call long_options(i) % print (6)
!     end do
     go to 999
  endif

  iret=fftwf_init_threads()            !Initialize FFTW threading 

! Default to 1 thread, but use nthreads for the big ones
  call fftwf_plan_with_nthreads(1)

! Import FFTW wisdom, if available
  wisfile=trim(data_dir)//'/jt9_wisdom.dat'// C_NULL_CHAR
  iret=fftwf_import_wisdom_from_filename(wisfile)

  if (.not. read_files) call jt9a()          !We're running under control of WSJT-X

999 continue

! Save wisdom and free memory
  iret=fftwf_export_wisdom_to_filename(wisfile)
  call four2a(a,-1,1,1,1)
  call filbig(-1.,0,0.,0,0.,0.,0)        !used for FFT plans
  call fftwf_cleanup_threads()
  call fftwf_cleanup()
end program jt9

! This source code file was last time modified by Igor Chernikov UA3DJY on December 14th, 2016.
! All changes are shown in the patch file coming together with the full JTDX source code.

subroutine filtersde(decoded,falsedec)

  integer, parameter :: EGRIDMAX=111
  character grid*4,call2*6,decoded*22
  logical(1) falsedec
    character*2 egrid(EGRIDMAX)&
  /'AA','AB','AC','AD','AF','AM','AN','AR','BA','BB','BC','BD','BE','BF','BM','BN','CA','CB','CC','CD', &
   'CE','CF','CL','CK','CJ','CR','DA','DB','DC','DD','DE','DF','DH','DI','DJ','DR','EA','EB','EC','ED', &
   'EE','EF','EG','EH','ER','FA','FB','GA','GB','GE','GL','GM','GR','HA','HB','HC','HE','HF','HG','HJ', &
   'HL','HN','HO','HR','IA','IB','IC','ID','IE','IG','JA','JB','JC','JE','JR','KA','KB','KC','KD','KR', &
   'LA','LB','LC','LD','LF','LQ','MA','MB','MG','MR','NA','NB','NC','ND','NE','NF','NG','PA','PC','PD', &
   'PE','QA','QB','QC','RA','RC','RL','RM','RN','RQ','RR'/

! check for false "DE " decodes

  i1=index(decoded,' ')
  i2=index(decoded(i1+1:),' ')
  if(i2.lt.4) go to 2
  i2=i2+i1

  call2=decoded(i1+1:i2-1)
  if(i2.gt.18) go to 2 ! avoid getting out of decoded*22
  grid=decoded(i2+1:i2+4)
  
  if(call2(1:1).eq."0" .or. call2(1:1).eq."Q") go to 2
  
  if(call2(1:1).ge.'0' .and. call2(1:1).le.'9' .and. &
     call2(2:2).ge.'0' .and. call2(2:2).le.'9') go to 2

  do i=1,EGRIDMAX
     if(grid(1:2).eq.egrid(i)) go to 2
  enddo

  if((grid(1:2).eq."GK" .and. grid(1:4).ne."GK03") .or. &
     (grid(1:2).eq."IF" .and. grid(1:4).ne."IF32") .or. &
     (grid(1:2).eq."IH" .and. grid(1:4).ne."IH74") .or. &
     (grid(1:2).eq."II" .and. grid(1:4).ne."II22") .or. &
     (grid(1:2).eq."JD" .and. grid(1:4).ne."JD15") .or. &
     (grid(1:2).eq."KE" .and. grid(1:4).ne."KE83") .or. &
      grid(1:3).eq."KF7" .or. &
     (grid(1:2).eq."LE" .and. grid(1:3).ne."LE5" .and. grid(1:3).ne."LE6") .or. &
      grid(1:4).eq."LJ08" .or. &
     (grid(1:2).eq."PB" .and. grid(1:4).ne."PB14") .or. &
      grid(1:4).eq."PI83" .or. &
     (grid(1:3).eq."PO8" .and. grid(1:4).ne."PO80") .or. &
      grid(1:3).eq."PP8" .or. grid(1:3).eq."PQ8" .or. &
     (grid(1:2).eq."QL" .and. grid(1:3).ne."QL0" .and. grid(1:3).ne."QL1") .or. &
     (grid(1:2).eq."RB" .and. grid(1:4).ne."RB25" .and. grid(1:4).ne."RB32") .or. &
     (grid(1:2).eq."RK" .and. grid(1:4).ne."RK39"))  go to 2


  go to 4

2 falsedec=.true.; return

4 return
end subroutine filtersde

subroutine inter_wspr(id,ndir)

! Interleave (ndir=1) or de-interleave (ndir=-1) the array id.

  integer*1 id(0:161),itmp(0:161)
  integer j0(0:161)
  logical first
  data first/.true./
  save

  if(first) then
! Compute the interleave table using bit reversal.
     k=-1
     do i=0,255
        n=0
        ii=i
        do j=0,7
           n=n+n
           if(iand(ii,1).ne.0) n=n+1
           ii=ii/2
        enddo
        if(n.le.161) then
           k=k+1
           j0(k)=n
        endif
     enddo
     first=.false.
  endif

  if(ndir.eq.1) then
     do i=0,161
        itmp(j0(i))=id(i)
     enddo
  else
     do i=0,161
        itmp(i)=id(j0(i))
     enddo
  endif

  do i=0,161
     id(i)=itmp(i)
  enddo

  return
end subroutine inter_wspr

! This source code file was last time modified by Igor UA3DJY on April 29th, 2017
! All changes are shown in the patch file coming together with the full JTDX source code.

subroutine chkss10(ss2,freq,drift,schk,qualf,syncro)

  real ss2(0:9,85)
  real s(0:9,85)
  include 'jt10sync.f90'

  ave=sum(ss2)/(10*85)
  if(freq+drift.eq.-999999.0) ave=1.0 ! 0.      !To silence compiler warning
  s=ss2/ave !-1.0

  s1=0.
  do i=1,16
     j=ii(i)
     if(j.le.85) then
        if(lsync(i)) s1=s1 + s(0,j)
        if(.not.lsync(i)) s1=s1 + s(1,j)
     endif
  enddo
  schk=s1/16.0

  ssig1=0.; ssig2=0.; snoise=0.; syncro=0.
  do i=1,85
     if(isync(i).eq.0) snoise=snoise+ss2(0,i)+ss2(1,i)
     if(isync(i).eq.1) then; ssig1=ssig1+ss2(0,i); snoise=snoise+ss2(1,i); endif
     if(isync(i).eq.2) then; ssig2=ssig2+ss2(1,i); snoise=snoise+ss2(0,i); endif
  enddo
  qualf=9.625*(ssig1+ssig2)/snoise !(170-16)/16=9.625  sync/noise tone ratio
  syncro=ssig1/ssig2

!print *,schk,qualf

  return
end subroutine chkss10

! This source code file was last time modified by Igor UA3DJY on August 19th, 2017
! All changes are shown in the patch file coming together with the full JTDX source code.

subroutine decode65b(s2,s2b,s2c,ntrials,hint_on,mycall,hiscall,hisgrid,nft,decoded,hintedrxfreq,hint, &
           npass1,hintedw,bypass_hintcq,bypass_hintall,bypass_ftrsd,offset1,nstophint,freemsg,hinteddyn,&
           dt,hintedrxfdt,nlasttx,ipass,sync2,isfalse,jt65bc,nharmonicsdepth,showharmonics)

  use jt65_mod2, only : s3
  use jt65_mod4 ! prc(126)
  
  real s2(66,126),s2b(66,126),s2c(66,126),s3b(64,63),s3c(64,63),syncpwr,storedsyncpwr1
  character mycall*12,hiscall*12,hisgrid*6,decoded*22,hint*1,isfalse*1
  integer mdat(63),nft
  logical(1) hintedrxfreq,hintedw,freemsg,hint_on,msg_decoded,bypass_hintcq, &
             bypass_ftrsd,npass1,first,offset1,bypass_hintall,nstophint,hinteddyn, &
             hintedrxfdt,jt65bc(2),showharmonics
  data first/.true./,storedsyncpwr1/0.0/
  save first,mdat,storedsyncpwr1

  if(first) then ! Determine locations of data and reference symbols
  nsym=126

  m=0
  do i=1,nsym
     if(.not.prc(i)) then
        m=m+1
        mdat(m)=i
     endif
  enddo
  first=.false.
  endif

! dupe candidates have the same sync signal power shall not go to decoders
  syncpwr=0.
  do i=1,126
     if(prc(i)) then
        syncpwr=syncpwr+s2(1,i)
     endif
  enddo
  if(syncpwr.eq.storedsyncpwr1) then
     nft=0
     decoded='                      '
     msg_decoded=.false.
     return
  endif
  if(offset1) storedsyncpwr1=syncpwr
  
  do j=1,63
     k=mdat(j)                       !Points to data symbol
     do i=1,64
        s3(i,j)=s2(i+2,k)
        s3b(i,j)=s2b(i+2,k)
        s3c(i,j)=s2c(i+2,k)
     enddo
  enddo
  
  call extract(s3b,s3c,ntrials,hint_on,mycall,hiscall,hisgrid,msg_decoded,decoded, &
               freemsg,nft,hintedrxfreq,hint,npass1,hintedw,bypass_hintcq, &
               bypass_hintall,bypass_ftrsd,nstophint,hinteddyn,dt,hintedrxfdt,syncpwr, &
               nlasttx,ipass,sync2,isfalse,jt65bc,nharmonicsdepth,showharmonics)

  return
end subroutine decode65b

subroutine flat4(s,npts0,nflatten)

! Flatten a spectrum for optimum display
! Input:  s(npts)    Linear scale in power
!         nflatten   If nflatten=0, convert to dB but do not flatten
! Output: s(npts)    Flattened, with dB scale


  implicit real*8 (a-h,o-z)
  real*4 s(6827)
  real*4 base
  real*8 x(1000),y(1000),a(5)
  data nseg/10/,npct/10/

  npts=min(6827,npts0)
  if(s(1).gt.1.e29) go to 900         !Boundary between Rx intervals: do nothing
  do i=1,npts
     s(i)=10.0*log10(s(i))
  enddo
  if(nflatten.eq.0) go to 900

  nlen=npts/nseg                      !Length of test segment
  i0=npts/2                           !Midpoint
  k=0
  do n=1,nseg                         !Skip first segment, likely rolloff here
     ib=n*nlen
     ia=ib-nlen+1
     if(n.eq.nseg) ib=npts
     call pctile(s(ia),ib-ia+1,npct,base) !Find lowest npct of points in segment
     do i=ia,ib
        if(s(i).le.base) then
           if (k.lt.1000) k=k+1       !Save these "lower envelope" points
           x(k)=i-i0
           y(k)=s(i)
        endif
     enddo
  enddo
  kz=k
  a=0.
  nterms=5
  
  call polyfit(x,y,y,kz,nterms,0,a,chisqr)  !Fit a low-order polynomial

  do i=1,npts
     t=i-i0
     yfit=a(1)+t*(a(2)+t*(a(3)+t*(a(4)+t*(a(5)))))
     s(i)=s(i)-yfit                    !Subtract the fitted baseline
  enddo

900 return
end subroutine flat4

subroutine deg2grid(dlong0,dlat,grid)

  real dlong                        !West longitude (deg)
  real dlat                         !Latitude (deg)
  character grid*6

  dlong=dlong0
  if(dlong.lt.-180.0) dlong=dlong+360.0
  if(dlong.gt.180.0) dlong=dlong-360.0

! Convert to units of 5 min of longitude, working east from 180 deg.
  nlong=int(60.0*(180.0-dlong)/5.0)
  n1=nlong/240                      !20-degree field
  n2=(nlong-240*n1)/24              !2 degree square
  n3=nlong-240*n1-24*n2             !5 minute subsquare
  grid(1:1)=char(ichar('A')+n1)
  grid(3:3)=char(ichar('0')+n2)
  grid(5:5)=char(ichar('a')+n3)

! Convert to units of 2.5 min of latitude, working north from -90 deg.
  nlat=int(60.0*(dlat+90)/2.5)
  n1=nlat/240                       !10-degree field
  n2=(nlat-240*n1)/24               !1 degree square
  n3=nlat-240*n1-24*n2              !2.5 minuts subsquare
  grid(2:2)=char(ichar('A')+n1)
  grid(4:4)=char(ichar('0')+n2)
  grid(6:6)=char(ichar('a')+n3)

  return
end subroutine deg2grid

! This source code file was last time modified by Igor Chernikov UA3DJY on September 21st, 2016.
! All changes are shown in the patch file coming together with the full JTDX source code.


subroutine fil6521(c1,n1,c3,n2)

  integer, parameter :: NTAPS=21,NDOWN=8
  integer, parameter :: NH=NTAPS/2
  complex c1(n1),c2(n1/NDOWN),c3(n1/NDOWN)

! Filter coefficients:
  real b(-NH:NH)
! Kaiser-Bessel FIR LPF  http://www.arc.id.au/FilterDesign.html
! fsample    (Hz)  172.265625   Input sample rate
! Ntaps            21         Number of filter taps
! fc         (Hz)  1          Cutoff frequency
! dF/2       (Hz)  25         Half transition band
! Stop Atten (dB)  90         Stopband attenuation
! fout       (Hz)  172.265625    Output sample rate  
data b/0.000011, 0.000113, 0.000416, 0.001058, 0.002158, 0.003751, 0.005737, &
0.007870, 0.009797, 0.011144, 0.011628, 0.011144, 0.009797, 0.007870, &
0.005737, 0.003751, 0.002158, 0.001058, 0.000416, 0.000113, 0.000011/

  n2=n1/NDOWN
  k0=NDOWN/2
  c2=0.
! Loop over all output samples
  do i=1,n2
     k=k0 + NDOWN*i
        c2(i)=c1(k)
  enddo

  c3=0.
  do i=1,n2
    do j=-NH,NH
    if(i.le.NH .or. i.gt.(n2-NH)) cycle
      c3(i)=c3(i)+c2(i+j)*b(j)
    enddo
  enddo
  c3=c3*540.0
  return
end subroutine fil6521

subroutine fillhash(numthreads,lfill)

  use packjt77 ! also setting mycall13,dxcall13
  use ft8_mod1, only : mycall,hiscall
  integer, intent(in) :: numthreads
  logical, intent(in) :: lfill
  character*13 cw

  if(lfill) then
    do i=1,numthreads
      do m=1,nlast_calls(i)
        nposition=nthrindex(i)+m
        cw=last_calls(nposition)
!print *,i,m,cw
        n10=ihashcall(cw,10)
        if(n10.ge.0 .and. n10 .le. 1023 .and. cw.ne.mycall13) calls10(n10)=cw

        n12=ihashcall(cw,12)
        if(n12.ge.0 .and. n12 .le. 4095 .and. cw.ne.mycall13) calls12(n12)=cw

        n22=ihashcall(cw,22)
        if(any(ihash22.eq.n22)) then   ! If entry exists, make sure callsign is the most recently received one
          where(ihash22.eq.n22) calls22=cw
          go to 900
        endif

! New entry: move table down, making room for new one at the top
        ihash22(nzhash:2:-1)=ihash22(nzhash-1:1:-1)

! Add the new entry
        calls22(nzhash:2:-1)=calls22(nzhash-1:1:-1)
        ihash22(1)=n22
        calls22(1)=cw
        if(nzhash.lt.MAXHASH) nzhash=nzhash+1
900     continue
      enddo
    enddo
  else
    nlast_calls=0
    mycall13=mycall//' '; dxcall13=hiscall//' '
    if(mycall13.ne.mycall13_0) then
      if(len(trim(mycall13)).gt.2) then
        mycall13_set=.true.
        mycall13_0=mycall13
        call save_hash_mycall(mycall13,hashmy10,hashmy12,hashmy22)
!print *,mycall13,hashmy10,hashmy12,hashmy22
      else
        mycall13_set=.false.
      endif
    endif

    if(dxcall13.ne.dxcall13_0) then
      if(len(trim(dxcall13)).gt.2) then
        dxcall13_set=.true.
        dxcall13_0=dxcall13
        hashdx10=ihashcall(dxcall13,10)
! make sure new DX Call is stored in hash tables prior to decoding
! it is needed if manually callsign set in DX Call window was not decoded before
        call save_hash_call(dxcall13,1)
!print *,dxcall13,hashdx10
      else
        dxcall13_set=.false.
      endif
    endif
  endif

  return
end subroutine fillhash

subroutine filt8(f0,nslots,width,wave)

  parameter (NFFT=180000,NH=NFFT/2)
  real wave(NFFT)
  real x(NFFT)
  real s1(0:NH)
  real s2(0:NH)
  complex cx(0:NH)
  equivalence (x,cx)

  x=wave
  call four2a(cx,NFFT,1,-1,0)              !r2c
  df=12000.0/NFFT
  fa=f0 - 0.5*6.25
  fb=f0 + 7.5*6.25 + (nslots-1)*60.0
  ia2=nint(fa/df)
  ib1=nint(fb/df)
  ia1=nint(ia2-width/df)
  ib2=nint(ib1+width/df)
  pi=4.0*atan(1.0)
  do i=ia1,ia2
     fil=(1.0 + cos(pi*df*(i-ia2)/width))/2.0
     cx(i)=fil*cx(i)
  enddo
  do i=ib1,ib2
     fil=(1.0 + cos(pi*df*(i-ib1)/width))/2.0
     cx(i)=fil*cx(i)
  enddo
  cx(0:ia1-1)=0.
  cx(ib2+1:)=0.

  call four2a(cx,nfft,1,1,-1)                  !c2r
  wave=x/nfft

!###
  if(nslots.ne.99) return
  x=wave
  call four2a(cx,NFFT,1,-1,0)              !r2c
  do i=0,NH
     s1(i)=real(cx(i))**2 + aimag(cx(i))**2
  enddo
  nadd=20
  call smo(s1,NH+1,s2,nadd)
  do i=0,NH
     freq=i*df
     write(29,3101) freq,db(s2(i)) - 72.0
3101 format(2f12.3)
  enddo
!###

  return
end subroutine filt8

subroutine gen_ft4wave(itone,nsym,nsps,fsample,f0,cwave,wave,icmplx,nwave)

  real wave(nwave)
  complex cwave(nwave)
  real pulse(6912)              !576*4*3
  real dphi(0:250000-1)
  integer itone(nsym)
  logical first
  data first/.true./
  save pulse,first,twopi,dt,hmod

  if(first) then
     twopi=8.0*atan(1.0)
     dt=1.0/fsample
     hmod=1.0
! Compute the smoothed frequency-deviation pulse
     do i=1,3*nsps
        tt=(i-1.5*nsps)/real(nsps)
        pulse(i)=gfsk_pulse(1.0,tt)
     enddo
     first=.false.
  endif

! Compute the smoothed frequency waveform.
! Length = (nsym+2)*nsps samples, zero-padded
  dphi_peak=twopi*hmod/real(nsps)
  dphi=0.0 
  do j=1,nsym         
     ib=(j-1)*nsps
     ie=ib+3*nsps-1
     dphi(ib:ie) = dphi(ib:ie) + dphi_peak*pulse(1:3*nsps)*itone(j)
  enddo

! Calculate and insert the audio waveform
  phi=0.0
  dphi = dphi + twopi*f0*dt                          !Shift frequency up by f0
  wave=0.
  if(icmplx.eq.1) cwave=0.
  k=0
  do j=0,nwave-1
     k=k+1
     if(icmplx.eq.0) then
        wave(k)=sin(phi)
     else
        cwave(k)=cmplx(cos(phi),sin(phi))
     endif
     phi=mod(phi+dphi(j),twopi)
  enddo

! Compute the ramp-up and ramp-down symbols
  if(icmplx.eq.0) then
     wave(1:nsps)=wave(1:nsps) *                                          &
          (1.0-cos(twopi*(/(i,i=0,nsps-1)/)/(2.0*nsps)))/2.0
     k1=(nsym+1)*nsps+1
     wave(k1:k1+nsps-1)=wave(k1:k1+nsps-1) *                              &
          (1.0+cos(twopi*(/(i,i=0,nsps-1)/)/(2.0*nsps)))/2.0
  else
     cwave(1:nsps)=cwave(1:nsps) *                                          &
          (1.0-cos(twopi*(/(i,i=0,nsps-1)/)/(2.0*nsps)))/2.0
     k1=(nsym+1)*nsps+1
     cwave(k1:k1+nsps-1)=cwave(k1:k1+nsps-1) *                              &
          (1.0+cos(twopi*(/(i,i=0,nsps-1)/)/(2.0*nsps)))/2.0
  endif

  return
end subroutine gen_ft4wave

real*8 function determ(array,norder)
  implicit real*8 (a-h,o-z)
  real*8 array(10,10)

  determ=1.
  do k=1,norder
     if (array(k,k).ne.0) go to 41
     do j=k,norder
        if(array(k,j).ne.0) go to 31
     enddo
     determ=0.
     go to 60

31   do i=k,norder
        s8=array(i,j)
        array(i,j)=array(i,k)
        array(i,k)=s8
     enddo
     determ=-1.*determ
41   determ=determ*array(k,k)
     if(k.lt.norder) then
        k1=k+1
        do i=k1,norder
           do j=k1,norder
              array(i,j)=array(i,j)-array(i,k)*array(k,j)/array(k,k)
           enddo
        enddo
     end if
  enddo

60 return
end function determ

module iso_c_utilities

  use, intrinsic :: iso_c_binding, only: c_ptr, c_char, c_f_pointer, c_associated
  implicit none

  public :: c_to_f_string, c_f_dyn_string

  private

  character(c_char), dimension(1), save, target :: dummy_string = "?"

  interface        ! strlen is a standard C function from <string.h>
     ! int strlen(char *string)
     function strlen (string) result (len) bind (c, name="strlen")
       use, intrinsic :: iso_c_binding, only: c_ptr, c_size_t
       implicit none
       type(c_ptr), value :: string
       integer(kind=c_size_t) :: len
     end function strlen

     ! void free(void * p)
     subroutine c_free (p) bind (c, name="free")
       use, intrinsic :: iso_c_binding, only: c_ptr
       implicit none
       type(c_ptr), value :: p
     end subroutine c_free
  end interface

contains

  !
  ! Cast C string pointer to Fortran string pointer
  !
  ! Warning! - C data must outlive result scope
  !
  function c_to_f_string (c_str) result (f_str)
    use, intrinsic :: iso_c_binding, only: c_ptr, c_f_pointer, c_char
    implicit none
    type(c_ptr), intent(in) :: c_str
    character(kind=c_char, len=:), pointer :: f_str
    character(kind=c_char), pointer :: arr(:)
    interface        ! strlen is a standard C function from <string.h>
       ! int strlen(char *string)
       function strlen (string) result (len) bind (c, name="strlen")
         use, intrinsic :: iso_c_binding, only: c_ptr, c_size_t
         implicit none
         type(c_ptr), value :: string
         integer(kind=c_size_t) :: len
       end function strlen
    end interface
    call c_f_pointer (c_str, arr, [strlen (c_str)])
    call get_scalar_pointer (size (arr), arr, f_str)
  end function c_to_f_string

  subroutine get_scalar_pointer (scalar_len, scalar, fptr)
    ! Convert a null-terminated C string into a Fortran character pointer
    use, intrinsic :: iso_c_binding, only: c_char
    integer, intent(in) :: scalar_len
    character(kind=c_char, len=scalar_len), intent(in), target :: scalar(1)
    character(kind=c_char, len=:), pointer :: fptr
    fptr => scalar(1)
  end subroutine get_scalar_pointer

  function c_f_dyn_string (cptr) result (fstr)
    ! Convert a null-terminated malloc'ed C string into a Fortran character array
    type(c_ptr), intent(in) :: cptr ! The C address
    character(kind=c_char), allocatable :: fstr(:)
    character(kind=c_char), pointer :: fptr(:)
    interface        ! strlen is a standard C function from <string.h>
       ! void free(void * p)
       subroutine c_free (p) bind (c, name="free")
         use, intrinsic :: iso_c_binding, only: c_ptr
         implicit none
         type(c_ptr), value :: p
       end subroutine c_free
    end interface
    if (c_associated (cptr)) then
       call c_f_pointer (fptr=fptr, cptr=cptr, shape=[strlen(cptr)])
    else
       ! To avoid segfaults, associate FPTR with a dummy target:
       fptr => dummy_string
    end if
    fstr = fptr
    call c_free (cptr)
  end function c_f_dyn_string

end module

! This source code file was last time modified by Igor UA3DJY on 20190220
! All changes are shown in the patch file coming together with the full JTDX source code.

subroutine bpdecode174_91(llr,apmask,maxiterations,message77,cw,nharderror,iter)
!
! A log-domain belief propagation decoder for the (174,91) code.
!
use iso_c_binding, only: c_loc,c_size_t
use crc
integer, parameter:: N=174, K=91, M=N-K
integer*1 cw(N)
integer*1, intent(in) :: apmask(N)
integer*1 decoded(K)
integer*1 message77(77)
integer nrw(M),ncw
integer Nm(7,M)   
integer Mn(3,N)  ! 3 checks per bit
integer synd(M)
real tov(3,N)
real toc(7,M)
real tanhtoc(7,M)
real zn(N)
real, intent(in) :: llr(N)
real Tmn

include "ldpc_174_91_c_reordered_parity.f90"

nclast=0
decoded=0
toc=0
tov=0
tanhtoc=0
! initialize messages to checks
do j=1,M
  do i=1,nrw(j)
    toc(i,j)=llr((Nm(i,j)))
  enddo
enddo

ncnt=0

do iter=0,maxiterations

! Update bit log likelihood ratios (tov=0 in iteration 0).
  do i=1,N
    if( apmask(i) .ne. 1 ) then
      zn(i)=llr(i)+sum(tov(1:ncw,i))
    else
      zn(i)=llr(i)
    endif
  enddo

! Check to see if we have a codeword (check before we do any iteration).
  cw=0
  where( zn .gt. 0. ) cw=1
  ncheck=0
  do i=1,M
    synd(i)=sum(cw(Nm(1:nrw(i),i)))
    if( mod(synd(i),2) .ne. 0 ) ncheck=ncheck+1
!   if( mod(synd(i),2) .ne. 0 ) write(*,*) 'check ',i,' unsatisfied'
  enddo
! write(*,*) 'number of unsatisfied parity checks ',ncheck
  if( ncheck .eq. 0 ) then ! we have a codeword - if crc is good, return it
    decoded=cw(1:K)
    call chkcrc14a(decoded,nbadcrc)
    nharderror=count( (2*cw-1)*llr .lt. 0.0 )
    if(nbadcrc.eq.0) then
      message77=decoded(1:77)
      return
    endif
  endif

  if( iter.gt.0 ) then  ! this code block implements an early stopping criterion
!  if( iter.gt.10000 ) then  ! this code block implements an early stopping criterion
    nd=ncheck-nclast
    if( nd .lt. 0 ) then ! # of unsatisfied parity checks decreased
      ncnt=0  ! reset counter
    else
      ncnt=ncnt+1
    endif
!    write(*,*) iter,ncheck,nd,ncnt
    if( ncnt .ge. 5 .and. iter .ge. 10 .and. ncheck .gt. 15) then
      nharderror=-1
      return
    endif
  endif
  nclast=ncheck

! Send messages from bits to check nodes 
  do j=1,M
    do i=1,nrw(j)
      ibj=Nm(i,j)
      toc(i,j)=zn(ibj)  
      do kk=1,ncw ! subtract off what the bit had received from the check
        if( Mn(kk,ibj) .eq. j ) then  
          toc(i,j)=toc(i,j)-tov(kk,ibj)
        endif
      enddo
    enddo
  enddo

! send messages from check nodes to variable nodes
  do i=1,M
    tanhtoc(1:7,i)=tanh(-toc(1:7,i)/2)
  enddo

  do j=1,N
    do i=1,ncw
      ichk=Mn(i,j)  ! Mn(:,j) are the checks that include bit j
      Tmn=product(tanhtoc(1:nrw(ichk),ichk),mask=Nm(1:nrw(ichk),ichk).ne.j)
      call platanh(-Tmn,y)
!      y=atanh(-Tmn)
      tov(i,j)=2*y
    enddo
  enddo

enddo
nharderror=-1
return
end subroutine bpdecode174_91

! This source code file was last time modified by Igor UA3DJY on July 22nd, 2017
! All changes are shown in the patch file coming together with the full JTDX source code.

subroutine hintwidecq(mrs,mrs2,decoded,hint_wide,npass1)

  use jt65_mod10  ! used to share stored messages
  use jt65_mod2, only : s3,correct_hint

  real u1
  integer mrs(63),mrs2(63)
  character msg00*22,decoded*22
  logical(1) hint_wide,npass1

  if(first) then
     call cqcall3()
     first=.false.
  endif
  
  hint_wide=.false.
  if(nused.eq.0) return

  ref0=0.
  do j=1,63
     ref0=ref0 + s3(mrs(j)+1,j)
  enddo

  u1=-99.0
  u2=u1

! Find u1 and u2 (best and second-best) codeword from a list, using 
! a bank of matched filters on the symbol spectra s3(i,j).
  ipk=1
  msg00='                      '
  do k=1,nused
        psum=0.
        ref=ref0
        do j=1,63
           i=sym2(j-1,k)+1
           psum=psum + s3(i,j)
           if(i.eq.mrs(j)+1) ref=ref - s3(i,j) + s3(mrs2(j)+1,j)
        enddo
        p=psum/ref

        if(p.gt.u1) then
           if(msg0(k).ne.msg00) u2=u1
           u1=p
           ipk=k
           msg00=msg0(k)
        endif
        if(msg0(k).ne.msg00 .and. p.gt.u2) u2=p
  enddo

  decoded='                      '
  bias=max(1.12*u2,0.35)
  qual=100.0*(u1-bias)
  thresh=(qual+8.0)*u1

  if(qual.ge.5.6 .or. u1.ge.0.69) then !maximizing sensitivity using 'OR'
!now blocking most of the false decodes 
     if(npass1) then
        if((thresh.gt.7.9 .and. u1.gt.0.63) .or. (thresh.gt.10.5 .and. u1.le.0.63)) then
!print *,qual,u1
!print *,thresh
           decoded=msg0(ipk)
           hint_wide=.true.
           correct_hint(1:63)=sym2(0:62,ipk)
        endif
     endif

     if(.not.npass1) then
        if(u1.gt.0.7 .and. thresh.lt.12.0) return
        if(u1.gt.0.8 .and. thresh.lt.20.0) return
        if(u1.gt.0.9 .and. thresh.lt.30.0) return
        if((thresh.gt.9.6 .and. u1.gt.0.63) .or. (thresh.gt.10.5 .and. u1.le.0.63)) then
!print *,qual,u1
!print *,thresh
           decoded=msg0(ipk)
           hint_wide=.true.
           correct_hint(1:63)=sym2(0:62,ipk)
        endif
     endif 
  endif

return
end subroutine hintwidecq

subroutine tone8(lmycallstd,lhiscallstd)

  use ft8_mod1, only : itone56,idtone56,msg,csynce,mycall,hiscall,idtonecqdxcns,idtonedxcns73,mybcall,hisbcall,lhound, &
                       idtonefox73,idtonespec
  complex csig0(151680)
  character msg37*37,msgsent37*37,mycall14*14,hiscall14*14
  character*4 rpt(56)
  integer itone(79),itone1(79)
  integer*1 msgbits(77)
  logical(1), intent(in) :: lmycallstd,lhiscallstd

  data rpt/'-01 ','-02 ','-03 ','-04 ','-05 ','-06 ','-07 ','-08 ','-09 ','-10 ', &
           '-11 ','-12 ','-13 ','-14 ','-15 ','-16 ','-17 ','-18 ','-19 ','-20 ', &
           '-21 ','-22 ','-23 ','-24 ','-25 ','-26 ','R-01','R-02','R-03','R-04', &
           'R-05','R-06','R-07','R-08','R-09','R-10','R-11','R-12','R-13','R-14', &
           'R-15','R-16','R-17','R-18','R-19','R-20','R-21','R-22','R-23','R-24', &
           'R-25','R-26','AA00','RRR ','RR73','73  '/

! taken from ft8_mod1
!    integer itone56(56,79),idtone56(56,58)
!    character*37 msg(56)

  if(lhound .and. len_trim(mybcall).gt.2 .and. len_trim(hisbcall).gt.2) then
    msg37=''; msg37=trim(mybcall)//' '//trim(hisbcall)//' RR73'
    i3=-1; n3=-1
    call genft8(msg37,i3,n3,0,msgsent37,msgbits,itone)
    idtonefox73(1:29)=itone(8:36)
    idtonefox73(30:58)=itone(44:72)
    msg37=''; msg37=trim(mybcall)//' RR73; '//trim(mybcall)//' <'//trim(hiscall)//'> -12'
    i3=-1; n3=-1
    call genft8(msg37,i3,n3,0,msgsent37,msgbits,itone)
    idtonespec(1:29)=itone(8:36)
    idtonespec(30:58)=itone(44:72)
  endif

  if(.not.lhiscallstd .and. len(trim(hiscall)).gt.2) then
    msg37=''; msg37='CQ '//trim(hiscall)
    i3=-1; n3=-1
    call genft8(msg37,i3,n3,0,msgsent37,msgbits,itone)
    idtonecqdxcns(1:29)=itone(8:36)
    idtonecqdxcns(30:58)=itone(44:72)
    msg37=''; msg37='<AA1AAA> '//trim(hiscall)//' 73'
    i3=-1; n3=-1
    call genft8(msg37,i3,n3,0,msgsent37,msgbits,itone)
    idtonedxcns73(1:29)=itone(8:36)
    idtonedxcns73(30:58)=itone(44:72)
  endif

  if(.not.lhiscallstd .and. .not.lmycallstd) return ! we do not support such message in FT8v2
  if(.not.lhiscallstd .or. .not.lmycallstd) then
    mycall14='              '; mycall14='<'//trim(mycall)//'>'
    hiscall14='              '; hiscall14='<'//trim(hiscall)//'>'
  endif

  if(lhiscallstd .and. lmycallstd) then
    do i=1,56
      msg37=''; msg37=trim(mycall)//' '//trim(hiscall)//' '//trim(rpt(i))
      msg(i)=msg37
      i3=-1; n3=-1
      call genft8(msg37,i3,n3,0,msgsent37,msgbits,itone)
      if(i.eq.1) itone1=itone
      idtone56(i,1:29)=itone(8:36)
      idtone56(i,30:58)=itone(44:72)
      itone56(i,1:79)=itone(1:79)
    enddo
    go to 2
  endif

  if(.not.lhiscallstd .and. lmycallstd) then
    do i=1,52
      msg37=''; msg37=trim(mycall)//' '//trim(hiscall14)//' '//trim(rpt(i))
      i3=-1; n3=-1
      call genft8(msg37,i3,n3,0,msgsent37,msgbits,itone)
      if(i.eq.1) itone1=itone
      idtone56(i,1:29)=itone(8:36)
      idtone56(i,30:58)=itone(44:72)
      itone56(i,1:79)=itone(1:79)
      msg37=''; msg37=trim(mycall)//' '//trim(hiscall)//' '//trim(rpt(i))
      msg(i)=msg37
    enddo
    do i=54,56
      msg37=''; msg37=trim(mycall14)//' '//trim(hiscall)//' '//trim(rpt(i))
      i3=-1; n3=-1
      call genft8(msg37,i3,n3,0,msgsent37,msgbits,itone)
      idtone56(i,1:29)=itone(8:36)
      idtone56(i,30:58)=itone(44:72)
      itone56(i,1:79)=itone(1:79)
      msg37=''; msg37=trim(mycall)//' '//trim(hiscall)//' '//trim(rpt(i))
      msg(i)=msg37
    enddo
    msg37=''; msg37=trim(mycall14)//' '//trim(hiscall)
    msg(53)=msg37
    i3=-1; n3=-1
    call genft8(msg37,i3,n3,0,msgsent37,msgbits,itone)
    idtone56(53,1:29)=itone(8:36)
    idtone56(53,30:58)=itone(44:72)
    itone56(53,1:79)=itone(1:79)
    go to 2
  endif

  if(lhiscallstd .and. .not.lmycallstd) then
    do i=1,52
      msg37=''; msg37=trim(mycall14)//' '//trim(hiscall)//' '//trim(rpt(i))
      i3=-1; n3=-1
      call genft8(msg37,i3,n3,0,msgsent37,msgbits,itone)
      if(i.eq.1) itone1=itone
      idtone56(i,1:29)=itone(8:36)
      idtone56(i,30:58)=itone(44:72)
      itone56(i,1:79)=itone(1:79)
      msg37=''; msg37=trim(mycall)//' '//trim(hiscall)//' '//trim(rpt(i))
      msg(i)=msg37
    enddo
    do i=54,56
      msg37=''; msg37=trim(mycall)//' '//trim(hiscall14)//' '//trim(rpt(i))
      i3=-1; n3=-1
      call genft8(msg37,i3,n3,0,msgsent37,msgbits,itone)
      idtone56(i,1:29)=itone(8:36)
      idtone56(i,30:58)=itone(44:72)
      itone56(i,1:79)=itone(1:79)
      msg37=''; msg37=trim(mycall)//' '//trim(hiscall)//' '//trim(rpt(i))
      msg(i)=msg37
    enddo
    msg37=''; msg37=trim(mycall14)//' '//trim(hiscall)
    msg(53)=msg37
    i3=-1; n3=-1
    call genft8(msg37,i3,n3,0,msgsent37,msgbits,itone)
    idtone56(53,1:29)=itone(8:36)
    idtone56(53,30:58)=itone(44:72)
    itone56(53,1:79)=itone(1:79)
    go to 2
  endif

2 m=13441 ! 7*1920+1
  call gen_ft8wave(itone1,79,1920,2.0,12000.0,0.0,csig0,xjunk,1,151680)
  do j=0,18
    do k=1,32; csynce(j,k)=csig0(m); m=m+60; enddo
  enddo
 
  return
end subroutine tone8

! This source code file was last time modified by Igor UA3DJY on 20181215
! All changes are shown in the patch file coming together with the full JTDX source code.

subroutine hintrxrmin(s3,mrs,mrs2,mycall,decoded,hint_call3)

  use packjt
  use prog_args
  use jt65_mod2, only : s3,correct_hint
  parameter (MAXCALLS=35000,MAXRPT=30)
  parameter (MAXMSG=MAXRPT*MAXCALLS)
  real s3(64,63),u1
  integer*1 sym2(0:62,MAXMSG)
  integer mrs(63),mrs2(63),dgen(12),sym_rev(0:62)
  logical(1) hint_call3,first
  character*6 call2(MAXCALLS)
  character*4 rpt(MAXRPT)
  character mycall*6,callsign*12,line*180,msg*22,msg00*22,decoded*22
  character*22 msg0(MAXMSG)
  data first/.true./
  data rpt/'-01','-02','-03','-04','-05',          &
           '-06','-07','-08','-09','-10',          &
           '-11','-12','-13','-14','-15',          &
           '-16','-17','-18','-19','-20',          &
           '-21','-22','-23','-24','-25',          &
           '-26','-27','-28','-29','-30'/
  save first,nused,msg0,sym2

  if(first) then
     open(23,file=trim(data_dir)//'/CALL3.TXT',status='unknown')
     icall=0
     j=0
     do i=1,MAXCALLS
        read(23,1002,end=10) line
1002    format(a80)
        if(line(1:4).eq.'ZZZZ') exit
        if(line(1:2).eq.'//') cycle
        i1=index(line,',')
        if(i1.lt.4) cycle
        callsign=line(1:i1-1)
        j=j+1
        call2(j)=callsign(1:6)               !### Fix for compound callsigns!
     enddo
10   ncalls=j
     if(ncalls.lt.1) then
        print *, 'copy CALL3.TXT file to log directory'
        print *, 'http://www.jtdx.tech'
!        stop 'CALL3.TXT is too short or missed?'
     endif
     close(23)

     if(ncalls.eq.0) then
        first=.false.
        return
     endif

     j=0
     do i=1,ncalls
        do m=1,MAXRPT
           j=j+1
           msg=mycall//' '//call2(i)//' '//rpt(m)
           call fmtmsg(msg,iz)
           call packmsg(msg,dgen,itype)            !Pack message into 72 bits
           call rs_encode(dgen,sym_rev)            !RS encode
           call interleave63(sym_rev,1)            !Interleave channel symbols
           call graycode(sym_rev,63,1,sym_rev)     !Apply Gray code
           sym2(0:62,j)=sym_rev(0:62)
           msg0(j)=msg
        enddo
     enddo
     nused=j
     first=.false.
  endif

  hint_call3=.false.
  ref0=0.
  do j=1,63
     ref0=ref0 + s3(mrs(j)+1,j)
  enddo

  u1=0.
  u1=-99.0
  u2=u1

! Find u1 and u2 (best and second-best) codeword from a list, using 
! a bank of matched filters on the symbol spectra s3(i,j).
  ipk=1
  ipk2=0
  msg00='                      '
  do k=1,nused
        psum=0.
        ref=ref0
        do j=1,63
           i=sym2(j-1,k)+1
           psum=psum + s3(i,j)
           if(i.eq.mrs(j)+1) ref=ref - s3(i,j) + s3(mrs2(j)+1,j)
        enddo
        p=psum/ref

        if(p.gt.u1) then
           if(msg0(k).ne.msg00) then
              ipk2=ipk
              u2=u1
           endif
           u1=p
           ipk=k
           msg00=msg0(k)
        endif
        if(msg0(k).ne.msg00 .and. p.gt.u2) then
           u2=p
           ipk2=k
        endif
  enddo

  decoded='                      '
  bias=max(1.12*u2,0.35)
  qual=100.0*(u1-bias)
  thresh_h=(qual+8.0)*u1
  qmin=1.0

  if(qual.ge.1.0 .or. u1.ge.0.6) then !maximizing sensitivity using 'OR'
     if(thresh_h.gt.1.2) then !blocking some false decodes using 'AND'
        decoded=msg0(ipk)
        hint_call3=.true.
        correct_hint(1:63)=sym2(0:62,ipk)
     endif
  endif
return
end subroutine hintrxrmin

! This source code file is created by Igor Chernikov UA3DJY on July 04th, 2016 and 
! last time mofified on June 28th, 2016.
! All changes are shown in the patch file coming together with the full JTDX source code.

module jt65_mod5

  real, save :: ref(3413)

end module jt65_mod5

! This source code file was last time modified by Igor UA3DJY on December 28th, 2016.
! All changes are shown in the patch file coming together with the full JTDX source code.

subroutine afc65b(c5x,npts,fsample,a,ccfbest,dtbest)

! Find delta f, f1, f2 ==> a(1:2)
  complex c5x(npts)
  real a(2),deltaa(2)

  a(1)=0.
  a(2)=0.
  deltaa(1)=2.0
  deltaa(2)=2.0
  nterms=2                                  !number of polynom coefficients
  
!  Start the iteration
  chisqr=0.
  chisqr0=1.e6
  do iter=1,4                               !One iteration is enough?
     do j=1,nterms
        chisq1=fchisq65(c5x,npts,fsample,a,ccfmax,dtmax)
        delta=deltaa(j)/float(iter)
10      a(j)=a(j)+delta
        chisq2=fchisq65(c5x,npts,fsample,a,ccfmax,dtmax)
        if(chisq2.eq.chisq1) go to 10
        if(chisq2.gt.chisq1) then
           delta=-delta                      !Reverse direction
           a(j)=a(j)+delta
           tmp=chisq1
           chisq1=chisq2
           chisq2=tmp
        endif
20      a(j)=a(j)+delta
        chisq3=fchisq65(c5x,npts,fsample,a,ccfmax,dtmax)
        if(chisq3.eq.chisq2) go to 20
        if(chisq3.lt.chisq2) then
           chisq1=chisq2
           chisq2=chisq3
           go to 20
        endif

! Find minimum of parabola defined by last three points
        delta=delta*(1./(1.+(chisq1-chisq2)/(chisq3-chisq2))+0.5)
        a(j)=a(j)-delta
     enddo
     chisqr=fchisq65(c5x,npts,fsample,a,ccfmax,dtmax)
     if(chisqr/chisqr0.gt.0.9999) go to 30
     chisqr0=chisqr
  enddo

30 ccfbest=1.e4*ccfmax*(1378.125/fsample)**2
  dtbest=dtmax

  return
end subroutine afc65b

subroutine timf2(x0,k,nfft,nwindow,nb,peaklimit,x1,slimit,lstrong,px,nzap)

! Sequential processing of time-domain I/Q data, using Linrad-like
! "first FFT" and "first backward FFT", treating frequencies with
! strong signals differently.  Noise blanking is applied to weak
! signals only.

!  x0       - real input data
!  nfft     - length of FFTs
!  nwindow  - 0 for no window, 2 for sin^2 window
!  x1       - real output data

! Non-windowed processing means no overlap, so kstep=nfft.  
! Sin^2 window has 50% overlap, kstep=nfft/2.

! Frequencies with strong signals are identified and separated.  Back
! transforms are done separately for weak and strong signals, so that
! noise blanking can be applied to the weak-signal portion.  Strong and
! weak are finally re-combined, in the time domain.

  parameter (MAXFFT=1024,MAXNH=MAXFFT/2)
  parameter (MAXSIGS=100)
  real x0(0:nfft-1),x1(0:nfft-1)
  real x(0:MAXFFT-1),xw(0:MAXFFT-1),xs(0:MAXFFT-1)
  real xwov(0:MAXNH-1),xsov(0:MAXNH-1)
  complex cx(0:MAXFFT-1),cxt(0:MAXFFT-1)
  complex cxs(0:MAXFFT-1)                     !Strong signals
  complex cxw(0:MAXFFT-1)                     !Weak signals
  real*4 w(0:MAXFFT-1)
  real*4 s(0:MAXNH)
  logical*1 lstrong(0:MAXNH),lprev
  integer ia(MAXSIGS),ib(MAXSIGS)
  logical first
  equivalence (x,cx),(xw,cxw),(xs,cxs)
  data first/.true./
  data k0/99999999/
  save

  if(first) then
     pi=4.0*atan(1.0)
     do i=0,nfft-1
        w(i)=(sin(i*pi/nfft))**2
     enddo
     s=0.
     nh=nfft/2
     kstep=nfft
     if(nwindow.eq.2) kstep=nh
     fac=1.0/nfft
     slimit=1.e30
     first=.false.
  endif

  if(k.lt.k0) then
     xsov=0.
     xwov=0.
  endif
  k0=k

  x(0:nfft-1)=x0
  if(nwindow.eq.2) x(0:nfft-1)=w(0:nfft-1)*x(0:nfft-1)
  call four2a(cx,nfft,1,-1,0)                       !First forward FFT, r2c
  cxt(0:nh)=cx(0:nh)

! Identify frequencies with strong signals.
  do i=0,nh
     p=real(cxt(i))**2 + aimag(cxt(i))**2
     s(i)=p
  enddo
  ave=sum(s(0:nh))/nh
  lstrong(0:nh)=s(0:nh).gt.10.0*ave

  nsigs=0
  lprev=.false.
  iwid=1
  ib=-99
  do i=0,nh
     if(lstrong(i) .and. (.not.lprev)) then
        if(nsigs.lt.MAXSIGS) nsigs=nsigs+1
        ia(nsigs)=i-iwid
        if(ia(nsigs).lt.0) ia(nsigs)=0
     endif
     if(.not.lstrong(i) .and. lprev) then
        ib(nsigs)=i-1+iwid
        if(ib(nsigs).gt.nh) ib(nsigs)=nh
     endif
     lprev=lstrong(i)
  enddo

  if(nsigs.gt.0) then
     do i=1,nsigs
        ja=ia(i)
        jb=ib(i)
        if(ja.lt.0 .or. ja.gt.nh .or. jb.lt.0 .or. jb.gt.nh) then
           cycle
        endif
        if(jb.eq.-99) jb=ja + min(2*iwid,nh)
        lstrong(ja:jb)=.true.
     enddo
  endif

! Copy frequency-domain data into array cs (strong) or cw (weak).
  do i=0,nh
     if(lstrong(i)) then
        cxs(i)=fac*cxt(i)
        cxw(i)=0.
     else
        cxw(i)=fac*cxt(i)
        cxs(i)=0.
     endif
  enddo

  call four2a(cxw,nfft,1,1,-1)           !Transform weak and strong back
  call four2a(cxs,nfft,1,1,-1)           !to time domain, separately (c2r)

  if(nwindow.eq.2) then
     xw(0:nh-1)=xw(0:nh-1)+xwov(0:nh-1)     !Add previous segment's 2nd half
     xwov(0:nh-1)=xw(nh:nfft-1)             !Save 2nd half
     xs(0:nh-1)=xs(0:nh-1)+xsov(0:nh-1)     !Ditto for strong signals
     xsov(0:nh-1)=xs(nh:nfft-1)
  endif

! Apply noise blanking to weak data
  if(nb.ne.0) then
     do i=0,kstep-1
        peak=abs(xw(i))
        if(peak.gt.peaklimit) then
           xw(i)=0.
           nzap=nzap+1
        endif
     enddo
  endif

! Compute power levels from weak data only
  do i=0,kstep-1
     px=px + xw(i)**2
  enddo

  x1(0:kstep-1)=xw(0:kstep-1) + xs(0:kstep-1)     !Recombine weak + strong

  return
end subroutine timf2

module options
  !
  ! Source code copied from:
  ! http://fortranwiki.org/fortran/show/Command-line+arguments
  !
  implicit none

  type option
     !> Long name.
     character(len=100) :: name
     !> Does the option require an argument?
     logical :: has_arg
     !> Corresponding short name.
     character :: chr
     !> Description.
     character(len=500) :: descr
     !> Argument name, if required.
     character(len=20) :: argname
   contains
     procedure :: print => print_opt
  end type option

contains

  !> Parse command line options. Options and their arguments must come before
  !> all non-option arguments. Short options have the form "-X", long options
  !> have the form "--XXXX..." where "X" is any character. Parsing can be
  !> stopped with the option '--'.
  !> The following code snippet illustrates the intended use:
  !> \code
  !> do
  !>   call getopt (..., optchar=c, ...)
  !>   if (stat /= 0) then
  !>     ! optional error handling
  !>     exit
  !>   end if
  !>   select case (c)
  !>     ! process options
  !>   end select
  !> end do
  !> \endcode
  subroutine getopt (options, longopts, optchar, optarg, arglen, stat, &
       offset, remain, err)
    use iso_fortran_env, only: error_unit

    !> String containing the characters that are valid short options. If
    !> present, command line arguments are scanned for those options.
    !> If a character is followed by a colon (:) its corresponding option
    !> requires an argument. E.g. "vn:" defines two options -v and -n with -n
    !> requiring an argument.
    character(len=*), intent(in), optional :: options

    !> Array of long options. If present, options of the form '--XXXX...' are
    !> recognised. Each option has an associated option character. This can be
    !> any character of default kind, it is just an identifier. It can, but
    !> doesn't have to, match any character in the options argument. In fact it
    !> is possible to only pass long options and no short options at all.
    !> Only name, has_arg and chr need to be set.
    type(option), intent(in), optional :: longopts(:)

    !> If stat is not 1, optchar contains the option character that was parsed.
    !> Otherwise its value is undefined.
    character, intent(out), optional :: optchar

    !> If stat is 0 and the parsed option requires an argument, optarg contains
    !> the first len(optarg) (but at most 500) characters of that argument.
    !> Otherwise its value is undefined. If the arguments length exceeds 500
    !> characters and err is .true., a warning is issued.
    character(len=*), intent(out), optional :: optarg

    !> If stat is 0 and the parsed option requires an argument, arglen contains
    !> the actual length of that argument. Otherwise its value is undefined.
    !> This can be used to make sure the argument was not truncated by the
    !> limited length of optarg.
    integer, intent(out), optional :: arglen

    !> Status indicator. Can have the following values:
    !>   -  0: An option was successfully parsed.
    !>   -  1: Parsing stopped successfully because a non-option or '--' was
    !>         encountered.
    !>   - -1: An unrecognised option was encountered.
    !>   - -2: A required argument was missing.
    !>   .
    !> Its value is never undefined.
    integer, intent(out), optional :: stat

    !> If stat is 1, offset contains the number of the argument before the
    !> first non-option argument, i.e. offset+n is the nth non-option argument.
    !> If stat is not 1, offset contains the number of the argument that would
    !> be parsed in the next call to getopt. This number can be greater than
    !> the actual number of arguments.
    integer, intent(out), optional :: offset

    !> If stat is 1, remain contains the number of remaining non-option
    !> arguments, i.e. the non-option arguments are in the range 
    !> (offset+1:offset+remain). If stat is not 1, remain is undefined.
    integer, intent(out), optional :: remain

    !> If err is present and .true., getopt prints messages to the standard
    !> error unit if an error is encountered (i.e. whenever stat would be set
    !> to a negative value).
    logical, intent(in), optional :: err

    integer, save :: pos = 1, cnt = 0
    character(len=500), save :: arg

    integer :: chrpos, length, st, id = 0
    character :: chr
    logical :: long

    if (cnt == 0) cnt = command_argument_count()
    long = .false.

    ! no more arguments left
    if (pos > cnt) then
       pos = pos - 1
       st = 1
       goto 10
    end if

    call get_command_argument (pos, arg, length)

    ! is argument an option?
    if (arg(1:1) == '-') then

       chr = arg(2:2)

       ! too long ('-xxxx...') for one dash?
       if (chr /= '-' .and. len_trim(arg) > 2) then
          st = -1
          goto 10
       end if

       ! forced stop ('--')
       if (chr == '-' .and. arg(3:3) == ' ') then
          st = 1
          goto 10
       end if

       ! long option ('--xxx...')
       if (chr == '-') then

          long = .true.

          ! check if valid
          id = lookup(arg(3:))

          ! option is invalid, stop
          if (id == 0) then
             st = -1
             goto 10
          end if

          chr = longopts(id)%chr

          ! check if option requires an argument
          if (.not. longopts(id)%has_arg) then
             st = 0
             goto 10
          end if

          ! check if there are still arguments left
          if (pos == cnt) then
             st = -2
             goto 10
          end if

          ! go to next position
          pos = pos + 1

          ! get argument
          call get_command_argument (pos, arg, length)

          ! make sure it is not an option
          if (arg(1:1) == '-') then
             st = -2
             pos = pos - 1
             goto 10
          end if

       end if

       ! short option
       ! check if valid
       if (present(options)) then
          chrpos = scan(options, chr)
       else
          chrpos = 0
       end if

       ! option is invalid, stop
       if (chrpos == 0) then
          st = -1
          goto 10
       end if

       ! look for argument requirement
       if (chrpos < len_trim(options)) then
          if (options(chrpos+1:chrpos+1) == ':') then

             ! check if there are still arguments left
             if (pos == cnt) then
                st = -2
                goto 10
             end if

             ! go to next position
             pos = pos + 1

             ! get argument
             call get_command_argument (pos, arg, length)

             ! make sure it is not an option
             if (arg(1:1) == '-') then
                st = -2
                pos = pos - 1
                goto 10
             end if

          end if
       end if

       ! if we get to this point, no error happened
       ! return option and the argument (if there is one)
       st = 0
       goto 10
    end if

    ! not an option, parsing stops
    st = 1
    ! we are already at the first non-option argument
    ! go one step back to the last option or option argument
    pos = pos - 1


    ! error handling and setting of return values
10  continue

    if (present(err)) then
       if (err) then

          select case (st)
          case (-1)
             write (error_unit, *) "error: unrecognised option: " // trim(arg) 
          case (-2)
             if (.not. long) then
                write (error_unit, *) "error: option -" // chr &
                     // " requires an argument"
             else
                write (error_unit, *) "error: option --" &
                     // trim(longopts(id)%name) // " requires an argument"
             end if
          end select

       end if
    end if

    if (present(optchar)) optchar = chr
    if (present(optarg))  optarg  = arg
    if (present(arglen))  arglen  = length
    if (present(stat))    stat    = st
    if (present(offset))  offset  = pos
    if (present(remain))  remain  = cnt-pos

    ! setup pos for next call to getopt
    pos = pos + 1

  contains

    integer function lookup (name)
      character(len=*), intent(in) :: name
      integer :: i

      ! if there are no long options, skip the loop
      if (.not. present(longopts)) goto 10

      do i = 1, size(longopts)
         if (name == longopts(i)%name) then
            lookup = i
            return
         end if
      end do
      ! if we get to this point, the option was not found

10    lookup = 0
    end function lookup

  end subroutine getopt

  !============================================================================

  !> Print an option in the style of a man page. I.e.
  !> \code
  !> -o arg
  !> --option arg
  !>    description.................................................................
  !>    ............................................................................
  !> \endcode
  subroutine print_opt (opt, unit)
    !> the option
    class(option), intent(in) :: opt
    !> logical unit number
    integer, intent(in) :: unit

    integer :: l, c1, c2

    if (opt%has_arg) then
       write (unit, '(1x,"-",a,1x,a)') opt%chr, trim(opt%argname)
       write (unit, '(1x,"--",a,1x,a)') trim(opt%name), trim(opt%argname)
    else
       write (unit, '(1x,"-",a)') opt%chr
       write (unit, '(1x,"--",a)') trim(opt%name)
    end if
    l = len_trim(opt%descr)

    ! c1 is the first character of the line
    ! c2 is one past the last character of the line
    c1 = 1
    do
       if (c1 > l) exit
       ! print at maximum 4+76 = 80 characters
       c2 = min(c1 + 76, 500)
       ! if not at the end of the whole string
       if (c2 /= 500) then
          ! find the end of a word
          do
             if (opt%descr(c2:c2) == ' ') exit
             c2 = c2-1
          end do
       end if
       write (unit, '(4x,a)') opt%descr(c1:c2-1)
       c1 = c2+1
    end do

  end subroutine print_opt

end module options

subroutine multimode_decoder(params)

  !$ use omp_lib
  use prog_args
!  use timer_module, only: timer
  use jt65_decode
  use jt9_decode
  use jt9s_decode
  use jt10_decode
  use ft8_decode
  use ft4_decode
  use ft8_mod1, only : ndecodes,allmessages,allsnrs,allfreq,mycall12_0,mycall12_00,hiscall12_0,nmsg,odd,even,oddcopy,     &
                       evencopy,nlasttx,lqsomsgdcd,mycalllen1,msgroot,msgrootlen,lapmyc,lagcc,sumxdtt,avexdt,             &
                       nfawide,nfbwide,mycall,hiscall,lhound,mybcall,hisbcall,lenabledxcsearch,lwidedxcsearch,hisgrid4,   &
                       lmultinst,dd8,nft8cycles,nft8swlcycles,lskiptx1,ncandallthr,nincallthr,incall,msgincall,xdtincall, &
                       maskincallthr,ltxing
  use ft4_mod1, only : llagcc,nFT4decd,nfafilt,nfbfilt,lfilter,lhidetest,lhidetelemetry,dd4
  use packjt77, only : lcommonft8b,ihash22,calls12,calls22

  include 'jt9com.f90'
!  include 'timer_common.inc'

  type, extends(jt65_decoder) :: counting_jt65_decoder
     integer :: decoded
  end type counting_jt65_decoder

  type, extends(jt9_decoder) :: counting_jt9_decoder
     integer :: decoded
  end type counting_jt9_decoder

  type, extends(jt9s_decoder) :: counting_jt9s_decoder
     integer :: decoded
  end type counting_jt9s_decoder
  
  type, extends(jt10_decoder) :: counting_jt10_decoder
     integer :: decoded
  end type counting_jt10_decoder
  
  type, extends(ft8_decoder) :: counting_ft8_decoder
     integer :: decoded
     real :: xdtt(200)
  end type counting_ft8_decoder

  type, extends(ft4_decoder) :: counting_ft4_decoder
     integer :: decoded
  end type counting_ft4_decoder

  logical first,firstsd
  logical(1) swlold,lhoundprev
  integer nutc,ndelay
  type(params_block) :: params
  data ndelay/0/
  data first/.true./
  data firstsd/.true./
  data swlold/.false./
  data lhoundprev/.false./
!  character(len=20) :: datetime
  character(len=6) :: hisgrid !, mygrid,
  save

  logical newdat65,newdat9,nagainjt9,nagainjt9s,nagainjt10,swlchanged,lowrms,fileExists

!character(10) dat, tim1, tim2, zon
!real(8) :: timer1,timer2 ! milliseconds
!integer(4) :: ival(8)

  type(counting_jt65_decoder) :: my_jt65
  type(counting_jt9_decoder) :: my_jt9
  type(counting_jt9s_decoder) :: my_jt9s
  type(counting_jt10_decoder) :: my_jt10
  type(counting_ft8_decoder) :: my_ft8
  type(counting_ft4_decoder) :: my_ft4
  
 !cast C character arrays to Fortran character strings
!  datetime=transfer(params%datetime, datetime)
  mycall=transfer(params%mycall,mycall)
  mybcall=transfer(params%mybcall,mybcall)
  hiscall=transfer(params%hiscall,hiscall)
  hisbcall=transfer(params%hisbcall,hisbcall)
!  mygrid=transfer(params%mygrid,mygrid)
  hisgrid=transfer(params%hisgrid,hisgrid)
  hisgrid4=hisgrid(1:4)

  my_ft8%decoded=0; my_ft8%xdtt=0.
  my_jt65%decoded=0; my_jt9%decoded=0; my_jt9s%decoded=0; my_jt10%decoded=0; my_ft4%decoded=0
  nagainjt9=.false.;  nagainjt9s=.false.;  nagainjt10=.false.; ncandall=0; ncandallthr=0

  if(params%lmodechanged) then; avexdt=0.; if(params%nmode.eq.8) nintcount=3; endif ! avexdt fast track in FT8 after mode change
  if(params%lbandchanged .and. (params%nmode.eq.8 .or. params%nmode.eq.4)) then; ihash22=-1; calls22=''; calls12=''; endif

  if(.not.params%nagain) ndelay=params%ndelay
  lqsomsgdcd=.false.
  if(ndelay.gt.0) then ! received incomplete interval
    if(params%nmode.eq.8) then; call partintft8(ndelay,params%nutc); lqsomsgdcd=.true.
    else if(params%nmode.eq.4) then; call partintft4(ndelay,params%nutc)
    else; call partint(ndelay,params%nutc)
    endif
  endif
  ntrials=params%nranera
  if(params%nsecbandchanged.gt.0) then
  nsamplesdel=params%nsecbandchanged*12000
    if(params%nmode.eq.8) then
      if(params%nsecbandchanged.gt.14) then; dd8=0. ! protection
      else; dd8(1:nsamplesdel)=0.
      endif
    else if(params%nmode.eq.4) then
      if(params%nsecbandchanged.gt.6) then; dd4=0. ! protection: interval length is greater than dd4 index range
      else; dd4(1:nsamplesdel)=0.
      endif
    endif
  endif

!  if (params%nagain .or. (params%nagainfil .and. (params%nmode.eq.65 .or. &
!      params%nmode.eq.(65+9)))) then
!     open(13,file=trim(temp_dir)//'/decoded.txt',status='unknown',position='append')
!  else
!     open(13,file=trim(temp_dir)//'/decoded.txt',status='unknown')
!  endif

  if(.not.params%nagain) nutc=params%nutc
!call date_and_time(date = dat, time = tim1, zone = zon)
!call date_and_time(values = ival)
!timer1 = dble(ival(8)) * 0.001_8 + &
!dble(ival(7)) + dble(ival(6)) * 60.0_8 + &
!dble(ival(5)) * 3600.0_8
!print *,'Decoder start: ',tim1
!print *,params%newdat,params%nagain,params%nagainfil
  swlchanged=.false.
  if(swlold.neqv.params%nswl) then
     swlchanged=.true.
     swlold=params%nswl
  endif
  if(first .or. swlchanged) then; call cwfilter(params%nswl,first,swlchanged); first=.false.; endif ! + ALLCALL to memory
  lenabledxcsearch=params%lenabledxcsearch; lwidedxcsearch=params%lwidedxcsearch

  lmultinst=params%lmultinst; lskiptx1=params%lskiptx1; lhidetest=params%lhidetest; lhidetelemetry=params%lhidetelemetry
  ltxing=params%ltxing
  if(params%nmode.eq.8) then
     mycalllen1=len_trim(mycall)+1
     msgroot=''; msgroot=trim(mycall)//' '//trim(hiscall)//' '; msgrootlen=len_trim(msgroot)
     lcommonft8b=params%lcommonft8b; lagcc=params%nagcc; lhound=params%lhound
     nft8cycles=params%nft8cycles; nft8swlcycles=params%nft8swlcycles; forcedt=0.
     if(params%nagcc .or. params%lforcesync) call agccft8(params%nfa,params%nfb,params%lforcesync,forcedt)
     if((hiscall.ne.hiscall12_0 .and. hiscall.ne.'            ') &
        .or. (mycall.ne.mycall12_0 .and. mycall.ne.'            ') .or. (lhound.neqv.lhoundprev)) then
        if(hiscall.ne.'            ') then
          call tone8(params%lmycallstd,params%lhiscallstd)
          hiscall12_0=hiscall; mycall12_0=mycall
        endif
        lhoundprev=lhound
     endif
     if(params%lmycallstd .and. mycall.ne.'            ' .and. mycall12_00.ne.mycall) then
       call tone8myc(); mycall12_00=mycall
     endif
     ndecodes=0; allmessages=""; allsnrs=0; allfreq=0. !init arrays for multithreading decoding
     numcores=omp_get_num_procs()
     nuserthr=params%nmt

     numthreads=1 ! fallback
     if(nuserthr.eq.0) then ! auto
       if(numcores.eq.1) then; numthreads=1
       else if(numcores.gt.1 .and. numcores.lt.5) then; numthreads=numcores-1
       else if(numcores.gt.4 .and. numcores.lt.9) then; numthreads=numcores-2
       else if(numcores.gt.8 .and. numcores.lt.16) then; numthreads=numcores-3
       else if(numcores.gt.15 .and. numcores.lt.21) then; numthreads=numcores-4
       else if(numcores.gt.20 .and. numcores.lt.30) then; numthreads=numcores-5
       else if(numcores.gt.29) then; numthreads=24
       endif
     else if(nuserthr.gt.0 .and. nuserthr.lt.25) then
! number of threads shall not exceed number of logical cores
       if(numcores.ge.nuserthr) then; numthreads=nuserthr; else; numthreads=numcores; endif
     endif

!print *,nuserthr,numcores,numthreads
     call omp_set_dynamic(.false.)
     call omp_set_nested(.true.)

     nfa=params%nfa; nfb=params%nfb; nfqso=params%nfqso; nfawide=params%nfa; nfbwide=params%nfb
     if(params%nfilter) then  ! 160Hz Filter bandwidth, 580Hz Filter bandwidth in Hound mode
        if(nfqso.lt.nfa .or. nfqso.gt.nfb) then
           write(*,32) nutc,'nfqso is out of bandwidth','d'; 32 format(i6.6,2x,a25,16x,a1); go to 800
        endif
        if(.not.params%lhound) then; nfa=max(nfa,nfqso-60); nfb=min(nfb,nfqso+60)
        else; nfa=max(nfa,nfqso-290); nfb=min(nfb,nfqso+290); endif
        numthreads=min(8,numthreads) ! to do: withdraw limitation when threads are in sync at main passes?
     endif
     if(params%nagainfil) then
        if(nfqso.lt.nfa .or. nfqso.gt.nfb) then
           write(*,64) nutc,'nfqso is out of bandwidth','d'; 64 format(i6.6,2x,a25,16x,a1); go to 800
        endif
        nfa=max(nfa,nfqso-25) ! 50Hz bandwidth for decode via double click
        nfb=min(nfb,nfqso+25)
        numthreads=min(4,numthreads) ! to do: withdraw limitation when threads are in sync at main passes?
     endif
     nsec=mod(nutc,100)
     nmsg=0
     if(nsec.ne.0 .and. nsec.ne.15 .and. nsec.ne.30 .and. nsec.ne.45) then ! reading simulated wav file
      odd%lstate=.false.; even%lstate=.false.; oddcopy%lstate=.false.; evencopy%lstate=.false.  
     endif
     if(firstsd) then; odd%lstate=.false.; even%lstate=.false.; firstsd=.false.; endif
     if(nsec.eq.0 .or. nsec.eq.30) then
       evencopy%msg=even%msg; evencopy%freq=even%freq
       evencopy%dt=even%dt; evencopy%lstate=even%lstate
       even%lstate=.false.
     endif
     if(nsec.eq.15 .or. nsec.eq.45) then
       oddcopy%msg=odd%msg; oddcopy%freq=odd%freq
       oddcopy%dt=odd%dt; oddcopy%lstate=odd%lstate
       odd%lstate=.false.
     endif
     nlasttx=params%nlasttx; lapmyc=params%lapmyc; nFT8decd=0; sumxdt=0.0; if(params%nmode.eq.4) sumxdtt=0.0
     call fillhash(numthreads,.false.)
     if(params%nmode.eq.8) call ft8apset(params%lmycallstd,params%lhiscallstd,numthreads)
!do i=9595,9605; print *,i,dd8(i); enddo ! check wav files processing

!     call timer('decft8  ',0)
if(numthreads.eq.1) then
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfa,nfb,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,1,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
endif

if(numthreads.eq.2) then
     nfmid=nfa+nint(abs(nfb-nfa)/2.); if((nfmid+1).gt.nfb) nfmid=nfb-1
!!!  !$omp parallel sections num_threads(2) copyin(/timer_private/) shared(dd8,nmsg,even,odd,lqsomsgdcd,first_osd,gen,ihash22,nzhash,calls10,calls12,calls22) if(.true.) !iif() needed on Mac
  !$omp parallel sections num_threads(2) shared(dd8,nmsg,even,odd,lqsomsgdcd), &
  !$omp& shared(first_osd,gen,ndecodes,allmessages,allsnrs,allfreq) if(.true.) !iif() needed on Mac
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfa,nfmid,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,1,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid+1,nfb,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,2,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp end parallel sections
endif

if(numthreads.eq.3) then
     nfdelta=nint(abs(nfb-nfa)/3.); nfmid1=nfa+nfdelta; nfmid2=nfmid1+nfdelta; if((nfmid2+1).gt.nfb) nfmid2=nfb-1
!!!  !$omp parallel sections num_threads(3) copyin(/timer_private/) shared(dd8,nmsg,even,odd,lqsomsgdcd,first_osd,gen,ihash22,nzhash,calls10,calls12,calls22) if(.true.) !iif() needed on Mac
  !$omp parallel sections num_threads(3) shared(dd8,nmsg,even,odd,lqsomsgdcd), &
  !$omp& shared(first_osd,gen,ndecodes,allmessages,allsnrs,allfreq) if(.true.) !iif() needed on Mac
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfa,nfmid1,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,1,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid1+1,nfmid2,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,2,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid2+1,nfb,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,3,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp end parallel sections
endif

if(numthreads.eq.4) then
     nfdelta=nint(abs(nfb-nfa)/4.); nfmid1=nfa+nfdelta; nfmid2=nfmid1+nfdelta; nfmid3=nfmid2+nfdelta
     if((nfmid3+1).gt.nfb) nfmid3=nfb-1
!!!  !$omp parallel sections num_threads(4) copyin(/timer_private/) shared(dd8,nmsg,even,odd,lqsomsgdcd,first_osd,gen,ihash22,nzhash,calls10,calls12,calls22) if(.true.) !iif() needed on Mac
  !$omp parallel sections num_threads(4) shared(dd8,nmsg,even,odd,lqsomsgdcd), &
  !$omp& shared(first_osd,gen,ndecodes,allmessages,allsnrs,allfreq) if(.true.) !iif() needed on Mac
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid1+1,nfmid2,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,2,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid2+1,nfmid3,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,3,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfa,nfmid1,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,1,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid3+1,nfb,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,4,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp end parallel sections
endif

if(numthreads.eq.5) then
     nfdelta=nint(abs(nfb-nfa)/5.); nfmid1=nfa+nfdelta; nfmid2=nfmid1+nfdelta; nfmid3=nfmid2+nfdelta
     nfmid4=nfmid3+nfdelta; if((nfmid4+1).gt.nfb) nfmid4=nfb-1
!!!  !$omp parallel sections num_threads(5) copyin(/timer_private/) shared(dd8,nmsg,even,odd,lqsomsgdcd,first_osd,gen,ihash22,nzhash,calls10,calls12,calls22) if(.true.) !iif() needed on Mac
  !$omp parallel sections num_threads(5) shared(dd8,nmsg,even,odd,lqsomsgdcd), &
  !$omp& shared(first_osd,gen,ndecodes,allmessages,allsnrs,allfreq) if(.true.) !iif() needed on Mac
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid2+1,nfmid3,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,3,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid1+1,nfmid2,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,2,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid3+1,nfmid4,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,4,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfa,nfmid1,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,1,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid4+1,nfb,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,5,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp end parallel sections
endif

if(numthreads.eq.6) then
     nfdelta=nint(abs(nfb-nfa)/6.); nfmid1=nfa+nfdelta; nfmid2=nfmid1+nfdelta; nfmid3=nfmid2+nfdelta
     nfmid4=nfmid3+nfdelta; nfmid5=nfmid4+nfdelta; if((nfmid5+1).gt.nfb) nfmid5=nfb-1
!!!  !$omp parallel sections num_threads(6) copyin(/timer_private/) shared(dd8,nmsg,even,odd,lqsomsgdcd,first_osd,gen,ihash22,nzhash,calls10,calls12,calls22) if(.true.) !iif() needed on Mac
  !$omp parallel sections num_threads(6) shared(dd8,nmsg,even,odd,lqsomsgdcd), &
  !$omp& shared(first_osd,gen,ndecodes,allmessages,allsnrs,allfreq) if(.true.) !iif() needed on Mac
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid2+1,nfmid3,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,3,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid3+1,nfmid4,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,4,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid1+1,nfmid2,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,2,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid4+1,nfmid5,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,5,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfa,nfmid1,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,1,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid5+1,nfb,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,6,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp end parallel sections
endif

if(numthreads.eq.7) then
     nfdelta=nint(abs(nfb-nfa)/7.); nfmid1=nfa+nfdelta; nfmid2=nfmid1+nfdelta; nfmid3=nfmid2+nfdelta
     nfmid4=nfmid3+nfdelta; nfmid5=nfmid4+nfdelta; nfmid6=nfmid5+nfdelta; if((nfmid6+1).gt.nfb) nfmid6=nfb-1
!!!  !$omp parallel sections num_threads(7) copyin(/timer_private/) shared(dd8,nmsg,even,odd,lqsomsgdcd,first_osd,gen,ihash22,nzhash,calls10,calls12,calls22) if(.true.) !iif() needed on Mac
  !$omp parallel sections num_threads(7) shared(dd8,nmsg,even,odd,lqsomsgdcd), &
  !$omp& shared(first_osd,gen,ndecodes,allmessages,allsnrs,allfreq) if(.true.) !iif() needed on Mac
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid3+1,nfmid4,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,4,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid2+1,nfmid3,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,3,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid4+1,nfmid5,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,5,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid1+1,nfmid2,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,2,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid5+1,nfmid6,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,6,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfa,nfmid1,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,1,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid6+1,nfb,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,7,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp end parallel sections
endif

if(numthreads.eq.8) then
     nfdelta=nint(abs(nfb-nfa)/8.); nfmid1=nfa+nfdelta; nfmid2=nfmid1+nfdelta; nfmid3=nfmid2+nfdelta
     nfmid4=nfmid3+nfdelta; nfmid5=nfmid4+nfdelta; nfmid6=nfmid5+nfdelta; nfmid7=nfmid6+nfdelta
     if((nfmid7+1).gt.nfb) nfmid7=nfb-1
!!!  !$omp parallel sections num_threads(8) copyin(/timer_private/) shared(dd8,nmsg,even,odd,lqsomsgdcd,first_osd,gen,ihash22,nzhash,calls10,calls12,calls22) if(.true.) !iif() needed on Mac
  !$omp parallel sections num_threads(8) shared(dd8,nmsg,even,odd,lqsomsgdcd), &
  !$omp& shared(first_osd,gen,ndecodes,allmessages,allsnrs,allfreq) if(.true.) !iif() needed on Mac
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid3+1,nfmid4,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,4,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid4+1,nfmid5,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,5,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid2+1,nfmid3,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,3,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid5+1,nfmid6,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,6,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid1+1,nfmid2,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,2,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid6+1,nfmid7,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,7,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfa,nfmid1,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,1,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid7+1,nfb,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,8,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp end parallel sections
endif

if(numthreads.eq.9) then
     nfdelta=nint(abs(nfb-nfa)/9.); nfmid1=nfa+nfdelta; nfmid2=nfmid1+nfdelta; nfmid3=nfmid2+nfdelta
     nfmid4=nfmid3+nfdelta; nfmid5=nfmid4+nfdelta; nfmid6=nfmid5+nfdelta; nfmid7=nfmid6+nfdelta
     nfmid8=nfmid7+nfdelta; if((nfmid8+1).gt.nfb) nfmid8=nfb-1
!!!  !$omp parallel sections num_threads(9) copyin(/timer_private/) shared(dd8,nmsg,even,odd,lqsomsgdcd,first_osd,gen,ihash22,nzhash,calls10,calls12,calls22) if(.true.) !iif() needed on Mac
  !$omp parallel sections num_threads(9) shared(dd8,nmsg,even,odd,lqsomsgdcd), &
  !$omp& shared(first_osd,gen,ndecodes,allmessages,allsnrs,allfreq) if(.true.) !iif() needed on Mac
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid4+1,nfmid5,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,5,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid3+1,nfmid4,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,4,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid5+1,nfmid6,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,6,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid2+1,nfmid3,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,3,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid6+1,nfmid7,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,7,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid1+1,nfmid2,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,2,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid7+1,nfmid8,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,8,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfa,nfmid1,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,1,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid8+1,nfb,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,9,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp end parallel sections
endif

if(numthreads.eq.10) then
     nfdelta=nint(abs(nfb-nfa)/10.); nfmid1=nfa+nfdelta; nfmid2=nfmid1+nfdelta; nfmid3=nfmid2+nfdelta
     nfmid4=nfmid3+nfdelta; nfmid5=nfmid4+nfdelta; nfmid6=nfmid5+nfdelta; nfmid7=nfmid6+nfdelta
     nfmid8=nfmid7+nfdelta; nfmid9=nfmid8+nfdelta; if((nfmid9+1).gt.nfb) nfmid9=nfb-1
!!!  !$omp parallel sections num_threads(10) copyin(/timer_private/) shared(dd8,nmsg,even,odd,lqsomsgdcd,first_osd,gen,ihash22,nzhash,calls10,calls12,calls22) if(.true.) !iif() needed on Mac
  !$omp parallel sections num_threads(10) shared(dd8,nmsg,even,odd,lqsomsgdcd), &
  !$omp& shared(first_osd,gen,ndecodes,allmessages,allsnrs,allfreq) if(.true.) !iif() needed on Mac
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid4+1,nfmid5,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,5,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid5+1,nfmid6,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,6,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid3+1,nfmid4,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,4,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid6+1,nfmid7,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,7,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid2+1,nfmid3,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,3,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid7+1,nfmid8,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,8,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid1+1,nfmid2,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,2,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid8+1,nfmid9,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,9,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfa,nfmid1,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,1,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid9+1,nfb,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,10,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp end parallel sections
endif

if(numthreads.eq.11) then
     nfdelta=nint(abs(nfb-nfa)/11.); nfmid1=nfa+nfdelta; nfmid2=nfmid1+nfdelta; nfmid3=nfmid2+nfdelta
     nfmid4=nfmid3+nfdelta; nfmid5=nfmid4+nfdelta; nfmid6=nfmid5+nfdelta; nfmid7=nfmid6+nfdelta; nfmid8=nfmid7+nfdelta
     nfmid9=nfmid8+nfdelta; nfmid10=nfmid9+nfdelta; if((nfmid10+1).gt.nfb) nfmid10=nfb-1
!!!  !$omp parallel sections num_threads(11) copyin(/timer_private/) shared(dd8,nmsg,even,odd,lqsomsgdcd,first_osd,gen,ihash22,nzhash,calls10,calls12,calls22) if(.true.) !iif() needed on Mac
  !$omp parallel sections num_threads(11) shared(dd8,nmsg,even,odd,lqsomsgdcd), &
  !$omp& shared(first_osd,gen,ndecodes,allmessages,allsnrs,allfreq) if(.true.) !iif() needed on Mac
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid5+1,nfmid6,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,6,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid4+1,nfmid5,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,5,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid6+1,nfmid7,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,7,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid3+1,nfmid4,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,4,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid7+1,nfmid8,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,8,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid2+1,nfmid3,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,3,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid8+1,nfmid9,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,9,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid1+1,nfmid2,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,2,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid9+1,nfmid10,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,10,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfa,nfmid1,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,1,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid10+1,nfb,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,11,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp end parallel sections
endif

if(numthreads.eq.12) then
     nfdelta=nint(abs(nfb-nfa)/12.); nfmid1=nfa+nfdelta; nfmid2=nfmid1+nfdelta; nfmid3=nfmid2+nfdelta
     nfmid4=nfmid3+nfdelta; nfmid5=nfmid4+nfdelta; nfmid6=nfmid5+nfdelta; nfmid7=nfmid6+nfdelta; nfmid8=nfmid7+nfdelta
     nfmid9=nfmid8+nfdelta; nfmid10=nfmid9+nfdelta; nfmid11=nfmid10+nfdelta; if((nfmid11+1).gt.nfb) nfmid11=nfb-1
!!!  !$omp parallel sections num_threads(12) copyin(/timer_private/) shared(dd8,nmsg,even,odd,lqsomsgdcd,first_osd,gen,ihash22,nzhash,calls10,calls12,calls22) if(.true.) !iif() needed on Mac
  !$omp parallel sections num_threads(12) shared(dd8,nmsg,even,odd,lqsomsgdcd), &
  !$omp& shared(first_osd,gen,ndecodes,allmessages,allsnrs,allfreq) if(.true.) !iif() needed on Mac
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid5+1,nfmid6,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,6,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid6+1,nfmid7,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,7,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid4+1,nfmid5,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,5,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid7+1,nfmid8,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,8,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid3+1,nfmid4,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,4,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid8+1,nfmid9,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,9,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid2+1,nfmid3,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,3,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid9+1,nfmid10,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,10,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid1+1,nfmid2,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,2,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid10+1,nfmid11,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,11,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfa,nfmid1,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,1,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid11+1,nfb,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,12,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp end parallel sections
endif

if(numthreads.eq.13) then
     nfdelta=nint(abs(nfb-nfa)/13.); nfmid1=nfa+nfdelta; nfmid2=nfmid1+nfdelta; nfmid3=nfmid2+nfdelta
     nfmid4=nfmid3+nfdelta; nfmid5=nfmid4+nfdelta; nfmid6=nfmid5+nfdelta; nfmid7=nfmid6+nfdelta; nfmid8=nfmid7+nfdelta
     nfmid9=nfmid8+nfdelta; nfmid10=nfmid9+nfdelta; nfmid11=nfmid10+nfdelta; nfmid12=nfmid11+nfdelta
     if((nfmid12+1).gt.nfb) nfmid12=nfb-1
!!!  !$omp parallel sections num_threads(13) copyin(/timer_private/) shared(dd8,nmsg,even,odd,lqsomsgdcd,first_osd,gen,ihash22,nzhash,calls10,calls12,calls22) if(.true.) !iif() needed on Mac
  !$omp parallel sections num_threads(13) shared(dd8,nmsg,even,odd,lqsomsgdcd), &
  !$omp& shared(first_osd,gen,ndecodes,allmessages,allsnrs,allfreq) if(.true.) !iif() needed on Mac
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid5+1,nfmid6,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,6,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid6+1,nfmid7,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,7,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid4+1,nfmid5,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,5,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid7+1,nfmid8,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,8,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid3+1,nfmid4,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,4,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid8+1,nfmid9,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,9,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid2+1,nfmid3,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,3,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid9+1,nfmid10,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,10,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid1+1,nfmid2,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,2,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid10+1,nfmid11,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,11,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfa,nfmid1,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,1,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid11+1,nfmid12,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,12,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid12+1,nfb,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,13,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp end parallel sections
endif

if(numthreads.eq.14) then
     nfdelta=nint(abs(nfb-nfa)/14.); nfmid1=nfa+nfdelta; nfmid2=nfmid1+nfdelta; nfmid3=nfmid2+nfdelta
     nfmid4=nfmid3+nfdelta; nfmid5=nfmid4+nfdelta; nfmid6=nfmid5+nfdelta; nfmid7=nfmid6+nfdelta; nfmid8=nfmid7+nfdelta
     nfmid9=nfmid8+nfdelta; nfmid10=nfmid9+nfdelta; nfmid11=nfmid10+nfdelta; nfmid12=nfmid11+nfdelta
     nfmid13=nfmid12+nfdelta; if((nfmid13+1).gt.nfb) nfmid13=nfb-1
!!!  !$omp parallel sections num_threads(14) copyin(/timer_private/) shared(dd8,nmsg,even,odd,lqsomsgdcd,first_osd,gen,ihash22,nzhash,calls10,calls12,calls22) if(.true.) !iif() needed on Mac
  !$omp parallel sections num_threads(14) shared(dd8,nmsg,even,odd,lqsomsgdcd), &
  !$omp& shared(first_osd,gen,ndecodes,allmessages,allsnrs,allfreq) if(.true.) !iif() needed on Mac
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid6+1,nfmid7,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,7,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid7+1,nfmid8,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,8,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid5+1,nfmid6,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,6,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid8+1,nfmid9,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,9,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid4+1,nfmid5,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,5,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid9+1,nfmid10,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,10,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid3+1,nfmid4,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,4,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid10+1,nfmid11,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,11,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid2+1,nfmid3,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,3,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid11+1,nfmid12,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,12,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid1+1,nfmid2,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,2,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid12+1,nfmid13,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,13,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfa,nfmid1,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,1,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid13+1,nfb,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,14,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp end parallel sections
endif

if(numthreads.eq.15) then
     nfdelta=nint(abs(nfb-nfa)/15.); nfmid1=nfa+nfdelta; nfmid2=nfmid1+nfdelta; nfmid3=nfmid2+nfdelta
     nfmid4=nfmid3+nfdelta; nfmid5=nfmid4+nfdelta; nfmid6=nfmid5+nfdelta; nfmid7=nfmid6+nfdelta; nfmid8=nfmid7+nfdelta
     nfmid9=nfmid8+nfdelta; nfmid10=nfmid9+nfdelta; nfmid11=nfmid10+nfdelta; nfmid12=nfmid11+nfdelta
     nfmid13=nfmid12+nfdelta; nfmid14=nfmid13+nfdelta; if((nfmid14+1).gt.nfb) nfmid14=nfb-1
!!!  !$omp parallel sections num_threads(15) copyin(/timer_private/) shared(dd8,nmsg,even,odd,lqsomsgdcd,first_osd,gen,ihash22,nzhash,calls10,calls12,calls22) if(.true.) !iif() needed on Mac
  !$omp parallel sections num_threads(15) shared(dd8,nmsg,even,odd,lqsomsgdcd), &
  !$omp& shared(first_osd,gen,ndecodes,allmessages,allsnrs,allfreq) if(.true.) !iif() needed on Mac
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid6+1,nfmid7,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,7,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid7+1,nfmid8,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,8,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid5+1,nfmid6,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,6,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid8+1,nfmid9,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,9,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid4+1,nfmid5,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,5,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid9+1,nfmid10,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,10,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid3+1,nfmid4,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,4,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid10+1,nfmid11,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,11,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid2+1,nfmid3,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,3,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid11+1,nfmid12,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,12,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid1+1,nfmid2,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,2,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid12+1,nfmid13,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,13,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfa,nfmid1,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,1,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid13+1,nfmid14,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,14,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid14+1,nfb,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,15,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp end parallel sections
endif

if(numthreads.eq.16) then
     nfdelta=nint(abs(nfb-nfa)/16.); nfmid1=nfa+nfdelta; nfmid2=nfmid1+nfdelta; nfmid3=nfmid2+nfdelta
     nfmid4=nfmid3+nfdelta; nfmid5=nfmid4+nfdelta; nfmid6=nfmid5+nfdelta; nfmid7=nfmid6+nfdelta; nfmid8=nfmid7+nfdelta
     nfmid9=nfmid8+nfdelta; nfmid10=nfmid9+nfdelta; nfmid11=nfmid10+nfdelta; nfmid12=nfmid11+nfdelta
     nfmid13=nfmid12+nfdelta; nfmid14=nfmid13+nfdelta; nfmid15=nfmid14+nfdelta; if((nfmid15+1).gt.nfb) nfmid15=nfb-1
!!!  !$omp parallel sections num_threads(16) copyin(/timer_private/) shared(dd8,nmsg,even,odd,lqsomsgdcd,first_osd,gen,ihash22,nzhash,calls10,calls12,calls22) if(.true.) !iif() needed on Mac
  !$omp parallel sections num_threads(16) shared(dd8,nmsg,even,odd,lqsomsgdcd), &
  !$omp& shared(first_osd,gen,ndecodes,allmessages,allsnrs,allfreq) if(.true.) !iif() needed on Mac
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid7+1,nfmid8,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,8,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid8+1,nfmid9,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,9,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid6+1,nfmid7,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,7,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid9+1,nfmid10,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,10,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid5+1,nfmid6,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,6,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid10+1,nfmid11,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,11,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid4+1,nfmid5,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,5,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid11+1,nfmid12,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,12,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid3+1,nfmid4,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,4,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid12+1,nfmid13,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,13,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid2+1,nfmid3,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,3,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid13+1,nfmid14,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,14,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid1+1,nfmid2,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,2,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid14+1,nfmid15,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,15,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfa,nfmid1,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,1,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid15+1,nfb,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,16,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp end parallel sections
endif

if(numthreads.eq.17) then
     nfdelta=nint(abs(nfb-nfa)/17.); nfmid1=nfa+nfdelta; nfmid2=nfmid1+nfdelta; nfmid3=nfmid2+nfdelta
     nfmid4=nfmid3+nfdelta; nfmid5=nfmid4+nfdelta; nfmid6=nfmid5+nfdelta; nfmid7=nfmid6+nfdelta; nfmid8=nfmid7+nfdelta
     nfmid9=nfmid8+nfdelta; nfmid10=nfmid9+nfdelta; nfmid11=nfmid10+nfdelta; nfmid12=nfmid11+nfdelta
     nfmid13=nfmid12+nfdelta; nfmid14=nfmid13+nfdelta; nfmid15=nfmid14+nfdelta; nfmid16=nfmid15+nfdelta
     if((nfmid16+1).gt.nfb) nfmid16=nfb-1
!!!  !$omp parallel sections num_threads(17) copyin(/timer_private/) shared(dd8,nmsg,even,odd,lqsomsgdcd,first_osd,gen,ihash22,nzhash,calls10,calls12,calls22) if(.true.) !iif() needed on Mac
  !$omp parallel sections num_threads(17) shared(dd8,nmsg,even,odd,lqsomsgdcd), &
  !$omp& shared(first_osd,gen,ndecodes,allmessages,allsnrs,allfreq) if(.true.) !iif() needed on Mac
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid7+1,nfmid8,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,8,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid8+1,nfmid9,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,9,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid6+1,nfmid7,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,7,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid9+1,nfmid10,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,10,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid5+1,nfmid6,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,6,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid10+1,nfmid11,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,11,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid4+1,nfmid5,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,5,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid11+1,nfmid12,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,12,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid3+1,nfmid4,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,4,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid12+1,nfmid13,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,13,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid2+1,nfmid3,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,3,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid13+1,nfmid14,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,14,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid1+1,nfmid2,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,2,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid14+1,nfmid15,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,15,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfa,nfmid1,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,1,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid15+1,nfmid16,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,16,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid16+1,nfb,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,17,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp end parallel sections
endif

if(numthreads.eq.18) then
     nfdelta=nint(abs(nfb-nfa)/18.); nfmid1=nfa+nfdelta; nfmid2=nfmid1+nfdelta; nfmid3=nfmid2+nfdelta
     nfmid4=nfmid3+nfdelta; nfmid5=nfmid4+nfdelta; nfmid6=nfmid5+nfdelta; nfmid7=nfmid6+nfdelta; nfmid8=nfmid7+nfdelta
     nfmid9=nfmid8+nfdelta; nfmid10=nfmid9+nfdelta; nfmid11=nfmid10+nfdelta; nfmid12=nfmid11+nfdelta
     nfmid13=nfmid12+nfdelta; nfmid14=nfmid13+nfdelta; nfmid15=nfmid14+nfdelta; nfmid16=nfmid15+nfdelta
     nfmid17=nfmid16+nfdelta; if((nfmid17+1).gt.nfb) nfmid17=nfb-1
!!!  !$omp parallel sections num_threads(18) copyin(/timer_private/) shared(dd8,nmsg,even,odd,lqsomsgdcd,first_osd,gen,ihash22,nzhash,calls10,calls12,calls22) if(.true.) !iif() needed on Mac
  !$omp parallel sections num_threads(18) shared(dd8,nmsg,even,odd,lqsomsgdcd), &
  !$omp& shared(first_osd,gen,ndecodes,allmessages,allsnrs,allfreq) if(.true.) !iif() needed on Mac
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid8+1,nfmid9,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,9,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid9+1,nfmid10,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,10,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid7+1,nfmid8,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,8,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid10+1,nfmid11,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,11,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid6+1,nfmid7,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,7,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid11+1,nfmid12,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,12,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid5+1,nfmid6,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,6,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid12+1,nfmid13,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,13,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid4+1,nfmid5,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,5,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid13+1,nfmid14,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,14,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid3+1,nfmid4,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,4,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid14+1,nfmid15,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,15,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid2+1,nfmid3,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,3,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid15+1,nfmid16,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,16,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid1+1,nfmid2,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,2,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid16+1,nfmid17,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,17,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfa,nfmid1,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,1,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid17+1,nfb,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,18,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp end parallel sections
endif

if(numthreads.eq.19) then
     nfdelta=nint(abs(nfb-nfa)/19.); nfmid1=nfa+nfdelta; nfmid2=nfmid1+nfdelta; nfmid3=nfmid2+nfdelta
     nfmid4=nfmid3+nfdelta; nfmid5=nfmid4+nfdelta; nfmid6=nfmid5+nfdelta; nfmid7=nfmid6+nfdelta; nfmid8=nfmid7+nfdelta
     nfmid9=nfmid8+nfdelta; nfmid10=nfmid9+nfdelta; nfmid11=nfmid10+nfdelta; nfmid12=nfmid11+nfdelta
     nfmid13=nfmid12+nfdelta; nfmid14=nfmid13+nfdelta; nfmid15=nfmid14+nfdelta; nfmid16=nfmid15+nfdelta
     nfmid17=nfmid16+nfdelta; nfmid18=nfmid17+nfdelta; if((nfmid18+1).gt.nfb) nfmid18=nfb-1
!!!  !$omp parallel sections num_threads(19) copyin(/timer_private/) shared(dd8,nmsg,even,odd,lqsomsgdcd,first_osd,gen,ihash22,nzhash,calls10,calls12,calls22) if(.true.) !iif() needed on Mac
  !$omp parallel sections num_threads(19) shared(dd8,nmsg,even,odd,lqsomsgdcd), &
  !$omp& shared(first_osd,gen,ndecodes,allmessages,allsnrs,allfreq) if(.true.) !iif() needed on Mac
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid8+1,nfmid9,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,9,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid9+1,nfmid10,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,10,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid7+1,nfmid8,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,8,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid10+1,nfmid11,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,11,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid6+1,nfmid7,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,7,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid11+1,nfmid12,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,12,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid5+1,nfmid6,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,6,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid12+1,nfmid13,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,13,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid4+1,nfmid5,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,5,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid13+1,nfmid14,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,14,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid3+1,nfmid4,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,4,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid14+1,nfmid15,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,15,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid2+1,nfmid3,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,3,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid15+1,nfmid16,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,16,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid1+1,nfmid2,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,2,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid16+1,nfmid17,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,17,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfa,nfmid1,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,1,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid17+1,nfmid18,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,18,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid18+1,nfb,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,19,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp end parallel sections
endif

if(numthreads.eq.20) then
     nfdelta=nint(abs(nfb-nfa)/20.); nfmid1=nfa+nfdelta; nfmid2=nfmid1+nfdelta; nfmid3=nfmid2+nfdelta
     nfmid4=nfmid3+nfdelta; nfmid5=nfmid4+nfdelta; nfmid6=nfmid5+nfdelta; nfmid7=nfmid6+nfdelta; nfmid8=nfmid7+nfdelta
     nfmid9=nfmid8+nfdelta; nfmid10=nfmid9+nfdelta; nfmid11=nfmid10+nfdelta; nfmid12=nfmid11+nfdelta
     nfmid13=nfmid12+nfdelta; nfmid14=nfmid13+nfdelta; nfmid15=nfmid14+nfdelta; nfmid16=nfmid15+nfdelta
     nfmid17=nfmid16+nfdelta; nfmid18=nfmid17+nfdelta; nfmid19=nfmid18+nfdelta; if((nfmid19+1).gt.nfb) nfmid19=nfb-1
!!!  !$omp parallel sections num_threads(20) copyin(/timer_private/) shared(dd8,nmsg,even,odd,lqsomsgdcd,first_osd,gen,ihash22,nzhash,calls10,calls12,calls22) if(.true.) !iif() needed on Mac
  !$omp parallel sections num_threads(20) shared(dd8,nmsg,even,odd,lqsomsgdcd), &
  !$omp& shared(first_osd,gen,ndecodes,allmessages,allsnrs,allfreq) if(.true.) !iif() needed on Mac
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid9+1,nfmid10,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,10,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid10+1,nfmid11,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,11,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid8+1,nfmid9,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,9,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid11+1,nfmid12,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,12,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid7+1,nfmid8,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,8,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid12+1,nfmid13,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,13,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid6+1,nfmid7,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,7,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid13+1,nfmid14,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,14,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid5+1,nfmid6,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,6,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid14+1,nfmid15,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,15,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid4+1,nfmid5,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,5,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid15+1,nfmid16,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,16,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid3+1,nfmid4,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,4,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid16+1,nfmid17,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,17,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid2+1,nfmid3,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,3,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid17+1,nfmid18,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,18,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid1+1,nfmid2,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,2,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid18+1,nfmid19,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,19,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfa,nfmid1,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,1,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid19+1,nfb,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,20,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp end parallel sections
endif

if(numthreads.eq.21) then
     nfdelta=nint(abs(nfb-nfa)/21.); nfmid1=nfa+nfdelta; nfmid2=nfmid1+nfdelta; nfmid3=nfmid2+nfdelta
     nfmid4=nfmid3+nfdelta; nfmid5=nfmid4+nfdelta; nfmid6=nfmid5+nfdelta; nfmid7=nfmid6+nfdelta; nfmid8=nfmid7+nfdelta
     nfmid9=nfmid8+nfdelta; nfmid10=nfmid9+nfdelta; nfmid11=nfmid10+nfdelta; nfmid12=nfmid11+nfdelta
     nfmid13=nfmid12+nfdelta; nfmid14=nfmid13+nfdelta; nfmid15=nfmid14+nfdelta; nfmid16=nfmid15+nfdelta
     nfmid17=nfmid16+nfdelta; nfmid18=nfmid17+nfdelta; nfmid19=nfmid18+nfdelta; nfmid20=nfmid19+nfdelta
     if((nfmid20+1).gt.nfb) nfmid20=nfb-1
!!!  !$omp parallel sections num_threads(21) copyin(/timer_private/) shared(dd8,nmsg,even,odd,lqsomsgdcd,first_osd,gen,ihash22,nzhash,calls10,calls12,calls22) if(.true.) !iif() needed on Mac
  !$omp parallel sections num_threads(21) shared(dd8,nmsg,even,odd,lqsomsgdcd), &
  !$omp& shared(first_osd,gen,ndecodes,allmessages,allsnrs,allfreq) if(.true.) !iif() needed on Mac
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid9+1,nfmid10,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,10,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid10+1,nfmid11,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,11,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid8+1,nfmid9,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,9,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid11+1,nfmid12,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,12,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid7+1,nfmid8,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,8,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid12+1,nfmid13,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,13,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid6+1,nfmid7,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,7,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid13+1,nfmid14,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,14,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid5+1,nfmid6,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,6,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid14+1,nfmid15,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,15,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid4+1,nfmid5,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,5,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid15+1,nfmid16,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,16,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid3+1,nfmid4,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,4,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid16+1,nfmid17,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,17,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid2+1,nfmid3,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,3,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid17+1,nfmid18,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,18,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid1+1,nfmid2,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,2,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid18+1,nfmid19,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,19,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfa,nfmid1,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,1,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid19+1,nfmid20,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,20,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid20+1,nfb,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,21,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp end parallel sections
endif

if(numthreads.eq.22) then
     nfdelta=nint(abs(nfb-nfa)/22.); nfmid1=nfa+nfdelta; nfmid2=nfmid1+nfdelta; nfmid3=nfmid2+nfdelta
     nfmid4=nfmid3+nfdelta; nfmid5=nfmid4+nfdelta; nfmid6=nfmid5+nfdelta; nfmid7=nfmid6+nfdelta; nfmid8=nfmid7+nfdelta
     nfmid9=nfmid8+nfdelta; nfmid10=nfmid9+nfdelta; nfmid11=nfmid10+nfdelta; nfmid12=nfmid11+nfdelta
     nfmid13=nfmid12+nfdelta; nfmid14=nfmid13+nfdelta; nfmid15=nfmid14+nfdelta; nfmid16=nfmid15+nfdelta
     nfmid17=nfmid16+nfdelta; nfmid18=nfmid17+nfdelta; nfmid19=nfmid18+nfdelta; nfmid20=nfmid19+nfdelta
     nfmid21=nfmid20+nfdelta; if((nfmid21+1).gt.nfb) nfmid21=nfb-1
!!!  !$omp parallel sections num_threads(22) copyin(/timer_private/) shared(dd8,nmsg,even,odd,lqsomsgdcd,first_osd,gen,ihash22,nzhash,calls10,calls12,calls22) if(.true.) !iif() needed on Mac
  !$omp parallel sections num_threads(22) shared(dd8,nmsg,even,odd,lqsomsgdcd), &
  !$omp& shared(first_osd,gen,ndecodes,allmessages,allsnrs,allfreq) if(.true.) !iif() needed on Mac
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid10+1,nfmid11,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,11,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid11+1,nfmid12,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,12,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid9+1,nfmid10,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,10,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid12+1,nfmid13,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,13,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid8+1,nfmid9,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,9,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid13+1,nfmid14,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,14,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid7+1,nfmid8,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,8,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid14+1,nfmid15,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,15,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid6+1,nfmid7,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,7,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid15+1,nfmid16,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,16,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid5+1,nfmid6,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,6,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid16+1,nfmid17,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,17,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid4+1,nfmid5,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,5,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid17+1,nfmid18,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,18,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid3+1,nfmid4,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,4,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid18+1,nfmid19,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,19,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid2+1,nfmid3,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,3,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid19+1,nfmid20,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,20,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid1+1,nfmid2,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,2,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid20+1,nfmid21,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,21,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfa,nfmid1,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,1,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid21+1,nfb,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,22,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp end parallel sections
endif

if(numthreads.eq.23) then
     nfdelta=nint(abs(nfb-nfa)/23.); nfmid1=nfa+nfdelta; nfmid2=nfmid1+nfdelta; nfmid3=nfmid2+nfdelta
     nfmid4=nfmid3+nfdelta; nfmid5=nfmid4+nfdelta; nfmid6=nfmid5+nfdelta; nfmid7=nfmid6+nfdelta; nfmid8=nfmid7+nfdelta
     nfmid9=nfmid8+nfdelta; nfmid10=nfmid9+nfdelta; nfmid11=nfmid10+nfdelta; nfmid12=nfmid11+nfdelta
     nfmid13=nfmid12+nfdelta; nfmid14=nfmid13+nfdelta; nfmid15=nfmid14+nfdelta; nfmid16=nfmid15+nfdelta
     nfmid17=nfmid16+nfdelta; nfmid18=nfmid17+nfdelta; nfmid19=nfmid18+nfdelta; nfmid20=nfmid19+nfdelta
     nfmid21=nfmid20+nfdelta; nfmid22=nfmid21+nfdelta; if((nfmid22+1).gt.nfb) nfmid22=nfb-1
!!!  !$omp parallel sections num_threads(23) copyin(/timer_private/) shared(dd8,nmsg,even,odd,lqsomsgdcd,first_osd,gen,ihash22,nzhash,calls10,calls12,calls22) if(.true.) !iif() needed on Mac
  !$omp parallel sections num_threads(23) shared(dd8,nmsg,even,odd,lqsomsgdcd), &
  !$omp& shared(first_osd,gen,ndecodes,allmessages,allsnrs,allfreq) if(.true.) !iif() needed on Mac
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid10+1,nfmid11,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,11,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid11+1,nfmid12,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,12,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid9+1,nfmid10,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,10,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid12+1,nfmid13,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,13,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid8+1,nfmid9,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,9,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid13+1,nfmid14,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,14,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid7+1,nfmid8,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,8,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid14+1,nfmid15,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,15,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid6+1,nfmid7,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,7,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid15+1,nfmid16,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,16,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid5+1,nfmid6,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,6,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid16+1,nfmid17,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,17,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid4+1,nfmid5,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,5,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid17+1,nfmid18,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,18,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid3+1,nfmid4,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,4,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid18+1,nfmid19,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,19,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid2+1,nfmid3,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,3,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid19+1,nfmid20,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,20,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid1+1,nfmid2,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,2,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid20+1,nfmid21,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,21,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfa,nfmid1,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,1,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid21+1,nfmid22,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,22,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid22+1,nfb,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,23,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp end parallel sections
endif

if(numthreads.eq.24) then
     nfdelta=nint(abs(nfb-nfa)/24.); nfmid1=nfa+nfdelta; nfmid2=nfmid1+nfdelta; nfmid3=nfmid2+nfdelta
     nfmid4=nfmid3+nfdelta; nfmid5=nfmid4+nfdelta; nfmid6=nfmid5+nfdelta; nfmid7=nfmid6+nfdelta; nfmid8=nfmid7+nfdelta
     nfmid9=nfmid8+nfdelta; nfmid10=nfmid9+nfdelta; nfmid11=nfmid10+nfdelta; nfmid12=nfmid11+nfdelta
     nfmid13=nfmid12+nfdelta; nfmid14=nfmid13+nfdelta; nfmid15=nfmid14+nfdelta; nfmid16=nfmid15+nfdelta
     nfmid17=nfmid16+nfdelta; nfmid18=nfmid17+nfdelta; nfmid19=nfmid18+nfdelta; nfmid20=nfmid19+nfdelta
     nfmid21=nfmid20+nfdelta; nfmid22=nfmid21+nfdelta; nfmid23=nfmid22+nfdelta; if((nfmid23+1).gt.nfb) nfmid23=nfb-1
!!!  !$omp parallel sections num_threads(24) copyin(/timer_private/) shared(dd8,nmsg,even,odd,lqsomsgdcd,first_osd,gen,ihash22,nzhash,calls10,calls12,calls22) if(.true.) !iif() needed on Mac
  !$omp parallel sections num_threads(24) shared(dd8,nmsg,even,odd,lqsomsgdcd), &
  !$omp& shared(first_osd,gen,ndecodes,allmessages,allsnrs,allfreq) if(.true.) !iif() needed on Mac
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid11+1,nfmid12,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,12,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid12+1,nfmid13,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,13,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid10+1,nfmid11,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,11,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid13+1,nfmid14,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,14,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid9+1,nfmid10,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,10,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid14+1,nfmid15,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,15,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid8+1,nfmid9,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,9,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid15+1,nfmid16,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,16,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid7+1,nfmid8,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,8,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid16+1,nfmid17,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,17,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid6+1,nfmid7,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,7,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid17+1,nfmid18,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,18,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid5+1,nfmid6,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,6,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid18+1,nfmid19,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,19,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid4+1,nfmid5,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,5,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid19+1,nfmid20,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,20,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid3+1,nfmid4,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,4,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid20+1,nfmid21,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,21,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid2+1,nfmid3,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,3,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid21+1,nfmid22,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,22,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid1+1,nfmid2,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,2,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid22+1,nfmid23,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,23,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfa,nfmid1,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,1,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp section
     call my_ft8%decode(ft8_decoded,params%nQSOProgress,nfqso,params%nft8rxfsens,  &
          params%nftx,nutc,nfmid23+1,nfb,params%ncandthin,params%ndtcenter, &
          nsec,params%napwid,params%nswl,params%lmycallstd,params%lhiscallstd, &
          params%nfilter,params%nstophint,24,numthreads,logical(params%nagainfil),params%lft8lowth, &
          params%lft8subpass,params%lhideft8dupes,params%lhidehash)
  !$omp end parallel sections
endif

    do i=1,numthreads
      do m=1,nincallthr(i)
      nindex=maskincallthr(i)+m
      incall(30:2:-1)=incall(30-1:1:-1); incall(1)%msg=msgincall(nindex); incall(1)%xdt=xdtincall(nindex)
      enddo
    enddo

    if(nsec.eq.0 .or. nsec.eq.30) even(nmsg+1:130)%lstate=.false.
    if(nsec.eq.15 .or. nsec.eq.45) odd(nmsg+1:130)%lstate=.false.

!do i=1,nmsg
!  if(nsec.eq.0 .or. nsec.eq.30) print *, even(i)%msg
!  if(nsec.eq.15 .or. nsec.eq.45) print *, odd(i)%msg
!enddo

    if(params%ndelay.eq.0) then
      nFT8decd=my_ft8%decoded; dtmed=0.
      if(params%lforcesync) then; nintcount=3 ! fast track after Sync
      else if(nintcount.gt.0) then; nintcount=nintcount-1
      endif
      if(params%lforcesync .and. nFT8decd.eq.0) then
        avexdt=forcedt
      else
        if(nFT8decd.gt.2) then
          do i=1,nFT8decd
            if(i.lt.nFT8decd-1) then
              if((my_ft8%xdtt(i).gt.my_ft8%xdtt(i+1) .and. my_ft8%xdtt(i).lt.my_ft8%xdtt(i+2)) &
                 .or. (my_ft8%xdtt(i).lt.my_ft8%xdtt(i+1) .and. my_ft8%xdtt(i).gt.my_ft8%xdtt(i+2))) then
                dtmed=my_ft8%xdtt(i)
              else if((my_ft8%xdtt(i+1).gt.my_ft8%xdtt(i) .and. my_ft8%xdtt(i+1).lt.my_ft8%xdtt(i+2)) &
                 .or. (my_ft8%xdtt(i+1).lt.my_ft8%xdtt(i) .and. my_ft8%xdtt(i+1).gt.my_ft8%xdtt(i+2))) then
                dtmed=my_ft8%xdtt(i+1)
              else if((my_ft8%xdtt(i+2).gt.my_ft8%xdtt(i) .and. my_ft8%xdtt(i+2).lt.my_ft8%xdtt(i+1)) &
                 .or. (my_ft8%xdtt(i+2).lt.my_ft8%xdtt(i) .and. my_ft8%xdtt(i+2).gt.my_ft8%xdtt(i+1))) then
                dtmed=my_ft8%xdtt(i+2)
              else
                dtmed=my_ft8%xdtt(i)
              endif
              sumxdt=sumxdt+dtmed
            else
              sumxdt=sumxdt+dtmed ! use last median value
            endif
          enddo
          if(nFT8decd.gt.5) then; avexdt=(avexdt+sumxdt/nFT8decd)/2
          else if(nFT8decd.eq.5) then; avexdt=(1.1*avexdt+0.9*sumxdt/nFT8decd)/2
          else if(nFT8decd.eq.4) then; avexdt=(1.25*avexdt+0.75*sumxdt/nFT8decd)/2
          else if(nFT8decd.eq.3) then; avexdt=(1.35*avexdt+0.65*sumxdt/nFT8decd)/2
          endif
        else if(nFT8decd.gt.0) then
          sumxdt=sum(my_ft8%xdtt(1:nFT8decd))
          if(nFT8decd.eq.2) then; avexdt=(1.5*avexdt+0.5*sumxdt/nFT8decd)/2
          else if(nFT8decd.eq.1) then; avexdt=(1.75*avexdt+0.25*sumxdt)/2
          endif
        endif
      endif
    endif
    if(nFT8decd.gt.10 .and. nintcount.eq.1) avexdt=sumxdt/nFT8decd ! fast track after Sync or mode change on crowded bands
    call fillhash(numthreads,.true.)
    ncandall=sum(ncandallthr(1:numthreads))
!     call timer('decft8  ',1)
    go to 800
  endif

  if(params%nmode.eq.4) then
    if(params%nagcc) call agccft4()
    nfa=params%nfa; nfb=params%nfb; nfqso=params%nfqso; lfilter=params%nfilter
    if(lfilter) then
      nfafilt=max(nfa,nfqso-95); nfbfilt=min(nfb,nfqso+95) ! 84 + 11Hz possible freq error  
      if(nfqso.lt.nfafilt .or. nfqso.gt.nfbfilt) then
        write(*,128) nutc,'nfqso is out of bandwidth','d'; 128 format(i6.6,2x,a25,16x,a1); go to 800
      endif
    endif
    llagcc=params%nagcc; nFT4decd=0; sumxdtt(1)=0.0
    call fillhash(1,.false.)
!    call timer('decft4  ',0)
    call my_ft4%decode(ft4_decoded,params%nQSOProgress,nfqso,nfa,nfb,params%nft4depth, &
         params%nstophint,params%nswl)
!    call timer('decft4  ',1)
    if(params%ndelay.eq.0) then
      sumxdt=sumxdtt(1)
      if(nFT4decd.gt.5) then; avexdt=(avexdt+sumxdt/nFT4decd)/2
      else if(nFT4decd.eq.5) then; avexdt=(1.1*avexdt+0.9*sumxdt/nFT4decd)/2
      else if(nFT4decd.eq.4) then; avexdt=(1.25*avexdt+0.75*sumxdt/nFT4decd)/2
      else if(nFT4decd.eq.3) then; avexdt=(1.35*avexdt+0.65*sumxdt/nFT4decd)/2
      else if(nFT4decd.eq.2) then; avexdt=(1.5*avexdt+0.5*sumxdt/nFT4decd)/2
      endif
    endif
    call fillhash(1,.true.)
    go to 800
  endif

  lowrms=.false.
  call rms_augap(params%nutc,lowrms)
  if(lowrms) go to 800

!n1000=0  ! attempt to make T10 noise blanker, some degradation in decoding
!do i=2,623998
!!if(abs(dd(i)-dd(i-1)).gt.1000) then; n1000=n1000+1; print *,i; endif
!if((dd(i+1)-dd(i)).gt.1000.0) dd(i+1)=dd(i)+(dd(i)+dd(i-1))/2.0
!if((dd(i)-dd(i+1)).gt.1000.0) dd(i+1)=dd(i)-(dd(i)+dd(i-1))/2.0
!enddo

! signal input level diagnostics
!rrr=0.
!ddd=0.
!do i=1,624000
!if (abs(dd(i)).gt.rrr) rrr=abs(dd(i))
!enddo
!ddd=20*log10(rrr)
!print *,''
!print *,'max possible sample level is 32767'
!print *,'max RX sample level',int(rrr)
!print *,''
!print *,'max possible dynamic range is 90dB'
!print *,'RX signal dynamic range',nint(ddd)
!print *,''
! end of signal input level diagnostics

  newdat65=params%newdat
  newdat9=params%newdat
  if(params%nagain .and. .not.params%nagainfil) newdat9=.true.

  nshift=26000

  call process_dd(params%nagcc,params%nmode,params%ntxmode,params%nzhsym)

  if(.not.params%nagainfil .and. params%ntxmode.eq.9 .and. params%nagain) nagainjt9=.true.
  if(.not.params%nagainfil .and. params%nmode.eq.9 .and. params%nagain) nagainjt9s=.true.
  if(.not.params%nagainfil .and. params%nagain) nagainjt10=.true.
  if(params%nagainfil) nagainjt10=.false.

  if(params%nmode.eq.10) then
     call my_jt10%decode(jt10_decoded,nutc,params%nfqso,newdat9,params%npts8,   &
          params%nfa,params%nfb,params%ntol,params%nzhsym,nagainjt10,params%nagainfil,params%ntrials10, &
          params%ntrialsrxf10,params%nfilter,params%nswl,params%nagcc,params%nhint,params%nstophint, &
          params%nlasttx,mycall,hiscall,hisgrid)
     go to 800
  endif

  if(params%nmode.eq.9) then
     call my_jt9s%decode(jt9s_decoded,nutc,params%nfqso,newdat9,params%npts8,   &
          params%nfa,params%nfb,params%nzhsym,params%nfilter,params%nswl,   &
          nagainjt9s,params%nagainfil,params%ndepth,params%nhint,params%nstophint, &
          params%nlasttx,mycall,hiscall,hisgrid)
     go to 800
  endif

  call omp_set_dynamic(.true.)
!!!  !$omp parallel sections num_threads(2) copyin(/timer_private/) shared(ndecoded) if(.true.) !iif() needed on Mac
  !$omp parallel sections num_threads(2) shared(ndecoded) if(.true.) !iif() needed on Mac
  !$omp section
  if(params%nmode.eq.65 .or. (params%nmode.eq.(65+9) .and. params%ntxmode.eq.65)) then
     ! We're in JT65 mode, or should do JT65 first

     nf1=params%nfa
     nf2=params%nfb

!     call timer('jt65a   ',0)
     call my_jt65%decode(jt65_decoded,nutc,nf1,nf2,params%nfqso,  &
          logical(params%nagainfil),ntrials,params%naggressive,params%nhint,mycall, &
          hiscall,hisgrid,params%nprepass,params%nswl,params%nfilter,params%nstophint, &
          params%nlasttx,params%nsdecatt,params%fmaskact,params%ntxmode,params%ntopfreq65, &
          params%nharmonicsdepth,params%showharmonics)
!     call timer('jt65a   ',1)
  else if(params%nmode.eq.(65+9) .and. params%ntxmode.eq.9) then
     ! We're in JT9 mode, or should do JT9 first
!     call timer('decjt9  ',0)
     call my_jt9%decode(jt9_decoded,nutc,params%nfqso,newdat9,params%npts8,   &
          params%nfa,params%nfsplit,params%nfb,params%ntol,params%nzhsym,                   &
          nagainjt9,params%nagainfil,params%ndepth,params%nmode,params%nhint,params%nstophint, &
          params%nlasttx,mycall,hiscall,hisgrid,params%ntxmode)
!     call timer('decjt9  ',1)
  endif

  !$omp section
  if(params%nmode.eq.(65+9)) then          !Do the other mode (we're in dual mode)
     if (params%ntxmode.eq.9) then
        if(.not.nagainjt9) then
           nf1=params%nfa
           nf2=params%nfb
!           call timer('jt65a   ',0)
           call my_jt65%decode(jt65_decoded,nutc,nf1,nf2,params%nfqso, &
           logical(params%nagainfil),ntrials,params%naggressive,params%nhint,mycall,     &
           hiscall,hisgrid,params%nprepass,params%nswl,params%nfilter,params%nstophint, &
           params%nlasttx,params%nsdecatt,params%fmaskact,params%ntxmode,params%ntopfreq65, &
           params%nharmonicsdepth,params%showharmonics)
!           call timer('jt65a   ',1)
        endif
     else
        if (params%ntxmode.eq.65 .and. params%nagain) go to 2
!        call timer('decjt9  ',0)
        call my_jt9%decode(jt9_decoded,nutc,params%nfqso,newdat9,params%npts8,&
             params%nfa,params%nfsplit,params%nfb,params%ntol,params%nzhsym,                &
             nagainjt9,params%nagainfil,params%ndepth,params%nmode,params%nhint,params%nstophint, &
             params%nlasttx,mycall,hiscall,hisgrid,params%ntxmode)
!        call timer('decjt9  ',1)
2       continue
     end if
  endif

  !$omp end parallel sections
!800 call date_and_time(date = dat, time = tim2, zone = zon)
!call date_and_time(values = ival)
!timer2 = dble(ival(8)) * 0.001_8 + &
!dble(ival(7)) + dble(ival(6)) * 60.0_8 + &
!dble(ival(5)) * 3600.0_8
!print *,'Decoding finished: ',tim2
!write (*,'(1x,a15,f6.3,a8)')'Decoding time: ',timer2-timer1, ' seconds'

800 continue

write(*,1010) avexdt,ncandall
1010 format('<DecodeFinished><avexdt>',f6.2,'<ncand>',i5)
  call flush(6)
  if(params%lforcesync .and. nFT8decd.eq.0) avexdt=0. ! reset value to let correct sliding in decoder
!  close(13)

  do i=1,1000
    inquire(file=trim(temp_dir)//'/.lock',exist=fileExists)
    if(fileExists) return ! ready to exit from decoder, Decode button hung up issue
    call sleep_msec(1)
  enddo

  return

contains

  subroutine jt65_decoded (this, utc, snr, dt, freq, decoded, servis)
    use jt65_decode
    implicit none

    class(jt65_decoder), intent(inout) :: this
    integer, intent(in) :: utc
    integer, intent(in) :: snr
    real, intent(in) :: dt
    integer, intent(in) :: freq
    character(len=26), intent(in) :: decoded
    character(len=1), intent(in) :: servis

    real dtshift
    dtshift=(real(nshift))/12000.0
    !$omp critical(decode_results)
    write(*,1010) utc,snr,dt-dtshift,freq,decoded,servis
1010 format(i4.4,i4,f5.1,i5,1x,'#',1x,a26,a1)
!    write(13,1012) utc,snr,dt-dtshift,float(freq),decoded,
!1012 format(i4.4,i5,f6.1,f8.0,3x,a26,' JT65')
    call flush(6)

    !$omp end critical(decode_results)
    select type(this)
    type is (counting_jt65_decoder)
       this%decoded = this%decoded + 1
    end select
 end subroutine jt65_decoded

  subroutine jt9_decoded (this, utc, snr, dt, freq, decoded, servis9)
    use jt9_decode
    implicit none

    class(jt9_decoder), intent(inout) :: this
    integer, intent(in) :: utc
    integer, intent(in) :: snr
    real, intent(in) :: dt
    real, intent(in) :: freq
    character(len=26), intent(in) :: decoded
    character(len=1), intent(in) :: servis9

    !$omp critical(decode_results)
    write(*,1000) utc,snr,dt,nint(freq),decoded,servis9
1000 format(i4.4,i4,f5.1,i5,1x,'@',1x,a26,a1)
!    write(13,1002) utc,snr,dt,freq,decoded
!1002 format(i4.4,i5,f6.1,f8.0,3x,a26,' JT9')
    call flush(6)
    !$omp end critical(decode_results)
    select type(this)
    type is (counting_jt9_decoder)
       this%decoded = this%decoded + 1
    end select
  end subroutine jt9_decoded

  subroutine jt9s_decoded (this, utc, snr, dt, freq, decoded, servis9)
    use jt9s_decode
    implicit none

    class(jt9s_decoder), intent(inout) :: this
    integer, intent(in) :: utc
    integer, intent(in) :: snr
    real, intent(in) :: dt
    real, intent(in) :: freq
    character(len=26), intent(in) :: decoded
    character(len=1), intent(in) :: servis9

    write(*,1000) utc,snr,dt,nint(freq),decoded,servis9
1000 format(i4.4,i4,f5.1,i5,1x,'@',1x,a26,a1)
!    write(13,1002) utc,snr,dt,freq,decoded
!1002 format(i4.4,i5,f6.1,f8.0,3x,a26,' JT9')
    call flush(6)
    select type(this)
    type is (counting_jt9s_decoder)
       this%decoded = this%decoded + 1
    end select
  end subroutine jt9s_decoded

  subroutine jt10_decoded (this, utc, snr, dt, freq, decoded, servis9)
    use jt10_decode
    implicit none

    class(jt10_decoder), intent(inout) :: this
    integer, intent(in) :: utc
    integer, intent(in) :: snr
    real, intent(in) :: dt
    real, intent(in) :: freq
    character(len=26), intent(in) :: decoded
    character(len=1), intent(in) :: servis9

    write(*,1000) utc,snr,dt,nint(freq),decoded,servis9
1000 format(i4.4,i4,f5.1,i5,1x,'+',1x,a26,a1)
!    write(13,1002) utc,snr,dt,freq,decoded
!1002 format(i4.4,i5,f6.1,f8.0,3x,a26,' T10')
    call flush(6)
    select type(this)
    type is (counting_jt10_decoder)
       this%decoded = this%decoded + 1
    end select
  end subroutine jt10_decoded

  subroutine ft8_decoded (this,snr,dt,freq,decoded,servis8)
    use ft8_decode
    implicit none

    class(ft8_decoder), intent(inout) :: this
    integer, intent(in) :: snr
    real, intent(in) :: dt
    real, intent(in) :: freq
    character(len=26), intent(in) :: decoded
    character(len=1), intent(in) :: servis8

    write(*,1000) nutc,snr,dt,nint(freq),decoded,servis8
1000 format(i6.6,i4,f5.1,i5,1x,'~',1x,a26,a1)
!    write(13,1002) nutc,snr,dt,freq,0,decoded
!1002 format(i6.6,i5,f6.1,f8.0,i4,3x,a26,' FT8')
    call flush(6)
!    call flush(13)

    select type(this)
    type is (counting_ft8_decoder)
       this%decoded = this%decoded + 1
       this%xdtt(this%decoded)=dt
    end select

    return
  end subroutine ft8_decoded

  subroutine ft4_decoded (this,snr,dt,freq,decoded,servis4)
    use ft4_decode
    implicit none

    class(ft4_decoder), intent(inout) :: this
    integer, intent(in) :: snr
    real, intent(in) :: dt
    real, intent(in) :: freq
    character(len=26), intent(in) :: decoded
    character(len=1), intent(in) :: servis4

    write(*,1001) nutc,snr,dt,nint(freq),decoded,servis4
1001 format(i6.6,i4,f5.1,i5,1x,':',1x,a26,a1)
    call flush(6)
    
    select type(this)
    type is (counting_ft4_decoder)
       this%decoded = this%decoded + 1
    end select

    return
  end subroutine ft4_decoded

end subroutine multimode_decoder

subroutine splitmsgcq(decoded,dtx)
  
  use jt65_mod8 !  dynhint(300), dynhintcq(150), rxfreq(20), rxfchg(1), ninterval, freq
  
  character decoded*22,direction*2,callsign*6,grid*4

  direction=''; callsign=''; grid=''; 
  i1=index(decoded,' '); i2=index(decoded(i1+1:),' ')

  if(i2.eq.3) then
    direction=decoded(4:5)
    i2=i2+i1; i3=index(decoded(i2+1:),' '); i3=i3+i2
    if(len_trim(decoded(i2+1:i3-1)).gt.6) return
    callsign=decoded(i2+1:i3-1); grid=decoded(i3+1:i3+4)
    go to 2
  endif

  if(i2.gt.3) then
    direction='01' ! non-directional CQ message
    i2=i2+i1
    callsign=decoded(i1+1:i2-1); grid=decoded(i2+1:i2+4)
    go to 2
  endif

2 do i=1,300
    if(dynhintcq(i)%ninterval.lt.0) then
      dynhintcq(i)%ninterval=ninterval; dynhintcq(i)%direction=direction; dynhintcq(i)%callsign=callsign
      dynhintcq(i)%grid=grid; dynhintcq(i)%freq=freq; dynhintcq(i)%dt=dtx
      exit
    endif
  enddo

!do i=1,30
!print *, dynhintcq(i)%ninterval
!print *, dynhintcq(i)%direction
!print *, dynhintcq(i)%callsign
!print *, dynhintcq(i)%grid
!enddo

  return
end subroutine splitmsgcq

! last time modified by Igor UA3DJY on 20191118

subroutine chkspecial8(msg37,msg37_2,nbadcrc)

  use ft8_mod1, only : mycall,hiscall
  character msg37*37,msg37_2*37,call_a*12,call_b*12,call_c*12
  logical(1) falsedec

  call_a='            '; call_b='            '; call_c='            '

! V03VTJ RR73; 2D3VDY <...> +08     call_a call_b call_c     
!V03VTJ <...> RR73         
!2D3VDY <...> +08          
! Y84NN RR73; HO5RFG <...> -16           
!Y84NN <...> RR73          
!HO5RFG <...> -16          
! P7IJQ RR73; MP4LEL <...> +02           
!P7IJQ <...> RR73          
!MP4LEL <...> +02 
 
  ispc1=index(msg37,' '); ispc2=index(msg37((ispc1+1):),' ')+ispc1; ispc12=index(msg37_2,' ')
  if(ispc1.gt.3 .and. ispc2.gt.7) then
    call_a=msg37(1:ispc1-1); call_b=msg37_2(1:ispc12-1); call_c=msg37(ispc1+1:ispc2-1)
    if(call_a.ne.mycall .and. call_b.ne.mycall .and. call_c.ne.hiscall) then
! call may not start from 'Q', zero and two digits
      if(call_a(1:1).eq.'Q' .or. call_b(1:1).eq.'Q') then
        nbadcrc=1; msg37='                                     '; msg37_2=msg37; return; endif
      if(call_a(1:1).eq.'0' .or. call_b(1:1).eq.'0') then
        nbadcrc=1; msg37='                                     '; msg37_2=msg37; return; endif
      if(call_a(1:1).ge.'0' .and. call_a(1:1).le.'9' .and. call_a(2:2).ge.'0' .and. call_a(2:2).le.'9') then
        nbadcrc=1; msg37='                                     '; msg37_2=msg37; return; endif
      if(call_b(1:1).ge.'0' .and. call_b(1:1).le.'9' .and. call_b(2:2).ge.'0' .and. call_b(2:2).le.'9') then
        nbadcrc=1;  msg37='                                     '; msg37_2=msg37; return; endif

      falsedec=.false.
      call chkflscall(call_a,call_b,falsedec)
      if(falsedec) then; nbadcrc=1; msg37='                                     '; msg37_2=msg37; return; endif
    endif
  endif

  return
end subroutine chkspecial8

! This source code file was last time modified by Igor UA3DJY on February 21st, 2018
! All changes are shown in the patch file coming together with the full JTDX source code.

subroutine filtersstd(decoded,mycall,falsedec,syncpwr)

  integer, parameter :: EGRIDMAX=111,PFXDMAX=69,PFXLMAX=54
  real syncpwr,datapwr,datacorr
  character grid*4,mycall*6,call1*6,call2*6,decoded*22,mycall12*12
  logical(1) falsedec
  character*2 egrid(EGRIDMAX)&
  /'AA','AB','AC','AD','AF','AM','AN','AR','BA','BB','BC','BD','BE','BF','BM','BN','CA','CB','CC','CD', &
   'CE','CF','CL','CK','CJ','CR','DA','DB','DC','DD','DE','DF','DH','DI','DJ','DR','EA','EB','EC','ED', &
   'EE','EF','EG','EH','ER','FA','FB','GA','GB','GE','GL','GM','GR','HA','HB','HC','HE','HF','HG','HJ', &
   'HL','HN','HO','HR','IA','IB','IC','ID','IE','IG','JA','JB','JC','JE','JR','KA','KB','KC','KD','KR', &
   'LA','LB','LC','LD','LF','LQ','MA','MB','MG','MR','NA','NB','NC','ND','NE','NF','NG','PA','PC','PD', &
   'PE','QA','QB','QC','RA','RC','RL','RM','RN','RQ','RR'/
  character*2 pfxd(PFXDMAX)&
  /'2E','2I','2K','2M','2W','3A','3B','3C','3D','3V','3W','3X','3Y','3Z','4A','4F','4J','4K','4L','4N', &
   '4O','4S','4U','4X','4Z','5A','5C','5H','5P','5Q','5R','5T','5U','5V','5W','5X','6K','7J','7K','7L', &
   '7M','7N','7O','7P','7Q','7S','7X','7Z','8J','8N','8P','8Q','8R','8S','9A','9G','9H','9J','9K','9L', &
   '9M','9N','9Q','9U','9V','9W','9X','9Y','9Z'/
  character*2 pfxl(PFXLMAX)&
  /'A2','A3','A4','A5','A6','A7','A9','C2','C3','C4','C5','C6','C9','D2','D4','D6','E1','E2','E3','E4', &
   'E5','E9','H2','H4','J2','J3','J4','J5','J6','J7','J8','P2','P3','P4','S0','S2','S5','S6','S7','S9', &
   'T2','T3','T4','T7','T8','T9','V2','V3','V4','V5','V6','V7','Z2','Z3'/


  mycall12='' !not used in chkfalse() for JT65
 
! check if any callsign begins with two digits

  i1=index(decoded,' ')
  if(i1.lt.4) go to 2
  i2=index(decoded(i1+1:),' ')
  if(i2.lt.4) go to 2
  if(i1.eq.4 .and. i2.eq.4) go to 2
  i2=i2+i1

  call1=decoded(1:i1-1)
  if(call1.eq.mycall) go to 4
  call2=decoded(i1+1:i2-1)
  if(i2.gt.14) go to 2 ! avoid getting out of decoded*22
  grid=decoded(i2+1:i2+4)

  if(call1(1:1).ge.'0' .and. call1(1:1).le.'9' .and. &
     call1(2:2).ge.'0' .and. call1(2:2).le.'9') go to 2
  
  if(call2(1:1).ge.'0' .and. call2(1:1).le.'9' .and. &
     call2(2:2).ge.'0' .and. call2(2:2).le.'9') go to 2

  if(call1(1:1).eq.'Q' .or. call2(1:1).eq.'Q') go to 2
  if(call1(1:1).eq.'0' .or. call2(1:1).eq.'0') go to 2
  if(call1(1:1).eq.'1' .and. call1(2:2).ne.'A' .and. call1(2:2).ne.'B') go to 2
  if(call2(1:1).eq.'1' .and. call2(2:2).ne.'A' .and. call2(2:2).ne.'B') go to 2

  if((grid(1:2).eq."GK" .and. grid(1:4).ne."GK03") .or. &
     (grid(1:2).eq."IF" .and. grid(1:4).ne."IF32") .or. &
     (grid(1:2).eq."IH" .and. grid(1:4).ne."IH74") .or. &
     (grid(1:2).eq."II" .and. grid(1:4).ne."II22") .or. &
     (grid(1:2).eq."JD" .and. grid(1:4).ne."JD15") .or. &
     (grid(1:2).eq."KE" .and. grid(1:4).ne."KE83") .or. &
      grid(1:3).eq."KF7" .or. &
     (grid(1:2).eq."LE" .and. grid(1:3).ne."LE5" .and. grid(1:3).ne."LE6") .or. &
      grid(1:4).eq."LJ08" .or. &
     (grid(1:2).eq."PB" .and. grid(1:4).ne."PB14") .or. &
      grid(1:4).eq."PI83" .or. &
     (grid(1:3).eq."PO8" .and. grid(1:4).ne."PO80") .or. &
      grid(1:3).eq."PP8" .or. grid(1:3).eq."PQ8" .or. &
     (grid(1:2).eq."QL" .and. grid(1:3).ne."QL0" .and. grid(1:3).ne."QL1") .or. &
     (grid(1:2).eq."RB" .and. grid(1:4).ne."RB25" .and. grid(1:4).ne."RB32") .or. &
     (grid(1:2).eq."RK" .and. grid(1:4).ne."RK39")) then

     if(call1(1:1).ge.'0' .and. call1(1:1).le.'9' .and. &
        call2(1:1).ge.'0' .and. call2(1:1).le.'9') go to 2

     if(call1(1:1).ge.'0' .and. call1(1:1).le.'9' .and. &
        call2(2:2).ge.'0' .and. call2(2:2).le.'9' .and. &
        call2(3:3).ge.'0' .and. call2(3:3).le.'9') go to 2

     if(call2(1:1).ge.'0' .and. call2(1:1).le.'9' .and. &
        call1(2:2).ge.'0' .and. call1(2:2).le.'9' .and. &
        call1(3:3).ge.'0' .and. call1(3:3).le.'9') go to 2
		 
     if(call1(2:2).ge.'0' .and. call1(2:2).le.'9' .and. &
        call1(3:3).ge.'0' .and. call1(3:3).le.'9' .and. &
        call2(2:2).ge.'0' .and. call2(2:2).le.'9' .and. &
        call2(3:3).ge.'0' .and. call2(3:3).le.'9') go to 2

     call chkfalse(decoded,mycall12,falsedec)
     if(falsedec) then
!print *,decoded ! diag only
        go to 4
     endif
  endif
  
  do i=1,EGRIDMAX
    if(grid(1:2).eq.egrid(i)) then

     if(call1(1:1).ge.'0' .and. call1(1:1).le.'9' .and. &
        call2(1:1).ge.'0' .and. call2(1:1).le.'9') go to 2

     if(call1(1:1).ge.'0' .and. call1(1:1).le.'9' .and. &
        call2(2:2).ge.'0' .and. call2(2:2).le.'9' .and. &
        call2(3:3).ge.'0' .and. call2(3:3).le.'9') go to 2

     if(call2(1:1).ge.'0' .and. call2(1:1).le.'9' .and. &
        call1(2:2).ge.'0' .and. call1(2:2).le.'9' .and. &
        call1(3:3).ge.'0' .and. call1(3:3).le.'9') go to 2
		 
     if(call1(2:2).ge.'0' .and. call1(2:2).le.'9' .and. &
        call1(3:3).ge.'0' .and. call1(3:3).le.'9' .and. &
        call2(2:2).ge.'0' .and. call2(2:2).le.'9' .and. &
        call2(3:3).ge.'0' .and. call2(3:3).le.'9') go to 2

       call chkfalse(decoded,mycall12,falsedec)
       if(falsedec) then
!print *,decoded ! diag only
          go to 4
       endif
    endif
  enddo
  

  if(call1(1:1).ge.'0' .and. call1(1:1).le.'9') then
     do i=1,PFXDMAX
        if(call1(1:2).eq.pfxd(i)) go to 4
     enddo
     call chkfalse(decoded,mycall12,falsedec)
     if(falsedec) then
!print *,decoded ! diag only
        go to 4
     endif
  endif

  if(call2(1:1).ge.'0' .and. call2(1:1).le.'9') then
     do i=1,PFXDMAX
        if(call2(1:2).eq.pfxd(i)) go to 4
     enddo
     call chkfalse(decoded,mycall12,falsedec)
     if(falsedec) then
!print *,decoded ! diag only
        go to 4
     endif
  endif

  if((call1(2:2).ge.'0' .and. call1(2:2).le.'9') .and. &
     (call1(3:3).ge.'0' .and. call1(3:3).le.'9')) then
      do i=1,PFXLMAX
        if(call1(1:2).eq.pfxl(i)) go to 4
      enddo
     call chkfalse(decoded,mycall12,falsedec)
     if(falsedec) then
!print *,decoded ! diag only
        go to 4
     endif
  endif

  if((call2(2:2).ge.'0' .and. call2(2:2).le.'9') .and. &
     (call2(3:3).ge.'0' .and. call2(3:3).le.'9')) then
      do i=1,PFXLMAX
        if(call2(1:2).eq.pfxl(i)) go to 4
      enddo
     call chkfalse(decoded,mycall12,falsedec)
     if(falsedec) then
!print *,decoded ! diag only
        go to 4
     endif
  endif

! check each callsign in the standard message if SNR is less than -27dB
  if(syncpwr.lt.70.)  then
     call chkfalse(decoded,mycall12,falsedec)
        if(falsedec) go to 4
  endif

  call datacor(datapwr,datacorr)

  qualityfac=datapwr/syncpwr

! check each callsign in the standard message if datapower/syncpower ratio is less than 0.165
  if(qualityfac.lt.0.18)  then
     call chkfalse(decoded,mycall12,falsedec)
     if(falsedec) go to 4
  endif

! check each callsign in the standard message if datacorr is less than 1.8
  if(datacorr.lt.1.8)  then
     call chkfalse(decoded,mycall12,falsedec)
     if(falsedec) go to 4
  endif

  go to 4

2 falsedec=.true.; return

4 return
end subroutine filtersstd

  use, intrinsic :: iso_c_binding, only: c_int, c_short, c_float, c_char, c_bool
  include 'constants.f90'

  !
  ! these structures must be kept in sync with ../commons.h
  !
  type, bind(C) :: params_block
!     character(kind=c_char) :: datetime(20)
     character(kind=c_char) :: mycall(12)
     character(kind=c_char) :: mybcall(12)
     character(kind=c_char) :: hiscall(12)
     character(kind=c_char) :: hisbcall(12)
!     character(kind=c_char) :: mygrid(6)
     character(kind=c_char) :: hisgrid(6)
     integer(c_int) :: listutc(10)
     integer(c_int) :: napwid
     integer(c_int) :: nQSOProgress
     integer(c_int) :: nftx
     integer(c_int) :: nutc
     integer(c_int) :: ntrperiod
     integer(c_int) :: nfqso
     integer(c_int) :: npts8
     integer(c_int) :: nfa
     integer(c_int) :: nfsplit
     integer(c_int) :: nfb
     integer(c_int) :: ntol
     integer(c_int) :: kin
     integer(c_int) :: nzhsym
     integer(c_int) :: ndepth
     integer(c_int) :: ncandthin
     integer(c_int) :: ndtcenter
     integer(c_int) :: nft8cycles
     integer(c_int) :: nft8swlcycles
     integer(c_int) :: ntxmode
     integer(c_int) :: nmode
     integer(c_int) :: nlist
     integer(c_int) :: nranera
     integer(c_int) :: ntrials10
     integer(c_int) :: ntrialsrxf10
     integer(c_int) :: naggressive
     integer(c_int) :: nharmonicsdepth
     integer(c_int) :: ntopfreq65
     integer(c_int) :: nprepass
     integer(c_int) :: nsdecatt
     integer(c_int) :: nlasttx
     integer(c_int) :: ndelay
     integer(c_int) :: nmt
     integer(c_int) :: nft8rxfsens
     integer(c_int) :: nft4depth
     integer(c_int) :: nsecbandchanged
     logical(c_bool) :: ndiskdat
     logical(c_bool) :: newdat
     logical(c_bool) :: nagain
     logical(c_bool) :: nagainfil
     logical(c_bool) :: nswl
     logical(c_bool) :: nfilter
     logical(c_bool) :: nstophint
     logical(c_bool) :: nagcc
     logical(c_bool) :: nhint
     logical(c_bool) :: fmaskact
     logical(c_bool) :: showharmonics
     logical(c_bool) :: lft8lowth
     logical(c_bool) :: lft8subpass
     logical(c_bool) :: ltxing
     logical(c_bool) :: lhidetest
     logical(c_bool) :: lhidetelemetry
     logical(c_bool) :: lhideft8dupes
     logical(c_bool) :: lhound
     logical(c_bool) :: lhidehash
     logical(c_bool) :: lcommonft8b
     logical(c_bool) :: lmycallstd
     logical(c_bool) :: lhiscallstd
     logical(c_bool) :: lapmyc
     logical(c_bool) :: lmodechanged
     logical(c_bool) :: lbandchanged
     logical(c_bool) :: lenabledxcsearch
     logical(c_bool) :: lwidedxcsearch
     logical(c_bool) :: lmultinst
     logical(c_bool) :: lskiptx1
     logical(c_bool) :: lforcesync
     logical(c_bool) :: learlystart
 end type params_block

  type, bind(C) :: dec_data
     real(c_float) :: ss(184,NSMAX)
     real(c_float) :: savg(NSMAX)
     integer(c_short) :: id2(NMAX)
     real(c_float) :: dd2(NMAX)
     type(params_block) :: params
  end type dec_data
  ! for unknown reason values of the variables at beginning of dec_data list are being
  ! not updated while Decode button is pushed manually, for decoding again keep variables at end
  ! of the list

module ft8_mod1

  parameter (NPS=180000,NFR=151680,NFILT1=4000,NFILT2=3400,numcqsig=20,numdeccq=40,nummycsig=5,numdecmyc=25,nmaxthreads=24) !NFRAME=1920*79
  real*4 dd8(nps)
  real endcorr(NFILT1/2+1),endcorrswl(NFILT2/2+1)
  complex cw(nps),csync(0:6,32),csynce(0:18,32),csyncsd(0:18,32),csyncsdcq(0:57,32),csynccq(0:7,32),ctwkw(11,32), &
          ctwkn(11,32),ctwk256(256)
  character*37 allmessages(200),msgsd76(76),msg(56),msgroot,msgincall(174)
  character lasthcall*12,mycall12_0*12,mycall12_00*12,hiscall12_0*12,hisgrid4*4
  character(len=12) :: mycall,hiscall,mybcall,hisbcall
  real allfreq(200),windowc1(0:54),windowx(0:200),pivalue,facx,twopi,facc1,dt,sumxdtt(24),avexdt, &
       xdtincall(174)
  integer itone76(76,79),idtone76(76,58),itone56(56,79),idtone56(56,58),idtone25(25,58),allsnrs(200),apsym(58),     &
          idtonemyc(58),mcq(29),mrrr(19),m73(19),mrr73(19),naptypes(0:5,27),icos7(0:6),graymap(0:7),nappasses(0:5), &
          nmsg,ndecodes,nlasttx,mycalllen1,msgrootlen,nfawide,nfbwide,nhaptypes(0:5,27),apsymsp(66),                &
          apsymdxns1(58),apsymdxnsrrr(77),ndxnsaptypes(0:5,27),apcqsym(77),apsymdxnsrr73(77),apsymdxns73(77),       &
          nft8cycles,nft8swlcycles,ncandallthr(24),maskincallthr(25),nincallthr(24),idtonecqdxcns(58),              &
          apsymmyns1(29),apsymmyns2(58),apsymmynsrr73(77),apsymmyns73(77),nmycnsaptypes(0:5,27),apsymdxstd(58),     &
          apsymdxnsr73(77),apsymdxns732(77),apsymmynsrrr(77),idtonedxcns73(58),idtonefox73(58),idtonespec(58),nintcount
  integer*1 gen(91,174)
  logical one(0:511,0:8),lqsomsgdcd,first_osd
  logical(1) lapmyc,lagcc,lagccbail,lhound,lenabledxcsearch,lwidedxcsearch,lmultinst,lskiptx1,ltxing
  data maskincallthr/0,30,45,55,65,75,85,90,95,100,105,110,115,120,125,130,135,140,145,150,155,160,165,170,175/
  data     mcq/0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0/
  data    mrrr/0,1,1,1,1,1,1,0,1,0,0,1,0,0,1,0,0,0,1/
  data     m73/0,1,1,1,1,1,1,0,1,0,0,1,0,1,0,0,0,0,1/
  data   mrr73/0,1,1,1,1,1,1,0,0,1,1,1,0,1,0,1,0,0,1/
  data   icos7/3,1,4,0,6,5,2/
  data graymap/0,1,3,2,5,6,4,7/
  data mycall12_0/'dummy'/
  data mycall12_00/'dummy'/
  data hiscall12_0/'dummy'/
! Hound OFF, MyCall is standard, DXCall is standard or empty
  data naptypes(0,1:27)/0,0,0,0,0,0,0,0,0,0,0,0,2,2,2,1,1,1,31,31,31,36,36,36,35,35,35/ ! Tx6 CQ
  data naptypes(1,1:27)/3,3,3,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,31,31,31,36,36,36,35,35,35/ ! Tx1 Grid
  data naptypes(2,1:27)/3,3,3,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,31,31,31,36,36,36,35,35,35/ ! Tx2 Report
  data naptypes(3,1:27)/3,3,3,6,6,6,5,5,5,4,4,4,0,0,0,0,0,0,31,31,31,36,36,36,35,35,35/ ! Tx3 RRreport
  data naptypes(4,1:27)/3,3,3,6,6,6,5,5,5,4,4,4,2,2,2,0,0,0,31,31,31,36,36,36,35,35,35/ ! Tx4 RRR,RR73
  data naptypes(5,1:27)/0,0,0,0,0,0,0,0,0,0,0,0,2,2,2,1,1,1,31,31,31,36,36,36,35,35,35/ ! Tx5 73
! Hound OFF, MyCall is non-standard, DXCall is standard or empty
  data nmycnsaptypes(0,1:27)/0,0,0,0,0,0,0,0,0,0,0,0,40,40,40,1,1,1,31,31,31,36,36,36,35,35,35/             ! Tx6 CQ
  data nmycnsaptypes(1,1:27)/41,41,41,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,31,31,31,36,36,36,35,35,35/             ! Tx1 DXcall MyCall
  data nmycnsaptypes(2,1:27)/41,41,41,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,31,31,31,36,36,36,35,35,35/             ! Tx2 Report
  data nmycnsaptypes(3,1:27)/41,41,41,44,44,44,43,43,43,42,42,42,0,0,0,0,0,0,31,31,31,36,36,36,35,35,35/    ! Tx3 RRreport
  data nmycnsaptypes(4,1:27)/41,41,41,44,44,44,43,43,43,42,42,42,40,40,40,0,0,0,31,31,31,36,36,36,35,35,35/ ! Tx4 RRR,RR73
  data nmycnsaptypes(5,1:27)/0,0,0,0,0,0,0,0,0,0,0,0,40,40,40,1,1,1,31,31,31,36,36,36,35,35,35/             ! Tx5 73
! Hound mode
  data nhaptypes(0,1:27)/0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,0,0,0,0,0,0,111,111,111/       ! Tx6 CQ, possible in idle mode if DXCall is empty
  data nhaptypes(1,1:27)/21,21,21,22,22,22,0,0,0,0,0,0,0,0,0,31,31,31,0,0,0,36,36,36,0,0,0/ ! Tx1 Grid idle mode or transmitting
  data nhaptypes(2,1:27)/0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0/             ! Tx2 none
  data nhaptypes(3,1:27)/21,21,21,22,22,22,23,23,23,24,24,24,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0/ ! Tx3 RRreport QSO in progress or QSO is finished
  data nhaptypes(4,1:27)/0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0/             ! Tx4 none
  data nhaptypes(5,1:27)/0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0/             ! Tx5 none
!non-standard DXCall
  data ndxnsaptypes(0,1:27)/0,0,0,0,0,0,0,0,0,0,0,0,2,2,2,1,1,1,31,31,31,36,36,36,35,35,35/             ! Tx6 CQ
  data ndxnsaptypes(1,1:27)/11,11,11,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,31,31,31,36,36,36,35,35,35/          ! Tx1 Grid
  data ndxnsaptypes(2,1:27)/11,11,11,0,0,0,0,0,0,0,0,0,0,0,0,1,1,1,31,31,31,36,36,36,35,35,35/          ! Tx2 Report
  data ndxnsaptypes(3,1:27)/11,11,11,14,14,14,13,13,13,12,12,12,0,0,0,0,0,0,31,31,31,36,36,36,35,35,35/ ! Tx3 RRreport
  data ndxnsaptypes(4,1:27)/11,11,11,14,14,14,13,13,13,12,12,12,2,2,2,0,0,0,31,31,31,36,36,36,35,35,35/ ! Tx4 RRR,RR73
  data ndxnsaptypes(5,1:27)/0,0,0,0,0,0,0,0,0,0,0,0,2,2,2,1,1,1,31,31,31,36,36,36,35,35,35/             ! Tx5 73
  data nintcount/0/
  data avexdt/0.0/
  data first_osd/.true./
  
  type odd_struct
    real freq
    real dt
    logical lstate
    character*37 msg
  end type odd_struct
  type(odd_struct) odd(130)

  type even_struct
    real freq
    real dt
    logical lstate
    character*37 msg
  end type even_struct
  type(even_struct) even(130)

  type oddcopy_struct
    real freq
    real dt
    logical lstate
    character*37 msg
  end type oddcopy_struct
  type(oddcopy_struct) oddcopy(130)

  type evencopy_struct
    real freq
    real dt
    logical lstate
    character*37 msg
  end type evencopy_struct
  type(evencopy_struct) evencopy(130)
  
  type lastrxmsg_struct
    real xdt
    logical lstate
    character*37 lastmsg
  end type lastrxmsg_struct
  type (lastrxmsg_struct) lastrxmsg(1)
  data lastrxmsg%lstate/.false./

  type callsigndtodd_struct
    real dt
    character*12 call2
  end type callsigndtodd_struct
  type (callsigndtodd_struct) calldtodd(150)

  type callsigndteven_struct
    real dt
    character*12 call2
  end type callsigndteven_struct
  type (callsigndteven_struct) calldteven(150)

  type incall_struct
    real xdt
    character*37 msg
  end type incall_struct
  type (incall_struct) incall(30)

  type evencq_struct
    real freq
    real xdt
    complex cs(0:7,79)
  end type evencq_struct
  type(evencq_struct) evencq(numcqsig,nmaxthreads) ! 24 threads

  type oddcq_struct
    real freq
    real xdt
    complex cs(0:7,79)
  end type oddcq_struct
  type(oddcq_struct) oddcq(numcqsig,nmaxthreads)

  type evenmyc_struct
    real freq
    real xdt
    complex cs(0:7,79)
  end type evenmyc_struct
  type(evenmyc_struct) evenmyc(nummycsig,nmaxthreads)

  type oddmyc_struct
    real freq
    real xdt
    complex cs(0:7,79)
  end type oddmyc_struct
  type(oddmyc_struct) oddmyc(nummycsig,nmaxthreads)

  type evenqso_struct
    real freq
    real xdt
    complex cs(0:7,79)
  end type evenqso_struct
  type(evenqso_struct) evenqso(1,nmaxthreads)

  type oddqso_struct
    real freq
    real xdt
    complex cs(0:7,79)
  end type oddqso_struct
  type(oddqso_struct) oddqso(1,nmaxthreads)

end module ft8_mod1

module ft4_decode

  type :: ft4_decoder
    procedure(ft4_decode_callback), pointer :: callback
  contains
    procedure :: decode
  end type ft4_decoder

  abstract interface
    subroutine ft4_decode_callback (this,snr,dt,freq,decoded,servis4)
      import ft4_decoder
      implicit none
      class(ft4_decoder), intent(inout) :: this
      integer, intent(in) :: snr
      real, intent(in) :: dt
      real, intent(in) :: freq
      character(len=26), intent(in) :: decoded
      character(len=1), intent(in) :: servis4
    end subroutine ft4_decode_callback
  end interface

contains

  subroutine decode(this,callback,nQSOProgress,nfqso,nfa,nfb,ndepth,stophint,swl)
!    use timer_module, only: timer
    use packjt77
    use ft4_mod1, only : nFT4decd,nfafilt,nfbfilt,lfilter,lhidetest,lhidetelemetry
    use ft8_mod1, only : sumxdtt,avexdt,mycall,hiscall
    include 'ft4/ft4_params.f90'
    class(ft4_decoder), intent(inout) :: this
    procedure(ft4_decode_callback) :: callback
    parameter (NSS=NSPS/NDOWN,NDMAX=NMAX/NDOWN)
    character message*37,msg26*26,msgsent*37,msg37_2*37
    character c77*77
    character*37 decodes(100)
    character*12 mycall0,hiscall0,call_a,call_b
    character*4 servis4
    complex cd2(0:NDMAX-1)                  !Complex waveform
    complex cb(0:NDMAX-1)
    complex cd(0:NN*NSS-1)                       !Complex waveform
    complex ctwk(2*NSS),ctwk2(2*NSS,-16:16)
    real a(5)
    real bitmetrics(2*NN,3)
    real llr(2*ND),llra(2*ND),llrb(2*ND),llrc(2*ND),llrd(2*ND)
    real candidate(2,100)
    integer apbits(2*ND)
    integer*1 message77(77),rvec(77),apmask(2*ND),cw(2*ND)
    integer*1 hbits(2*NN)
    integer i4tone(103)
    integer nappasses(0:5)    ! # of decoding passes for QSO States 0-5
    integer naptypes(0:5,4)   ! nQSOProgress, decoding pass
    integer mcq(29),mrrr(19),m73(19),mrr73(19)
    logical nohiscall,unpk77_success,first,dobigfft,dosubtract,doosd,badsync,lFreeText,lhidemsg
    logical(1), intent(in) :: stophint,swl
    logical(1) falsedec

    data first/.true./
    data     mcq/0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,1,0,0/
    data    mrrr/0,1,1,1,1,1,1,0,1,0,0,1,0,0,1,0,0,0,1/
    data     m73/0,1,1,1,1,1,1,0,1,0,0,1,0,1,0,0,0,0,1/
    data   mrr73/0,1,1,1,1,1,1,0,0,1,1,1,0,1,0,1,0,0,1/
    data rvec/0,1,0,0,1,0,1,0,0,1,0,1,1,1,1,0,1,0,0,0,1,0,0,1,1,0,1,1,0, &
      1,0,0,1,0,1,1,0,0,0,0,1,0,0,0,1,0,1,0,0,1,1,1,1,0,0,1,0,1, &
      0,1,0,1,0,1,1,0,1,1,1,1,1,0,0,0,1,0,1/
    save fs,dt1,tt,txt,twopi,h,first,apbits,nappasses,naptypes, &
      mycall0,hiscall0,ctwk2

    this%callback => callback
    mycalllen1=len_trim(mycall)+1
    smax=0.; smax1=0.; nd1=0 ! smax init value shall be increased to 1.+ ?

    if(first) then
      fs=12000.0/NDOWN                !Sample rate after downsampling
      dt1=1/fs                         !Sample interval after downsample (s)
      tt=NSPS*dt1                      !Duration of "itone" symbols (s)
      txt=NZ*dt1                       !Transmission length (s) without ramp up/down
      twopi=8.0*atan(1.0)
      h=1.0

      do idf=-16,16
        a=0.
        a(1)=real(idf)
        ctwk=1.
        call twkfreq1(ctwk,0,2*NSS,2*NSS,fs/2.0,a,ctwk2(:,idf))
      enddo

      mcq=2*mod(mcq+rvec(1:29),2)-1
      mrrr=2*mod(mrrr+rvec(59:77),2)-1
      m73=2*mod(m73+rvec(59:77),2)-1
      mrr73=2*mod(mrr73+rvec(59:77),2)-1
      nappasses(0)=2; nappasses(1)=2; nappasses(2)=2; nappasses(3)=2; nappasses(4)=2; nappasses(5)=3

! iaptype
!   1        CQ     ???    ???           (29 ap bits)
!   2        MyCall ???    ???           (29 ap bits)
!   3        MyCall DxCall ???           (58 ap bits)
!   4        MyCall DxCall RRR           (77 ap bits)
!   5        MyCall DxCall 73            (77 ap bits)
!   6        MyCall DxCall RR73          (77 ap bits)

      naptypes(0,1:4)=(/1,2,0,0/) ! Tx6 selected (CQ)
      naptypes(1,1:4)=(/2,3,0,0/) ! Tx1
      naptypes(2,1:4)=(/2,3,0,0/) ! Tx2
      naptypes(3,1:4)=(/3,6,0,0/) ! Tx3
      naptypes(4,1:4)=(/3,6,0,0/) ! Tx4
      naptypes(5,1:4)=(/3,1,2,0/) ! Tx5

      mycall0=''; hiscall0=''; first=.false.
    endif

    l1=index(mycall,char(0)); if(l1.ne.0) mycall(l1:)=" "
    l1=index(hiscall,char(0)); if(l1.ne.0) hiscall(l1:)=" "
    if(mycall.ne.mycall0 .or. hiscall.ne.hiscall0) then
      apbits=0; apbits(1)=99; apbits(30)=99
      if(len(trim(mycall)) .lt. 3) go to 10
      nohiscall=.false.; hiscall0=hiscall
! use mycall for dummy hiscall - mycall won't be hashed
      if(len(trim(hiscall0)).lt.3) then; hiscall0=mycall; nohiscall=.true.; endif
      message=trim(mycall)//' '//trim(hiscall0)//' RR73'
      i3=-1; n3=-1
      call pack77(message,i3,n3,c77,1); call unpack77(c77,1,msgsent,unpk77_success,1)
      if(i3.ne.1 .or. (message.ne.msgsent) .or. .not.unpk77_success) go to 10
      read(c77,'(77i1)') message77
      message77=mod(message77+rvec,2)
      call encode174_91(message77,cw)
      apbits=2*cw-1
      if(nohiscall) apbits(30)=99
10    continue
      mycall0=mycall; hiscall0=hiscall
    endif

    maxcand=100; ndecodes=0; decodes=' '; fa=nfa; fb=nfb
! ndepth=1: 1 pass, no subtraction
! ndepth=2: 3 passes, bp only
! ndepth=3: 3 passes, bp+osd
    max_iterations=40; syncmin=1.2; dosubtract=.true.; doosd=.true.; nsp=3
    if(ndepth.eq.2) doosd=.false.
    if(ndepth.eq.1) then; nsp=1; dosubtract=.false.; doosd=.false.; endif

    do isp = 1,nsp
      if(isp.eq.2) then; if(ndecodes.eq.0) exit; nd1=ndecodes
      elseif(isp.eq.3) then; nd2=ndecodes-nd1; if(nd2.eq.0) exit
      endif

      candidate=0.0
      ncand=0
      call getcandidates4(fa,fb,syncmin,nfqso,maxcand,candidate,ncand)
      dobigfft=.true.
      do icand=1,ncand
        f0=candidate(1,icand)
        nf0=nint(f0); if(lfilter .and. (nf0.lt.nfafilt .or. nf0.gt.nfbfilt)) cycle
        snr=candidate(2,icand)-1.0
!print *,icand,f0,snr
        call ft4_downsample(dobigfft,f0,cd2)  !Downsample to 32 Sam/Sym
        if(dobigfft) dobigfft=.false.
        sum2=sum(cd2*conjg(cd2))/(real(NMAX)/real(NDOWN))
        if(sum2.gt.0.0) cd2=cd2/sqrt(sum2)
! Sample rate is now 12000/18 = 666.67 samples/second
! +/- 1.1 +/- 735 (1470); +/- 1.4 +/- 934.5 (1869); 0.5 sec 334 samples
        if(swl) then; ibwindow=623; else; ibwindow=490; endif ! /3
        ibottom=(0.5+avexdt)*666.67-667
        do iseg=1,3                ! DT search is done over 3 segments
          do isync=1,2          
            if(isync.eq.1) then
              idfmin=-12
              idfmax=12
              idfstp=3
!-1.0..+1.4; -1.2..+1.7 start window
              if(abs(avexdt).lt.1.e-6) then
                if(iseg.eq.1) then
                  if(swl) then; ibmin=179; ibmax=823; else; ibmin=194; ibmax=730; endif
                elseif(iseg.eq.2) then
                  smax1=smax
                  if(swl) then; ibmin=824; ibmax=1467; else; ibmin=731; ibmax=1266; endif
                elseif(iseg.eq.3) then
                  if(swl) then; ibmin=-467; ibmax=178; else; ibmin=-344; ibmax=193; endif
                endif
              else
                if(iseg.eq.1) then
                  ibmin=ibottom+ibwindow+1; ibmax=ibottom+ibwindow*2
                elseif(iseg.eq.2) then
                  smax1=smax
                  ibmin=ibottom+ibwindow*2+1; ibmax=ibottom+ibwindow*3
                elseif(iseg.eq.3) then
                  ibmin=ibottom; ibmax=ibottom+ibwindow
                endif
              endif
              ibstp=4
            else
              idfmin=idfbest-4
              idfmax=idfbest+4
              idfstp=1
              ibmin=ibest-5
              ibmax=ibest+5
              ibstp=1
            endif
            ibest=-1
            idfbest=0
            smax=-99.
            do idf=idfmin,idfmax,idfstp
              do istart=ibmin,ibmax,ibstp
                call sync4d(cd2,istart,ctwk2(:,idf),1,sync)  !Find sync power
                if(sync.gt.smax) then
                  smax=sync
                  ibest=istart
                  idfbest=idf
                endif
              enddo
            enddo
          enddo
          if(iseg.eq.1) smax1=smax
          if(smax.lt.1.2) cycle
          if(iseg.gt.1 .and. smax.lt.smax1) cycle 
          f1=f0+real(idfbest)
          if( f1.le.10.0 .or. f1.ge.4990.0 ) cycle
          call ft4_downsample(dobigfft,f1,cb) !Final downsample, corrected f0
          sum2=sum(abs(cb)**2)/(real(NSS)*NN)
          if(sum2.gt.0.0) cb=cb/sqrt(sum2)
          cd=0.
          if(ibest.ge.0) then
            it=min(NDMAX-1,ibest+NN*NSS-1)
            np=it-ibest+1
            cd(0:np-1)=cb(ibest:it)
          else
            cd(-ibest:ibest+NN*NSS-1)=cb(0:NN*NSS+2*ibest-1)
          endif
          call get_ft4_bitmetrics(cd,bitmetrics,badsync)
          if(badsync) cycle
          hbits=0
          where(bitmetrics(:,1).ge.0) hbits=1
          ns1=count(hbits(  1:  8).eq.(/0,0,0,1,1,0,1,1/))
          ns2=count(hbits( 67: 74).eq.(/0,1,0,0,1,1,1,0/))
          ns3=count(hbits(133:140).eq.(/1,1,1,0,0,1,0,0/))
          ns4=count(hbits(199:206).eq.(/1,0,1,1,0,0,0,1/))
          nsync_qual=ns1+ns2+ns3+ns4
          if(nsync_qual.lt. 20) cycle

          scalefac=2.83
          llra(  1: 58)=bitmetrics(  9: 66, 1)
          llra( 59:116)=bitmetrics( 75:132, 1)
          llra(117:174)=bitmetrics(141:198, 1)
          llra=scalefac*llra
          llrb(  1: 58)=bitmetrics(  9: 66, 2)
          llrb( 59:116)=bitmetrics( 75:132, 2)
          llrb(117:174)=bitmetrics(141:198, 2)
          llrb=scalefac*llrb
          llrc(  1: 58)=bitmetrics(  9: 66, 3)
          llrc( 59:116)=bitmetrics( 75:132, 3)
          llrc(117:174)=bitmetrics(141:198, 3)
          llrc=scalefac*llrc

          apmag=maxval(abs(llra))*1.1
          npasses=3+nappasses(nQSOProgress)
          if(stophint) npasses=4
          if(ndepth.eq.1) npasses=3
          do ipass=1,npasses
            if(ipass.eq.1) llr=llra; if(ipass.eq.2) llr=llrb; if(ipass.eq.3) llr=llrc
            if(ipass.le.3) then; apmask=0; iaptype=0; endif
            if(ipass.gt.3) then
              llrd=llra
              iaptype=naptypes(nQSOProgress,ipass-3)
              if(stophint) iaptype=1
! Conditions that cause us to bail out of AP decoding
              napwid=50
              if(iaptype.ge.3 .and. (abs(f1-nfqso).gt.napwid)) cycle
              if(iaptype.ge.2 .and. apbits(1).gt.1) cycle  ! No, or nonstandard, mycall
              if(iaptype.ge.3 .and. apbits(30).gt.1) cycle ! No, or nonstandard, dxcall

              if(iaptype.eq.1) then; apmask=0; apmask(1:29)=1; llrd(1:29)=apmag*mcq(1:29); endif ! CQ
              if(iaptype.eq.2) then; apmask=0; apmask(1:29)=1; llrd(1:29)=apmag*apbits(1:29); endif ! MyCall,???,???
              if(iaptype.eq.3) then; apmask=0; apmask(1:58)=1; llrd(1:58)=apmag*apbits(1:58); endif ! MyCall,DxCall,???
              if(iaptype.eq.4 .or. iaptype.eq.5 .or. iaptype.eq.6) then ! mycall, hiscall, RRR|73|RR73
                apmask=0; apmask(1:77)=1; if(iaptype.eq.6) llrd(1:77)=apmag*apbits(1:77)
              endif
              llr=llrd
            endif
            message77=0; dmin=0.0
            call bpdecode174_91(llr,apmask,max_iterations,message77,cw,nharderror,niterations)
            if(doosd .and. nharderror.lt.0) then
              ndeep=3
!              if(abs(nfqso-f1).le.napwid) ndeep=4
              call osd4_174_91(llr,apmask,ndeep,message77,cw,nharderror,dmin)
            endif

            if(sum(message77).eq.0) cycle
            if(nharderror.ge.0) then
              message77=mod(message77+rvec,2) ! remove rvec scrambling
              write(c77,'(77i1)') message77(1:77); read(c77(72:74),'(b3)') n3; read(c77(75:77),'(b3)') i3
              call unpack77(c77,1,message,unpk77_success,1)
              if(message.eq."") cycle ! being treated as false decode
              if(unpk77_success.and.dosubtract) then
                call get_ft4_tones_from_77bits(message77,i4tone)
                dt=real(ibest)/666.67
                call subtractft4(i4tone,f1,dt)
              endif

              lhidemsg=.false.
              if(lhidetelemetry .and. i3.eq.0 .and. n3.eq.5) lhidemsg=.true.
              if(lhidetest) then
                if((i3.eq.0 .and. n3.gt.1 .and. n3.lt.5) .or. i3.eq.3 .or. i3.gt.4) then
                  if(mycalllen1.lt.4 .or. message(1:mycalllen1).ne.trim(mycall)//' ') lhidemsg=.true.
                endif
                if(message(1:3).eq.'CQ ') then
                  if(message(1:6).eq.'CQ RU ' .or. message(1:6).eq.'CQ FD ' .or. message(1:8).eq.'CQ TEST ') &
                    lhidemsg=.true.
                endif
              endif

              lFreeText=.false.; if(i3.eq.0 .and. n3.eq.0) lFreeText=.true.
! delete braces
              if(.not.lFreeText .and. index(message,'<').gt.0) then ! DXpedition being not supported in FT4
                ispc1=index(message,' '); ispc2=index(message((ispc1+1):),' ')+ispc1
                ispc3=index(message((ispc2+1):),' ')+ispc2
                ieoc1=ispc1-1; iboc2=ispc1+1; ieoc2=ispc2-1
                if(message(1:1).eq.'<' .and. message(2:2).ne.'.') then
                  message(ieoc1:37)=message(ieoc1+1:37)//' '; message(1:37)=message(2:37)//' '
                else if(message(iboc2:iboc2).eq.'<' .and. message(iboc2+1:iboc2+1).ne.'.') then
                  message(ieoc2:37)=message(ieoc2+1:37)//' '; message(iboc2:37)=message(iboc2+1:37)//' '
                else
                  iboc3=ispc2+1; ieoc3=ispc3-1
                  if(message(iboc3:iboc3).eq.'<' .and. message(iboc3+1:iboc3+1).ne.'.') then
                    message(ieoc3:37)=message(ieoc3+1:37)//' '; message(iboc3:37)=message(iboc3+1:37)//' '
                  endif
                endif
              endif

              idupe=0
              do i=1,ndecodes; if(decodes(i).eq.message) idupe=1; enddo
              if(idupe.eq.1) exit
              ndecodes=ndecodes+1; decodes(ndecodes)=message
              if(snr.gt.0.0) then; xsnr=10*log10(snr)-14.8; else; xsnr=-21.0; endif
              nsnr=nint(max(-21.0,xsnr))
              xdt=ibest/666.67 - 0.5
! check for false decodes
! i3=3 n3=4  TU; B69FWJ 8Z6IB 559 580  
! i3=3 n3=3  TU; FD9GRU HT1HHY R 529 11
              if(message(1:3).eq.'TU;' .and. nsnr.lt.-15 .and. i3.eq.3 .and. (n3.eq.3 .or. n3.eq.4)) then
                ispc1=index(message,' '); ispc2=index(message((ispc1+1):),' ')+ispc1 
                ispc3=index(message((ispc2+1):),' ')+ispc2
                call_a=''; call_b=''; call_a=message(ispc1+1:ispc2-1); call_b=message(ispc2+1:ispc3-1)
                falsedec=.false.; call chkflscall(call_a,call_b,falsedec)
                if(falsedec) then; message=''; cycle; endif
              endif
              if(iaptype.eq.1 .and. xsnr.lt.-15.) then
                nbadcrc=0; call chkfalse8(message,i3,n3,nbadcrc,iaptype,.false.)
                if(nbadcrc.eq.1) then; message=''; cycle; endif
              endif
! EA1AHY M83WN/R R QA79   *
! MS8QQS UX3QBS/P R NG63  i3=2 n3=7
! 3B4NDC/R C40AUZ/R R IR83  i3=1 n3=7
! EA1AHY PW1BSL R GR47 i3=1 n3=3 mycall
! EA1AHY PW1BSL R GR47 *  i3=1 n3=1 mycall
              if((i3.eq.1 .or. i3.eq.2) .and. index(message,' R ').gt.0) then
                ispc1=index(message,' '); ispc2=index(message((ispc1+1):),' ')+ispc1
                ispc3=index(message((ispc2+1):),' ')+ispc2
                if(message(ispc2:ispc3).eq.' R ') then 
                  call_a='            '; call_b='            '
                  if(message(1:ispc1-1).eq.trim(mycall)) then
                    call_a='CQ          '
                  else
                    if((i3.eq.1 .and. message(ispc1-2:ispc1-1).eq.'/R') .or. &
                       (i3.eq.2 .and. message(ispc1-2:ispc1-1).eq.'/R')) then
                      call_a=message(1:ispc1-3)
                    else
                      call_a=message(1:ispc1-1)
                    endif
                  endif
                  if((i3.eq.1 .and. message(ispc2-2:ispc2-1).eq.'/R') .or. &
                     (i3.eq.2 .and. message(ispc2-2:ispc2-1).eq.'/P')) then
                    call_b=message(ispc1+1:ispc2-3)
                  else
                    call_b=message(ispc1+1:ispc2-1)
                  endif
                  falsedec=.false.; call chkflscall(call_a,call_b,falsedec)
                  if(falsedec) then; nbadcrc=1; message=''; return; endif
                endif
              endif
!write(21,'(i6.6,i5,2x,f4.1,i6,2x,a37,2x,f4.1,3i3,f5.1,i4,i4,i4)') &
!  nutc,nsnr,xdt,nint(f1),message,smax,iaptype,ipass,isp,dmin,nsync_qual,nharderror,iseg
              if(i3.eq.0 .and. n3.eq.1) then ! special DXpedition msg
                call msgparser(message,msg37_2)
                servis4="1"
                msg26=message(1:26); call this%callback(nsnr,xdt,f1,msg26,servis4)
                msg26=msg37_2(1:26); call this%callback(nsnr,xdt,f1,msg26,servis4)
              else
                msg26=message(1:26); servis4=""
                if(lFreeText) then; if(abs(nfqso-nint(f1)).le.10) then; servis4=','; else; servis4='.'; endif; endif
                if(.not.lhidemsg) call this%callback(nsnr,xdt,f1,msg26,servis4)
              endif
              nFT4decd=nFT4decd+1; sumxdtt(1)=sumxdtt(1)+xdt
              exit
            endif
          enddo !Sequence estimation
          if(nharderror.ge.0) exit
        enddo !3 DT segments
      enddo    !Candidate list
    enddo       !Subtraction loop

    return
  end subroutine decode

end module ft4_decode

! This source code file was last time modified by Igor UA3DJY on 20181215
! All changes are shown in the patch file coming together with the full JTDX source code.

subroutine hintwidedx(mrs,mrs2,decoded,hint_wide,npass1)

  use packjt
  use prog_args
  use jt65_mod2, only : s3,correct_hint
  parameter (MAXCALLS=35000)
  parameter (MAXMSG=MAXCALLS)
  real u1
  integer*1 sym2(0:62,MAXMSG) 
  integer mrs(63),mrs2(63),dgen(12),sym_rev(0:62)
  character*6 call2(MAXCALLS)
  character*4 grid2(MAXCALLS)
  character line*180,msg*22,msg00*22,callsign*12,grid*4,decoded*22
  character*22 msg0(MAXMSG)
  logical(1) hint_wide,npass1,first
  data first/.true./
  save first,nused,msg0,sym2

  if(first) then
     open(23,file=trim(data_dir)//'/CALL3.TXT',status='unknown')
     icall=0
     j=0
     do i=1,MAXCALLS
        read(23,1002,end=10) line
1002    format(a80)
        if(line(1:4).eq.'ZZZZ') exit
        if(line(1:2).eq.'//') cycle
        i1=index(line,',')
        if(i1.lt.4) cycle
        i2=index(line(i1+1:),',')
        if(i2.lt.5) cycle
        i2=i2+i1
        callsign=line(1:i1-1)
        grid=line(i1+1:i2-1)
        j=j+1
        call2(j)=callsign(1:6)               !### Fix for compound callsigns!
        grid2(j)=grid
     enddo
10   ncalls=j
     if(ncalls.lt.1) then
        print *, 'copy CALL3.TXT file to log directory'
        print *, 'http://www.jtdx.tech'
!        stop 'CALL3.TXT is too short or missed?'
     endif
     close(23)

     if(ncalls.eq.0) then
        first=.false.
        return
     endif

     j=0
     do i=1,ncalls
           j=j+1
           msg='CQ DX '//call2(i)//' '//grid2(i)

           call fmtmsg(msg,iz)
           call packmsg(msg,dgen,itype)            !Pack message into 72 bits
           call rs_encode(dgen,sym_rev)            !RS encode
           call interleave63(sym_rev,1)            !Interleave channel symbols
           call graycode(sym_rev,63,1,sym_rev)     !Apply Gray code
           sym2(0:62,j)=sym_rev(0:62)
           msg0(j)=msg
     enddo
     nused=j
     first=.false.
  endif

  ref0=0.
  do j=1,63
     ref0=ref0 + s3(mrs(j)+1,j)
  enddo

  u1=0.
  u1=-99.0
  u2=u1

! Find u1 and u2 (best and second-best) codeword from a list, using 
! a bank of matched filters on the symbol spectra s3(i,j).
  ipk=1
  ipk2=0
  msg00='                      '
  do k=1,nused
        psum=0.
        ref=ref0
        do j=1,63
           i=sym2(j-1,k)+1
           psum=psum + s3(i,j)
           if(i.eq.mrs(j)+1) ref=ref - s3(i,j) + s3(mrs2(j)+1,j)
        enddo
        p=psum/ref

        if(p.gt.u1) then
           if(msg0(k).ne.msg00) then
              ipk2=ipk
              u2=u1
           endif
           u1=p
           ipk=k
           msg00=msg0(k)
        endif
        if(msg0(k).ne.msg00 .and. p.gt.u2) then
           u2=p
           ipk2=k
        endif

  enddo

  decoded='                      '
  bias=max(1.12*u2,0.35)
  qual=100.0*(u1-bias)
  thresh=(qual+8.0)*u1

  hint_wide=.false.
  if(qual.ge.5.6 .or. u1.ge.0.69) then !maximizing sensitivity using 'OR'
!now blocking most of the false decodes 
     if(npass1) then
        if((thresh.gt.7.9 .and. u1.gt.0.63) .or. (thresh.gt.10.5 .and. u1.le.0.63)) then
!print *,qual,u1
!print *,thresh
           decoded=msg0(ipk)
           hint_wide=.true.
           correct_hint(1:63)=sym2(0:62,ipk)
        endif
     endif

     if(.not.npass1) then
        if(u1.gt.0.7 .and. thresh.lt.12.0) return
        if(u1.gt.0.8 .and. thresh.lt.20.0) return
        if(u1.gt.0.9 .and. thresh.lt.30.0) return
        if((thresh.gt.9.6 .and. u1.gt.0.63) .or. (thresh.gt.10.5 .and. u1.le.0.63)) then
!print *,qual,u1
!print *,thresh
           decoded=msg0(ipk)
           hint_wide=.true.
           correct_hint(1:63)=sym2(0:62,ipk)
        endif
     endif 
  endif

return
end subroutine hintwidedx

! last time modified by Igor UA3DJY on 20200105

subroutine partintft4(ndelay,nutc)

  use ft4_mod1, only : dd4
  real rnd

  if(ndelay.gt.50) ndelay=50
  numsamp=nint((float(ndelay))*1200) ! 12000 sample rate
  dd4(numsamp+1:73728)=dd4(1:(73728-numsamp))
  do i=1,numsamp
     call random_number(rnd)
     dd4(i)=10.0*rnd-5.
  enddo
  write(*,2) nutc,'partial loss of data','d'
2 format(i6.6,2x,a20,21x,a1)
  call flush(6)

  return
end subroutine partintft4

! This source code file was last time modified by Igor Chernikov UA3DJY on October 03rd, 2016.
! All changes are shown in the patch file coming together with the full JTDX source code.

subroutine twkfreq65(cx,n5,a)

  complex cx(n5)
  real a(2)
  complex w,wstep
  data twopi/6.283185307/

! Apply AFC corrections to the cx data
  w=1.0
  wstep=1.0
  x0=0.5*n5
  do i=1,n5
     if(mod(i,100).eq.1) then
        x=(i-x0)/float(n5)
        dphi=(a(1) + x*a(2)) * (twopi/1378.125)
        wstep=cmplx(cos(dphi),sin(dphi))
     endif
     w=w*wstep
     cx(i)=w*cx(i)
  enddo
  return
end subroutine twkfreq65

! This source code file was last time modified by Igor UA3DJY on 20181215
! All changes are shown in the patch file coming together with the full JTDX source code.

subroutine gen65(msg0,ichk,msgsent,itone,itype)

! Encodes a JT65 message to yieild itone(1:126)

  use packjt
  use jt65_mod4
  character*22 msg0
  character*22 message          !Message to be generated
  character*22 msgsent          !Message as it will be received
  integer itone(126)
  integer dgen(13)
  integer sent(63)
  save

  if(msg0(1:1).eq.'@') then
     read(msg0(2:5),*,end=1,err=1) nfreq
     go to 2
1    nfreq=1000
2    itone(1)=nfreq
  else
     message=msg0
     do i=1,22
        if(ichar(message(i:i)).eq.0) then
           message(i:)='                      '
           exit
        endif
     enddo

     do i=1,22                               !Strip leading blanks
        if(message(1:1).ne.' ') exit
        message=message(i+1:)
     enddo

        call packmsg(message,dgen,itype)    !Pack message into 72 bits
        call unpackmsg(dgen,msgsent)        !Unpack to get message sent
        if(ichk.ne.0) go to 999             !Return if checking only

        call rs_encode(dgen,sent)           !Apply Reed-Solomon code
        call interleave63(sent,1)           !Apply interleaving
        call graycode65(sent,63,1)          !Apply Gray code
        nsym=126                            !Symbols per transmission

     k=0
     do j=1,nsym
        if(.not.prc(j)) then
           k=k+1
           itone(j)=sent(k)+2
        else
           itone(j)=0
        endif
     enddo
  endif

999 return
end subroutine gen65

  INTEGER FFTW_R2HC
  PARAMETER (FFTW_R2HC=0)
  INTEGER FFTW_HC2R
  PARAMETER (FFTW_HC2R=1)
  INTEGER FFTW_DHT
  PARAMETER (FFTW_DHT=2)
  INTEGER FFTW_REDFT00
  PARAMETER (FFTW_REDFT00=3)
  INTEGER FFTW_REDFT01
  PARAMETER (FFTW_REDFT01=4)
  INTEGER FFTW_REDFT10
  PARAMETER (FFTW_REDFT10=5)
  INTEGER FFTW_REDFT11
  PARAMETER (FFTW_REDFT11=6)
  INTEGER FFTW_RODFT00
  PARAMETER (FFTW_RODFT00=7)
  INTEGER FFTW_RODFT01
  PARAMETER (FFTW_RODFT01=8)
  INTEGER FFTW_RODFT10
  PARAMETER (FFTW_RODFT10=9)
  INTEGER FFTW_RODFT11
  PARAMETER (FFTW_RODFT11=10)
  INTEGER FFTW_FORWARD
  PARAMETER (FFTW_FORWARD=-1)
  INTEGER FFTW_BACKWARD
  PARAMETER (FFTW_BACKWARD=+1)
  INTEGER FFTW_MEASURE
  PARAMETER (FFTW_MEASURE=0)
  INTEGER FFTW_DESTROY_INPUT
  PARAMETER (FFTW_DESTROY_INPUT=1)
  INTEGER FFTW_UNALIGNED
  PARAMETER (FFTW_UNALIGNED=2)
  INTEGER FFTW_CONSERVE_MEMORY
  PARAMETER (FFTW_CONSERVE_MEMORY=4)
  INTEGER FFTW_EXHAUSTIVE
  PARAMETER (FFTW_EXHAUSTIVE=8)
  INTEGER FFTW_PRESERVE_INPUT
  PARAMETER (FFTW_PRESERVE_INPUT=16)
  INTEGER FFTW_PATIENT
  PARAMETER (FFTW_PATIENT=32)
  INTEGER FFTW_ESTIMATE
  PARAMETER (FFTW_ESTIMATE=64)
  INTEGER FFTW_ESTIMATE_PATIENT
  PARAMETER (FFTW_ESTIMATE_PATIENT=128)
  INTEGER FFTW_BELIEVE_PCOST
  PARAMETER (FFTW_BELIEVE_PCOST=256)
  INTEGER FFTW_DFT_R2HC_ICKY
  PARAMETER (FFTW_DFT_R2HC_ICKY=512)
  INTEGER FFTW_NONTHREADED_ICKY
  PARAMETER (FFTW_NONTHREADED_ICKY=1024)
  INTEGER FFTW_NO_BUFFERING
  PARAMETER (FFTW_NO_BUFFERING=2048)
  INTEGER FFTW_NO_INDIRECT_OP
  PARAMETER (FFTW_NO_INDIRECT_OP=4096)
  INTEGER FFTW_ALLOW_LARGE_GENERIC
  PARAMETER (FFTW_ALLOW_LARGE_GENERIC=8192)
  INTEGER FFTW_NO_RANK_SPLITS
  PARAMETER (FFTW_NO_RANK_SPLITS=16384)
  INTEGER FFTW_NO_VRANK_SPLITS
  PARAMETER (FFTW_NO_VRANK_SPLITS=32768)
  INTEGER FFTW_NO_VRECURSE
  PARAMETER (FFTW_NO_VRECURSE=65536)
  INTEGER FFTW_NO_SIMD
  PARAMETER (FFTW_NO_SIMD=131072)

! last time modified by Igor UA3DJY on 20200104

module jt9s_decode

  type :: jt9s_decoder
     procedure(jt9s_decode_callback), pointer :: callback
   contains
     procedure :: decode
  end type jt9s_decoder

  abstract interface
     subroutine jt9s_decode_callback (this, utc, snr, dt, freq, decoded, servis9)
       import jt9s_decoder
       implicit none
       class(jt9s_decoder), intent(inout) :: this
       integer, intent(in) :: utc
       integer, intent(in) :: snr
       real, intent(in) :: dt
       real, intent(in) :: freq
       character(len=26), intent(in) :: decoded
       character(len=1), intent(in) ::  servis9
     end subroutine jt9s_decode_callback
  end interface

contains

  subroutine decode(this,callback,nutc,nfqso,newdatin,npts8,nfa,nfb,nzhsym,filter,swl,  &
       nagain,nagainfil,ndepth,hint,stophint,nlasttx,mycall12,hiscall12,hisgrid6)
    use timer_module, only: timer
!npts8 = 74736
    include 'constants.f90'
    class(jt9s_decoder), intent(inout) :: this
    procedure(jt9s_decode_callback) :: callback
    integer, parameter :: MAXCANDRXF=5, MAXCAND=700
    character(len=12), intent(in) :: mycall12, hiscall12
    character(len=6), intent(in) :: hisgrid6
    integer, intent(in) :: nlasttx
    integer i4Decoded6BitWords(12),i4GrayCodedSym(69),mrs(69),mrs2(69)
    real s3(0:7,69)
    real t1,t2,trxf
    logical, intent(in) :: newdatin,nagain
    logical(1), intent(in) :: nagainfil,hint,stophint,filter,swl
    logical newdat,done(NSMAX)
    integer*1 i1SoftSymbols(207)
    character msg26*26,msg*22,servis9*1,mycall*6,hiscall*6,hisgrid*4,chint*1,hiscallrxf*6
    logical(1) freemsg,dupe,rxfreq,hintdec,dofano,tryhint
    type accepted_decode
       integer i
       character*22 decoded
    end type accepted_decode
    type(accepted_decode) dec(200)
    type rxfreq_decode
       real freq
       real xdt
       character*22 msg
    end type rxfreq_decode
    type(rxfreq_decode) rxfdec(1)
    type candrxf
       real ccfred
       integer i
    end type candrxf
    type(candrxf) carxf(MAXCANDRXF)
    type candidate
       real ccfred
       integer i
    end type candidate
    type(candidate) ca(MAXCAND)
    save rxfdec

    this%callback => callback
    ndecoded=0; chint=' '; nsps=6912
    df3=1500.0/2048.0 ! 0.732421875 Hz
    irxf=nint(nfqso/df3)+1
    dec%i=-1; dec%decoded=''
    newdat=newdatin
    mycall=mycall12(1:6); hiscall=hiscall12(1:6); hisgrid=hisgrid6(1:4); hiscallrxf=''
    dupe=.false.; rxfreq=.false.; tryhint=.false.
    ntxmode=9 ! being used for compatibility with JT65+JT9 mode decode9 subroutine

    nsps8=nsps/8
    dblim=db(864.0/nsps8) - 26.2
    nf1=nfa
    ia=max(1,nint(nf1/df3))
    ib=min(NSMAX,nint(nfb/df3))

    if(nagain .or. nagainfil) newdat=.true.

!    if(nagain .or. nagainfil) then; th_wide=th_agn; th_rxf=th_agn; newdat=.false.; endif
!    if((nagain .or. nagainfil) .and. agcc.neqv.agcclast) newdat=.true.
    call cpu_time(t1)
  do ipass=1,2
    done=.false.

!    if(newdat) then
!       call timer('sync9   ',0)
       call sync9s(ca,carxf,nzhsym,ia,ib,irxf,ndepth,nagain,nagainfil,ipass,filter)
!       call timer('sync9   ',1)
!    endif

    if(.not.nagainfil) then ! RX frequency candidate list decoding
       limit=200000
       if(nagain) limit=3000000
!print *,'nagain',nagain
       do icand=1,maxcandrxf
!print *,'rxf', ca(icand)%i
!print *,(df3*(carxf(icand)%i-1))
!print *,icand
          if(nagain) then
             call cpu_time(trxf)
             if(.not.swl) then
                if((trxf-t1).gt.10.0) exit
             else
                if((trxf-t1).gt.30.0) exit
             endif
          endif
          if(carxf(icand)%i.le.0) cycle
          if(done(carxf(icand)%i)) cycle
          if(.not.swl .and. nagain .and. icand.ge.2) limit=300000
          fpk=df3*(carxf(icand)%i-1)
!print *,icand,fpk
          tryhint=.false.
!          call timer('softsym9s ',0)
          call softsym9s(npts8,nsps8,newdat,fpk,syncpk,snrdb,xdt,    &
               freq,drift,a3,schk,i1SoftSymbols,mrs,mrs2,s3,tryhint,xdtrxf)
!          call timer('softsym9s ',1)
          sync=(syncpk+1)/4.0
          dofano=.true.
          if(sync.lt.0.5 .or. schk.lt.1.) dofano=.false.
          rxfreq=.false.
          if(abs(freq-real(nfqso)).lt.2.0 .and. xdt.gt.-0.5 .and. xdt.lt.1.5) rxfreq=.true.
          freemsg=.false.; servis9=' '
!if(rxfreq) print *,fpk,freq,xdt
          call decode9(i1SoftSymbols,limit,msg,freemsg,i4Decoded6BitWords,mrs,mrs2,hint, &
               stophint,nlasttx,mycall,hiscall,hisgrid,rxfreq,s3,i4GrayCodedSym,hintdec, &
               chint,dofano,snrdb,ntxmode,tryhint)
          if(abs(fpk-real(nfqso)).lt.3.0 .and. freemsg) servis9=','
          if(abs(fpk-real(nfqso)).ge.3.0 .and. freemsg) servis9='.'
          if(hintdec) servis9=chint

          if(sync.lt.0.0 .or. snrdb.lt.dblim-2.0) sync=0.0
          nsync=int(sync)
          if(nsync.gt.10) nsync=10
          nsnr=nint(snrdb)
          ndrift=nint(drift/df3)

          if(msg.ne.'                      ') then
             dupe=.false.
             if(ndecoded.ne.0) then
                if(.not.hintdec) then
                   do k=1,200
                      if(dec(k)%i.eq.-1) exit
                      if(dec(k)%decoded.eq.msg .and. abs(dec(k)%i-carxf(icand)%i).lt.24) dupe=.true.
                   enddo
                else
                   do k=1,200
                      if(dec(k)%i.eq.-1) exit
                      if(dec(k)%decoded(1:10).eq.msg(1:10) .and. abs(dec(k)%i-irxf).lt.104) dupe=.true. !45Hz
                   enddo
                endif
             endif

             if(dupe) cycle
!print *,carxf(icand)%ccfred
             if(associated(this%callback)) then
                msg26=msg//'    '
                call this%callback(nutc,nsnr,xdt,freq,msg26,servis9)
             endif
             if(.not.hintdec) then
                iaa=max(1,carxf(icand)%i-15)
                ibb=min(NSMAX,carxf(icand)%i+23)
             else
                iaa=max(1,irxf-1)
                ibb=min(NSMAX,irxf+1)
             endif
             ndecoded=ndecoded+1
             done(iaa:ibb)=.true.
             dec(ndecoded)%i=carxf(icand)%i
             dec(ndecoded)%decoded=msg
             if(.not.freemsg .and. abs(freq-real(nfqso)).lt.2.0 .and. msg(1:4).eq.mycall(1:4)) then
                rxfdec(1)%msg=msg
                rxfdec(1)%xdt=xdt
                rxfdec(1)%freq=freq
             endif
             if(ipass.ne.2) call subtract9s(i4Decoded6BitWords,freq,drift,xdt,i4GrayCodedSym,hintdec)
             exit ! RX freq decoding done, no need to try more candidates
          endif
       enddo
    endif


    if(hint) then ! try to decode exact RX frequency with Hint
       fpk=real(nfqso)
       tryhint=.false.
       if(ipass.eq.2) then
          if(abs(real(nfqso)-rxfdec(1)%freq).lt.2.0 .and. len_trim(hiscall).gt.2) then
             i1=index(rxfdec(1)%msg,' ')
             i2=index(rxfdec(1)%msg((i1+1):),' ')
             if(i1.lt.8 .and. i2.lt.15) hiscallrxf=rxfdec(1)%msg((i1+1):(i1+i2-1))
             if(hiscall.eq.hiscallrxf .and. len_trim(hiscallrxf).ne.0) then
                fpk=rxfdec(1)%freq
                xdtrxf=rxfdec(1)%xdt
                if(xdtrxf.gt.-2.5 .and. xdtrxf.lt.5.0) tryhint=.true.
             endif
          endif
       endif
!       call timer('softsym9s ',0)
       call softsym9s(npts8,nsps8,newdat,fpk,syncpk,snrdb,xdt,    &
            freq,drift,a3,schk,i1SoftSymbols,mrs,mrs2,s3,tryhint,xdtrxf)
!       call timer('softsym9s ',1)

       sync=(syncpk+1)/4.0
       dofano=.false. 
       rxfreq=.false.
       if(abs(freq-real(nfqso)).lt.2.0 .and. xdt.gt.-0.5 .and. xdt.lt.1.5) rxfreq=.true.
       freemsg=.false.; servis9=' '

!if(rxfreq) print *,fpk,freq,xdt
       call decode9(i1SoftSymbols,limit,msg,freemsg,i4Decoded6BitWords,mrs,mrs2,hint, &
            stophint,nlasttx,mycall,hiscall,hisgrid,rxfreq,s3,i4GrayCodedSym,hintdec, &
            chint,dofano,snrdb,ntxmode,tryhint)

       if(hintdec) servis9=chint
       if(sync.lt.0.0 .or. snrdb.lt.dblim-2.0) sync=0.0
       nsync=int(sync)
       if(nsync.gt.10) nsync=10
       nsnr=nint(snrdb)
       ndrift=nint(drift/df3)

       if(msg.ne.'                      ') then
          dupe=.false.
          if(ndecoded.ne.0) then
             do k=1,200
                if(dec(k)%i.eq.-1) exit
                if(dec(k)%decoded(1:10).eq.msg(1:10) .and. abs(dec(k)%i-irxf).lt.104) dupe=.true. !45Hz
             enddo
          endif
          if(dupe) cycle
          if(associated(this%callback)) then
             msg26=msg//'    '
             call this%callback(nutc,nsnr,xdt,freq,msg26,servis9)
          endif
         iaa=max(1,irxf-1)
         ibb=min(NSMAX,irxf+1)
         ndecoded=ndecoded+1
         done(iaa:ibb)=.true.
         dec(ndecoded)%i=irxf
         dec(ndecoded)%decoded=msg
         if(.not.freemsg .and. abs(freq-real(nfqso)).lt.2.0 .and. msg(1:4).eq.mycall(1:4)) then
            rxfdec(1)%msg=msg
            rxfdec(1)%xdt=xdt
            rxfdec(1)%freq=freq
         endif
         if(ipass.ne.2) call subtract9s(i4Decoded6BitWords,freq,drift,xdt,i4GrayCodedSym,hintdec)
      endif
    endif


    if(.not.nagain) then ! wideband candidate list decoding
       limit=5000
       if(ndepth.eq.2) limit=10000
       if(ndepth.ge.3) limit=30000
       if(nagainfil) limit=300000
       if(swl) limit=limit*2

       do icand=1,maxcand
          call cpu_time(t2)
          if(.not.swl) then
             if(ipass.eq.1 .and. (t2-t1).gt.5.0) exit
             if(ipass.eq.2 .and. (t2-t1).gt.10.0) exit
          else
             if(ipass.eq.1 .and. (t2-t1).gt.9.0) exit
             if(ipass.eq.2 .and. (t2-t1).gt.30.0) exit
          endif
          if(nagainfil .and. icand.gt.5) exit
!print *,'W', ca(icand)%i
          if(ca(icand)%i.le.0) cycle
          if(done(ca(icand)%i)) cycle
          fpk=df3*(ca(icand)%i-1)

          tryhint=.false.
!          call timer('softsym9s ',0)
          call softsym9s(npts8,nsps8,newdat,fpk,syncpk,snrdb,xdt,    &
               freq,drift,a3,schk,i1SoftSymbols,mrs,mrs2,s3,tryhint,xdtrxf)
!          call timer('softsym9s ',1)
          sync=(syncpk+1)/4.0
          dofano=.true.
          if(sync.lt.1.0 .or. schk.lt.1.5) cycle
          rxfreq=.false.
          if(abs(freq-real(nfqso)).lt.2.0 .and. xdt.gt.-0.5 .and. xdt.lt.1.5) rxfreq=.true.
          freemsg=.false.; servis9=' '

!if(rxfreq) print *,fpk,freq,xdt
          call decode9(i1SoftSymbols,limit,msg,freemsg,i4Decoded6BitWords,mrs,mrs2,hint, &
               stophint,nlasttx,mycall,hiscall,hisgrid,rxfreq,s3,i4GrayCodedSym,hintdec, &
               chint,dofano,snrdb,ntxmode,tryhint)

          if(abs(fpk-real(nfqso)).lt.3.0 .and. freemsg) servis9=','
          if(abs(fpk-real(nfqso)).ge.3.0 .and. freemsg) servis9='.'
          if(sync.lt.0.0 .or. snrdb.lt.dblim-2.0) sync=0.0
          nsync=int(sync)
          if(nsync.gt.10) nsync=10
          nsnr=nint(snrdb)
          ndrift=nint(drift/df3)

          if(msg.ne.'                      ') then
             dupe=.false.
             if(ndecoded.ne.0) then
                do k=1,200
                   if(dec(k)%i.eq.-1) exit
                   if(dec(k)%decoded.eq.msg .and. abs(dec(k)%i-ca(icand)%i).lt.24) dupe=.true.
                enddo
             endif
!print *,ipass,fpk
!print *,msg
!endif
             if(dupe) cycle
!print *,ipass,(t2-t1)
             if(associated(this%callback)) then
                msg26=msg//'    '
                call this%callback(nutc,nsnr,xdt,freq,msg26,servis9)
             endif
             iaa=max(1,ca(icand)%i-15)
             ibb=min(NSMAX,ca(icand)%i+23)
             ndecoded=ndecoded+1
             done(iaa:ibb)=.true.
             dec(ndecoded)%i=ca(icand)%i
             dec(ndecoded)%decoded=msg
             if(.not.freemsg .and. abs(freq-real(nfqso)).lt.2.0 .and. msg(1:4).eq.mycall(1:4)) then
                rxfdec(1)%msg=msg
                rxfdec(1)%xdt=xdt
                rxfdec(1)%freq=freq
             endif
             if(ipass.ne.2) call subtract9s(i4Decoded6BitWords,freq,drift,xdt,i4GrayCodedSym,hintdec)
          endif
       enddo
    endif
    if(ipass.eq.1) newdat=.true.
  enddo
    return
  end subroutine decode
end module jt9s_decode

subroutine partintft8(ndelay,nutc)

  use ft8_mod1, only : dd8
  real rnd

  if(ndelay.gt.120) ndelay=120
  numsamp=nint(float(ndelay)*1200)
  dd8(numsamp+1:180000)=dd8(1:(180000-numsamp))
  do i=1,numsamp
     call random_number(rnd)
     dd8(i)=10.0*rnd-5.
  enddo
  write(*,2) nutc,'partial loss of data','d'
2 format(i6.6,2x,a20,21x,a1)
  call flush(6)

  return
end subroutine partintft8

program testfast9

  parameter (NMAX=359424)
  integer*2 id2(NMAX)
  integer narg(0:11)
  character*80 line(100)
  character submode*1,infile*80
  
  nargs=iargc()
  if(nargs.ne.2) then
     print*,'Usage:    testfast9 submode infile'
     print*,'Example: testfast9 E /data/VE1SKY/K1JT/JT9E/150806_123300.wav'
     go to 999
  endif
  call getarg(1,submode)
  call getarg(2,infile)

  open(10,file=infile,access='stream',status='old')
  read(10) id2(1:22)                     !Skip 44 header bytes
  npts=NMAX
  read(10,end=1) id2(1:npts)                   !Read the raw data

1 i1=index(infile,'.wav')
  read(infile(i1-6:i1-1),*) narg(0)
  narg(1)=NMAX
  n=ichar(submode)
  narg(2)=n-ichar('A')
  if(n.ge.97 .and. n.le.104) narg(2)=n-ichar('a')
  narg(3)=1
  narg(4)=0
  narg(5)=0
  narg(6)=0
  narg(7)=29951
  narg(8)=1
  narg(9)=102
  narg(10)=700
  narg(11)=500

  call fast9(id2,narg,line)
  print*,line(1)

999 end program testfast9

subroutine hash(string,len,ihash)
  use iso_c_binding, only: c_loc,c_size_t
  use hashing
  parameter (MASK15=32767)
!  character*(*), target :: string
  character*1, target :: string
     i=nhash(c_loc(string),int(len,c_size_t),146)
     ihash=iand(i,MASK15)
  return
end subroutine hash

subroutine cwfilter(swl,first,swlchanged)

  use ft8_mod1, only : cw,windowc1,windowx,pivalue,facx,mcq,m73,mrr73,mrrr,one,twopi,facc1,dt,csync,idtone25,csynccq, &
                       NFILT1,NFILT2,endcorr,endcorrswl,ctwkw,ctwkn,ctwk256
  use jt65_mod9 ! callsign DB to memory
  use prog_args ! path to files

  parameter (NFFT=180000)
  complex csig0(151680)
  real*4 window1(-NFILT1/2:NFILT1/2),window2(-NFILT2/2:NFILT2/2)
  character*37 msgcq25(25),msgsent37
  integer itone(79)
  integer*1 msgbits(77)
  logical(1), intent(in) :: swl
  logical, intent(in) :: first,swlchanged

!pushing callsigns from ALLCALL to memory
  if(first) then
    open(24,file=trim(share_dir)//'/ALLCALL7.TXT',status='unknown') ! accepting Australian 7-char callsigns
    do i=1,MAXC
      read(24,1004,end=20) line
1004  format(a80)
      if(line(1:4).eq.'ZZZZ') exit
      if(line(1:2).eq.'//') cycle
      i1=index(line,',')
      if(i1.lt.4 .or. i1.gt.8) cycle
      callsign=line(1:i1-1)
      if(callsign(1:1).gt.'0' .and. callsign(1:1).lt.'D') then; ncall0c=ncall0c+1; call0c(ncall0c)=callsign(1:7)
      else if(callsign(1:1).gt.'C' .and. callsign(1:1).lt.'E') then; ncalld=ncalld+1; calld(ncalld)=callsign(1:7)
      else if(callsign(1:1).gt.'D' .and. callsign(1:1).lt.'G') then; ncallef=ncallef+1; callef(ncallef)=callsign(1:7)
      else if(callsign(1:1).gt.'F' .and. callsign(1:1).lt.'I') then; ncallgh=ncallgh+1; callgh(ncallgh)=callsign(1:7)
      else if(callsign(1:1).gt.'H' .and. callsign(1:1).lt.'J') then; ncalli=ncalli+1; calli(ncalli)=callsign(1:7)
      else if(callsign(1:1).gt.'I' .and. callsign(1:1).lt.'K') then; ncallj=ncallj+1; callj(ncallj)=callsign(1:7)
      else if(callsign(1:1).gt.'J' .and. callsign(1:1).lt.'L') then; ncallk=ncallk+1; callk(ncallk)=callsign(1:7)
      else if(callsign(1:1).gt.'K' .and. callsign(1:1).lt.'N') then; ncalllm=ncalllm+1; calllm(ncalllm)=callsign(1:7)
      else if(callsign(1:1).gt.'M' .and. callsign(1:1).lt.'O') then; ncalln=ncalln+1; calln(ncalln)=callsign(1:7)
      else if(callsign(1:1).gt.'N' .and. callsign(1:1).lt.'P') then; ncallo=ncallo+1; callo(ncallo)=callsign(1:7)
      else if(callsign(1:1).gt.'O' .and. callsign(1:1).lt.'R') then; ncallpq=ncallpq+1; callpq(ncallpq)=callsign(1:7)
      else if(callsign(1:1).gt.'Q' .and. callsign(1:1).lt.'S') then; ncallr=ncallr+1; callr(ncallr)=callsign(1:7)
      else if(callsign(1:1).gt.'R' .and. callsign(1:1).lt.'U') then; ncallst=ncallst+1; callst(ncallst)=callsign(1:7)
      else if(callsign(1:1).gt.'T' .and. callsign(1:1).lt.'W') then; ncalluv=ncalluv+1; calluv(ncalluv)=callsign(1:7)
      else if(callsign(1:1).gt.'V' .and. callsign(1:1).lt.'X') then; ncallw=ncallw+1; callw(ncallw)=callsign(1:7)
      else if(callsign(1:1).gt.'W' .and. callsign(1:1).le.'Z') then; ncallxz=ncallxz+1; callxz(ncallxz)=callsign(1:7)
      endif
    enddo
20  close(24)
!print *,ncall0c,"call0c"; print *,ncalld,"calld"; print *,ncallef,"callef"; print *,ncallgh,"callgh"
!print *,ncalli,"calli"; print *,ncallj,"callj"; print *,ncallk,"callk"; print *,ncalllm,"calllm"
!print *,ncalln,"calln"; print *,ncallo,"callo"; print *,ncallpq,"callpq"; print *,ncallr,"callr"
!print *,ncallst,"callst"; print *,ncalluv,"calluv"; print *,ncallw,"callw"; print *,ncallxz,"callxz"
    if(ncall0c.lt.1 .or. ncalld.lt.1 .or. ncallef.lt.1 .or. ncallgh.lt.1 .or. ncalli.lt.1 .or. ncallj.lt.1 .or. &
       ncallk.lt.1 .or. ncalllm.lt.1 .or. ncalln.lt.1 .or. ncallo.lt.1 .or. ncallpq.lt.1 .or. ncallr.lt.1 .or.  &
       ncallst.lt.1 .or. ncalluv.lt.1 .or. ncallw.lt.1 .or. ncallxz.lt.1) then
      ldbvalid=.false.
      write(*,4) 'ALLCALL7.TXT is too short or broken?','d' ! 50th position for "d"
4     format(a36,13x,a1)
      call flush(6)
    endif

    pivalue=4.d0*atan(1.d0)
    twopi=8.d0*atan(1.d0)
    dt=1.d0/12000.d0

    do i=0,54; windowc1(i)=(1.0+cos(i*pivalue/55))/2; enddo
    facx=1.0/300.0
    do i=0,200
      windowx(i)=(1.0+cos(i*pivalue/200))/2
    enddo
    windowx=facx*windowx
    facc1=0.01/sqrt(61440.) ! 1.0/sqrt(192000.*3200.) NFFT1*NFFT2

    mcq=2*mcq-1
    mrrr=2*mrrr-1
    m73=2*m73-1
    mrr73=2*mrr73-1

    one=.false.
    do i=0,511
      do j=0,8
        if(iand(i,2**j).ne.0) one(i,j)=.true.
      enddo
    enddo

    msgcq25=''
    msgcq25(2)='CQ 2E0DLA IO92'
    msgcq25(3)='CQ BH3NEB ON81'
    msgcq25(4)='CQ CG3CGT FN04'
    msgcq25(5)='CQ DX CT1JA IM59'
    msgcq25(6)='CQ CU20E'
    msgcq25(7)='CQ NA CX1OB GF14'
    msgcq25(8)='CQ DF2AJ JN49'
    msgcq25(9)='CQ DG4XPZ JN58'
    msgcq25(10)='CQ EA8XR IL19'
    msgcq25(11)='CQ F1YE IN94'
    msgcq25(12)='CQ DX G1KLN IO82'
    msgcq25(13)='CQ HL2KVF PM38'
    msgcq25(14)='CQ IU1ZSV JN45'
    msgcq25(15)='CQ JG1TWO PM96'
    msgcq25(16)='CQ K2ST EM96'
    msgcq25(17)='CQ N9TUX EL98'
    msgcq25(18)='CQ SA NO2FA FM18'
    msgcq25(19)='CQ OH6GKE KP13'
    msgcq25(20)='CQ PD0ORM JO24'
    msgcq25(21)='CQ DX PT7DS HI06'
    msgcq25(22)='CQ RA3XEP KO84'
    msgcq25(23)='CQ SM2GSH KP05'
    msgcq25(24)='CQ UA9OHX NO15'
    msgcq25(25)='CQ JA W0YH EN12'
    do i=2,25
      i3=-1; n3=-1
      call genft8sd(msgcq25(i),i3,n3,msgsent37,msgbits,itone)
      if(i.eq.2) then
        call gen_ft8wave(itone,79,1920,2.0,12000.0,0.0,csig0,xjunk,1,151680)
        m=1
        do j=0,14
          do k=1,32
            if(j.lt.7) then; csync(j,k)=csig0(m); else; csynccq(j-7,k)=csig0(m); endif
            m=m+60
          enddo
        enddo
      endif
      idtone25(i,1:29)=itone(8:36)
      idtone25(i,30:58)=itone(44:72)
    enddo
    dt2=0.005 ! fs2=200 Hz
    k=1
    do ifr=-5,5                              !Search over +/- 2.5 Hz
      delf=ifr*0.5
      dphi=twopi*delf*dt2
      phi=0.0
      do i=1,32
        ctwkw(k,i)=cmplx(cos(phi),sin(phi))
        phi=mod(phi+dphi,twopi)
      enddo
      k=k+1
    enddo
    k=1
    do ifr=-5,5                              !Search over +/- 1.25 Hz
      delf=ifr*0.25
      dphi=twopi*delf*dt2
      phi=0.0
      do i=1,32
        ctwkn(k,i)=cmplx(cos(phi),sin(phi))
        phi=mod(phi+dphi,twopi)
      enddo
      k=k+1
    enddo
! lcqsignal
    delf=3.125
    dphi=twopi*delf*dt2
    phi=0.0
    do i=1,256
      ctwk256(i)=cmplx(cos(phi),sin(phi))
      phi=mod(phi+dphi,twopi)
    enddo
  endif

! this filter is being used for signal subtraction
! Create and normalize the filter
  if(first .or. swlchanged) then
     fac=1.0/float(nfft)
     sumw=0.0
     if(.not.swl) then
        do j=-NFILT1/2,NFILT1/2
           window1(j)=cos(pivalue*j/NFILT1)**2
           sumw=sumw+window1(j)
        enddo
        cw=0.
        cw(1:NFILT1+1)=window1/sumw
        cw=cshift(cw,NFILT1/2+1)
        do j=1,NFILT1/2+1
          endcorr(j)=1.0/(1.0-sum(window1(j-1:NFILT1/2))/sumw)
        enddo
     else
        do j=-NFILT2/2,NFILT2/2
           window2(j)=cos(pivalue*j/NFILT2)
           sumw=sumw+window2(j)
        enddo
        cw=0.
        cw(1:NFILT2+1)=window2/sumw
        cw=cshift(cw,NFILT2/2+1)
        do j=1,NFILT2/2+1
          endcorrswl(j)=1.0/(1.0-sum(window2(j-1:NFILT2/2))/sumw)
        enddo
     endif
     call four2a(cw,NFFT,1,-1,1)
     cw=cw*fac
  endif

  return  
end subroutine cwfilter
  

program t1

  parameter (NSPM=1404)
  complex csig(0:NSPM-1)
  complex c(0:NSPM-1)
  complex cnoise(0:NSPM-1)
  complex cd(0:11,0:3)
  complex z,zmax
  integer itone(234)
  real r(234)
  real ss(0:3)
  character*12 arg

  nargs=iargc()
  if(nargs.ne.3) then
     print*,'Usage: t1 nsymtest snrdb iters'
     go to 999
  endif
  call getarg(1,arg)
  read(arg,*) nsymtest
  call getarg(2,arg)
  read(arg,*) snrdb
  call getarg(3,arg)
  read(arg,*) iters

  call init_random_seed()       ! seed Fortran RANDOM_NUMBER generator
  call sgran()                  ! see C rand generator (used in gran)

  call random_number(r)
  itone=0
  where(r.gt.0.5) itone=1

  twopi=8.0*atan(1.0)
  fmid=1500.0
  f0=fmid-500.
  f1=fmid+500.
  dt=1.0/12000.0

  phi=0.
  do n=0,3
     k=-1
     dphi=twopi*f0*dt
     if(n.ge.2) dphi=twopi*f1*dt
     do i=0,5
        k=k+1
        phi=phi+dphi
        if(phi.gt.twopi) phi=phi-twopi
        cd(k,n)=cmplx(cos(phi),sin(phi))
     enddo

     dphi=twopi*f0*dt
     if(mod(n,2).eq.1) dphi=twopi*f1*dt
     do i=6,11
        k=k+1
        phi=phi+dphi
        if(phi.gt.twopi) phi=phi-twopi
        cd(k,n)=cmplx(cos(phi),sin(phi))
     enddo
  enddo

!  do k=0,11
!     write(13,1000) k,cd(k,0:3)
!1000 format(i4,8f9.3)
!enddo

! Generate signal waveform
  k=-1
  phi=0.
  do j=1,234
     dphi=twopi*f0*dt
     if(itone(j).eq.1) dphi=twopi*f1*dt
     do i=1,6
        k=k+1
        phi=phi+dphi
        if(phi.gt.twopi) phi=phi-twopi
        csig(k)=cmplx(cos(phi),sin(phi))
!        write(14,1000) k,csig(k)
     enddo
  enddo

     write(*,1010) 
1010 format('  S/N  (S+N)/N    BER'/'----------------------')

  isnra=10
  isnrb=-3
  nsyms=234
  do isnr=isnra,isnrb,-1
     snr=10.0**(0.1*isnr)
     if(snrdb.ne.0.0) snr=10.0**(0.1*snrdb)
     fac=1.0/sqrt(snr)
     nsumerr=0
     do iter=1,iters
        do i=0,NSPM-1
           x=gran()
           y=gran()
           cnoise(i)=cmplx(x,y)
        enddo

        c=csig + fac*cnoise
        nerr=0
        n1=2
        nstep=2
        iz=5
        if(nsymtest.eq.2) then
           n1=3
           nstep=1
           iz=11
        endif

        do j=1,nsyms
           smax=0.
           do n=0,n1,nstep
              s=0.
              k=6*(j-1)
              do i=0,iz
                 s=s + aimag(c(k+i))*aimag(cd(i,n))
              enddo
              ss(n)=s
              if(abs(s).gt.abs(smax)) then
                 smax=s
                 npk=n
              endif
           enddo
           sym=max(abs(ss(2)),abs(ss(3))) - max(abs(ss(0)),abs(ss(1)))
!           ibit=npk/2
           ibit=0
           if(sym.ge.0.0) ibit=1
           if(ibit.ne.itone(j)) nerr=nerr+1
        enddo
        nsumerr=nsumerr+nerr
     enddo

     write(*,1020) 10.0*log10(snr),10.0*log10(snr+1.0),            &
          float(nsumerr)/(nsyms*iters)
1020 format(f5.1,f7.1,f9.3)
     if(snrdb.ne.0.0) exit
  enddo

999 end program t1

subroutine smo(x,npts,y,nadd)

  real x(npts)
  real y(npts)

  nh=nadd/2
  do i=1+nh,npts-nh
     sum1=0.
     do j=-nh,nh
        sum1=sum1 + x(i+j)
     enddo
     y(i)=sum1
  enddo
  x=y
  x(:nh)=0.
  x(npts-nh+1:)=0.

  return
end subroutine smo

subroutine fil4(id1,n1,id2,n2,dd2)

  parameter (NTAPS=15)
  parameter (NDOWN=4)             !Downsample ratio
  integer*2 id1(n1)
  integer*2 id2(*)
  real dd2(*)
  real t(NTAPS)
  data t/NTAPS*0.0/
  real w(NTAPS)
! Filter coefficients:
! Kaiser-Bessel FIR LPF  http://www.arc.id.au/FilterDesign.html
! fsample     = 48000 Hz
! Ntaps       = 15
! fc          = 6000  Hz
! df/2        = 2626  Hz
! Stop Atten  = 30    dB
! fout        = 12000 Hz

  data w/-0.012989, -0.028287, -0.029614, 0.000000, 0.065033,  0.149500,  0.221615, &
          0.250000,  0.221615,  0.149500, 0.065033, 0.000000, -0.029614, -0.028287, -0.012989 /
  save w,t

  n2=n1/NDOWN ! n1=13824 n2=3456
  if(n2*NDOWN.ne.n1) stop 'Error in fil4'
  k=1-NDOWN
  do i=1,n2
     k=k+NDOWN
     t(1:11)=t(5:15)     !Shift old data down t(1:NTAPS-NDOWN)=t(1+NDOWN:NTAPS)
     t(12:15)=id1(k:k+3) !Insert new data at end of t, t(1+NTAPS-NDOWN:NTAPS)=id1(k:k+NDOWN-1)
     dd2(i)=dot_product(w,t)
     id2(i)=nint(dd2(i))
  enddo

  return
end subroutine fil4

program ft4sim

! Generate simulated signals for experimental "FT4" mode 

  use wavhdr
  use packjt77
  include 'ft4_params.f90'               !Set various constants
  parameter (NWAVE=NN*NSPS)
  parameter (NZZ=21*3456)                !72576
  type(hdr) h                            !Header for .wav file
  character arg*12,fname*17
  character msg37*37,msgsent37*37
  character c77*77
  complex c0(0:NZZ-1)
  complex c(0:NZZ-1)
  real wave(NZZ)
  real dphi(0:NZZ-1)
  real pulse(3*NSPS)               
  integer itone(NN)
  integer*1 msgbits(77)
  integer*2 iwave(NZZ)                  !Generated full-length waveform
  integer icos4(4)
  data icos4/0,1,3,2/
  
! Get command-line argument(s)
  nargs=iargc()
  if(nargs.ne.7) then
     print*,'Usage:    ft4sim "message"                 f0     DT fdop del nfiles snr'
     print*,'Examples: ft4sim "CQ W9XYZ EN37"        1500 0.0  0.1 1.0   10   -15'
     print*,'          ft4sim "K1ABC W9XYZ R 539 WI" 1500 0.0  0.1 1.0   10   -15'
     go to 999
  endif
  call getarg(1,msg37)                   !Message to be transmitted
  call getarg(2,arg)
  read(arg,*) f0                         !Frequency (only used for single-signal)
  call getarg(3,arg)
  read(arg,*) xdt                        !Time offset from nominal (s)
  call getarg(4,arg)
  read(arg,*) fspread                    !Watterson frequency spread (Hz)
  call getarg(5,arg)
  read(arg,*) delay                      !Watterson delay (ms)
  call getarg(6,arg)
  read(arg,*) nfiles                     !Number of files
  call getarg(7,arg)
  read(arg,*) snrdb                      !SNR_2500

  nfiles=abs(nfiles)
  twopi=8.0*atan(1.0)
  fs=12000.0                             !Sample rate (Hz)
  dt=1.0/fs                              !Sample interval (s)
  hmod=1.0                               !Modulation index (0.5 is MSK, 1.0 is FSK)
  tt=NSPS*dt                             !Duration of symbols (s)
  baud=1.0/tt                            !Keying rate (baud)
  txt=NZ2*dt                             !Transmission length (s)

  bandwidth_ratio=2500.0/(fs/2.0)
  sig=sqrt(2*bandwidth_ratio) * 10.0**(0.05*snrdb)
  if(snrdb.gt.90.0) sig=1.0

  ! Source-encode, then get itone()
  i3=-1
  n3=-1
  call pack77(msg37,i3,n3,c77,1)
  read(c77,'(77i1)') msgbits
  call genft4(msg37,0,1,msgsent37,msgbits,itone)
  write(*,*)  
  write(*,'(a9,a37,3x,a7,i1,a1,i1)') 'Message: ',msgsent37,'i3.n3: ',i3,'.',n3
  write(*,1000) f0,xdt,txt,snrdb
1000 format('f0:',f9.3,'   DT:',f6.2,'   TxT:',f6.1,'   SNR:',f6.1)
  write(*,*)  
  if(i3.eq.1) then
    write(*,*) '         mycall                         hiscall                    hisgrid'
    write(*,'(28i1,1x,i1,1x,28i1,1x,i1,1x,i1,1x,15i1,1x,3i1)') msgbits(1:77) 
  else
    write(*,'(a14)') 'Message bits: '
    write(*,'(77i1)') msgbits
  endif
  write(*,*) 
  write(*,'(a17)') 'Channel symbols: '
  write(*,'(76i1)') itone
  write(*,*)  

  call sgran()

! The filtered frequency pulse 
  do i=1,3*NSPS
     tt=(i-1.5*NSPS)/real(NSPS)
     pulse(i)=gfsk_pulse(1.0,tt)
  enddo

! Define the instantaneous frequency waveform
  dphi_peak=twopi*hmod/real(NSPS)
  dphi=0.0 
  do j=1,NN         
     ib=(j-1)*NSPS
     ie=ib+3*NSPS-1
     dphi(ib:ie)=dphi(ib:ie)+dphi_peak*pulse*itone(j)
  enddo

  phi=0.0
  c0=0.0
  dphi=dphi+twopi*f0*dt
!  do j=0,NMAX-1                          !### ??? ###
  do j=0,(NN+2)*NSPS-1
     c0(j)=cmplx(cos(phi),sin(phi))
     phi=mod(phi+dphi(j),twopi)
  enddo 
 
  c0(0:NSPS-1)=c0(0:NSPS-1)*(1.0-cos(twopi*(/(i,i=0,NSPS-1)/)/(2.0*NSPS)) )/2.0
  c0((NN+1)*NSPS:(NN+2)*NSPS-1)=c0((NN+1)*NSPS:(NN+2)*NSPS-1)*(1.0+cos(twopi*(/(i,i=0,NSPS-1)/)/(2.0*NSPS) ))/2.0
  c0((NN+2)*NSPS:)=0.

  k=nint((xdt+0.5)/dt)-NSPS
  c0=cshift(c0,-k)
  if(k.gt.0) c0(0:k-1)=0.0
  if(k.lt.0) c0(NZZ+k:NZZ-1)=0.0

  do ifile=1,nfiles
     c=c0
     if(fspread.ne.0.0 .or. delay.ne.0.0) call watterson(c,NZZ,NWAVE,fs,delay,fspread)
     c=sig*c
     wave=real(c)
     peak=maxval(abs(wave))
     nslots=1
   
     if(snrdb.lt.90) then
        do i=1,NZZ                   !Add gaussian noise at specified SNR
           xnoise=gran()
           wave(i)=wave(i) + xnoise
        enddo
     endif

     gain=100.0
     if(snrdb.lt.90.0) then
       wave=gain*wave
     else
       datpk=maxval(abs(wave))
       fac=32766.9/datpk
       wave=fac*wave
     endif
     if(any(abs(wave).gt.32767.0)) print*,"Warning - data will be clipped."
     iwave=nint(wave)
     h=default_header(12000,NZZ)
     write(fname,1102) ifile
1102 format('000000_',i6.6,'.wav')
     open(10,file=fname,status='unknown',access='stream')
     write(10) h,iwave                !Save to *.wav file
     close(10)
     write(*,1110) ifile,xdt,f0,snrdb,fname
1110 format(i4,f7.2,f8.2,f7.1,2x,a17)
  enddo
  
999 end program ft4sim

subroutine getcandidates4(fa,fb,syncmin,nfqso,maxcand,candidate,ncand)

  use ft4_mod1, only : dd4
  include 'ft4_params.f90'
  real s(NH1,NHSYM)
  real savg(NH1),savsm(NH1)
  real sbase(NH1)
  real x(NFFT1)
  real window(256)
  complex cx(0:NH1)
  real candidate(2,maxcand),candidatet(2,maxcand)
  equivalence (x,cx)
  logical first
  data first/.true./
  save first,window

  if(first) then
    first=.false.
    pi=4.0*atan(1.)
    do i=1,256
      window(i)=SQRT((1.0+cos(i*pi/256))/2)
    enddo
  endif

! Compute symbol spectra, stepping by NSTEP steps.  
  savg=0.
  df=12000.0/NFFT1
  fac=1.0/300.0
  do j=1,NHSYM
     ia=(j-1)*NSTEP + 1
     ib=ia+2303 ! ib=ia+NFFT1-1
     if(ib.gt.NMAX) exit
     x(129:2432)=fac*dd4(ia:ib)!; x(129)=x(129)*1.9; x(2432)=x(2432)*1.9
     if(j.ne.1) then; x(1:128)=fac*dd4(ia-128:ia-1); else; x(1:128)=0.; endif
     if(j.ne.NHSYM) then; x(2433:NFFT1)=fac*dd4(ib+1:ib+128); else; x(2433:NFFT1)=0.; endif
     x(1:128)=x(1:128)*window(1:128); x(2433:NFFT1)=x(2433:NFFT1)*window(129:256)
     call four2a(cx,NFFT1,1,-1,0)              !r2c FFT
     s(1:NH1,j)=abs(cx(1:NH1))**2
     savg=savg + s(1:NH1,j)                   !Average spectrum
  enddo
  savg=savg/NHSYM

  savsm=0.
  do i=9,NH1-8; savsm(i)=sum(savg(i-8:i+8))/17.; enddo
  do i=1,8; k=i-1; savsm(i)=sum(savg(i-k:i+k))/(2*k+1); enddo
!  do i=NH1-7,NH1; k=NH1-i; savsm(i)=sum(savg(i-k:i+k))/(2*k+1); enddo

  nfa=max(1,nint(fa/df)); nfb=min(nint(4910.0/df),nint(fb/df))
  if(nfa.lt.43) then; nfaa=43; else; nfaa=nfa; endif
  call ft4_baseline(savg,nfa,nfb,sbase); if(any(sbase(nfaa:nfb).le.0)) return

  if(nfa.ge.43) then; savsm(nfa:nfb)=savsm(nfa:nfb)/sbase(nfa:nfb)
  else; savsm(1:42)=savsm(1:42)/sbase(43); savsm(43:nfb)=savsm(43:nfb)/sbase(43:nfb)
  endif
  f_offset = -1.5*12000.0/NSPS
  ncand=0; candidatet=0
  do i=nfa+1,nfb-1
     if(savsm(i).ge.savsm(i-1) .and. savsm(i).ge.savsm(i+1) .and.      &
          savsm(i).ge.syncmin) then
        den=savsm(i-1)-2*savsm(i)+savsm(i+1)
        del=0.
        if(den.ne.0.0)  del=0.5*(savsm(i-1)-savsm(i+1))/den
        fpeak=(i+del)*df+f_offset
!        if(fpeak.lt.200.0 .or. fpeak.gt.4910.0) cycle
        if(fpeak.gt.4910.0) cycle
        speak=savsm(i) - 0.25*(savsm(i-1)-savsm(i+1))*del
        ncand=ncand+1
        candidatet(1,ncand)=fpeak
        candidatet(2,ncand)=speak
        if(ncand.eq.maxcand) exit
     endif
  enddo
  candidate=0
  nq=count(abs(candidatet(1,1:ncand)-nfqso).le.20.0)
  n1=1; n2=nq+1 
  do i=1,ncand
     if(abs(candidatet(1,i)-nfqso).le.20.0) then
        candidate(1:2,n1)=candidatet(1:2,i)
        n1=n1+1
     else
        candidate(1:2,n2)=candidatet(1:2,i)
        n2=n2+1
     endif
  enddo 
return
end subroutine getcandidates4

program ft8sim_gfsk

! Generate simulated "type 2" ft8 files
! Output is saved to a *.wav file.

  use wavhdr
  use packjt77
  include 'ft8_params.f90'               !Set various constants
  parameter (NWAVE=NN*NSPS)
  type(hdr) h                            !Header for .wav file
  character arg*12,fname*17
  character msg37*37,msgsent37*37
  character c77*77
  complex c0(0:NMAX-1)
  complex c(0:NMAX-1)
  complex cwave(0:NWAVE-1)
  real wave(NMAX)
  real xjunk(NWAVE)
  integer itone(NN)
  integer*1 msgbits(77)
  integer*2 iwave(NMAX)                  !Generated full-length waveform

! Get command-line argument(s)
  nargs=iargc()
  if(nargs.ne.7) then
     print*,'Usage:    ft8sim "message"                 f0     DT fdop del nfiles snr'
     print*,'Examples: ft8sim "K1ABC W9XYZ EN37"       1500.0 0.0  0.1 1.0   10   -18'
     print*,'          ft8sim "WA9XYZ/R KA1ABC/R FN42" 1500.0 0.0  0.1 1.0   10   -18'
     print*,'          ft8sim "K1ABC RR73; W9XYZ <KH1/KH7Z> -11" 300 0 0 0 25 1 -10'
     go to 999
  endif
  call getarg(1,msg37)                   !Message to be transmitted
  call getarg(2,arg)
  read(arg,*) f0                         !Frequency (only used for single-signal)
  call getarg(3,arg)
  read(arg,*) xdt                        !Time offset from nominal (s)
  call getarg(4,arg)
  read(arg,*) fspread                    !Watterson frequency spread (Hz)
  call getarg(5,arg)
  read(arg,*) delay                      !Watterson delay (ms)
  call getarg(6,arg)
  read(arg,*) nfiles                     !Number of files
  call getarg(7,arg)
  read(arg,*) snrdb                      !SNR_2500

  nsig=1
  if(f0.lt.100.0) then
     nsig=f0
     f0=1500
  endif

  nfiles=abs(nfiles)
  twopi=8.0*atan(1.0)
  fs=12000.0                             !Sample rate (Hz)
  dt=1.0/fs                              !Sample interval (s)
  tt=NSPS*dt                             !Duration of symbols (s)
  baud=1.0/tt                            !Keying rate (baud)
  bw=8*baud                              !Occupied bandwidth (Hz)
  txt=NZ*dt                              !Transmission length (s)
  bt=2.0                         
  bandwidth_ratio=2500.0/(fs/2.0)
  sig=sqrt(2*bandwidth_ratio) * 10.0**(0.05*snrdb)
  if(snrdb.gt.90.0) sig=1.0
  txt=NN*NSPS/12000.0

  ! Source-encode, then get itone()
  i3=-1
  n3=-1
  call pack77(msg37,i3,n3,c77,1)
  call genft8(msg37,i3,n3,1,msgsent37,msgbits,itone)
  call gen_ft8wave(itone,NN,NSPS,bt,fs,f0,cwave,xjunk,1,NWAVE)  !Generate complex cwave

  write(*,*)  
  write(*,'(a23,a37,3x,a7,i1,a1,i1)') 'New Style FT8 Message: ',msgsent37,'i3.n3: ',i3,'.',n3
  write(*,1000) f0,xdt,txt,snrdb,bw
1000 format('f0:',f9.3,'   DT:',f6.2,'   TxT:',f6.1,'   SNR:',f6.1,    &
       '  BW:',f4.1)
  write(*,*)  
  if(i3.eq.1) then
    write(*,*) '         mycall                         hiscall                    hisgrid'
    write(*,'(28i1,1x,i1,1x,28i1,1x,i1,1x,i1,1x,15i1,1x,3i1)') msgbits(1:77) 
  else
    write(*,'(a14)') 'Message bits: '
    write(*,'(77i1)') msgbits
  endif
  write(*,*) 
  write(*,'(a17)') 'Channel symbols: '
  write(*,'(79i1)') itone
  write(*,*)  

  call sgran()

  msg0=msg
  do ifile=1,nfiles
     c0=0.
     c0(0:NWAVE-1)=cwave
     c0=cshift(c0,-nint((xdt+0.5)/dt))
     if(fspread.ne.0.0 .or. delay.ne.0.0) call watterson(c0,NMAX,NWAVE,fs,delay,fspread)
     c=sig*c0
  
     wave=imag(c)
     peak=maxval(abs(wave))
     nslots=1
   
     if(snrdb.lt.90) then
        do i=1,NMAX                   !Add gaussian noise at specified SNR
           xnoise=gran()
           wave(i)=wave(i) + xnoise
        enddo
     endif

     gain=100.0
     if(snrdb.lt.90.0) then
       wave=gain*wave
     else
       datpk=maxval(abs(wave))
       fac=32766.9/datpk
       wave=fac*wave
     endif
     if(any(abs(wave).gt.32767.0)) print*,"Warning - data will be clipped."
     iwave=nint(wave)
     h=default_header(12000,NMAX)
     write(fname,1102) ifile
1102 format('000000_',i6.6,'.wav')
     open(10,file=fname,status='unknown',access='stream')
     write(10) h,iwave                !Save to *.wav file
     close(10)
     write(*,1110) ifile,xdt,f0,snrdb,fname
1110 format(i4,f7.2,f8.2,f7.1,2x,a17)
  enddo    
999 end program ft8sim_gfsk

subroutine four2a(a,nfft,ndim,isign,iform)

! IFORM = 1, 0 or -1, as data is
! complex, real, or the first half of a complex array.  Transform
! values are returned in array DATA.  They are complex, real, or
! the first half of a complex array, as IFORM = 1, -1 or 0.

! The transform of a real array (IFORM = 0) dimensioned N(1) by N(2)
! by ... will be returned in the same array, now considered to
! be complex of dimensions N(1)/2+1 by N(2) by ....  Note that if
! IFORM = 0 or -1, N(1) must be even, and enough room must be
! reserved.  The missing values may be obtained by complex conjugation.  

! The reverse transformation of a half complex array dimensioned
! N(1)/2+1 by N(2) by ..., is accomplished by setting IFORM
! to -1.  In the N array, N(1) must be the true N(1), not N(1)/2+1.
! The transform will be real and returned to the input array.

! This version of four2a makes calls to the FFTW library to do the 
! actual computations.

  parameter (NPMAX=2100)                 !Max numberf of stored plans
  parameter (NSMALL=16385)               !Max size of "small" FFTs
  complex a(nfft)                        !Array to be transformed
  complex aa(NSMALL)                     !Local copy of "small" a()
  integer nn(NPMAX),ns(NPMAX),nf(NPMAX)  !Params of stored plans 
  integer*8 nl(NPMAX),nloc               !More params of plans
  integer*8 plan(NPMAX)                  !Pointers to stored plans
  logical found_plan
  data nplan/0/                          !Number of stored plans
  common/patience/npatience,nthreads     !Patience and threads for FFTW plans
  include 'fftw3.f90'                    !FFTW definitions
  save plan,nplan,nn,ns,nf,nl

  if(nfft.lt.0) go to 999

  nloc=loc(a)
  found_plan = .false.

  do i=1,nplan
     if(nfft.eq.nn(i) .and. isign.eq.ns(i) .and.                     &
          iform.eq.nf(i) .and. nloc.eq.nl(i)) then
        found_plan = .true.
        exit
     end if
  enddo

  if(i.ge.NPMAX) stop 'Too many FFTW plans requested.'

  if (.not. found_plan) then
  !$omp critical(four2a_setup)
     nplan=nplan+1
     i=nplan

     nn(i)=nfft
     ns(i)=isign
     nf(i)=iform
     nl(i)=nloc

! Planning: FFTW_ESTIMATE, FFTW_ESTIMATE_PATIENT, FFTW_MEASURE, 
!            FFTW_PATIENT,  FFTW_EXHAUSTIVE
     nflags=FFTW_ESTIMATE
     if(npatience.eq.1) nflags=FFTW_ESTIMATE_PATIENT
     if(npatience.eq.2) nflags=FFTW_MEASURE
     if(npatience.eq.3) nflags=FFTW_PATIENT
     if(npatience.eq.4) nflags=FFTW_EXHAUSTIVE

     if(nfft.le.NSMALL) then
        jz=nfft
        if(iform.le.0) jz=nfft/2+1
        aa(1:jz)=a(1:jz)
     endif

     !$omp critical(fftw) ! serialize non thread-safe FFTW3 calls
     if(isign.eq.-1 .and. iform.eq.1) then
        call sfftw_plan_dft_1d(plan(i),nfft,a,a,FFTW_FORWARD,nflags)
     else if(isign.eq.1 .and. iform.eq.1) then
        call sfftw_plan_dft_1d(plan(i),nfft,a,a,FFTW_BACKWARD,nflags)
     else if(isign.eq.-1 .and. iform.eq.0) then
        call sfftw_plan_dft_r2c_1d(plan(i),nfft,a,a,nflags)
     else if(isign.eq.1 .and. iform.eq.-1) then
        call sfftw_plan_dft_c2r_1d(plan(i),nfft,a,a,nflags)
     else
        stop 'Unsupported request in four2a'
     endif
     !$omp end critical(fftw)

     if(nfft.le.NSMALL) then
        jz=nfft
        if(iform.le.0) jz=nfft/2+1
        a(1:jz)=aa(1:jz)
     endif
  !$omp end critical(four2a_setup)
  end if

  call sfftw_execute(plan(i))
  return

999 continue

  !$omp critical(four2a)
  do i=1,nplan
! The test is only to silence a compiler warning:
     if(ndim.ne.-999) then
        !$omp critical(fftw) ! serialize non thread-safe FFTW3 calls
        call sfftw_destroy_plan(plan(i))
        !$omp end critical(fftw)
     end if
  enddo

  nplan=0
  !$omp end critical(four2a)

  return
end subroutine four2a

subroutine wav11(d2,npts,dd)

! Convert i*2 data sampled at 12000 Hz to r*4 sampled at 11025 Hz.

  parameter (NZ11=60*11025,NZ12=60*12000)
  parameter (NFFT1=64*12000,NFFT2=64*11025)
  integer*2 d2(NZ12)
  real*4 dd(NZ11)
  real x(NFFT2)
  complex cx(0:NFFT1/2)
  equivalence (x,cx)
  save x,cx

  jz=min(NZ12,npts)
  x(1:jz)=d2(1:jz)
  x(jz+1:)=0.0
  call four2a(cx,nfft1,1,-1,0)                    !Forwarxd FFT, r2c
  df=12000.0/NFFT1
  ia=5000.0/df
  cx(ia:)=0.0
  call four2a(cx,nfft2,1,1,-1)                   !Inverse FFT, c2r
  npts=jz*11025.0/12000.0
  fac=1.e-6
  dd(1:npts)=fac*x(1:npts)
  if(npts.lt.NZ11) dd(npts+1:NZ11)=0.0

  return
end subroutine wav11

subroutine to_contest_msg(msg0,msg)

! If the message has "R grid4" istead of "grid4", remove the "R "
! and substitute the diametrically opposite grid.
  
  character*6 g1,g2
  character*22 msg0,msg
  logical isgrid
  isgrid(g1)=g1(1:1).ge.'A' .and. g1(1:1).le.'R' .and. g1(2:2).ge.'A' .and. &
       g1(2:2).le.'R' .and. g1(3:3).ge.'0' .and. g1(3:3).le.'9' .and.       &
       g1(4:4).ge.'0' .and. g1(4:4).le.'9' .and. g1(1:4).ne.'RR73'

  i0=index(msg0,' R ') + 3                  !Check for ' R ' in message
  g1=msg0(i0:i0+3)//'  '
  if(isgrid(g1)) then                       !Check for ' R grid'
     call grid2deg(g1,dlong,dlat)
     dlong=dlong+180.0
     if(dlong.gt.180.0) dlong=dlong-360.0
     dlat=-dlat
     call deg2grid(dlong,dlat,g2)           !g2=antipodes grid
     msg=msg0(1:i0-3)//g2(1:4)              !Send message with g2
  else
     msg=msg0
  endif

  return
end subroutine to_contest_msg

subroutine watterson(c,npts,fs,delay,fspread)

  complex c(0:npts-1)
  complex c2(0:npts-1)
  complex cs1(0:npts-1)
  complex cs2(0:npts-1)

  nonzero=0
  df=fs/npts
  if(fspread.gt.0.0) then
     do i=0,npts-1
        xx=gran()
        yy=gran()
        cs1(i)=0.707*cmplx(xx,yy)
        xx=gran()
        yy=gran()
        cs2(i)=0.707*cmplx(xx,yy)
     enddo
     call four2a(cs1,npts,1,-1,1)     !To freq domain
     call four2a(cs2,npts,1,-1,1)
     do i=0,npts-1
        f=i*df
        if(i.gt.npts/2) f=(i-npts)*df
        x=(f/(0.5*fspread))**2
        a=0.
        if(x.le.50.0) then
           a=exp(-x)
        endif
        cs1(i)=a*cs1(i)
        cs2(i)=a*cs2(i)
        if(abs(f).lt.10.0) then
           p1=real(cs1(i))**2 + aimag(cs1(i))**2
           p2=real(cs2(i))**2 + aimag(cs2(i))**2
           if(p1.gt.0.0) nonzero=nonzero+1
!           write(62,3101) f,p1,p2,db(p1+1.e-12)-60,db(p2+1.e-12)-60
!3101       format(f10.3,2f12.3,2f10.3)
        endif
     enddo
     call four2a(cs1,npts,1,1,1)     !Back to time domain
     call four2a(cs2,npts,1,1,1)
     cs1(0:npts-1)=cs1(0:npts-1)/npts
     cs2(0:npts-1)=cs2(0:npts-1)/npts
  endif

  nshift=nint(0.001*delay*fs)
  c2(0:npts-1)=cshift(c(0:npts-1),nshift)
  sq=0.
  do i=0,npts-1
     if(nonzero.gt.1) then
        c(i)=0.5*(cs1(i)*c(i) + cs2(i)*c2(i))
     else
        c(i)=0.5*(c(i) + c2(i))
     endif
     sq=sq + real(c(i))**2 + aimag(c(i))**2
!     write(61,3001) i/12000.0,c(i)
!3001 format(3f12.6)
  enddo
  rms=sqrt(sq/npts)
  c=c/rms

  return
end subroutine watterson

! This source code file was last time modified by Igor UA3DJY on May 25th, 2018
! All changes are shown in the patch file coming together with the full JTDX source code.

subroutine encode174(message,codeword)
! Encode an 101-bit message and return a 174-bit codeword. 
! The generator matrix has dimensions (73,101). 
! The code is a (174,101) regular ldpc code with column weight 3.
! The code was generated using the PEG algorithm.
! After creating the codeword, the columns are re-ordered according to 
! "colorder" to make the codeword compatible with the parity-check matrix 
!
include "ldpc_174_87_params.f90"

integer*1 codeword(N)
integer*1 gen(M,K)
integer*1 itmp(N)
integer*1 message(K)
integer*1 pchecks(M)
logical first
data first/.true./

save first,gen

if( first ) then ! fill the generator matrix
  gen=0
  do i=1,M
    do j=1,11
      read(g(i)( (j-1)*2+1:(j-1)*2+2 ),"(Z2)") istr
        do jj=1, 8
          icol=(j-1)*8+jj
          if( icol .le. 87 ) then
            if( btest(istr,8-jj) ) gen(i,icol)=1
          endif
        enddo
    enddo
  enddo
first=.false.
endif

do i=1,M
  nsum=0
  do j=1,K 
    nsum=nsum+message(j)*gen(i,j)
  enddo
  pchecks(i)=mod(nsum,2)
enddo

itmp(1:M)=pchecks
itmp(M+1:N)=message(1:K)
codeword(colorder+1)=itmp(1:N)

return
end subroutine encode174

! This source code file was last time modified by Igor UA3DJY on 20181215
! All changes are shown in the patch file coming together with the full JTDX source code.

module packjt

! These variables are accessible from outside via "use packjt":
  integer jt_itype,jt_nc1,jt_nc2,jt_ng,jt_k1,jt_k2
  character*6 jt_c1,jt_c2,jt_c3

  contains

subroutine packbits(dbits,nsymd,m0,sym)

 ! Pack 0s and 1s from dbits() into sym() with m0 bits per word.
 ! NB: nsymd is the number of packed output words.

   integer sym(:)
   integer*1 dbits(:)

   k=0
   do i=1,nsymd
      n=0
      do j=1,m0
         k=k+1
         m=dbits(k)
         n=ior(ishft(n,1),m)
      enddo
      sym(i)=n
   enddo

   return
 end subroutine packbits

 subroutine unpackbits(sym,nsymd,m0,dbits)

 ! Unpack bits from sym() into dbits(), one bit per byte.
 ! NB: nsymd is the number of input words, and m0 their length.
 ! there will be m0*nsymd output bytes, each 0 or 1.

   integer sym(:)
   integer*1 dbits(:)

   k=0
   do i=1,nsymd
      mask=ishft(1,m0-1)
      do j=1,m0
         k=k+1
         dbits(k)=0
         if(iand(mask,sym(i)).ne.0) dbits(k)=1
         mask=ishft(mask,-1)
      enddo
   enddo

   return
 end subroutine unpackbits

 subroutine packcall(callsign,ncall,text)

 ! Pack a valid callsign into a 28-bit integer.

   parameter (NBASE=37*36*10*27*27*27)
   character callsign*6,c*1,tmp*6
   logical text

   text=.false.

 ! Work-around for Swaziland prefix:
   if(callsign(1:4).eq.'3DA0') callsign='3D0'//callsign(5:6)

 ! Work-around for Guinea prefixes:
   if(callsign(1:2).eq.'3X' .and. callsign(3:3).ge.'A' .and.          &
        callsign(3:3).le.'Z') callsign='Q'//callsign(3:6)

   if(callsign(1:3).eq.'CQ ') then
      ncall=NBASE + 1
      if(callsign(4:4).ge.'0' .and. callsign(4:4).le.'9' .and.        &
           callsign(5:5).ge.'0' .and. callsign(5:5).le.'9' .and.      &
           callsign(6:6).ge.'0' .and. callsign(6:6).le.'9') then
         read(callsign(4:6),*) nfreq
         ncall=NBASE + 3 + nfreq
      endif
      return
   else if(callsign(1:4).eq.'QRZ ') then
      ncall=NBASE + 2
      return
   else if(callsign(1:3).eq.'DE ') then
      ncall=267796945
      return
   endif

   tmp='      '
   if(callsign(3:3).ge.'0' .and. callsign(3:3).le.'9') then
      tmp=callsign
   else if(callsign(2:2).ge.'0' .and. callsign(2:2).le.'9') then
      if(callsign(6:6).ne.' ') then
         text=.true.
         return
      endif
      tmp=' '//callsign(:5)
   else
      text=.true.
      return
   endif

   do i=1,6
      c=tmp(i:i)
      if(c.ge.'a' .and. c.le.'z')                                &
           tmp(i:i)=char(ichar(c)-ichar('a')+ichar('A'))
   enddo

   n1=0
   if((tmp(1:1).ge.'A'.and.tmp(1:1).le.'Z').or.tmp(1:1).eq.' ') n1=1
   if(tmp(1:1).ge.'0' .and. tmp(1:1).le.'9') n1=1
   n2=0
   if(tmp(2:2).ge.'A' .and. tmp(2:2).le.'Z') n2=1
   if(tmp(2:2).ge.'0' .and. tmp(2:2).le.'9') n2=1
   n3=0
   if(tmp(3:3).ge.'0' .and. tmp(3:3).le.'9') n3=1
   n4=0
   if((tmp(4:4).ge.'A'.and.tmp(4:4).le.'Z').or.tmp(4:4).eq.' ') n4=1
   n5=0
   if((tmp(5:5).ge.'A'.and.tmp(5:5).le.'Z').or.tmp(5:5).eq.' ') n5=1
   n6=0
   if((tmp(6:6).ge.'A'.and.tmp(6:6).le.'Z').or.tmp(6:6).eq.' ') n6=1

   if(n1+n2+n3+n4+n5+n6 .ne. 6) then
      text=.true.
      return 
   endif

   ncall=nchar(tmp(1:1))
   ncall=36*ncall+nchar(tmp(2:2))
   ncall=10*ncall+nchar(tmp(3:3))
   ncall=27*ncall+nchar(tmp(4:4))-10
   ncall=27*ncall+nchar(tmp(5:5))-10
   ncall=27*ncall+nchar(tmp(6:6))-10

   return
 end subroutine packcall

 subroutine unpackcall(ncall,word,iv2,psfx)

   parameter (NBASE=37*36*10*27*27*27)
   character word*12,c*37,psfx*4

   data c/'0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ '/

   word='......' 
   psfx='    '
   n=ncall
   iv2=0
   if(n.ge.262177560) go to 20
   word='......'
 !  if(n.ge.262177560) go to 999            !Plain text message ...
   i=mod(n,27)+11
   word(6:6)=c(i:i)
   n=n/27
   i=mod(n,27)+11
   word(5:5)=c(i:i)
   n=n/27
   i=mod(n,27)+11
   word(4:4)=c(i:i)
   n=n/27
   i=mod(n,10)+1
   word(3:3)=c(i:i)
   n=n/10
   i=mod(n,36)+1
   word(2:2)=c(i:i)
   n=n/36
   i=n+1
   word(1:1)=c(i:i)
   do i=1,4
      if(word(i:i).ne.' ') go to 10
   enddo
   go to 999
 10 word=word(i:)
   go to 999

 20 if(n.ge.267796946) go to 999

 ! We have a JT65v2 message
   if((n.ge.262178563) .and. (n.le.264002071)) then
 ! CQ with prefix
      iv2=1
      n=n-262178563
      i=mod(n,37)+1
      psfx(4:4)=c(i:i)
      n=n/37
      i=mod(n,37)+1
      psfx(3:3)=c(i:i)
      n=n/37
      i=mod(n,37)+1
      psfx(2:2)=c(i:i)
      n=n/37
      i=n+1
      psfx(1:1)=c(i:i)

   else if((n.ge.264002072) .and. (n.le.265825580)) then
 ! QRZ with prefix
      iv2=2
      n=n-264002072
      i=mod(n,37)+1
      psfx(4:4)=c(i:i)
      n=n/37
      i=mod(n,37)+1
      psfx(3:3)=c(i:i)
      n=n/37
      i=mod(n,37)+1
      psfx(2:2)=c(i:i)
      n=n/37
      i=n+1
      psfx(1:1)=c(i:i)

   else if((n.ge.265825581) .and. (n.le.267649089)) then
 ! DE with prefix
      iv2=3
      n=n-265825581
      i=mod(n,37)+1
      psfx(4:4)=c(i:i)
      n=n/37
      i=mod(n,37)+1
      psfx(3:3)=c(i:i)
      n=n/37
      i=mod(n,37)+1
      psfx(2:2)=c(i:i)
      n=n/37
      i=n+1
      psfx(1:1)=c(i:i)

   else if((n.ge.267649090) .and. (n.le.267698374)) then
 ! CQ with suffix
      iv2=4
      n=n-267649090
      i=mod(n,37)+1
      psfx(3:3)=c(i:i)
      n=n/37
      i=mod(n,37)+1
      psfx(2:2)=c(i:i)
      n=n/37
      i=n+1
      psfx(1:1)=c(i:i)

   else if((n.ge.267698375) .and. (n.le.267747659)) then
 ! QRZ with suffix
      iv2=5
      n=n-267698375
      i=mod(n,37)+1
      psfx(3:3)=c(i:i)
      n=n/37
      i=mod(n,37)+1
      psfx(2:2)=c(i:i)
      n=n/37
      i=n+1
      psfx(1:1)=c(i:i)

   else if((n.ge.267747660) .and. (n.le.267796944)) then
 ! DE with suffix
      iv2=6
      n=n-267747660
      i=mod(n,37)+1
      psfx(3:3)=c(i:i)
      n=n/37
      i=mod(n,37)+1
      psfx(2:2)=c(i:i)
      n=n/37
      i=n+1
      psfx(1:1)=c(i:i)

   else if(n.eq.267796945) then
 ! DE with no prefix or suffix
      iv2=7
      psfx = '    '
   endif

999 if(word(1:3).eq.'3D0') word='3DA0'//word(4:)
   if(word(1:1).eq.'Q' .and. word(2:2).ge.'A' .and.                 &
        word(2:2).le.'Z') word='3X'//word(2:)

   return
 end subroutine unpackcall

 subroutine packgrid(grid,ng,text)

   parameter (NGBASE=180*180)
   character*4 grid
   character*1 c1
   logical text

   text=.false.
   if(grid.eq.'    ') go to 90               !Blank grid is OK

 ! First, handle signal reports in the original range, -01 to -30 dB
   if(grid(1:1).eq.'-') then
      read(grid(2:3),*,err=800,end=800) n
      if(n.ge.1 .and. n.le.30) then
         ng=NGBASE+1+n
         go to 900
      endif
      go to 10
   else if(grid(1:2).eq.'R-') then
      read(grid(3:4),*,err=800,end=800) n
      if(n.ge.1 .and. n.le.30) then
         ng=NGBASE+31+n
         go to 900
      endif
      go to 10
 ! Now check for RO, RRR, or 73 in the message field normally used for grid
   else if(grid(1:4).eq.'RO  ') then
      ng=NGBASE+62
      go to 900
   else if(grid(1:4).eq.'RRR ') then
      ng=NGBASE+63
      go to 900
   else if(grid(1:4).eq.'73  ') then
      ng=NGBASE+64
      go to 900
   endif

 ! Now check for extended-range signal reports: -50 to -31, and 0 to +49.
 10 n=99
   c1=grid(1:1)
   read(grid,*,err=20,end=20) n
   go to 30
 20 read(grid(2:4),*,err=30,end=30) n
 30 if(n.ge.-50 .and. n.le.49) then
      if(c1.eq.'R') then
         write(grid,1002) n+50
 1002    format('LA',i2.2)
      else
         write(grid,1003) n+50
 1003    format('KA',i2.2)
      endif
      go to 40
   endif

 ! Maybe it's free text ?
   if(grid(1:1).lt.'A' .or. grid(1:1).gt.'R') text=.true.
   if(grid(2:2).lt.'A' .or. grid(2:2).gt.'R') text=.true.
   if(grid(3:3).lt.'0' .or. grid(3:3).gt.'9') text=.true.
   if(grid(4:4).lt.'0' .or. grid(4:4).gt.'9') text=.true.
   if(text) go to 900

 ! OK, we have a properly formatted grid locator
 40 call grid2deg(grid//'mm55',dlong,dlat)
   long=int(dlong)
   lat=int(dlat+ 90.0)
   ng=((long+180)/2)*180 + lat
   go to 900

 90 ng=NGBASE + 1
   go to 900

 800 text=.true.
 900 continue

   return
 end subroutine packgrid

 subroutine unpackgrid(ng,grid)

   parameter (NGBASE=180*180)
   character grid*4,grid6*6

   grid='    '
   if(ng.ge.32400) go to 10
   dlat=mod(ng,180)-90
   dlong=(ng/180)*2 - 180 + 2
   call deg2grid(dlong,dlat,grid6)
   grid=grid6(:4)
   if(grid(1:2).eq.'KA') then
      read(grid(3:4),*) n
      n=n-50
      write(grid,1001) n
 1001 format(i3.2)
      if(grid(1:1).eq.' ') grid(1:1)='+'
   else if(grid(1:2).eq.'LA') then
      read(grid(3:4),*) n
      n=n-50
      write(grid,1002) n
 1002 format('R',i3.2)
      if(grid(2:2).eq.' ') grid(2:2)='+'
   endif
   go to 900

 10 n=ng-NGBASE-1
   if(n.ge.1 .and.n.le.30) then
      write(grid,1012) -n
 1012 format(i3.2)
   else if(n.ge.31 .and.n.le.60) then
      n=n-30
      write(grid,1022) -n
 1022 format('R',i3.2)
   else if(n.eq.61) then
      grid='RO'
   else if(n.eq.62) then
      grid='RRR'
   else if(n.eq.63) then
      grid='73'
   endif

 900 return
 end subroutine unpackgrid

 subroutine packmsg(msg0,dat,itype)

 ! Packs a JT9/JT65 message into twelve 6-bit symbols

 ! itype Message Type
 !--------------------
 !   1   Standardd message
 !   2   Type 1 prefix
 !   3   Type 1 suffix
 !   4   Type 2 prefix
 !   5   Type 2 suffix
 !   6   Free text
 !  -1   Does not decode correctly

   parameter (NBASE=37*36*10*27*27*27)
   parameter (NBASE2=262178562)
   character*22 msg0,msg
   integer dat(:)
   character*12 c1,c2
   character*4 c3
   character*6 grid6
   logical text1,text2,text3

   itype=1

      msg=msg0

   call fmtmsg(msg,iz)
   if(msg(1:3).eq.'CQ ' .and. msg(4:4).ge.'0' .and. msg(4:4).le.'9'   &
        .and. msg(5:5).eq.' ') msg='CQ 00'//msg(4:)

   if(msg(1:6).eq.'CQ DX ') msg(3:3)='9'
   if(msg(1:3).eq.'CQ ' .and.                                         &
        msg(4:4).ge.'A' .and. msg(4:4).le.'Z' .and.                   &
        msg(5:5).ge.'A' .and. msg(5:5).le.'Z' .and.                   &
        msg(6:6).eq.' ') msg='E9'//msg(4:)
  
 ! See if it's a CQ message
   if(msg(1:3).eq.'CQ ') then
      i=3
 ! ... and if so, does it have a reply frequency?
      if(msg(4:4).ge.'0' .and. msg(4:4).le.'9' .and.                  &
           msg(5:5).ge.'0' .and. msg(5:5).le.'9' .and.                &
           msg(6:6).ge.'0' .and. msg(6:6).le.'9') i=7
      go to 1
   endif

   do i=1,22
      if(msg(i:i).eq.' ') go to 1       !Get 1st blank
   enddo
   go to 10                             !Consider msg as plain text

 1 ia=i
   c1=msg(1:ia-1)
   do i=ia+1,22
      if(msg(i:i).eq.' ') go to 2       !Get 2nd blank
   enddo
   go to 10                             !Consider msg as plain text

 2 ib=i
   c2=msg(ia+1:ib-1)

   do i=ib+1,22
      if(msg(i:i).eq.' ') go to 3       !Get 3rd blank
   enddo
   go to 10                             !Consider msg as plain text

 3 ic=i
   c3='    '
   if(ic.ge.ib+1) c3=msg(ib+1:ic)
   if(c3.eq.'OOO ') c3='    '           !Strip out the OOO flag
   call getpfx1(c1,k1,nv2a)
   if(nv2a.ge.4) go to 10
   call packcall(c1,nc1,text1)
   if(text1) go to 10
   call getpfx1(c2,k2,nv2b)
   call packcall(c2,nc2,text2)
   if(text2) go to 10
   if(nv2a.eq.2 .or. nv2a.eq.3 .or. nv2b.eq.2 .or. nv2b.eq.3) then
      if(k1.lt.0 .or. k2.lt.0 .or. k1*k2.ne.0) go to 10
      if(k2.gt.0) k2=k2+450
      k=max(k1,k2)
      if(k.gt.0) then
         call k2grid(k,grid6)
         c3=grid6(:4)
      endif
   endif
   call packgrid(c3,ng,text3)

   if(nv2a.lt.4 .and. nv2b.lt.4 .and. (.not.text1) .and. (.not.text2) .and.  &
        (.not.text3)) go to 20

   nc1=0
   if(nv2b.eq.4) then
      if(c1(1:3).eq.'CQ ' .and. (.not.text3))  nc1=262178563 + k2
      if(c1(1:4).eq.'QRZ ' .and. (.not.text3)) nc1=264002072 + k2
      if(c1(1:3).eq.'DE ' .and. (.not.text3))  nc1=265825581 + k2
   else if(nv2b.eq.5) then
      if(c1(1:3).eq.'CQ ' .and. (.not.text3))  nc1=267649090 + k2
      if(c1(1:4).eq.'QRZ ' .and. (.not.text3)) nc1=267698375 + k2
      if(c1(1:3).eq.'DE ' .and. (.not.text3))  nc1=267747660 + k2
   endif
   if(nc1.ne.0) go to 20

 ! The message will be treated as plain text.
 10 itype=6
   call packtext(msg,nc1,nc2,ng)
   ng=ng+32768

 ! Encode data into 6-bit words
20 continue
   if(itype.ne.6) itype=max(nv2a,nv2b)
   jt_itype=itype
   jt_c1=c1(1:6)
   jt_c2=c2(1:6)
   jt_c3=c3
   jt_k1=k1
   jt_k2=k2
   jt_nc1=nc1
   jt_nc2=nc2
   jt_ng=ng
   dat(1)=iand(ishft(nc1,-22),63)                !6 bits
   dat(2)=iand(ishft(nc1,-16),63)                !6 bits
   dat(3)=iand(ishft(nc1,-10),63)                !6 bits
   dat(4)=iand(ishft(nc1, -4),63)                !6 bits
   dat(5)=4*iand(nc1,15)+iand(ishft(nc2,-26),3)  !4+2 bits
   dat(6)=iand(ishft(nc2,-20),63)                !6 bits
   dat(7)=iand(ishft(nc2,-14),63)                !6 bits
   dat(8)=iand(ishft(nc2, -8),63)                !6 bits
   dat(9)=iand(ishft(nc2, -2),63)                !6 bits
   dat(10)=16*iand(nc2,3)+iand(ishft(ng,-12),15) !2+4 bits
   dat(11)=iand(ishft(ng,-6),63)
   dat(12)=iand(ng,63)

   return
 end subroutine packmsg

 subroutine unpackmsg(dat,msg)

   parameter (NBASE=37*36*10*27*27*27)
   parameter (NGBASE=180*180)
   integer dat(:)
   character c1*12,c2*12,grid*4,msg*22,grid6*6,psfx*4,junk2*4
   logical cqnnn

   cqnnn=.false.
   nc1=ishft(dat(1),22) + ishft(dat(2),16) + ishft(dat(3),10)+         &
        ishft(dat(4),4) + iand(ishft(dat(5),-2),15)

   nc2=ishft(iand(dat(5),3),26) + ishft(dat(6),20) +                   &
        ishft(dat(7),14) + ishft(dat(8),8) + ishft(dat(9),2) +         &
        iand(ishft(dat(10),-4),3)

   ng=ishft(iand(dat(10),15),12) + ishft(dat(11),6) + dat(12)

   if(ng.ge.32768) then
      call unpacktext(nc1,nc2,ng,msg)
      go to 100
   endif

   call unpackcall(nc1,c1,iv2,psfx)
   if(iv2.eq.0) then
 ! This is an "original JT65" message
      if(nc1.eq.NBASE+1) c1='CQ    '
      if(nc1.eq.NBASE+2) c1='QRZ   '
      nfreq=nc1-NBASE-3
      if(nfreq.ge.0 .and. nfreq.le.999) then
         write(c1,1002) nfreq
 1002    format('CQ ',i3.3)
         cqnnn=.true.
      endif
   endif

   call unpackcall(nc2,c2,junk1,junk2)
   call unpackgrid(ng,grid)

   if(iv2.gt.0) then
 ! This is a JT65v2 message
      do i=1,4
         if(ichar(psfx(i:i)).eq.0) psfx(i:i)=' '
      enddo

      n1=len_trim(psfx)
      n2=len_trim(c2)
      if(iv2.eq.1) msg='CQ '//psfx(:n1)//'/'//c2(:n2)//' '//grid
      if(iv2.eq.2) msg='QRZ '//psfx(:n1)//'/'//c2(:n2)//' '//grid
      if(iv2.eq.3) msg='DE '//psfx(:n1)//'/'//c2(:n2)//' '//grid
      if(iv2.eq.4) msg='CQ '//c2(:n2)//'/'//psfx(:n1)//' '//grid
      if(iv2.eq.5) msg='QRZ '//c2(:n2)//'/'//psfx(:n1)//' '//grid
      if(iv2.eq.6) msg='DE '//c2(:n2)//'/'//psfx(:n1)//' '//grid
      if(iv2.eq.7) then
         grid6=grid//'ma'
         call grid2k(grid6,k)
         if(k.ge.451 .and. k.le.900) then
            call getpfx2(k,c2)
            n2=len_trim(c2)
            msg='DE '//c2(:n2)
         else
            msg='DE '//c2(:n2)//' '//grid
         endif
      endif
      if(iv2.eq.8) msg=' '
      go to 100
   else

   endif

   grid6=grid//'ma'
   call grid2k(grid6,k)
   if(k.ge.1 .and. k.le.450)   call getpfx2(k,c1)
   if(k.ge.451 .and. k.le.900) call getpfx2(k,c2)

   i=index(c1,char(0))
   if(i.ge.3) c1=c1(1:i-1)//'            '
   i=index(c2,char(0))
   if(i.ge.3) c2=c2(1:i-1)//'            '

   msg='                      '
   j=0
   if(cqnnn) then
      msg=c1//'          '
      j=7                                  !### ??? ###
      go to 10
   endif

   do i=1,12
      j=j+1
      msg(j:j)=c1(i:i)
      if(c1(i:i).eq.' ') go to 10
   enddo
   j=j+1
   msg(j:j)=' '

 10 do i=1,12
      if(j.le.21) j=j+1
      msg(j:j)=c2(i:i)
      if(c2(i:i).eq.' ') go to 20
   enddo
   if(j.le.21) j=j+1
   msg(j:j)=' '

 20 if(k.eq.0) then
      do i=1,4
         if(j.le.21) j=j+1
         msg(j:j)=grid(i:i)
      enddo
      if(j.le.21) j=j+1
      msg(j:j)=' '
   endif

 100 continue
   if(msg(1:6).eq.'CQ9DX ') msg(3:3)=' '
   if(msg(1:2).eq.'E9' .and.                                          &
        msg(3:3).ge.'A' .and. msg(3:3).le.'Z' .and.                   &
        msg(4:4).ge.'A' .and. msg(4:4).le.'Z' .and.                   &
        msg(5:5).eq.' ') msg='CQ '//msg(3:)

   if(msg(1:5).eq.'CQ 00' .and. msg(6:6).ge.'0' .and.                 &
        msg(6:6).le.'9') msg='CQ '//msg(6:)

!!following code shall not be applied to FT8v2
!!protection if len_trim of the message components is greater than expected
!   if(len_trim(msg).gt.20 .and. .not.bcontest) msg='                      ' !is bpcontest check needed?
   return
 end subroutine unpackmsg

 subroutine packtext(msg,nc1,nc2,nc3)

   parameter (MASK28=2**28 - 1)
   character*22 msg
   character*42 c
   data c/'0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ +-./?'/

   nc1=0
   nc2=0
   nc3=0

   do i=1,5                                !First 5 characters in nc1
      do j=1,42                            !Get character code
         if(msg(i:i).eq.c(j:j)) go to 10
      enddo
      j=37
 10   j=j-1                                !Codes should start at zero
      nc1=42*nc1 + j
   enddo

   do i=6,10                               !Characters 6-10 in nc2
      do j=1,42                            !Get character code
         if(msg(i:i).eq.c(j:j)) go to 20
      enddo
      j=37
 20   j=j-1                                !Codes should start at zero
      nc2=42*nc2 + j
   enddo

   do i=11,13                              !Characters 11-13 in nc3
      do j=1,42                            !Get character code
         if(msg(i:i).eq.c(j:j)) go to 30
      enddo
      j=37
 30   j=j-1                                !Codes should start at zero
      nc3=42*nc3 + j
   enddo

 ! We now have used 17 bits in nc3.  Must move one each to nc1 and nc2.
   nc1=nc1+nc1
   if(iand(nc3,32768).ne.0) nc1=nc1+1
   nc2=nc2+nc2
   if(iand(nc3,65536).ne.0) nc2=nc2+1
   nc3=iand(nc3,32767)

   return
 end subroutine packtext

 subroutine unpacktext(nc1a,nc2a,nc3a,msg)

   character*22 msg
   character*44 c
   data c/'0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ +-./?'/

   nc1=nc1a
   nc2=nc2a
   nc3=iand(nc3a,32767)                      !Remove the "plain text" bit
   if(iand(nc1,1).ne.0) nc3=nc3+32768
   nc1=nc1/2
   if(iand(nc2,1).ne.0) nc3=nc3+65536
   nc2=nc2/2

   do i=5,1,-1
      j=mod(nc1,42)+1
      msg(i:i)=c(j:j)
      nc1=nc1/42
   enddo

   do i=10,6,-1
      j=mod(nc2,42)+1
      msg(i:i)=c(j:j)
      nc2=nc2/42
   enddo

   do i=13,11,-1
      j=mod(nc3,42)+1
      msg(i:i)=c(j:j)
      nc3=nc3/42
   enddo
   msg(14:22) = '         '

   return
 end subroutine unpacktext

 subroutine getpfx1(callsign,k,nv2)

   character*12 callsign0,callsign,lof,rof
   character*8 c
   character addpfx*8,tpfx*4,tsfx*3
   logical ispfx,issfx,invalid
   common/pfxcom/addpfx
   include 'pfx.f90'

   callsign0=callsign
   nv2=1
   iz=index(callsign,' ') - 1
   if(iz.lt.0) iz=12
   islash=index(callsign(1:iz),'/')
   k=0
 !  if(k.eq.0) go to 10     !Tnx to DL9RDZ for reminder:this was for tests only!
   c='   '
   if(islash.gt.0 .and. islash.le.(iz-4)) then
 ! Add-on prefix
      c=callsign(1:islash-1)
      callsign=callsign(islash+1:iz)
      do i=1,NZ
         if(pfx(i)(1:4).eq.c) then
            k=i
            nv2=2
            go to 10
         endif
      enddo
      if(addpfx.eq.c) then
         k=449
         nv2=2
         go to 10
      endif

   else if(islash.eq.(iz-1)) then
 ! Add-on suffix
      c=callsign(islash+1:iz)
      callsign=callsign(1:islash-1)
      do i=1,NZ2
         if(sfx(i).eq.c(1:1)) then
            k=400+i
            nv2=3
            go to 10
         endif
      enddo
   endif

 10 if(islash.ne.0 .and.k.eq.0) then
 ! Original JT65 would force this compound callsign to be treated as
 ! plain text.  In JT65v2, we will encode the prefix or suffix into nc1.
 ! The task here is to compute the proper value of k.
      lof=callsign0(:islash-1)
      rof=callsign0(islash+1:)
      llof=len_trim(lof)
      lrof=len_trim(rof)
      ispfx=(llof.gt.0 .and. llof.le.4)
      issfx=(lrof.gt.0 .and. lrof.le.3)
      invalid=.not.(ispfx.or.issfx)
      if(ispfx.and.issfx) then
         if(llof.lt.3) issfx=.false.
         if(lrof.lt.3) ispfx=.false.
         if(ispfx.and.issfx) then
            i=ichar(callsign0(islash-1:islash-1))
            if(i.ge.ichar('0') .and. i.le.ichar('9')) then
               issfx=.false.
            else
               ispfx=.false.
            endif
         endif
      endif

      if(invalid) then
         k=-1
      else
         if(ispfx) then
            tpfx=lof(1:4)
            k=nchar(tpfx(1:1))
            k=37*k + nchar(tpfx(2:2))
            k=37*k + nchar(tpfx(3:3))
            k=37*k + nchar(tpfx(4:4))
            nv2=4
            i=index(callsign0,'/')
            callsign=callsign0(:i-1)
            callsign=callsign0(i+1:)
         endif
         if(issfx) then
            tsfx=rof(1:3)
            k=nchar(tsfx(1:1))
            k=37*k + nchar(tsfx(2:2))
            k=37*k + nchar(tsfx(3:3))
            nv2=5
            i=index(callsign0,'/')
            callsign=callsign0(:i-1)
         endif
      endif
   endif

   return
 end subroutine getpfx1

 subroutine getpfx2(k0,callsign)

   character callsign*12
   include 'pfx.f90'
   character addpfx*8
   common/pfxcom/addpfx

   k=k0
   if(k.gt.450) k=k-450
   if(k.ge.1 .and. k.le.NZ) then
      iz=index(pfx(k),' ') - 1
      callsign=pfx(k)(1:iz)//'/'//callsign
   else if(k.ge.401 .and. k.le.400+NZ2) then
      iz=index(callsign,' ') - 1
      callsign=callsign(1:iz)//'/'//sfx(k-400)
   else if(k.eq.449) then
      iz=index(addpfx,' ') - 1
      if(iz.lt.1) iz=8
      callsign=addpfx(1:iz)//'/'//callsign
   endif

   return
 end subroutine getpfx2

 subroutine grid2k(grid,k)

   character*6 grid

   call grid2deg(grid//'55',xlong,xlat)
   nlong=nint(xlong)
   nlat=nint(xlat)
   k=0
   if(nlat.ge.85) k=5*(nlong+179)/2 + nlat-84

   return
 end subroutine grid2k

 subroutine k2grid(k,grid)
   character grid*6

   nlong=2*mod((k-1)/5,90)-179
   if(k.gt.450) nlong=nlong+180
   nlat=mod(k-1,5)+ 85
   dlat=nlat
   dlong=nlong
   call deg2grid(dlong,dlat,grid)

   return
 end subroutine k2grid

 subroutine grid2n(grid,n)
   character*4 grid

   i1=ichar(grid(1:1))-ichar('A')
   i2=ichar(grid(3:3))-ichar('0')
   i=10*i1 + i2
   n=-i - 31

   return
 end subroutine grid2n

 subroutine n2grid(n,grid)
   character*4 grid

   if(n.gt.-31 .or. n.lt.-70) stop 'Error in n2grid'
   i=-(n+31)                           !NB: 0 <= i <= 39
   i1=i/10
   i2=mod(i,10)
   grid(1:1)=char(ichar('A')+i1)
   grid(2:2)='A'
   grid(3:3)=char(ichar('0')+i2)
   grid(4:4)='0'

   return
 end subroutine n2grid

 function nchar(c)

 ! Convert ascii number, letter, or space to 0-36 for callsign packing.

   character c*1

   n=0                                    !Silence compiler warning
   if(c.ge.'0' .and. c.le.'9') then
      n=ichar(c)-ichar('0')
   else if(c.ge.'A' .and. c.le.'Z') then
      n=ichar(c)-ichar('A') + 10
   else if(c.ge.'a' .and. c.le.'z') then
      n=ichar(c)-ichar('a') + 10
   else if(c.ge.' ') then
      n=36
   else
      Print*,'Invalid character in callsign ',c,' ',ichar(c)
      stop
   endif
   nchar=n

   return
 end function nchar

 subroutine pack50(n1,n2,dat)

   integer*1 dat(:),i1

   i1=iand(ishft(n1,-20),255)                !8 bits
   dat(1)=i1
   i1=iand(ishft(n1,-12),255)                 !8 bits
   dat(2)=i1
   i1=iand(ishft(n1, -4),255)                 !8 bits
   dat(3)=i1
   i1=16*iand(n1,15)+iand(ishft(n2,-18),15)   !4+4 bits
   dat(4)=i1
   i1=iand(ishft(n2,-10),255)                 !8 bits
   dat(5)=i1
   i1=iand(ishft(n2, -2),255)                 !8 bits
   dat(6)=i1
   i1=64*iand(n2,3)                           !2 bits
   dat(7)=i1
   dat(8)=0
   dat(9)=0
   dat(10)=0
   dat(11)=0

   return
 end subroutine pack50

subroutine packpfx(call1,n1,ng,nadd)

  character*12 call1,call0
  character*3 pfx
  logical text

  i1=index(call1,'/')
  if(call1(i1+2:i1+2).eq.' ') then
! Single-character add-on suffix (maybe also fourth suffix letter?)
     call0=call1(:i1-1)
     call packcall(call0,n1,text)
     nadd=1
     nc=ichar(call1(i1+1:i1+1))
     if(nc.ge.48 .and. nc.le.57) then
        n=nc-48
     else if(nc.ge.65 .and. nc.le.90) then
        n=nc-65+10
     else
        n=38
     endif
     nadd=1
     ng=60000-32768+n
  else if(call1(i1+3:i1+3).eq.' ') then
! Two-character numerical suffix, /10 to /99
     call0=call1(:i1-1)
     call packcall(call0,n1,text)
     nadd=1
     n=10*(ichar(call1(i1+1:i1+1))-48) + ichar(call1(i1+2:i1+2)) - 48
     nadd=1
     ng=60000 + 26 + n
  else
! Prefix of 1 to 3 characters
     pfx=call1(:i1-1)
     if(pfx(3:3).eq.' ') pfx=' '//pfx(1:2)
     if(pfx(3:3).eq.' ') pfx=' '//pfx(1:2)
     call0=call1(i1+1:)
     call packcall(call0,n1,text)

     ng=0
     do i=1,3
        nc=ichar(pfx(i:i))
        if(nc.ge.48 .and. nc.le.57) then
           n=nc-48
        else if(nc.ge.65 .and. nc.le.90) then
           n=nc-65+10
        else
           n=36
        endif
        ng=37*ng + n
     enddo
     nadd=0
     if(ng.ge.32768) then
        ng=ng-32768
        nadd=1
     endif
  endif

  return
end subroutine packpfx

end module packjt

! last time modified by Igor UA3DJY on 20200104

module jt10_decode

  type :: jt10_decoder
     procedure(jt10_decode_callback), pointer :: callback
   contains
     procedure :: decode
  end type jt10_decoder

  abstract interface
     subroutine jt10_decode_callback (this, utc, snr, dt, freq, decoded, servis9)
       import jt10_decoder
       implicit none
       class(jt10_decoder), intent(inout) :: this
       integer, intent(in) :: utc
       integer, intent(in) :: snr
       real, intent(in) :: dt
       real, intent(in) :: freq
       character(len=26), intent(in) :: decoded
       character(len=1), intent(in) ::  servis9
     end subroutine jt10_decode_callback
  end interface

contains

  subroutine decode(this,callback,nutc,nfqso,newdatin,npts8,nfa,nfb,ntol,nzhsym,nagain,nagainfil, &
             ntrials10,ntrialsrxf10,filter,swl,agcc,hint,stophint,nlasttx,mycall12,hiscall12,hisgrid6)
    use timer_module, only: timer
!    use jt9_mod2
!!use wavhdr
!!use jt65_mod6
    class(jt10_decoder), intent(inout) :: this
    procedure(jt10_decode_callback) :: callback
    integer, parameter :: NSMAX10=11520, MAXCANDRXF=5, MAXCAND=200
!!type(hdr) h
!!integer*2 idd(1:648000)
    character(len=12), intent(in) :: mycall12, hiscall12
    character(len=6), intent(in) :: hisgrid6
    integer, intent(in) :: nlasttx
    logical, intent(in) :: newdatin,nagain
    logical(1), intent(in) :: nagainfil,filter,swl,agcc,hint,stophint
    logical newdat
    real s3(0:7,69)
    logical done(NSMAX10)
    integer*1 i1SoftSymbols(207)
    integer*4 i4Decoded6BitWords(12),i4GrayCodedSym(69)
    integer mrs(69),mrs2(69)
    character msg26*26,msg*22,servis9*1,mycall*6,hiscall*6,hisgrid*4,chint*1,hiscallrxf*6
    integer ncand0
    logical(1) freemsg,dupe,agcclast,rxfreq,hintdec,dofano,tryhint
    type accepted_decode
       integer i
       character*22 decoded
    end type accepted_decode
    type(accepted_decode) dec(200)
    type rxfreq_decode
       real freq
       real xdt
       character*22 msg
    end type rxfreq_decode
    type(rxfreq_decode) rxfdec(1)
    type candrxf
       real ccfred
       integer i
    end type candrxf
    type(candrxf) carxf(MAXCANDRXF)
    type candidate
       real ccfred
       integer i
    end type candidate
    type(candidate) ca(MAXCAND)
    save ncand0,agcclast,rxfdec

    this%callback => callback
    ndecoded=0; noff=3; chint=' '
    nsps=6912                                   !Params for JT9-1
    df3=12000.0/27648.0 ! 0.434027(7) Hz frequency bin width
    dec%i=-1; dec%decoded=''
    dupe=.false.; rxfreq=.false.; tryhint=.false.
    ntol1=ntol !supress compiler warning
    newdat=newdatin
    mycall=mycall12(1:6); hiscall=hiscall12(1:6); hisgrid=hisgrid6(1:4); hiscallrxf=''

    if(filter) then; nfa=max(1,nfqso-80); nfb=min(4945,nfqso+80); endif
    if(nagain .or. nagainfil) then; nfa=max(1,nfqso-20); nfb=min(4945,nfqso+20); endif
    ia=max(1,nint(nfa/df3))
    ib=min(NSMAX10,nint(nfb/df3))
    irxf=nint(nfqso/df3)+1

    th_wide=2.6; th_rxf=2.0; th_agn=2.0
    if(nagain .or. nagainfil) then; th_wide=th_agn; th_rxf=th_agn; newdat=.false.; endif
    if((nagain .or. nagainfil) .and. agcc.neqv.agcclast) newdat=.true.
    agcclast=agcc

    nsps8=nsps/8
!    df8=1500.0/nsps8 ! 1.73611116
    dblim=db(864.0/nsps8) - 26.2

!    fac=ntrials10**2
    facrxf=ntrialsrxf10**2
!print *,'ncand0',ncand0; ncount=0

 do ipass=1,2
    done=.false.
    call cpu_time(t1)
!    call timer('sync9   ',0)
    call sync10(nzhsym,ia,ib,irxf,th_wide,th_rxf,ncand0,newdat,carxf,ca)
!    call timer('sync9   ',1)

!    limit=100000*fac ! max limit is 20648000

    if(.not.nagainfil) then ! RX frequency candidate list decoding
       limit=300000*facrxf
       if(nagain) limit=1000000*ntrialsrxf10
       if(swl) limit=2*limit
       limitr=limit/4

       do icand=1,maxcandrxf
!print *,carxf(icand)%i,carxf(icand)%ccfred
          if(carxf(icand)%i.lt.0) cycle
          dofano=.true.
          fpk=(carxf(icand)%i-1)*df3
          if(ncand0.gt.199 .and. icand.gt.2) limit=limitr
!print *,fpk,carxf(icand)%ccfred
!print *,fpk
          tryhint=.false.
!          call timer('softsym ',0)
          call softsym10(npts8,nsps8,newdat,fpk,syncpk,snrdb,xdt,    &
               freq,drift,schk,i1SoftSymbols,qualf,syncro,mrs,mrs2,s3,tryhint,xdtrxf)
!          call timer('softsym ',1)
          sync=(syncpk+1)/4.0
!print *,freq,syncpk,schk
!print *,freq,syncro
!print *,schk,qualf
!print *,sync
!          if(sync.lt.0.5 .or. schk.lt.1.0) cycle
          if(sync.lt.0.5 .or. schk.lt.2.0 .or. qualf.lt.2.4) dofano=.false.
          rxfreq=.false.
          if(abs(freq-real(nfqso)).lt.2.0 .and. xdt.gt.-0.5 .and. xdt.lt.1.5) rxfreq=.true.
!!!          if(syncro.lt.0.2 .or. syncro.gt.5.) cycle
          freemsg=.false.; servis9=' '
!          call timer('jt9fano ',0)
          call decode10(i1SoftSymbols,limit,msg,freemsg,i4Decoded6BitWords,mrs,mrs2,hint, &
               stophint,nlasttx,mycall,hiscall,hisgrid,rxfreq,s3,i4GrayCodedSym,hintdec, &
               chint,dofano,snrdb,tryhint)
!          call timer('jt9fano ',1)
          if(freemsg) servis9=','; if(hintdec) servis9=chint
          if(sync.lt.0.0 .or. snrdb.lt.dblim-2.0) sync=0.0
          nsync=int(sync)
          if(nsync.gt.10) nsync=10
          nsnr=nint(snrdb)
          ndrift=nint(drift/df3)

          if(msg.ne.'                      ') then
             dupe=.false.
             if(ndecoded.ne.0) then
                if(.not.hintdec) then
                   do k=1,200
                      if(dec(k)%i.eq.-1) exit
                      if(dec(k)%decoded.eq.msg .and. abs(dec(k)%i-carxf(icand)%i).lt.104) dupe=.true. ! 104 lt 45Hz
                   enddo
                else
                  do k=1,200
                     if(dec(k)%i.eq.-1) exit
                     if(dec(k)%decoded(1:10).eq.msg(1:10) .and. abs(dec(k)%i-carxf(icand)%i).lt.104) dupe=.true. !45Hz
                  enddo
                endif
             endif

             if(dupe) then
                done((irxf-1):(irxf+1))=.true.
                cycle
             endif
             if (associated(this%callback)) then
                msg26=msg//'    '
                call this%callback(nutc,nsnr,xdt,freq,msg26,servis9)
             endif

             ndecoded=ndecoded+1
!print *, carxf(icand)%i, carxf(icand)%ccfred
             if(nsnr.ge.15) noff=6; if(nsnr.le.14 .and. nsnr.ge.-5) noff=5
             if(nsnr.le.-6 .and. nsnr.ge.-10) noff=4
             if(nsnr.le.-11 .and. nsnr.ge.-16) noff=3; if(nsnr.le.-17 .and. nsnr.ge.-19) noff=2
             if(nsnr.eq.-20) noff=1; if(nsnr.le.-21) noff=0
             done((irxf-noff):(irxf+noff))=.true.
             dec(ndecoded)%i=carxf(icand)%i
             dec(ndecoded)%decoded=msg
             if(.not.freemsg .and. abs(freq-real(nfqso)).lt.2.0 .and. msg(1:4).eq.mycall(1:4)) then
                rxfdec(1)%msg=msg
                rxfdec(1)%xdt=xdt
                rxfdec(1)%freq=freq
             endif
             if(ipass.ne.2) call subtract10(i4Decoded6BitWords,freq,drift,xdt,i4GrayCodedSym,hintdec)
             exit
          else
             done(irxf)=.true.
          endif
          if(icand.gt.1) rxfreq=.false.
       enddo
    endif

    if(hint) then ! try to decode exact RX frequency with Hint
       rxfreq=.false.; dofano=.false.; fpk=real(nfqso)

       tryhint=.false.
       if(ipass.eq.2) then
          if(abs(real(nfqso)-rxfdec(1)%freq).lt.2.0 .and. len_trim(hiscall).gt.2) then
             i1=index(rxfdec(1)%msg,' ')
             i2=index(rxfdec(1)%msg((i1+1):),' ')
             if(i1.lt.8 .and. i2.lt.15) hiscallrxf=rxfdec(1)%msg((i1+1):(i1+i2-1))
             if(hiscall.eq.hiscallrxf .and. len_trim(hiscallrxf).ne.0) then
                fpk=rxfdec(1)%freq
                xdtrxf=rxfdec(1)%xdt
                if(xdtrxf.gt.-2.5 .and. xdtrxf.lt.5.0) tryhint=.true.
             endif
          endif
       endif

!          call timer('softsym ',0)
       call softsym10(npts8,nsps8,newdat,fpk,syncpk,snrdb,xdt,    &
            freq,drift,schk,i1SoftSymbols,qualf,syncro,mrs,mrs2,s3,tryhint,xdtrxf)
!          call timer('softsym ',1)
       sync=(syncpk+1)/4.0
!          if(syncro.lt.0.2 .or. syncro.gt.5.) cycle
       freemsg=.false.; servis9=' '
       if(xdt.gt.-0.5 .and. xdt.lt.1.5) rxfreq=.true.
       call decode10(i1SoftSymbols,limit,msg,freemsg,i4Decoded6BitWords,mrs,mrs2,hint, &
            stophint,nlasttx,mycall,hiscall,hisgrid,rxfreq,s3,i4GrayCodedSym,hintdec, &
            chint,dofano,snrdb,tryhint)
       if(freemsg) servis9=','; if(hintdec) servis9=chint
       if(sync.lt.0.0 .or. snrdb.lt.dblim-2.0) sync=0.0
       nsync=int(sync)
       if(nsync.gt.10) nsync=10
       nsnr=nint(snrdb)
       ndrift=nint(drift/df3)

       if(msg.ne.'                      ') then
          dupe=.false.
          if(ndecoded.ne.0) then
             do k=1,200
                if(dec(k)%i.eq.-1) exit
                if(dec(k)%decoded(1:10).eq.msg(1:10) .and. abs(dec(k)%i-irxf).lt.104) dupe=.true. !45Hz
             enddo
          endif
          if(dupe) done(irxf)=.true.
          if(.not.dupe) then
             if(associated(this%callback)) then
                msg26=msg//'    '
                call this%callback(nutc,nsnr,xdt,freq,msg26,servis9)
             endif

             ndecoded=ndecoded+1
!print *, carxf(icand)%i, carxf(icand)%ccfred
             if(nsnr.ge.15) noff=6; if(nsnr.le.14 .and. nsnr.ge.-5) noff=5
             if(nsnr.le.-6 .and. nsnr.ge.-10) noff=4
             if(nsnr.le.-11 .and. nsnr.ge.-16) noff=3; if(nsnr.le.-17 .and. nsnr.ge.-19) noff=2
             if(nsnr.eq.-20) noff=1; if(nsnr.le.-21) noff=0
             done((irxf-noff):(irxf+noff))=.true.
             dec(ndecoded)%i=irxf
             dec(ndecoded)%decoded=msg
             if(ipass.eq.1) then
                if(.not.freemsg .and. abs(freq-real(nfqso)).lt.2.0 .and. msg(1:4).eq.mycall(1:4)) then
                   rxfdec(1)%msg=msg
                   rxfdec(1)%xdt=xdt
                   rxfdec(1)%freq=freq
                endif
             endif
          endif
          call subtract10(i4Decoded6BitWords,freq,drift,xdt,i4GrayCodedSym,hintdec)
       endif
    endif
!goto 256 ! diag only
    ncurcand=0

    if(.not.nagain) then ! wideband candidate list decoding
       limit=200000*ntrials10
       if(nagainfil) limit=500000*facrxf
       if(swl) limit=2*limit
       limitr=limit/4
       rxfreq=.false.

       do icand=1,maxcand
!print *,ca(icand)%i,ca(icand)%ccfred
!print *, ca(icand)%i,'B'
          if(ca(icand)%i.lt.0) cycle; if(done(ca(icand)%i)) cycle
!print *, ca(icand)%i,'A'
          if(nagainfil .and. icand.gt.10) exit
!print *,done(ca(icand)%i),ccfok(ca(icand)%i)
          dofano=.true.
          ncurcand=ncurcand+1
          fpk=(ca(icand)%i-1)*df3
!print *,fpk
          if((.not.nagainfil .and. ncand0.gt.199 .and. ncurcand.gt.10) .or. ncurcand.gt.15) limit=limitr
!ncount=ncount+1; print *,ncount
          tryhint=.false.
!          call timer('softsym ',0)
          call softsym10(npts8,nsps8,newdat,fpk,syncpk,snrdb,xdt,    &
               freq,drift,schk,i1SoftSymbols,qualf,syncro,mrs,mrs2,s3,tryhint,xdtrxf)
!          call timer('softsym ',1)
          sync=(syncpk+1)/4.0
!print *,freq,syncpk,schk
!print *,freq,sync
!print *,syncro
!          if(sync.lt.1.0 .or. schk.lt.1.5) cycle
          if(sync.lt.1.0 .or. schk.lt.2.0 .or. qualf.lt.2.4) then
             if(ncurcand.gt.0) ncurcand=ncurcand-1
             dofano=.false.
          endif
          if(syncro.lt.0.2 .or. syncro.gt.5.) then
             if(ncurcand.gt.0) ncurcand=ncurcand-1
             cycle
          endif
!print *,qualf,syncro
          freemsg=.false.; servis9=' '
!          call timer('jt9fano ',0)
          call decode10(i1SoftSymbols,limit,msg,freemsg,i4Decoded6BitWords,mrs,mrs2,hint, &
               stophint,nlasttx,mycall,hiscall,hisgrid,rxfreq,s3,i4GrayCodedSym,hintdec, &
               chint,dofano,snrdb,tryhint)
!          call timer('jt9fano ',1)
          if(abs(fpk-float(nfqso)).lt.3.0 .and. freemsg) servis9=',' ! keep it for hide freemsg filter
          if(abs(fpk-float(nfqso)).ge.3.0 .and. freemsg) servis9='.'
          if(hintdec) servis9=chint

          if(sync.lt.0.0 .or. snrdb.lt.dblim-2.0) sync=0.0
          nsync=int(sync)
          if(nsync.gt.10) nsync=10
          nsnr=nint(snrdb)
          ndrift=nint(drift/df3)

          if(msg.ne.'                      ') then
             dupe=.false.
             if(ndecoded.ne.0) then
                do k=1,200
                   if(dec(k)%i.eq.-1) exit
                   if(dec(k)%decoded.eq.msg .and. abs(dec(k)%i-ca(icand)%i).lt.104) dupe=.true. ! 104 lt 45Hz
                enddo
             endif
!!print *, freq, ca(icand)%i
!!print *, msg, ca(icand)%ccfred
!print *, ca(icand)%i, ca(icand)%ccfred
             if(dupe) then
                iaa=max(1,ca(icand)%i-2)
                ibb=min(NSMAX10,ca(icand)%i+2)
                done(iaa:ibb)=.true.
                cycle
             endif
             if(associated(this%callback)) then
                msg26=msg//'    '
                call this%callback(nutc,nsnr,xdt,freq,msg26,servis9)
             end if
             ndecoded=ndecoded+1
!print *,schk,qualf
             if(nsnr.ge.15) noff=6; if(nsnr.le.14 .and. nsnr.ge.-5) noff=5
             if(nsnr.le.-6 .and. nsnr.ge.-10) noff=4
             if(nsnr.le.-11 .and. nsnr.ge.-16) noff=3; if(nsnr.le.-17 .and. nsnr.ge.-19) noff=2
             if(nsnr.eq.-20) noff=1; if(nsnr.le.-21) noff=0
             iaa=max(1,ca(icand)%i-noff)
             ibb=min(NSMAX10,ca(icand)%i+noff)
             done(iaa:ibb)=.true.
             dec(ndecoded)%i=ca(icand)%i
             dec(ndecoded)%decoded=msg
             if(ipass.ne.2) call subtract10(i4Decoded6BitWords,freq,drift,xdt,i4GrayCodedSym,hintdec)
          endif
          call cpu_time(t2)
          if(.not.swl .and. (t2-t1).gt.5.0) exit
          if(swl .and. (t2-t1).gt.10.0) exit
       enddo
    endif
!256 continue ! diag only
    if(ipass.eq.1) newdat=.true.
 enddo

!!h=default_header(12000,648000)
!!idd(1:624000)=nint(dd(1:624000))
!!idd(624001:)=0
!!open(10,file='out.wav',access='stream',status='unknown')
!!write(10) h,idd(1:648000)
!!close(10)

    return
  end subroutine decode
end module jt10_decode

! This source code file was last time modified by Igor Chernikov UA3DJY on December 12th, 2016.
! All changes are shown in the patch file coming together with the full JTDX source code.

subroutine filterscq(decoded,falsedec)
  
  character decoded*22
  logical(1) falsedec

! check for false "CQ " decodes

  if(len_trim(decoded).gt.18) then
     if((decoded(1:3).eq."CQ " .or. decoded(1:3).eq."DE ") .and. decoded(8:8).eq."/" .and. &
     decoded(4:7).ne."3DA0") go to 2
  endif

  if(len_trim(decoded).gt.19) then
     if(decoded(1:4).eq."QRZ " .and. decoded(9:9).eq."/" .and. decoded(5:8).ne."3DA0") go to 2
  endif

  go to 4

2 falsedec=.true.; return

4 return
end subroutine filterscq

! This source code file is last time mofified by Igor UA3DJY on March 10th, 2017 
! All changes are shown in the patch file coming together with the full JTDX source code.

module jt65_mod4

  logical(1) :: prc(126)=(/                                                     &
    .TRUE.,.FALSE.,.FALSE.,.TRUE.,.TRUE.,.FALSE.,.FALSE.,.FALSE.,.TRUE.,.TRUE., &
    .TRUE.,.TRUE.,.TRUE.,.TRUE.,.FALSE.,.TRUE.,.FALSE.,.TRUE.,.FALSE.,.FALSE.,  &
    .FALSE.,.TRUE.,.FALSE.,.TRUE.,.TRUE.,.FALSE.,.FALSE.,.TRUE.,.FALSE.,.FALSE.,&
    .FALSE.,.TRUE.,.TRUE.,.TRUE.,.FALSE.,.FALSE.,.TRUE.,.TRUE.,.TRUE.,.TRUE.,   &
    .FALSE.,.TRUE.,.TRUE.,.FALSE.,.TRUE.,.TRUE.,.TRUE.,.TRUE.,.FALSE.,.FALSE.,  &
    .FALSE.,.TRUE.,.TRUE.,.FALSE.,.TRUE.,.FALSE.,.TRUE.,.FALSE.,.TRUE.,.TRUE.,  &
    .FALSE.,.FALSE.,.TRUE.,.TRUE.,.FALSE.,.TRUE.,.FALSE.,.TRUE.,.FALSE.,.TRUE., &
    .FALSE.,.FALSE.,.TRUE.,.FALSE.,.FALSE.,.FALSE.,.FALSE.,.FALSE.,.FALSE.,.TRUE.,&
    .TRUE.,.FALSE.,.FALSE.,.FALSE.,.FALSE.,.FALSE.,.FALSE.,.FALSE.,.TRUE.,.TRUE.,&
    .FALSE.,.TRUE.,.FALSE.,.FALSE.,.TRUE.,.FALSE.,.TRUE.,.TRUE.,.FALSE.,.TRUE., &
    .FALSE.,.TRUE.,.FALSE.,.TRUE.,.FALSE.,.FALSE.,.TRUE.,.TRUE.,.FALSE.,.FALSE.,&
    .TRUE.,.FALSE.,.FALSE.,.TRUE.,.FALSE.,.FALSE.,.FALSE.,.FALSE.,.TRUE.,.TRUE.,&
    .TRUE.,.TRUE.,.TRUE.,.TRUE.,.TRUE.,.TRUE./)

end module jt65_mod4

subroutine grayline(nyear,month,nday,uth,mygrid,nduration,isun)

  character*8 mygrid
  real LST
  real lat,lon

  call grid2deg(MyGrid,elon,lat)
  lon=-elon

  uth0=uth-0.5*nduration/60.0
  uth1=uth+0.5*nduration/60.0

  call sun(nyear,month,nday,uth0,lon,lat,RASun,DecSun,LST,        &
       AzSun,ElSun0,mjd,day)
  call sun(nyear,month,nday,uth1,lon,lat,RASun,DecSun,LST,        &
       AzSun,ElSun1,mjd,day)

  elchk=-0.8333
  isun=-1
  if(elsun0.lt.elchk .and. elsun1.ge.elchk) then
     isun=0
  else if(elsun0.gt.elchk .and. elsun1.le.elchk) then
     isun=2
  else if(elsun1.gt.elchk) then
     isun=1
  else
     isun=3
  endif

  return
end subroutine grayline

subroutine ft8sd(s8,srr,itone,msgd,msg37,lft8sd,lcq)

  use ft8_mod1, only : mycall
  real, intent(in) :: s8(0:7,79)
  real s8_1(0:7,79)
  character msgd*37,msg37*37,msg372*37,msgsent37*37,c1*12,c2*12
  character*37 msg4(4)
  integer idtone4(4,58),itone4(4,79)
  integer itone(79),itonedem(58),idtone(58),ip1(1)
  integer*1 msgbits(77)
  logical(1), intent(in) :: lcq
  logical(1) lft8sd,lmatched(58)

  if(index(msgd,' RR73').gt.0 .or. index(msgd,' 73').gt.0) return ! do not process 73 messages
! do not process messages with grid
  if(.not.(msgd(1:3).eq.'CQ ' .or. index(msgd,'-').gt.0 .or. index(msgd,'+').gt.0 .or. index(msgd,' RRR').gt.0)) return

  lmatched=.false.; s8_1=s8; itonedem=11

  if(.not.lcq) then
    c1='            '; c2='            '
    ispc1=index(msgd,' '); ispc2=index(msgd((ispc1+1):),' ')+ispc1
    if(len(msgd(1:ispc1-1)).le.12 .and. len(msgd(ispc1+1:ispc2-1)).le.12) then
      c1=msgd(1:ispc1-1); c2=msgd(ispc1+1:ispc2-1)
    else
      return
    endif
    if(len_trim(c1).lt.3 .or. len_trim(c2).lt.3 .or. c2.eq.trim(mycall)) return
    do i=1,4
      msg4(i)='                                     '
      if(i.eq.1) msg4(i)=msgd
      if(i.eq.2) msg4(i)=trim(c1)//' '//trim(c2)//' RRR'
      if(i.eq.3) msg4(i)=trim(c1)//' '//trim(c2)//' RR73'
      if(i.eq.4) msg4(i)=trim(c1)//' '//trim(c2)//' 73'
    enddo
  endif

  if(lcq) then
    i3=-1; n3=-1
    msg372=msgd
    call genft8sd(msg372,i3,n3,msgsent37,msgbits,itone)
    idtone(1:29)=itone(8:36)
    idtone(30:58)=itone(44:72)
  else
    do i=1,4
      msg372=msg4(i)
      i3=-1; n3=-1
      call genft8sd(msg372,i3,n3,msgsent37,msgbits,itone)
      idtone4(i,1:29)=itone(8:36)
      idtone4(i,30:58)=itone(44:72)
      itone4(i,1:79)=itone(1:79)
    enddo
  endif

  do i=1,58
    if(i.le.29) then; ip1=maxloc(s8_1(:,i+7))-1; itonedem(i)=ip1(1); s8_1(ip1(1),i+7)=0.0
    else; ip1=maxloc(s8_1(:,i+14))-1; itonedem(i)=ip1(1); s8_1(ip1(1),i+14)=0.0; endif
  enddo

  imax=0
  if(lcq) then
    nmatch1=0; ncrcpaty1=0
    do k=1,58
      if(idtone(k).eq.itonedem(k)) then; nmatch1=nmatch1+1; lmatched(k)=.true.; if(k.gt.25) ncrcpaty1=ncrcpaty1+1; endif
    enddo
    if(nmatch1.gt.26) then; lft8sd=.true.; msg37=msgd; return; endif
  else
    nmatchditer1=0; nbaseiter1=0; ncrcpatyiter1=0;
    do i=1,4
      nmatch1=0; nbase1=0; ncrcpaty1=0
      do k=1,58
        if(idtone4(i,k).eq.itonedem(k)) then
          nmatch1=nmatch1+1; if(k.lt.23) nbase1=nbase1+1; if(k.gt.25) ncrcpaty1=ncrcpaty1+1 ! CRC+parity
        endif
      enddo
      if(nmatch1.gt.nmatchditer1) then
        imax=i; nmatchditer1=nmatch1; nbaseiter1=nbase1; ncrcpatyiter1=ncrcpaty1
      endif
    enddo
    if(imax.eq.0) return
    if(srr.gt.3.0 .and. nbaseiter1.lt.12) return ! prevent false decodes from the strong signals
    nmatch1=nmatchditer1; ncrcpaty1=ncrcpatyiter1!; nbase1=nbaseiter1
    idtone(1:58)=idtone4(imax,1:58)
    if(nmatch1.gt.26 .and. ncrcpaty1.gt.10) then
      lft8sd=.true.; msg37=msg4(imax); itone(1:79)=itone4(imax,1:79); return
    endif
    do k=1,58
      if(idtone(k).eq.itonedem(k)) lmatched(k)=.true. 
    enddo
  endif

  if(nmatch1.ge.16) then
    do i=1,58
      if(lmatched(i)) cycle
      if(i.le.29) then; ip1=maxloc(s8_1(:,i+7))-1; itonedem(i)=ip1(1); s8_1(ip1(1),i+7)=0.0
      else; ip1=maxloc(s8_1(:,i+14))-1; itonedem(i)=ip1(1); s8_1(ip1(1),i+14)=0.0; endif
    enddo
    nmatch2=nmatch1; ncrcpaty2=ncrcpaty1
    do k=1,58
      if(lmatched(k)) cycle
      if(idtone(k).eq.itonedem(k)) then; nmatch2=nmatch2+1; lmatched(k)=.true.; if(k.gt.25) ncrcpaty2=ncrcpaty2+1; endif
    enddo
    if(nmatch2.gt.38 .and. ncrcpaty2.gt.19) then
      lft8sd=.true.
      if(lcq) then; msg37=msgd; else; msg37=msg4(imax); itone(1:79)=itone4(imax,1:79); endif
      return
    endif

    do i=1,58
      if(lmatched(i)) cycle
      if(i.le.29) then; ip1=maxloc(s8_1(:,i+7))-1; itonedem(i)=ip1(1); s8_1(ip1(1),i+7)=0.0
      else; ip1=maxloc(s8_1(:,i+14))-1; itonedem(i)=ip1(1); s8_1(ip1(1),i+14)=0.0; endif
    enddo
    nmatch3=nmatch2; ncrcpaty3=ncrcpaty2
    do k=1,58
      if(lmatched(k)) cycle
      if(idtone(k).eq.itonedem(k)) then; nmatch3=nmatch3+1; lmatched(k)=.true.; if(k.gt.25) ncrcpaty3=ncrcpaty3+1; endif
    enddo
    if(nmatch3.gt.44 .and. ncrcpaty3.gt.21) then
      lft8sd=.true.
      if(lcq) then; msg37=msgd; else; msg37=msg4(imax); itone(1:79)=itone4(imax,1:79); endif
      return
    endif

    do i=1,58
      if(lmatched(i)) cycle
      if(i.le.29) then; ip1=maxloc(s8_1(:,i+7))-1; itonedem(i)=ip1(1); s8_1(ip1(1),i+7)=0.0
      else; ip1=maxloc(s8_1(:,i+14))-1; itonedem(i)=ip1(1); s8_1(ip1(1),i+14)=0.0; endif
    enddo
    nmatch4=nmatch3; ncrcpaty4=ncrcpaty3
    do k=1,58
      if(lmatched(k)) cycle
      if(idtone(k).eq.itonedem(k)) then; nmatch4=nmatch4+1; lmatched(k)=.true.; if(k.gt.25) ncrcpaty4=ncrcpaty4+1; endif
    enddo
    if(nmatch4.gt.47 .and. ncrcpaty4.gt.23) then
      lft8sd=.true.
      if(lcq) then; msg37=msgd; else; msg37=msg4(imax); itone(1:79)=itone4(imax,1:79); endif
      return
    endif

    do i=1,58
      if(lmatched(i)) cycle
      if(i.le.29) then; ip1=maxloc(s8_1(:,i+7))-1; itonedem(i)=ip1(1); s8_1(ip1(1),i+7)=0.0
      else; ip1=maxloc(s8_1(:,i+14))-1; itonedem(i)=ip1(1); s8_1(ip1(1),i+14)=0.0; endif
    enddo
    nmatch5=nmatch4; ncrcpaty5=ncrcpaty4
    do k=1,58
      if(lmatched(k)) cycle
      if(idtone(k).eq.itonedem(k)) then; nmatch5=nmatch5+1; lmatched(k)=.true.; if(k.gt.25) ncrcpaty5=ncrcpaty5+1; endif
    enddo
    if(nmatch5.gt.50 .and. (nmatch1.gt.21 .or. nmatch2.gt.31 .or. nmatch3.gt.38 .or. nmatch4.gt.46) .and. &
       ncrcpaty5.gt.25) then
      lft8sd=.true.
      if(lcq) then; msg37=msgd; else; msg37=msg4(imax); itone(1:79)=itone4(imax,1:79); endif
      return
    endif

    do i=1,58
      if(lmatched(i)) cycle
      if(i.le.29) then; ip1=maxloc(s8_1(:,i+7))-1; itonedem(i)=ip1(1); s8_1(ip1(1),i+7)=0.0
      else; ip1=maxloc(s8_1(:,i+14))-1; itonedem(i)=ip1(1); s8_1(ip1(1),i+14)=0.0; endif
    enddo
    nmatch6=nmatch5; ncrcpaty6=ncrcpaty5
    do k=1,58
      if(lmatched(k)) cycle
      if(idtone(k).eq.itonedem(k)) then; nmatch6=nmatch6+1; lmatched(k)=.true.; if(k.gt.25) ncrcpaty6=ncrcpaty6+1; endif
    enddo
    if(nmatch6.gt.54 .and. (nmatch1.gt.22 .or. nmatch2.gt.27 .or. nmatch3.gt.35 .or. &
       (nmatch2-nmatch1).gt.9 .or. (nmatch3-nmatch2).gt.10) .and. ncrcpaty6.gt.29) then
      lft8sd=.true.
      if(lcq) then; msg37=msgd; else; msg37=msg4(imax); itone(1:79)=itone4(imax,1:79); endif
      return
    endif

  endif

  return
end subroutine ft8sd

! This source code file was last time modified by Igor Chernikov UA3DJY on July 11th, 2016.
! All changes are shown in the patch file coming together with the full JTDX source code.

subroutine flat65(ss,ref)

  integer, parameter :: NSZ=3413,NHSYM=276
  real stmp(NSZ)
  real ss(NHSYM,NSZ)
  real ref(NSZ)

  npct=28                                       !Somewhat arbitrary
  do i=1,NSZ
     call pctile(ss(1,i),nhsym,npct,stmp(i))
  enddo

  nsmo=33
  ia=nsmo/2 + 1
  ib=NSZ - nsmo/2 - 1
  do i=ia,ib
     call pctile(stmp(i-nsmo/2),nsmo,npct,ref(i))
  enddo
  ref(:ia-1)=ref(ia)
  ref(ib+1:)=ref(ib)
  ref=4.0*ref

  return
end subroutine flat65

      

! This source code file was last time modified by Igor UA3DJY on 20181215
! All changes are shown in the patch file coming together with the full JTDX source code.

subroutine genft8refsig(itone,cref,f0)

  use ft8_mod1, only :twopi,dt
  complex cref(151680) !NFRAME=1920*79
  integer itone(79)
!  real*8 twopi,phi,dphi,dt,xnsps
  real phi,dphi,xnsps,dtf0

  xnsps=1920.d0
  phi=0.d0
  k=1
  dtf0=f0*dt
  do i=1,79
    dphi=twopi*(dtf0+itone(i)/xnsps)
    do is=1,1920
      cref(k)=cmplx(cos(phi),sin(phi))
      phi=mod(phi+dphi,twopi)
      k=k+1
    enddo
  enddo
  return
end subroutine genft8refsig

! This source code file was last time modified by Igor UA3DJY on 20181215
! All changes are shown in the patch file coming together with the full JTDX source code.

program jt65sim

! Generate simulated JT65 data for testing WSJT-X

  use wavhdr
  use packjt
  use options
  use jt65_mod4
  parameter (NMAX=54*12000)              ! = 648,000
  parameter (NFFT=10*65536,NH=NFFT/2)
  parameter (MAXCALLS=35000,MAXRPT=60)  ! 34999 calls in CALL3.TXT
  type(hdr) h                            !Header for .wav file
  integer*2 iwave(NMAX)                  !Generated waveform
  integer*4 itone(126)                   !Channel symbols (values 0-65)
  integer dgen(12)                       !Twelve 6-bit data symbols
  integer sent(63)                       !RS(63,12) codeword
  real*4 xnoise(NMAX)                    !Generated random noise
  real*4 dat(NMAX)                       !Generated real data
  complex cdat(NMAX)                     !Generated complex waveform
  complex cspread(0:NFFT-1)              !Complex amplitude for Rayleigh fading
  complex z
  real*8 f0,dt,twopi,phi,dphi,baud,fsample,freq,sps
  character*6 callc3(MAXCALLS)
  character*4 gridc3(MAXCALLS)
  character msg*22,fname*11,csubmode*1,call1*6,call2*6,c,optarg*500,numbuf*32
  character line*180,callsign*12,grid*4,grid2*4,rest*4
  logical :: display_help=.false.,seed_prngs=.true.
  type (option) :: long_options(5) = [ &
    option ('help',.false.,'h','Display this help message',''),                                &
    option ('time-offset',.true.,'t','Mean Time delta value, Gaussian distribution, default SECONDS=0.0','SECONDS'),&
    option ('num-files',.true.,'f','Number of files to generate, default FILES=1','FILES'),    &
    option ('no-prng-seed',.false.,'p','Do not seed PRNGs (use for reproducible tests)',''),   &
    option ('nsignals',.true.,'n','number of signals in file, default =1','') ]
  
  character*4 rpt(MAXRPT),r73(3)
  data rpt/ '-01','-02','-03','-04','-05',         &
           '-06','-07','-08','-09','-10',          &
           '-11','-12','-13','-14','-15',          &
           '-16','-17','-18','-19','-20',          &
           '-21','-22','-23','-24','-25',          &
           '-26','-27','-28','-29','-30',          &
           'R-01','R-02','R-03','R-04','R-05',     &
           'R-06','R-07','R-08','R-09','R-10',     &
           'R-11','R-12','R-13','R-14','R-15',     &
           'R-16','R-17','R-18','R-19','R-20',     &
           'R-21','R-22','R-23','R-24','R-25',     &
           'R-26','R-27','R-28','R-29','R-30'/     
  data r73/'RRR','73','RR73'/
  
! Default parameters:
  csubmode='A'
  mode65=1
  nsigs=1
  fspread=0.
  ncross=0.
  xdt=0.
  snrdb=0.
  nfiles=1

  do
     call getopt('h:t:f:pn:',long_options,c,optarg,narglen,nstat,noffset,nremain,.true.)
     if( nstat .ne. 0 ) then
        exit
     end if
     select case (c)
     case ('h')
        display_help = .true.
     case ('c')
        read (optarg(:narglen), *,err=10) ncross
     case ('t')
        read (optarg(:narglen), *) numbuf
        if (numbuf(1:1) == '\') then
           read (numbuf(2:), *,err=10) xdt
        else
           read (numbuf, *,err=10) xdt
        end if
     case ('f')
        read (optarg(:narglen), *,err=10) nfiles
     case ('p')
        seed_prngs=.false.
     case ('n')
        read (optarg(:narglen), *,err=10) nsigs
     end select
     cycle
10   display_help=.true.
     print *, 'Optional argument format error for option -', c
  end do

  if(display_help .or. nstat.lt.0 .or. nremain.ge.1) then
     print *, ''
     print *, 'Usage: jt65sim [OPTIONS]'
     print *, ''
     print *, '       Generate one or more simulated JT65 signals in .WAV file(s)'
     print *, ''
     print *, 'Example: jt65sim -m B -n 10 -d 0.2 -t 0.0 -f 4'
     print *, ''
     print *, 'OPTIONS: NB Use \ (\\ on *nix shells) to escape -ve arguments'
     print *, ''
     do i = 1, size (long_options)
       call long_options(i) % print (6)
     end do
     go to 999
  endif

  if (seed_prngs) then
     call init_random_seed()    ! seed Fortran RANDOM_NUMBER generator
     call sgran()               ! see C rand generator (used in gran)
  end if

     open(23,file='CALL3.TXT',status='unknown')
     icall=0
     j=0
     do i=1,MAXCALLS
        read(23,1001,end=20) line
1001    format(a80)
        if(line(1:4).eq.'ZZZZ') exit
        if(line(1:2).eq.'//') cycle
        i1=index(line,',')
        if(i1.lt.4) cycle
        i2=index(line(i1+1:),',')
        if(i2.lt.5) cycle
        i2=i2+i1
        callsign=line(1:i1-1)
        grid=line(i1+1:i2-1)
        j=j+1
        callc3(j)=callsign(1:6)               !### Fix for compound callsigns!
        gridc3(j)=grid
     enddo
20   ncalls=j
     close(23)

  rms=100.
  fsample=12000.d0                   !Sample rate (Hz)
  dt=1.d0/fsample                    !Sample interval (s)
  twopi=8.d0*atan(1.d0)
  npts=54*12000                      !Total samples in .wav file
  baud=11025.d0/4096.d0              !Keying rate
  sps=12000.d0/baud                  !Samples per symbol, at fsample=12000 Hz
  nsym=126                           !Number of channel symbols
  h=default_header(12000,npts)
  dfsig=2000.0/nsigs                 !Freq spacing between sigs in file (Hz)

  do ifile=1,nfiles                  !Loop over requested number of files
     write(fname,1002) ifile         !Output filename
1002 format('000000_',i4.4)
     open(10,file=fname//'.wav',access='stream',status='unknown')

     xnoise=0.
     cdat=0.
!     if(snrdb.lt.90) then
        do i=1,npts
           xnoise(i)=gran()          !Generate gaussian noise
        enddo
!     endif

     do isig=1,nsigs                        !Generate requested number of sigs
        call random_number(rr1)
!        f0=5.0+2690.0*rr1
        f0=1500.0+5.0*rr1
        xdtisig=xdt+gran()
        call random_number(rr1)
        snrdb=rr1*(-25.0)-1.0
        xsnr=snrdb
        if(snrdb.eq.0.0) xsnr=-19 - isig

     call random_number(rr1)
     np1=nint(rr1*ncalls)
     call1=callc3(np1)

     call random_number(rr1)
     np2=nint(rr1*ncalls)
     call2=callc3(np2)
     grid2=gridc3(np2)

     call random_number(rr1)
     np3=nint(rr1*(MAXRPT+60)) ! 60 is for CQ ,73 and call1 call2 grid messages
     if(np3.eq.0) rest=rpt(1)
     if(np3.gt.0 .and. np3.le.60) rest=rpt(np3)
     if(np3.gt.60 .and. np3.le.80) rest=grid2
     if(np3.gt.80 .and. np3.le.86) rest=r73(1)
     if(np3.gt.86 .and. np3.le.93) rest=r73(2)
     if(np3.gt.93 .and. np3.le.100) rest=r73(3)
     if(np3.gt.100) then
        call1='CQ'
        rest=grid2
     endif
 
     msg=trim(call1)//' '//trim(call2)//' '//trim(rest)
 
        call packmsg(msg,dgen,itype)        !Pack message into 12 six-bit bytes
        call rs_encode(dgen,sent)           !Encode using RS(63,12)
        call interleave63(sent,1)           !Interleave channel symbols
        call graycode65(sent,63,1)          !Apply Gray code

        k=0
        do j=1,nsym                         !Insert sync and data into itone()
           if(.not.prc(j)) then
              k=k+1
              itone(j)=sent(k)+2
           else
              itone(j)=0
           endif
        enddo

        bandwidth_ratio=2500.0/6000.0
        sig=sqrt(2*bandwidth_ratio)*10.0**(0.05*xsnr)
        if(xsnr.gt.90.0) sig=1.0
        write(*,1020) ifile,isig,f0,csubmode,xsnr,xdtisig,fspread,msg
1020    format(i4,i4,f10.3,2x,a1,2x,f5.1,f6.2,f5.1,1x,a22)

        phi=0.d0
        dphi=0.d0
        k=12000 + xdtisig*12000                 !Start audio at t = xdt + 1.0 s
        isym0=-99
        do i=1,npts                         !Add this signal into cdat()
           isym=floor(i/sps)+1
           if(isym.gt.nsym) exit
           if(isym.ne.isym0) then
              freq=f0 + itone(isym)*baud*mode65
              dphi=twopi*freq*dt
              isym0=isym
           endif
           phi=phi + dphi
           if(phi.gt.twopi) phi=phi-twopi
           xphi=phi
           z=cmplx(cos(xphi),sin(xphi))
           k=k+1
           if(k.ge.1) cdat(k)=cdat(k) + sig*z
        enddo
     enddo

     if(fspread.ne.0) then                  !Apply specified Doppler spread
        df=12000.0/nfft
        twopi=8*atan(1.0)
        cspread(0)=1.0
        cspread(NH)=0.

        do i=1,NH
           f=i*df
           x=f/fspread
           z=0.
           a=0.
           if(x.lt.50.0) then
              a=sqrt(exp(-x*x))
              call random_number(r1)
              phi1=twopi*r1
              z=a*cmplx(cos(phi1),sin(phi1))
           endif
           cspread(i)=z
           z=0.
           if(x.lt.50.0) then
              call random_number(r2)
              phi2=twopi*r2
              z=a*cmplx(cos(phi2),sin(phi2))
           endif
           cspread(NFFT-i)=z
        enddo

        do i=0,NFFT-1
           f=i*df
           if(i.gt.NH) f=(i-nfft)*df
           s=real(cspread(i))**2 + aimag(cspread(i))**2
!          write(13,3000) i,f,s,cspread(i)
!3000      format(i5,f10.3,3f12.6)
        enddo
!        s=real(cspread(0))**2 + aimag(cspread(0))**2
!        write(13,3000) 1024,0.0,s,cspread(0)

        call four2a(cspread,NFFT,1,1,1)             !Transform to time domain

        sum=0.
        do i=0,NFFT-1
           p=real(cspread(i))**2 + aimag(cspread(i))**2
           sum=sum+p
        enddo
        avep=sum/NFFT
        fac=sqrt(1.0/avep)
        cspread=fac*cspread                   !Normalize to constant avg power
        cdat=cspread(1:npts)*cdat             !Apply Rayleigh fading

!        do i=0,NFFT-1
!           p=real(cspread(i))**2 + aimag(cspread(i))**2
!           write(14,3010) i,p,cspread(i)
!3010       format(i8,3f12.6)
!        enddo

     endif

     dat=aimag(cdat) + xnoise                 !Add the generated noise
     fac=32767.0/nsigs
     if(snrdb.ge.90.0) iwave(1:npts)=nint(fac*dat(1:npts))
     if(snrdb.lt.90.0) iwave(1:npts)=nint(rms*dat(1:npts))
     write(10) h,iwave(1:npts)                !Save the .wav file
     close(10)
  enddo

999 end program jt65sim

module timer_module
  implicit none

  abstract interface
     subroutine timer_callback (dname, k)
       character(len=8), intent(in) :: dname
       integer, intent(in) :: k
     end subroutine timer_callback
  end interface

  public :: null_timer
  procedure(timer_callback), pointer :: timer => null_timer

contains
  !
  ! default Fortran implementation which does nothing
  !
  subroutine null_timer (dname, k)
    implicit none
    character(len=8), intent(in) :: dname
    integer, intent(in) :: k
  end subroutine null_timer
end module timer_module

! This source code file was last time modified by Igor UA3DJY on 20200203

subroutine ft8mf1(s8,itone,msgd,msg37,lft8sd)

  use ft8_mod1, only : itone76,idtone76,msgsd76
  real, intent(in) :: s8(0:7,79)
  real s8d(0:7,58)
  character msgd*37,msg37*37,msggrid*37,c1*12,c2*12,grid*4
  integer itone(79),mrs(58),mrs2(58)
  logical(1) lft8sd,lr73,lgrid,lreport,lrreport,lrrr

  lr73=.false.; lgrid=.false.; lreport=.false.; lrreport=.false.; lrrr=.false.
  c1='            '; c2='            '
  ispc1=index(msgd,' '); ispc2=index(msgd((ispc1+1):),' ')+ispc1; ispc3=index(msgd((ispc2+1):),' ')+ispc2
  if(len(msgd(1:ispc1-1)).le.12 .and. len(msgd(ispc1+1:ispc2-1)).le.12) then
    c1=msgd(1:ispc1-1); c2=msgd(ispc1+1:ispc2-1)
  else
    return
  endif
  if(len_trim(c1).lt.3 .or. len_trim(c2).lt.3) return
  if(msgd(ispc2+1:ispc3-1).eq.'RR73' .or. msgd(ispc2+1:ispc3-1).eq.'73') lr73=.true.
  if(.not.lr73 .and. (ispc3-ispc2).eq.5 .and. msgd(ispc2+1:ispc2+2).ne.'R+' .and. msgd(ispc2+1:ispc2+2).ne.'R-') &
    lgrid=.true.
  if(msgd(ispc2+1:ispc2+1).eq.'+' .or. msgd(ispc2+1:ispc2+1).eq.'-') lreport=.true.
  if(msgd(ispc2+1:ispc2+2).eq.'R+' .or. msgd(ispc2+1:ispc2+2).eq.'R-') lrreport=.true.
  if(msgd(ispc2+1:ispc3-1).eq.'RRR') lrrr=.true.

  thresh=0.0; i1=0; i2=0
  do i=1,58; if(i.le.29) then; s8d(0:7,i)=s8(0:7,i+7); else; s8d(0:7,i)=s8(0:7,i+14); endif; enddo
  do j=1,58
    s1=-1.0E6; s2=-1.0E6
    do i=0,7; if(s8d(i,j).gt.s1) then; s1=s8d(i,j); i1=i; endif; enddo
    do i=0,7; if(i.ne.i1 .and. s8d(i,j).gt.s2) then; s2=s8d(i,j); i2=i; endif; enddo
    mrs(j)=i1; mrs2(j)=i2
  enddo
  ref0=0.0
  do i=1,58; ref0=ref0 + s8d(mrs(i),i); enddo

  ipk=0; u1=0.0; u2=0.0
  do k=1,76
    psum=0.; ref=ref0
    do j=1,58; i3=idtone76(k,j); psum=psum + s8d(i3,j); if(i3.eq.mrs(j)) ref=ref - s8d(i3,j) + s8d(mrs2(j),j); enddo
    p=psum/ref
    if(p.gt.u1) then; u2=u1; u1=p; ipk=k
    else; if(p.gt.u2) u2=p
    endif
  enddo
!/'+09 ','+08 ','+07 ','+06 ','+05 ','+04 ','+03 ','+02 ','+01 ','+00 ', &
! '-01 ','-02 ','-03 ','-04 ','-05 ','-06 ','-07 ','-08 ','-09 ','-10 ', &
! '-11 ','-12 ','-13 ','-14 ','-15 ','-16 ','-17 ','-18 ','-19 ','-20 ', &
! '-21 ','-22 ','-23 ','-24 ','-25 ','-26 ','R+09','R+08','R+07','R+06', &
! 'R+05','R+04','R+03','R+02','R+01','R+00','R-01','R-02','R-03','R-04', &
! 'R-05','R-06','R-07','R-08','R-09','R-10','R-11','R-12','R-13','R-14', &
! 'R-15','R-16','R-17','R-18','R-19','R-20','R-21','R-22','R-23','R-24', &
! 'R-25','R-26','RRR ','RR73','73  ','AA00'/
  if(ipk.ne.0) then
    if(lgrid) then
      if(ipk.eq.76) then
        msggrid=msgsd76(76)
        ispc1=index(msggrid,' '); ispc2=index(msggrid((ispc1+1):),' ')+ispc1; ispc3=index(msggrid((ispc2+1):),' ')+ispc2
        grid=msggrid(ispc2+1:ispc3-1)
        if(grid.eq.'AA00') return
      endif
      if(ipk.lt.37 .or. (ipk.gt.72 .and. ipk.lt.76)) return
    endif
    if(lreport) then; if((ipk.gt.36 .and. ipk.lt.73) .or. ipk.eq.76) return; endif
    if(lrreport) then; if(ipk.lt.37 .or. ipk.eq.73 .or. ipk.eq.76) return; endif
    if(lrrr) then; if(ipk.lt.73 .or. ipk.eq.76) return; endif
    if(lr73) then; if(ipk.lt.74 .or. ipk.eq.76) return; endif

    qual=100.0*(u1-u2)
    thresh=(qual+10.0)*(u1-0.6)
    if(thresh.gt.4.0 .and. qual.gt.2.6 .and. u1.gt.0.77) then
!print *,'matched',thresh
!print *,msgsd76(ipk)
!      if(trim(msgsd76(ipk)).eq.'CQ DE AA00') return ! triggered by memory corruption?
      lft8sd=.true.; msg37=msgsd76(ipk); itone(1:79)=itone76(ipk,1:79); return
    endif
  endif

  return
end subroutine ft8mf1

! FT4 
! LDPC(174,91) code, four 4x4 Costas arrays for sync, ramp-up and ramp-down symbols

parameter (KK=91)                     !Information bits (77 + CRC14)
parameter (ND=87)                     !Data symbols
parameter (NS=16)                     !Sync symbols 
parameter (NN=103)                    !Sync and data symbols NN=NS+ND
parameter (NN2=105)                   !Total channel symbols NN2=NS+ND+2
parameter (NSPS=576)                  !Samples per symbol at 12000 S/s
parameter (NZ=59328)                  !Sync and Data samples NZ=NSPS*NN
parameter (NZ2=60480)                 !Total samples in shaped waveform NZ2=NSPS*NN2
!parameter (NMAX=21*3456)              !Samples in iwave (72576)
parameter (NMAX=73728)                !Samples in iwave
!parameter (NFFT1=2304, NH1=NFFT1/2)   !Length of FFTs for symbol spectra
parameter (NFFT1=2560, NH1=1280)      !Length of FFTs for symbol spectra NH1=NFFT1/2
parameter (NSTEP=NSPS)                !Coarse time-sync step size
parameter (NHSYM=123)  !Number of symbol spectra (1/4-sym steps) NHSYM=(NMAX-NFFT1)/NSTEP)
parameter (NDOWN=18)                  !Downsample factor

! This source code file was last time modified by Igor UA3DJY on May 16th, 2017
! All changes are shown in the patch file coming together with the full JTDX source code.

subroutine symspec10(c5,nz3d,nsps8,xdt,fsample,freq,drift,snrdb,schk,    &
     i1SoftSymbolsScrambled,qualf,syncro,mrs,mrs2,s3)

! Compute soft symbols from the final downsampled data
  complex c5(0:nz3d-1)
  complex z
  integer*1 i1SoftSymbolsScrambled(207)
  integer mrs(69),mrs2(69)
  real aa(3)
  real ss2(0:9,85)
  real s3(0:7,69)
  include 'jt10sync.f90'
  data scale/10.0/

  ndt=nint(fsample*(1.0+xdt))
  aa(1)=-1500.0*4.0/nsps8
  aa(2)=0.
  aa(3)=0.

  do i=0,9                                         !Loop over the 9 tones
     if(i.ge.1) call twkfreq(c5,c5,nz3d,fsample,aa)
     m=0
     k=-1+ndt
     do j=1,85                                     !Loop over all symbols
        z=0.
        do n=1,256                               !Sum over 16 samples
           k=k+1
           if(k.ge.0 .and. k.lt.nz3d) z=z+c5(k)
        enddo
        ss2(i,j)=real(z)**2 + aimag(z)**2        !Symbol spectra, data and sync
        if(i.ge.2 .and. isync(j).eq.0) then
           m=m+1
           s3(i-2,m)=ss2(i,j)                   !Symbol spectra, data only
        endif
     enddo
  enddo

  call chkss10(ss2,freq,drift,schk,qualf,syncro)

  i1=1; i2=1
! find most reliable symbol tone values
  do j=1,69
     s1=0.0
     do i=0,7
        if(s3(i,j).gt.s1) then
           s1=s3(i,j)
           i1=i                              !Most reliable
        endif
     enddo
     s2=0.0
     do i=0,7
        if(i.ne.i1 .and. s3(i,j).gt.s2) then
           s2=s3(i,j)
           i2=i                              !Second most reliable
        endif
     enddo
     mrs(j)=i1
     mrs2(j)=i2
  enddo

  ss=0.
  sig=0.
  do j=1,69
     smax=0.
     do i=0,7
        smax=max(smax,s3(i,j))
        ss=ss+s3(i,j)
     enddo
     sig=sig+smax
     ss=ss-smax
  enddo
  ave=ss/(69*7)                           !Baseline
!  call pctile(ss2,10*85,35,xmed)
  s3=s3/ave
!  sig=sig*1.736/(2500.*69.*ave)      !SNR
  sig=sig/69.
!  t=max(1.0,sig - 1.0)
!  snrdb=db(t) - 61.3
  snrdb=10.*log10(sig) - 84.3

  m0=3
  k=0
  do j=1,69
!        smax=0.
!        do i=0,7
!           if(s3(i,j).gt.smax) smax=s3(i,j)
!        enddo

     do m=m0-1,0,-1                   !Get bit-wise soft symbols
        if(m.eq.2) then
           r1=max(s3(4,j),s3(5,j),s3(6,j),s3(7,j))
           r0=max(s3(0,j),s3(1,j),s3(2,j),s3(3,j))
        else if(m.eq.1) then
           r1=max(s3(2,j),s3(3,j),s3(4,j),s3(5,j))
           r0=max(s3(0,j),s3(1,j),s3(6,j),s3(7,j))
        else
           r1=max(s3(1,j),s3(2,j),s3(4,j),s3(7,j))
           r0=max(s3(0,j),s3(3,j),s3(5,j),s3(6,j))
        endif

        k=k+1
        i4=nint(scale*(r1-r0))
        if(i4.lt.-127) i4=-127
        if(i4.gt.127) i4=127
!        i4=i4+128
!        if(i4.le.127) i1SoftSymbolsScrambled(k)=i4
!        if(i4.ge.128) i1SoftSymbolsScrambled(k)=i4-256
        i1SoftSymbolsScrambled(k)=i4
     enddo
  enddo

  return
end subroutine symspec10

! This source code file was last time modified by Igor UA3DJY on July 20th, 2017.
! All changes are shown in the patch file coming together with the full JTDX source code.

subroutine sync9(nzhsym,lag1,lag2,ia,ib,ccfred,red2)

  use jt9_mod1 ! dd9(0:NPTS9-1) NPTS9=618624
  include 'constants.f90' ! NSMAX=6827 MAXFFT3=16384
  include 'jt9sync.f90'
  real, DIMENSION(:), ALLOCATABLE :: dd1
  real, DIMENSION(:,:), ALLOCATABLE :: ss
  real ccfred(NSMAX),savg(NSMAX),savg2(NSMAX),sq(NSMAX),red2(NSMAX),ss1(184),smo(-5:25)
  real x(MAXFFT3),w(MAXFFT3)
  complex c(0:MAXFFT3/2)
  logical(1) first
  equivalence (x,c)
  data first/.true./
  save first,w

  fac1=0.1 
  fac2=(1.0/MAXFFT3)**2; twopi=6.28318531
  nhstep=3456 ! 6912/2 

  if(first) then ! Compute the FFT window
     do k=1,MAXFFT3
        w(k)=sin(twopi*(k+2)/32768) ! 32768 = 2*MAXFFT3
     enddo
     first=.false.
  endif

  allocate(dd1(631552), STAT = nAllocateStatus1)
  if(nAllocateStatus1.ne.0) STOP "Not enough memory"
  allocate(ss(184,NSMAX), STAT = nAllocateStatus1)
  if(nAllocateStatus1.ne.0) STOP "Not enough memory"

  dd1(1:NPTS9)=dd9(0:NPTS9-1) ! NPTS9=618624
  dd1(NPTS9+1:631552)=0.

  do j=1,nzhsym !nhsym
     i0=(j-1)*nhstep
     x=fac1*w*dd1(i0+1:i0+MAXFFT3)
     call four2a(c,MAXFFT3,1,-1,0)                !r2c forward FFT
     do i=ia,ib
       s=fac2*SQRT(real(c(i))**2 + aimag(c(i))**2)
       ss(j,i)=s
     enddo
  enddo
  deallocate (dd1, STAT = nDeAllocateStatus1)
  if (nDeAllocateStatus1.ne.0) print *, 'failed to release memory'


  ipk=0; ccfred=0.

  do i=ia,ib                         !Loop over freq range
     ss1=ss(1:184,i)
     call pctile(ss1,nzhsym,40,xmed)

     ss1=ss1/xmed - 1.0
     do j=1,nzhsym
        if(ss1(j).gt.3.0) ss1(j)=3.0
     enddo

     call pctile(ss1,nzhsym,45,sbase)
     ss1=ss1-sbase

     smax=0.
     do lag=lag1,lag2                !DT = 2.5 to 5.0 s
        sum1=0.
        do j=1,16                    !Sum over 16 sync symbols
           k=ii2(j) + lag
           if(k.ge.1 .and. k.le.nzhsym) then
              sum1=sum1 + ss1(k)
           endif
        enddo
        if(sum1.gt.smax) then
           smax=sum1
           ipk=i 
        endif
     enddo
     ccfred(i)=smax                        !Best at this freq, over all lags
  enddo

  call pctile(ccfred(ia),ib-ia+1,50,xmed)
  if(xmed.le.0.0) xmed=1.0
  ccfred=2.0*ccfred/xmed 

  savg=0.
  do j=1,nzhsym
     savg(ia:ib)=savg(ia:ib) + ss(j,ia:ib)
  enddo

  deallocate (ss, STAT = nDeAllocateStatus1)
  if (nDeAllocateStatus1.ne.0) print *, 'failed to release memory'

  savg(ia:ib)=savg(ia:ib)/nzhsym
  smo(0:20)=1.0/21.0
  smo(-5:-1)=-(1.0/21.0)*(21.0/10.0)
  smo(21:25)=smo(-5)

  do i=ia,ib
     sm=0.
     do j=-5,25
        if(i+j.ge.1 .and. i+j.lt.NSMAX) sm=sm + smo(j)*savg(i+j)
     enddo
     savg2(i)=sm
     sq(i)=sm*sm
  enddo

  call pctile(sq(ia:ib),ib-ia+1,20,sq0)
  rms=sqrt(sq0)
  savg2(ia:ib)=savg2(ia:ib)/(5.0*rms)

  red2=0.
  do i=ia+11,ib-10
     ref=max(savg2(i-10),savg2(i+10))
     red2(i)=savg2(i)-ref
     if(red2(i).lt.-99.0) red2(i)=-99.0
     if(red2(i).gt.99.0) red2(i)=99.0
  enddo

  return
end subroutine sync9

subroutine encode174_91(message77,codeword)
!
! Add a 14-bit CRC to a 77-bit message and return a 174-bit codeword
!
use, intrinsic :: iso_c_binding
use iso_c_binding, only: c_loc,c_size_t
use crc

integer, parameter:: N=174, K=91, M=N-K
character*91 tmpchar
integer*1 codeword(N)
integer*1 gen(M,K)
integer*1 message77(77),message(K)
integer*1 pchecks(M)
integer*1, target :: i1MsgBytes(12)
include "ldpc_174_91_c_generator.f90"
logical first
data first/.true./
save first,gen
!$omp threadprivate(first,gen)

if( first ) then ! fill the generator matrix
  first=.false.
  gen=0
  do i=1,M
    do j=1,23
      read(g(i)(j:j),"(Z1)") istr
        ibmax=4
        if(j.eq.23) ibmax=3 
        do jj=1, ibmax 
          icol=(j-1)*4+jj
          if( btest(istr,4-jj) ) gen(i,icol)=1
        enddo
    enddo
  enddo
endif

! Add 14-bit CRC to form 91-bit message+CRC14
write(tmpchar,'(77i1)') message77
tmpchar(78:80)='000'
i1MsgBytes=0
read(tmpchar,'(10b8)') i1MsgBytes(1:10)
ncrc14 = crc14 (c_loc (i1MsgBytes), 12)
write(tmpchar(78:91),'(b14)') ncrc14
read(tmpchar,'(91i1)') message

do i=1,M
  nsum=0
  do j=1,K 
    nsum=nsum+message(j)*gen(i,j)
  enddo
  pchecks(i)=mod(nsum,2)
enddo

codeword(1:K)=message
codeword(K+1:N)=pchecks

return
end subroutine encode174_91

subroutine fmtmsg(msg,iz)

  character*22 msg

! Convert all letters to upper case
  iz=22
  do i=1,22
     if(msg(i:i).ge.'a' .and. msg(i:i).le.'z')                       &
          msg(i:i)= char(ichar(msg(i:i))+ichar('A')-ichar('a'))
     if(msg(i:i).ne.' ') iz=i
  enddo

  do iter=1,5                           !Collapse multiple blanks into one
     ib2=index(msg(1:iz),'  ')
     if(ib2.lt.1) go to 100
     msg=msg(1:ib2)//msg(ib2+2:)
     iz=iz-1
  enddo

100 return
end subroutine fmtmsg

! last time modified by Igor UA3DJY on 20200105

subroutine partint(ndelay,nutc)

  use jt65_mod6
  real rnd

  numsamp=ndelay*1200
  dd(numsamp+1:624000)=dd(1:(624000-numsamp))
     do i=1,numsamp
        call random_number(rnd)
        dd(i)=10.0*rnd-5.
     enddo
  write(*,2) nutc,'partial loss of data','d'
2 format(i4.4,2x,a20,21x,a1)
  call flush(6)

  return
end subroutine partint

! This source code file was last time modified by Igor UA3DJY on July 10th, 2017.
! All changes are shown in the patch file coming together with the full JTDX source code.

subroutine sync9s(ca,carxf,nzhsym,ia,ib,irxf,ndepth,nagain,nagainfil,ipass,filter)

  use jt65_mod6
  include 'constants.f90'
  integer, parameter :: MAXCANDRXF=5, MAXCAND=700, NFFT=16384
  real, DIMENSION(:), ALLOCATABLE :: dd1,ccfred1
  real, DIMENSION(:,:), ALLOCATABLE :: ss
  real x(NFFT),w(NFFT),ccfred(NSMAX),savg(NSMAX),savg2(NSMAX),sq(NSMAX),red2(NSMAX), &
       ssc(NSMAX),sscw(NSMAX),smo(-5:25),ss1(184)
  complex c(0:NFFT/2)
  logical nagain
  logical(1) nagainfil,filter,first
  equivalence (x,c)
  type candrxf
     real ccfred
     integer i
  end type candrxf
  type(candrxf) carxf(MAXCANDRXF)
  type candidate
     real ccfred
     integer i
  end type candidate
  type(candidate) ca(MAXCAND)
  include 'jt9sync.f90'
  data first/.true./
  save ccfred,red2,first,w

  ipk=0; ccfred=0.; carxf%ccfred=0.; carxf%i=-1; ca%ccfred=0.; ca%i=-1
  lag1=-9    !=-int(2.5/tstep + 0.9999)  tstep=0.5*nsps/12000.0  !Half-symbol step (seconds)
  lag2=18    !=int(5.0/tstep + 0.9999)
  nhstep=3456 ! 6912/2 

  red2limw=1.6
  if(ndepth.eq.1) ccflimw=3.0
  if(ndepth.eq.2) ccflimw=2.7
  if(ndepth.ge.3) ccflimw=2.5
  ccflimrxf=0.4; red2limrxf=0.6
  if(nagain) ccflimrxf=0.3
  if(nagainfil) then; ccflimw=2.3; ccflimrxf=0.3; endif

  fac1=0.1 
  fac2=(1.0/NFFT)**2; twopi=6.28318531

  if(first) then ! Compute the FFT window
     do k=1,NFFT
        w(k)=sin(twopi*(k+2)/32768) ! 32768 = 2*NFFT
     enddo
     first=.false.
  endif
  
  allocate(dd1(631552), STAT = nAllocateStatus1)
  if(nAllocateStatus1.ne.0) STOP "Not enough memory"
  allocate(ss(184,NSMAX), STAT = nAllocateStatus1)
  if(nAllocateStatus1.ne.0) STOP "Not enough memory"

  dd1(1:624000)=dd(1:624000)
  dd1(624001:631552)=0.

  do j=1,nzhsym !nhsym
     i0=(j-1)*nhstep
     x=fac1*w*dd1(i0+1:i0+NFFT)
     call four2a(c,NFFT,1,-1,0)                !r2c forward FFT
     do i=ia,ib
       s=fac2*SQRT(real(c(i))**2 + aimag(c(i))**2)
       ss(j,i)=s
     enddo
  enddo
  deallocate (dd1, STAT = nDeAllocateStatus1)
  if (nDeAllocateStatus1.ne.0) print *, 'failed to release memory'

  if(ipass.eq.1) then
    do i=ia,ib ! df3=0.732421875 Hz
       if(i.le.NSMAX-22) then; ssc(i)=sum(ss(1:nzhsym,i:i+22)); else; ssc(i)=1.0; endif
    enddo
    do i=ia,ib
       if(i.ge.ia+22 .and. i.le.ib-22) sscw(i)=ssc(i)/(0.5*(ssc(i-22)+ssc(i+22)))
       if(i.lt.ia+22) sscw(i)=ssc(i)/ssc(i+22)
       if(i.gt.ib-22) sscw(i)=ssc(i)/ssc(i-22)
    enddo
  endif
  
  do i=ia,ib                         !Loop over freq range
     ss1=ss(1:184,i)
     call pctile(ss1,nzhsym,40,xmed)
     ss1=ss1/xmed - 1.0
     do j=1,nzhsym
        if(ss1(j).gt.3.0) ss1(j)=3.0
     enddo

     call pctile(ss1,nzhsym,45,sbase)
     ss1=ss1-sbase

     smax=0.
     do lag=lag1,lag2                !DT = 2.5 to 5.0 s
        sum1=0.
        do j=1,16                    !Sum over 16 sync symbols
           k=ii2(j) + lag
           if(k.ge.1 .and. k.le.nzhsym) then
              sum1=sum1 + ss1(k)
           endif
        enddo
        if(sum1.gt.smax) then
           smax=sum1
           ipk=i 
        endif
     enddo
     if(ipass.eq.1) ccfred(i)=smax*sscw(i)                !Best at this freq, over all lags
     if(ipass.eq.2) ccfred(i)=smax
  enddo

  call pctile(ccfred(ia),ib-ia+1,50,xmed)
  if(xmed.le.0.0) xmed=1.0
  ccfred=2.0*ccfred/xmed 

  savg=0.
  do j=1,nzhsym
     savg(ia:ib)=savg(ia:ib) + ss(j,ia:ib)
  enddo

  deallocate (ss, STAT = nDeAllocateStatus1)
  if (nDeAllocateStatus1.ne.0) print *, 'failed to release memory'

  savg(ia:ib)=savg(ia:ib)/nzhsym
  smo(0:20)=1.0/21.0
  smo(-5:-1)=-(1.0/21.0)*(21.0/10.0)
  smo(21:25)=smo(-5)

  do i=ia,ib
     sm=0.
     do j=-5,25
        if(i+j.ge.1 .and. i+j.lt.NSMAX) sm=sm + smo(j)*savg(i+j)
     enddo
     savg2(i)=sm
     sq(i)=sm*sm
  enddo

  call pctile(sq(ia:ib),ib-ia+1,20,sq0)
  rms=sqrt(sq0)
  savg2(ia:ib)=savg2(ia:ib)/(5.0*rms)

  red2=0.
  do i=ia+11,ib-10
     ref=max(savg2(i-10),savg2(i+10))
     red2(i)=savg2(i)-ref
     if(red2(i).lt.-99.0) red2(i)=-99.0
     if(red2(i).gt.99.0) red2(i)=99.0
  enddo

  allocate(ccfred1(NSMAX), STAT = nAllocateStatus1)
  if(nAllocateStatus1.ne.0) STOP "Not enough memory"
  ccfred1=ccfred

  if(.not.nagainfil) then
     ncandrxf=0
     do m=1,maxcandrxf
        if(irxf.gt.(ia+3) .and. irxf.lt.(ib-3)) then
           nmaxloc=MAXLOC(ccfred1((irxf-3):(irxf+3)),dim=1)   !getting index of ccfred with maximum value for RX freq
           nmaxloc=nmaxloc+irxf-4
!print *,nmaxloc,ccfred1(nmaxloc),red2(nmaxloc)
!           if(abs(ccfred1(nmaxloc)).gt.ccflimrxf .and. red2(nmaxloc).gt.red2limrxf) then !applying thresholds
           if(ccfred1(nmaxloc).lt.ccflimrxf .or. red2(nmaxloc).lt.red2limrxf) then !applying thresholds
              ccfred1(nmaxloc)=0.0
              cycle
           endif
!print *,'add rxf cand'
           ncandrxf=ncandrxf+1
           carxf(ncandrxf)%ccfred=ccfred1(nmaxloc)
           carxf(ncandrxf)%i=nmaxloc
           ccfred1(nmaxloc)=0.
        endif
     enddo
  endif

! df3=0.732421875 Hz
  if(filter) then; ccfred1(:(irxf-69))=0.0; ccfred1((irxf+69):)=0.0; endif ! +-50Hz BW
  if(nagainfil) then; ccfred1(:(irxf-29))=0.0; ccfred1((irxf+29):)=0.0; endif ! +-20Hz BW

  if(.not.nagain) then
     ncandw=0
     do m=1,maxcand
        nmaxloc=MAXLOC(ccfred1,dim=1)   !getting index of ccfred with maximum value
        if(ccfred1(nmaxloc).lt.ccflimw) then ! .or. red2(nmaxloc).lt.red2limw) then !applying thresholds
           ccfred1(nmaxloc)=0.0
           cycle
        endif
        ncandw=ncandw+1
        ca(ncandw)%ccfred=ccfred1(nmaxloc)
        ca(ncandw)%i=nmaxloc
        ccfred1(nmaxloc)=0.
     enddo
  endif
!print *,ncandw,ncandrxf  
  deallocate (ccfred1, STAT = nDeAllocateStatus1)
  if (nDeAllocateStatus1.ne.0) print *, 'failed to release memory'

  return
end subroutine sync9s

!
! Generate a seed for the RANDOM_NUMBER PRNG that is guaranteed to be
! unique even if many processes are started simultaneously
!
subroutine init_random_seed()
  use iso_fortran_env, only: int64
  implicit none
  integer, allocatable :: seed(:)
  integer :: i, n, un, istat, dt(8), pid
  integer(int64) :: t

  call random_seed(size = n)
  allocate(seed(n))
  ! First try if the OS provides a random number generator
  open(newunit=un, file="/dev/urandom", access="stream", &
       form="unformatted", action="read", status="old", iostat=istat)
  if (istat == 0) then
     read(un) seed
     close(un)
  else
     ! Fallback to XOR:ing the current time and pid. The PID is
     ! useful in case one launches multiple instances of the same
     ! program in parallel.
     call system_clock(t)
     if (t == 0) then
        call date_and_time(values=dt)
        t = (dt(1) - 1970) * 365_int64 * 24 * 60 * 60 * 1000 &
             + dt(2) * 31_int64 * 24 * 60 * 60 * 1000 &
             + dt(3) * 24_int64 * 60 * 60 * 1000 &
             + dt(5) * 60 * 60 * 1000 &
             + dt(6) * 60 * 1000 + dt(7) * 1000 &
             + dt(8)
     end if
     pid = getpid()
     t = ieor(t, int(pid, kind(t)))
     do i = 1, n
        seed(i) = lcg(t)
     end do
  end if
  call random_seed(put=seed)
contains
  ! This simple PRNG might not be good enough for real work, but is
  ! sufficient for seeding a better PRNG.
  function lcg(s)
    integer :: lcg
    integer(int64) :: s
    if (s == 0) then
       s = 104729
    else
       s = mod(s, 4294967296_int64)
    end if
    s = mod(s * 279470273_int64, 4294967291_int64)
    lcg = int(mod(s, int(huge(0), int64)), kind(0))
  end function lcg
end subroutine init_random_seed

module packjt77

! These variables are accessible from outside via "use packjt77":
  parameter (MAXHASH=1000,MAXTXHASH=5,MAXRECENT=10)
  character (len=13), dimension(0:1023) ::  calls10=''
  character (len=13), dimension(0:4095) ::  calls12=''
  character (len=13), dimension(1:MAXHASH) :: calls22=''
  character (len=13), dimension(0:1023) ::  txcalls10=''
  character (len=13), dimension(0:4095) ::  txcalls12=''
  character (len=13), dimension(1:MAXTXHASH) :: txcalls22=''
  character (len=13), dimension(1:MAXRECENT) :: recent_calls=''
  character (len=13), dimension(1:840) :: last_calls=''
  character (len=13) :: mycall13=''
  character (len=13) :: dxcall13=''
  character (len=13) :: mycall13_0=''
  character (len=13) :: dxcall13_0=''
  integer hashmy10,hashmy12,hashmy22,hashdx10
  logical :: dxcall13_set=.false.
  logical :: mycall13_set=.false.

  integer, dimension(1:MAXHASH) :: ihash22=-1
  integer, dimension(1:5) :: itxhash22=-1
  integer, dimension(1:24) :: nlast_calls=0
  integer, dimension(1:25) :: nthrindex=(/0,200,300,370,420,460,500,530,560,590,610,630,650,670,690,710, &
                                        730,750,770,790,800,810,820,830,840/)
  integer :: nzhash=0
  integer :: nztxhash=0
  integer n28a,n28b
!$omp threadprivate(recent_calls,n28a,n28b)
  logical(1) lcommonft8b

  contains

subroutine hash10(n10,c13,nthr)

  character*13 c13
  integer, intent(in) :: nthr

  c13='<...>'
  if(n10.lt.0 .or. n10.gt.1023) return
  if(nthr.gt.25) then ! TX message
    if(len(trim(txcalls10(n10))).gt.0) then
      c13=txcalls10(n10)
      c13='<'//trim(c13)//'>'
    endif
  else
    if(len(trim(calls10(n10))).gt.0) then
      c13=calls10(n10)
      c13='<'//trim(c13)//'>'
    endif
  endif
  return

end subroutine hash10

subroutine hash12(n12,c13,nthr)

  character*13 c13
  integer, intent(in) :: nthr
  
  c13='<...>'
  if(n12.lt.0 .or. n12.gt.4095) return
  if(nthr.gt.25) then ! TX message
    if(len(trim(txcalls12(n12))).gt.0) then
      c13=txcalls12(n12)
      c13='<'//trim(c13)//'>'
    endif
  else
    if(len(trim(calls12(n12))).gt.0) then
      c13=calls12(n12)
      c13='<'//trim(c13)//'>'
    endif
  endif

  return

end subroutine hash12


subroutine hash22(n22,c13,nthr)

  character*13 c13
  integer, intent(in) :: nthr
  
  c13='<...>'
  if(nthr.gt.25) then ! TX message
    do i=1,nztxhash
      if(itxhash22(i).eq.n22) then
        c13=txcalls22(i)
        c13='<'//trim(c13)//'>'
        go to 900
      endif
    enddo
  else
    do i=1,nzhash
      if(ihash22(i).eq.n22) then
        c13=calls22(i)
        c13='<'//trim(c13)//'>'
        go to 900
      endif
    enddo
  endif

900 return
end subroutine hash22


integer function ihashcall(c0,m)

  integer*8 n8
  character*13 c0
  character*38 c
  data c/' 0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ/'/

  n8=0
  do i=1,11
     j=index(c,c0(i:i)) - 1
     n8=38*n8 + j
  enddo
  ihashcall=ishft(47055833459_8*n8,m-64)

  return
end function ihashcall

subroutine save_hash_mycall(c13,n10,n12,n22)

  character*13 c13,cw

  cw=c13 
  if(cw(1:1).eq.' ' .or. cw(1:5).eq.'<...>') return
  if(cw(1:1).eq.'<') cw=cw(2:)
  i=index(cw,'>')
  if(i.gt.0) cw(i:)='         '
  if(len(trim(cw)) .lt. 3) return

  n12=ihashcall(cw,12)
  if(n12.ge.0 .and. n12 .le. 4095 .and. cw.ne.mycall13) calls12(n12)=cw

  n10=ihashcall(cw,10)
  if(n10.ge.0 .and. n10 .le. 1023 .and. cw.ne.mycall13) calls10(n10)=cw

  n22=ihashcall(cw,22)
  if(any(ihash22.eq.n22)) then   ! If entry exists, make sure callsign is the most recently received one
    where(ihash22.eq.n22) calls22=cw
    go to 1900
  endif

! New entry: move table down, making room for new one at the top
  ihash22(nzhash:2:-1)=ihash22(nzhash-1:1:-1)

! Add the new entry
  calls22(nzhash:2:-1)=calls22(nzhash-1:1:-1)
  ihash22(1)=n22
  calls22(1)=cw
  if(nzhash.lt.MAXHASH) nzhash=nzhash+1

1900 continue

  return 
end subroutine save_hash_mycall

subroutine save_hash_txcall(c13,n10,n12,n22,lhashit)

  character*13 c13,cw
  logical, intent(in) :: lhashit

  cw=c13 
  if(cw(1:1).eq.' ' .or. cw(1:5).eq.'<...>') return
  if(cw(1:1).eq.'<') cw=cw(2:)
  i=index(cw,'>')
  if(i.gt.0) cw(i:)='         '
  if(len(trim(cw)) .lt. 3) return

  n12=ihashcall(cw,12)

  if(lhashit) then
    if(n12.ge.0 .and. n12 .le. 4095 .and. cw.ne.mycall13) txcalls12(n12)=cw

    n10=ihashcall(cw,10)
    if(n10.ge.0 .and. n10 .le. 1023 .and. cw.ne.mycall13) txcalls10(n10)=cw

    n22=ihashcall(cw,22)
    if(any(itxhash22.eq.n22)) then   ! If entry exists, make sure callsign is the most recently received one
      where(itxhash22.eq.n22) txcalls22=cw
      go to 1900
    endif

! New entry: move table down, making room for new one at the top
    itxhash22(nztxhash:2:-1)=itxhash22(nztxhash-1:1:-1)

! Add the new entry
    txcalls22(nztxhash:2:-1)=txcalls22(nztxhash-1:1:-1)
    itxhash22(1)=n22
    txcalls22(1)=cw
    if(nztxhash.lt.MAXTXHASH) nztxhash=nztxhash+1

1900 continue
  endif

  return 
end subroutine save_hash_txcall

subroutine save_hash_call(c13,nthr)

  character*13 c13,cw
  integer, intent(in) :: nthr

  if(nthr.gt.24) return
  cw=c13 
  if(cw(1:1).eq.' ' .or. cw(1:5).eq.'<...>') return
  if(cw(1:1).eq.'<') cw=cw(2:)
  i=index(cw,'>')
  if(i.gt.0) cw(i:)='         '
  if(len(trim(cw)) .lt. 3) return

  nposition=nthrindex(nthr)+nlast_calls(nthr)
  if(nposition.lt.nthrindex(nthr+1)) then
    nlast_calls(nthr)=nlast_calls(nthr)+1
    last_calls(nposition+1)=cw
!print *,nthr,nlast_calls(nthr),nposition+1,last_calls(nposition+1)
  endif

  return 
end subroutine save_hash_call

subroutine pack77(msg0,i3,n3,c77,ntxhash)

  use packjt
  character*37 msg,msg0
  character*18 c18
  character*13 w(19)
  character*77 c77
  integer nw(19)
  integer ntel(3)
  integer, intent(in) :: ntxhash

  msg=msg0
  i3_hint=i3
  n3_hint=n3
  i3=-1
  n3=-1
  if(i3_hint.eq.0 .and. n3_hint.eq.5) go to 5

! Convert msg to upper case; collapse multiple blanks; parse into words.
  call split77(msg,nwords,nw,w)
  if(msg(1:3).eq.'CQ ' .or. msg(1:3).eq.'DE ' .or. msg(1:4).eq.'QRZ ') go to 100

! Check 0.1 (DXpedition mode)
  call pack77_01(nwords,w,i3,n3,c77,ntxhash)
  if(i3.ge.0 .or. n3.ge.1) go to 900
! Check 0.2 (EU VHF contest exchange)
!  call pack77_02(nwords,w,i3,n3,c77)
!  if(i3.ge.0) go to 900

! Check 0.3 and 0.4 (ARRL Field Day exchange)
  call pack77_03(nwords,w,i3,n3,c77,ntxhash)
  if(i3.ge.0) go to 900
  if(nwords.ge.2) go to 100

  ! Check 0.5 (telemetry)
5  i0=index(msg,' ')
  c18=msg(1:i0-1)
  c18=adjustr(c18)
  ntel=-99
  read(c18,1005,err=6) ntel
1005 format(3z6)
  if(ntel(1).ge.2**23) go to 800
6 if(ntel(1).ge.0 .and. ntel(2).ge.0 .and. ntel(3).ge.0) then
     i3=0
     n3=5
     write(c77,1006) ntel,n3,i3
1006 format(b23.23,2b24.24,2b3.3)
     go to 900
  endif

100 call pack77_06(nwords,w,i3,n3,c77,i3_hint,n3_hint,ntxhash)
  if(i3.ge.0) go to 900

! Check Type 1 (Standard 77-bit message) or Type 2, with optional "/P"
  call pack77_1(nwords,w,i3,n3,c77,ntxhash)
  if(i3.ge.0) go to 900

! Check Type 3 (ARRL RTTY contest exchange)
  call pack77_3(nwords,w,i3,n3,c77,ntxhash)
  if(i3.ge.0) go to 900

! Check Type 4 (One nonstandard call and one hashed call)
  call pack77_4(nwords,w,i3,n3,c77,ntxhash)
  if(i3.ge.0) go to 900

! Check Type 5 (EU VHF Contest with 2 hashed calls, report, serial, and grid6)
  call pack77_5(nwords,w,i3,n3,c77,ntxhash)
  if(i3.ge.0) go to 900

! It defaults to free text
800 i3=0
  n3=0
  msg(14:)='                        '
  call packtext77(msg(1:13),c77(1:71))
  write(c77(72:77),'(2b3.3)') n3,i3

900 return
end subroutine pack77

subroutine unpack77(c77,nrx,msg,unpk77_success,nthr)
!
! nrx=1 when unpacking a received message
! nrx=0 when unpacking a to-be-transmitted message
! the value of nrx is used to decide when mycall13 or dxcall13 should
! be used in place of a callsign from the hashtable
!
  parameter (NSEC=85)      !Number of ARRL Sections
  parameter (NUSCAN=65)    !Number of US states and Canadian provinces
  parameter (MAXGRID4=32400)
  integer*8 n58
  integer ntel(3)
  character*77 c77
  character*37 msg
  character*13 call_1,call_2,call_3,call_1a
  character*11 c11
  character*3 crpt,cntx,cpfx
  character*3 cmult(NUSCAN)
  character*6 cexch,grid6
  character*4 grid4,cserial
  character*3 csec(NSEC)
  character*38 c
  character*36 a2
  logical unpk28_success,unpk77_success,unpkg4_success
  integer, intent(in) :: nthr

  data a2/'0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ'/,nzzz/46656/
  data c/' 0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ/'/
  data csec/                                                         &
       "AB ","AK ","AL ","AR ","AZ ","BC ","CO ","CT ","DE ","EB ",  &       
       "EMA","ENY","EPA","EWA","GA ","GTA","IA ","ID ","IL ","IN ",  &       
       "KS ","KY ","LA ","LAX","MAR","MB ","MDC","ME ","MI ","MN ",  &       
       "MO ","MS ","MT ","NC ","ND ","NE ","NFL","NH ","NL ","NLI",  &       
       "NM ","NNJ","NNY","NT ","NTX","NV ","OH ","OK ","ONE","ONN",  &       
       "ONS","OR ","ORG","PAC","PR ","QC ","RI ","SB ","SC ","SCV",  &       
       "SD ","SDG","SF ","SFL","SJV","SK ","SNJ","STX","SV ","TN ",  &       
       "UT ","VA ","VI ","VT ","WCF","WI ","WMA","WNY","WPA","WTX",  &       
       "WV ","WWA","WY ","DX ","PE "/
  data cmult/                                                        &
       "AL ","AK ","AZ ","AR ","CA ","CO ","CT ","DE ","FL ","GA ",  &
       "HI ","ID ","IL ","IN ","IA ","KS ","KY ","LA ","ME ","MD ",  &
       "MA ","MI ","MN ","MS ","MO ","MT ","NE ","NV ","NH ","NJ ",  &
       "NM ","NY ","NC ","ND ","OH ","OK ","OR ","PA ","RI ","SC ",  &
       "SD ","TN ","TX ","UT ","VT ","VA ","WA ","WV ","WI ","WY ",  &
       "NB ","NS ","QC ","ON ","MB ","SK ","AB ","BC ","NWT","NF ",  &
       "LB ","NU ","YT ","PEI","DC "/

  unpk77_success=.true.

! Check for bad data
  do i=1,77
     if(c77(i:i).ne.'0' .and. c77(i:i).ne.'1') then
        msg='failed unpack'
        unpk77_success=.false.
        return
     endif
  enddo

  read(c77(72:77),'(2b3)') n3,i3
  msg=repeat(' ',37)
  if(i3.eq.0 .and. n3.eq.0) then
! 0.0  Free text
     call unpacktext77(c77(1:71),msg(1:13))
     msg(14:)='                        '
     msg=adjustl(msg)
     if(msg(1:1).eq.' ') then
        unpk77_success=.false.
        return
     endif
  else if(i3.eq.0 .and. n3.eq.1) then
! 0.1  K1ABC RR73; W9XYZ <KH1/KH7Z> -11   28 28 10 5       71   DXpedition Mode
     read(c77,1010) n28a,n28b,n10,n5
1010 format(2b28,b10,b5)
     irpt=2*n5 - 30
     write(crpt,1012) irpt
1012 format(i3.2)
     if(irpt.ge.0) crpt(1:1)='+'
     call unpack28(n28a,call_1,unpk28_success,nthr) 
     if(.not.unpk28_success .or. n28a.le.2) unpk77_success=.false.
     call unpack28(n28b,call_2,unpk28_success,nthr)
     if(.not.unpk28_success .or. n28b.le.2) unpk77_success=.false.
     call hash10(n10,call_3,nthr)
     if(nrx.eq.1) then
       if(dxcall13_set .and. hashdx10.eq.n10) then; call_3='<'//trim(dxcall13)//'>'
       elseif(.not.dxcall13_set .and. .not.lcommonft8b .and. hashdx10.eq.n10) then; call_3='<'//trim(dxcall13_0)//'>'
       elseif(.not.dxcall13_set .and. .not.lcommonft8b .and. hashdx10.ne.n10) then; call_3=trim(call_3)
       elseif(.not.dxcall13_set .and. lcommonft8b .and. hashdx10.eq.n10)  then; call_3='<'//trim(dxcall13_0)//'>'
       elseif(.not.dxcall13_set .and. lcommonft8b .and. hashdx10.ne.n10)  then; call_3='<...>'
       else; call_3='<...>'
       endif
     endif
     if(nrx.eq.0 .and. mycall13_set .and. n10.eq.hashmy10) call_3='<'//trim(mycall13)//'>'
     msg=trim(call_1)//' RR73; '//trim(call_2)//' '//trim(call_3)//' '//crpt

  else if(i3.eq.0 .and. n3.eq.2) then
     unpk77_success=.false.
  else if(i3.eq.0 .and. (n3.eq.3 .or. n3.eq.4)) then
! 0.3   WA9XYZ KA1ABC R 16A EMA            28 28 1 4 3 7    71   ARRL Field Day
! 0.4   WA9XYZ KA1ABC R 32A EMA            28 28 1 4 3 7    71   ARRL Field Day
     read(c77,1030) n28a,n28b,ir,intx,nclass,isec
1030 format(2b28,b1,b4,b3,b7)
     if(isec.gt.NSEC .or. isec.lt.1) then
         unpk77_success=.false.
         isec=1
     endif
     call unpack28(n28a,call_1,unpk28_success,nthr)
     if(.not.unpk28_success .or. n28a.le.2) unpk77_success=.false.
     call unpack28(n28b,call_2,unpk28_success,nthr)
     if(.not.unpk28_success .or. n28b.le.2) unpk77_success=.false.
     ntx=intx+1
     if(n3.eq.4) ntx=ntx+16
     write(cntx(1:2),1032) ntx
1032 format(i2)
     cntx(3:3)=char(ichar('A')+nclass)
     if(ir.eq.0 .and. ntx.lt.10) msg=trim(call_1)//' '//trim(call_2)//     &
          cntx//' '//csec(isec)
     if(ir.eq.1 .and. ntx.lt.10) msg=trim(call_1)//' '//trim(call_2)//     &
          ' R'//cntx//' '//csec(isec)
     if(ir.eq.0 .and. ntx.ge.10) msg=trim(call_1)//' '//trim(call_2)//     &
          ' '//cntx//' '//csec(isec)
     if(ir.eq.1 .and. ntx.ge.10) msg=trim(call_1)//' '//trim(call_2)//     &
          ' R '//cntx//' '//csec(isec)

  else if(i3.eq.0 .and. n3.eq.5) then
! 0.5   0123456789abcdef01                 71               71   Telemetry (18 hex)
     read(c77,1006) ntel
1006 format(b23,2b24)
     write(msg,1007) ntel
1007 format(3z6.6)
     do i=1,18
        if(msg(i:i).ne.'0') exit
        msg(i:i)=' '
     enddo
     msg=adjustl(msg)

  else if(i3.eq.0 .and. n3.eq.6) then
     read(c77(49:50),'(2b1)') j2a,j2b
     itype=2
     if(j2b.eq.0 .and. j2a.eq.0) itype=1
     if(j2b.eq.0 .and. j2a.eq.1) itype=3
     if(itype.eq.1) then
! WSPR Type 1
        read(c77,2010) n28,igrid4,idbm
2010    format(b28.28,b15.15,b5.5)
        idbm=nint(idbm*10.0/3.0)
        call unpack28(n28,call_1,unpk28_success,nthr) 
        if(.not.unpk28_success) unpk77_success=.false.
        call to_grid4(igrid4,grid4,unpkg4_success)
        if(.not.unpkg4_success) unpk77_success=.false.
        write(crpt,'(i3)') idbm
        msg=trim(call_1)//' '//grid4//' '//trim(adjustl(crpt))
        if (unpk77_success) call save_hash_call(call_1,nthr) !### Is this OK here? ###

     else if(itype.eq.2) then
! WSPR Type 2
        read(c77,2020) n28,npfx,idbm
2020    format(b28.28,b16.16,b5.5)
        idbm=nint(idbm*10.0/3.0)        
        call unpack28(n28,call_1,unpk28_success,nthr) 
        if(.not.unpk28_success) unpk77_success=.false.
        write(crpt,'(i3)') idbm
        cpfx='   '
        if(npfx.lt.nzzz) then
! Prefix
           do i=3,1,-1
              j=mod(npfx,36)+1
              cpfx(i:i)=a2(j:j)
              npfx=npfx/36
              if(npfx.eq.0) exit
           enddo
           msg=trim(adjustl(cpfx))//'/'//trim(call_1)//' '//trim(adjustl(crpt))
           call_1a=trim(adjustl(cpfx))//'/'//trim(call_1)
           call save_hash_call(call_1a,nthr)  !### Is this OK here? ###
        else
! Suffix
           npfx=npfx-nzzz
           if(npfx.le.35) then
              cpfx(1:1)=a2(npfx+1:npfx+1)
           else if(npfx.gt.35 .and. npfx.le.1295) then
              cpfx(1:1)=a2(npfx/36+1:npfx/36+1)
              cpfx(2:2)=a2(mod(npfx,36)+1:mod(npfx,36)+1)
           else if(npfx.gt.1295 .and. npfx.le.12959) then
              cpfx(1:1)=a2(npfx/360+1:npfx/360+1)
              cpfx(2:2)=a2(mod(npfx/10,36)+1:mod(npfx/10,36)+1)
              cpfx(3:3)=a2(mod(npfx,10)+1:mod(npfx,10)+1)
           else
              unpk77_success=.false.
              return
           endif
           msg=trim(call_1)//'/'//trim(adjustl(cpfx))//' '//trim(adjustl(crpt))
           call_1a=trim(call_1)//'/'//trim(adjustl(cpfx))
           call save_hash_call(call_1a,nthr)  !### Is this OK here? ###
        endif
        
     else if(itype.eq.3) then
! WSPR Type 3
        read(c77,2030) n22,igrid6
2030    format(b22.22,b25.25)
        n28=n22+2063592
        call unpack28(n28,call_1,unpk28_success,nthr) 
        if(.not.unpk28_success) unpk77_success=.false.
        call to_grid(igrid6,grid6,unpkg4_success)
        if(.not.unpkg4_success) unpk77_success=.false.
        msg=trim(call_1)//' '//grid6
     endif
  
  else if(i3.eq.0 .and. n3.gt.6) then
     unpk77_success=.false.

  else if(i3.eq.1 .or. i3.eq.2) then
! Type 1 (standard message) or Type 2 ("/P" form for EU VHF contest)
     read(c77,1000) n28a,ipa,n28b,ipb,ir,igrid4,i3
1000 format(2(b28,b1),b1,b15,b3)
     call unpack28(n28a,call_1,unpk28_success,nthr)
     if(nrx.eq.1 .and. mycall13_set .and. hashmy22.eq.(n28a-2063592)) then
        call_1='<'//trim(mycall13)//'>'
        unpk28_success=.true.
     endif
     if(.not.unpk28_success) unpk77_success=.false.
     call unpack28(n28b,call_2,unpk28_success,nthr)
     if(.not.unpk28_success) unpk77_success=.false.
     if(call_1(1:3).eq.'CQ_') call_1(3:3)=' '
     if(index(call_1,'<').le.0) then
        i=index(call_1,' ')
        if(i.ge.4 .and. ipa.eq.1 .and. i3.eq.1) call_1(i:i+1)='/R'
        if(i.ge.4 .and. ipa.eq.1 .and. i3.eq.2) call_1(i:i+1)='/P'
        if(i.ge.4) call add_call_to_recent_calls(call_1,nthr)
     endif
     if(index(call_2,'<').le.0) then
        i=index(call_2,' ')
        if(i.ge.4 .and. ipb.eq.1 .and. i3.eq.1) call_2(i:i+1)='/R'
        if(i.ge.4 .and. ipb.eq.1 .and. i3.eq.2) call_2(i:i+1)='/P'
        if(i.ge.4) call add_call_to_recent_calls(call_2,nthr)
     endif
     if(igrid4.le.MAXGRID4) then
        call to_grid4(igrid4,grid4,unpkg4_success)
        if(.not.unpkg4_success) unpk77_success=.false.
        if(ir.eq.0) msg=trim(call_1)//' '//trim(call_2)//' '//grid4
        if(ir.eq.1) msg=trim(call_1)//' '//trim(call_2)//' R '//grid4
        if(msg(1:3).eq.'CQ ' .and. ir.eq.1) unpk77_success=.false.
!out of current realisation of protocol: GRID is always dropped at WSJT-X/JTDX transmission of the messages below
!           i3          n3
!           1           0
!110015 -23  0.5 1450 ~ <...> Y96IHQ/R GL12
!112215 -23  0.0 1606 ~ <...> 3U1TBM/R CC65
!000102 -23  0.5  801 ~ <...> NV3QHV/R JF62
        if(ir.eq.0 .and. call_1(1:1).eq.'<' .and. grid4.ne.'RR73') then ! hash value can also be associated with a valid callsign
          nlencall2=len_trim(call_2)
          if(nlencall2.gt.1) then
            if(call_2(nlencall2-1:nlencall2).eq.'/R') unpk77_success=.false.
          endif
        endif
     else
        irpt=igrid4-MAXGRID4
        if(irpt.eq.1) msg=trim(call_1)//' '//trim(call_2)
        if(irpt.eq.2) msg=trim(call_1)//' '//trim(call_2)//' RRR'
        if(irpt.eq.3) msg=trim(call_1)//' '//trim(call_2)//' RR73'
        if(irpt.eq.4) msg=trim(call_1)//' '//trim(call_2)//' 73'
        if(irpt.ge.5) then
           isnr=irpt-35
           if(isnr.gt.50) isnr=isnr-101
           write(crpt,'(i3.2)') isnr
           if(crpt(1:1).eq.' ') crpt(1:1)='+'
           if(ir.eq.0) msg=trim(call_1)//' '//trim(call_2)//' '//crpt
           if(ir.eq.1) msg=trim(call_1)//' '//trim(call_2)//' R'//crpt
        endif
        if(msg(1:3).eq.'CQ ' .and. irpt.ge.2) unpk77_success=.false.
     endif

  else if(i3.eq.3) then
! Type 3: ARRL RTTY Contest
     read(c77,1040) itu,n28a,n28b,ir,irpt,nexch,i3
1040 format(b1,2b28.28,b1,b3.3,b13.13,b3.3)
     write(crpt,1042) irpt+2
1042 format('5',i1,'9')
     nserial=nexch
     imult=-1
     if(nexch.gt.8000) then
        imult=nexch-8000
        nserial=-1
     endif
     call unpack28(n28a,call_1,unpk28_success,nthr)
     if(.not.unpk28_success) unpk77_success=.false.
     call unpack28(n28b,call_2,unpk28_success,nthr)
     if(.not.unpk28_success) unpk77_success=.false.
     imult=0
     nserial=0
     if(nexch.gt.8000) imult=nexch-8000
     if(nexch.lt.8000) nserial=nexch
     
     if(imult.ge.1 .and.imult.le.NUSCAN) then
        if(itu.eq.0 .and. ir.eq.0) msg=trim(call_1)//' '//trim(call_2)//             &
             ' '//crpt//' '//cmult(imult)
        if(itu.eq.1 .and. ir.eq.0) msg='TU; '//trim(call_1)//' '//trim(call_2)//     &
             ' '//crpt//' '//cmult(imult)
        if(itu.eq.0 .and. ir.eq.1) msg=trim(call_1)//' '//trim(call_2)//             &
             ' R '//crpt//' '//cmult(imult)
        if(itu.eq.1 .and. ir.eq.1) msg='TU; '//trim(call_1)//' '//trim(call_2)//     &
             ' R '//crpt//' '//cmult(imult)
     else if(nserial.ge.1 .and. nserial.le.7999) then
        write(cserial,'(i4.4)') nserial
        if(itu.eq.0 .and. ir.eq.0) msg=trim(call_1)//' '//trim(call_2)//             &
             ' '//crpt//' '//cserial
        if(itu.eq.1 .and. ir.eq.0) msg='TU; '//trim(call_1)//' '//trim(call_2)//     &
             ' '//crpt//' '//cserial
        if(itu.eq.0 .and. ir.eq.1) msg=trim(call_1)//' '//trim(call_2)//             &
             ' R '//crpt//' '//cserial
        if(itu.eq.1 .and. ir.eq.1) msg='TU; '//trim(call_1)//' '//trim(call_2)//     &
             ' R '//crpt//' '//cserial
     endif

  else if(i3.eq.4) then
! Type 4     
     read(c77,1050) n12,n58,iflip,nrpt,icq
1050 format(b12,b58,b1,b2,b1)
     do i=11,1,-1
        j=mod(n58,38)+1
        c11(i:i)=c(j:j)
        n58=n58/38
     enddo
     call hash12(n12,call_3,nthr)
     if(iflip.eq.0) then       ! 12 bit hash for TO call
        call_1=call_3          
        call_2=adjustl(c11)//'  '
        call add_call_to_recent_calls(call_2,nthr)
        if(nrx.eq.1 .and.                        &  
           dxcall13_set .and. mycall13_set .and. & 
           call_2.eq.dxcall13 .and.              &
           n12.eq.hashmy12 ) call_1='<'//trim(mycall13)//'>'
        if(nrx.eq.1 .and.                        &
           mycall13_set .and.                    & 
           index(call_1,'<...>').gt.0 .and.      &
           n12.eq.hashmy12 ) call_1='<'//trim(mycall13)//'>'
     else                      ! 12 bit hash for DE call
        call_1=adjustl(c11)
        call_2=call_3          
        call add_call_to_recent_calls(call_1,nthr)
        if(nrx.eq.0 .and.                        & 
           mycall13_set .and. & 
           n12.eq.hashmy12) call_2='<'//trim(mycall13)//'>'
     endif
     if(icq.eq.0) then
        if(nrpt.eq.0) msg=trim(call_1)//' '//trim(call_2)
        if(nrpt.eq.1) msg=trim(call_1)//' '//trim(call_2)//' RRR'
        if(nrpt.eq.2) msg=trim(call_1)//' '//trim(call_2)//' RR73'
        if(nrpt.eq.3) msg=trim(call_1)//' '//trim(call_2)//' 73'
     else
        msg='CQ '//trim(call_2)
     endif
     if(call_2(1:1).lt.':' .and. call_2(1:1).gt.'/' .and. call_2(2:2).lt.':' .and. call_2(2:2).gt.'/') unpk77_success=.false.
     if(len_trim(call_2).eq.11) then
       ispace=index(call_2,' '); if(ispace.gt.0 .and. ispace.lt.12) unpk77_success=.false.
       islash=index(call_2,'/'); if(islash.eq.1 .or. islash.eq.2 .or. islash.eq.11 .or. (islash.eq.10 .and. &
       call_2(11:11).gt.'@' .and. call_2(11:11).lt.'[' .and. call_2(11:11).ne.'P')) unpk77_success=.false.
       if(islash.lt.6 .and. call_2(11:11).lt.':' .and. call_2(11:11).gt.'/') unpk77_success=.false.
     endif
     if(msg(1:3).ne.'CQ ') then
       if(call_1(1:1).lt.':' .and. call_1(1:1).gt.'/' .and. call_1(2:2).lt.':' .and.call_1(2:2).gt.'/') unpk77_success=.false.
       if(len_trim(call_1).eq.11) then
         ispace=index(call_1,' '); if(ispace.gt.0 .and. ispace.lt.12) unpk77_success=.false.
         islash=index(call_1,'/'); if(islash.eq.1 .or. islash.eq.2 .or. islash.eq.11 .or. (islash.eq.10 .and. &
         call_1(11:11).gt.'@' .and. call_1(11:11).lt.'[' .and. call_1(11:11).ne.'P')) unpk77_success=.false.
         if(islash.lt.6 .and. call_1(11:11).lt.':' .and. call_1(11:11).gt.'/') unpk77_success=.false.
       endif
     endif
     nmsglen=len_trim(msg)
! protocol violations, also reported at wrong TX message packing
! prevent broken message transmission
     if(unpk77_success .and. nmsglen.gt.0) then
       indxp=index(msg,'/P ')
       if((icq.eq.0 .and. nrpt.eq.0 .and. (indxp.lt.1 .or. indxp.gt.7)) .or. icq.eq.1) then
! -23 -3.3 N0S/W45ETOE <...>
!071445 -14  0.1  779 ~ <...>
!071445 -14  0.1  779 ~ W5JZ  ! hash was associated
! CQ <...>
! with exception to broken by packing message 'JQ1AHT/P <JL1LOF/1> -15' wrongly being transmitted as type 4 message 'JQ1AHT/P <JL1LOF/1>'
         if(msg(nmsglen:nmsglen).eq.'>') unpk77_success=.false.
       endif
     endif
! <...> /BZZ/0ZZ/C
! <...> ZZZZ/0Z/Z/
! <...> OZZZZ/0ZZZ/
! <...> 0I/IZZZ/O K
! <...> J/IZZZ/O K
     if(unpk77_success .and. iflip.eq.0 .and. icq.eq.0 .and. nrpt.eq.0) then
       nlencall2=len_trim(call_2)
       if(nlencall2.gt.9) then
         if(call_2(1:1).eq.'/' .or. call_2(nlencall2:nlencall2).eq.'/') unpk77_success=.false.
         nindxspace=index(call_2,' ')
         if(nindxspace.gt.0 .and. nindxspace.lt.nlencall2) unpk77_success=.false.
       endif
     endif

  else if(i3.eq.5) then
     
! Type 5  <PA3XYZ> <G4ABC/P> R 590003 IO91NP      h12 h22 r1 s3 S11 g25
! EU VHF contest
     read(c77,1060) n12,n22,ir,irpt,iserial,igrid6
1060 format(b12,b22,b1,b3,b11,b25)
     if(igrid6.lt.0 .or. igrid6.gt.18662399) then
        unpk77_success=.false.
        return
     endif
     call hash12(n12,call_1,nthr)
     if(n12.eq.hashmy12) call_1='<'//trim(mycall13)//'>'
     call hash22(n22,call_2,nthr)
     nrs=52+irpt
     write(cexch,1022) nrs,iserial
1022 format(i2,i4.4)
     call to_grid6(igrid6,grid6,unpk77_success)
     if(ir.eq.0) msg=trim(call_1)//' '//trim(call_2)//' '//cexch//' '//grid6
     if(ir.eq.1) msg=trim(call_1)//' '//trim(call_2)//' R '//cexch//' '//grid6

  else if(i3.ge.6) then ! i3 values 6 and 7 are not yet defined
     unpk77_success=.false.
  endif
  if(msg(1:4).eq.'CQ <') unpk77_success=.false.

  return
end subroutine unpack77

subroutine pack28(c13,n28,ntxhash)

! Pack a special token, a 22-bit hash code, or a valid base call into a 28-bit
! integer.

  parameter (NTOKENS=2063592,MAX22=4194304)
  logical is_digit,is_letter,lhashit
  character*13 c13
  character*6 callsign
  character*1 c
  character*4 c4
  character*37 a1
  character*36 a2
  character*10 a3
  character*27 a4
  integer, intent(in) :: ntxhash
  data a1/' 0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ'/
  data a2/'0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ'/
  data a3/'0123456789'/
  data a4/' ABCDEFGHIJKLMNOPQRSTUVWXYZ'/
  
  is_digit(c)=c.ge.'0' .and. c.le.'9'
  is_letter(c)=c.ge.'A' .and. c.le.'Z'

  n28=-1
! Work-around for Swaziland prefix:
  if(c13(1:4).eq.'3DA0') callsign='3D0'//c13(5:7)
! Work-around for Guinea prefixes:
  if(c13(1:2).eq.'3X' .and. c13(3:3).ge.'A' .and.          &
       c13(3:3).le.'Z') callsign='Q'//c13(3:6)

! Check for special tokens first
  if(c13(1:3).eq.'DE ') then
     n28=0
     go to 900
  endif
  
  if(c13(1:4).eq.'QRZ ') then
     n28=1
     go to 900
  endif

  if(c13(1:3).eq.'CQ ') then
     n28=2
     go to 900
  endif

  if(c13(1:3).eq.'CQ_') then
     n=len(trim(c13))
     if(n.ge.4 .and. n.le.7) then
        nlet=0
        nnum=0
        do i=4,n
           c=c13(i:i)
           if(c.ge.'A' .and. c.le.'Z') nlet=nlet+1
           if(c.ge.'0' .and. c.le.'9') nnum=nnum+1
        enddo
        if(nnum.eq.3 .and. nlet.eq.0) then
           read(c13(4:3+nnum),*) nqsy
           n28=3+nqsy
           go to 900
        endif
        if(nlet.ge.1 .and. nlet.le.4 .and. nnum.eq.0) then
           c4=c13(4:n)
           c4=adjustr(c4)
           m=0
           do i=1,4
              j=0
              c=c4(i:i)
              if(c.ge.'A' .and. c.le.'Z') j=ichar(c)-ichar('A')+1
              m=27*m + j
           enddo
           n28=3+1000+m
           go to 900
        endif
     endif
  endif

  lhashit=.false.; if(ntxhash.eq.1) lhashit=.true.
! Check for <...> callsign
  if(c13(1:1).eq.'<')then
     call save_hash_txcall(c13,n10,n12,n22,lhashit)   !Save callsign in hash table
     i2=index(c13,'>')
     c13=c13(2:i2-1)
     n22=ihashcall(c13,22)
     n28=NTOKENS + n22
     go to 900
  endif

! Check for standard callsign
  iarea=-1
  n=len(trim(c13))
  do i=n,2,-1
     if(is_digit(c13(i:i))) exit
  enddo
  iarea=i                                   !Call-area digit
  npdig=0                                   !Digits before call area
  nplet=0                                   !Letters before call area
  do i=1,iarea-1
     if(is_digit(c13(i:i))) npdig=npdig+1
     if(is_letter(c13(i:i))) nplet=nplet+1
  enddo
  nslet=0
  do i=iarea+1,n
     if(is_letter(c13(i:i))) nslet=nslet+1
  enddo
  if(iarea.lt.2 .or. iarea.gt.3 .or. nplet.eq.0 .or.       &
       npdig.ge.iarea-1 .or. nslet.gt.3) then
! Treat this as a nonstandard callsign: compute its 22-bit hash
     call save_hash_txcall(c13,n10,n12,n22,lhashit)   !Save callsign in hash table
     n22=ihashcall(c13,22)
     n28=NTOKENS + n22
     go to 900
  endif
  
  n=len(trim(c13))
! This is a standard callsign
  call save_hash_txcall(c13,n10,n12,n22,lhashit)   !Save callsign in hash table
  if(iarea.eq.2) callsign=' '//c13(1:5)
  if(iarea.eq.3) callsign=c13(1:6)
  i1=index(a1,callsign(1:1))-1
  i2=index(a2,callsign(2:2))-1
  i3=index(a3,callsign(3:3))-1
  i4=index(a4,callsign(4:4))-1
  i5=index(a4,callsign(5:5))-1
  i6=index(a4,callsign(6:6))-1
  n28=36*10*27*27*27*i1 + 10*27*27*27*i2 + 27*27*27*i3 + 27*27*i4 + &
       27*i5 + i6
  n28=n28 + NTOKENS + MAX22

900 n28=iand(n28,ishft(1,28)-1)
  return
end subroutine pack28


subroutine unpack28(n28_0,c13,success,nthr)

  parameter (NTOKENS=2063592,MAX22=4194304)
  logical success
  character*13 c13
  character*37 c1
  character*36 c2
  character*10 c3
  character*27 c4
  integer, intent(in) :: nthr
  data c1/' 0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ'/
  data c2/'0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ'/
  data c3/'0123456789'/
  data c4/' ABCDEFGHIJKLMNOPQRSTUVWXYZ'/

  success=.true.
  n28=n28_0
  if(n28.lt.NTOKENS) then
! Special tokens DE, QRZ, CQ, CQ_nnn, CQ_aaaa
     if(n28.eq.0) c13='DE           '
     if(n28.eq.1) c13='QRZ          '
     if(n28.eq.2) c13='CQ           '
     if(n28.le.2) go to 900
     if(n28.le.1002) then
        write(c13,1002) n28-3
1002    format('CQ_',i3.3)
        go to 900
     endif
     if(n28.le.532443) then
        n=n28-1003
        n0=n
        i1=n/(27*27*27)
        n=n-27*27*27*i1
        i2=n/(27*27)
        n=n-27*27*i2
        i3=n/27
        i4=n-27*i3
        c13=c4(i1+1:i1+1)//c4(i2+1:i2+1)//c4(i3+1:i3+1)//c4(i4+1:i4+1)
        c13=adjustl(c13)
        c13='CQ_'//c13(1:10)
        go to 900
     endif
  endif
  n28=n28-NTOKENS
  if(n28.lt.MAX22) then
! This is a 22-bit hash of a callsign
     n22=n28
     call hash22(n22,c13,nthr)     !Retrieve callsign from hash table
     go to 900
  endif
  
! Standard callsign
  n=n28 - MAX22
  i1=n/(36*10*27*27*27)
  n=n-36*10*27*27*27*i1
  i2=n/(10*27*27*27)
  n=n-10*27*27*27*i2
  i3=n/(27*27*27)
  n=n-27*27*27*i3
  i4=n/(27*27)
  n=n-27*27*i4
  i5=n/27
  i6=n-27*i5
  c13=c1(i1+1:i1+1)//c2(i2+1:i2+1)//c3(i3+1:i3+1)//c4(i4+1:i4+1)//     &
       c4(i5+1:i5+1)//c4(i6+1:i6+1)
  c13=adjustl(c13)

900 i0=index(c13,' ')

  if((i0.ne.0 .and. i0.lt.len(trim(c13))) .or. (c13(1:1).lt.':' .and. c13(1:1).gt.'/' .and. &
     c13(2:2).lt.':' .and. c13(2:2).gt.'/')) then
     c13='QU1RK'
     success=.false.
  endif

  return
end subroutine unpack28

subroutine split77(msg,nwords,nw,w)

! Convert msg to upper case; collapse multiple blanks; parse into words.

  character*37 msg
  character*13 w(19)
  character*1 c,c0
  character*6 bcall_1
  logical ok1
  integer nw(19)
    
  iz=len(trim(msg))
  j=0
  k=0
  n=0
  c0=' '
  w='             '
  do i=1,iz
     if(ichar(msg(i:i)).eq.0) msg(i:i)=' '
     c=msg(i:i)                                 !Single character
     if(c.eq.' ' .and. c0.eq.' ') cycle         !Skip leading/repeated blanks
     if(c.ne.' ' .and. c0.eq.' ') then
        k=k+1                                   !New word
        n=0
     endif
     j=j+1                                      !Index in msg
     n=n+1                                      !Index in word
     if(c.ge.'a' .and. c.le.'z') c=char(ichar(c)-32)  !Force upper case
     msg(j:j)=c
     if(n.le.13) w(k)(n:n)=c                    !Copy character c into word
     c0=c
  enddo
  iz=j                                          !Message length
  nwords=k                                      !Number of words in msg
  if(nwords.le.0) go to 900
  nw(k)=len(trim(w(k)))
  msg(iz+1:)='                                     '
  if(nwords.lt.3) go to 900
  call chkcall(w(3),bcall_1,ok1)
  if(ok1 .and. w(1)(1:3).eq.'CQ ') then
     w(1)='CQ_'//w(2)(1:10)             !Make "CQ " into "CQ_"
     w(2:12)=w(3:13)                    !Move all remeining words down by one
     nwords=nwords-1
  endif
  
900 return
end subroutine split77


subroutine pack77_01(nwords,w,i3,n3,c77,ntxhash)

! Pack a Type 0.1 message: DXpedition mode
! Example message:  "K1ABC RR73; W9XYZ <KH1/KH7Z> -11"   28 28 10 5

  character*13 w(19),c13
  character*77 c77
  character*6 bcall_1,bcall_2
  logical ok1,ok2,lhashit
  integer, intent(in) :: ntxhash

  if(nwords.ne.5) go to 900                !Must have 5 words
  if(trim(w(2)).ne.'RR73;') go to 900      !2nd word must be "RR73;"
  if(w(4)(1:1).ne.'<') go to 900           !4th word must have <...>
  if(index(w(4),'>').lt.1) go to 900
  n=-99
  read(w(5),*,err=1) n
1 if(n.eq.-99) go to 900                   !5th word must be a valid report
  n5=(n+30)/2
  if(n5.lt.0) n5=0
  if(n5.gt.31) n5=31
  call chkcall(w(1),bcall_1,ok1)
  if(.not.ok1) go to 900                   !1st word must be a valid basecall
  call chkcall(w(3),bcall_2,ok2)
  if(.not.ok2) go to 900                   !3rd word must be a valid basecall

! Type 0.1:  K1ABC RR73; W9XYZ <KH1/KH7Z> -11   28 28 10 5       71   DXpedition special msg
  i3=0
  n3=1
  call pack28(w(1),n28a,ntxhash)
  call pack28(w(3),n28b,ntxhash)
  lhashit=.false.; if(ntxhash.eq.1) lhashit=.true.
  call save_hash_txcall(w(4),n10,n12,n22,lhashit)
  i2=index(w(4),'>')
  c13=w(4)(2:i2-1)
  n10=ihashcall(c13,10)
  write(c77,1010) n28a,n28b,n10,n5,n3,i3
1010 format(2b28.28,b10.10,b5.5,2b3.3)
  
900 return
end subroutine pack77_01

subroutine pack77_03(nwords,w,i3,n3,c77,ntxhash)

! Check 0.3 and 0.4 (ARRL Field Day exchange)
! Example message:  WA9XYZ KA1ABC R 16A EMA       28 28 1 4 3 7    71  

  parameter (NSEC=85)      !Number of ARRL Sections
  character*13 w(19)
  character*77 c77
  character*6 bcall_1,bcall_2
  character*3 csec(NSEC)
  logical ok1,ok2
  integer, intent(in) :: ntxhash
  data csec/                                                         &
       "AB ","AK ","AL ","AR ","AZ ","BC ","CO ","CT ","DE ","EB ",  &       
       "EMA","ENY","EPA","EWA","GA ","GTA","IA ","ID ","IL ","IN ",  &       
       "KS ","KY ","LA ","LAX","MAR","MB ","MDC","ME ","MI ","MN ",  &       
       "MO ","MS ","MT ","NC ","ND ","NE ","NFL","NH ","NL ","NLI",  &       
       "NM ","NNJ","NNY","NT ","NTX","NV ","OH ","OK ","ONE","ONN",  &       
       "ONS","OR ","ORG","PAC","PR ","QC ","RI ","SB ","SC ","SCV",  &       
       "SD ","SDG","SF ","SFL","SJV","SK ","SNJ","STX","SV ","TN ",  &       
       "UT ","VA ","VI ","VT ","WCF","WI ","WMA","WNY","WPA","WTX",  &       
       "WV ","WWA","WY ","DX ","PE "/

  if(nwords.lt.4 .or. nwords.gt.5) return  
  call chkcall(w(1),bcall_1,ok1)
  call chkcall(w(2),bcall_2,ok2)
  if(.not.ok1 .or. .not.ok2) return
  isec=-1
  do i=1,NSEC
     if(csec(i).eq.w(nwords)(1:3)) then
        isec=i
        exit
     endif
  enddo
  if(isec.eq.-1) return
  if(nwords.eq.5 .and. trim(w(3)).ne.'R') return
  
  ntx=-1
  j=len(trim(w(nwords-1)))-1
  read(w(nwords-1)(1:j),*,err=1,end=1) ntx          !Number of transmitters
1 if(ntx.lt.1 .or. ntx.gt.32) return
  nclass=ichar(w(nwords-1)(j+1:j+1))-ichar('A')
  
  m=len(trim(w(nwords)))                            !Length of section abbreviation
  if(m.lt.2 .or. m.gt.3) return

! 0.3   WA9XYZ KA1ABC R 16A EMA            28 28 1 4 3 7    71   ARRL Field Day
! 0.4   WA9XYZ KA1ABC R 32A EMA            28 28 1 4 3 7    71   ARRL Field Day
  
  i3=0
  n3=3                                 !Type 0.3 ARRL Field Day
  intx=ntx-1
  if(intx.ge.16) then
     n3=4                              !Type 0.4 ARRL Field Day
     intx=ntx-17
  endif
  call pack28(w(1),n28a,ntxhash)
  call pack28(w(2),n28b,ntxhash)
  ir=0
  if(w(3)(1:2).eq.'R ') ir=1
  write(c77,1010) n28a,n28b,ir,intx,nclass,isec,n3,i3
1010 format(2b28.28,b1,b4.4,b3.3,b7.7,2b3.3)

  return
end subroutine pack77_03

subroutine pack77_06(nwords,w,i3,n3,c77,i3_hint,n3_hint,ntxhash)

  character*13 w(19)
  character*77 c77
  character*6 bcall,grid6
  character*4 grid4
  character*1 c
  character*36 a2
  integer, intent(in) :: ntxhash
  data a2/'0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ'/,nzzz/46656/
  
  logical is_grid4,is_grid6,is_digit,ok
  is_grid4(grid4)=len(trim(grid4)).eq.4 .and.                        &
       grid4(1:1).ge.'A' .and. grid4(1:1).le.'R' .and.               &
       grid4(2:2).ge.'A' .and. grid4(2:2).le.'R' .and.               &
       grid4(3:3).ge.'0' .and. grid4(3:3).le.'9' .and.               &
       grid4(4:4).ge.'0' .and. grid4(4:4).le.'9'

  is_grid6(grid6)=(len(trim(grid6)).eq.6.or.len(trim(grid6)).eq.4).and. &
       grid6(1:1).ge.'A' .and. grid6(1:1).le.'R' .and.               &
       grid6(2:2).ge.'A' .and. grid6(2:2).le.'R' .and.               &
       grid6(3:3).ge.'0' .and. grid6(3:3).le.'9' .and.               &
       grid6(4:4).ge.'0' .and. grid6(4:4).le.'9' .and.               &
       (len(trim(grid6)).eq.4.or.                                    &
       (grid6(5:5).ge.'A' .and. grid6(5:5).le.'X' .and.              &
       grid6(6:6).ge.'A' .and. grid6(6:6).le.'X'))

  is_digit(c)=c.ge.'0' .and. c.le.'9'

  m1=len(trim(w(1)))
  m2=len(trim(w(2)))
  m3=len(trim(w(3)))
  if(nwords.eq.3 .and. m1.ge.3 .and. m1.le.6 .and. m2.eq.4 .and. m3.le.2) then
! WSPR Type 1
     if(.not.is_grid4(w(2)(1:4))) go to 900
     if(.not.is_digit(w(3)(1:1))) go to 900
     if(m3.eq.2) then
        if(.not.is_digit(w(3)(2:2))) go to 900
     endif
     i3=0
     n3=6
     call pack28(w(1),n28,ntxhash)
     grid4=w(2)(1:4)
     k1=(ichar(grid4(1:1))-ichar('A'))*18*10*10
     k2=(ichar(grid4(2:2))-ichar('A'))*10*10
     k3=(ichar(grid4(3:3))-ichar('0'))*10
     k4=(ichar(grid4(4:4))-ichar('0'))
     igrid4=k1+k2+k3+k4
     read(w(3),*) idbm
     if(idbm.lt.0) idbm=0
     if(idbm.gt.60) idbm=60
     idbm=nint(0.3*idbm)
     write(c77,1010) n28,igrid4,idbm,0,0,0,n3,i3
1010 format(b28.28,b15.15,b5.5,2i1,b21.21,2b3.3)
     go to 900
  endif
  if(nwords.eq.2 .and. m1.ge.5 .and. m1.le.10 .and. m2.le.2) then
! WSPR Type 2
     i1=index(w(1),'/')
     if(i1.lt.2 .or. i1.eq.m1) go to 900
     if(.not.is_digit(w(2)(1:1))) go to 900
     if(i1.eq.(m1-3) .and. .not.is_digit(w(1)(m1:m1))) go to 900
     if(m2.eq.2) then
        if(.not.is_digit(w(2)(2:2))) go to 900
     endif
     call chkcall(w(1),bcall,ok)
     if(.not.ok) go to 900
     if(i1.le.4) then
! We have a prefix
        npfx=index(a2,w(1)(1:1))-1
        if(i1.ge.3) npfx=36*npfx + index(a2,w(1)(2:2))-1
        if(i1.eq.4) npfx=36*npfx + index(a2,w(1)(3:3))-1
     else
! We have a suffix
        if((m1-i1).eq.1) npfx=index(a2,w(1)(i1+1:i1+1))-1
        if((m1-i1).eq.2) npfx=36*(index(a2,w(1)(i1+1:i1+1))-1) +             &
             index(a2,w(1)(i1+2:i1+2))-1
        if((m1-i1).eq.3) then
! Third character of a suffix must be a digit
           if(.not.is_digit(w(1)(i1+3:i1+3))) go to 900
           npfx=36*10*(index(a2,w(1)(i1+1:i1+1))-1) +                        &
             10*(index(a2,w(1)(i1+2:i1+2))-1) + index(a2,w(1)(i1+3:i1+3))-1
        endif
        npfx=npfx + nzzz
     endif
     i3=0
     n3=6
     call pack28(bcall//'       ',n28,ntxhash)
     read(w(2),*) idbm
     if(idbm.lt.0) idbm=0
     if(idbm.gt.60) idbm=60
     idbm=nint(0.3*idbm)
     write(c77,1020) n28,npfx,idbm,1,0,n3,i3
1020 format(b28.28,b16.16,b5.5,i1,b21.21,2b3.3)
     go to 900
  endif

  if(i3_hint.eq.0.and.n3_hint.eq.6.and.nwords.eq.2 .and. m1.ge.5  &
       .and. m1.le.12 .and. m2.le.6) then
! WSPR Type 3

     !n3_hint=6 and i3_hint=0 is a hint that the caller wanted a
     !50-bit encoding rather than the possible alternative n3=4 77-bit
     !encoding
     if(index(w(1),'<').lt.1 .or. index(w(1),'>').lt.1) go to 900
     grid6=w(2)(1:6)
     if(.not.is_grid6(grid6)) go to 900
     i3=0
     n3=6
     call pack28(w(1),n28,ntxhash)
     n22=n28-2063592
     k1=(ichar(grid6(1:1))-ichar('A'))*18*10*10*25*25
     k2=(ichar(grid6(2:2))-ichar('A'))*10*10*25*25
     k3=(ichar(grid6(3:3))-ichar('0'))*10*25*25
     k4=(ichar(grid6(4:4))-ichar('0'))*25*25
     if (grid6(5:6).eq.'  ') then
        igrid6=k1+k2+k3+k4+24*25+24
     else
        k5=(ichar(grid6(5:5))-ichar('A'))*25
        k6=(ichar(grid6(6:6))-ichar('A'))
        igrid6=k1+k2+k3+k4+k5+k6
     endif
     write(c77,1030) n22,igrid6,2,0,n3,i3
1030 format(b22.22,b25.25,b3.3,b21.21,2b3.3)
  endif

900 return  
end subroutine pack77_06

subroutine pack77_1(nwords,w,i3,n3,c77,ntxhash)

! Check Type 1 (Standard 77-bit message) and Type 2 (ditto, with a "/P" call)
! Example message:  WA9XYZ/R KA1ABC/R R FN42     28 1 28 1 1 15   74

  parameter (MAXGRID4=32400)
  character*13 w(19),c13
  character*77 c77
  character*6 bcall_1,bcall_2
  character*4 grid4
  character c1*1,c2*2
  logical is_grid4
  logical ok1,ok2
  integer, intent(in) :: ntxhash
  is_grid4(grid4)=len(trim(grid4)).eq.4 .and.                        &
       grid4(1:1).ge.'A' .and. grid4(1:1).le.'R' .and.               &
       grid4(2:2).ge.'A' .and. grid4(2:2).le.'R' .and.               &
       grid4(3:3).ge.'0' .and. grid4(3:3).le.'9' .and.               &
       grid4(4:4).ge.'0' .and. grid4(4:4).le.'9'

  if(nwords.lt.2 .or. nwords.gt.4) return
  call chkcall(w(1),bcall_1,ok1)
  call chkcall(w(2),bcall_2,ok2)
  if(w(1)(1:3).eq.'DE ' .or. w(1)(1:3).eq.'CQ_' .or.  w(1)(1:3).eq.'CQ ' .or. &
       w(1)(1:4).eq.'QRZ ') ok1=.true.
  if(w(1)(1:1).eq.'<' .and. index(w(1),'>').ge.5) ok1=.true.
  if(w(2)(1:1).eq.'<' .and. index(w(2),'>').ge.5) ok2=.true.
  if(.not.ok1 .or. .not.ok2) return
  if(w(1)(1:1).eq.'<' .and. index(w(2),'/').gt.0) return
  if(w(2)(1:1).eq.'<' .and. index(w(1),'/').gt.0) return
  if(nwords.eq.2 .and. (.not.ok2 .or. index(w(2),'/').ge.2)) return
  if(nwords.eq.2) go to 10

  c1=w(nwords)(1:1)
  c2=w(nwords)(1:2)
  if(.not.is_grid4(w(nwords)(1:4)) .and. c1.ne.'+' .and. c1.ne.'-'              &
       .and. c2.ne.'R+' .and. c2.ne.'R-' .and. trim(w(nwords)).ne.'RRR' .and.   &
       trim(w(nwords)).ne.'RR73' .and. trim(w(nwords)).ne.'73') return
  if(c1.eq.'+' .or. c1.eq.'-') then
     ir=0
     read(w(nwords),*,err=900) irpt
     if(irpt.ge.-50 .and. irpt.le.-31) irpt=irpt+101
     irpt=irpt+35
  else if(c2.eq.'R+' .or. c2.eq.'R-') then
     ir=1
     read(w(nwords)(2:),*,err=900) irpt
     if(irpt.ge.-50 .and. irpt.le.-31) irpt=irpt+101
     irpt=irpt+35
  else if(trim(w(nwords)).eq.'RRR') then
     ir=0
     irpt=2
  else if(trim(w(nwords)).eq.'RR73') then
     ir=0
     irpt=3
  else if(trim(w(nwords)).eq.'73') then
     ir=0
     irpt=4
  endif

! 1     WA9XYZ/R KA1ABC/R R FN42           28 1 28 1 1 15   74   Standard msg
! 2     PA3XYZ/P GM4ABC/P R JO22           28 1 28 1 1 15   74   EU VHF contest  

10 i1psuffix=index(w(1)//' ' ,'/P ')
  i2psuffix=index(w(2)//' ','/P ')
  if(nwords.eq.2 .or. nwords.eq.3 .or. (nwords.eq.4 .and.               &
       w(3)(1:2).eq.'R ')) then
     n3=0
     i3=1                          !Type 1: Standard message, possibly with "/R"
     if (i1psuffix.ge.4.or.i2psuffix.ge.4) i3=2 !Type 2, with "/P"
  endif
  c13=bcall_1
  if(c13(1:3).eq.'CQ_' .or. w(1)(1:1).eq.'<') c13=w(1)
  call pack28(c13,n28a,ntxhash)
  c13=bcall_2
  if(w(2)(1:1).eq.'<') c13=w(2)
  call pack28(c13,n28b,ntxhash)
  ipa=0
  ipb=0
  if(i1psuffix.ge.4.or.index(w(1)//' ','/R ').ge.4) ipa=1
  if(i2psuffix.ge.4.or.index(w(2)//' ','/R ').ge.4) ipb=1
  
  grid4=w(nwords)(1:4)
  if(is_grid4(grid4)) then
     ir=0
     if(w(3).eq.'R ') ir=1
     j1=(ichar(grid4(1:1))-ichar('A'))*18*10*10
     j2=(ichar(grid4(2:2))-ichar('A'))*10*10
     j3=(ichar(grid4(3:3))-ichar('0'))*10
     j4=(ichar(grid4(4:4))-ichar('0'))
     igrid4=j1+j2+j3+j4
  else
     igrid4=MAXGRID4 + irpt
  endif
  if(nwords.eq.2) then
     ir=0
     irpt=1
     igrid4=MAXGRID4+irpt
  endif
  write(c77,1000) n28a,ipa,n28b,ipb,ir,igrid4,i3
1000 format(2(b28.28,b1),b1,b15.15,b3.3)
  return

900 return
end subroutine pack77_1


subroutine pack77_3(nwords,w,i3,n3,c77,ntxhash)
! Check Type 3 (ARRL RTTY contest exchange)
!ARRL RTTY   - US/Can: rpt state/prov      R 579 MA
!     	     - DX:     rpt serial          R 559 0013
! Example message:  TU; W9XYZ K1ABC R 579 MA           1 28 28 1 3 13   74

  parameter (NUSCAN=65)    !Number of US states and Canadian provinces/territories
  character*13 w(19)
  character*77 c77
  character*6 bcall_1,bcall_2
  character*3 cmult(NUSCAN),mult
  character crpt*3
  integer, intent(in) :: ntxhash
  logical ok1,ok2
  data cmult/                                                        &
       "AL ","AK ","AZ ","AR ","CA ","CO ","CT ","DE ","FL ","GA ",  &
       "HI ","ID ","IL ","IN ","IA ","KS ","KY ","LA ","ME ","MD ",  &
       "MA ","MI ","MN ","MS ","MO ","MT ","NE ","NV ","NH ","NJ ",  &
       "NM ","NY ","NC ","ND ","OH ","OK ","OR ","PA ","RI ","SC ",  &
       "SD ","TN ","TX ","UT ","VT ","VA ","WA ","WV ","WI ","WY ",  &
       "NB ","NS ","QC ","ON ","MB ","SK ","AB ","BC ","NWT","NF ",  &
       "LB ","NU ","YT ","PEI","DC "/

  if(w(1)(1:1).eq.'<' .and. w(2)(1:1).eq.'<') go to 900
  if(nwords.eq.4 .or. nwords.eq.5 .or. nwords.eq.6) then
     i1=1
     if(trim(w(1)).eq.'TU;') i1=2
     call chkcall(w(i1),bcall_1,ok1)
     call chkcall(w(i1+1),bcall_2,ok2)
     if(.not.ok1 .or. .not.ok2) go to 900
     crpt=w(nwords-1)(1:3)
     if(index(crpt,'-').ge.1 .or. index(crpt,'+').ge.1) go to 900
     if(crpt(1:1).eq.'5' .and. crpt(2:2).ge.'2' .and. crpt(2:2).le.'9' .and.    &
          crpt(3:3).eq.'9') then
        nserial=0
        read(w(nwords),*,err=1) nserial
     endif
1    mult='   '
     imult=-1
     do i=1,NUSCAN
        if(cmult(i).eq.w(nwords)) then
           imult=i
           mult=cmult(i)
           exit
        endif
     enddo
     nexch=0
     if(nserial.gt.0) nexch=nserial
     if(imult.gt.0) nexch=8000+imult
     if(mult.ne.'   ' .or. nserial.gt.0) then
        i3=3
        n3=0
        itu=0
        if(trim(w(1)).eq.'TU;') itu=1
        call pack28(w(1+itu),n28a,ntxhash)
        call pack28(w(2+itu),n28b,ntxhash)
        ir=0
        if(w(3+itu)(1:2).eq.'R ') ir=1
        read(w(3+itu+ir),*,err=900) irpt
        irpt=(irpt-509)/10 - 2
        if(irpt.lt.0) irpt=0
        if(irpt.gt.7) irpt=7
! 3     TU; W9XYZ K1ABC R 579 MA             1 28 28 1 3 13       74   ARRL RTTY contest
! 3     TU; W9XYZ G8ABC R 559 0013           1 28 28 1 3 13       74   ARRL RTTY (DX)
        write(c77,1010) itu,n28a,n28b,ir,irpt,nexch,i3
1010    format(b1,2b28.28,b1,b3.3,b13.13,b3.3)
     endif
  endif

900 return
end subroutine pack77_3

subroutine pack77_4(nwords,w,i3,n3,c77,ntxhash)

! Check Type 4 (One nonstandard call and one hashed call)
! Example message: <WA9XYZ> PJ4/KA1ABC RR73           12 58 1 2 1      74

  integer*8 n58
  logical ok1,ok2,lhashit
  character*13 w(19)
  character*77 c77
  character*13 call_1,call_2
  character*11 c11
  character*6 bcall_1,bcall_2
  character*38 c
  integer, intent(in) :: ntxhash
  data c/' 0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ/'/

  iflip=0
  i3=-1
  if(nwords.eq.2 .or. nwords.eq.3) then
     call_1=w(1)
     if(call_1(1:1).eq.'<') call_1=w(1)(2:len(trim(w(1)))-1)
     call_2=w(2)
     if(call_2(1:1).eq.'<') call_2=w(2)(2:len(trim(w(2)))-1)
     call chkcall(call_1,bcall_1,ok1)
     call chkcall(call_2,bcall_2,ok2)
     if(call_1.eq.bcall_1 .and. call_2.eq.bcall_2 .and. ok1 .and. ok2) go to 900
     icq=0
     if(trim(w(1)).eq.'CQ' .or. (ok1.and.ok2)) then
        if(trim(w(1)).eq.'CQ' .and. len(trim(w(2))).le.4) go to 900
        i3=4
        n3=0
        if(trim(w(1)).eq.'CQ') icq=1
     endif

     lhashit=.false.; if(ntxhash.eq.1) lhashit=.true.
     if(icq.eq.1) then
        iflip=0
        n12=0
        c11=adjustr(call_2(1:11))
        call save_hash_txcall(w(2),n10,n12,n22,lhashit)
     else if(w(1)(1:1).eq.'<') then
        iflip=0
        i3=4
        call save_hash_txcall(w(1),n10,n12,n22,lhashit)
        c11=adjustr(call_2(1:11))
     else if(w(2)(1:1).eq.'<') then
        iflip=1
        i3=4
        call save_hash_txcall(w(2),n10,n12,n22,lhashit)
        c11=adjustr(call_1(1:11))
     endif
     n58=0
     do i=1,11
        n58=n58*38 + index(c,c11(i:i)) - 1
     enddo
     nrpt=0
     if(trim(w(3)).eq.'RRR') nrpt=1
     if(trim(w(3)).eq.'RR73') nrpt=2
     if(trim(w(3)).eq.'73') nrpt=3
     if(icq.eq.1) then
        iflip=0
        nrpt=0
     endif
     write(c77,1010) n12,n58,iflip,nrpt,icq,i3
1010 format(b12.12,b58.58,b1,b2.2,b1,b3.3)
     do i=1,77
        if(c77(i:i).eq.'*') c77(i:i)='0'     !### Clean up any illegal chars ###
     enddo
  endif

900 return
end subroutine pack77_4

subroutine pack77_5(nwords,w,i3,n3,c77,ntxhash)

! Pack a Type 0.2 message: EU VHF Contest mode
! Example message:  PA3XYZ/P R 590003 IO91NP           28 1 1 3 12 25
!                 <PA3XYZ> <G4ABC/P> R 590003 IO91NP   h10 h20 r1 s3 s12 g25

  character*13 w(19),c13
  character*77 c77
  character*6 grid6
  logical is_grid6,lhashit
  integer, intent(in) :: ntxhash

  is_grid6(grid6)=len(trim(grid6)).eq.6 .and.                        &
       grid6(1:1).ge.'A' .and. grid6(1:1).le.'R' .and.               &
       grid6(2:2).ge.'A' .and. grid6(2:2).le.'R' .and.               &
       grid6(3:3).ge.'0' .and. grid6(3:3).le.'9' .and.               &
       grid6(4:4).ge.'0' .and. grid6(4:4).le.'9' .and.               &
       grid6(5:5).ge.'A' .and. grid6(5:5).le.'X' .and.               &
       grid6(6:6).ge.'A' .and. grid6(6:6).le.'X'

  if(nwords.lt.4 .or. nwords.gt.5) return        !nwords must be 4 or 5
  if(w(1)(1:1).ne.'<' .or. w(2)(1:1).ne.'<') return !Both calls must be hashed
  nx=-1
  read(w(nwords-1),*,err=2) nx
2 if(nx.lt.520001 .or. nx.gt.594095) return   !Exchange between 520001 - 594095
  if(.not.is_grid6(w(nwords)(1:6))) return    !Last word must be a valid grid6

! Type 0.2: <PA3XYZ> <G4ABC/P> R 590003 IO91NP     h10 h20 r1 s3 s12 g25

  i3=5
  n3=0

  lhashit=.false.; if(ntxhash.eq.1) lhashit=.true.

  call save_hash_txcall(w(1),n10,n12,n22,lhashit)
  i2=index(w(1),'>')
  c13=w(1)(2:i2-1)
  n12=ihashcall(c13,12)

  call save_hash_txcall(w(2),n10a,n12a,n22,lhashit)
  i2=index(w(2),'>')
  c13=w(2)(2:i2-1)
  n22=ihashcall(c13,22)

  ir=0
  if(w(3)(1:2).eq.'R ') ir=1
  irpt=nx/10000 - 52
  iserial=mod(nx,10000)
  if(iserial.gt.2047) iserial=2047
  grid6=w(nwords)(1:6)
  j1=(ichar(grid6(1:1))-ichar('A'))*18*10*10*24*24
  j2=(ichar(grid6(2:2))-ichar('A'))*10*10*24*24
  j3=(ichar(grid6(3:3))-ichar('0'))*10*24*24
  j4=(ichar(grid6(4:4))-ichar('0'))*24*24
  j5=(ichar(grid6(5:5))-ichar('A'))*24
  j6=(ichar(grid6(6:6))-ichar('A'))
  igrid6=j1+j2+j3+j4+j5+j6
  write(c77,1010) n12,n22,ir,irpt,iserial,igrid6,i3
1010 format(b12.12,b22.22,b1,b3.3,b11.11,b25.25,b3.3)

  return
end subroutine pack77_5

subroutine packtext77(c13,c71)

  character*13 c13,w
  character*71 c71
  character*42 c
  character*1 qa(10),qb(10)
  data c/' 0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ+-./?'/

  call mp_short_init
  qa=char(0)
  w=adjustr(c13)
  do i=1,13
     j=index(c,w(i:i))-1
     if(j.lt.0) j=0
     call mp_short_mult(qb,qa(2:10),9,42)     !qb(1:9)=42*qa(2:9)
     call mp_short_add(qa,qb(2:10),9,j)      !qa(1:9)=qb(2:9)+j
  enddo

  write(c71,1010) qa(2:10)
1010 format(b7.7,8b8.8)

  return
end subroutine packtext77

subroutine unpacktext77(c71,c13)

  integer*1   ia(10)
  character*1 qa(10),qb(10)
  character*13 c13
  character*71 c71
  character*42 c
  equivalence (qa,ia),(qb,ib)
  data c/' 0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZ+-./?'/

  qa(1)=char(0)
  read(c71,1010) qa(2:10)
1010 format(b7.7,8b8.8)

  do i=13,1,-1
     call mp_short_div(qb,qa(2:10),9,42,ir)
     c13(i:i)=c(ir+1:ir+1)
     qa(2:10)=qb(1:9)
  enddo

  return
end subroutine unpacktext77

subroutine mp_short_ops(w,u)
  character*1 w(*),u(*)
  integer i,ireg,j,n,ir,iv,ii1,ii2
  character*1 creg(4)
  save ii1,ii2
  equivalence (ireg,creg)

  entry mp_short_init
  ireg=256*ichar('2')+ichar('1')
  do j=1,4
     if (creg(j).eq.'1') ii1=j
     if (creg(j).eq.'2') ii2=j
  enddo
  return

  entry mp_short_add(w,u,n,iv)
  ireg=256*iv
  do j=n,1,-1
     ireg=ichar(u(j))+ichar(creg(ii2))
     w(j+1)=creg(ii1)
  enddo
  w(1)=creg(ii2)
  return

  entry mp_short_mult(w,u,n,iv)
  ireg=0
  do j=n,1,-1
     ireg=ichar(u(j))*iv+ichar(creg(ii2))
     w(j+1)=creg(ii1)
  enddo
  w(1)=creg(ii2)
  return

  entry mp_short_div(w,u,n,iv,ir)
  ir=0
  do j=1,n
     i=256*ir+ichar(u(j))
     w(j)=char(i/iv)
     ir=mod(i,iv)
  enddo
  return
  
  return
end subroutine mp_short_ops

subroutine add_call_to_recent_calls(callsign,nthr)

  character*13 callsign
  logical ladd
  integer, intent(in) :: nthr

! only add if the callsign is not already on the list
  ladd=.true.
  do i=1,MAXRECENT-1 ! if callsign is at the end of the list add it again
     if(recent_calls(i).eq.callsign) ladd=.false.
  enddo

  if(ladd) then
     do i=MAXRECENT,2,-1
        recent_calls(i)=recent_calls(i-1)
     enddo
     recent_calls(1)=callsign
  endif

! Make sure that callsign is hashed
  call save_hash_call(callsign,nthr)

  return
end subroutine add_call_to_recent_calls

subroutine to_grid4(n,grid4,ok)
  character*4 grid4
  logical ok

  ok=.false.
  j1=n/(18*10*10)
  if (j1.lt.0.or.j1.gt.17) goto 900
  n=n-j1*18*10*10
  j2=n/(10*10)
  if (j2.lt.0.or.j2.gt.17) goto 900
  n=n-j2*10*10
  j3=n/10
  if (j3.lt.0.or.j3.gt.9) goto 900
  j4=n-j3*10
  if (j4.lt.0.or.j4.gt.9) goto 900
  grid4(1:1)=char(j1+ichar('A'))
  grid4(2:2)=char(j2+ichar('A'))
  grid4(3:3)=char(j3+ichar('0'))
  grid4(4:4)=char(j4+ichar('0'))
  ok=.true.

900 return
end subroutine to_grid4

subroutine to_grid6(n,grid6,ok)
  character*6 grid6
  logical ok

  ok=.false.
  j1=n/(18*10*10*24*24)
  if (j1.lt.0.or.j1.gt.17) goto 900
  n=n-j1*18*10*10*24*24
  j2=n/(10*10*24*24)
  if (j2.lt.0.or.j2.gt.17) goto 900
  n=n-j2*10*10*24*24
  j3=n/(10*24*24)
  if (j3.lt.0.or.j3.gt.9) goto 900
  n=n-j3*10*24*24
  j4=n/(24*24)
  if (j4.lt.0.or.j4.gt.9) goto 900
  n=n-j4*24*24
  j5=n/24
  if (j5.lt.0.or.j5.gt.23) goto 900
  j6=n-j5*24
  if (j6.lt.0.or.j6.gt.23) goto 900
  grid6(1:1)=char(j1+ichar('A'))
  grid6(2:2)=char(j2+ichar('A'))
  grid6(3:3)=char(j3+ichar('0'))
  grid6(4:4)=char(j4+ichar('0'))
  grid6(5:5)=char(j5+ichar('A'))
  grid6(6:6)=char(j6+ichar('A'))  
  ok=.true.

900 return
end subroutine to_grid6

subroutine to_grid(n,grid6,ok)
  ! 4-, or 6-character grid
  character*6 grid6
  logical ok

  ok=.false.
  j1=n/(18*10*10*25*25)
  if (j1.lt.0.or.j1.gt.17) goto 900
  n=n-j1*18*10*10*25*25
  j2=n/(10*10*25*25)
  if (j2.lt.0.or.j2.gt.17) goto 900
  n=n-j2*10*10*25*25
  j3=n/(10*25*25)
  if (j3.lt.0.or.j3.gt.9) goto 900
  n=n-j3*10*25*25
  j4=n/(25*25)
  if (j4.lt.0.or.j4.gt.9) goto 900
  n=n-j4*25*25
  j5=n/25
  if (j5.lt.0.or.j5.gt.24) goto 900
  j6=n-j5*25
  if (j6.lt.0.or.j6.gt.24) goto 900
  grid6=''
  grid6(1:1)=char(j1+ichar('A'))
  grid6(2:2)=char(j2+ichar('A'))
  grid6(3:3)=char(j3+ichar('0'))
  grid6(4:4)=char(j4+ichar('0'))
  if (j5.ne.24.or.j6.ne.24) then
     grid6(5:5)=char(j5+ichar('A'))
     grid6(6:6)=char(j6+ichar('A'))
  endif
  ok=.true.

900 return
end subroutine to_grid

end module packjt77

module ft8_decode

  type :: ft8_decoder
     procedure(ft8_decode_callback), pointer :: callback
   contains
     procedure :: decode
  end type ft8_decoder

  abstract interface
     subroutine ft8_decode_callback (this,snr,dt,freq,decoded,servis8)
       import ft8_decoder
       implicit none
       class(ft8_decoder), intent(inout) :: this
       integer, intent(in) :: snr
       real, intent(in) :: dt,freq
       character(len=26), intent(in) :: decoded
       character(len=1), intent(in) :: servis8
     end subroutine ft8_decode_callback
  end interface

contains

  subroutine decode(this,callback,nQSOProgress,nfqso,nft8rxfsens,nftx,nutc,nfa,nfb,ncandthin,ndtcenter,nsec, &
                    napwid,swl,lmycallstd,lhiscallstd,filter,stophint,nthr,numthreads,nagainfil,lft8lowth,   &
                    lft8subpass,lhideft8dupes,lhidehash)
!use wavhdr
!    use timer_module, only: timer
 !$ use omp_lib
    use ft8_mod1, only : ndecodes,allmessages,allsnrs,allfreq,odd,even,nmsg,lastrxmsg,lasthcall,calldteven,calldtodd,incall, &
                         oddcopy,evencopy,avexdt,mycall,hiscall,dd8,nft8cycles,nft8swlcycles,ncandallthr,nincallthr,evencq,  &
                         oddcq,numcqsig,numdeccq,evenmyc,oddmyc,nummycsig,numdecmyc,lapmyc,evenqso,oddqso,lqsomsgdcd,hisgrid4
    use ft4_mod1, only : lhidetest,lhidetelemetry
    include 'ft8_params.f90'
!type(hdr) h

    class(ft8_decoder), intent(inout) :: this
    procedure(ft8_decode_callback) :: callback
!    real sbase(NH1)
!integer*2 iwave(180000)
    real, DIMENSION(:), ALLOCATABLE :: dd8m
    real candidate(4,460),freqsub(200)
    integer, intent(in) :: nQSOProgress,nfqso,nft8rxfsens,nftx,nfa,nfb,ncandthin,ndtcenter,nsec,napwid,nthr,numthreads
    logical, intent(in) :: nagainfil
    logical(1), intent(in) :: swl,filter,stophint,lft8lowth,lft8subpass,lhideft8dupes, &
                              lhidehash,lmycallstd,lhiscallstd
    logical newdat1,lsubtract,ldupe,lFreeText,lspecial
    logical(1) lft8sdec,lft8s,lft8sd,lrepliedother,lhashmsg,lqsothread,lhidemsg,lhighsens,lcqcand,lsubtracted,levenint,loddint, &
               lnohiscall,lnomycall,lnohisgrid
    character msg37*37,msg37_2*37,msg26*26,servis8*1,datetime*13,call2*12
    character*37 msgsrcvd(130)

    type oddtmp_struct
      real freq
      real dt
      logical lstate
      character*37 msg
    end type oddtmp_struct
    type(oddtmp_struct) oddtmp(130)

    type eventmp_struct
      real freq
      real dt
      logical lstate
      character*37 msg
    end type eventmp_struct
    type(eventmp_struct) eventmp(130)

    type tmpcqdec_struct
      real freq
      real xdt
    end type tmpcqdec_struct
    type(tmpcqdec_struct) tmpcqdec(numdeccq) ! 40 sigs

    type tmpcqsig_struct
      real freq
      real xdt
      complex cs(0:7,79)
    end type tmpcqsig_struct
    type(tmpcqsig_struct) tmpcqsig(numcqsig) ! 20 sigs

    type tmpmyc_struct
      real freq
      real xdt
    end type tmpmyc_struct
    type(tmpmyc_struct) tmpmyc(numdecmyc) ! 25 sigs

    type tmpmycsig_struct
      real freq
      real xdt
      complex cs(0:7,79)
    end type tmpmycsig_struct
    type(tmpmycsig_struct) tmpmycsig(nummycsig) ! 5 sigs

    type tmpqsosig_struct
      real freq
      real xdt
      complex cs(0:7,79)
    end type tmpqsosig_struct
    type(tmpqsosig_struct) tmpqsosig(1)

    this%callback => callback

    oddtmp%lstate=.false.; eventmp%lstate=.false.; nmsgloc=0; ncandthr=0
    nmsgcq=0; tmpcqdec(:)%freq=6000.0; nmsgmyc=0; tmpmyc(:)%freq=6000.0
    tmpcqsig(:)%freq=6000.0; tmpmycsig(:)%freq=6000.0; tmpqsosig(1)%freq=6000.0
    if(hiscall.eq.'') then; lastrxmsg(1)%lstate=.false. 
    else if(lastrxmsg(1)%lstate .and. lasthcall.ne.hiscall .and. index(lastrxmsg(1)%lastmsg,trim(hiscall)).le.0) &
          then; lastrxmsg(1)%lstate=.false.
    endif

    levenint=.false.; loddint=.false.
    if(nsec.eq.0 .or. nsec.eq.30) then; levenint=.true.
    elseif(nsec.eq.15 .or. nsec.eq.45) then; loddint=.true.
    endif

    lrepliedother=.false.; lft8sdec=.false.; lqsothread=.false.; lsubtracted=.false.!; lthrdecd=.false.
    ncount=0; servis8=' '; mycalllen1=len_trim(mycall)+1; nincallthr(nthr)=0; nallocthr=0; ncqsignal=0; nmycsignal=0
!print *,lastrxmsg(1)%lstate,lastrxmsg(1)%xdt,lastrxmsg(1)%lastmsg
    write(datetime,1001) nutc        !### TEMPORARY ###
1001 format("000000_",i6.6)

    lnohiscall=.false.; if(len_trim(hiscall).lt.3) lnohiscall=.true.
    lnomycall=.false.; if(len_trim(mycall).lt.3) lnomycall=.true.
    lnohisgrid=.false.; if(len_trim(hisgrid4).ne.4) lnohisgrid=.true.

    if(nfqso.ge.nfa .and. nfqso.le.nfb) lqsothread=.true.

    if(lqsothread .and. .not.lastrxmsg(1)%lstate .and. .not.stophint .and. hiscall.ne.'') then
! got incoming call
      do i=1,30
        if(incall(i)%msg(1:1).eq." ") exit
        if(index(incall(i)%msg,(trim(mycall)//' '//trim(hiscall))).eq.1) then
          lastrxmsg(1)%lastmsg=incall(i)%msg; lastrxmsg(1)%xdt=incall(i)%xdt; lastrxmsg(1)%lstate=.true.; exit
        endif
      enddo

      if(.not.lastrxmsg(1)%lstate) then
! calling someone, lastrxmsg still not valid
        if(levenint) then
          do i=1,130
            if(.not.evencopy(i)%lstate) cycle
            if(index(evencopy(i)%msg,' '//trim(hiscall)//' ').gt.1) then
              lastrxmsg(1)%lastmsg=evencopy(i)%msg; lastrxmsg(1)%xdt=evencopy(i)%dt; lastrxmsg(1)%lstate=.true.; exit
            endif
          enddo
        elseif(loddint) then
          do i=1,130
            if(.not.oddcopy(i)%lstate) cycle
              if(index(oddcopy(i)%msg,' '//trim(hiscall)//' ').gt.1) then
                lastrxmsg(1)%lastmsg=oddcopy(i)%msg; lastrxmsg(1)%xdt=oddcopy(i)%dt; lastrxmsg(1)%lstate=.true.; exit
              endif
          enddo
        endif
      endif
    endif

!print *,'in',lastrxmsg(1)%lstate
!print *,lastrxmsg(1)%lastmsg
!write(*,1018) nQSOProgress,'d'
!1018 format(i1,46x,a1)

! sliding search over +/- 2.5s relative to 0.5s TX start time
    jzb=-62 + avexdt*25.;  jzt=62 + avexdt*25.
! sliding search over +/- 3.5s relative to 0.5s TX start time
    if(swl) then; jzb=-86 + avexdt*25.;  jzt=86 + avexdt*25.; endif

    npass=3 ! fallback
    if(swl) then
      if(nft8swlcycles.eq.1) then; npass=3
      else if(nft8swlcycles.eq.2) then; npass=6
      else if(nft8swlcycles.eq.3) then; npass=9
      else; npass=3
      endif
    else
      if(nft8cycles.eq.1) then; npass=3
      else if(nft8cycles.eq.2) then; npass=6
      else if(nft8cycles.eq.3) then; npass=9
      else; npass=3
      endif
    endif
    syncmin=1.5
    do ipass=1,npass
      newdat1=.true.; lsubtract=.true.; npos=0
      if(ipass.eq.1 .or. ipass.eq.4 .or. ipass.eq.7) then
        if(lft8lowth .or. swl) syncmin=1.225
      elseif(ipass.eq.2 .or. ipass.eq.5 .or. ipass.eq.8) then
         if(lft8lowth .or. swl) syncmin=1.5
      elseif(ipass.eq.3 .or. ipass.eq.6 .or. ipass.eq.9) then
         if(lft8lowth .or. swl) syncmin=1.1
      endif
      if(ipass.gt.5 .or. (ipass.eq.3 .and. npass.eq.3 .and. .not.swl)) lsubtract=.false.
      if(ipass.eq.4) then
!$omp barrier
!$omp single
          if(npass.eq.9) then ! 3 decoding cycles
            nallocthr=nthr
            allocate(dd8m(180000), STAT = nAllocateStatus1)
            if(nAllocateStatus1.ne.0) STOP "Not enough memory"
            dd8m=dd8
          endif
          do i=1,179999; dd8(i)=(dd8(i)+dd8(i+1))/2; enddo
!$omp end single
!$omp barrier
      else if(ipass.eq.7) then
!$omp barrier
        if(nthr.eq.nallocthr) then
          dd8(1)=dd8m(1)
          do i=2,180000; dd8(i)=(dd8m(i-1)+dd8m(i))/2; enddo
          deallocate (dd8m, STAT = nDeAllocateStatus1)
          if (nDeAllocateStatus1.ne.0) print *, 'failed to release memory'
        endif
!$omp barrier
      endif
      !call timer('sync8   ',0)
      call sync8(nfa,nfb,syncmin,nfqso,candidate,ncand,jzb,jzt,swl,ipass,lqsothread,ncandthin,filter,ndtcenter)
      !call timer('sync8   ',1)
      do icand=1,ncand
        sync=candidate(3,icand)
        f1=candidate(1,icand)
        xdt=candidate(2,icand)
        lcqcand=.false.; if(candidate(4,icand).gt.1.0) lcqcand=.true.
        lhighsens=.false.
        if(sync.lt.1.9 .or. ((ipass.eq.2 .or. ipass.eq.4 .or. ipass.eq.6).and. sync.lt.3.15)) lhighsens=.true.
        lspecial=.false.; lFreeText=.false.; i3bit=0; lft8s=.false.; lft8sd=.false.; lhashmsg=.false.; iaptype=0
        msg37='';i3=16;n3=16
        !call timer('ft8b    ',0)
!if(nthr.eq.1) print *,ipass,'nthr1',newdat1
!if(nthr.eq.2) print *,ipass,'nthr2',newdat1
!write (*,"(F5.2,1x,I1,1x,I4,1x,F4.2)") candidate(2,icand)-0.5,ipass,nint(candidate(1,icand)),candidate(3,icand)
        call ft8b(newdat1,nQSOProgress,nfqso,nftx,napwid,lsubtract,npos,freqsub,tmpcqdec,tmpmyc,              &
                  nagainfil,iaptype,f1,xdt,nbadcrc,lft8sdec,msg37,msg37_2,xsnr,swl,stophint,               &
                  nthr,lFreeText,ipass,lft8subpass,lspecial,lcqcand,ncqsignal,nmycsignal,npass,            &
                  i3bit,lhidehash,lft8s,lmycallstd,lhiscallstd,levenint,loddint,lft8sd,i3,n3,nft8rxfsens,  &
                  ncount,msgsrcvd,lrepliedother,lhashmsg,lqsothread,lft8lowth,lhighsens,lsubtracted,       &
                  tmpcqsig,tmpmycsig,tmpqsosig,lnohiscall,lnomycall,lnohisgrid)
        nsnr=nint(xsnr)
        xdt=xdt-0.5
        !call timer('ft8b    ',1)
        if(nbadcrc.eq.0) then
          lhidemsg=.false.
          if(lhidetelemetry .and. i3.eq.0 .and. n3.eq.5) lhidemsg=.true.
          if(lhidetest) then
            if((i3.eq.0 .and. n3.gt.1 .and. n3.lt.5) .or. i3.eq.3 .or. i3.gt.4) then
              if(mycalllen1.lt.4 .or. msg37(1:mycalllen1).ne.trim(mycall)//' ') lhidemsg=.true.
            endif
            if(msg37(1:3).eq.'CQ ') then
              if(msg37(1:6).eq.'CQ RU ' .or. msg37(1:6).eq.'CQ FD ' .or. msg37(1:8).eq.'CQ TEST ') lhidemsg=.true.
            endif
          endif

          if(lspecial) then; nspecial=2; else; nspecial=1; endif
          do k=1,nspecial
            if(k.eq.2) msg37=msg37_2
            ldupe=.false.
            if(msg37(1:6).eq."      ") ldupe=.true. 
            if(.not.ldupe .and. ndecodes.gt.0) then
              do idec=1,ndecodes
                if(lhideft8dupes) then
                  if(msg37.eq.allmessages(idec) .and. (nsnr.le.allsnrs(idec) .or. &
                     (nsnr.gt.allsnrs(idec) .and. abs(allfreq(idec)-f1).lt.45.0))) then
                    ldupe=.true.; exit
                  endif
                else
                  if(msg37.eq.allmessages(idec) .and. ((nsnr.le.allsnrs(idec) .and. &
                     abs(allfreq(idec)-f1).lt.45.0) .or. (nsnr.gt.allsnrs(idec) .and. &
                     abs(allfreq(idec)-f1).lt.45.0 .and. numthreads.ne.1))) then
                    ldupe=.true.; exit
                  endif
                endif
              enddo
            endif
            if(.not.ldupe) then
              if(.not.lFreeText .and. k.eq.1) call extract_call(msg37,call2)
!$omp critical(update_arrays)
              ndecodes=ndecodes+1; allmessages(ndecodes)=msg37; allsnrs(ndecodes)=nsnr; allfreq(ndecodes)=f1
              if(.not.lhidemsg) then
 ! simulated wav tests affected, structure contains data for at least previous and current even|odd intervals
                if(levenint) then
                  calldteven(150:2:-1)=calldteven(150-1:1:-1); calldteven(1)%call2=call2; calldteven(1)%dt=xdt
                else if(loddint) then
                  calldtodd(150:2:-1)=calldtodd(150-1:1:-1); calldtodd(1)%call2=call2; calldtodd(1)%dt=xdt
                endif
              endif
!$omp end critical(update_arrays)
              if(.not.lhidemsg) then
                if(iaptype.eq.0) then
                  if(.not.lFreeText .or. lspecial) servis8=' '
                  if(.not.lspecial .and. lFreeText) then
                    if(abs(nfqso-nint(f1)).le.10) then; servis8=','; else; servis8='.'; endif
                  endif
                  if(lft8sd .or. lft8s) servis8='^'
                else
                  if(lft8sd .or. lft8s) then; servis8='^'; else; servis8='*'; endif
                endif
                if(i3bit.eq.1) servis8='1'
!write (*,"(F5.2,1x,I1,1x,I4,1x,F4.2)") candidate(2,icand)-0.5,ipass,nint(candidate(1,icand)),candidate(3,icand)
!write (*,"(I1,1x,F4.2)") ipass,candidate(3,icand)
!print *,candidate(2,icand)-0.5,msg37
!print *,msg37
                msg26=msg37(1:26)
                if(associated(this%callback)) call this%callback(nsnr,xdt,f1,msg26,servis8)
              endif

              if(msg37(1:3).eq.'CQ ' .and. nmsgcq.lt.numdeccq) then
                nmsgcq=nmsgcq+1; xdtr=xdt+0.5
                tmpcqdec(nmsgcq)%freq=f1; tmpcqdec(nmsgcq)%xdt=xdtr
              endif
              if(lapmyc .and. lmycallstd) then
                ispc1=index(msg37,' ')
                if(msg37(1:ispc1-1).eq.trim(mycall) .and. nmsgmyc.lt.numdecmyc) then
                  nmsgmyc=nmsgmyc+1; xdtr=xdt+0.5
                  tmpmyc(nmsgmyc)%freq=f1; tmpmyc(nmsgmyc)%xdt=xdtr
                endif
              endif

              if(i3.eq.4 .and. msg37(1:3).eq.'CQ ' .and. mod(nsec,15).eq.0 .and. nmsgloc.lt.130) then
                nmsgloc=nmsgloc+1
                if(levenint) then
                  eventmp(nmsgloc)%msg=msg37; eventmp(nmsgloc)%freq=f1
                  eventmp(nmsgloc)%dt=xdt; eventmp(nmsgloc)%lstate=.true.
                endif
                if(loddint) then
                  oddtmp(nmsgloc)%msg=msg37; oddtmp(nmsgloc)%freq=f1
                  oddtmp(nmsgloc)%dt=xdt; oddtmp(nmsgloc)%lstate=.true.
                endif
                go to 4 ! tmp filled in
              endif
              if(.not.lFreeText) then ! protection against any possible free txtmsg bit corruption
                ispc1=index(msg37,' ')
                if(.not.lhashmsg .and. mod(nsec,15).eq.0 .and. ((i3.eq.1 .and. .not.lft8sd) .or. lft8sd) .and. &
                   msg37(1:ispc1-1).ne.trim(mycall) .and. nmsgloc.lt.130 .and. index(msg37,'<').le.0) then
                  if(index(msg37,'/').gt.0 .and. msg37(1:3).ne.'CQ ') go to 4 ! compound not supported
                  nmsgloc=nmsgloc+1
                  if(levenint) then
                    eventmp(nmsgloc)%msg=msg37; eventmp(nmsgloc)%freq=f1
                    eventmp(nmsgloc)%dt=xdt; eventmp(nmsgloc)%lstate=.true.
                  endif
                  if(loddint) then
                    oddtmp(nmsgloc)%msg=msg37; oddtmp(nmsgloc)%freq=f1
                    oddtmp(nmsgloc)%dt=xdt; oddtmp(nmsgloc)%lstate=.true.
                  endif
                endif
              endif
            endif
4           continue
          enddo
        endif
      enddo
      ncandthr=ncandthr+ncand
    enddo
! h=default_header(12000,NMAX)
! open(10,file='subtract.wav',status='unknown',access='stream')
! iwave(1:180000)=nint(dd8(1:180000))
! write(10) h,iwave
! close(10)
    if(levenint) then
      evencq(1:ncqsignal,nthr)%freq=tmpcqsig(1:ncqsignal)%freq
      evencq(1:ncqsignal,nthr)%xdt=tmpcqsig(1:ncqsignal)%xdt
      do ik=1,ncqsignal; evencq(ik,nthr)%cs=tmpcqsig(ik)%cs; enddo
      if(lapmyc) then
        evenmyc(1:nmycsignal,nthr)%freq=tmpmycsig(1:nmycsignal)%freq
        evenmyc(1:nmycsignal,nthr)%xdt=tmpmycsig(1:nmycsignal)%xdt
        do ik=1,nmycsignal; evenmyc(ik,nthr)%cs=tmpmycsig(ik)%cs; enddo
        if(.not.lqsomsgdcd .and. tmpqsosig(1)%freq.lt.5001.) then
          evenqso(1,nthr)%freq=tmpqsosig(1)%freq; evenqso(1,nthr)%xdt=tmpqsosig(1)%xdt
          evenqso(1,nthr)%cs=tmpqsosig(1)%cs
        endif
      endif
    else if(loddint) then
      oddcq(1:ncqsignal,nthr)%freq=tmpcqsig(1:ncqsignal)%freq
      oddcq(1:ncqsignal,nthr)%xdt=tmpcqsig(1:ncqsignal)%xdt
      do ik=1,ncqsignal; oddcq(ik,nthr)%cs=tmpcqsig(ik)%cs; enddo
      if(lapmyc) then
        oddmyc(1:nmycsignal,nthr)%freq=tmpmycsig(1:nmycsignal)%freq
        oddmyc(1:nmycsignal,nthr)%xdt=tmpmycsig(1:nmycsignal)%xdt
        do ik=1,nmycsignal; oddmyc(ik,nthr)%cs=tmpmycsig(ik)%cs; enddo
        if(.not.lqsomsgdcd .and. tmpqsosig(1)%freq.lt.5001.) then
          oddqso(1,nthr)%freq=tmpqsosig(1)%freq; oddqso(1,nthr)%xdt=tmpqsosig(1)%xdt
          oddqso(1,nthr)%cs=tmpqsosig(1)%cs
        endif
      endif
    endif
    ncandthr=nint(float(ncandthr)/npass)
    ncandallthr(nthr)=ncandallthr(nthr)+ncandthr
    if(nmsgloc.gt.0) then
!$omp critical(update_structures)
      if(levenint) then
        even(nmsg+1:nmsg+nmsgloc)%msg=eventmp(1:nmsgloc)%msg; even(nmsg+1:nmsg+nmsgloc)%freq=eventmp(1:nmsgloc)%freq
        even(nmsg+1:nmsg+nmsgloc)%dt=eventmp(1:nmsgloc)%dt; even(nmsg+1:nmsg+nmsgloc)%lstate=eventmp(1:nmsgloc)%lstate
        nmsg=nmsg+nmsgloc
      else if(loddint) then
        odd(nmsg+1:nmsg+nmsgloc)%msg=oddtmp(1:nmsgloc)%msg; odd(nmsg+1:nmsg+nmsgloc)%freq=oddtmp(1:nmsgloc)%freq
        odd(nmsg+1:nmsg+nmsgloc)%dt=oddtmp(1:nmsgloc)%dt; odd(nmsg+1:nmsg+nmsgloc)%lstate=oddtmp(1:nmsgloc)%lstate
        nmsg=nmsg+nmsgloc
      endif
!$omp end critical(update_structures)
    endif
!print *,'out',lastrxmsg(1)%lstate
!print *,lastrxmsg(1)%lastmsg
    return
  end subroutine decode
end module ft8_decode

! This source code file was last time modified by Igor Chernikov UA3DJY on July 07th, 2016.
! All changes are shown in the patch file coming together with the full JTDX source code.

subroutine peakup(ym,y0,yp,dx)

real*4 b,c,dx,yp,ym,y0

  b=yp-ym
  c=yp+ym-2*y0
  dx=-((b/c)/2)

  return
end subroutine peakup

program count4

  parameter(NMAX=1000)
  character*47 line
  real snr(NMAX)
  real dt(NMAX)
  real f(NMAX)

  open(10,file='/users/joe/appdata/local/wsjt-x/all.txt',status='old')

  read(10,1000,end=10) line
1000 format(a47)

  nsync1=0
  nsync2=0
  n1=0
  n2=0
  nerr=0

  do i=1,99999
     read(10,1000,end=10) line
     if(line(47:47).ne.' ') cycle                !Skip average decodes
     if(line(20:20).eq.'*') nsync1=nsync1+1
     if(line(20:20).eq.'#') nsync2=nsync2+1
     if(line(22:34).eq.'CQ K1ABC FN42') then
        n2=n2+1                                  !Correlation decode
        read(line,1002) snr(n2),dt(n2),f(n2)
1002    format(4x,f4.0,f5.2,f5.0)
        if(line(42:42).eq.'*') n1=n1+1           !Convolutional decode
     else
        if(line(22:34).ne.'             ') nerr=nerr+1
     endif
  enddo

10 call stats(snr,n2,snrave,snrdev)
  call stats(dt,n2,dtave,dtdev)
  call stats(f,n2,fave,fdev)

write(*,1010) nsync1,nsync2,n1,n2,nerr,snrave,dtave,fave,snrdev,dtdev,fdev
1010 format(5i5,f7.1,f7.2,f7.0/25x,f7.1,f7.2,f7.0)

end program count4

subroutine stats(x,nz,ave,rms)
  real x(nz)

  ave=0.
  rms=0.
  if(nz.gt.0) ave=sum(x)/nz
  x=x-ave
  if(nz.gt.1) rms=sqrt(dot_product(x,x)/(nz-1))

  return
end subroutine stats

! This source code file is created by Igor Chernikov UA3DJY on June 24th, 2016 and 
! last time mofified on August 02nd, 2016.
! All changes are shown in the patch file coming together with the full JTDX source code.

module jt65_mod3

 complex cref(720000),camp(720000),cfilt(720000),cw(720000)
 save
end module jt65_mod3

subroutine mixlpf(x1,nbfo,c0)

  real*4 x1(512)
  real*8 twopi,phi,dphi
  complex c1(512),c2(105+512)
  complex c0(64)
  data phi/0.d0/
  save phi,c2

  twopi=8.d0*atan(1.d0)
  dphi=twopi*nbfo/12000.d0
  
  do i=1,512
     phi=phi+dphi
     if(phi.gt.twopi) phi=phi-twopi
     xphi=phi
     c1(i)=x1(i)*cmplx(cos(xphi),sin(xphi))
  enddo
  c2(106:105+512)=c1
  
  call fil3c(c2,105+512,c0,n2)
  c2(1:105)=c1(512-104:512)                       !Save 105 trailing samples

  return
end subroutine mixlpf

! last time modified by Igor UA3DJY on 20200202

subroutine wspr_downsample(id2,k)

! Input:
!  id2       raw 16-bit integer data, 12000 Hz sample rate
!  k         pointer to the most recent new data

! Output (in common/c0com)
!  c0        complex data downsampled to 1500 Hz

  parameter (NMAX=120*12000)         !Total sample intervals per 30 minutes
  parameter (NDMAX=120*1500)         !Sample intervals at 1500 Hz rate
!  parameter (NSMAX=1366)             !Max length of saved spectra
  parameter (NFFT1=1024)
  parameter (MAXFFT3=32768)
  real*4 w3(MAXFFT3)
  real*4 x0(NFFT1)
  integer*2 id2(NMAX)
  complex c0
  common/c0com/c0(NDMAX)
!  data rms/999.0/,k0/99999999/,nfft3z/0/,nsps/8192/,nbfo/1500/
  data k0/99999999/,nfft3z/0/,nsps/8192/,nbfo/1500/
  save

  nfft3=nsps/4
!  jstep=nsps/16
  if(k.gt.NMAX) go to 999
  if(k.lt.nfft3) go to 999                   !Wait for enough samples to start
  if(nfft3.ne.nfft3z) then
     pi=4.0*atan(1.0)
     do i=1,nfft3
        w3(i)=2.0*(sin(i*pi/nfft3))**2             !Window for nfft3
     enddo
     nfft3z=nfft3
  endif

  if(k.lt.k0) then
     k1=0
     k8=0
!     if(ndiskdat.eq.0) then
!        id2(k+1:)=0
!        c0=0.          !This is necessary to prevent "ghosts".  Not sure why.
!     endif
  endif
  k0=k
 
!  nzap=0
!  nbslider=0
!  sigmas=1.0*(10.0**(0.01*nbslider)) + 0.7
!  peaklimit=sigmas*max(10.0,rms)
!  px=0.

!  nwindow=2
!  kstep1=NFFT1
!  if(nwindow.ne.0) kstep1=NFFT1/2
  kstep1=NFFT1/2
  nblks=(k-k1)/kstep1
!  gain=1.0
!  nb=0
  do nblk=1,nblks
     do i=1,NFFT1
!        x0(i)=gain*id2(k1+i)
        x0(i)=float(id2(k1+i))
     enddo
!     call timf2(x0,k,NFFT1,nwindow,nb,peaklimit,x1,   &
!          slimit,lstrong,px,nzap)
! Mix at nbfo Hz, lowpass at +/-750 Hz, and downsample to 1500 Hz complex.
     call mixlpf(x0,nbfo,c0(k8+1))
     k1=k1+kstep1
     k8=k8+kstep1/8
  enddo

999 return
end subroutine wspr_downsample

subroutine chkcall(w,bc,cok)

! Check "w" to see if it could be a valid standard callsign or a valid
! compound callsign.
! Return base call "bc" and a logical "cok" indicator.

  character w*13                            !A putative callsign
  character bc*6                            !Base call (tentative)
  character c*1
  logical cok,isdigit,isletter
  
  isdigit(c)=(ichar(c).ge.ichar('0')) .and. (ichar(c).le.ichar('9'))
  isletter(c)=(ichar(c).ge.ichar('A')) .and. (ichar(c).le.ichar('Z'))
  
  cok=.true.
  bc=w(1:6)
  n1=len_trim(w)
  if(n1.gt.11) go to 100
  if(index(w,'.').ge.1) go to 100
  if(index(w,'+').ge.1) go to 100
  if(index(w,'-').ge.1) go to 100
  if(index(w,'?').ge.1) go to 100
  if(n1.gt.6 .and. index(w,'/').le.0) go to 100

  i0=index(w,'/')
  if(max(i0-1,n1-i0).gt.6) go to 100      !Base call must be < 7 characters
  if(i0.ge.2 .and. i0.le.n1-1) then       !Extract base call from compound call
     if(i0-1.le.n1-i0) bc=w(i0+1:n1)//'   '
     if(i0-1.gt.n1-i0) bc=w(1:i0-1)//'   '
  endif

  nbc=len_trim(bc)
  if(nbc.gt.6) go to 100  !Base call should have no more than 6 characters

! One of first two characters (c1 or c2) must be a letter
  if((.not.isletter(bc(1:1))) .and. (.not.isletter(bc(2:2)))) go to 100
  if(bc(1:1).eq.'Q') go to 100              !Calls don't start with Q

! Must have a digit in 2nd or 3rd position
  i1=0
  if(isdigit(bc(2:2))) i1=2
  if(isdigit(bc(3:3))) i1=3
  if(i1.eq.0) go to 100

! Callsign must have a suffix of 1-3 letters
  if(i1.eq.nbc) go to 100
  n=0
  do i=i1+1,nbc
     j=ichar(bc(i:i))
     if(j.lt.ichar('A') .or. j.gt.ichar('Z')) go to 100
     n=n+1
  enddo
  if(n.ge.1 .and. n.le.3) go to 200

100 cok=.false.
     
200 return
end subroutine chkcall

subroutine indexx(arr,n,indx)

  parameter (M=7,NSTACK=50)
  integer n,indx(n)
  real arr(n)
  integer i,indxt,ir,itemp,j,jstack,k,l,istack(NSTACK)
  real a

  do j=1,n
     indx(j)=j
  enddo

  jstack=0
  l=1
  ir=n
1 if(ir-l.lt.M) then
     do j=l+1,ir
        indxt=indx(j)
        a=arr(indxt)
        do i=j-1,1,-1
           if(arr(indx(i)).le.a) goto 2
           indx(i+1)=indx(i)
        enddo
        i=0
2       indx(i+1)=indxt
     enddo
     if(jstack.eq.0) return

     ir=istack(jstack)
     l=istack(jstack-1)
     jstack=jstack-2

  else
     k=(l+ir)/2
     itemp=indx(k)
     indx(k)=indx(l+1)
     indx(l+1)=itemp

     if(arr(indx(l+1)).gt.arr(indx(ir))) then
        itemp=indx(l+1)
        indx(l+1)=indx(ir)
        indx(ir)=itemp
     endif

     if(arr(indx(l)).gt.arr(indx(ir))) then
        itemp=indx(l)
        indx(l)=indx(ir)
        indx(ir)=itemp
     endif

     if(arr(indx(l+1)).gt.arr(indx(l))) then
        itemp=indx(l+1)
        indx(l+1)=indx(l)
        indx(l)=itemp
     endif

     i=l+1
     j=ir
     indxt=indx(l)
     a=arr(indxt)
3    continue
     i=i+1
     if(arr(indx(i)).lt.a) goto 3

4    continue
     j=j-1
     if(arr(indx(j)).gt.a) goto 4
     if(j.lt.i) goto 5
     itemp=indx(i)
     indx(i)=indx(j)
     indx(j)=itemp
     goto 3

5    indx(l)=indx(j)
     indx(j)=indxt
     jstack=jstack+2
     if(jstack.gt.NSTACK) stop 'NSTACK too small in indexx'
     if(ir-i+1.ge.j-l)then
        istack(jstack)=ir
        istack(jstack-1)=i
        ir=j-1
     else
        istack(jstack)=j-1
        istack(jstack-1)=l
        l=i
     endif
  endif
  goto 1

end subroutine indexx

subroutine interleave63(d1,idir)

! Interleave (idir=1) or de-interleave (idir=-1) the array d1.

  integer d1(0:6,0:8)
  integer d2(0:8,0:6)

  if(idir.ge.0) then
     do i=0,6
        do j=0,8
           d2(j,i)=d1(i,j)
        enddo
     enddo
     call move(d2,d1,63)
  else
     call move(d1,d2,63)
     do i=0,6
        do j=0,8
           d1(i,j)=d2(j,i)
        enddo
     enddo
  endif
         
  return
end subroutine interleave63

subroutine genft8(msg,i3,n3,ntxhash,msgsent,msgbits,itone)

! Encode an FT8 message, producing array itone().
  
  use packjt77
  use ft8_mod1, only : icos7,graymap
  character msg*37,msgsent*37,c77*77
  integer*1 msgbits(77),codeword(174)
  integer itone(79)
  logical unpk77_success

  i3=-1
  n3=-1
  call pack77(msg,i3,n3,c77,ntxhash)
  if(ntxhash.eq.1) then
    call unpack77(c77,0,msgsent,unpk77_success,26) !TX message, unpack to get msgsent, use TX hash tables and do not save RX hash values
  else
    call unpack77(c77,0,msgsent,unpk77_success,27) !service message, unpack to get msgsent. Do not save hash values
  endif
  read(c77,'(77i1)',err=1) msgbits
  if(unpk77_success) go to 2
1 msgbits=0
  itone=0
  msgsent='*** bad message ***                  '
  go to 900

entry get_tones_from_77bits(msgbits,itone) 

2  call encode174_91(msgbits,codeword)      !Encode the test message

! Message structure: S7 D29 S7 D29 S7
  itone(1:7)=icos7; itone(37:43)=icos7; itone(73:79)=icos7
  k=7
  do j=1,58
     i=3*j -2
     k=k+1
     if(j.eq.30) k=k+7
     indx=codeword(i)*4 + codeword(i+1)*2 + codeword(i+2)
     itone(k)=graymap(indx)
  enddo

900 return
end subroutine genft8

! This source code file was last time modified by Igor UA3DJY on 20181215
! All changes are shown in the patch file coming together with the full JTDX source code.

subroutine hintdxrr9(mrs,mrs2,mycall,hiscall,decoded,hintdec,s3,i4GrayCodedSym)

  use packjt
  parameter (MAXRPT=33)
  parameter (MAXMSG=MAXRPT)
  real u1
  real s3(0:7,69)
  integer mrs(69),mrs2(69),sym2(0:68,MAXMSG),sym_rev(0:68)
  integer*4 i4Msg6BitWords(13)            !72-bit message as 6-bit words
  integer*1 i1Msg8BitBytes(13)            !72 bits and zero tail as 8-bit bytes
  integer*1 i1EncodedBits(207)            !Encoded information-carrying bits
  integer*1 i1ScrambledBits(207)          !Encoded bits after interleaving
  integer*4 i4DataSymbols(69)             !Data symbols (values 0-7)
  integer*4 i4GrayCodedSym(69)        !Gray-coded symbols (values 0-7)
  logical(1) hintdec
  character mycall*6,hiscall*6,msg*22,msg00*22,decoded*22,prevcall*6
  character*4 rpt(MAXRPT)
  character*22 msg0(MAXMSG)

  data rpt/'R-01','R-02','R-03','R-04','R-05',     &
           'R-06','R-07','R-08','R-09','R-10',     &
           'R-11','R-12','R-13','R-14','R-15',     &
           'R-16','R-17','R-18','R-19','R-20',     &
           'R-21','R-22','R-23','R-24','R-25',     &
           'R-26','R-27','R-28','R-29','R-30',     &
           'R-31','R-32','R-33'/

  save msg0,sym2,prevcall

  hintdec=.false.
  if(hiscall.eq.'') return
  do i=1,6
   if(hiscall(i:i).eq.'/') return
  enddo

  if(hiscall.eq.prevcall) then
     go to 2
  else
     prevcall=hiscall
  endif

  nsym2=206

  do m=1,MAXMSG
     msg=mycall//' '//hiscall//' '//rpt(m)
     call fmtmsg(msg,iz)
     call packmsg(msg,i4Msg6BitWords,itype)  !Pack into 12 6-bit bytes
     call entail(i4Msg6BitWords,i1Msg8BitBytes)  !Add tail, make 8-bit bytes
     call encode232(i1Msg8BitBytes,nsym2,i1EncodedBits)   !Encode K=32, r=1/2
     i1EncodedBits(207)=0
     call interleave9(i1EncodedBits,1,i1ScrambledBits)    !Interleave bits
     i1ScrambledBits(207)=0
     call packbits(i1ScrambledBits,69,3,i4DataSymbols)    !Pk 3-bits into words
     call graycode(i4DataSymbols,69,1,sym_rev) !Apply Gray code
     sym2(0:68,m)=sym_rev(0:68)
     msg0(m)=msg
  enddo

2  ref0=0.
   do j=1,69
      ref0=ref0 + s3(mrs(j),j)
   enddo

  u1=-99.0
  u2=u1

! Find u1 and u2 (best and second-best) codeword from a list, using 
! a bank of matched filters on the symbol spectra s3(i,j).
  ipk=1
  msg00='                      '
  do k=1,MAXMSG
        psum=0.
        ref=ref0
        do j=1,69
           i=sym2(j-1,k)
           psum=psum + s3(i,j)
           if(i.eq.mrs(j)) ref=ref - s3(i,j) + s3(mrs2(j),j)
        enddo
        p=psum/ref

        if(p.gt.u1) then
           if(msg0(k).ne.msg00) u2=u1
           u1=p
           ipk=k
           msg00=msg0(k)
        endif
        if(msg0(k).ne.msg00 .and. p.gt.u2) u2=p
  enddo

  decoded='                      '
  bias=max(1.12*u2,0.35)
  qual=100.0*(u1-bias)
  thresh=qual*u1
! maximizing sensitivity .and. blocking some false decodes
  if((qual.ge.5.0 .or. u1.ge.0.736) .and. thresh.gt.10.15) then
    decoded=msg0(ipk)
!print *,qual,u1,thresh
!print *,thresh
!print *,decoded
    hintdec=.true.
    i4GrayCodedSym(1:69)=sym2(0:68,ipk)
  endif 
  return
end subroutine hintdxrr9

! This source code file was last time modified by Igor UA3DJY on 20190108

! call may not start from 'Q', zero and two digits
  if(callsign(1:1).eq.'Q' .or. callsign(1:1).eq.'0' .or. callsign(1:1).eq.'/') then
        nbadcrc=1; msg37='                                     '; return; endif

   if(callsign(1:1).ge.'0' .and. callsign(1:1).le.'9') then
     if(callsign(2:2).ge.'0' .and. callsign(2:2).le.'9') then
       nbadcrc=1; msg37='                                     '; return; endif
     if(callsign(2:2).ge.'A' .and. callsign(2:2).le.'Z' .and. callsign(3:3).ge.'A' .and. callsign(3:3).le.'Z' &
       .and. callsign(4:4).ge.'A' .and. callsign(4:4).le.'Z') then
       nbadcrc=1; msg37='                                     '; return; endif
   endif

   if(callsign(1:1).ge.'A' .and. callsign(1:1).le.'Z') then
     if(callsign(2:2).ge.'A' .and. callsign(2:2).le.'Z' &
       .and. callsign(3:3).ge.'A' .and. callsign(3:3).le.'Z') then
       nbadcrc=1; msg37='                                     '; return; endif
   endif

   if(callsign(1:1).ge.'0' .and. callsign(1:1).le.'9') then
     if(callsign(2:2).ge.'A' .and. callsign(2:2).le.'Z' &
       .and. callsign(3:3).ge.'A' .and. callsign(3:3).le.'Z') then
       if(callsign(1:3).ne.'3DA' .and. callsign(1:3).ne.'3XY') then
         nbadcrc=1; msg37='                                     '; return; endif
     endif
   endif

! This source code file was last time modified by Igor UA3DJY on 20200203

subroutine ft8mfcq(s8,itone,msgd,msg37,lft8sd)

  use ft8_mod1, only : idtone25
  real, intent(in) :: s8(0:7,79)
  real s8d(0:7,58)
  character*37 msgd,msg37,msgsent37
  integer itone(79),mrs(58),mrs2(58)
  integer*1 msgbits(77)
  logical(1) lft8sd

  if(len_trim(msgd).lt.6) return
  i3=-1; n3=-1
  call genft8sd(msgd,i3,n3,msgsent37,msgbits,itone)
  idtone25(1,1:29)=itone(8:36)
  idtone25(1,30:58)=itone(44:72)

  thresh=0.0; i1=0; i2=0
  do i=1,58; if(i.le.29) then; s8d(0:7,i)=s8(0:7,i+7); else; s8d(0:7,i)=s8(0:7,i+14); endif; enddo
  do j=1,58
    s1=-1.0E6; s2=-1.0E6
    do i=0,7; if(s8d(i,j).gt.s1) then; s1=s8d(i,j); i1=i; endif; enddo
    do i=0,7; if(i.ne.i1 .and. s8d(i,j).gt.s2) then; s2=s8d(i,j); i2=i; endif; enddo
    mrs(j)=i1; mrs2(j)=i2
  enddo
  ref0=0.0
  do i=1,58; ref0=ref0 + s8d(mrs(i),i); enddo

  ipk=0; u1=0.0; u2=0.0
  do k=1,25
    psum=0.; ref=ref0
    do j=1,58; i3=idtone25(k,j); psum=psum + s8d(i3,j); if(i3.eq.mrs(j)) ref=ref - s8d(i3,j) + s8d(mrs2(j),j); enddo
    p=psum/ref
    if(p.gt.u1) then; u2=u1; u1=p; ipk=k
    else; if(p.gt.u2) u2=p
    endif
  enddo

  if(ipk.eq.1) then
    qual=100.0*(u1-u2)
    thresh=(qual+10.0)*(u1-0.6)
    if(thresh.gt.4.0 .and. qual.gt.2.6 .and. u1.gt.0.77) then
!print *,'matched',thresh
!print *,msgsd76(ipk)
!      if(msgd(1:10).eq.'CQ DE AA00') return ! triggered by memory corruption?
      lft8sd=.true.; msg37=msgd; return
    endif
  endif

  return
end subroutine ft8mfcq

! This source code file was last time modified by Igor Chernikov UA3DJY on May 25th, 2016.
! All changes are shown in the patch file coming together with the full JTDX source code.

subroutine pctile(x,npts,npct,xpct)

  parameter (NMAX=32768)
  real*4 x(npts)
  real*4 tmp(NMAX)
  real*4 xpct
  
  if(npts.le.0) then
     xpct=1.0
     go to 900
  endif
  if(npts.gt.NMAX) stop

  tmp(1:npts)=x
  call shell(npts,tmp)
  j=nint(npts*0.01*npct)
  if(j.lt.1) j=1
  if(j.gt.npts) j=npts
  xpct=tmp(j)

900 continue
  return
end subroutine pctile

! This source code file was last time modified by Igor UA3DJY on 20181215
! All changes are shown in the patch file coming together with the full JTDX source code.

subroutine gen9(msg0,ichk,msgsent,i4tone,itype)

! Encodes a JT9 message and returns msgsent, the message as it will
! be decoded, and an integer array i4tone(85) of 9-FSK tone values 
! in the range 0-8.  

  use packjt
  character*22 msg0
  character*22 message                    !Message to be generated
  character*22 msgsent                    !Message as it will be received
  integer*4 i4Msg6BitWords(13)            !72-bit message as 6-bit words
  integer*1 i1Msg8BitBytes(13)            !72 bits and zero tail as 8-bit bytes
  integer*1 i1EncodedBits(207)            !Encoded information-carrying bits
  integer*1 i1ScrambledBits(207)          !Encoded bits after interleaving
  integer*4 i4DataSymbols(69)             !Data symbols (values 0-7)
  integer*4 i4GrayCodedSymbols(69)        !Gray-coded symbols (values 0-7)
  integer*4 i4tone(85)                    !Tone #s, data and sync (values 0-8)
  include 'jt9sync.f90'
  save

  if(msg0(1:1).eq.'@') then
     read(msg0(2:5),*,end=1,err=1) nfreq
     go to 2
1    nfreq=1000
2    i4tone(1)=nfreq
  else
     message=msg0
     do i=1,22
        if(ichar(message(i:i)).eq.0) then
           message(i:)='                      '
           exit
        endif
     enddo

     do i=1,22                               !Strip leading blanks
        if(message(1:1).ne.' ') exit
        message=message(i+1:)
     enddo

     call packmsg(message,i4Msg6BitWords,itype)  !Pack into 12 6-bit bytes
     call unpackmsg(i4Msg6BitWords,msgsent)      !Unpack to get msgsent
     if(ichk.ne.0) go to 999
     call entail(i4Msg6BitWords,i1Msg8BitBytes)  !Add tail, make 8-bit bytes
     nsym2=206
     call encode232(i1Msg8BitBytes,nsym2,i1EncodedBits)   !Encode K=32, r=1/2
     i1EncodedBits(207)=0
     call interleave9(i1EncodedBits,1,i1ScrambledBits)    !Interleave bits
     i1ScrambledBits(207)=0
     call packbits(i1ScrambledBits,69,3,i4DataSymbols)    !Pk 3-bits into words
     call graycode(i4DataSymbols,69,1,i4GrayCodedSymbols) !Apply Gray code

! Insert sync symbols at ntone=0 and add 1 to the data-tone numbers.
     j=0
     do i=1,85
        if(isync(i).eq.1) then
           i4tone(i)=0
        else
           j=j+1
           i4tone(i)=i4GrayCodedSymbols(j)+1
        endif
     enddo
  endif

999 return
end subroutine gen9

subroutine fix_contest_msg(mygrid,msg)

! If distance from mygrid to grid1 is more thsn 10000 km, change "grid1"
! to "R grid2" where grid2 is the antipodes of grid1.

  character*6 mygrid
  character*22 msg
  character*6 g1,g2
  logical isgrid

  isgrid(g1)=g1(1:1).ge.'A' .and. g1(1:1).le.'R' .and. g1(2:2).ge.'A' .and. &
       g1(2:2).le.'R' .and. g1(3:3).ge.'0' .and. g1(3:3).le.'9' .and.       &
       g1(4:4).ge.'0' .and. g1(4:4).le.'9' .and. g1(1:4).ne.'RR73'

  n=len(trim(msg))
  if(n.lt.4) return

  g1=msg(n-3:n)//'  '
  if(isgrid(g1)) then
     call azdist(mygrid,g1,0.d0,nAz,nEl,nDmiles,nDkm,nHotAz,nHotABetter)
     if(ndkm.gt.10000) then
        call grid2deg(g1,dlong,dlat)
        dlong=dlong+180.0
        if(dlong.gt.180.0) dlong=dlong-360.0
        dlat=-dlat
        call deg2grid(dlong,dlat,g2)
        msg=msg(1:n-4)//'R '//g2(1:4)
     endif
  endif

  return
end subroutine fix_contest_msg

program t6

  parameter (MAXFFT=1404)
  complex c(0:MAXFFT-1)
  real s(0:MAXFFT-1)

  m1=45
  m2=67
  m3=89
  nsym=3*11 + m1 + m2 + m3
  nfft=6*nsym
  nh=nfft/2

  best=9999.
!  do m1=22,67
!     do m2=37,97
  do m1=30,67
     do m2=26,100
        m3=201-m2-m1
        if(m3.lt.13) cycle
        c=0.
        n1=6*(11+m1)
        n2=n1+6*(11+m2)
        c(1:66)=1.
        c(1+n1:66+n1)=1.
        c(1+n2:66+n2)=1.
  
        call four2a(c,nfft,1,-1,1)            !c2c FFT

        df=12000.0/nfft
        smax=0.
        do i=0,nfft-1
           s(i)=real(c(i))**2 + aimag(c(i))**2
           if(i.ne.0) smax=max(s(i),smax)
        enddo
        sidelobe=db(smax/s(0))
        
        if(sidelobe.lt.best) then
           write(*,1000) m1,m2,m3,sidelobe
1000       format(3i5,f8.2)
           best=sidelobe
           s=s/s(0)
           rewind 13
           do j=0,nfft-1
              i=mod(j+nh,nfft)
              f=i*df
              if(i.gt.nh) f=f-12000.0
              write(13,1020) f,s(i)
1020          format(2f12.4)
           enddo
        endif
     enddo
  enddo
  
end program t6

subroutine encode232(dat,nsym,symbol)

! Convolutional encoder for a K=32, r=1/2 code.

  integer*1 dat(13)                 !User data, packed 8 bits per byte
  integer*1 symbol(206)             !Channel symbols, one bit per byte
  integer*1 i1
  include 'conv232.f90'

  nstate=0
  k=0
  do j=1,nsym
     do i=7,0,-1
        i1=dat(j)
        i4=i1
        if (i4.lt.0) i4=i4+256
        nstate=ior(ishft(nstate,1),iand(ishft(i4,-i),1))
        n=iand(nstate,npoly1)
        n=ieor(n,ishft(n,-16))
        k=k+1
        symbol(k)=partab(iand(ieor(n,ishft(n,-8)),255))
        n=iand(nstate,npoly2)
        n=ieor(n,ishft(n,-16))
        k=k+1
        symbol(k)=partab(iand(ieor(n,ishft(n,-8)),255))
        if(k.ge.nsym) go to 100
     enddo
  enddo

100 continue

  return
end subroutine encode232

! This source code file was last time modified by Igor Chernikov UA3DJY on November 26th, 2016.
! All changes are shown in the patch file coming together with the full JTDX source code.

  parameter (MAXTEST=35,NTEST=27)
  character*22 testmsg(MAXTEST)
  data testmsg(1:NTEST)/         &
       "CQ WB9XYZ EN34",         &
       "CQ DX WB9XYZ EN34",      &
       "QRZ WB9XYZ EN34",        &
       "KA1ABC WB9XYZ EN34",     &
       "KA1ABC WB9XYZ RO",       &
       "KA1ABC WB9XYZ -21",      &
       "KA1ABC WB9XYZ R-19",     &
       "KA1ABC WB9XYZ RRR",      &
       "KA1ABC WB9XYZ 73",       &
       "KA1ABC WB9XYZ",          &
       "CQ 000 WB9XYZ EN34",     &
       "CQ 999 WB9XYZ EN34",     &
       "CQ EU WB9XYZ EN34",      &
       "CQ WY WB9XYZ EN34",      &
       "ZL/KA1ABC WB9XYZ",       &
       "KA1ABC ZL/WB9XYZ",       &
       "KA1ABC/4 WB9XYZ",        &
       "KA1ABC WB9XYZ/4",        &
       "CQ ZL4/KA1ABC",          &
       "DE ZL4/KA1ABC",          &
       "QRZ ZL4/KA1ABC",         &
       "CQ WB9XYZ/VE4",          &
       "HELLO WORLD",            &
       "ZL4/KA1ABC 73",          &
       "KA1ABC XL/WB9XYZ",       &
       "KA1ABC WB9XYZ/W4",       &
       "123456789ABCDEFGH"/

! This source code file was last time modified by Igor UA3DJY on 20181231
! All changes are shown in the patch file coming together with the full JTDX source code.

subroutine rms_augap(nutc,lowrms)

  use jt65_mod6, only : dd

  logical lowrms,baddata

  rms1=sqrt(dot_product(dd(100000:100099),dd(100000:100099))/100.0)
  rms2=sqrt(dot_product(dd(200000:200099),dd(200000:200099))/100.0)
  rms3=sqrt(dot_product(dd(300000:300099),dd(300000:300099))/100.0)
  rms4=sqrt(dot_product(dd(400000:400099),dd(400000:400099))/100.0)
  rms5=sqrt(dot_product(dd(500000:500099),dd(500000:500099))/100.0)
  rms=(rms1+rms2+rms3+rms4+rms5)/5.0
  if(rms.lt.2.0) then
     write(*,1016) nutc,'input signal low rms','d'
1016 format(i4.4,2x,a20,19x,a1)
     call flush(6)
     lowrms=.true.
     return
  endif

  if(baddata()) then
     write(*,1017) nutc,'audio gap detected','d'
1017 format(i4.4,2x,a18,21x,a1)
     call flush(6)
	 
     j=0
     do i=1,490
        sq=0.
        do n=1,1200,60
           j=j+60
           x=dd(j)
           sq=sq + abs(x)
        enddo
        if(sq.lt.1.0) then
           dd(j)=1.0; dd(j-600)=1.0
        endif
     enddo
  endif

  return
end subroutine rms_augap

! This source code file was last time modified by Igor UA3DJY on 20190429
! All changes are shown in the patch file coming together with the full JTDX source code.

subroutine agccft4()

  use ft4_mod1, only : dd4
  integer, parameter :: NFFT=8192,NSZ=3413 !3413 = NFFT*5000/12000
  real*4 x11(NFFT),w11(NFFT),ss33(NSZ)
  complex c11(0:NFFT/2)
  integer indx(NSZ)
  logical(1) first
  equivalence (x11,c11)
  data first/.true./
  save first,w11

  fac1=7.e-4

  if(first) then ! Compute the FFT window
    twopi=8.d0*atan(1.d0)
    do k=1,NFFT; w11(k)=sin(twopi*(k+2)/16384); enddo
    first=.false.
  endif

  x11=fac1*w11*dd4(1:8192); call four2a(c11,NFFT,1,-1,0) !r2c forward FFT
  do i=1,NSZ; s33=ABS(c11(i)); ss33(i)=SQRT(s33); enddo
  call indexx(ss33(1:nsz),nsz,indx)
  smed=ss33(indx(1707)); if(smed.gt.1.E-6) then; s3start=smed; else; s3start=1.0; endif

  x11=fac1*w11*dd4(64385:72576); call four2a(c11,NFFT,1,-1,0) !r2c forward FFT
  do i=1,NSZ; s33=ABS(c11(i)); ss33(i)=SQRT(s33); enddo
  call indexx(ss33(1:nsz),nsz,indx)
  smed=ss33(indx(1707)); if(smed.gt.1.E-6) then; s3end=smed; else; s3end=1.0; endif

  dd4(1:8192)=dd4(1:8192)/s3start; dd4(64385:73728)=dd4(64385:73728)/s3end

  return
end subroutine agccft4

#!/bin/sh
JTDX_BUNDLE="`echo "$0" | sed -e 's/\/Contents\/MacOS\/.*//'`"
JTDX_RESOURCES="$JTDX_BUNDLE/Contents/Resources"
JTDX_TEMP="/tmp/jtdx/$UID"

echo "running $0"
echo "JTDX_BUNDLE: $JTDX_BUNDLE"

# Setup temporary runtime files
rm -rf "$JTDX_TEMP"

export "DYLD_LIBRARY_PATH=$JTDX_RESOURCES/lib"
export "PATH=$JTDX_RESOURCES/bin:$PATH"

#export
exec "$JTDX_RESOURCES/bin/jtdx"

#!/bin/sh

#
# Windows
#
#inkscape -z -e /tmp/image-0.png wsjt_globe_128x128.svg
#inkscape -z -e /tmp/image-1.png wsjtx_globe_1024x1024.svg
#convert '/tmp/image-%d.png[0-1]' -background transparent	\
#    \( -clone 0 -resize 16 -colors 256 -compress none \)	\
#    \( -clone 0 -resize 20 -colors 256 -compress none \)	\
#    \( -clone 0 -resize 24 -colors 256 -compress none \)	\
#    \( -clone 0 -resize 32 -colors 256 -compress none \)	\
#    \( -clone 0 -resize 40 -colors 256 -compress none \)	\
#    \( -clone 1 -resize 48 -colors 256 -compress none \)	\
#    \( -clone 1 -resize 96 -colors 256 -compress none \)	\
#    \( -clone 1 -resize 128 -colors 256 -compress none \)	\
#    \( -clone 0 -resize 16 -compress none \)	\
#    \( -clone 0 -resize 20 -compress none \)	\
#    \( -clone 0 -resize 24 -compress none \)	\
#    \( -clone 0 -resize 32 -compress none \)	\
#    \( -clone 0 -resize 40 -compress none \)	\
#    \( -clone 1 -resize 48 -compress none \)	\
#    \( -clone 1 -resize 64 -compress none \)	\
#    \( -clone 1 -resize 96 -compress none \)	\
#    \( -clone 1 -resize 128 -compress none \)	\
#    \( -clone 1 -resize 256 -compress Zip \)	\
#    -delete 1 -delete 0	\
#    -alpha remove ../icons/windows-icons/wsjtx.ico
#rm /tmp/image-0.png /tmp/image-1.png
#identify -format '%f %p/%n %m %C/%Q %r %G %A %z\n' ../icons/windows-icons/wsjtx.ico

inkscape -z -e /tmp/image-0.png jtdx_globe_128x128.svg
inkscape -z -e /tmp/image-1.png jtdx_globe_1024x1024.svg
convert '/tmp/image-%d.png[0-1]' -background transparent	\
    \( -clone 0 -resize 16 -colors 256 -compress none \)	\
    \( -clone 0 -resize 20 -colors 256 -compress none \)	\
    \( -clone 0 -resize 24 -colors 256 -compress none \)	\
    \( -clone 0 -resize 32 -colors 256 -compress none \)	\
    \( -clone 0 -resize 40 -colors 256 -compress none \)	\
    \( -clone 1 -resize 48 -colors 256 -compress none \)	\
    \( -clone 1 -resize 96 -colors 256 -compress none \)	\
    \( -clone 1 -resize 128 -colors 256 -compress none \)	\
    \( -clone 0 -resize 16 -compress none \)	\
    \( -clone 0 -resize 20 -compress none \)	\
    \( -clone 0 -resize 24 -compress none \)	\
    \( -clone 0 -resize 32 -compress none \)	\
    \( -clone 0 -resize 40 -compress none \)	\
    \( -clone 1 -resize 48 -compress none \)	\
    \( -clone 1 -resize 64 -compress none \)	\
    \( -clone 1 -resize 96 -compress none \)	\
    \( -clone 1 -resize 128 -compress none \)	\
    \( -clone 1 -resize 256 -compress Zip \)	\
    -delete 1 -delete 0	\
    -alpha remove ../icons/windows-icons/jtdx.ico
rm /tmp/image-0.png /tmp/image-1.png
identify -format '%f %p/%n %m %C/%Q %r %G %A %z\n' ../icons/windows-icons/jtdx.ico
#
inkscape -z -e installer_logo.png -w 150 -h 57 -b white installer_logo.svg
convert png:installer_logo.png -resize 150x57 +matte BMP3:../icons/windows-icons/installer_logo.bmp
rm installer_logo.png
identify -format '%f %p/%n %m %C/%Q %r %G %A %z\n' ../icons/windows-icons/installer_logo.bmp

#
# Mac
#
mkdir -p ../icons/Darwin/wsjtx.iconset
inkscape -z -e ../icons/Darwin/wsjtx.iconset/icon_16x16.png -w 16 -h 16 jtdx_globe_128x128.svg
inkscape -z -e ../icons/Darwin/wsjtx.iconset/icon_16x16@2x.png -w 32 -h 32 jtdx_globe_128x128.svg
inkscape -z -e ../icons/Darwin/wsjtx.iconset/icon_32x32.png -w 32 -h 32 jtdx_globe_128x128.svg
inkscape -z -e ../icons/Darwin/wsjtx.iconset/icon_32x32@2x.png -w 64 -h 64 jtdx_globe_128x128.svg
inkscape -z -e ../icons/Darwin/wsjtx.iconset/icon_128x128.png -w 128 -h 128 jtdx_globe_1024x1024.svg
inkscape -z -e ../icons/Darwin/wsjtx.iconset/icon_128x128@2x.png -w 256 -h 256 jtdx_globe_1024x1024.svg
inkscape -z -e ../icons/Darwin/wsjtx.iconset/icon_256x256.png -w 256 -h 256 jtdx_globe_1024x1024.svg
inkscape -z -e ../icons/Darwin/wsjtx.iconset/icon_256x256@2x.png -w 512 -h 512 jtdx_globe_1024x1024.svg
inkscape -z -e ../icons/Darwin/wsjtx.iconset/icon_512x512.png -w 512 -h 512 jtdx_globe_1024x1024.svg
inkscape -z -e ../icons/Darwin/wsjtx.iconset/icon_512x512@2x.png -w 1024 -h 1024 jtdx_globe_1024x1024.svg
identify -format '%f %p/%n %m %C/%Q %r %G %A %z\n' ../icons/Darwin/wsjtx.iconset/*
# generic globe iconset for utilities
#mkdir -p ../icons/Darwin/wsjtx.iconset
#inkscape -z -e ../icons/Darwin/wsjtx.iconset/icon_16x16.png -w 16 -h 16 wsjt_globe_128x128.svg
#inkscape -z -e ../icons/Darwin/wsjtx.iconset/icon_16x16@2x.png -w 32 -h 32 wsjt_globe_128x128.svg
#inkscape -z -e ../icons/Darwin/wsjtx.iconset/icon_32x32.png -w 32 -h 32 wsjt_globe_128x128.svg
#inkscape -z -e ../icons/Darwin/wsjtx.iconset/icon_32x32@2x.png -w 64 -h 64 wsjt_globe_128x128.svg
#inkscape -z -e ../icons/Darwin/wsjtx.iconset/icon_128x128.png -w 128 -h 128 wsjtx_globe_1024x1024.svg
#inkscape -z -e ../icons/Darwin/wsjtx.iconset/icon_128x128@2x.png -w 256 -h 256 wsjtx_globe_1024x1024.svg
#inkscape -z -e ../icons/Darwin/wsjtx.iconset/icon_256x256.png -w 256 -h 256 wsjtx_globe_1024x1024.svg
#inkscape -z -e ../icons/Darwin/wsjtx.iconset/icon_256x256@2x.png -w 512 -h 512 wsjtx_globe_1024x1024.svg
#inkscape -z -e ../icons/Darwin/wsjtx.iconset/icon_512x512.png -w 512 -h 512 wsjtx_globe_1024x1024.svg
#inkscape -z -e ../icons/Darwin/wsjtx.iconset/icon_512x512@2x.png -w 1024 -h 1024 wsjtx_globe_1024x1024.svg
#identify -format '%f %p/%n %m %C/%Q %r %G %A %z\n' ../icons/Darwin/wsjtx.iconset/*
# generic globe iconset for utilities
mkdir -p ../icons/Darwin/wsjt.iconset
inkscape -z -e ../icons/Darwin/wsjt.iconset/icon_16x16.png -w 16 -h 16 wsjt_globe_128x128.svg
inkscape -z -e ../icons/Darwin/wsjt.iconset/icon_16x16@2x.png -w 32 -h 32 wsjt_globe_128x128.svg
inkscape -z -e ../icons/Darwin/wsjt.iconset/icon_32x32.png -w 32 -h 32 wsjt_globe_128x128.svg
inkscape -z -e ../icons/Darwin/wsjt.iconset/icon_32x32@2x.png -w 64 -h 64 wsjt_globe_128x128.svg
inkscape -z -e ../icons/Darwin/wsjt.iconset/icon_128x128.png -w 128 -h 128 wsjt_globe_1024x1024.svg
inkscape -z -e ../icons/Darwin/wsjt.iconset/icon_128x128@2x.png -w 256 -h 256 wsjt_globe_1024x1024.svg
inkscape -z -e ../icons/Darwin/wsjt.iconset/icon_256x256.png -w 256 -h 256 wsjt_globe_1024x1024.svg
inkscape -z -e ../icons/Darwin/wsjt.iconset/icon_256x256@2x.png -w 512 -h 512 wsjt_globe_1024x1024.svg
inkscape -z -e ../icons/Darwin/wsjt.iconset/icon_512x512.png -w 512 -h 512 wsjt_globe_1024x1024.svg
inkscape -z -e ../icons/Darwin/wsjt.iconset/icon_512x512@2x.png -w 1024 -h 1024 wsjt_globe_1024x1024.svg
identify -format '%f %p/%n %m %C/%Q %r %G %A %z\n' ../icons/Darwin/wsjt.iconset/*
#
inkscape -z -e "../icons/Darwin/DragNDrop Background.png" -w 640 -h 480 -b white "DragNDrop Background.svg"
identify -format '%f %p/%n %m %C/%Q %r %G %A %z\n' "../icons/Darwin/DragNDrop Background.png"

#
# KDE & Gnome
#
#inkscape -z -e ../icons/Unix/wsjtx_icon.png -w 128 -h 128 wsjtx_globe_1024x1024.svg
#identify -format '%f %p/%n %m %C/%Q %r %G %A %z\n' ../icons/Unix/wsjtx_icon.png
inkscape -z -e ../icons/Unix/wsjtx_icon.png -w 128 -h 128 jtdx_globe_1024x1024.svg
identify -format '%f %p/%n %m %C/%Q %r %G %A %z\n' ../icons/Unix/wsjtx_icon.png

# Contributing

This file describes a path to contribute to this project. Check out our
[CODE OF CONDUCT](./CODE_OF_CONDUCT.md).

## Bug Reports and Feature Requests

If you have encountered a problem with QDarkStyle or have an idea for a new
feature, please submit it to the
[issue tracker](https://github.com/ColinDuquesnoy/QDarkStyleSheet/issues).

## Contributing to QDarkStyle

The recommended way for new contributors to submit code to QDarkStyle is to
fork the repository on GitHub and then submit a pull request after
committing the changes.  The pull request will then need to be approved by one
of the manteiners before it is merged into the main repository.

- Check for open issues or open a fresh issue to start a discussion around a
    feature idea or a bug.
- Fork [the repository](https://github.com/ColinDuquesnoy/QDarkStyleSheet)
    on GitHub to start making your changes to the master branch.
- Write a test which shows that the bug was fixed or that the feature works
    as expected if its a function, or create a screenshot if you are changing
    the stylesheet evidencing the changes.
- Send a pull request and bug the maintainer until it gets merged and
    published. Make sure to add yourself to
    [AUTHORS](./AUTHORS.md)
    and the change(s) to
    [CHANGES](./CHANGES.md).

## Getting Started

These are the basic steps needed to start developing on QDarkStyle.

- Create an account on GitHub.

- Fork the main
    [QDarkStyle repository](https://github.com/ColinDuquesnoy/QDarkStyleSheet)
    using the GitHub interface.

- Clone the forked repository to your machine.

    ```bash
       git clone https://github.com/USERNAME/qdarkstyle
       cd qdarkstyle
    ```

- Checkout the appropriate branch.

    ```bash
       git checkout master
    ```

- Setup a virtual environment (not essential, but highly recommended).

    ```bash
       virtualenv ~/.venv
       . ~/.venv/bin/activate
       pip install -e .
    ```

- Create a new working branch. Choose any name you like.

    ```bash
       git checkout -b feature-xyz
    ```

- Hands on.

    For tips on working with the code, see the Code Guide.

- Test, test, test.

    Testing is best done through ``tox``, which provides a number of targets and
    allows testing against multiple different Python environments:

- Please add a list point to [CHANGES](./CHANGES.md) if the fix or
    feature is not trivial (small doc updates, typo fixes).

- Please add you as an author to [AUTHORS](./AUTHORS.md).

- Add files to commit.

    Add files that are part of your changes, remember that each commit
    must represent a small but functional change. Remember to add CHANGES.md
    and AUTHORS.md too. To add all files changed do:
    ```bash
       git add .
    ```

- Commiting changes.

    GitHub recognizes certain phrases that can be used to automatically
    update the issue tracker, so you can commit like this:

    ```bash
       git commit -m "Add useful new feature that does this, close #42"
    ```
    ```bash
       git commit -m "Fix returning problem for get_style(), fix #78"
    ```

- Push changes in the branch to your forked repository on GitHub.

    ```bash
       git push origin feature-xyz
    ```

- Submit a pull request (PR).

    Do it from your branch to the respective branch using the
    [GitHub PR](https://github.com/ColinDuquesnoy/QDarkStyleSheet/pulls)
    interface.

- Wait for mainteiner to review your changes.

## Logging

Inside modules we provided a logging that should be used to inform the user.
Please, follow the levels bellow.

- debug: for debug information, high detailed one, directed to programers;
- info: something important for common user to know;
- warning: something that should not be a big problem or a desicision changed;
- error: some error, but not capable of stop program;
- critical: something that stops the running program.

## Guide to QDarkStyle

Now you can use our example to work on the stylesheet. It has all possible
widget provided by Qt - common ones. Feel free to add more to them.

To simplify the structure, there are separated files in
[example.ui](./example/ui/) folder.

- `dw_buttons.ui`: all types of buttons;
- `dw_containers_no_tabs.ui`: all types of containers except for tabs;
- `dw_containers_tabs.ui`: all containers tabs;
- `dw_displays.ui`: all types of displays;
- `dw_inputs_fields.ui`: all types of inputs with fields;
- `dw_inputs_no_fields.ui`: all types of inputs without fields;
- `dw_views.ui`: all types of views;
- `dw_widgets.ui`: all types of widgets;
- `mw_menus.ui`: main window with all menus and toolbars.

*Obs.: `dw` stands for dock widget and `mw` for main window.*

The entire example is built at runtime, in
[example.py](./example/example.py). To see more information about it,
see its documentation.

### Modifying UI Files

Feel free to modify [ui](./example/ui) files with Qt Designer and recompile UI using
[process_ui.py](./script/process_ui.py) script, inside script folder, using:

```bash
python process_ui.py
```

It will generate all `_ui.py` files for PyQt4, PyQt5, PySide, QtPy, PyQtGraph.

### Modifying QSS File

If you are changing the [stylesheet](./qdarkstyle/style.qss), you will need
to recompile the QRC files using [process_qrc.py](./script/process_qrc.py)
script, inside script folder.

```bash
python process_qrc.py
```

This generates all `_rc.py` files for PyQt4, PyQt5, PySide, QtPy, PyQtGraph.

### Making It Easy

To simplify this process for the developer, if you are changing many things,
use the script [run_ui_css_edition.py](./script/run_ui_css_edition.py):

```bash
python run_ui_css_edition.py
```

This creates a loop that restarts the application, process ui and css
files.

For more information about those scripts, see their documentation.

### Qt, Stylesheets and Palettes

- [Box model](http://doc.qt.io/qt-5/images/stylesheet-boxmodel.png)
- [Box model with height and width](https://www.tutorialrepublic.com/lib/images/css-box-model.jpg)
- [Customizing Widgets](http://doc.qt.io/qt-5/stylesheet-customizing.html)
- [Window structure](http://doc.qt.io/qt-5/images/mainwindowlayout.png)
- [QMainWindow](http://doc.qt.io/qt-5/qmainwindow.html)
- [References](http://doc.qt.io/qt-5/stylesheet.html)

Create good palettes with these tools. For example, on paletton, choose
  three colors from greyish light (foreground), greyish dark (background)
  and three more colorfull colors (selection). Greyish colors have a litle
  bit of the main color, so it is nice to change it if you change the main
  color.

- [Paletton.com](http://paletton.com/)
- [Coolors.co](https://coolors.co/)

## Unit Testing and Fix Preview

It is a good practice, if you are writing functions to QDarkStyle or fixing
something related to those functions (not style), that you provide a test
for it.

If you are fixing something about style, please, at least, provide an
screenshot before and after the fix to comparison. This could be inserted
in the issue tracker, as a message. Better than that, use modules provided
in test folder to create a GUI test, creating a new file for it.

Check [test](./test) files to more details. Tests will keep our application stable.

## If You Are a Mantainer, Go Ahead

We create a guide to create and upload this package to PyPI, follow the
instructions in [PRODUCTION](./PRODUCTION.md).

<!-- You can erase any parts of this template not applicable/known to your Issue. -->

### Describe Your Environment

[Versions from your environment]

- QDarkStyle:
- OS:
- Python:

[If used, please inform their versions]

- PySide:
- PyQt:
- PyQtGraph:
- QtPy:
- QT_API:
- PYQTGRAPH_QT_LIB:

### Language

[Python] or [C++]

### Description / Steps to Reproduce [if necessary]

[Description of the issue]

1. [First Step]
2. [Second Step]
3. [and so on...]

### Actual Result

[A description, output ou image of the actual result]

### Expected Results / Proposed Result

[A description, output ou image of the expected/proposed result]

### Relevant Code [if necessary]

[A piece of code to reproduce and/or fix this issue]

```
# code here to reproduce the problem
```

# Authors

## Mainteiner(s)

These people were/are mainteiners of this project.

- 2013-2018
    [Colin Duquesnoy](https://github.com/ColinDuquesnoy) -
    <colin.duquesnoy@gmail.com> -
    original author.
- 2018
    [Daniel Pizetta](https://github.com/dpizetta) -
    <daniel.pizetta@usp.br> -
    improvements and bug fixes.

## Contributor(s)

These people contribute to bug fixes, improvements and so on.
Please, insert your information after the last one.

- Year - Name - `<contact>` - contribution.
- 2018 - [mowoolli](https://github.com/mowoolli) - bug fixes.
- 2018 - Xingyun Wu - `xingyun.wu@foxmail.com` - bug fixes.
- 2018 - [KcHNST](https://github.com/KcHNST) - bug fixes.

Thank you all!

# Production

Of course, until you start these steps, make sure the package have passed all
tests and checkers before continue.

- Create a `.pypirc` file in your home folder with this
    ```bash
        [distutils]
        index-servers =
        pypi
        testpypi

        [pypi]
        repository:https://pypi.python.org/pypi
        username=your username

        [testpypi]
        repository: https://test.pypi.org/legacy/
        username=your username
    ```

    If you want to put also your password in that file, remember to set
    appropriated permission to it.

    *Note that you need to create an account for both sites.*

- Install TWine
    ```bash
        sudo apt install twine
    ```

- Register if necessary
    ```bash
        python setup.py register
    ```

- Create a distribution (code package and wheel)
    ```bash
        python setup.py sdist bdist_wheel
    ```

- Test uploading using Twine
    ```bash
        twine upload -r testpypi dist/*
    ```

- Check if things are OK on [PyPI test page](https://test.pypi.org/project/QDarkStyle).

- Test installing using pip from test PyPI
    ```bash
        pip install --index-url https://test.pypi.org/project/ qdarkstyle
    ```

- **If you make sure all things are OK**, upload officialy
    ```bash
        twine upload -r pypi dist/*
    ```

- Check if things are OK on [PyPI official page](https://pypi.python.org/pypi/QDarkStyle).

- Test installing using pip
    ```bash
        pip install qdarkstyle
    ```
